#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: domaindel.pl,v 1.1.1.1 2002/09/09 07:43:31 snavi Exp $

##001102 v5.1 ɥᥤб(wbmc03-001) Y.Uemukai
##001203 v5.1 Webalizer饹б(wbmc03-076) K.Chikita
##010221 v4.0.1 fml ɥᥤб ɲ K.Chikita
##010405 v4.0.1 WEBݡֹѹǽɲ Y.Uemukai
##010830 v4.2 졼֥ФǤ checkVirtualHost_realwbmc() ¹Ԥ oku


require "/opt/nec/wbmc/lib/wbmc.pl";
require join ("/", $WBMC_ADM_DIR, "domain", "domain.pl");
require join ("/", $WBMC_DOMADM_DIR, "account", "account.pl");
require join ("/", $WBMC_ADM_DIR, "service/11sendmail", "fml", "virtualdfml.pl");

############################################################################
#  <̾>
#        delDomainInf (ɥᥤؿ)
#  <>
#       /ۥɥᥤɬפʺ̤Ԥ
#
#  <>
#       delDomain($domainname,$mode,$ip,$groupname,$webpart,$mailpart,$hostname)
#  <>
#       ($domainname) : ɥᥤ̾
#       ($mode)       : REAL/VIRTUAL
#       ($ip)         : IPɥ쥹
#       ($groupname)  : 롼̾
#       ($webpart)    : WEBѥǥѡƥ( /dev/hda1:/home)
#       ($mailpart)   : MAILѥǥѡƥ( /dev/hda1:/home)
#       ($hostname)   : ۥ̾
#  <>
#        ｪλ :  ""
#        ۾ｪλ :  顼å
#
#
############################################################################

sub delDomainInf(){

  local($domainname,$mode,$ip,$groupname,$webpart,$mailpart,$hostname) = @_;
  local($filename,$sameip_cnt,$del_startline,$del_finalline,$hit_flg,$i,$rtn_code,$webaccessport,$sslwebaccessport)= "";
  local(@conf,@orgconf) = ();


  ###########################################
  ##
  ## ɥᥤե뤫
  ##
  ## readǼԤ餽λǽλ
  ## writeϤΤޤ
  ##
  ###########################################
  @conf = ();
  $filename = "/etc/opt/nec/wbmc/domain.conf";
  if(&readFile($filename, "domain.conf", *conf) == 0){
    $rtn_code = "$filenameեɤ߹ߤ˼Ԥޤ";
    return($rtn_code);
  }


  # ɥᥤե᤹
  $sameip_cnt =0;
  $del_startline = 0;
  $del_finalline = 0;
  $hit_flg = 0;

  @orgconf = @conf;
  for($i=0; $i < @conf; $i++){
    $conf[$i] =~ s/^\s*//;
    $conf[$i] =~ s/\s*$//;

# REP ɥᥤѹȼѹ "" -> "</DOMAINNAME>"
#    if($conf[$i] eq ""){
    if($conf[$i] eq "</DOMAINNAME>"){
      if($del_finalline eq 0 && $hit_flg eq 1){
        $del_finalline = $i;
        $hit_flg = 0;
      }
    }

    @line = split(/ +/,$conf[$i]);

    if($line[0] eq "<DOMAINNAME"){
      if($line[1] eq $domainname){
        $del_startline = $i;
        $hit_flg = 1;
      }
    }
    if($line[0] eq "PORTNUM" && $hit_flg eq 1){
      $portnum = $line[1];
    }
    if($line[0] eq "IP"){
      if($line[1] eq $ip){
        $sameip_cnt++;
      }
    }
# ADD WEBݡֹѹб
    if($line[0] eq "WEBACCESS_PORT" && $hit_flg eq 1){
      $webaccessport = $line[1];
    }
    if($line[0] eq "SSLWEBACCESS_PORT" && $hit_flg eq 1){
      $sslwebaccessport = $line[1];
    }
  }

  #оݥɥᥤξ(19+1 2000/8/29)õ
  splice(@orgconf,$del_startline,$del_finalline - $del_startline+1);


  # ɥᥤե˽񤭹
  if(&writeFile($filename, "domain.conf", @orgconf) == 0){
      $rtn_code .= "$filenameեν񤭹ߤ˼Ԥޤ";
  }



#================================================================
#¥ɥᥤ
#Թˤ궯Ū֤ͤ
#----------------------------------------------------------------
# REP ɥᥤѹȼ
#
#================================================================
##  if($mode =~ /REAL/){
##    $domainname = "$hostname.$domainname";
      $hostname = "";
##  }

  #==================================================
  #   GROUP ("groupdel 롼̾" ȯ)
  #==================================================
  #饹б No.1-1
  $rtn_code .= &cluster_system_backup("/etc/group");

  if(system("/usr/sbin/groupdel $groupname") != 0){
    $rtn_code .= "롼פκ˼Ԥޤ";
  }

  #饹б No.1-2
  $rtn_code .= &cluster_system_sync("/etc/group");


  #==================================================
  #ۥɥᥤѥե&ܥå󥯺
  #==================================================
  $rtn_code .= &cluster_exec("delDomainDirSlink",$domainname,$webpart,$mailpart);


  #==================================================
  #ɥᥤ̾/롼̾ հѺ
  # ۥɥᥤΤ
  #==================================================
  if($mode eq "VIRTUAL"){
  #饹б No.2-1
    $rtn_code .= &cluster_system_backup("/etc/domainaliases");
    if(&delDomainGroupChgName($domainname) eq -1){
      $rtn_code .= "/etc/domainaliasesեκ˼Ԥޤ";
    }
  #饹б No.2-2
    $rtn_code .=&cluster_system_sync("/etc/domainaliases");
  }


  #==================================================
  #            Apache 
  #̾(www.  ɥᥤ̾)
  #ݡֹ(wbmc.conf->80)
  #==================================================


  #MAILФΤߤηֻApahceϤκϹԤʤ
  if($WBMC_MACHINE_TYPE eq "mail"){ goto webend;}

  if($webpart){
# REP ݡֹѹǽб(Ǥ->)
#/etc/httpd/wbmc.conf
    $rtn_code .= &NewdelVirtualHost($domainname,$webaccessport,$hostname,"off");

#SSLбΤᡢ
    $rtn_code .= &NewdelVirtualHost($domainname,$sslwebaccessport,$hostname,"on");

## LBֻΤ߽Ԥʤ
    if ($WBMC_MACHINE_TYPE eq "web") {
      $rtn_code .= &cluster_exec_all("checkVirtualHost_realwbmc");
    }

  # ApachƵư
    if(&isServiceRunning("$WBMC_ADM_DIR/service/01httpd")) {
      $rtn_code .= &restartApache_domain();
    }
  }

webend:


  #/etc/opt/nec/wbmchttpd/conf/wbmchttpd.conf

  $rtn_code .= &delWbmcVirtualHost($domainname,$ip,$portnum,$mode);

  #==================================================
  #            SENDMAIL
  #
  #==================================================

  #WEBФΤߤηֻsendmailϤϹԤʤ
  if($WBMC_MACHINE_TYPE eq "web"){ goto mailend;}


  if($mode eq "VIRTUAL"){
    #fmlɲ
    $rtn_code .= &deleteFmlML($domainname);
    $rtn_code .= &delVirtUserTable($domainname);
  }

  $rtn_code .= &delMailAlias($groupname);

  #sendmailκƵư
  if(&isServiceRunning("$WBMC_ADM_DIR/mail")){
    if(system("/etc/rc.d/init.d/sendmail reload > /dev/null 2>&1") != 0){
      $rtn_code .= "sendmailκƵư˼Ԥޤ";
    }
  }
  #popdκƵư
  if(&isServiceRunning("$WBMC_ADM_DIR/service/12popd")){
    if(system("/etc/rc.d/init.d/popd restart  > /dev/null 2>&1") != 0){
      $rtn_code .= "popdκƵư˼Ԥޤ";
    }
  }
  #imapdκƵư
  if(&isServiceRunning("$WBMC_ADM_DIR/service/13imapd")){
    if(system("/etc/rc.d/init.d/imapd restart  > /dev/null 2>&1") != 0){
      $rtn_code .= "imapdκƵư˼Ԥޤ";
    }
  }

mailend:

  #==================================================
  #            FTP
  #
  #==================================================

  $rtn_code .= &delFtpAccess($domainname,$ip,$groupname,$sameip_cnt);


  #==================================================
  #           WebAlizer 
  #
  #==================================================

  #饹б wbmc03-076
  # $rtn_code .= &delWebalizer($domainname);
  $rtn_code .= &cluster_exec_all("delWebalizer",$domainname);


  return($rtn_code);
}

1;
