#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: ssl.cgi,v 1.1.1.1 2002/09/09 07:43:31 snavi Exp $

##010207 SSLưˤ뽤 haramoto
##010213 server̾ɽ      haramoto
##010213 ѹ      haramoto
##010219 ѹ      haramoto
##010219 (encode)      S.Oku
##010413 SSLθκػ߽ɲ   S.Oku

#-----------------------------------------------------------------------
##010228 v4.0.1 wbmc04-012(SSLǽư) б   haramoto(S.Oku)
##010308 v4.0.1 (wbmc04-012)SSL require(domain.plɲ)  S.Oku
##010322 v4.0.1 SSLѻΡ̾׵κػߤ  S.Oku


#-----------------------------------------------------------------------
require "../../lib/wbmc.pl";
require "./domainssl.pl";               ##010228
require "$WBMC_ADM_DIR/domain/domain.pl";

$server = $ARGV[0]; $server =~ s/\\(.)/$1/g;
$port = $ARGV[1]; $port =~ s/\\(.)/$1/g;
$webserver = $ARGV[2]; $webserver =~ s/\\(.)/$1/g;      ##010213
$domaindata = &encodeUrl($ARGV[3]);
if (!$ARGV[3]) {
    $domaindata = &encodeUrl($ARGV[2]);
}

# $domaindata =~ s/\\(.)/$1/g;      ##010213
#  $domaindata = &encodeUrl($domaindata);       ##010219


# ݡֹ椬 * λϥ顼
if ($port eq "*") {
    &showErrorPage("ݡֹ * ФSSLꤹ뤳ȤϤǤޤ");
    exit(1);
}

## SSLλѾ֤  add 010322
if ($err = &getSslStatus($server, $port ,*status)) {
    &showErrorPage($err);
    exit(1);
}
$sslstatus = $status;
$status = "";

# ̩κ
if ($err = &getSecretStatus($server, $port, *status)) {
    &showErrorPage($err);
    exit(1);
}
if ($status) {
    $secret = "<FONT COLOR=red></FONT>";
    $secflag = 1;
} else {
    $secret = "̤";
    $secflag = 0;
}

# ̾׵κ
if ($err = &getCertificateRequest($server, $port, *text, *exist)) {
    &showErrorPage($err);
    exit(1);
}
if ($exist) {
    $csr = "<FONT COLOR=red></FONT>";
    $csrflag = 1;
} else {
    $csr = "̤";
    $csrflag = 0;
}

# κ
if ($err = &getCertificate($server, $port, *text, *who, *exist)) {
    &showErrorPage($err);
    exit(1);
}
if ($exist) {
    $certificate = "<FONT COLOR=red></FONT>";
    $certflag = 1;
} else {
    $certificate = "̤";
    $certflag = 0;
}

#ʥӥ
$navibar = &getNavigation(
    "ɥᥤ", "domain.cgi",               ##010207
    "ɥᥤԽ", "domainmod.cgi?$domaindata",        ##010207 010219
    "SSL",      "",
    "_back",    "domainmod.cgi?$domaindata",                ##010207
    "_help",    "ssl_help.html");

#-----------------------------------------------------------------------
print <<END_OF_DATA
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>ɥᥤԽ - SSL</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function func() {
    for (i = 0; i < document.f1.Action.length; i++) {
        if (document.f1.Action[i].checked) {
            act = document.f1.Action[i].value;
            break;
        }
    }
    if (i == document.f1.Action.length) {
        alert("ꤷƤ");
        return;
    }
    else if (act == "makeSelfCertificate") {
        if ($certflag == 1) {
            if (!window.confirm("Ǥ˾¸ߤޤ񤭤Ƥ⤫ޤޤ󤫡")) {
                return;
            }
        }
        if ($secflag == 1) {
            if (!window.confirm("Ť̩¸ߤΤǾ񤭤ޤǤ")) {
                return;
            }
        }
        if ($csrflag == 1) {
            if (!window.confirm("Ť̾׵᤬¸ߤΤǺޤǤ")) {
                return;
            }
        }
    }
    else if (act == "showCertificate") {
        if ($certflag == 0) {
            alert("񤬺Ƥޤ");
            return;
        }
    }
    else if (act == "deleteSelfCertificate") {
        if ($sslstatus == 1) {
            alert("SSLλϡ̩κϤǤޤ ɥᥤԽ̤SSLѤΥå򳰤Ƥ顢ԤäƤ");
            return;
        } else if (($secflag == 0) && ($certflag == 0)) {
            alert("̩Ⱦ񤬺Ƥޤ");
            return;
        } else if (($secflag == 1) && ($certflag == 0)) {
            if (!window.confirm("̩ޤǤ")) {
                return;
            }
        } else if (($secflag == 0) && ($certflag == 1)) {
            if (!window.confirm("ޤǤ")) {
                return;
            }
        } else {
            if (!window.confirm("̩ȾޤǤ")) {
                return;
            }
        }
    }
    else if (act == "makeCertificateRequest") {
        if ($sslstatus == 1) {
            alert("SSLλϡ̩̾׵ǧڶɽ̾ˤκϤǤޤ ɥᥤԽ̤SSLѤΥå򳰤Ƥ顢Ƥ");
            return;
            
        } else if ($csrflag == 1) {
            if (!window.confirm("Ǥ˾̾׵᤬¸ߤޤ񤭤Ƥޤޤ󤫡")) {
                return;
            }
        }
        if ($certflag == 1) {
            if (!window.confirm("Ť¸ߤΤǺޤǤ")) {
                return;
            }
        }
        if ($secflag == 1) {
            if (!window.confirm("Ť̩¸ߤΤǾ񤭤ޤǤ")) {
                return;
            }
        }
    }
    else if (act == "showCertificateRequest") {
        if ($csrflag == 0) {
            alert("̾׵᤬Ƥޤ");
            return;
        }
    }
    else if (act == "deleteCertificateRequest") {
        if ($sslstatus == 1) {
            alert("SSLλϡ̩̾׵κϤǤޤ ɥᥤԽ̤SSLѤΥå򳰤Ƥ顢ԤäƤ");
            return;
        } else if (($secflag == 0) && ($csrflag == 0)) {
            alert("̩Ⱦ̾׵᤬Ƥޤ");
            return;
        } else if (($secflag == 1) && ($csrflag == 0)) {
            if (!window.confirm("̩ޤǤ")) {
                return;
            }
        } else if (($secflag == 0) && ($csrflag == 1)) {
            if (!window.confirm("̾׵ޤǤ")) {
                return;
            }
        } else {
            if (!window.confirm("̩Ⱦ̾׵ޤǤ")) {
                return;
            }
        }
    }
    else if (act == "registCertificate") {
        if ($sslstatus == 1) {
            alert("SSLλϡǧڶɽ̾ˤϿϤǤޤ ɥᥤԽ̤SSLѤΥå򳰤Ƥ顢ϿԤäƤ");
            return;
        } else if ($secflag == 0) {
            alert("̩Ƥޤ");
            return;
        }
        if ($csrflag == 0) {
            alert("̾׵᤬Ƥޤ");
            return;
        }
        if ($certflag == 1) {
            if (!window.confirm("Ǥ˾¸ߤޤ񤭤Ƥ⤫ޤޤ󤫡")) {
                return;
            }
        }
    }
    else if (act == "deleteCertificate") {
        if ($sslstatus == 1) {
            alert("SSLλϡκϤǤޤ ɥᥤԽ̤SSLѤΥå򳰤Ƥ顢ԤäƤ");
            return;
        } else if ($certflag == 0) {
            alert("񤬺Ƥޤ");
            return;
        } else {
            if (!window.confirm("ޤǤ")) {
                return;
            }
        }
    }
    document.f1.submit();
}
// -->
</SCRIPT>
</HEAD>
<BODY>
<H4 ALIGN="center">ɥᥤԽ - SSL</H4>
<HR>
 $navibar
<HR>
        <!-- ##000823 delete -- ##010213 add
        -->
<CENTER>
<FONT COLOR="red"><B>$webserver</B></FONT>
</CENTER>
<P>
         <!--
          -->
<CENTER>
<TABLE>
 <TR>
  <TD>
   <FORM METHOD=POST NAME="f1" ACTION="ssl2.cgi?$server+$port+$webserver+$domaindata">
    <TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH="100%">
     <TR BGCOLOR="#000080">
      <TD>
       <FONT COLOR="#FFFFFF"> <B>̩Ⱦκ</B></FONT>
      </TD>
     </TR>
     <TR>
      <TD>
       <TABLE>
    <TR>
         <TD>
          <BR>ߤξ<BR>
          <TABLE>
           <TR>
            <TD WIDTH=35></TD>
            <TD>̩ξ֡</TD>
            <TD>$secret</TD>
           </TR>
           <TR>
            <TD></TD>
            <TD>̾׵ξ֡</TD>
            <TD>$csr</TD>
           </TR>
           <TR>
            <TD></TD>
            <TD>ξ֡</TD>
            <TD>$certificate</TD>
           </TR>
          </TABLE>
         </TD>
        </TR>

        <TR>
         <TD>
          <TABLE>
           <TR>
            <TD>
             ʽ̾ξ<BR>

             <TABLE>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="makeSelfCertificate">̩Ⱦ<BR>
               </TD>
              </TR>
              <TR>
               <TD></TD>
               <TD>
                <INPUT TYPE=radio  NAME="Action" VALUE="showCertificate">ξɽ<BR>
               </TD>
              </TR>
              <TR>
               <TD></TD>
               <TD>
               <INPUT TYPE=radio NAME="Action" VALUE="deleteSelfCertificate">̩Ⱦ<BR>
               </TD>
              </TR>
             </TABLE>

            </TD>
           </TR>
          </TABLE>
         </TD>
        </TR>

        <TR>
         <TD>
          <TABLE>
           <TR>
            <TD>
             ǧڶɽ̾ξ<BR>

             <TABLE>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="makeCertificateRequest">̩Ⱦ̾׵<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="showCertificateRequest">̾׵ɽ<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="deleteCertificateRequest">̩Ⱦ̾׵<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="registCertificate">̾ѤߤξϿ<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="showCertificate">ξɽ<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="deleteCertificate"><BR>
               </TD>
              </TR>
             </TABLE>

        </TD>
           </TR>
          </TABLE>
         </TD>
        </TR>

        <TR>
         <TD>

       <TABLE ALIGN=center>
        <TR>
         <TD>
          <INPUT TYPE="button" VALUE="" onClick="func()">
         </TD>
        </TR>
       </TABLE>

         </TD>
        </TR>
       </TABLE>

     </TR>
    </TABLE>
   </FORM>
  </TD>
 </TR>
</TABLE>
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#-----------------------------------------------------------------------

