#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: listmod.cgi,v 1.2 2002/09/24 06:03:19 snavi Exp $

#--------------------------------------------------------------------

require "../../../../lib/wbmc.pl";
require join ("/", $WBMC_ADM_DIR, "service/11sendmail/fml", "fml.pl");
require "./msgedit.ph";

my($i);
my($listname,$listname_show,$listname_arg);
my($domainname, $domainname_show, $domainname_arg);

# ѥ᡼롣
$listname = $ARGV[0]; $listname =~ s/\\(.)/$1/g;
$domainname = $ARGV[1]; $domainname =~ s/\\(.)/$1/g;

# Υ󥳡
$listname_show	= &encodeHtml($listname);
$listname_arg	= &encodeUrl($listname);
$domainname_show = &encodeHtml($domainname);
$domainname_arg  = &encodeUrl($domainname);

# cfɤ߹ࡣ
if ($err = &readFmlFile($listname, "$WBMC_FMLSPOOLDIR/$domainname/$listname/cf", *lines)) {
	&showErrorPage($err, "fml.cgi?$domainname_arg");
	exit(1);
}

$limsize = "";
$chk_allsave = "";
$reply_to = "";

# ͥå
for ($i = 0; $i <= $#lines; $i++) {
	# ƤΥݥꥷ
	if ($lines[$i] =~ /^PERMIT_POST_FROM\s+([^\s]+)\s*/i) {
		if ($1 =~ /members_only/) {
			$pp_membes_only = "CHECKED";
			next;
		}
		if ($1 =~ /anyone/) {
			$pp_anyone = "CHECKED";
		}
		if ($1 =~ /moderator/) {
			$pp_moderator = "CHECKED";
		}
		next;
	}
	# аʳ
	if ($lines[$i] =~ /^REJECT_POST_HANDLER\s+([^\s]+)\s*/i) {
		if ($1 =~ /reject/) {
			$pe_reject = "CHECKED";
			next;
		}
		if ($1 =~ /ignore/) {
			$pe_ignore = "CHECKED";
		}
		if ($1 =~ /auto_regist/) {
			$pe_auto_regist = "CHECKED";
		}
		next;
	}
	# ⡼ȥޥɤΥݥꥷ
	if ($lines[$i] =~ /^PERMIT_COMMAND_FROM\s+([^\s]+)\s*/i) {
		if ($1 =~ /members_only/) {
			$cp_membes_only = "CHECKED";
			next;
		}
		if ($1 =~ /anyone/) {
			$cp_anyone = "CHECKED";
		}
		next;
	}
	# аʳΥ⡼ȥޥ
	if ($lines[$i] =~ /^REJECT_COMMAND_HANDLER\s+([^\s]+)\s*/i) {
		if ($1 =~ /reject/) {
			$ce_reject = "CHECKED";
			next;
		}
		if ($1 =~ /ignore/) {
			$ce_ignore = "CHECKED";
		}
		if ($1 =~ /auto_subscribe/) {
			$ce_auto_subscribe = "CHECKED";
		}
		next;
	}
	# ⡼ȴޥɤλ
	if ($lines[$i] =~ /REMOTE_ADMINISTRATION/) {
               	if ($lines[$i] =~ /^REMOTE_ADMINISTRATION\s+1\s*$/) {
                       	$remote_admcmd = "CHECKED";
                        next;
                }
               	elsif ($lines[$i] !~ /^REMOTE_ADMINISTRATION_/){
                 	$no_remote_admcmd = "CHECKED";
		}
	}
	# ⡼ȴޥɻѵļ
	# members-adminΰɽ
	$body    = "";
	$body   .="<TR bgcolor=\"#cccccc\">"
	        . "<TH NOWRAP>"
	        . ""
	        . "</TH>"
	        . "<TH><NOBR>⡼ȴޥɻѵĥɥ쥹</NOBR></TH>";
	$body .= "</TR>\n";
	$body   .="<TR>"
	        . "<TH NOWRAP>"
	        . "<INPUT TYPE=button VALUE=\"ɲ\" onClick=\"location.href='adminadd.cgi?$listname+$domainname'\">"
	        . "</TH>"
	        . "<TD><NOBR><BR></NOBR></TD>";
	$body .= "</TR>\n";
	if (-e "$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin") {
		# members-adminɤ߹ࡣ
		if ($err = &readFmlFile($listname, "$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin", *pass_lines)) {
			&showErrorPage($err, "fml.cgi?$domainname_arg");
			exit(1);
		}
		foreach (@pass_lines) {
			s/\s*$//;
			if ($_ =~ /^#/) {
				next;
			}
	   	 	# 桼̾
	   	 	$user_name = $_;
	   	 	# Խ//桼̾
	   	 	$body   .="<TR>"
	        	        . "<TH NOWRAP>"
	           	        . "<INPUT TYPE=button VALUE=\"Խ\" onClick=\"location.href='adminmod.cgi?$listname+$domainname+$user_name'\">"
	           	        . "<INPUT TYPE=button VALUE=\"\" onClick=\"funcDelete('$_', '$listname', '$domainname')\">"
	          	        . "</TH>"
	           	        . "<TD><NOBR>$user_name</NOBR></TD>";
	   		$body   .= "</TR>\n";
		}
	}
	# ⡼ȴޥɤǧ
	if ($lines[$i] =~ /^REMOTE_ADMINISTRATION_AUTH_TYPE\s+([^\s]+)\s*/i) {
		if ($1 =~ /crypt/) {
			$auth_crypt = "CHECKED";
			next;
		}
		if ($1 =~ /address/) {
			$auth_address = "CHECKED";
		}
#		if ($1 =~ /md5/) {
#			$auth_md5 = "CHECKED";
#		}
		if ($1 =~ /pgp/) {
			$auth_pgp = "CHECKED";
		}
		next;
	}
	# ᡼륵
	if ($lines[$i] =~ /^INCOMING_MAIL_SIZE_LIMIT\s+([^\s]*)\s*/i) {
		$limsize = $1;
		if ($1 eq "") {
			$limsize = 0;
		}
		next;
	}
        # пͤλϣʳϡ1ɽ
        if ($lines[$i] =~ /^MAX_MEMBER_LIMIT\s+([^\s]*)\s*/i) {
                $maxmember = ${1}+1;
                if ($maxmember == 1) {
                        $maxmember = 0;
                }
                next;
        }
	# ᡼¸
	if ($lines[$i] =~ /^NOT_USE_SPOOL\s+([^\s]*)\s*/i) {
		if ($1 != 0) {
			$chk_nosave = "CHECKED";
		}
		next;
	}
	if ($lines[$i] =~ /^USE_EXPIRE\s+([^\s]*)\s*/i) {
		if ($1 == 0) {
			if ($chk_nosave eq "") { $chk_allsave = "CHECKED"; }
		}
		next;
	}
	if ($lines[$i] =~ /^EXPIRE_LIMIT\s+([^\s]*)\s*/i) {
		if ($1 =~ /^([0-9]+)days$/) {
			if (($chk_nosave eq "") && ($chk_allsave eq "")) { $chk_days = "CHECKED"; }
			$days = $1;
		}
		elsif ($1 =~ /^([0-9]+)$/) {
			if (($chk_nosave eq "") && ($chk_allsave eq "")) { $chk_articles = "CHECKED"; }
			$articles = $1;
		}
		next;
	}
        # إåν񤭴
        if ($lines[$i] =~ /^SUBJECT_TAG_TYPE\s+(\S+.*)\s*$/i) {
                if ($1 eq "") { $no_tag = "SELECTED"; next; }
                if ($1 =~ /\(\:\)/)  { $type01 = "SELECTED"; next; }
                if ($1 =~ /\[\:\]/)  { $type02 = "SELECTED"; next; }
                if ($1 =~ /\(\s\)/)  { $type03 = "SELECTED"; next; }
                if ($1 =~ /\[\s\]/)  { $type04 = "SELECTED"; next; }
                if ($1 =~ /\(\,\)/)  { $type05 = "SELECTED"; next; }
                if ($1 =~ /\[\,\]/)  { $type06 = "SELECTED"; next; }
                if ($1 =~ /\(\)/)    { $type07 = "SELECTED"; next; }
                if ($1 =~ /\[\]/)    { $type08 = "SELECTED"; next; }
                if ($1 =~ /\(ID\)/)  { $type09 = "SELECTED"; next; }
                if ($1 =~ /\[ID\]/)  { $type10 = "SELECTED"; next; }
        }
        if ($lines[$i] =~ /^SUBJECT_FORM_LONG_ID\s*([^\s]*)\s*/i) {
                if ($1 eq "") { $id01 = "SELECTED"; next; }
                if ($1 == -1) { $id01 = "SELECTED"; next; }
                if ($1 ==  2) { $id02 = "SELECTED"; next; }
                if ($1 ==  3) { $id03 = "SELECTED"; next; }
                if ($1 ==  4) { $id04 = "SELECTED"; next; }
                if ($1 ==  5) { $id05 = "SELECTED"; next; }
                if ($1 ==  6) { $id06 = "SELECTED"; next; }
                if ($1 ==  7) { $id07 = "SELECTED"; next; }
                if ($1 ==  8) { $id08 = "SELECTED"; next; }
                if ($1 ==  9) { $id09 = "SELECTED"; next; }
                if ($1 == 10) { $id10 = "SELECTED"; next; }
        }
	if ($lines[$i] =~ /^&DEFINE_FIELD_FORCED\s*\(['"]reply-to['"]\s*,(.*)\)/) {
		@replylines = split(/,/, $1);
		$reply_to = "";
		foreach (@replylines) {	
			if ($_ =~ /([^'"\s].*[^\s'"])/) {
				# ɥ쥹å
				$reply_to .= $1;
				$reply_to .= ",";
			}
		}
	}
	if ($lines[$i] =~ /^&DEFINE_FIELD_FORCED\s*\(['"]from['"]\s*,(.*)\)/) {
		if ($1 =~ /([^'"\s].*[^\s'"])/) {
			# ɥ쥹å
			$from = $1;
		}
	}
}
#if ($reply_to eq "") {
#	$reply_to = "$listname\@$domainname";
#}

# ʥӥС
$navibar = &getNavigation(
        "ӥ",               "../../menu.cgi",
        "᡼륵(sendmail)", "../index.cgi",
	"ɥᥤ",           "index.cgi",
        "᡼󥰥ꥹ",       "./fml.cgi?$domainname_arg",
        "᡼󥰥ꥹȤԽ", "",
        "_back",                  "fml.cgi?$domainname_arg",
        "_help",                  "fmlope_help.html");

#--------------------------------------------------------------------

print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>᡼󥰥ꥹȤԽ</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function funcDelete(user, listname, domainname) {
    if (window.confirm("桼(" + user + ")ޤǤ")) {
	location.href="admindel.cgi?" + listname + "+" + domainname + "+" + user;
    }
    return(false);
}
// -->
</SCRIPT>
</HEAD>
<BODY>
<H4 ALIGN=center>᡼󥰥ꥹȤԽ</H4>
<HR>   
$navibar
<HR>       
<CENTER>
<TABLE>
<TR><TD><B>ɥᥤ</B></TD><TD><B></B></TD><TD><B>$domainname_show</B></TD></TR>
<TR><TD><B>᡼󥰥ꥹ</B></TD><TD><B></B></TD><TD><B>$listname_show</B></TD></TR>
</TABLE>
<TABLE>
<TR>
<TD>
<FORM METHOD=POST ACTION="listmod2.cgi?$listname_arg+$domainname_arg">
<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH=600>
	<TR BGCOLOR="#000080">
		<TD>
			<FONT COLOR="#FFFFFF"> <B>ƥݥꥷ⡼ȥޥɡ⡼ȴޥɤ</B></FONT>
		</TD>
	</TR>
	
	<TR>
	<TH>
	<TABLE WIDTH=100%>
		<TR>
			<!-- cf : PERMIT_POST_FROM -->
			<TD VALIGN=top>ƤΥݥꥷ</TD>
			<TD>
				<INPUT TYPE="radio" NAME="PSTPERM" VALUE="members_only"		$pp_membes_only>ФΤƲǽ<BR>
				<INPUT TYPE="radio" NAME="PSTPERM" VALUE="anyone"			$pp_anyone>ïǤƲǽ<BR>
				<INPUT TYPE="radio" NAME="PSTPERM" VALUE="moderator"		$pp_moderator>ǥ졼ͳƲǽ<BR>
			</TD>
		</TR>
		<TR>
			<!-- cf : REJECT_POST_HANDLER -->
			<TD VALIGN=top>аʳơ</TD>
			<TD>
				<INPUT TYPE="radio" NAME="PSTELSE" VALUE="reject"			$pe_reject>ƤݤơƼԤ<BR>
				<INPUT TYPE="radio" NAME="PSTELSE" VALUE="ignore"			$pe_ignore>Ƥ˴ơ̵<BR>
				<INPUT TYPE="radio" NAME="PSTELSE" VALUE="auto_regist"		$pe_auto_regist>ưϿ⡼<BR>
			</TD>
		</TR>
		
		<TR>
			<!-- cf : PERMIT_COMMAND_FROM -->
			<TD VALIGN=top>⡼ȥޥɤΥݥꥷ</TD>
			<TD>
				<INPUT TYPE="radio" NAME="CMDPERM" VALUE="members_only"		$cp_membes_only>ФΤ߻Ѳǽ<BR>
				<INPUT TYPE="radio" NAME="CMDPERM" VALUE="anyone"			$cp_anyone>ïǤѲǽ<BR>
			</TD>
		</TR>
		<TR>
			<!-- cf : REJECT_COMMAND_HANDLER -->
			<TD VALIGN=top>аʳΥ⡼ȥޥɡ</TD>
			<TD>
				<INPUT TYPE="radio" NAME="CMDELSE" VALUE="reject"			$ce_reject>⡼ȥޥɤݤơƼԤ<BR>
				<INPUT TYPE="radio" NAME="CMDELSE" VALUE="ignore"			$ce_ignore>⡼ȥޥɤ˴ơ̵<BR>
				<INPUT TYPE="radio" NAME="CMDELSE" VALUE="auto_subscribe"	$ce_auto_subscribe>ưϿ<BR>
			</TD>
		</TR>
		<TR>
			<!-- cf : REMOTE_ADMINISTRATION -->
			<TD VALIGN=top>⡼ȴޥɤλѡ</TD>
			<TD>
				<INPUT TYPE="radio" NAME="ADMCMD" VALUE="0"	$no_remote_admcmd>⡼ȴޥɤλԲ<BR>
				<INPUT TYPE="radio" NAME="ADMCMD" VALUE="1"	$remote_admcmd>⡼ȴޥɤλѲǽ<BR>
			</TD>
		</TR>
		<TR>
			<!-- cf : REMOTE_ADMINISTRATION_AUTH_TYPE -->
<!-- comment out
			<TD VALIGN=top>⡼ȴޥɤǧ</TD>
			<TD>
				<INPUT TYPE="radio" NAME="AUTHTYPE" VALUE="address"	$auth_address>ɥ쥹Τ<BR>
				<INPUT TYPE="radio" NAME="AUTHTYPE" VALUE="crypt"	$auth_crypt>ɥ쥹ȥѥ<BR>
				<INPUT TYPE="radio" NAME="AUTHTYPE" VALUE="pgp"	$auth_pgp>PGPǹԤʤ<BR>
			</TD>
		</TR>
-->
		<TR>
			<!-- cf : ADMIN_MEMBER_LIST -->
			<TD VALIGN=top>⡼ȴޥɻѵļԡ</TD>
			<TD>
			<TABLE BORDER=1 CELLSPACING=0 bgcolor="#FFFFFF">
			$body
			</TABLE>
			</TD>
		</TR>
		<TR>
			<!-- cf : PermitAdminProcedure -->
			<TD VALIGN=top>⡼ȴޥɤԽ</TD>
			<TD>
			<INPUT TYPE=button VALUE="Խ" onclick=location.href='admcmdmod.cgi?$listname+$domainname'>
			</TD>
		</TR>
		<TR>
			<TD ALIGN=center COLSPAN=2>
				<INPUT TYPE="submit" VALUE="">
			</TD>
		</TR>
	</TABLE>
	</TH>
	</TR>
</TABLE>

<BR>
<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH=600>
  <TR BGCOLOR="#000080">
    <TD><FONT COLOR="#FFFFFF"> <B>᡼󥰥ꥹȤδ</B></FONT></TD>
  </TR>
  <TR>
  <TH>
  <TABLE WIDTH=100%>
    <TR>
      <!-- cf : INCOMING_MAIL_SIZE_LIMIT -->
      <TD VALIGN=top>᡼륵ξ¡</TD>
      <TD><INPUT TYPE="text"  NAME="LIMSIZE" size=30 VALUE=$limsize></TD>
    </TR>
    <TR>
      <!-- cf : MAX_MEMBER_LIMIT -->
      <TD VALIGN=top>пͿ</TD>
      <TD><INPUT TYPE="text"  NAME="MAXMEM" size=30 VALUE=$maxmember></TD>
    </TR>
    <TR>
      <!-- cf : USE_EXPIRE, EXPIRE_LIMIT -->
      <TD VALIGN=top>᡼¸</TD>
      <TD>
        <TABLE>
	  <TR>
            <TD><INPUT TYPE="radio" NAME="EXPIRE" VALUE="nosave" $chk_nosave>¸ʤ</TD>
	  </TR>
	  <TR>
            <TD><INPUT TYPE="radio" NAME="EXPIRE" VALUE="days" $chk_days></TD>
            <TD><INPUT TYPE="text" NAME="DAYS" size=12 VALUE="$days">¸</TD>
	  </TR>
	  <TR>
            <TD><INPUT TYPE="radio" NAME="EXPIRE" VALUE="articles" $chk_articles></TD>
            <TD><INPUT TYPE="text" NAME="ARTNUM" size=12 VALUE=$articles>¸</TD>
	  </TR>
	  <TR>
            <TD><INPUT TYPE="radio" NAME="EXPIRE" VALUE="allsave" $chk_allsave>٤¸</TD>
	  </TR>
        </TABLE>
      </TD>
    </TR>
    <TR>
      <TD ALIGN=center COLSPAN=2><INPUT TYPE="submit" VALUE=""><TD>
    </TR>
  </TABLE>
  </TR>
</TABLE>

<BR>
<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH=600>
  <TR BGCOLOR="#000080">
    <TD><FONT COLOR="#FFFFFF"> <B>إåν񤭴</B></FONT></TD>
  </TR>
  <TR>
  <TH>
  <TABLE WIDTH=100%>
    <TR>
      <!-- cf : SUBJECT_TAG_TYPE -->
      <TD VALIGN=top>Subject: </TD>
      <TD>
        <SELECT NAME="TAGTYPE">
            <OPTION VALUE="" $no_tag>ʤ
            <OPTION VALUE="(:)" $type01>(Elena:00100)
            <OPTION VALUE="[:]" $type02>[Elena:00100]
            <OPTION VALUE="( )" $type03>(Elena 00100)
            <OPTION VALUE="[ ]" $type04>[Elena 00100]
            <OPTION VALUE="(,)" $type05>(Elena,00100)
            <OPTION VALUE="[,]" $type06>[Elena,00100]
            <OPTION VALUE="()" $type07>(Elena)
            <OPTION VALUE="[]" $type08>[Elena]
            <OPTION VALUE="(ID)" $type09>(00100)
            <OPTION VALUE="[ID]" $type10>[00100]
        </SELECT>
      </TD>
    </TR>
    <TR>
      <!-- cf : SUBJECT_FORM_LONG_ID -->
      <TD VALIGN=top>Subject: ɣķ</TD>
      <TD>
        <SELECT NAME="IDNUM">
            <OPTION VALUE="-1" $id01>[elena 1],     [elena 100],   [elena 10000]
            <OPTION VALUE="2" $id02>[elena 01],    [elena 100],   [elena 10000]
            <OPTION VALUE="3" $id03>[elena 001],   [elena 100],   [elena 10000]
            <OPTION VALUE="4" $id04>[elena 0001],  [elena 0100],  [elena 10000]
            <OPTION VALUE="5" $id05>[elena 00001], [elena 00100], [elena 10000]
            <OPTION VALUE="6" $id06>[elena 000100]
            <OPTION VALUE="7" $id07>[elena 0000100]
            <OPTION VALUE="8" $id08>[elena 00000100]
            <OPTION VALUE="9" $id09>[elena 000000100]
            <OPTION VALUE="10" $id10>[elena 0000000100]
        </SELECT>
      </TD>
    </TR>
    <TR>
      <TD VALIGN=top>Reply-To: ֿ</TD>
      <TD><INPUT TYPE="text" NAME="REPLYTO" size=50 VALUE="$reply_to"></TD>
    </TR>
    <TR>
      <TD VALIGN=top>From: п</TD>
      <TD><INPUT TYPE="text" NAME="FROM" size=50 VALUE="$from"></TD>
    </TR>
    <TR>
      <TD ALIGN=center COLSPAN=2><INPUT TYPE="submit" VALUE=""><TD>
    </TR>
  </TABLE>
  </TR>
</TABLE>
</FORM>

<CENTER>
<FORM METHOD=POST ACTION="msgedit.cgi?$listname_arg+$domainname_arg">
<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH=600>
  <TR BGCOLOR="#000080">
    <TD><FONT COLOR="#FFFFFF"> <B>ֿåԽ</B></FONT></TD>
  </TR>
  <TR>
  <TH>
  <TABLE WIDTH=100%>
    <TR>
      <!-- VALUE="xxx" ϡºݤΥե̾Ʊ̾ɬ -->
      <TD VALIGN=top>
        <INPUT TYPE="radio" NAME="MSGFILE" VALUE="confirm" CHECKED>$confirm<BR>
        <INPUT TYPE="radio" NAME="MSGFILE" VALUE="deny" >$deny<BR>
        <INPUT TYPE="radio" NAME="MSGFILE" VALUE="guide" >$guide<BR>
      </TD>
      <TD VALIGN=top>
        <INPUT TYPE="radio" NAME="MSGFILE" VALUE="help" >$help<BR>
        <INPUT TYPE="radio" NAME="MSGFILE" VALUE="objective" >$objective<BR>
        <INPUT TYPE="radio" NAME="MSGFILE" VALUE="welcome" >$welcome<BR>
      </TD>
    </TR>
    <TR>
      <TD ALIGN=center COLSPAN=2><INPUT TYPE="submit" VALUE="Խ"><TD>
    </TR>
  </TABLE>
  </TR>
</TABLE>
</FORM>

</FORM>
</TD>
</TR>
</TABLE>
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
