#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: ml_html.cgi,v 1.1 2002/09/24 04:44:21 snavi Exp $


require "../../../../../lib/wbmc.pl";

my($admin_conf) = "ADMIN";

my($update_conf) = "UPDATE";
my($update_hour) = "HOUR";
my($update_day)  = "DAILY";
my($update_week) = "WEEKLY";

my($index_conf)         = "INDEX";
my($index_def_conf)     = "DEF";
my($index_search_conf)  = "SEARCH";
my($index_user_conf)    = "USER";

my($fml_dir) = "/home/fml";

#
# å
#
exit(1) if(@ARGV < 2);

#
# ᡼󥰥ꥹ̾󥳡
#
$listname = $ARGV[0];
$listname =~ s/\\(.)/$1/g;
$listname_show  = &encodeHtml($listname);
#$listname_arg   = &encodeUrl($listname);

#
# ɥᥤ̾󥳡
#
$domainname = $ARGV[1];
$domainname =~ s/\\(.)/$1/g;
$domainname_show = &encodeHtml($domainname);
$domainname_arg  = &encodeUrl($domainname);

my($lock_file) = "wbmc_ml_html.conf";
my($conf_file) = "$fml_dir/$domainname/$listname/$lock_file";

#
# HTMLե̵ͭå
#

# ե뤬¸ߤʤ
if (! -e "$conf_file") {
    $admin_off_chk = "CHECKED";
    $update_off_chk = "CHECKED";
    $idef_on_chk = "CHECKED";

# ե뤬¸ߤ
} else {
    if (!&readFile($conf_file, $lock_file, *lines)) {
        &showErrorPage("եɤ߹ޤ", "../fml.cgi?$domainname_arg");
        exit(1);
    }

    foreach $line (@lines) {

        # ԥ᡼륢ɥ쥹
        if ($line =~ /^\s*$admin_conf/) {
            $admin_on_chk = "CHECKED";
            $admin_mail_addr = (split (':', $line))[1];
            $admin_mail_addr_show = &encodeHtml($admin_mail_addr);
            next;
        }

        # ư
        if ($line =~ /^\s*$update_conf/) { 
            $update_on_chk = "CHECKED";
            @t_elm = split (':', $line);
            $value = $t_elm[2];
            chomp($value);
            if ($t_elm[1] eq $update_hour) {
                $hour_on_chk = "CHECKED";
                if ($value == 1) { $hour_1_chk = "SELECTED"; next; }
                if ($value == 2) { $hour_2_chk = "SELECTED"; next; }
                if ($value == 3) { $hour_3_chk = "SELECTED"; next; }
                if ($value == 4) { $hour_4_chk = "SELECTED"; next; }
                if ($value == 6) { $hour_6_chk = "SELECTED"; next; }
                if ($value == 12) { $hour_12_chk = "SELECTED"; next; }
            }
            if ($t_elm[1] eq $update_day) {
                $daily_on_chk = "CHECKED";
                $daily_hour = (split ('-', $value))[0];
                $daily_minute = (split ('-', $value))[1];

                if ($daily_hour == 0) { $daily_hour_0_chk = "SELECTED"; }
                elsif ($daily_hour == 1) { $daily_hour_1_chk = "SELECTED"; }
                elsif ($daily_hour == 2) { $daily_hour_2_chk = "SELECTED"; }
                elsif ($daily_hour == 3) { $daily_hour_3_chk = "SELECTED"; }
                elsif ($daily_hour == 4) { $daily_hour_4_chk = "SELECTED"; }
                elsif ($daily_hour == 5) { $daily_hour_5_chk = "SELECTED"; }
                elsif ($daily_hour == 6) { $daily_hour_6_chk = "SELECTED"; }
                elsif ($daily_hour == 7) { $daily_hour_7_chk = "SELECTED"; }
                elsif ($daily_hour == 8) { $daily_hour_8_chk = "SELECTED"; }
                elsif ($daily_hour == 9) { $daily_hour_9_chk = "SELECTED"; }
                elsif ($daily_hour == 10) { $daily_hour_10_chk = "SELECTED"; }
                elsif ($daily_hour == 11) { $daily_hour_11_chk = "SELECTED"; }
                elsif ($daily_hour == 12) { $daily_hour_12_chk = "SELECTED"; }
                elsif ($daily_hour == 13) { $daily_hour_13_chk = "SELECTED"; }
                elsif ($daily_hour == 14) { $daily_hour_14_chk = "SELECTED"; }
                elsif ($daily_hour == 15) { $daily_hour_15_chk = "SELECTED"; }
                elsif ($daily_hour == 16) { $daily_hour_16_chk = "SELECTED"; }
                elsif ($daily_hour == 17) { $daily_hour_17_chk = "SELECTED"; }
                elsif ($daily_hour == 18) { $daily_hour_18_chk = "SELECTED"; }
                elsif ($daily_hour == 19) { $daily_hour_19_chk = "SELECTED"; }
                elsif ($daily_hour == 20) { $daily_hour_20_chk = "SELECTED"; }
                elsif ($daily_hour == 21) { $daily_hour_21_chk = "SELECTED"; }
                elsif ($daily_hour == 22) { $daily_hour_22_chk = "SELECTED"; }
                elsif ($daily_hour == 23) { $daily_hour_23_chk = "SELECTED"; }

                if ($daily_minute == 0) { $daily_minute_0_chk = "SELECTED"; }
                elsif ($daily_minute == 10) { $daily_minute_10_chk = "SELECTED"; }
                elsif ($daily_minute == 20) { $daily_minute_20_chk = "SELECTED"; }
                elsif ($daily_minute == 30) { $daily_minute_30_chk = "SELECTED"; }
                elsif ($daily_minute == 40) { $daily_minute_40_chk = "SELECTED"; }
                elsif ($daily_minute == 50) { $daily_minute_50_chk = "SELECTED"; }

                next;
            }
            if ($t_elm[1] eq $update_week) {
                $weekly_on_chk = "CHECKED";
                $weekly_day = (split ('-', $value))[0];
                $weekly_hour = (split ('-', $value))[1];

                if ($weekly_day eq "mon") { $week_mon_chk = "SELECTED"; }
                elsif ($weekly_day eq "tue") { $week_tue_chk = "SELECTED"; }
                elsif ($weekly_day eq "wed") { $week_wed_chk = "SELECTED"; }
                elsif ($weekly_day eq "thu") { $week_thu_chk = "SELECTED"; }
                elsif ($weekly_day eq "fri") { $week_fri_chk = "SELECTED"; }
                elsif ($weekly_day eq "sat") { $week_sat_chk = "SELECTED"; }
                elsif ($weekly_day eq "sun") { $week_sun_chk = "SELECTED"; }

                if ($weekly_hour == 0) { $week_hour_0_chk = "SELECTED"; }
                elsif ($weekly_hour == 1) { $week_hour_1_chk = "SELECTED"; }
                elsif ($weekly_hour == 2) { $week_hour_2_chk = "SELECTED"; }
                elsif ($weekly_hour == 3) { $week_hour_3_chk = "SELECTED"; }
                elsif ($weekly_hour == 4) { $week_hour_4_chk = "SELECTED"; }
                elsif ($weekly_hour == 5) { $week_hour_5_chk = "SELECTED"; }
                elsif ($weekly_hour == 6) { $week_hour_6_chk = "SELECTED"; }
                elsif ($weekly_hour == 7) { $week_hour_7_chk = "SELECTED"; }
                elsif ($weekly_hour == 8) { $week_hour_8_chk = "SELECTED"; }
                elsif ($weekly_hour == 9) { $week_hour_9_chk = "SELECTED"; }
                elsif ($weekly_hour == 10) { $week_hour_10_chk = "SELECTED"; }
                elsif ($weekly_hour == 11) { $week_hour_11_chk = "SELECTED"; }
                elsif ($weekly_hour == 12) { $week_hour_12_chk = "SELECTED"; }
                elsif ($weekly_hour == 13) { $week_hour_13_chk = "SELECTED"; }
                elsif ($weekly_hour == 14) { $week_hour_14_chk = "SELECTED"; }
                elsif ($weekly_hour == 15) { $week_hour_15_chk = "SELECTED"; }
                elsif ($weekly_hour == 16) { $week_hour_16_chk = "SELECTED"; }
                elsif ($weekly_hour == 17) { $week_hour_17_chk = "SELECTED"; }
                elsif ($weekly_hour == 18) { $week_hour_18_chk = "SELECTED"; }
                elsif ($weekly_hour == 19) { $week_hour_19_chk = "SELECTED"; }
                elsif ($weekly_hour == 20) { $week_hour_20_chk = "SELECTED"; }
                elsif ($weekly_hour == 21) { $week_hour_21_chk = "SELECTED"; }
                elsif ($weekly_hour == 22) { $week_hour_22_chk = "SELECTED"; }
                elsif ($weekly_hour == 23) { $week_hour_23_chk = "SELECTED"; }

                next;
            }
        }

        # HTMLڡɽ
        if ($line =~ /^\s*$index_conf/) { 
            @i_elm = split (':', $line);
            $value = $i_elm[2];
            chomp($value);
            if ($i_elm[1] eq $index_def_conf) {
                $idef_on_chk = "CHECKED";
            } elsif ($i_elm[1] eq $index_search_conf) {
                $isearch_on_chk = "CHECKED";
                $search_path = $value;
                $search_path_show = &encodeHtml($search_path);
                if ($value eq "") {
                    $sdef_on_chk = "CHECKED";
                } else {
                    $sdef_off_chk = "CHECKED";
                }
            } elsif ($i_elm[1] eq $index_user_conf) {
                $iuser_on_chk = "CHECKED";
                $index_path = $value;
                $index_path_show = &encodeHtml($index_path);
            }
            next;
        }
    }
}
if ($admin_on_chk ne "CHECKED") { $admin_off_chk = "CHECKED"; }
if ($update_on_chk ne "CHECKED") { $update_off_chk = "CHECKED"; }
if ($isearch_on_chk ne "CHECKED" and $iuser_on_chk ne "CHECKED") { $idef_on_chk = "CHECKED"; }

#
# ᡼󥰥ꥹ̾ɥᥤ̾
#
$listinfo = "<TABLE>"
    . "<TR><TD><B>ɥᥤ</B></TD><TD><B></B></TD><TD><B>$domainname_show</B></TD></TR>"
    . "<TR><TD><B>᡼󥰥ꥹ</B></TD><TD><B></B></TD><TD><B>$listname_show</B></TD></T
R>"
    . "</TABLE>";

$navibar = &getNavigation(
        "ӥ",                    "../../../menu.cgi",
        "᡼륵(sendmail)",      "../../index.cgi",
        "ɥᥤ",                "../index.cgi",
        "᡼󥰥ꥹ",            "../fml.cgi?$domainname_arg",
        "᡼󥰥ꥹHTML",    "",
        "_back",                       "../fml.cgi?$domainname_arg",
        "_help",                       "index_help.html");
#----------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp
Pragma: no-cache

<HTML>
<HEAD>
<TITLE>᡼󥰥ꥹHTML</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function set_html() {
    if (window.confirm("᡼󥰥ꥹȤHTMLޤ᡼¸̤˱ƺ˻֤פޤǤ")) {
        document.FORM_SET.submit();
    }
}
function del_html() {
    if (window.confirm("᡼󥰥ꥹȤHTMLޤǤ")) {
        document.FORM_DEL.submit();
    }
}
//-->
</SCRIPT>
</HEAD>
<BODY>

<H4 ALIGN=center>᡼󥰥ꥹHTML</H4>
<HR>
$navibar
<HR>
<CENTER>
<BR>
$listinfo


<BR>
<FORM METHOD="POST" NAME="FORM_SET" ACTION="ml_html_set.cgi">
<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1>
 <TR BGCOLOR="#000080">
  <TD><FONT COLOR="#FFFFFF"> <B>᡼󥰥ꥹHTML</B></FONT></TD>
 </TR>
 <TR>
  <TD>
   <TABLE>
    <TR>
     <TD NOWRAP="nowrap">ԥ᡼륢ɥ쥹</TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="ADMIN_ADDR" VALUE="ADMIN_OFF" $admin_off_chk>ʤ
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="ADMIN_ADDR" VALUE="ADMIN_ON" $admin_on_chk>롡
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD COLSPAN=20>
      <INPUT TYPE="text" NAME="MAIL_ADDR" SIZE="40" VALUE="$admin_mail_addr_show">
     </TD>
    </TR>
    <TR>
     <TD NOWRAP="nowrap">ư</TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="UPDATE" VALUE="UPDATE_OFF" $update_off_chk>̵
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="UPDATE" VALUE="UPDATE_ON" $update_on_chk>ͭ
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="UPDATE_SELECT" VALUE="HOUR_ON" $hour_on_chk>
      <SELECT NAME="HOUR">
       <OPTION $hour_1_chk>1</OPTION>
       <OPTION $hour_2_chk>2</OPTION>
       <OPTION $hour_3_chk>3</OPTION>
       <OPTION $hour_4_chk>4</OPTION>
       <OPTION $hour_6_chk>6</OPTION>
       <OPTION $hour_12_chk>12</OPTION>
      </SELECT>
      
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="UPDATE_SELECT" VALUE="DAILY_ON" $daily_on_chk>
      <SELECT NAME="DAILY_HOUR">
       <OPTION $daily_hour_0_chk>0</OPTION>
       <OPTION $daily_hour_1_chk>1</OPTION>
       <OPTION $daily_hour_2_chk>2</OPTION>
       <OPTION $daily_hour_3_chk>3</OPTION>
       <OPTION $daily_hour_4_chk>4</OPTION>
       <OPTION $daily_hour_5_chk>5</OPTION>
       <OPTION $daily_hour_6_chk>6</OPTION>
       <OPTION $daily_hour_7_chk>7</OPTION>
       <OPTION $daily_hour_8_chk>8</OPTION>
       <OPTION $daily_hour_9_chk>9</OPTION>
       <OPTION $daily_hour_10_chk>10</OPTION>
       <OPTION $daily_hour_11_chk>11</OPTION>
       <OPTION $daily_hour_12_chk>12</OPTION>
       <OPTION $daily_hour_13_chk>13</OPTION>
       <OPTION $daily_hour_14_chk>14</OPTION>
       <OPTION $daily_hour_15_chk>15</OPTION>
       <OPTION $daily_hour_16_chk>16</OPTION>
       <OPTION $daily_hour_17_chk>17</OPTION>
       <OPTION $daily_hour_18_chk>18</OPTION>
       <OPTION $daily_hour_19_chk>19</OPTION>
       <OPTION $daily_hour_20_chk>20</OPTION>
       <OPTION $daily_hour_21_chk>21</OPTION>
       <OPTION $daily_hour_22_chk>22</OPTION>
       <OPTION $daily_hour_23_chk>23</OPTION>
      </SELECT>
      
      <SELECT NAME="DAILY_MINUTE">
       <OPTION $daily_minute_0_chk>0</OPTION>
       <OPTION $daily_minute_10_chk>10</OPTION>
       <OPTION $daily_minute_20_chk>20</OPTION>
       <OPTION $daily_minute_30_chk>30</OPTION>
       <OPTION $daily_minute_40_chk>40</OPTION>
       <OPTION $daily_minute_50_chk>50</OPTION>
      </SELECT>
      ʬ
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="UPDATE_SELECT" VALUE="WEEKLY_ON" $weekly_on_chk>轵
      <SELECT NAME="WEEK">
       <OPTION VALUE="mon" $week_mon_chk></OPTION>
       <OPTION VALUE="tue" $week_tue_chk></OPTION>
       <OPTION VALUE="wed" $week_wed_chk></OPTION>
       <OPTION VALUE="thu" $week_thu_chk></OPTION>
       <OPTION VALUE="fri" $week_fri_chk></OPTION>
       <OPTION VALUE="sat" $week_sat_chk></OPTION>
       <OPTION VALUE="sun" $week_sun_chk></OPTION>
      </SELECT>
      <SELECT NAME="WEEK_HOUR">
       <OPTION $week_hour_0_chk>0</OPTION>
       <OPTION $week_hour_1_chk>1</OPTION>
       <OPTION $week_hour_2_chk>2</OPTION>
       <OPTION $week_hour_3_chk>3</OPTION>
       <OPTION $week_hour_4_chk>4</OPTION>
       <OPTION $week_hour_5_chk>5</OPTION>
       <OPTION $week_hour_6_chk>6</OPTION>
       <OPTION $week_hour_7_chk>7</OPTION>
       <OPTION $week_hour_8_chk>8</OPTION>
       <OPTION $week_hour_9_chk>9</OPTION>
       <OPTION $week_hour_10_chk>10</OPTION>
       <OPTION $week_hour_11_chk>11</OPTION>
       <OPTION $week_hour_12_chk>12</OPTION>
       <OPTION $week_hour_13_chk>13</OPTION>
       <OPTION $week_hour_14_chk>14</OPTION>
       <OPTION $week_hour_15_chk>15</OPTION>
       <OPTION $week_hour_16_chk>16</OPTION>
       <OPTION $week_hour_17_chk>17</OPTION>
       <OPTION $week_hour_18_chk>18</OPTION>
       <OPTION $week_hour_19_chk>19</OPTION>
       <OPTION $week_hour_20_chk>20</OPTION>
       <OPTION $week_hour_21_chk>21</OPTION>
       <OPTION $week_hour_22_chk>22</OPTION>
       <OPTION $week_hour_23_chk>23</OPTION>
      </SELECT>
      
     </TD>
    </TR>
    <TR>
     <TD NOWRAP="nowrap">HTMLڡɽ</TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="INDEX_VIEW" VALUE="IDEF_ON" $idef_on_chk>ǥե
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="INDEX_VIEW" VALUE="IDEF_S_ON" $isearch_on_chk>ǥե(ͭ)
     </TD>
    </TR>
    <TR>
    <TR>
     <TD><BR></TD>
    </TR>
     <TD><BR></TD>
     <TD NOWRAP="nowrap">ڡɽ</TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="SEARCH_VIEW" VALUE="SDEF_ON" $sdef_on_chk>ǥե
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="SEARCH_VIEW" VALUE="SDEF_OFF" $sdef_off_chk>桼
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD><BR></TD>
     <TD COLSPAN=20>
      <INPUT TYPE="text" NAME="SEARCH_PATH" SIZE="50" VALUE="$search_path_show">
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD>
      <INPUT TYPE="radio" NAME="INDEX_VIEW" VALUE="IDEF_OFF" $iuser_on_chk>桼
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD COLSPAN=20>
      <INPUT TYPE="text" NAME="INDEX_PATH" SIZE="50" VALUE="$index_path_show">
     </TD>
    </TR>
    <TR>
     <TD COLSPAN=20" ALIGN="center">
       <INPUT TYPE="button" VALUE="" onClick='set_html()'>
       <INPUT TYPE="button" VALUE="" onClick='del_html()'>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>
<INPUT TYPE="hidden" NAME="LISTNAME" VALUE="$listname">
<INPUT TYPE="hidden" NAME="DOMAINNAME" VALUE="$domainname">
</FORM>
<FORM METHOD="POST" NAME="FORM_DEL" ACTION="del_html.cgi">
 <INPUT TYPE="hidden" NAME="LISTNAME" VALUE="$listname">
 <INPUT TYPE="hidden" NAME="DOMAINNAME" VALUE="$domainname">
</FORM>
<BR>


</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>

END_OF_DATA
#=---------
