# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: virtualdfml.pl,v 1.1.1.1 2002/09/09 07:43:32 snavi Exp $

# ۥɥᥤѹ ˤ fml Ϣν

##010615  "1;" ɲ    haramoto
##010704 v4.1.0  \Q  \E б S.Oku

require "/opt/nec/wbmc/domain/lib/wbmc.pl";
require join ("/", $WBMC_ADM_DIR, "service/11sendmail/fml", "fml.pl");
require join ("/", $WBMC_DOMADM_DIR, "mail", "aliase.pl");

$FML_SYSTEM="$WBMC_FMLDIR/.fml/system"; # fml systemե̾

#--------------------------------------------------------------------
# ۥɥᥤɲûν
#--------------------------------------------------------------------
#
# ̾
#   makeFmlML - ۥɥᥤѤΥ᡼󥰥ꥹȤ
# 
#   makeFmlML($virtual)
# 
#   $virtual ۥɥᥤ FQDN
# 
#   ｪλ ""
#   ۾ｪλ ""ʳΥ顼å
#
sub makeFmlML
{
  my($virtual)=$_[0];
  my($err)="";

  if( !&makeFmlSpool($virtual) ){
    $err .= "makeFmlML()::ۥɥᥤMLסǤޤǤ \n";
  }
  if( !&makeFmlSystem($virtual) ){
    $err .= "makeFmlML()::ۥɥᥤsystemեǤޤǤ \n";
  }
  return $err;
}

#
# ̾
#   makeFmlSpool - ۥɥᥤѤ fml Υס
# 
#   makeFmlSpool($virtual)
# 
#   $virtual ۥɥᥤ FQDN
# 
#   ｪλ 1
#   ۾ｪλ 0
#
sub makeFmlSpool
{
  my($virtual)=$_[0];
#  my($ret);  20000222 mod
  my($ret) = "1"; 
  my($fml_uid,$fml_gid);
  my($dir)="$WBMC_FMLSPOOLDIR/$virtual";
  my($sys)="$dir/.fml";

#  $ret=mkdir($dir,0755);  20000222 mod 
  if (!-d $dir) {
     $ret=mkdir($dir,0755);
  }
  if (!-d $sys) {		# 20010305 add shimizu
     $ret=mkdir($sys,0755);
  }


  ($fml_uid,$fml_gid)=&getUidGid("fml"); # 桼 fml  uid gid 
  chown($fml_uid, $fml_gid, $dir);
  chown($fml_uid, $fml_gid, $sys);  # 20010305 add shimizu

  return($ret);
}

#
# ̾
#   makeFmlSystem - ۥɥᥤѤ fml Υƥե
# 
#   makeFmlSystem($domainname)
# 
#   $domainname ۥɥᥤ FQDN
# 
#   ｪλ 1
#   ۾ｪλ 0
#
sub makeFmlSystem
{
  my($domainname)=$_[0];
  my($FML_VIRTSYS) = "$WBMC_FMLSPOOLDIR/$domainname/.fml/system";
  my($WBMC_LOCK_R_B)  = 1; # ɤ߹ߥå(֥å⡼)
  my($WBMC_LOCK_W_B)  = 2; # 񤭹ߥå(֥å⡼)
  my($WBMC_LOCK_R_NB) = 5; # ɤ߹ߥå(Υ֥å⡼)
  my($WBMC_LOCK_W_NB) = 6; # 񤭹ߥå(Υ֥å⡼)

  # ¥ɥᥤΥƥեɤ߹
  open(ORG,"$FML_SYSTEM") || return 0;
  flock(ORG, 2) || return 0;
  @org=<ORG>;
  close(ORG);
  # ۥɥᥤΥƥե򳫤
  open(VD,"> $FML_VIRTSYS") || return 0;
  foreach $line (@org){
    # ᡼󥰥ꥹȤμΤ֤ǥ쥯ȥ
    if( $line =~ /^\s*\$ML_DIR/ ){
      $line =~ /(.+)\/(.+)\'(.+)/;
      print VD "$1/$domainname\'$3\n";
      next;
    }
    # ɥᥤ̾
    if( $line =~ /^\s*(\$DOMAIN|\$FQDN)/ ){
      $line =~ /\'(.+)\'/;
      print VD "$`\'$domainname\'$'";
      next;
    }
    print VD $line;
  }
  close(VD);

  return(1);
}

#
# ̾
#   getUidGid - 桼̾ 桼ID  롼ID 
# 
#   getUidGid($username)
# 
#   $username - 桼̾
# 
#   ｪλ (桼ID, 롼ID)
#   ۾ｪλ (-1,-1)
#
sub getUidGid
{
  my($username)=$_[0];
  my($uid,$gid)=(-1,-1);
  my(@passwd,@p);

  # 桼ID õ
  open(PASSWD,"/etc/passwd");
  @p=<PASSWD>; 
  close(PASSWD);
  foreach (@p){
    @passwd=split(":",$_);
    $uid=$passwd[2] if( $passwd[0] eq $username);
  }

  # 롼ID õ
  open(PASSWD,"/etc/group");
  @p=<PASSWD>; 
  close(PASSWD);
  foreach (@p){
    @passwd=split(":",$_);
    $gid=$passwd[2] if( $passwd[0] eq $username);
  }
  return($uid,$gid);
}

#--------------------------------------------------------------------
# ۥɥᥤ̾ѹν
#--------------------------------------------------------------------
#
# ̾
#   renameFmlML - ᡼󥰥ꥹȤߤβۥɥᥤ̾ѹ
#                 ƥե롢åե롢
#                 סǥ쥯ȥѹ
# 
#   renameFmlML($old_domainname,$new_domainname)
# 
#   $old_domainname ѹβۥɥᥤ FQDN
#   $new_domainname ѹβۥɥᥤ FQDN
# 
#   ｪλ ""
#   ۾ｪλ ""ʳΥ顼å
#
sub renameFmlML
{
  my($old_domainname,$new_domainname)=@_;
  my(@mess)=(          # åե̾
    "confirm",         #   confirm ⡼ɤϿ
    "confirmd.ackreq", #   confirm ⡼ɤϿ³ǧ
    "deny",            #   г
    "guide",           #   ML  guide
    "help",            #   ML λȤ help
    "help-admin",      #   admin  help
    "objective",       #   ML  objective (Ū)
    "welcome");        #   å
  my($SPOOL)="$WBMC_FMLSPOOLDIR/$old_domainname"; # סΥǥ쥯ȥ
  my($dir,$file,@a);
  my($err)="";

  # Ť system եäơ system ե
  if( !&deleteFmlSystem($old_domainname) ){
    $err .= "renameFmlML()::ۥɥᥤ̾ѹsystemեǤޤǤ \n";
  }
  if( !&makeFmlSystem($new_domainname) ){
    $err .= "renameFmlML()::ۥɥᥤsystemեǤޤǤ \n";
  }

  # åեΥ᡼륢ɥ쥹ѹ
  opendir(DIR_FML, $SPOOL);
  for $dir (readdir(DIR_FML)) {
    next if $dir =~ /^\./;
    next if $dir =~ /^\@/;
    next if $dir eq 'etc';
    foreach $file (@mess){
      # åե򳫤ǤʤƤ̵롣
      open(MESS,"$SPOOL/$dir/$file") || next;
      @a=<MESS>;
      close(MESS);
      # ᡼륢ɥ쥹Υɥᥤʬ֤񤭽Ф
      @a=&replaceDomainPart($old_domainname,$new_domainname,@a);
      open(MESS,"> $SPOOL/$dir/$file");
      print MESS @a;
      close(MESS);
    }
  }

  # סǥ쥯ȥ̾Ѥ
  if( !rename("$WBMC_FMLSPOOLDIR/$old_domainname","$WBMC_FMLSPOOLDIR/$new_domainname") ){
    $err .= "renameFmlML()::ۥɥᥤMLס͡ǤޤǤ \n";
  }
  
  return($err);
}

#
# ̾
#   replaceDomainPart - ᡼륢ɥ쥹Υɥᥤʬ򸡺ִ
# 
#   replaceDomainPart($old,$new,@a)
# 
#   $old ʸ
#   $new ִʸ
#   @a ִоʸ
# 
#   ִ줿ʸ
#
sub replaceDomainPart
{
  my($old,$new,@a)=@_;
  my($i);
  
  foreach $i (0..$#a){
    $a[$i] =~ s/\Q$old\E/$new/g;
  }
  return @a;
}


#--------------------------------------------------------------------
# ۥɥᥤν
#--------------------------------------------------------------------
#
# ̾
#   deleteFmlML - ۥɥᥤѤΥ᡼󥰥ꥹȤ
# 
#   deleteFmlML($domainname)
# 
#   $domainname ۥɥᥤ FQDN
# 
#   ｪλ ""
#   ۾ｪλ ""ʳΥ顼å
#
sub deleteFmlML
{
  my($err)="";
  my($domainname) = @_;
  
  # ꥢ
  $err .= &deleteFmlAliases($domainname);
  if( !&deleteFmlSpool($domainname) ){
    $err .= "deleteFmlML()::ۥɥᥤMLΥסǤޤǤ \n";
  }
#  if( !&deleteFmlSystem($domainname) ){
#    $err .= "deleteFmlML()::ۥɥᥤѤsystemեǤޤǤ \n";
#  }
  return($err);
}

#
# ̾
#   deleteFmlSpool - ۥɥᥤѤ ס
# 
#   deleteFmlSpool($domainname)
# 
#   $domainname ۥɥᥤ FQDN
# 
#   ｪλ 1
#   ۾ｪλ 0
#
sub deleteFmlSpool
{
  return !system("/bin/rm -rf $WBMC_FMLSPOOLDIR/$_[0]");
}

#
# ̾
#   deleteFmlSystem - ۥɥᥤѤ fml  system ե
# 
#   deleteFmlSystem($domainname)
# 
#   $domainname ۥɥᥤ FQDN
# 
#   ｪλ 1
#   ۾ｪλ 0
#
sub deleteFmlSystem
{
  return unlink("$FML_SYSTEM-$_[0]");
}

#
# ̾
#   deleteFmlAliases - ۥɥᥤѤ fml Υꥢ
# 
#   deleteFmlAliases($domainname)
# 
#   $domainname ۥɥᥤ FQDN
# 
#   ｪλ 1
#   ۾ｪλ 0
#
sub deleteFmlAliases
{
  my($domainname) = @_;
  my(@all_lists) = ();
  my($i);
  @all_lists = &getListName($domainname);
  $err = "";
  for ($i = 0; $i <= $#all_lists; $i++) {
    if ($err = &delListAliases($all_lists[$i], $domainname)) {
      return($err);
    }
  }
  return($err);
}

1;

