#!/usr/bin/perl

#----------------------------------------------------------------------------
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

##011212 v4.3 DNSSOAԽǴԺĹб hirano

#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "named.pl";
require "namedapi.pl";
#------------------------------------------------------------

if ($err = &readParam()) {
	$err = $STR_ERR_SYSTEM;
	&showErrorPage("$err", "");
	exit(1);
}

$zfile = $FORM{'ZONE_FILE'};
$zname = $FORM{'ZONE_NAME'};

for($i = 0; $i < 10; $i++){
  $owner[$i] = $FORM{"LEFT$i"};
  $record[$i] = $FORM{"SELECT$i"};
  $value[$i] = $FORM{"RIGHT$i"};
  $mx[$i] = $FORM{"MX$i"};

  $value[$i] =~ s/\s+$//;
  $value[$i] =~ s/^\s+//;
  $owner[$i] =~ s/\s+$//;
  $owner[$i] =~ s/^\s+//;
}

# check parameters
$bErr = 0;
$noitems = 0;
for($i = 0; $i < 10; $i++){
    if(($owner[$i] ne "") && ($value[$i] eq "")){
        $ErrMsg = "ͤϤƤޤ";
	$bErr = 1;
    }
    if(($owner[$i] eq "") && ($value[$i] eq "")){
	$noitems++;
	next;
    }

# records: A, PTR, CNAME, NS, MX, HINFO, TXT, WKS
    if($record[$i] eq "A"){
        if(ipAddrCheck($value[$i]) == 0){
	    $ErrMsg = "Ϥ줿ɥ쥹Ǥ";
	    $bErr =1;
        }
    } elsif(($record[$i] eq "PTR") || ($record[$i] eq "CNAME")
	    || ($record[$i] eq "NS")){

	if($value[$i] !~ /^(.+)\.$/){
		$checkname = join(".", $value[$i], $zname);
	}else{
		$checkname = $1;
	}

        if(&checkDomainName2($checkname) == 0){
	    $ErrMsg = "Ϥ줿ɥᥤ̾Ǥ";
	    $bErr = 1;
        }
    } elsif($record[$i] eq "MX"){

	if($value[$i] !~ /^(.+)\.$/){
		$checkname = join(".", $value[$i], $zname);
	}else{
		$checkname = $1;
	}

        if(&checkDomainName2($checkname) == 0){
	    $ErrMsg = "Ϥ줿ɥᥤ̾Ǥ";
	    $bErr = 1;
        }
        if($mx[$i] eq ""){
	    $ErrMsg = "ͥ٤ϤƤޤ";
	    $bErr = 1;
        }
        if(($mx[$i] =~ /[^0-9]/) || ($mx[$i] > 32767)){
	    $ErrMsg = "ꤹͥ٤032767ͤꤷƤ";
	    $bErr = 1;
        }
    }

    if($record[$i] ne "MX"){
        $mx[$i] = "";
    } else{
        $mx[$i] .= "\t";
    }

    if($bErr == 1){
	$i++;
	&showErrorPage("$iܤιܤ$ErrMsg", "addrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
# ͤޤ"
	exit(1);
    }

}

if($noitems == 10){
	&showErrorPage("ܤϤƤޤ","addrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
	exit(1);
}


open(ZONEFILE,"/var/named/$zfile");
while(<ZONEFILE>){
    $lines[$n++] = $_;
}
close(ZONEFILE);

# search SOA border line
$n = 0;
$bSOA = 0;
while($n < @lines){
    if($lines[$n] =~ /SOA/){
	$bSOA = 1;
    }
    if(($bSOA == 1) && ($lines[$n] =~ /\)/)){
	last;
    }
    $n++;
}
$n++;
$startsoa = $n;
while(($lines[$n] =~ "^\s*\n") || ($lines[$n] !~ /^\w+\s+.*IN/) && ($n < @lines)){
    $n++;
}
$finishsoa = $n;

# add records
for($n = 0; $n < 10; $n++){
    # add SOA record area
    if(($owner[$n] eq "") && ($value[$n] eq "")){
	next;
    }

    # check duplicate definition
    $bErr = 0;
    if($owner[$n] eq ""){
	for($x = $startsoa; $x < $finishsoa; $x++){
	    if($lines[$x] =~ /IN\s+(\S+)\s+(.*)$/){
		$rec2 = $1;
		$val2 = $2;
		if($rec2 eq "MX"){
		    ($val2) = $val2 =~ /^\d+\s+(.*)$/;
		}
		$val2 =~ s/\s//g;
		if(($record[$n] eq $rec2) && ($value[$n] eq $val2)){
		    $bErr = 1;
		}
	    }
	}
    } else{
	for($x = $finishsoa; $x < @lines; $x++){
	    if($lines[$x] =~ /^(.*)\s+IN\s+(\S+)\s+(.*)$/){
		$owns = $1;
		$rec2 = $2;
		$val2 = $3;
		# back track owner
		if($owns =~ /^\s/){
		    $xx = $x - 1;
		    while($xx >= $finishsoa){
			if($lines[$xx] =~ /^(.*)\s+IN\s+(\S+)\s+(.*)$/){
			    $owns = $1;
			    if($owns !~ /^\s/){
				last;
			    }
			}
			$xx--;
		    }
		}
		$owns =~ /^(\S+)\s/;
		$own2 = $1;

		if($rec2 eq "MX"){
		    ($val2) = $val2 =~ /^\d+\s+(.*)$/;
		}
		$val2 =~ s/\s//g;
		if(($own2 eq $owner[$n]) &&
		   ($record[$n] eq $rec2) && ($value[$n] eq $val2)){
		    $bErr = 1;
		}
	    }
	}
    }

    if($bErr == 1){
	$n++;
	&showErrorPage("$nܤϹܤϴ¸ߤޤ", "addrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
	exit(1);
    }


    if($owner[$n] eq ""){
	$insertptr = $finishsoa;
    } else{
	$insertptr = @lines;
    }
	
    # new entry
    if($found == 0){
	$newline = "$owner[$n]";
	$tabs = 2 - length($owner[$n]) / 8;
	for($l = 0; $l < $tabs; $l++){
	    $newline .= "\t";
	}
	$newline .= "\tIN\t$record[$n]\t$mx[$n]$value[$n]\n";
	splice(@lines, $insertptr, 0, $newline);
	if($owner[$n] eq ""){
	    $finishsoa++;
	}
    }
}


open(OUTFILE, ">/var/named/$zfile");
#open(OUTFILE, ">/tmp/testout");

for($n = 0; $n < @lines; $n++){
    print OUTFILE $lines[$n];
}
close(OUTFILE);

#system("/opt/nec/wbmc/adm/service/dns/named.cgi");

if (&checkPid("named")) {
    if ($err = restartService("named")) {
	&showErrorPage("$err", "named.cgi");
	exit(1);
    }
}

&showResultPage("","editzone.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
