#!/usr/bin/perl

#----------------------------------------------------------------------------
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.


#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "named.pl";
require "namedapi.pl";
#------------------------------------------------------------
if ($err = &readParam()) {
	$err = $STR_ERR_SYSTEM;
	&showErrorPage("$err", "");
	exit(1);
}

#($localhost) = system("/bin/hostname") =~ /([.*])0/;
#$localhost = $ENV{'HOSTNAME'};
chomp($localhost =`hostname`);

# generate serial number
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdat) = localtime;
$year += 1900;
$mon++;
if ($mday < 10)  { $mday = "0$mday";   }
if ($mon < 10)  { $mon = "0$mon";   }
$serialnum = $year . $mon . $mday . "00";

$zonefilename = $FORM{'zonefname'};
$domainname = $FORM{'domainname'};

if($FORM{'nameoraddress'} eq ""){
      &showErrorPage("ɥᥤ̾ͥåȥɥ쥹ꤷƤ", "addzone.cgi");
      exit(1);
}

# check valid file name
if($FORM{'editfname'} eq "on"){
    if($zonefilename eq ""){
	&showErrorPage("Zoneե̾ϤƤޤ", "addzone.cgi");
	exit(1);
    }
    if(checkNoPathFileName($zonefilename) == 0){
	&showErrorPage("Zoneե̾Ǥ̤̾ϤƤ", "addzone.cgi");
	exit(1);
    }
}

# check zone name already exist
open(NAMEDCONF, "/etc/named.conf");
while(<NAMEDCONF>){
    $namedconf .= $_;
}
close(NAMEDCONF);

# erase last period
if($domainname =~ /^(.*)\.$/){
    $domainname = $1;
}

#
if ($FORM{'nameoraddress'} eq "domain_name"){

      # check input empty
      if($domainname eq ""){
	  &showErrorPage("ɥᥤ̾ϤƤޤ", "addzone.cgi");
	  exit(1);
      }
      # check valid domain name
      if(&checkDomainName2($domainname) == 0){
	  &showErrorPage("ɥᥤ̾Ǥ", "addzone.cgi");
	  exit(1);
      }
      # check domainname has already exist
      if(($namedconf =~ /zone\s*\"\Q$domainname\E\"\s*{/i) ||
	  ($namedconf =~ /zone\s*\"\Q$domainname\E\.\"\s*{/i)){
	  &showErrorPage("Ϥ줿ɥᥤ̾ϴϿƤޤ", "addzone.cgi");
	  exit(1);
      }

      # check if there same domain name
      if($namedconf =~ /zone\s*\"\Q$domainname\E\"/){
	  &showErrorPage("'$domainname'ȤZoneϴϿƤޤ", "addzone.cgi");
	  exit(1);
      }

      if($FORM{'editfname'} ne "on"){
	  $zonefilename = "g.$domainname";
      }
      # check zone filename already exist
      if(-e "/var/named/$zonefilename"){
	  &showErrorPage("ꤵ줿Zoneե̾ϴ¸ߤޤ", "addzone.cgi");
	  exit(1);
      }

      $namedconf .=  "zone \"$domainname\" {\n";
      $namedconf .=  "	type master\;\n";
      $namedconf .=  "	file \"$zonefilename\"\;\n";
      $namedconf .=  "}\;\n\n";

      open(NAMEDCONF, ">/etc/named.conf");
      print(NAMEDCONF $namedconf);
      close(NAMEDCONF);
      
      $zonefile .= "@	IN	SOA	$localhost.	root.$localhost.	(\n";
      $zonefile .= "			$serialnum\n";
      $zonefile .= "			28800\n";
      $zonefile .= "			14400\n";
      $zonefile .= "			3600000\n";
      $zonefile .= "			86400 \n";
      $zonefile .= ")\n\n";

      open(ZONEFILE, ">/var/named/$zonefilename");
      print(ZONEFILE $zonefile);
      close(ZONEFILE);
}

#հ
if ($FORM{'nameoraddress'} eq "nw_address"){
      
      #Ϥ줿ɥ쥹Υå
      $bit = $FORM{'nwaddress'} =~ tr/\./\./;
      if($FORM{'nwaddress'} eq ""){
	  &showErrorPage("ͥåȥɥ쥹ϤƤޤ", "addzone.cgi");
	  exit(1);
      }
      if($bit != 3){
	  &showErrorPage("Ϥ줿ɥ쥹Ǥ", "addzone.cgi"); 
	  exit(1);
      }
      #ͥåȥޥΥå
      if ($FORM{'bit'} eq ""){
	  &showErrorPage("ӥåĹꤷƤ", "addzone.cgi"); 
	  exit(1);
      }
      $bErr = 0;
      @IPaddress = split(/\./,$FORM{'nwaddress'});

      if ($FORM{'bit'} eq "8bit"){
	  $loopmax = 1;
      } elsif ($FORM{'bit'} eq "16bit"){
	  $loopmax = 2;
      } elsif ($FORM{'bit'} eq "24bit"){
	  $loopmax = 3;
      } else{
	  $bErr = 1;
      }

      $addrtmp = "";
      for($x = 0; $x < $loopmax; $x++){
	  if(($IPaddress[$x] eq "") ||
	     ($IPaddress[$x] =~ /[^0-9]/) || ($IPaddress[$x] > 255)){
	      $bErr = 1;
	  }
	  if($x != 0){
	      $addrtmp .= ".";
	  }
	  $addrtmp .= "$IPaddress[$x]";
      }

      if($bErr == 1){
	  &showErrorPage("Ϥ줿ɥ쥹Ǥ", "addzone.cgi"); 
	  exit(1);
      }
      
      #ʸȿž
      $nwaddress .= &reverseAddr($addrtmp);

      # check if there same network address
      if($namedconf =~ /zone\s*\"\Q$nwaddress\E\.IN-ADDR\.ARPA\"/i){
	  &showErrorPage("Ϥ줿ͥåȥɥ쥹ϴϿƤޤ", "addzone.cgi");
	  exit(1);
      }
      
      if($FORM{'editfname'} ne "on"){
	  $zonefilename = "g.$nwaddress.IN-ADDR.ARPA";
      }
      # check zone filename already exist
      if(-e "/var/named/$zonefilename"){
	  &showErrorPage("ꤵ줿Zoneե̾ϴ¸ߤޤ", "addzone.cgi");
	  exit(1);
      }

      #
      $namedconf .=  "zone \"$nwaddress.IN-ADDR.ARPA\"{\n";
      $namedconf .=  "	type master\;\n";
      $namedconf .=  "	file \"$zonefilename\"\;\n";
      $namedconf .=  "}\;\n\n";

      open(NAMEDCONF, ">/etc/named.conf");
      print(NAMEDCONF $namedconf);
      close(NAMEDCONF);
      
      $zonefile .= "@	IN	SOA	$localhost.	root.$localhost.	(\n";
      $zonefile .= "			$serialnum\n";
      $zonefile .= "			28800\n";
      $zonefile .= "			14400\n";
      $zonefile .= "			3600000\n";
      $zonefile .= "			86400 \n";
      $zonefile .= ")\n\n";

      open(ZONEFILE, ">/var/named/$zonefilename");
      print(ZONEFILE $zonefile);
      close(ZONEFILE);
}


if (&checkPid("named")) {
    if ($err = restartService("named")) {
	&showErrorPage("$err", "named.cgi");
	exit(1);
    }
}

#system("/opt/nec/wbmc/adm/service/dns/named.cgi");
&showResultPage("","named.cgi");
