#!/usr/bin/perl

#----------------------------------------------------------------------------
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "named.pl";
require "namedapi.pl";
#------------------------------------------------------------

$infilename = "/etc/named.conf";

$InOptions = 0;
$level = 0;

open(INFILE, "$infilename");

while(<INFILE>)
{
    if($InOptions == 0){
  if(/^options\s*\{/){
      $InOptions = 1;
      $level = 1;
  }
  next;
    } else{
  # ignore 'directory' field
  if(/^\s*directory\s*\"/){
      next;
  }
  # get 'forward only;' field
  if(/^\s*forward\s+only/){
      $forwardonly = "CHECKED";
      next;
  }
  # get 'query-source string' field
  if(/^\s*query-source\s+address\s+\*\s+port\s+53\;/){
      $querysource = "CHECKED";
      next;
  }

        # ignore forwarders datas
  if(/^\s*forwarders\s*\{/){
      $forwarders = "CHECKED";
      if(/\{(.*)\}/){
    $forwarderlist = $1;
    next;
      }
      while(<INFILE>){
    if(/\}/){
        last;
          }
    $forwarderlist .= $_;
      }
      next;
  }
        $level += /\{/g;
        $level -= /\}/g;

  # search terminate string
  if((/^\}/) && ($level == 0)){
      $InOptions = 0;
      last;
  }
  # ignore other option datas
  $options .= $_;
    }
}

close(INFILE);

$forwarderlist =~ s/\n\s*/\n/g;
$forwarderlist =~ s/^\s*//;

$options =~ s/\n\s*/\n/g;
$options =~ s/^\s*//;


#------------------------------------------------------------
$navibar = &getNavigation(
                "$STR_SERVICE", "$SERVICECGI",
                "͡ॵ(named)", "named.cgi",
                "Option", "",
                "_back", "named.cgi",
                "_help", "option_help.html");
#------------------------------------------------------------

print <<END_OF_DATA
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>Option</TITLE>
</HEAD>

<BODY>

<CENTER>
<H4 ALIGN="center">Option</H4>
</CENTER>
<HR>
$navibar
<HR>

<BR>
<CENTER>
<TABLE>
 <TR>
  <TD>
   <TABLE BORDER=1 BGCOLOR="#CCCCCC" CELLSPACING=0 CELLPADDING=1 WIDTH=100%>
    <TR BGCOLOR="#000080">
     <TD><FONT COLOR="#FFFFFF"> <B>Option</B></FONT></TD>
    </TR>
    <TR>
     <TD>
      <TABLE WIDTH=100% BORDER=0 CELLSPACING=0 CELLPADDING=1>
  <FORM NAME="setform" ACTION="optionset.cgi" METHOD="POST">
  <TR>
  <TD>
    <DD>forwarders</DD>
  </TD>
  </TR>
  <TR>
  <TD>
  <DD>
      <TEXTAREA NAME="forwardip" COLS=45 ROWS=5>$forwarderlist</TEXTAREA>
  </DD>
  </TD>
  </TR>
  <TR>
        <TD>
    <DT>
      <INPUT TYPE="checkbox" NAME="only" VALUE="on" $forwardonly>forward only
    </DT>
        </TD>
  </TR>
  <TR>
        <TD>
    <DT>
      <INPUT TYPE="checkbox" NAME="query" VALUE="on" $querysource>query-source address * port 53
    </DT>
        </TD>
  </TR>
        <TR>
        <TD>
    <DD>
      ¾Option
    </DD>
        </TD>
        </TR>
        <TR>
        <TD>
        <DD>
      <TEXTAREA NAME="option" COLS=45 ROWS=7>$options</TEXTAREA>
        </DD>
        </TD>
        </TR>
    <TR>
     <TD>
        <Center>
      <INPUT TYPE="submit" VALUE="">
        </Center>
     </TD>
    </TR>
  </FORM>
      </TABLE>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>
</CENTER>
<BR>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------

