#!/usr/bin/perl
# Copyright (C) 2002 NEC Corporation
# All Rights Reserved.

#021008 v5.0 
##040303 v5.1.1 ɥ쥹Ģ(ldap)ǡ500ʾɽǤ褦б ishiyama

sub sanitize {
	my $input = $_[0];
	$input =~ s/&/&amp;/g;         # &  &amp;
	$input =~ s/</&lt;/g;          # <  &lt;
	$input =~ s/>/&gt;/g;          # >  &gt;
	$input =~ s/"/&quot;/g;        # "  &quot;
	$input =~ s/'/&#39;/g;         # '  &#39;
	return $input;
}

require "../../../lib/wbmc.pl";
require "./ldap.pl";
use Jcode;
use MIME::Base64;

$suffix = "";
$rootpw = "";
$rootdn = "";

$navibar = &getNavigation(
"ӥ", "../menu.cgi",
"ɥ쥹Ģ(ldap)", "",
"_back", "../menu.cgi",
"_help", "index_help.html");

$slapd_found = 0;

open(PS,"/bin/ps ax |");
while(<PS>){
	$_ =~ /^\s*[0-9]+\s+[\w\/\?]+\s+\w+\s+[0-9\:]+\s+(.*)/ ;
	if ( $1 =~ /\/usr\/sbin\/slapd/ ){
		$slapd_found = 1;
		last;
	}
}
close(PS);
if($slapd_found eq 0){
	&showErrorPage("ldapӥưƤޤ");
	exit;
}

$suffix = &get_conf("suffix");
#$rootdn = &get_conf("rootdn");
#$rootpw = &get_conf("rootpw");
$rootdn = &get_conf("rootdn");	# 2004/03/03 add by ishiyama
$rootpw = &get_conf("rootpw");  # 2004/03/03 add by ishiyama


# Τ ldapsearch ơϿѤߤοͤ $table ˤ֤Ǥ
# ldapsearch Ƥ cn ꤷƤcnФ
# ldapsearch -LLL -x -b $rootdn '(&(objectclass=person)(cn=$name))' @item Ԥ
%record = ();
#open(PERSON,"$ldapsearch -LLL -x -b \"$suffix\" \"(objectclass=person)\" @item |");	# 2004/03/03 del by ishiyama
open(PERSON,"$ldapsearch -LLL -x -D \"$rootdn\" -w \"$rootpw\" -b \"$suffix\" \"(objectclass=person)\" @item |");	# 2004/03/03 add by ishiyama
while (<PERSON>){
	if ($_ =~ /^\s*$/){
		$target_name = $record{'dn'};
		$target_name =~ /.*cn=([0-9]+)/;
		$id = $1;
		$table .= "<TR> \n"
			. "<TH><INPUT TYPE=\"button\" VALUE=\"Խ\" onClick=\"location.href='modify.cgi?$id'\">"
			. "<INPUT TYPE=\"button\" VALUE=\"\" onClick='del(\"$target_name\")'></TH>";
		foreach $i (@print_item){
			$show_item = $record{$i};
			$show_item = &sanitize($show_item);
			$show_item =~ s/ /&nbsp;/g;
			$table .= "<td>".$show_item."</td>";
		}
		$table .= "\n";
		%record = ();
		next;
	}
	foreach $i (@item){
		if ($_ =~ /^$i:\s+(.*)/){
			$record{$i} = $1;
		}
		elsif ($_ =~ /^$i\:\:\s+(.*)/){
			$record{$i} = MIME::Base64::decode_base64($1);
			$record{$i} = jcode($record{$i},'utf8')->euc;
		}
	}
}
close(PERSON);

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>ɥ쥹Ģ(ldap)</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function del(id) {
  if (window.confirm("ƤǤ")) {
    document.DEL.ID.value = id;
    document.DEL.submit();
  }
}
// -->
</SCRIPT>
</HEAD>
<BODY>
<H4 ALIGN="center">ɥ쥹Ģ(ldap)</H4>
<HR>
$navibar
<HR>
<CENTER>
<TABLE BORDER=0>
 <TR>
  <TD>
   <FORM>
   <TABLE BORDER=1 BGCOLOR="#CCCCCC" CELLSPACING=0 CELLPADDING=1 WIDTH="100%">
    <TR BGCOLOR="#000080">
     <TD><FONT COLOR="#FFFFFF"><B>ɥ쥹Ģ</B></FONT></TD>
    </TR>
    <TR> 
     <TD>
      <TABLE BORDER=1 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
       <TR>
        <TH></TH>
        <TH>̾</TH>
        <TH>᡼륢ɥ쥹</TH>
        <TH>̾</TH>
        <TH>ȿ̾</TH>
        <TH></TH>
        <TH>ֹ</TH>
       </TR>
       <TR>
        <TH><INPUT TYPE="button" VALUE="ɲ" onClick=\"location.href='add.cgi'"
></TH>
        <TD><BR></TD>
        <TD><BR></TD>
        <TD><BR></TD>
        <TD><BR></TD>
        <TD><BR></TD>
        <TD><BR></TD>
       </TR>
        $table
      </TABLE>
     </TD>
    </TR>
   </TABLE>
  </FORM>
  </TD>
 </TR>
</TABLE>
</FORM>
<FORM METHOD="POST" ACTION="delete.cgi" NAME="DEL">
 <INPUT TYPE="hidden" NAME="ID">
</FORM>
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------

