#!/usr/bin/perl
# Copyright (C) 2002-2003 NEC Corporation
# All Rights Reserved.

#021008 v5.0 
##20030328 v5.1.0 ʸĹåɲ oyama
##040303 v5.1.1 ɥ쥹Ģ(ldap)ǡ500ʾɽǤ褦б ishiyama

use MIME::Base64;
use Jcode;

# եե̾
my $SLAPD_CONF = "/etc/openldap/slapd.conf";

# ldap ޥ
$ldapsearch = "/usr/bin/ldapsearch";
$ldapdelete = "/usr/bin/ldapdelete";
$ldapadd = "/usr/bin/ldapadd";
$ldapmodify = "/usr/bin/ldapmodify";

# ɽ&ǰóݤ
@print_item = qw(cn mail o ou title telephoneNumber);
@item = qw(dn cn mail o ou title telephoneNumber);
# item̾ȡɽ̾б
%name_table = qw(cn ̾ mail ᡼륢ɥ쥹 o ̾ ou ȿ̾ title  telephoneNumber ֹ);

# ldap  dn Ϳ桼ȤθͭID֤ޤǻѺѤߤǼ
# 桼ɲä뤿Ӥ ID ͤ1ɲä롣
# 桼Ȥ ID 򸺤餷Ϥʤ
$ldap_uid_conf = "/etc/opt/nec/wbmc/ldap.conf";

# ͿID
sub get_next_ldapid
{
	my $id;
	if ( ! -e $ldap_uid_conf ) {
		if (system("/bin/echo 0 > $ldap_uid_conf")) {
			&showErrorPage("$ldap_uid_conf κ˼Ԥޤ");
			exit;
		}
	}
	if (! open(LDAP_UID_CONF, $ldap_uid_conf)) {
		&showErrorPage("$ldap_uid_conf Υץ˼Ԥޤ");
		exit;
	}
	$id = <LDAP_UID_CONF>;
	close(LDAP_UID_CONF);
	if ($id =~ /[0-9]+$/){
		$id = $id+1;
	}
	else {
		&showErrorPage("$ldap_uid_conf ե뤬Ǥ");
		exit;
	}
	return $id;
}

# եɤ߹
sub get_conf
{
	my $value = $_[0];
	my $ret_value = "";

	( -e $SLAPD_CONF ) || &showErrorPage("$SLAPD_CONF Ĥޤ");
	open (SLAPD_CONF, $SLAPD_CONF) || &showErrorPage("$SLAPD_CONF Υץ˼Ԥޤ");
	while(<SLAPD_CONF>) {
		if ($_ =~ /^\s*$value\s*\"(.*)\"/) {
			$ret_value = $1;
			last;
		}
	}
	if ( $ret_value eq "" ) {
		&showErrorPage("$SLAPD_CONF ˰۾郎ޤ$value ĤޤǤ");
	}
	close(SLAPD_CONF);
	return $ret_value;
}

# ǻꤷidĿͤϿѤߤå
# ¸ߤȤ   : 1
# ¸ߤʤȤ : 0
sub check_id_exist
{
	my $id = $_[0];
	my $ret_val = 0;

	my $suffix = &get_conf("suffix");
	my $rootdn = &get_conf("rootdn");	# 2004/03/03 add by ishiyama
	my $rootpw = &get_conf("rootpw");	# 2004/03/03 add by ishiyama

	#open(NAME,"$ldapsearch -LLL -x -b \"$suffix\" \"(objectclass=person)\" cn|");	# 2004/03/03 del by ishiyama
	open(NAME,"$ldapsearch -LLL -x -D \"$rootdn\" -w \"$rootpw\" -b \"$suffix\" \"(objectclass=person)\" cn|");	# 2004/03/03 add by ishiyama
	while(<NAME>){
		if ($_ =~ /$id\$/){
			$ret_val = 1;
			last;
		}
	}
	close(NAME);
	return $ret_val;
}

# ǻꤷIDλľ %record ˳Ǽ֤
sub get_record()
{
	my $ldap_uid = $_[0];
	my %record = ();
	my $suffix = &get_conf("suffix");
	my $line = "";
	my $get_id = "";

	#open(PERSON,"$ldapsearch -LLL -x -b \"$suffix\" \"(objectclass=person)\" @item|");	# 2004/03/03 del by ishiyama
	open(PERSON,"$ldapsearch -LLL -x -D \"$rootdn\" -w \"$rootpw\" -b \"$suffix\" \"(objectclass=person)\" @item|");	# 2004/03/03 add by ishiyama
	while (<PERSON>){
		$line = $_;
		if ($line =~ /dn\:\:\s+(.*)/){
			$get_id = MIME::Base64::decode_base64($1);
		}
		elsif ($line =~ /dn:\s+(.*)/) {
			$get_id = $1;
		}
		if ( $get_id eq $ldap_uid ){
			$record{'dn'} = $get_id;
			last;
		}
	}
	while(<PERSON>){
		if ($_ =~ /^\s*$/){
			last;
		}
		foreach $i (@item){
			if ($_ =~ /^$i:\s+(.*)/){
				$record{$i} = $1;
			}
			elsif ($_ =~ /^$i\:\:\s+(.*)/){
				$record{$i} = MIME::Base64::decode_base64($1);
				$record{$i} = jcode($record{$i},'utf8')->euc;
			}
		}
	}
	close(PERSON);
	return(%record);
}

#20030328 ɲ
# ɲ,ѹԤƥƤåؿ
# ꤬äˤϡ֤ͤ˥顼Ƥޤޤ
# ʸĹäˤϡ顼ʬ˳̤ǤʸĹ
#  : ɲáѹԤƥΥϥå
sub check_ldap_item
{
	my %record = @_;
	my $i,$check_string,$len;
	my $ret = "";

	foreach $i (@item){
		$check_string = $record{$i};
		# utf8 -> euc Ѵκݤʸ󤬰ۤʤäƤʸ
		if ($check_string ne jcode($check_string,'utf8')->euc) {
			$check_string = MIME::Base64::encode_base64($check_string);
			$check_string .= "$i\:\: ";
		} else {
			$check_string .= "$i: ";
		}
		$len = length($check_string);
		if ($len > 74 ) {
			$ret .= "$name_table{$i} ʸ¿ޤ($len)\n";
		}
	}
	if ($record{"cn"} eq ""){
		$ret .= $name_table{"cn"}."ϤƤޤ\n";
	}
	if ($record{"mail"} eq ""){
		$ret .= $name_table{"mail"}."ϤƤޤ\n";
	}
	if ($record{"mail"} ne "" && $record{"mail"} =~ /[^\w\.\-@]/ ) {
		$ret .= $name_table{"mail"}."ηޤ\n";
	}
	if ($record{"telephoneNumber"}  ne "" && $record{"telephoneNumber"} =~ /[^0-9\-]/){
		$ret .= $name_table{"telephoneNumber"}."ηޤ\n";
	}
	return($ret);
}
