#!/usr/bin/perl
# Copyright (C) 2002-2003 NEC Corporation
# All Rights Reserved.

## 2002 021014 v5.0 
## 20030328 v5.1.0 ϲǽʸ oyama

use Jcode;

require "../../../lib/wbmc.pl";
require "./ldap.pl";

#եɤ߹
$suffix = &get_conf("suffix");
$rootdn = &get_conf("rootdn");
$rootpw = &get_conf("rootpw");

my $ldap_ldif = "/opt/nec/tmp/ldap.ldif";
my $ldif = "";

$id = $ARGV[0];
$ldap_uid = "cn=$id,$suffix";

&readParam();

#եफ
$cn = jcode($FORM{'NAME'})->utf8;
$mail = ($FORM{'MAIL'});
$o = jcode($FORM{'COMPANY'})->utf8;
$ou = jcode($FORM{'OU'})->utf8;
$title = jcode($FORM{'TITLE'})->utf8;
$telephoneNumber = $FORM{'TELEPHONE'};

#ϥå˳Ǽ
@modify_record{@item} = ($ldap_uid,$cn,$mail,$o,$ou,$title,$telephoneNumber);

#νоIDξ
%record = &get_record($ldap_uid);
foreach $i (@item){
	$record{$i} = jcode($record{$i},'euc')->utf8;
}

#ͤΥå
$ret = &check_ldap_item(%modify_record);
if ( $ret ne "" ) {
	$ret =~ s/\n/\<br\>/g;
	&showErrorPage($ret);
	exit;
}

#Ͽ ldif ե
if (! open(OUT,"> $ldap_ldif")) {
	&showErrorPage("ѥեκ˼Ԥޤ");
	exit;
}

# ldapmodify ˿碌 ldif ե
#$ldif = "dn: cn=$id,$suffix\n";
$ldif = "";

foreach $i (@item) {
	if ($record{$i} ne $modify_record{$i}){
		if ( $modify_record{$i} eq "" ){
			$ldif .= "dn: cn=$id,$suffix\n"
				."delete: $i\n\n";
		}
		elsif ( $record{$i} eq ""){
			$ldif .= "dn: cn=$id,$suffix\n"
				."add: $i\n"
				."$i: $modify_record{$i}\n\n";
		}
		else{
			$ldif .= "dn: cn=$id,$suffix\n"
				."replace: $i\n"
				."$i: $modify_record{$i}\n\n";
		}
	}
}

print OUT "$ldif";
close(OUT);

system("$ldapmodify -x -D \"$rootdn\" -w \"$rootpw\" -f $ldap_ldif >/dev/null 2>&1");
unlink($ldap_ldif);

&showPage("./index.cgi");
#------------------------------------------------------
