#!/usr/bin/perl

# Copyright (C) 2003 NEC Corporation
# All Rights Reserved.

# RCS: $Id: chksvc.pl,v 1.2 2003/03/20 07:33:06 snavi Exp $


#require "../../lib/wbmc.pl";


$conf_file = "/etc/opt/nec/wbmc/mon_svc.conf";
$conf_lock = "mon_svc.conf";

$def_file = "/etc/opt/nec/wbmc/mon_svc.def";
$def_lock = "mon_svc.def";


#
# Function
#   ӥƻե뤫
# Parameters
#   $call     ƤӽФ(0:GUI, 1:¾)
# Return
#   ӥƻ
#   ԡʤ
#

sub get_definition
{
    my($call) = @_;

    my(@definition);
    my($chk_str1) = "Default Services";
    my($chk_str2) = "Selected Services";

    if (!&readFile($def_file, $def_lock, *lines)) {
        if ($call == 0) {
            &showErrorPage("$def_fileɤ߹ߤ˼Ԥޤ");
            exit(1);
        } else {
            print "$def_fileɤ߹ߤ˼Ԥޤ\n";
            exit(1);
        }
    }

    # ӥƻ
    foreach (@lines) {
        next if ($_ =~ /^\s*$/);
        if ($_ =~ /^\s*#\s*$chk_str1$/) {
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str2$/) {
            next;
        }

        s/^\s*//;
        s/\s*$//;
        push (@definition, $_);
    }

    return(@definition);
}


#
# Function
#   ӥƻե뤫饵ӥ(ǥե)
# Parameters
#   $call     ƤӽФ(0:GUI, 1:¾)
# Return
#   ƻоݥӥ(ǥե)
#   ԡʤ
#

sub get_svc_def
{
    my($call) = @_;

    my(@svc_def);
    my($flag) = 0;
    my($chk_str1) = "Default Services";
    my($chk_str2) = "Monitor Services";

    if (!&readFile($conf_file, $conf_lock, *lines)) {
        if ($call == 0) {
            &showErrorPage("$conf_fileɤ߹ߤ˼Ԥޤ");
            exit(1);
        } else {
            print "$conf_fileɤ߹ߤ˼Ԥޤ\n";
            exit(1);
        }
    }

    # ƻоݥӥ(ǥե)
    foreach (@lines) {
        next if ($_ =~ /^\s*$/);
        if ($_ =~ /^\s*#\s*$chk_str1$/) {
            $flag = 1;
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str2$/) {
            $flag = 0;
            last;
        }

        if ($flag == 1) {
            s/^\s*//;
            s/\s*$//;
            push (@svc_def, $_);
            next;
        }
    }

    return(@svc_def);
}


#
# Function
#   ӥƻե뤫饵ӥ()
# Parameters
#   $call     ƤӽФ(0:GUI, 1:¾)
# Return
#   ƻоݥӥ()
#   ԡʤ
#

sub get_svc_info
{
    my($call) = @_;

    my(@svc_info);
    my($flag) = 0;
    my($chk_str1) = "Monitor Services";
    my($chk_str2) = "Monitor Interval";

    if (!&readFile($conf_file, $conf_lock, *lines)) {
        if ($call == 0) {
            &showErrorPage("$conf_fileɤ߹ߤ˼Ԥޤ");
            exit(1);
        } else {
            print "$conf_fileɤ߹ߤ˼Ԥޤ\n";
            exit(1);
        }
    }

    # ƻоݥӥ()
    foreach (@lines) {
        next if ($_ =~ /^\s*$/);
        if ($_ =~ /^\s*#\s*$chk_str1$/) {
            $flag = 1;
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str2$/) {
            $flag = 0;
            last;
        }

        if ($flag == 1) {
            s/^\s*//;
            s/\s*$//;
            push (@svc_info, $_);
            next;
        }
    }

    return(@svc_info);
}


#
# Function
#   ӥƻֳ֡᡼
# Parameters
#   $call     ƤӽФ(0:GUI, 1:¾)
# Return
#   ӥƻֳ֡᡼̵ͭ
#   ԡʤ
#

sub get_interval_chkmail
{
    my($call) = @_;

    my(@svc_info);
    my($interval, $chkmail);
    my($flag) = 0;
    my($chk_str1) = "Monitor Interval";
    my($chk_str2) = "Check Mail";

    if (!&readFile($conf_file, $conf_lock, *lines)) {
        if ($call == 0) {
            &showErrorPage("$conf_fileɤ߹ߤ˼Ԥޤ");
            exit(1);
        } else {
            print "$conf_fileɤ߹ߤ˼Ԥޤ\n";
            exit(1);
        }
    }

    # ӥƻֳ֡᡼
    foreach (@lines) {
        next if ($_ =~ /^\s*$/);
        if ($_ =~ /^\s*#\s*$chk_str1$/) {
            $flag = 1;
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str2$/) {
            $flag = 2;
            next;
        }

        if ($flag == 1) {
            s/^\s*//;
            s/\s*$//;
            $interval = $_;
            $flag = 0;
            next;
        }
        if ($flag == 2) {
            s/^\s*//;
            s/\s*$//;
            $chkmail = $_;
            $flag = 0;
            last;
        }
    }

    return($interval, $chkmail);
}


#
# Function
#   ӥƻֳ֡᡼󹹿
# Parameters
#   $interval            ӥƻֳ
#   $check_mail          ᡼̵ͭ(ͭ:1, ̵:0)
# Return
#       ʤ
#       ʤ
#

sub mod_interval_chkmail
{
    my($interval, $check_mail) = @_;

    my(@conf_tmp);
    my($dir);
    my($flag) = 0;
    my($chk_str1) = "Monitor Interval";
    my($chk_str2) = "Check Mail";

    if (!&readFile($conf_file, $conf_lock, *lines)) {
        &showErrorPage("$conf_fileɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    # ӥƻե빹
    foreach (@lines) {
        if ($_ =~ /^\s*#\s*$chk_str1$/) {
            $flag = 1;
            push (@conf_tmp, $_);
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str2$/) {
            $flag = 2;
            push (@conf_tmp, $_);
            next;
        }

        if ($flag == 1) {
            push (@conf_tmp, "$interval\n");
            $flag = 0;
            next;
        }
        if ($flag == 2) {
            push (@conf_tmp, "$check_mail\n");
            $flag = 0;
            next;
        }
        push (@conf_tmp, $_);
    }

    if (!&writeFile($conf_file, $conf_lock, @conf_tmp)) {
        &showErrorPage("$conf_fileν񤭹ߤ˼Ԥޤ");
        exit(1);
    }
}


#
# Function
#   ӥƻ߽
# Parameters
#   ʤ
# Return
#       ʤ
#       ʤ
#

sub chksvc_down
{
    # ӥƻե빹()
    &del_svc_conf();

    # ե빹()
    &del_cron();
    system ("/etc/rc.d/init.d/crond restart &> /dev/null");
}


#
# Function
#   ե빹 
# Parameters
#   $call     ƤӽФ(0:GUI, 1:¾)
# Return
#       ʤ
#       ʤ
#

sub mod_cron
{
    my($call) = @_;

    my(@cron_tmp);
    my($interval, $chkmail);
    my($flag, $cflag) = 0;
    my($cron_conf) = "/etc/crontab";
    my($cron_lock) = "crontab";
    my($chk_str) = "Monitor Interval";
    my($chk_str1) = "chksvc configuration begin";
    my($chk_str2) = "chksvc configuration end";
    my($cron_sh2) = "0 7 * * * root /opt/nec/wbmc/bin/chkcron";

    if (!&readFile($conf_file, $conf_lock, *lines)) {
        &showErrorPage("$conf_fileɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    if (!&readFile($cron_conf, $cron_lock, *lines2)) {
        &showErrorPage("$cron_confɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    # ӥƻֳ֡᡼̵ͭ
    ($interval, $chkmail) = &get_interval_chkmail($call);

    if ($interval < 60) {
        $cron_sh = "0-59/$interval * * * * root /opt/nec/wbmc/bin/chksvc";
    } elsif ($interval >= 60 and $interval < 1440) {
        $hour = int $interval / 60;
#        $min  = $interval % 60;
        $cron_sh = "0 0-23/$hour * * * root /opt/nec/wbmc/bin/chksvc";
    } elsif ($interval == 1440) {
        $cron_sh = "0 7 * * * root /opt/nec/wbmc/bin/chksvc";
    } else {
        &showErrorPage("ӥƻֳ֤Ǥ");
        exit(1);
    }

    # /å
    foreach (@lines2) {
        $cflag = 1 if ($_ =~ /^\s*#\s*$chk_str1$/);
        push (@cron_tmp, $_);
    }

    # ե빹
    if ($cflag == 0) {     # ɲ
        push (@cron_tmp, "\n");
        push (@cron_tmp, "# $chk_str1\n");
        push (@cron_tmp, "$cron_sh\n");
        if ($chkmail == 0) {
            push (@cron_tmp, "$cron_sh2\n");
        }
        push (@cron_tmp, "# $chk_str2\n");
    } elsif ($cflag == 1) {     # 
        @cron_tmp = "";
        foreach (@lines2) {
            if ($_ =~ /^\s*#\s*$chk_str1$/) {
                $flag = 1;
                push (@cron_tmp, $_);
                next;
            }
            if ($_ =~ /^\s*#\s*$chk_str2$/) {
                $flag = 0;
                push (@cron_tmp, "$cron_sh\n");
                if ($chkmail == 0) {
                    push (@cron_tmp, "$cron_sh2\n");
                }
                push (@cron_tmp, $_);
                next;
            }
            if ($flag == 1) {
                next;
            }
            push (@cron_tmp, $_);
        }
    } else {
        &showErrorPage("$cron_confξ˼Ԥޤ");
        exit(1);
    }

    if (!&writeFile($cron_conf, $cron_lock, @cron_tmp)) {
        &showErrorPage("$cron_confν񤭹ߤ˼Ԥޤ");
        exit(1);
    }
}


#
# Function
#   ե빹() 
# Parameters
#   ʤ
# Return
#       ʤ
#       ʤ
#

sub del_cron
{
    my(@cron_tmp);
    my($flag) = 0;
    my($cron_conf) = "/etc/crontab";
    my($cron_lock) = "crontab";
    my($chk_str1) = "chksvc configuration begin";
    my($chk_str2) = "chksvc configuration end";

    if (!&readFile($cron_conf, $cron_lock, *lines)) {
        &showErrorPage("$cron_confɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    # ե빹()
    foreach (@lines) {
        if ($_ =~ /^\s*#\s*$chk_str1$/) {
            $flag = 1;
            push (@cron_tmp, $_);
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str2$/) {
            $flag = 0;
            push (@cron_tmp, $_);
            next;
        }
        if ($flag == 1) {
            next;
        }
        push (@cron_tmp, $_);
    }

    if (!&writeFile($cron_conf, $cron_lock, @cron_tmp)) {
        &showErrorPage("$cron_confν񤭹ߤ˼Ԥޤ");
        exit(1);
    }
}

#
# Function
#   ӥƻե빹
# Parameters
#   @dirs_set             ƻоݥӥ
# Return
#       ʤ
#       ʤ
#

sub mod_svc_conf
{
    my(@dirs_set) = @_;

    my(@conf_tmp);
    my($dir);
    my($flag) = 0;
    my($chk_str1) = "Monitor Services";
    my($chk_str2) = "Monitor Interval";

    if (!&readFile($conf_file, $conf_lock, *lines)) {
        &showErrorPage("$conf_fileɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    # ӥƻե빹
    foreach (@lines) {
        if ($_ =~ /^\s*#\s*$chk_str1$/) {
            $flag = 1;
            push (@conf_tmp, $_);
            next;
        }
        if ($flag == 1 and $_ =~ /^\s*$/) {
            foreach $dir (@dirs_set) {
                push (@conf_tmp, "$dir\n");
            }
            push (@conf_tmp, "\n");
            $flag = 2;
            next;
        }
        if ($flag == 1) {
            foreach $dir (@dirs_set) {
                push (@conf_tmp, "$dir\n");
            }
            $flag = 2;
            next;
        }
        if ($_ =~ /^\s*$/) {
            push (@conf_tmp, $_);
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str2$/) {
            $flag = 0;
            push (@conf_tmp, $_);
            next;
        }
        if ($flag == 2) {
            next;
        }
        push (@conf_tmp, $_);
    }

    if (!&writeFile($conf_file, $conf_lock, @conf_tmp)) {
        &showErrorPage("$conf_fileν񤭹ߤ˼Ԥޤ");
        exit(1);
    }
}

#
# Function
#   ӥƻե빹()
# Parameters
#   ʤ
# Return
#       ʤ
#       ʤ
#

sub del_svc_conf
{
    my(@conf_tmp);
    my($flag) = 0;
    my($chk_str1) = "Monitor Services";
    my($chk_str2) = "Monitor Interval";

    if (!&readFile($conf_file, $conf_lock, *lines)) {
        &showErrorPage("$conf_fileɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    foreach (@lines) {
        if ($_ =~ /^\s*$/) {
            push (@conf_tmp, $_);
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str1$/) {
            $flag = 1;
            push (@conf_tmp, $_);
            next;
        }
        if ($_ =~ /^\s*#\s*$chk_str2$/) {
            $flag = 0;
            push (@conf_tmp, $_);
            next;
        }

        if ($flag == 1) {
            next;
        }
        push (@conf_tmp, $_);
    }

    if (!&writeFile($conf_file, $conf_lock, @conf_tmp)) {
        &showErrorPage("$conf_fileν񤭹ߤ˼Ԥޤ");
        exit(1);
    }
}


#
# Function
#   wbmc.confեΥޥ(CGI¹Եɲ)
# Parameters
#   $cgi_dir               CGIǥ쥯ȥ
#   $domainname            ɥᥤ̾
# Return
#       ""
#       顼å
#

sub cgi_on
{
    my($cgi_dir, $domainname) = @_;

    my($ret, $org) = "";
    my(@tmp) = "";
    my($flag) = 0;
    my($conf_file) = "/etc/httpd/conf/wbmc.conf";
    my($lock_file) = "wbmc.conf";

    my($line01) = "\t<Directory \"$cgi_dir\">\n";
    my($line02) = "\t\tOptions +ExecCGI -Includes -Indexes -FollowSymLinks -MultiViews\n";
    my($line03) = "\t\tAllowOverride None\n";
    my($line04) = "\t<\/Directory>\n";

    if (!&readFile($conf_file, $lock_file, *lines)) {
        $ret = "$conf_fileեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^ServerName\s+$domainname$/) {
            $flag = 1;
            push (@tmp, $org);
            next;
        }
        if (/^<Directory\s+\"$cgi_dir\">$/ and $flag == 1) {
            $flag = 2;
            push (@tmp, $org);
            next;
        }
        if (/^Options\s+/ and $flag == 2) {
            $_ = $org;
            s/-ExecCGI/+ExecCGI/g;
            push (@tmp, $_);
            $flag = 0;
            next;
        }
        if (/^<\/Directory>$/ and $flag == 2) {
            $flag = 0;
            push (@tmp, $org);
            next;
        }
        if (/^<\/VirtualHost>$/ and $flag == 1) {
            push (@tmp, $line01);
            push (@tmp, $line02);
            push (@tmp, $line03);
            push (@tmp, $line04);
            push (@tmp, $org);
            $flag = 0;
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($conf_file, $lock_file, @tmp)) {
        $ret = "$conf_fileեν񤭹ߤ˼Ԥޤ";
        goto done;
    }

    system ("/etc/rc.d/init.d/httpd restart &> /dev/null");

done:

    return($ret);

}

#
# Function
#   wbmc.confեΥޥ(CGI¹Եĺ)
# Parameters
#   $cgi_dir               CGIǥ쥯ȥ
#   $domainname            ɥᥤ̾
# Return
#       ""
#       顼å
#

sub cgi_off
{
    my($cgi_dir, $domainname) = @_;

    my($ret, $org) = "";
    my(@tmp) = "";
    my($flag) = 0;
    my($conf_file) = "/etc/httpd/conf/wbmc.conf";
    my($lock_file) = "wbmc.conf";

    if (!&readFile($conf_file, $lock_file, *lines)) {
        $ret = "$conf_fileեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^<Directory\s+\"$cgi_dir\">$/) {
            $flag = 1;
            push (@tmp, $org);
            next;
        }
        if (/^Options\s+/ and $flag == 1) {
            $_ = $org;
            s/\+ExecCGI/-ExecCGI/g;
            push (@tmp, $_);
            $flag = 0;
            next;
        }
        if (/^<\/Directory>$/) {
            $flag = 0;
            push (@tmp, $org);
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($conf_file, $lock_file, @tmp)) {
        $ret = "$conf_fileեν񤭹ߤ˼Ԥޤ";
        goto done;
    }

    system ("/etc/rc.d/init.d/httpd restart &> /dev/null");

done:

    return($ret);

}

#
# Function
#   HTMLμư
# Parameters
#   $fml_dir                  ᡼󥰥ꥹȥǥ쥯ȥ
#   $domainname               ɥᥤ̾
#   $listname                 ᡼󥰥ꥹ̾
#   $def                      Indexڡɽեå(on/off)
#   $update_select            
#   $arg1                     (1)
#   $arg2                     (2)
#   $mhonarc_cmd              mhonarcޥ
#   $mrc_file                 MRCե
#   $html_dir                 HTMLեǼǥ쥯ȥ
#   $spool_dir                סǥ쥯ȥ
#   $mknmz_cmd                mknmzޥ
#   $mknmzrc_file             mknmzrcե
#   $index_dir                Namazuǥåǥ쥯ȥ
# Return
#       ""
#       顼å
#

sub autorun_html
{
    my($fml_dir, $domainname, $listname, $def, $update_select, $arg1, $arg2, $mhonarc_cmd, $mrc_file, $html_dir, $spool_dir, $mknmz_cmd, $mknmzrc_file, $index_dir) = @_;

    my($ret);
    my($flag) = 0;
    my(@tmp) = "";
    my($bin_lock) = "$domainname" . "_" . "$listname";
    my($bin_file) = "/opt/nec/wbmc/bin/$bin_lock";
    my($crontab_lock) = "crontab";
    my($crontab_file) = "/etc/$crontab_lock";
    my($crond_scpt) = "/etc/rc.d/init.d/crond";

    # ư¹ԥץȺ
    if (($ret = &make_autorun($fml_dir, $domainname, $listname, $def, $mhonarc_cmd, $mrc_file, $html_dir, $spool_dir, $mknmz_cmd, $mknmzrc_file, $index_dir, $bin_lock, $bin_file)) ne "") {
        goto done;
    }

    # /etc/crontab
    if (!&readFile($crontab_file, $crontab_lock, *lines)) {
        $ret = "$crontab_fileեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    if ($update_select eq "HOUR_ON") {
        $schedule = "0 0-23/$arg1 * * * root $bin_file &> /dev/null\n";
    } elsif ($update_select eq "DAILY_ON") {
        $schedule = "$arg2 $arg1 * * * root $bin_file &> /dev/null\n";
    } elsif ($update_select eq "WEEKLY_ON") {
        $schedule = "0 $arg2 * * $arg1 root $bin_file &> /dev/null\n";
    } 

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^#\s*$domainname\/$listname\s+HTML\s+update$/) {
            $flag = 1;
            push (@tmp, $org);
            next;
        }
        if ($flag == 1) {
            $flag = 2;
            push (@tmp, $schedule);
            next;
        }
        push (@tmp, $org);
    }
    if ($flag == 0) {
        push (@tmp, "# $domainname/$listname HTML update\n");
        push (@tmp, $schedule);
    }
            
    if (!&writeFile($crontab_file, $crontab_lock, @tmp)) {
        $ret = "$crontab_fileեν񤭹ߤ˼Ԥޤ";
        goto done;
    }
    system ("$crond_scpt restart &> /dev/null");

done:

    return($ret);

}

#
# Function
#   HTMLμư
# Parameters
#   $domainname               ɥᥤ̾
#   $listname                 ᡼󥰥ꥹ̾
# Return
#       ""
#       顼å
#

sub del_autorun
{
    my($domainname, $listname) = @_;

    my($flag) = 0;
    my(@tmp) = "";
    my($bin_lock) = "$domainname" . "_" . "$listname";
    my($bin_file) = "/opt/nec/wbmc/bin/$bin_lock";
    my($crontab_lock) = "crontab";
    my($crontab_file) = "/etc/$crontab_lock";
    my($crond_scpt) = "/etc/rc.d/init.d/crond";

    # 륹ץȺ
    unlink $bin_file if (-e $bin_file);

    # /etc/crontab
    if (!&readFile($crontab_file, $crontab_lock, *lines)) {
        $ret = "$crontab_fileեɤ߹ߤ˼Ԥޤ";
        goto done;
    }

    foreach (@lines) {
        $org = $_;
        s/^\s+//;
        s/\s+$//;

        if (/^#\s*$domainname\/$listname\s+HTML\s+update$/) {
            $flag = 1;
            next;
        }
        if ($flag == 1) {
            $flag = 2;
            next;
        }
        push (@tmp, $org);
    }

    if (!&writeFile($crontab_file, $crontab_lock, @tmp)) {
        $ret = "$crontab_fileեν񤭹ߤ˼Ԥޤ";
        goto done;
    }
    system ("$crond_scpt restart &> /dev/null");

done:

    return($ret);

}

#
# Function
#   ֥饦Υॢ޻
# Parameters
#   $title               ȥ
#   $show_str            ɽʸ
#   $append              ɽ(0)/ɲɽ(1)
# Return
#       ""
#       ""
#

sub no_timeout
{
    my($title, $show_str, $append) = @_;

    if ($append == 0) {
        print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY>
END_OF_DATA
    }

    print <<END_OF_DATA;
<TABLE><TR><TD></TD></TR></TABLE>
<HR>
$show_str<BR>
END_OF_DATA

    # ˲ɽ褦ߡǡ
    print "<!--\n";
    print "A" x 1024;
    print "-->\n";

    $count = 0;
    for(;;) {
        if($count eq "0"){
            print "<TABLE><TR><TD></TD></TR></TABLE>";
        }elsif($count % 50){
            print "";
        }else{
            print "<BR>";
        }
        # ॢбΤᡢSTDOUХåեեå夹롣
        $buff = select(STDOUT);
        $| = 1;
        select($buff);
        sleep 5;         # 5äޤ
        $count++;
    }
}

#
# Function
#   ư¹ԥץȺ
# Parameters
#   $fml_dir                  ᡼󥰥ꥹȥǥ쥯ȥ
#   $domainname               ɥᥤ̾
#   $listname                 ᡼󥰥ꥹ̾
#   $def                      Indexڡɽեå(on/off)
#   $mhonarc_cmd              mhonarcޥ
#   $mrc_file                 MRCե
#   $html_dir                 HTMLեǼǥ쥯ȥ
#   $spool_dir                סǥ쥯ȥ
#   $mknmz_cmd                mknmzޥ
#   $mknmzrc_file             mknmzrcե
#   $index_dir                Namazuǥåǥ쥯ȥ
#   $bin_lock                 ץȥե̾
#   $bin_file                 ץȥեХѥ
# Return
#       ""
#       顼å
#

sub make_autorun
{
    my($fml_dir, $domainname, $listname, $def, $mhonarc_cmd, $mrc_file, $html_dir, $spool_dir, $mknmz_cmd, $mknmzrc_file, $index_dir, $bin_lock, $bin_file) = @_;

    my($ret);
    my(@tmp) = "";
    my($template1) = "script_template1";
    my($template2) = "script_template2";
    my($result_mhonarc) = "$fml_dir/$domainname/$listname/result_mhonarc";
    my($result_mknmz) = "$fml_dir/$domainname/$listname/result_mknmz";

    if ($def eq "on" or $def eq "on1") {
        if (!&readFile($template1, $template1, *lines)) {
            $ret = "ƥץ졼ȥեɤ߹ߤ˼Ԥޤ";
            goto done;
        }

        if ($def eq "on") {
            foreach (@lines) {
                s/__MHONARC_CMD/$mhonarc_cmd/g;
                s/__MRC_FILE/$mrc_file/g;
                s/__HTML_DIR/$html_dir/g;
                s/__SPOOL_DIR/$spool_dir/g;
                s/__RESULT_MHONARC/$result_mhonarc/g;
                s/__MKNMZ_CMD/$mknmz_cmd/g;
                s/__MKNMZRC_FILE/$mknmzrc_file/g;
                s/__INDEX_DIR/$index_dir/g;
                s/__RESULT_MKNMZ/$result_mknmz/g;

                push (@tmp, $_);
            }
        } elsif ($def eq "on1") {
            foreach (@lines) {
                s/__MHONARC_CMD/$mhonarc_cmd/g;
                s/__MRC_FILE/$mrc_file/g;
                s/__HTML_DIR/$html_dir/g;
                s/__SPOOL_DIR/$spool_dir/g;
                s/__RESULT_MHONARC/$result_mhonarc/g;
                s/__MKNMZ_CMD/$mknmz_cmd/g;
                s/__MKNMZRC_FILE/$mknmzrc_file/g;
                s/__INDEX_DIR/$index_dir/g;
                s/__RESULT_MKNMZ/$result_mknmz/g;
                s/ -I / -T /g;

                push (@tmp, $_);
            }
        }

        if (!&writeFile($bin_file, $bin_lock, @tmp)) {
            $ret = "$bin_fileեν񤭹ߤ˼Ԥޤ";
            goto done;
        }
    } elsif ($def eq "off") {
        if (!&readFile($template2, $template2, *lines)) {
            $ret = "ƥץ졼ȥեɤ߹ߤ˼Ԥޤ";
            goto done;
        }

        foreach (@lines) {
            s/__MHONARC_CMD/$mhonarc_cmd/g;
            s/__MRC_FILE/$mrc_file/g;
            s/__HTML_DIR/$html_dir/g;
            s/__SPOOL_DIR/$spool_dir/g;
            s/__RESULT_MHONARC/$result_mhonarc/g;

            push (@tmp, $_);
        }

        if (!&writeFile($bin_file, $bin_lock, @tmp)) {
            $ret = "$bin_fileեν񤭹ߤ˼Ԥޤ";
            goto done;
        }
    }
    chmod 0755, $bin_file;

done:

    return($ret);

}


#
# Function
#   ӥ֥å
# Parameters
#   $src     åоݥӥ(def:ǥեȡsel:)
#   $call    ƤӽФ(0:GUI1:¾)
# Return
#   ӥ
#   ԡʤ
#

sub chk_svc
{
    my($src, $call) = @_;

    my($pid) = "pid";
    my(@src_svc, @definition);
    my($svc, $def);
    my(@def_line, @pid_info);
    my($i, $flag);
    my(@rechk_svc);

    my($ftp_flag) = 0;
    my($telnet_flag) = 0;
    my($ftpd) = "31ftpd";
    my($telnetd) = "91telnetd";
    my($xinetd_ftp) = "/etc/xinetd.d/wu-ftpd";
    my($xinetd_telnet) = "/etc/xinetd.d/telnet";
    my($xinetd_ftp_lock) = "wu-ftpd";
    my($xinetd_telnet_lock) = "telnet";

    if ($src eq "def") {     # ƻоݥӥ(ǥե)
        @src_svc = &get_svc_def($call);
    } elsif ($src eq "sel") {     # ƻоݥӥ()
        @src_svc = &get_svc_info($call);
    }

    # ӥƻե
    @definition = &get_definition($call);

    # ӥå¹
    foreach $svc (@src_svc) {
        if ($svc eq $ftpd) {
            if (-e "$xinetd_ftp") {
                if (!&readFile("$xinetd_ftp", "$xinetd_ftp_lock", *xinetd_conf)) {
                    print "$xinetd_ftpեΥץ˼Ԥޤ\n";
                    push (@rechk_svc, $svc);
                    next;
                }
                for ($i = 0; $i <= $#xinetd_conf; $i++) {
                    if ($xinetd_conf[$i] =~ /disable\s*=\s*(.*)/) {
                        if ($1 eq "no") {
                            $ftp_flag = 1;
                            last;
                        }
                    }
                }
                if ($ftp_flag == 0) {
                    push (@rechk_svc, $svc);
                    next;
                }
            } else {
                print "$xinetd_ftpե뤬¸ߤޤ\n";
                push (@rechk_svc, $svc);
                next;
            }
        } elsif ($svc eq $telnetd) {
            if (-e "$xinetd_telnet") {
                if (!&readFile("$xinetd_telnet", "$xinetd_telnet_lock", *xinetd_conf)) {
                    print "$xinetd_telnetեΥץ˼Ԥޤ\n";
                    push (@rechk_svc, $svc);
                    next;
                }
                for ($i = 0; $i <= $#xinetd_conf; $i++) {
                    if ($xinetd_conf[$i] =~ /disable\s*=\s*(.*)/) {
                        if ($1 eq "no") {
                            $telnet_flag = 1;
                            last;
                        }
                    }
                }
                if ($telnet_flag == 0) {
                    push (@rechk_svc, $svc);
                    next;
                }
            } else {
                print "$xinetd_telnetե뤬¸ߤޤ\n";
                push (@rechk_svc, $svc);
                next;
            }
        }
    LP: foreach $def (@definition) {
            @def_line = split (':', $def);
            if ($svc eq $def_line[0]) {
                if (!open(IN, "/etc/rc.d/init.d/$def_line[1] status 2>&1 |")) {
                    print "$def_line[1]ӥ־˼Ԥޤ\n";
                    exit(1);
                } else {
                    if ($def_line[2] eq $pid) {
                        while(<IN>) {
                            s/^\s*//;
                            s/\s*$//;
                            if ($_ =~ /.+\((.+)\).+/) {
                                @pid_info = split ('\s+', $1);
                                for ($i = 0; $i < @pid_info; $i++) {
                                    if ($i == 0) {
                                        if ($pid_info[$i] !~ /$pid/i) {
                                            push (@rechk_svc, $svc);
                                            close(IN);
                                            last LP;
                                        }
                                    } else {
                                        if ($pid_info[$i] =~ /\D/) {
                                            push (@rechk_svc, $svc);
                                            close(IN);
                                            last LP;
                                        }
                                    }
                                }
                            } else {
                                push (@rechk_svc, $svc);
                                close(IN);
                                last LP;
                            }
                        }
                    } else {
                        $flag = 0;
                        while(<IN>) {
                            s/^\s*//;
                            s/\s*$//;
                            if ($_ =~ /$def_line[2]/) {
                                $flag = 1;
                                last;
                            }
                        }
                        if ($flag == 0) {
                            push (@rechk_svc, $svc);
                            close(IN);
                            last LP;
                        }
                    }
                }
                close(IN);
            }
        }
    }
    return (@rechk_svc);
}


#
# Function
#   ƥϿ
# Parameters
#   $chk_result      ӥå(1:2:۾3:ơå)
#   @err_services    ӥ
# Return
#   ʤ
#   ԡʤ
#

sub write_syslog
{
    my($chk_result, @err_services) = @_;

    my(@err_svc_conv);
    my($msg1) = "*** service check success ***";
    my($msg2) = "*** service check failure ***";
    my($msg3) = "service check running";

    my($logger_cmd) = "/usr/bin/logger";
    my($logger_opt) = "-i -t";
    my($logger_tag) = "chksvc";

    $logger_tag = "chkcron" if ($chk_result == 3);
    @err_svc_conv = &conv_svc(@err_services);

    if ($chk_result == 1) {
        system ("$logger_cmd $logger_opt $logger_tag \"$msg1\" > /dev/null 2>&1");
    } elsif ($chk_result == 2) {
        system ("$logger_cmd $logger_opt $logger_tag \"$msg2 : @err_svc_conv\" > /dev/null 2>&1");
    } elsif ($chk_result == 3) {
        system ("$logger_cmd $logger_opt $logger_tag \"$msg3\" > /dev/null 2>&1");
    } else {
        print "ӥå̤۾Ǥ\n";
        exit(1);
    }
}        


#
# Function
#   ƥԤإ᡼
# Parameters
#   $chk_result      ӥå(1:2:۾3:ơå)
#   @err_services    ӥ
# Return
#   ʤ
#   ԡʤ
#

sub send_mail
{
    my($chk_result, @err_services) = @_;

    my(@err_svc_conv);
    my($msg1) = "*** service check success ***";
    my($msg2) = "*** service check failure ***";
    my($msg3) = "service check running";

    my($echo_cmd) = "/bin/echo";
    my($mail_cmd) = "/bin/mail";
    my($mail_opt) = "-s";
    my($mail_to) = "root";
    my($mail_bd) = "/opt/nec/wbmc/adm/service/97chksvc/mail_body_$$";

    @err_svc_conv = &conv_svc(@err_services);

    if ($chk_result == 1) {
        system ("$echo_cmd \"$msg1\" > $mail_bd");
        system ("$mail_cmd $mail_opt \"$msg1\" $mail_to  < $mail_bd > /dev/null 2>&1");
        unlink $mail_bd;
    } elsif ($chk_result == 2) {
        system ("$echo_cmd \"$msg2\" > $mail_bd");
        foreach (@err_svc_conv) {
            system ("$echo_cmd \"$_\" >> $mail_bd");
        }
        system ("$mail_cmd $mail_opt \"$msg2\" $mail_to  < $mail_bd > /dev/null 2>&1");
        unlink $mail_bd;
    } elsif ($chk_result == 3) {
        system ("$echo_cmd \"$msg3\" > $mail_bd");
        system ("$mail_cmd $mail_opt \"$msg3\" $mail_to  < $mail_bd > /dev/null 2>&1");
        unlink $mail_bd;
    } else {
        print "ӥå̤۾Ǥ\n";
        exit(1);
    }
}        


#
# Function
#   ӥ̾Ѵ
# Parameters
#   @int_svc      ӥ̾
# Return
#   ӥ̾
#   ԡʤ
#

sub conv_svc
{
    my(@int_svc) = @_;

    my(@ext_svc, @line);
    my($int, $def);
    my($ftp) = "31ftpd";
    my($telnet) = "91telnetd";
    my($call) = 1;
    my(@definition) = &get_definition($call);

    foreach $int (@int_svc) {
        foreach $def (@definition) {
            @line = split (':', $def);
            if ($int eq $line[0]) {
                if ($int eq $ftp or $int eq $telnet) {
                    $int =~ s/^\d+//;
                    push (@ext_svc, $int);
                    last;
                } else {
                    push (@ext_svc, $line[1]);
                    last;
                }
            }
        }
    }

    if ($#int_svc != $#ext_svc) {
        print "ӥ̾Ѵ˼Ԥޤ\n";
        exit(1);
    }

    return (@ext_svc);
}

1;
