#!/usr/bin/perl

# Copyright (C) 2000-2003 NEC Corporation
# All Rights Reserved.

# RCS: $Id: updown.cgi,v 1.4 2003/02/26 05:56:22 snavi Exp $


# print "Content-type: text/html\n\n";

## 000916 v4.1 OSưɲ Hori
## 030205 ӥƻɲ watanabe

require "../../lib/wbmc.pl";
require "./97chksvc/chksvc.pl";

&readParam();

#
# ᥤ롼
#
{
    # եͤɤ߼
    $updown = $FORM{'UPDOWN'};
    $dir = $FORM{'NAME'};

    # Υӥ¸ߤʤХ顼
    if (! -d $dir) {
        &showErrorPage("ꤵ줿ӥĤޤ");
        exit(1);
    }
    
    # wbmc.rcեɤ߽Ф
    if (!&readFile("$dir/wbmc.rc", "wbmc.rc", *wbmc_rc)) {
        &showErrorPage("ӥμ˼Ԥޤ");
        exit(1);
    }
    $title = "";
    $service_type = "";
    $service_name = "";
    $start = "";
    for (@wbmc_rc) {
        s/\s*$//;
        if (/^#/) {
            next;
        }
        elsif (/^\s*Title:\s*(.*)/i) {
            $title = $1;
        }
        elsif (/^\s*ServiceType:\s*(.*)/i) {
            $service_type = $1;
        }
        elsif (/^\s*ServiceName:\s*(.*)/i) {
            $service_name = $1;
        }
        elsif (/^\s*Start:\s*(.*)/i) {
            $start = $1;
        }
    }

    # ӥ̾ʬʤХ顼
    if ($service_name eq "") {
        &showErrorPage("ӥμ˼Ԥޤ");
        exit(1);
    }

    if ($start ne "" && $start !~ /^\//) {
        $start = $dir . "/" . $start;
    }

    # ӥ򥢥åor󤵤
    # xinetdѹ
    #if ($service_type =~ /^inetd$/i) {
    #    $ret = &inetd_updown($service_name, $updown);
    if ($service_type =~ /^xinetd$/i) {
        $ret = &xinetd_updown($service_name, $updown);
    } elsif ($service_type =~ /^crond$/i) {
        $ret = &crond_regist($service_name, $updown, $dir);
    } else {
        $ret = &rcd_updown($service_name, $updown, $start);
    }
 
    # ̤ɽ
    sleep 1; # wbmcmsvdΩ夬Ԥ
    if ($ret == 1) {
        &showPage("menu.cgi");
    }
}


#
# crondΥåץ(Ͽ/)
#
sub crond_regist
{
    local($service_name, $updown, $dir) = @_;

    return(1) if ($updown eq "reup");

    $upcheck = "upcheck.sh";
    $upcheck_path = "$dir/$upcheck";

    if (!&readFile("$upcheck_path", "$upcheck", *upchk_contents)) {
        &showErrorPage("ӥƻ뵯ưμ˼Ԥޤ");
        exit(1);
    }

    foreach (@upchk_contents) {
        if ($_ =~ /^echo\s+/) {
            push (@tmp_array, "echo $updown\n");
        } else {
            push (@tmp_array, "$_");
        }
    }

    if (!&writeFile("$upcheck_path", "$upcheck", @tmp_array)) {
        &showErrorPage("ӥƻ뵯ưν񤭹ߤ˼Ԥޤ");
        exit(1);
    }

    if ($updown eq "down") {
        &chksvc_down();
    }

    return(1);
}

#
# xinetdΥåץ
#
sub xinetd_updown
{
    local($service_name, $updown) = @_;
    local(@xinetd_conf, $i, $servname, $changeflag, $pid);
    local($xinetd_d_file);

    if ($service_name eq "ftp") {
        $xinetd_d_file = "/etc/xinetd.d/wu-ftpd";
    }
    else {
        $xinetd_d_file = "/etc/xinetd.d/" . $service_name;
    }

    # xinetd.d/ӥɤ߹
    if (!&readFile("$xinetd_d_file", "xinetd.conf", *xinetd_conf)) {
        &showErrorPage("$xinetd_d_fileեɤޤǤ");
        exit(1);
    }
    $changeflag = 0;
    for ($i = 0; $i <= $#xinetd_conf; $i++) {
        if ($xinetd_conf[$i] =~ /disable\s*=\s*(.*)/) {
            if ($updown eq "up" || $updown eq "reup") {
                splice(@xinetd_conf, $i, 1, "\tdisable\t\t\t= no\n");
            } elsif ($xinetd_conf[$i] !~ /^\s*#/) {
                splice(@xinetd_conf, $i, 1, "\tdisable\t\t\t= yes\n");
            }
            $changeflag = 1;
        }
    }
    # xinetd.d/ӥ꤬ѹƤ
    if ($changeflag) {
        # ե񤭴
        if (!&writeFile("$xinetd_d_file", "xinetd.conf", @xinetd_conf)) {
            &showErrorPage("$xinetd_d_fileեؤν񤭹ߤ˼Ԥޤ");
            exit(1);
        }
        # xinetdƵư
        system("/etc/rc.d/init.d/xinetd stop > /dev/null 2>&1");
        system("/etc/rc.d/init.d/xinetd start > /dev/null 2>&1");
    }

    return(1);

}

#
# inetdΥåץ
#
sub inetd_updown
{
    local($service_name, $updown) = @_;
    local(@inetd_conf, $i, $servname, $changeflag, $pid);

    # inetd.confɤ߹Ǥ
    if (!&readFile("/etc/inetd.conf", "inetd.conf", *inetd_conf)) {
        &showErrorPage("/etc/initd.confեɤޤǤ");
        exit(1);
    }

    $changeflag = 0;
    for ($i = 0; $i <= $#inetd_conf; $i++) {
        if ($inetd_conf[$i] =~ /^\s*(#|)\s*([^\s]*)\s+(stream|dgram)/) {
            $servname = $2;
        } else {
            next;
        }
        if ($servname ne $service_name) {
            next;
        }
        if ($updown eq "up" || $updown eq "reup") {
            $inetd_conf[$i] =~ s/^(\s*)(#)/$1/;
        } elsif ($inetd_conf[$i] !~ /^\s*#/) {
            $inetd_conf[$i] =~ s/^/#/;
        }
        $changeflag = 1;
    }

    # inetd꤬ѹƤ
    if ($changeflag) {

        # inetd.conf 񤭴
        if (!&writeFile("/etc/inetd.conf", "inetd.conf", @inetd_conf)) {
            &showErrorPage("/etc/inetd.confեؤν񤭹ߤ˼Ԥޤ");
            exit(1);
        }

        # inetdƵư
        if (!open(IN, "/var/run/inetd.pid")) {
            &showErrorPage("inetdƵưǤޤǤ");
            exit(1);
        }
        if (!($pid = <IN>)) {
            &showErrorPage("inetdƵưǤޤǤ");
            exit(1);
        }
        close(IN);
        if (kill(1, $pid) != 1) {
            &showErrorPage("inetdƵưǤޤǤ");
            exit(1);
        }
    }

    return(1);
}

#
# rc.dΥåץ
#
sub rcd_updown
{
    local($service_name, $updown, $start) = @_;

    if ($updown eq "up") {
#       system("/sbin/chkconfig $service_name on");
        if ($start eq "") {
            system("/etc/rc.d/init.d/$service_name start > /dev/null 2>&1");
        } else {
            &showPage($start);
            return(0);
        }
    } elsif ($updown eq "down") {
#       system("/sbin/chkconfig $service_name off");
        system("/etc/rc.d/init.d/$service_name stop > /dev/null 2>&1");
    } elsif ($updown eq "reup") {
#       system("/sbin/chkconfig $service_name on");
        if ($start eq "") {
            system("/etc/rc.d/init.d/$service_name stop > /dev/null 2>&1");
            system("/etc/rc.d/init.d/$service_name start > /dev/null 2>&1");
        } else {
            &showPage($start);
            return(0);
        }
    }

    return(1);
}

