#!/usr/bin/perl

# Copyright (C) 2002 NEC Corporation
# All Rights Reserved.

# RCS: $Id: aftalb.pl,v 1.2 2002/09/25 07:30:46 snavi Exp $

require "../../../lib/wbmc.pl";

#
# Function
#      ϥեΥԡ(ϥե̾.old)
# Usage
#      $result = &preserve_file($file_name);
# Parameters
#      $file_name          ϥե̾(Хѥ)
# Return
#      ξ   1
#      Ԥξ   0
#

sub preserve_file 
{
    my($file_name) = @_;

    if(-f "$file_name.old"){
        if(system("/bin/rm -rf $file_name.old")>0){
            return(0);
        }
    }
    if(system("/bin/cp -fp $file_name $file_name.old")>0){
        return(0);
    }
    return(1);
}

#
# Function
#      ONBOOTѹ
# Usage
#      $result = &chg_onboot($mode, $virtual_adapter);
# Parameters
#      $mode                     ⡼(NORMAL/AFT/ALB)
#      $virtual_adapter          ۥץ
# Return
#      ξ   1
#      Ԥξ   0
#

sub chg_onboot
{
    my($mode, $virtual_adapter) = @_;

    while ($file = </etc/sysconfig/network-scripts/ifcfg-*>) {
        @ent = @line = @tmp = "";
        @ent = split(/\//, $file);
        $lockfile = $ent[4];
        next if ($lockfile eq "ifcfg-lo");
        next if ($lockfile =~ /\.old$/);

        if (!&readFile($file, $lockfile, *line)) {
            return(0);
        }

        if ($mode eq "NORMAL" and $lockfile =~ /ifcfg-eth0$/) {
            for (@line) {
                s/ONBOOT=no/ONBOOT=yes/i;
                push (@tmp, $_);
            }
        } elsif ($mode eq "NORMAL" and $lockfile =~ /ifcfg-$virtual_adapter/) {
            for (@line) {
                s/ONBOOT=yes/ONBOOT=no/i;
                push (@tmp, $_);
            }
        } elsif (($mode eq "AFT" or $mode eq "ALB") and $lockfile =~ /ifcfg-eth/) {
            for (@line) {
                s/ONBOOT=yes/ONBOOT=no/i;
                push (@tmp, $_);
            }
        } elsif (($mode eq "AFT" or $mode eq "ALB") and $lockfile =~ /ifcfg-$virtual_adapter$/) {
            for (@line) {
                s/ONBOOT=no/ONBOOT=yes/i;
                push (@tmp, $_);
            }
        } else {
            for (@line) {
                push (@tmp, $_);
            }
        }

        # ե
        return(0) if (!&preserve_file($file));

        if (!&writeFile($file, $lockfile, @tmp)) {
            system("/bin/mv -f $file.old $file");
            return(0);
        }
    }
    return(1);
}

1;
