#!/usr/bin/perl

# Copyright (C) 2002 NEC Corporation
# All Rights Reserved.

# RCS: $Id: remove2.cgi,v 1.3 2004/09/09 07:15:07 snavi Exp $

##040224 v5.1.1 Samba Unmountб(Samba꤬Ĥ) Ishiyama

use POSIX;

require "../../../lib/wbmc.pl";
require join ("/", $WBMC_ADM_DIR,"system/backup/date.pl");
&readParam();

#Ǥ
#$backup_conf = "$WBMC_CONF_DIR/backup.conf";
#$backup_conf_lock = "backup.conf";
$restorefile_lock = "backup";


$backup_dir = $ARGV[0];
$backupmode = $ARGV[1];
$restorefile = $ARGV[2];
$restorefile =~ s/\\(.)/$1/g;
$item = $ARGV[3];
$item =~ s/\\(.)/$1/g;
$linenum = $ARGV[4];	# 010426 add

## ʬХåå/smbmount б 2002.6.10 kima
require join ("/", $WBMC_ADM_DIR,"system/backup/split_backup.pl");
require join ("/", $WBMC_ADM_DIR,"disk/disk.pl");
$conf_file = "$WBMC_CONF_DIR/backup.conf";
$conf_lock = "backup.conf";

chdir("$backup_dir");

## ʬХåå/smbmount б 2002.6.10 kima
if ($backupmode eq "SMB") {
  if (!&readFile("/etc/sysconfig/network-scripts/ifcfg-eth0", "ifcfg-eth0", *file)) {
    &showErrorPage("ͥåȥ󥿥եեɤ߹ߤ˼Ԥޤ");
    exit(1);
  }
  $ipaddr = "";
  for ($i = 0; $i < @file; $i++) {
    if ($file[$i] =~ /^\s*IPADDR\s*=\s*(.*)\s*$/) {
      $ipaddr = $1;
    }
  }
  if(!mkdir($backup_dir_smbmnt, 0755)) {
    &showErrorPage("samba ³˼Ԥޤ mkdir error backup_dir_smbmnt : $backup_dir_smbmnt ($item)");
    exit(1);
  }

  if (!&readFile($conf_file, $conf_lock, *conf)) {
    &showErrorPage("Хååեɤ߹ߤ˼Ԥޤ read file error '$conf_file' ($item)\n");
    exit(1);
  }
  $item_flag = 0;
  for ($i = 0; $i < @conf; $i++) {
    if ($conf[$i] =~ /^\s*$item\s*{\s*$/) {
      $item_flag = 1;
    }
    if ($item_flag && $conf[$i] =~ /^\s*}\s*$/) {
      $item_flag = 0;
    }
    if ($item_flag && $conf[$i] =~ /^\s*TARGET\s*=\s*(.*)\s*$/) {
      $target_dir = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*BACKUP\s*=\s*(.*)\s*$/) {
      $backup_dir = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*ROTATE\s*=\s*(.*)\s*$/) {
      $rotate_max = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*BACKUPMODE\s*=\s*(.*)\s*$/) {
      $backupmode = &getValue($1);
      @line = split(/\s+/, $backupmode);
    }
    if ($item_flag && $conf[$i] =~ /^\s*WORKGROUP\s*=\s*(.*)\s*$/) {
      $workgroup = &getValue($1);
      $workgroup_arg = &encodeCmdArg($workgroup);
    }
    if ($item_flag && $conf[$i] =~ /^\s*WINMACHINE\s*=\s*(.*)\s*$/) {
      $winmachine = &getValue($1);
      $winmachine_arg = &encodeCmdArg($winmachine);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SHARE\s*=\s*(.*)\s*$/) {
      $share = &getValue($1);
      $share_arg = &encodeCmdArg($share);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SMBUSER\s*=\s*(.*)\s*$/) {
      $smbuser = &getValue($1);
      $smbuser_arg = &encodeCmdArg($smbuser);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SMBPASSWD\s*=\s*"(.*)"\s*$/) {
      $smbpasswd = &getValue($1);
      $smbpasswd_arg = &encodeCmdArg($smbpasswd);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FTPSERVER\s*=\s*(.*)\s*$/) {
      $ftpserver = &getValue($1);
      $ftpserver_arg = &encodeCmdArg($ftpserver);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FTPUSER\s*=\s*(.*)\s*$/) {
      $ftpuser = &getValue($1);
      $ftpuser_arg = &encodeCmdArg($ftpuser);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FTPPASSWD\s*=\s*"(.*)"\s*$/) {
      $ftppasswd = &getValue($1);
      $ftppasswd_arg = &encodeCmdArg($ftppasswd);
    }
    if ($item_flag && $conf[$i] =~ /^\s*DOMAINBACKUPTYPE\s*=\s*(.*)\s*$/) {
      $domainbackuptype = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*DOMAINNAME\s*=\s*(.*)\s*$/) {
      $domainname = &getValue($1);
      @domainlist = split(/\s+/, $domainname);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FMLBACKUPTYPE\s*=\s*(.*)\s*$/) {
      $fmlbackuptype = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FMLNAME\s*=\s*(.*)\s*$/) {
      $fmlname = &getValue($1);
      @fmllist = split(/\s+/, $fmlname);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SPOOL\s*=\s*(.*)\s*$/) {
      $spool = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SYMLINK\s*=\s*(.*)\s*$/) {
      $cluster_symlink = &getValue($1);
      @symlinklist = split(/\s+/, $cluster_symlink);
    }
  }

  my $result = &SmbMount($winmachine, $share, $backup_dir_smbmnt, $smbuser_arg, $smbpasswd_arg, $workgroup_arg);
  if ($result) {
    &showErrorPage("Хååץեɤ߹ߤ˼Ԥޤsmbmount failed($item, $backup_dir_smbmnt) : $result");
    exit(1);
  }
  chdir("$backup_dir_smbmnt/$ipaddr");
}

# ɽ
# update /bin/tar -> /opt/nec/baktar/baktar 001227
# 010426 kokokara rep ɽ饤
if ($linenum eq "") {
#	if (!&readFile("/bin/cat $restorefile$split_postfix* | /opt/nec/baktar/baktar tvfz - |", $restorefile_lock, *tarfile)) {
	  if ($backupmode eq "SMB") {
	    chdir($backup_dir);
	    my $result = &SmbUnMount($backup_dir_smbmnt);
	    if($result) {
	      &showErrorPage("Хååץեɤ߹ߤ˼Ԥޤsamba ͭ˼Ԥޤ($result)");
	      exit(1);
	    }
	    # 2004/02/24 add by Ishiyama
	    my $err = &delSmb($winmachine, $share, $backup_dir_smbmnt);
	    if($err) {
	      &showErrorPage("samba κ˼Ԥޤ($err)");
	    }
	    #
	  }
#	  &showErrorPage("Хååץեɤ߹ߤ˼Ԥޤ");
#	  exit(1);
#	}
} else {
#	if (!&readFile("/bin/cat $restorefile$split_postfix* | /opt/nec/baktar/baktar tvfz - | head -n $linenum |", $restorefile_lock, *tarfile)) {
	  if ($backupmode eq "SMB") {
	    chdir($backup_dir);
	    my $result = &SmbUnMount($backup_dir_smbmnt);
	    if($result) {
	      &showErrorPage("Хååץեɤ߹ߤ˼Ԥޤsamba ͭ˼Ԥޤ($result)");
	      exit(1);
	    }
            # 2004/02/24 add by Ishiyama
            my $err = &delSmb($winmachine, $share, $backup_dir_smbmnt);
            if($err) {
              &showErrorPage("samba κ˼Ԥޤ($err)");
            }
            #
	  }
#	  &showErrorPage("Хååץեɤ߹ߤ˼Ԥޤ");
#	  exit(1);
#	}
}
# 010426 kokomade rep

#@tmp = @tarfile;
#for ($i = 0 ; $i < @tmp; $i++) {
#    $tmp[$i] =~ s/&/&amp;/g ;
#    $tmp[$i] =~ s/</&lt;/g ;
#    $tmp[$i] =~ s/>/&gt;/g ;
#}

# եκ
## smbmount ѤѹˤʤäΤ smb ξϺʤ
## 2002.6.10 kima
#if ($backupmode eq "SMB" || $backupmode eq "FTP") {
#if ($backupmode eq "FTP") {
@remove_files = <$restorefile$split_postfix*>;
push(@remove_files,$restorefile);
$result = unlink(@remove_files);
if($result != @remove_files){
    &showErrorPage("եκ˼Ԥޤ");
    exit (1);
}
#}

## smbmount б
if ($backupmode eq "SMB") {
  chdir($backup_dir);
  my $result = &SmbUnMount($backup_dir_smbmnt);
  if($result) {
    &showErrorPage("samba ͭβ˼Ԥޤsmbumount failed($item, $backup_dir_smbmnt) : $result");
    exit(1);
  }
  # 2004/02/24 add by Ishiyama
  my $err = &delSmb($winmachine, $share, $backup_dir_smbmnt);
  if($err) {
    &showErrorPage("samba κ˼Ԥޤ($err)");
  }
  #
}

#Хååץե̾
#$backup_dir$brestorefileδ֤'/'롣
if ($backup_dir =~ /[^\/]$/) {
    $backup_dir .= "\/";
}

# Хååץե뤬¸ߤȤʤڡѤ
@backup_files = <"backup_".$item."_"*>;
if ( @backup_files != 0 ){
	&showResultPage("ե $restorefile ޤ","./restore.cgi?$item");
}
else {
	&showResultPage("ե $restorefile ޤ","./main.cgi");
}
