#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: restore_run2.cgi,v 1.5 2004/09/09 07:15:07 snavi Exp $

##040224 v5.1.1 Samba Unmountб(Samba꤬Ĥ) Ishiyama

#ꥹȥμ¹

use POSIX;

require "../../../lib/wbmc.pl";
require join ("/", $WBMC_ADM_DIR, "service/11sendmail/fml", "fml.pl");
require join ("/", $WBMC_ADM_DIR, "system", "backup", "date.pl");	# 010426 add


## ʬХåå/smbmount б 2002.5.24 kima
require join ("/", $WBMC_ADM_DIR,"system/backup/split_backup.pl");
require join ("/", $WBMC_ADM_DIR,"disk/disk.pl");

#Ǥ
#$backup_conf = "$WBMC_CONF_DIR/backup.conf";
#$backup_conf_lock = "backup.conf";
#$backupdir = "/var/backup";    ## wbmc03-B12

$conf_file = "$WBMC_CONF_DIR/backup.conf";
$conf_lock = "backup.conf";
$tag_name = "wbmc_backup";
$log_file = "/var/log/wbmc";

$backup_dir = $ARGV[0];
$backupmode = $ARGV[1];
$restorefile = $ARGV[2];
$restorefile =~ s/\\(.)/$1/g;
$item = $ARGV[3];
$item =~ s/\\(.)/$1/g;
$newbackupdir = $ARGV[4];

# 010426 kokokara
$targetfile = $ARGV[5];
$targetfile =~ s/:/ /g;

$cluster_type = &cluster_typechk();
$cluster_master = &cluster_masterchk();

# зб  001219	010426 move
if (!($workmode = &getConfParam("WbMC", "WorkMode"))) {
    &showErrorPage("եɤ߹ߤ˼Ԥޤ");
  exit(1);
}


# ǥ쥯ȥ꤬ʤΤͭ
# ե륪Х饹ΥޥʳǤϥǥΤߤ򥿡å
if ($targetfile eq "") {
	if (($cluster_type eq "cluster" && $cluster_master eq "master") ||
		($workmode eq "Standalone" || $workmode eq "WebLoadbalance")) {
	} else {
		if ($item eq "sysconf" || $item eq "conf" ||
			$item eq "home" || $item eq "mail" || $item eq "fml") {
			$target = &Getbackupconf($item, "TARGET");
			if ($target eq "") {
				&showErrorPage("Хåå׾μ˼Ԥޤ");
				exit(1);
			}
			if ($item eq "mail") {
				@target = split(/ /, $target);
				if ($restorefile =~ /mail_spool/) {
					$targetfile = $target[1];
				} else {
					$targetfile = $target[0];
				}
			} else {
				$targetfile = $target;
			}
			# ܥå󥯤Ǥʤ
			if ($item eq "sysconf") {
				$symlink = &Getbackupconf($item, "SYMLINK");
				if ($symlink eq "") {
					&showErrorPage("Хåå׾μ˼Ԥޤ");
					exit(1);
				}
				@symlink_list = split(/\s/, $symlink);
				for($j = 0; $j < @symlink_list; $j++) {
					if ($symlink_list[$j] eq "/home/web" ||
						$symlink_list[$j] eq "/home/mail" ||
						$symlink_list[$j] eq "/home/.wbmc" ) {
					} else {
						if (!-l $symlink_list[$j]) {
							system ("/bin/rm -fr $symlink_list[$j]");
						}
					}
				}
			}
		}
	}

	# ե륪Х饹Υޥquota.group quota.user 	# 010502 add
	# Ǥ ե긡
	if ($cluster_type eq "cluster" && $cluster_master eq "master") {
		if (!($mountpoint = &getConfParam("WbMC", "MountPoint"))) {
			&showErrorPage("եɤ߹ߤ˼Ԥޤ");
			exit(1);
		}
		if ( ($item eq "sysconf" || $item eq "home") && $newbackupdir eq "/" ){
			system ("/bin/rm -fr $mountpoint/aquota.group");
			system ("/bin/rm -fr $mountpoint/aquota.user");
		}
	}
}

# Ƭ / 
if ($targetfile ne "") {
	$targetfile =~ s/[\s,]+/ /g;
	@target = split(/ /, $targetfile);
	$targetfile = "";
	for($i = 0; $i < @target; $i++) {
		$target[$i] =~ s/^\///;
		$targetfile .= " $target[$i]";
	}
}
# 010426 kokomade

#
# Хååץե̾κ
#
if ($backup_dir =~ /[^\/]$/) {
        $backup_dir .= "\/";
}
$backup_filename = "$backup_dir$restorefile";

if($backupmode eq 'SMB') {
  if (!&readFile("/etc/sysconfig/network-scripts/ifcfg-eth0", "ifcfg-eth0", *file)) {
    &showErrorPage("ͥåȥ󥿥եեɤ߹ߤ˼Ԥޤ");
    exit(1);
  }
  $ipaddr = "";
  for ($i = 0; $i < @file; $i++) {
    if ($file[$i] =~ /^\s*IPADDR\s*=\s*(.*)\s*$/) {
      $ipaddr = $1;
    }
  }
  $backup_filename = "$backup_dir_smbmnt/$ipaddr/$restorefile"
}

#
#ХååץեŸ
#
if (!chdir("$newbackupdir")) {
    &showErrorPage("ꥹȥΥǥ쥯ȥ꤬¸ߤޤ");
    exit(1);
}

## ν wbmc_restore_split_backup ޥɤʬ
## fork Ƽ¹Ԥвȷ̤
## $backup_dir/.restore_status_${item}_${backupmode}
## ˽Ф
$restore_status_file = "$backup_dir/.restore_status_${item}_${backupmode}";
#$restore_status_file_lock = "$backup_dir/.restore_status_${item}_${backupmode}.lock";
if(-e $restore_status_file) {
    &showErrorPage("$item ($backupmode) ϴ˥ꥹȥǤ");
    exit(1);
}

## ǥåΥå򤹤٤ xxx
## not implemented kima 2002.5.25

if ( $pid = fork ) {
  # ƥץν
  if($pid == -1) {
    &showErrorPage("ꥹȥץ˼Ԥޤ");
    exit(1);
  }
} elsif ( defined $pid ) {
  # ҥץν
  close(STDIN);
  close(STDOUT);
  my $err_out_file = "$restore_status_file$date_str$$.log";
  open(STDERR, ">$err_out_file");
  &do_resore_cmd($item,
		 $backupmode,
		 $backup_dir,
		 $restorefile,
		 $backup_filename,
		 $newbackupdir,
		 $backup_dir_smbmnt,
		 $err_out_file,
		 $restore_status_file);

  exit(0);
}
# ƥץϳϥåФƽλ

$| = 1;
print "Content-type: text/html; charset=euc-jp\n";
print "Pragma: no-cache\n";
print "\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>ꥹȥ</TITLE>\n";
print "</HEAD>\n";
print "<BODY>\n";
print "<!--\n";
# write dummy data
for ($i = 0 ; $i < 1000; $i++) {
    print "A";
}
print "-->\n";
print "<BR>ꥹȥ桧<BR>\n";
print "ꥹȥ̤Ǽ¹Υꥹȥξ֤ǧƤ";
print "<A HREF=\"./restore.cgi?$item+$backupmode\">[BACK]</A>\n";
print "</BODY>\n";
print "</HTML>\n";
exit(0);

sub do_resore_cmd {
  my ($item,
      $backupmode,
      $backup_dir,
      $restorefile,
      $backup_filename,
      $newbackupdir,
      $backup_dir_smbmnt,
      $err_out_file,
      $restore_status_file) = @_;

  open(RESTORE_STATUS, ">$restore_status_file");
  select(RESTORE_STATUS); $| = 1;
  if (!chdir("$newbackupdir")) {
    print STDERR "ꥹȥΥǥ쥯ȥ꤬¸ߤޤ\n";
    print RESTORE_STATUS "error\nꥹȥΥǥ쥯ȥ꤬¸ߤޤ\n";
    goto jump_exit;
  }

  if ($item eq "mail") {
    @service_state = ('off', 'off', 'off', 'off');
    if (!&mail_service_stop(*service_state)) {
      print RESTORE_STATUS "error\nӥߤ˼Ԥޤ\n";
      goto jump_exit;
    }
  }

  if ($item eq "fml") {
    # ᡼󥰥ꥹбå
    $fmllist = "";
    if ($restorefile =~ /backup_${item}_(.*)_\d+.tgz/) {
      $fmllist = $1;
    } elsif ($restorefile =~ /backup_smb_${item}_(.*)_\d+.tgz/) {
      $fmllist = $1;
    } elsif ($restorefile =~ /backup_ftp_${item}_(.*)_\d+.tgz/) {
      $fmllist = $1;
    }
    if ($fmllist eq "") {
      print STDERR "᡼󥰥ꥹȤμ˼Ԥޤ\n";
      print RESTORE_STATUS "error\n᡼󥰥ꥹȤμ˼Ԥޤ\n";
      goto jump_exit;
    }
    # if ($err = &lockFml($fmllist, $WBMC_LOCK_R_NB, *lockfmlfile)) {
    if ($err = &lockDomainFml($fmllist, $WBMC_LOCK_R_NB, *lockfmlfile)) {
      print STDERR "$err\n᡼󥰥ꥹȤΥå˼Ԥޤ\n";
      print RESTORE_STATUS "error\n$err\n᡼󥰥ꥹȤΥå˼Ԥޤ\n";
      goto jump_exit;
    }
  }
  print STDERR "status\n(pid=$$)ꥹȥ\n";
  print RESTORE_STATUS "status\n(pid=$$)ꥹȥ\n";
  
  setpgrp($$, $$);

  $mailtar_flg = "off";
  if ($WBMC_MGRVER =~ /^1\./ && $WBMC_MGRNAME =~ /Management Console for Appliance Server/ ) {
    if (($workmode eq "Standalone" && $WBMC_MACHINE_TYPE eq "mail") ||
	$workmode eq "MailCluster" ||
	($workmode eq "Standalone" && $WBMC_MACHINE_TYPE eq "pre")) {
      $mailtar_flg = "ok";
    }
  } else {
    $mailtar_flg = "ok";
  }
  ## SMB  smbmount ƥꥹȥ 2002.5.25 kima
  ## ǥޥȡ
  ## ʹ exit ޤ smbunmount ɬפ롣
  if($backupmode eq "SMB") {
    if(!mkdir($backup_dir_smbmnt, 0755)) {
      print STDERR "mkdir error backup_dir_smbmnt : $backup_dir_smbmnt ($item)";
      print RESTORE_STATUS "error\nmkdir error backup_dir_smbmnt : $backup_dir_smbmnt ($item)";
      goto jump_exit;
    }
    # ipaddr μ
    if (!&readFile("/etc/sysconfig/network-scripts/ifcfg-eth0", "ifcfg-eth0", *file)) {
      print STDERR "cannot read ifcfg-eth0";
      print RESTORE_STATUS "error\ncannot read ifcfg-eth0";
      goto jump_exit;
    }
    for ($i = 0; $i < @file; $i++) {
      if ($file[$i] =~ /^\s*IPADDR\s*=\s*(.*)\s*$/) {
	$ipaddr = $1;
      }
    }


    ## ϴؿ٤ xxxx 2002.5.25 kima
    # եͤɤ߹
    if (!&readFile($conf_file, $conf_lock, *conf)) {
      print STDERR "read file error '$conf_file' ($item)\n";
      print RESTORE_STATUS "error\nread file error '$conf_file' ($item)\n";
      goto jump_exit;
    }
    $item_flag = 0;
    for ($i = 0; $i < @conf; $i++) {
      if ($conf[$i] =~ /^\s*$item\s*{\s*$/) {
	$item_flag = 1;
      }
      if ($item_flag && $conf[$i] =~ /^\s*}\s*$/) {
	$item_flag = 0;
      }
      if ($item_flag && $conf[$i] =~ /^\s*TARGET\s*=\s*(.*)\s*$/) {
	$target_dir = &getValue($1);
      }
      if ($item_flag && $conf[$i] =~ /^\s*BACKUP\s*=\s*(.*)\s*$/) {
	$backup_dir = &getValue($1);
      }
      if ($item_flag && $conf[$i] =~ /^\s*ROTATE\s*=\s*(.*)\s*$/) {
	$rotate_max = &getValue($1);
      }
      if ($item_flag && $conf[$i] =~ /^\s*BACKUPMODE\s*=\s*(.*)\s*$/) {
	$backupmode = &getValue($1);
	@line = split(/\s+/, $backupmode);
      }
      if ($item_flag && $conf[$i] =~ /^\s*WORKGROUP\s*=\s*(.*)\s*$/) {
	$workgroup = &getValue($1);
	$workgroup_arg = &encodeCmdArg($workgroup);
      }
      if ($item_flag && $conf[$i] =~ /^\s*WINMACHINE\s*=\s*(.*)\s*$/) {
	$winmachine = &getValue($1);
	$winmachine_arg = &encodeCmdArg($winmachine);
      }
      if ($item_flag && $conf[$i] =~ /^\s*SHARE\s*=\s*(.*)\s*$/) {
	$share = &getValue($1);
	$share_arg = &encodeCmdArg($share);
      }
      if ($item_flag && $conf[$i] =~ /^\s*SMBUSER\s*=\s*(.*)\s*$/) {
	$smbuser = &getValue($1);
	$smbuser_arg = &encodeCmdArg($smbuser);
      }
      if ($item_flag && $conf[$i] =~ /^\s*SMBPASSWD\s*=\s*"(.*)"\s*$/) {
	$smbpasswd = &getValue($1);
	$smbpasswd_arg = &encodeCmdArg($smbpasswd);
      }
      if ($item_flag && $conf[$i] =~ /^\s*FTPSERVER\s*=\s*(.*)\s*$/) {
	$ftpserver = &getValue($1);
	$ftpserver_arg = &encodeCmdArg($ftpserver);
      }
      if ($item_flag && $conf[$i] =~ /^\s*FTPUSER\s*=\s*(.*)\s*$/) {
	$ftpuser = &getValue($1);
	$ftpuser_arg = &encodeCmdArg($ftpuser);
      }
      if ($item_flag && $conf[$i] =~ /^\s*FTPPASSWD\s*=\s*"(.*)"\s*$/) {
	$ftppasswd = &getValue($1);
	$ftppasswd_arg = &encodeCmdArg($ftppasswd);
      }
      if ($item_flag && $conf[$i] =~ /^\s*DOMAINBACKUPTYPE\s*=\s*(.*)\s*$/) {
	$domainbackuptype = &getValue($1);
      }
      if ($item_flag && $conf[$i] =~ /^\s*DOMAINNAME\s*=\s*(.*)\s*$/) {
	$domainname = &getValue($1);
	@domainlist = split(/\s+/, $domainname);
      }
      if ($item_flag && $conf[$i] =~ /^\s*FMLBACKUPTYPE\s*=\s*(.*)\s*$/) {
	$fmlbackuptype = &getValue($1);
      }
      if ($item_flag && $conf[$i] =~ /^\s*FMLNAME\s*=\s*(.*)\s*$/) {
	$fmlname = &getValue($1);
	@fmllist = split(/\s+/, $fmlname);
      }
      if ($item_flag && $conf[$i] =~ /^\s*SPOOL\s*=\s*(.*)\s*$/) {
	$spool = &getValue($1);
      }
      if ($item_flag && $conf[$i] =~ /^\s*SYMLINK\s*=\s*(.*)\s*$/) {
	$cluster_symlink = &getValue($1);
	@symlinklist = split(/\s+/, $cluster_symlink);
      }
    }

    my $result = &SmbMount($winmachine, $share, $backup_dir_smbmnt, $smbuser_arg, $smbpasswd_arg, $workgroup_arg);
    if($result) {
      print STDERR "smbmount failed($item, $backup_dir_smbmnt) : $result";
      print RESTORE_STATUS "error\n smbmount failed($item, $backup_dir_smbmnt ) : $result";
      goto jump_exit;
    }
  }

  my $tarpid;
  if ($item eq "mail" || ($item eq "sysconf" && $mailtar_flg eq "ok")) {
    if (!($tarpid = open(CMD, "/bin/cat $backup_filename$split_postfix* | /opt/nec/mailtar/mailtar xvfz - $targetfile 2>&1 |"))) {
      print STDERR "mailtar ޥɤμ¹Ԥ˼Ԥޤ\n";
      print RESTORE_STATUS "mailtar ޥɤμ¹Ԥ˼Ԥޤ\n";
      if($backupmode eq "SMB") {
	chdir($backup_dir);
	&SmbUnMount($backup_dir_smbmnt);
	# 2004/02/24 add by Ishiyama
	&delSmb($winmachine, $share, $backup_dir_smbmnt);
	#
      }
      goto jump_exit;
    }
  } else {
    # update /bin/tar -> /opt/nec/baktar/baktar 001227
    if (!($tarpid = open(CMD, "/bin/cat $backup_filename$split_postfix* | /opt/nec/baktar/baktar xvfz - $targetfile 2>&1 |"))) {
      print STDERR "baktar ޥɤμ¹Ԥ˼Ԥޤ\n";
      print RESTORE_STATUS "error\nbacktar ޥɤμ¹Ԥ˼Ԥޤ\n";
      if($backupmode eq "SMB") {
	chdir($backup_dir);
	&SmbUnMount($backup_dir_smbmnt);
	# 2004/02/24 add by Ishiyama
	&delSmb($winmachine, $share, $backup_dir_smbmnt);
	#
      }
      goto jump_exit;
    }
  }

  $cnt = 0;
  $SIG{'TERM'} = "sigexit";
  $errflag = 0;
  while (<CMD>) {
    if (/\/opt\/nec\/baktar\/baktar: / || /\/opt\/nec\/mailtar\/mailtar: /) {
      # timestampå̵
      if (/Archive contains future timestamp/i) {
	next;
      }
      if (/Removing leading/i) {
	next;
      }
      # taråҤȤĤǤ⤢ȥե饰򤿤ƤƤ
      $errflag = 1;

      # ե̾()ɽ
      if (($cnt - 1) % 100) {
	print STDERR $cnt - 1;
	print STDERR ": $prevfile<BR>\n";
      }

      # taråʸɽ
      print STDERR "<FONT COLOR=red>$_</FONT><BR>\n";

      # No space顼ȯ
      if (/No space left on device/i) {
	my $time = localtime();
	print STDERR "No space left on device($time)\n";
	print RESTORE_STATUS "error\nNo space left on device($time)\n";
	$errflag = 2;
	# mount ե륷ƥ򰮤äƤץ򻦤
	chdir($backup_dir);
	kill(9, $tarpid);
	print STDERR "[/sbin/fuser -QUIT -km $backup_dir_smbmnt]\n";
	system("/sbin/fuser -QUIT -km $backup_dir_smbmnt 1>&2");
	kill(9, -$tarpid);
	sleep(10);
	last;
      }
    } else {
      if (($cnt % 100) == 0) {
	print STDERR "$cnt: $_<BR>\n";
      }
      $cnt++;
    }
    $prevfile = $_;
  }
  close(CMD);

  if($backupmode eq "SMB") {
    chdir($backup_dir);
    my $result = &SmbUnMount($backup_dir_smbmnt);
    my $time = localtime();
    # 2004/02/24 add by Ishiyama
    &delSmb($winmachine, $share, $backup_dir_smbmnt);
    #
    print STDERR "smbunmount : $reslut($time)";
  }

  if ($backupmode eq "FTP") {
    chdir("$backup_dir");
    unlink("$restorefile");
  }
  if ($item eq "mail") {
    if (!&mail_service_start(@service_state)) {
      $errflag = 2;
      my $time = localtime();
      print STDERR "<FONT COLOR=red>Service start (crrond/sendmail/popd/imapd) failed...($time)</FONT><BR>\n";
      print RESTORE_STATUS "warn\nService start (crrond/sendmail/popd/imapd) failed...($time)\n";
    }
  }

  # ᡼󥰥ꥹбå
  if ($item eq "fml") {
    # &unlockFml($lockfmlfile);
    &unlockDomainFml($lockfmlfile);
  }
  # 2003/5/13 ꥹȥ quotacheck ¹
  system("/sbin/quotaoff -aug &> /dev/null");
  system("/sbin/quotacheck -aug &> /dev/null");
  system("/sbin/quotaon -aug &> /dev/null");

  if($errflag < 2) {
    my $time = localtime();
    print RESTORE_STATUS "finish\n$time : ˽λޤ($item, $backupmode)\n";
  }
 jump_exit:
  close(STDERR);
  rename($err_out_file, "$restore_status_file.prev.errorout");
  close(RESTORE_STATUS);
  rename($restore_status_file, "$restore_status_file.finish");
}

sub mail_service_stop
{
  local(*service_state) = @_;
  local($ret,$i,@service);

  $ret = 1;
  # sendmail -> popd -> imapd -> cron
  @service = ('crond', 'sendmail', 'popd', 'imapd');
  for ($i=0;$i<@service;$i++) {
    open(IN, "/etc/rc.d/init.d/$service[$i] status |");
    while (<IN>) {
        s/[\r\n]*$//;
      if (/is running/) {
        $service_state[$i] = "on";
        # ưߤ
        if (system("/etc/rc.d/init.d/$service[$i] stop > /dev/null") != 0) {
          $ret = 0;
        }
      }
    }
    close(IN);
  }
  return $ret;
}

#000919 add start
sub mail_service_start
{
  local(@service_state) = @_;
  local($rtn,$i,@service);

  $rtn = 1;
  # sendmail -> popd -> imapd -> cron
  @service = ('crond', 'sendmail', 'popd', 'imapd');
  for ($i=0;$i<@service;$i++) {
    if ($service_state[$i] eq "on") {
      if (system("/etc/rc.d/init.d/$service[$i] start > /dev/null") != 0) {
        $rtn = 0;
      }
    }
  }
  return $rtn;
}
#000919 add stop

sub sigexit
{
    kill(9, -$$);
    exit(1);
}

#  #000919 add start
#  if ($item eq "mail") {
#    @service_state = ('off', 'off', 'off', 'off');
#    if (!&mail_service_stop(*service_state)) {
#      &showErrorPage("ӥߤ˼Ԥޤ");
#      exit(1);
#    }
#  }
#  #000919 add stop

#  if ($item eq "fml") {
#    # ᡼󥰥ꥹбå
#    $fmllist = "";
#    if ($restorefile =~ /backup_${item}_(.*)_\d+.tgz/) {
#      $fmllist = $1;
#    } elsif ($restorefile =~ /backup_smb_${item}_(.*)_\d+.tgz/) {
#      $fmllist = $1;
#    } elsif ($restorefile =~ /backup_ftp_${item}_(.*)_\d+.tgz/) {
#      $fmllist = $1;
#    }
#    if ($fmllist eq "") {
#      &showErrorPage("᡼󥰥ꥹȤμ˼Ԥޤ");
#      exit(1);
#    }
#  # if ($err = &lockFml($fmllist, $WBMC_LOCK_R_NB, *lockfmlfile)) {
#    if ($err = &lockDomainFml($fmllist, $WBMC_LOCK_R_NB, *lockfmlfile)) {
#      &showErrorPage("$err<BR>᡼󥰥ꥹȤΥå˼Ԥޤ");
#      exit(1);
#    }
#  }

#  #-----------------------------------------------------
#  $| = 1;
#  print "Content-type: text/html; charset=euc-jp\n";
#  print "Pragma: no-cache\n";
#  print "\n";
#  print "<HTML>\n";
#  print "<HEAD>\n";
#  print "<TITLE>ꥹȥ</TITLE>\n";
#  print "</HEAD>\n";
#  print "<BODY>\n";
#  print "<!--\n";
#  # write dummy data
#  for ($i = 0 ; $i < 1000; $i++) {
#      print "A";
#  }
#  print "-->\n";
#  print "<BR>ꥹȥ桧<BR>\n";
#  setpgrp($$, $$);

#  # 001219 kokokara
#  # mailtar ¸ߥå
#  # mailtar ޥ  (ƥե)
#  # appliance3.0 
#  # appliance2.0 MailServer (Standalone/MailCluster) SEC (Standalone)
#  # tar ޥ    (ƥե)
#  # appliance2.0 WebServer  (Standalone/WebLoadbalance)
#  $mailtar_flg = "off";
#  if ($WBMC_MGRVER =~ /^1\./) {
#    if (($workmode eq "Standalone" && $WBMC_MACHINE_TYPE eq "mail") ||
#       $workmode eq "MailCluster" ||
#       ($workmode eq "Standalone" && $WBMC_MACHINE_TYPE eq "pre")) {
#      $mailtar_flg = "ok";
#    }
#  } else {
#    $mailtar_flg = "ok";
#  }
#  # 001219 kokomade

#  ## SMB  smbmount ƥꥹȥͤѹ 2002.5.24 kima
#  ## ǥޥȡ
#  ## ʹ exit ޤ smbunmount ɬפ롣
#  ## ޤ̤礭Ȥ cgi ΥॢȤɬפ롣xxx

#  # continue

#  if ($item eq "mail" || ($item eq "sysconf" && $mailtar_flg eq "ok")) {
#    if (!open(CMD, "/bin/cat $backup_filename$split_postfix* | /opt/nec/mailtar/mailtar xvfz - $targetfile 2>&1 |")) {	# 010426 rep
#        print "<SCRIPT>\n";
#        print "location.href='./restore_error.cgi';\n";
#        print "</SCRIPT>\n";
#        print "</BODY>\n";
#        print "</HTML>\n";
#        exit(0);
#    }
#  } else {
#    # update /bin/tar -> /opt/nec/baktar/baktar 001227
#    if (!open(CMD, "/bin/cat $backup_filename$split_postfix* | /opt/nec/baktar/baktar xvfz - $targetfile 2>&1 |")) {		# 010426 rep
#        print "<SCRIPT>\n";
#        print "location.href='./restore_error.cgi';\n";
#        print "</SCRIPT>\n";
#        print "</BODY>\n";
#        print "</HTML>\n";
#        exit(0);
#    }
#  }
#  $cnt = 0;
#  $SIG{'TERM'} = "sigexit";
#  $errflag = 0;
#  while (<CMD>) {
#      if (/\/opt\/nec\/baktar\/baktar: / || /\/opt\/nec\/mailtar\/mailtar: /) { # 001227
#          # timestampå̵
#          if (/Archive contains future timestamp/i) {
#              next;
#          }

#          if (/Removing leading/i) {
#              next;
#          }

#          # taråҤȤĤǤ⤢ȥե饰򤿤ƤƤ
#          $errflag = 1;

#          # ե̾()ɽ
#          if (($cnt - 1) % 100) {
#              print $cnt - 1;
#              print ": $prevfile<BR>\n";
#          }

#          # taråʸɽ
#          print "<FONT COLOR=red>$_</FONT><BR>\n";

#          # No space顼ȯ
#          if (/No space left on device/i) {
#              last;
#          }
#      } else {
#          if (($cnt % 100) == 0) {
#              print "$cnt: $_<BR>\n";
#          }
#          $cnt++;
#      }
#      $prevfile = $_;
#  }
#  close(CMD);


#  # եκ
#  ## SMB ϥޥȤŸͤѹʤΤǺʤ褦ˤ 2002.5.24 kima
#  #if ($backupmode eq "SMB" || $backupmode eq "FTP") {
#  if ($backupmode eq "FTP") {
#      chdir("$backup_dir");   ## wbmc03-B12
#      unlink("$restorefile");
#  }

#  #000919 add start
#  if ($item eq "mail") {
#    if (!&mail_service_start(@service_state)) {
#      $errflag = 1;
#      print "<FONT COLOR=red>Service start (crrond/sendmail/popd/imapd) failed...</FONT><BR>\n";
#    }
#  }
#  #000919 add stop

#  # ᡼󥰥ꥹбå
#  if ($item eq "fml") {
#  # &unlockFml($lockfmlfile);
#    &unlockDomainFml($lockfmlfile);
#  }

#  if ($errflag) {
#      print "<A HREF=\"./restore.cgi?$item+$backupmode\">[BACK]</A>\n";
#  } else {
#      print "<SCRIPT>\n";
#      if ($?) {
#          print "location.href='./restore_error.cgi?$item+$backupmode';\n";
#      } else {
#          print "location.href='./restore_done.cgi?$item+$backupmode';\n";
#      }
#      print "</SCRIPT>\n";
#  }


#  print "</BODY>\n";
#  print "</HTML>\n";
#  #-----------------------------------------------------

#  sub mail_service_stop
#  {
#    local(*service_state) = @_;
#    local($ret,$i,@service);

#    $ret = 1;
#    # sendmail -> popd -> imapd -> cron
#    @service = ('crond', 'sendmail', 'popd', 'imapd');
#    for ($i=0;$i<@service;$i++) {
#      open(IN, "/etc/rc.d/init.d/$service[$i] status |");
#      while (<IN>) {
#          s/[\r\n]*$//;
#        if (/is running/) {
#          $service_state[$i] = "on";
#          # ưߤ
#          if (system("/etc/rc.d/init.d/$service[$i] stop > /dev/null") != 0) {
#            $ret = 0;
#          }
#        }
#      }
#      close(IN);
#    }
#    return $ret;
#  }

#  #000919 add start
#  sub mail_service_start
#  {
#    local(@service_state) = @_;
#    local($rtn,$i,@service);

#    $rtn = 1;
#    # sendmail -> popd -> imapd -> cron
#    @service = ('crond', 'sendmail', 'popd', 'imapd');
#    for ($i=0;$i<@service;$i++) {
#      if ($service_state[$i] eq "on") {
#        if (system("/etc/rc.d/init.d/$service[$i] start > /dev/null") != 0) {
#          $rtn = 0;
#        }
#      }
#    }
#    return $rtn;
#  }
#  #000919 add stop

#  sub sigexit
#  {
#      kill(9, -$$);
#      exit(1);
#  }

