## obNAbvt@CΉ 2002.5.24 kima
## wbmc/adm/sysyem/backup/restore.cgi
## wbmc/bin/wbmc_backup
##  require ĂB

use POSIX qw(strftime); # for strftime();

# smbmount pfBNg
$date_str = strftime("%Y%m%d%H%M%S", localtime);
$backup_dir_smbmnt = "/mnt/_tmp_smbmnt.$date_str.$$";
# split
$split_size = 2 * 1024 * 1024 * 1024 -1;
$split_cmd = "/usr/bin/split --bytes=${split_size} ";
$split_postfix = '._split_';

sub collect_backup_files {
  my ($dir, $base_file) = @_;
  opendir(DIRH, $dir) || return -1;
  my @files = grep(/^$base_file\Q$split_postfix\E*/, readdir(DIRH));
  closedir(DIRH);
#  print "\n>>collect!\n";
#  print join("\n", @files);
#  print "<<collect!\n";
  return @files;
}

sub remove_old_bakcup {
  my ($dir, $base_file) = @_;
  unlink("$dir/$base_file");
  my @files = &collect_backup_files($dir, $base_file);
  my $file;
  foreach $file (@files) {
    unlink("$dir/$file");
  }
}

sub chmod_backup_files {
  my ($mode, $dir, $base_file) = @_;
  print "chmod_backup_files : $dir/$base_file\n";
  chmod($mode, "$dir/$base_file");
  my @files = &collect_backup_files($dir, $base_file);
  my $file;
  my $error_flag = 0;
  foreach $file (@files) {
    print "chmod_backup_files : $dir/$file\n";
    if(!chmod($mode, "$dir/$file")) {
      $error_flag = 1;
    }
  }
  return $error_flag;
}

sub getValue {
	local($str) = @_;

	$str =~ s/^[\s]*//;
	$str =~ s/[\s]*$//;
	if ($str =~ /^"(.*)"$/) {
		$str = $1;
	}

	return($str);
}

1;
