#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: tape_main.cgi,v 1.3 2003/03/14 07:44:25 snavi Exp $

##001205 v5.1 ťХåå׳ǧб(wbmc03-B21) Hori
##001205 v5.1 åܥåΥǥ(wbmc03-B22) Hori
##010426 v4.0.1 饹б or ǽ	Hori
##010705 v4.1.1 塼Хååб	Hori
##030314 v5.1 GuardianWallΥб oyama

require "../../../lib/wbmc.pl";
require "./date.pl"; # 030314 add

$conf_file = "$WBMC_CONF_DIR/backup.conf";
$conf_lock = "backup.conf";

# ơץХåå׵ǽե
$tape_backup_conf = "$WBMC_CONF_DIR/tape_backup.conf";
$tape_backup_conf_lock = "tape_backup.conf";

# ơץǥХ̾
$tape_dev_default = "/dev/nst0";

$cluster_type = &cluster_typechk();			# 010426 add
$cluster_master = &cluster_masterchk();		# 010426 add

# ơץǥХ̾
$tape_dev = "";
@tape_conf = ();
if (-f $tape_backup_conf) {
    if (!&readFile($tape_backup_conf, $tape_backup_conf_lock, *tape_conf)) {
        &showErrorPage("ơեɤ߹ߤ˼Ԥޤ");
        exit(1);
    }
}

# app 4.1 rep kokokara 
$item_flag = 0;
@item_list = ();
$hour = 0;
$min = 0;
for ($i = 0; $i < @tape_conf; $i++) {
	if ($tape_conf[$i] =~ /\s*#/) {
		next;
	}
	if ($item_flag == 0) {
		if ($tape_conf[$i] =~ /^(.*)\s*{\s*$/) {
			$item_flag = 1;
			$tmp = $1;
			$tmp =~ s/^\s*//;
			$tmp =~ s/\s*$//;
			push(@item_list, $tmp);
		}
		if ($tape_conf[$i] =~ /^\s*DEVICE\s*=\s*(.*)\s*$/) {
			$tape_dev = $1;
		}
		if ($tape_conf[$i] =~ /^\s*PERIOD\s*=\s*(.*)\s*$/) {
			$period = $1;
		}
		if ($tape_conf[$i] =~ /^\s*WEEK\s*=\s*(.*)\s*$/) {
			$week = $1;
		}
		if ($tape_conf[$i] =~ /^\s*MONTHDAY\s*=\s*(.*)\s*$/) {
			$monthday = $1;
		}
		if ($tape_conf[$i] =~ /^\s*HOUR\s*=\s*(.*)\s*$/) {
			$hour = $1;
		}
		if ($tape_conf[$i] =~ /^\s*MIN\s*=\s*(.*)\s*$/) {
			$min = $1;
		}
	} else {
		if ($tape_conf[$i] =~ /^\s*}\s*$/) {
			$item_flag = 0;
		}
	}
}
# app 4.1 rep kokomade

if ($tape_dev eq "") {
    $tape_dev = $tape_dev_default;
}

# Хååץƥɽѡ
$table = "";

@conf = ();
if (-f $conf_file) {
    if (!&readFile($conf_file, $conf_lock, *conf)) {
        &showErrorPage("Хååեɤ߹ߤ˼Ԥޤ");
        exit(1);
    }
}

$item_flag = 0;
$j = 0;
$backuplist = 0;		# wbmc03-B22
for ($i = 0; $i < @conf; $i++) {

    if ($conf[$i] =~ /\s*#/) {
        next;
    }

    if ($conf[$i] =~ /^(.*)\s*{\s*$/) {
        $item_flag = 1;
        $item = $1;
		$item =~ s/^\s*//;
		$item =~ s/\s*$//;

        $name = "";
        $target = "";
        $backup = "";

    }

    if ($item_flag && $conf[$i] =~ /^\s*}\s*$/) {
        $item_flag = 0;

        #-----------------------------------------------------------------
        if ($WBMC_MACHINE_TYPE eq "web") {
            if ($item eq "mail" || $item eq "fml") {
                next;
            }
        }
        #-----------------------------------------------------------------
		# 010426 kokokara
		# ե륪Х饹ǥޥ(롼׵ư)¦Τɽ
		if ($cluster_type eq "cluster" && $cluster_master eq "slave") {
			if ($item eq "home" || $item eq "mail" || $item eq "fml") {
				next;
			}
		}
		# 010426 kokomade
		# 030314 kokokara
                if (system("/bin/rpm -q $GuardianWall_rpm > /dev/null")){
                        if ($item eq "GW_backup"){
                                next;
                        }
                }
		# 030314 kokomade

        $i_name = "backup" . $j;
        $j++;
		$backuplist++;		# wbmc03-B22

	# app 4.1 rep kokokara
		$chk = "";
		for ($k = 0; $k < @item_list; $k++) {
			if ($item eq $item_list[$k]) {
				$chk = "CHECKED";
				last;
			}
		}

	# wbmc03-B21 kokokara update
		if ($item eq "conf" || $item eq "home" || $item eq "mail" || $item eq "fml") {
	        $table .= "<DD><INPUT TYPE=checkbox NAME=$i_name VALUE=$item $chk>$name</DD>";
		} else {
	        $table .= "<DT><INPUT TYPE=checkbox NAME=$i_name VALUE=$item $chk>$name</DT>";
		}
	# wbmc03-B21 kokomade update
	# app 4.1 rep kokomade
    }

    if ($item_flag && $conf[$i] =~ /^\s*NAME\s*=\s*(.*)\s*$/) {
        $name = $1;
    }
    if ($item_flag && $conf[$i] =~ /^\s*TARGET\s*=\s*(.*)\s*$/) {
        $target = $1;
    }
    if ($item_flag && $conf[$i] =~ /^\s*BACKUP\s*=\s*(.*)\s*$/) {
        $backup = $1;
    }

}

# app 4.1 kokokara
# 塼
# 饸ܥ档
if ($period =~ /^\s*DAILY\s*$/i) {
    $dailychk = "CHECKED";
} elsif ($period =~ /^\s*WEEKLY\s*$/i) {
    $weeklychk = "CHECKED";
} elsif ($period =~ /^\s*MONTHLY\s*$/i) {
    $monthlychk = "CHECKED";
} else {
    $nobackupchk = "CHECKED";
}

# 
if ($week =~ /^\s*SUN\s*$/i) {
    $sunchk = "SELECTED";
} elsif ($week =~ /^\s*MON\s*$/i) {
    $monchk = "SELECTED";
} elsif ($week =~ /^\s*TUE\s*$/i) {
    $tuechk = "SELECTED";
} elsif ($week =~ /^\s*WED\s*$/i) {
    $wedchk = "SELECTED";
} elsif ($week =~ /^\s*THU\s*$/i) {
    $thuchk = "SELECTED";
} elsif ($week =~ /^\s*FRI\s*$/i) {
    $frichk = "SELECTED";
} elsif ($week =~ /^\s*SAT\s*$/i) {
    $satchk = "SELECTED";
}
# app 4.1 kokomade

$navibar = &getNavigation(
    "ƥ", "../system.cgi",
    "Хåå/ꥹȥ", "./main.cgi",
    "ơץХåå", "",
    "_back", "./main.cgi",
    "_help", "tape_main_help.cgi"
    );
#---------------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>ơץХåå</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function execute1(backupcnt,type) {
	sysconf_flg = 0;
	other_flg = 0;
	msg = "";
	cnt = 0;
	b_cnt = 0;
	while(b_cnt < backupcnt) {
		chk =document.BACKUP.elements[cnt].checked;
		val =document.BACKUP.elements[cnt].value;
		cname=document.BACKUP.elements[cnt].name;
		bname = "backup" + b_cnt;
		cnt++;
		if (cname != bname) {
			continue;
		}
		b_cnt++;
		if (chk == true) {
			switch (val) {
			case "sysconf":
				sysconf_flg = 1;
				break;
			case "conf":
			case "home":
			case "mail":
			case "fml":
				other_flg = 1;
				break;
			}
		}
	}

	schedule = "NO";
	for(i = 0; i < document.BACKUP.SCHEDULE.length; i++) {
		if(document.BACKUP.SCHEDULE[i].checked) {
			schedule = document.BACKUP.SCHEDULE[i].value;
			break;
		}
	}

	msgdef = "";
	if (sysconf_flg == 1 && other_flg == 1) {
		msgdef = "\\nޤ";
		msg = "ƱƤŤ˥ХååפޤǤ";
	}
	if (type == "set") {
	    if (msg && schedule != "NO") {
			if (window.confirm(msg)) {
			} else {
				return;
			}
	    }
		document.BACKUP.SET_TYPE.value = "SETTING";
		document.BACKUP.submit();
	} else {
	    if (window.confirm("ơץХååפ¹ԤޤǤ" + msgdef + msg)) {
	        document.BACKUP.SET_TYPE.value = "EXEC";
	        document.BACKUP.submit();
	    }
	}
}

// -->
</SCRIPT>
</HEAD>
<BODY>

<H4 ALIGN=center>ơץХåå</H4>
<HR>
$navibar
<HR>

<CENTER>
<FORM METHOD="POST" NAME="BACKUP" ACTION="./tape_backup.cgi?$j">

<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH=480>
 <TR BGCOLOR="#000080">
  <TD><FONT COLOR="#FFFFFF"><B> ơץǥХ</B></FONT></TD>
 </TR ALIGN=center>
 <TR>
  <TD>
   <TABLE>
   <DT><B>ǥХ̾</B>
    <DD><INPUT TYPE=text NAME='DEV_NAME' VALUE=$tape_dev></DD>
   </DT>
   <TD  WIDTH=480 ALIGN="center">
     <INPUT TYPE=button VALUE="" onClick=execute1($backuplist,"set")>
   </TD>
   </TABLE>
  </TD>
 </TR>
</TABLE>

<P>

<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH=480>
 <TR BGCOLOR="#000080">
  <TD><FONT COLOR="#FFFFFF"><B> Хåå</B></FONT></TD>
 </TR ALIGN=center>

 <TR>
  <TD>

   <TABLE>
    <TR>
     <TD><B>塼롧</B></TD>
     <TD><INPUT TYPE=radio NAME="SCHEDULE" VALUE="DAILY" $dailychk></TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD><INPUT TYPE=radio NAME="SCHEDULE" VALUE="WEEKLY" $weeklychk>轵
      <SELECT NAME="WEEK">
       <OPTION VALUE="SUN" $sunchk>
       <OPTION VALUE="MON" $monchk>
       <OPTION VALUE="TUE" $tuechk>
       <OPTION VALUE="WED" $wedchk>
       <OPTION VALUE="THU" $thuchk>
       <OPTION VALUE="FRI" $frichk>
       <OPTION VALUE="SAT" $satchk>
      </SELECT>
     </TD>
    </TR>
    <TR>
     <TD><BR></TD>
     <TD><INPUT TYPE=radio NAME="SCHEDULE" VALUE="MONTHLY" $monthlychk>
     <INPUT TYPE=text SIZE=4 NAME="DAY" VALUE="$monthday">
     </TD>
    </TR>
    <TR> 
     <TD><BR></TD>
     <TD><INPUT TYPE=radio NAME="SCHEDULE" VALUE="NO" $nobackupchk>Хååפʤ</TD>
    </TR>
    <TR>
     <TD><B></B></TD>
     <TD><INPUT TYPE=text SIZE=4 VALUE="$hour" NAME="HOUR"><INPUT SIZE=4 TYPE=text VALUE="$min" NAME="MIN">ʬ˥Хåå</TD>
    </TR>
    <TD><INPUT TYPE=hidden NAME="HOUR_OLD" VALUE="$hour"></TD>
    <TD><INPUT TYPE=hidden NAME="MIN_OLD" VALUE="$min"></TD>
   </TABLE>

   <TABLE>
    <TR>
     <TD>
      <DL>
       <DT><B>Хååо</B>
        <DL>
$table
        </DL>
       </DT>
       <P>
      </DL>
     </TD>
    </TR>
    <TR><TD><INPUT TYPE=hidden NAME='SET_TYPE'></TD></TR>
    <TR>
     <TD WIDTH=480 ALIGN="center">
        <INPUT TYPE=button VALUE="" onClick=execute1($backuplist,"set")>
        <INPUT TYPE=button VALUE="¨¹" onClick=execute1($backuplist,"exec")>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>
</FORM>

</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#---------------------------------------------------------------------

