#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: logset.cgi,v 1.2 2002/09/24 06:11:50 snavi Exp $


#
#
# 
#
#


$logrotate_d = "/etc/logrotate.d";
$service_lock = "logrotate.d";

require "../../../lib/wbmc.pl";
require "./log_file_list.pl";

&readParam();

$dailyflag = 0;
$weeklyflag = 0;
$monthlyflag = 0;
$sizeflag = 0;
$rotateflag = 0;
$generationflag = 0;
$norotate = 0;					## 010528 add
#
# å
#
if (@ARGV < 2) {
	exit(1);
}

#
# ӥ̾μ
#
$servicename = $ARGV[0];
$servicename =~ s/\\(.)/$1/g;

#
# ե̾ǥ쥯ȥ̾μ
#
$log = $ARGV[1];
$log =~ s/\\(.)/$1/g;
$sectionname = $log;
$log =~ s/[\/]/ /g;
#@log_tmp = split(/ /, $log);		## 010528 del ̤

$logname = "$servicename:$sectionname";
if (defined($logent{$logname})) {
	$logname = $logent{$logname};
} else {
	if ($servicename eq "apache") {
		@servername = split(/log\./, $sectionname);
		$logname = "$servicename:$servername[0]";
		$logname .= "log";
		if (defined($logent{$logname})) {
			$logname = $logent{$logname};
		$logname .= "$servername[1]";
		}
	}
}

## 010528 add kokokara
#
#
# ơ/δ(/etc/logrotate.conf)
#
#
if (!&readFile("/etc/logrotate.conf", "logrotate.conf", *file)) {
	&showErrorPage("ơե(/etc/logrotate.conf)ɤ߹ߤ˼Ԥޤ");
	exit(1);
}
$secflag = 0;
$default_type = "";
$default_rotate = "";
for ($i = 0; $i < @file; $i++) {
	$file[$i] =~ s/\s*$//;
	$file[$i] =~ s/^\s*//;
	if ($file[$i] =~ /^#/) {
		next;
	}
	if ($file[$i] =~ /{/) {
		$secflag = 1;
	} elsif ($file[$i] =~ /}/) {
		$secflag = 0;
	} elsif ($secflag == 0 && $file[$i] =~ /^rotate\s(.*)$/) {
		$default_rotate = $1;
	} elsif ($secflag == 0 && $file[$i] =~ /^daily$/) {
		$default_type = "daily";
	} elsif ($secflag == 0 && $file[$i] =~ /^weekly$/) {
		$default_type = "weekly";
	} elsif ($secflag == 0 && $file[$i] =~ /^monthly$/) {
		$default_type = "monthly";
	} elsif ($secflag == 0 && $file[$i] =~ /^size\s*=\s*(.*)$/) {
		$default_type = "size";
		$default_size = $1;
		$default_size =~ s/K/k/;
		$default_size =~ s/m/M/;
	}
}
## 010528 add kokomade

if (!&readFile("$logrotate_d/$servicename", $service_lock, *file)) {
	&showErrorPage("$logrotate_d/$servicenameɤ߹ߤ˼Ԥޤ");
	exit(1);
}

$secflag = 0;
$postrotateflag = 0;										## 010528 add
$errflag = 0;												## 010528 add
for($i = 0; $i < @file; $i++) {
	$file[$i] =~ s/\s*$//;
	$file[$i] =~ s/^\s*//;
#	if ($file[$i] =~ /^#/) {								## 010528 del
#		next;												## 010528 del
#	}														## 010528 del
	if ($file[$i] =~ /^(|##WbMC#\s*)}$/) {					## 010528 rep
		if ($secflag) {
			if ($file[$i] =~ /^##WbMC#/) {					## 010528 add
				$norotate = 1;								## 010528 add
			}												## 010528 add
			last;
		}
	}
	if ($file[$i] =~ /^(|##WbMC#\s*)\Q$sectionname\E\s*{/) {	## 010528 rep
		$secflag = 1;
	}

	if ($secflag && $file[$i] =~ /^daily$/) {
		if ($postrotateflag == 0) {							## 010528 add
			$dailyflag = 1;
			$rotateflag = 1;
		} else {											## 010528 add
			$errflag = 1;									## 010528 add
		}
	}
	if ($secflag && $file[$i] =~ /^weekly$/) {
		if ($postrotateflag == 0) {							## 010528 add
			$weeklyflag = 1;
			$rotateflag = 1;
		} else {											## 010528 add
			$errflag = 1;									## 010528 add
		}
	}
	if ($secflag && $file[$i] =~ /^monthly$/) {
		if ($postrotateflag == 0) {							## 010528 add
			$monthlyflag = 1;
			$rotateflag = 1;
		} else {											## 010528 add
			$errflag = 1;									## 010528 add
		}
	}
	if ($secflag && $file[$i] =~ /^size/) {
		if ($postrotateflag == 0) {							## 010528 add
			@tmp = split(/=/,$file[$i]);					## 010528 rep
			$tmp[1] =~ s/\s//g;								## 010528 add
			$size = $tmp[1];

			$sizeflag = 1;
			$rotateflag = 1;
		} else {											## 010528 add
			$errflag = 1;									## 010528 add
		}
	}
	if ($secflag && $file[$i] =~ /^rotate\s*(.*)/) {		## 010528 rep
		if ($postrotateflag == 0) {							## 010528 add
#			@tmp = split(/\s+/, $file[$i]);					## 010528 del
#			$generation = $tmp[1];							## 010528 del
			$generation = $1;								## 010528 add

			$generationflag = 1;
		} else {											## 010528 add
			$errflag = 1;									## 010528 add
		}
	}

	if ($secflag && $file[$i] =~ /^postrotate$/) {			## 010528 add
		$postrotateflag = 1;								## 010528 add
	}														## 010528 add
	if ($secflag && $file[$i] =~ /^endscript$/) {			## 010528 add
		$postrotateflag = 0;								## 010528 add
	}														## 010528 add
}
## 010528 add kokokara
# ơȴ
if ($errflag == 1) {
	if ($default_type eq "daily") {
		$dailyflag = 1;
		$rotateflag = 1;
	} elsif ($default_type eq "weekly") {
		$weeklyflag = 1;
		$rotateflag = 1;
	} elsif ($default_type eq "monthly") {
		$monthlyflag = 1;
		$rotateflag = 1;
	} elsif ($default_type eq "size") {
		$size = $default_size;
		$sizeflag = 1;
		$rotateflag = 1;
	} else {
		$rotateflag = 0;
	}
	$generationflag = 1;
	$generation = $default_rotate;
} elsif ($norotate == 0 && $sizeflag == 0 && $rotateflag == 0) {
	if ($sizeflag == 0 && $default_type eq "size") {
		$size = $default_size;
		$sizeflag = 1;
		$rotateflag = 1;
	} elsif ($rotateflag == 0 && $default_type eq "daily") {
		$dailyflag = 1;
		$rotateflag = 1;
	} elsif ($rotateflag == 0 && $default_type eq "weekly") {
		$weeklyflag = 1;
		$rotateflag = 1;
	} elsif ($rotateflag == 0 && $default_type eq "monthly") {
		$monthlyflag = 1;
		$rotateflag = 1;
	}
	$generationflag = 1;
	$generation = $default_rotate;
}
## 010528 add kokomade

#
# ӥ
#
$webservice = "<TR><TD COLSPAN=3>ե롧$logname</TD>\n"
	. "</TR>\n";

#
# ơ
#
$webrotate = "<TR>"
	. "<TD>ơȡ</TD>\n";
if ($rotateflag == 1 && (($dailyflag) || ($weeklyflag) || ($monthlyflag))) {
	$webrotate .= "<TD COLSPAN=2>"
	. "<INPUT TYPE=\"radio\" NAME=\"ROTATE\" VALUE=\"PERIOD\" CHECKED>"
	. "ǹԤ</TD>\n";
} else {
	$webrotate .= "<TD COLSPAN=2>"
	. "<INPUT TYPE=\"radio\" NAME=\"ROTATE\" VALUE=\"PERIOD\">"
	. "ǹԤ</TD>\n";
}
$webrotate .= "</TD>\n"
	. "</TR>\n"
	. "<TR>"
	. "<TD><BR></TD>"
	. "<TD><BR></TD>";
if ($dailyflag == 1) {
	$webrotate .= "<TD><INPUT TYPE=\"radio\" NAME=\"TERM\" "
	. "VALUE=\"DAILY\" CHECKED>\n";
} else {
	$webrotate .= "<TD><INPUT TYPE=\"radio\" NAME=\"TERM\" "
	. "VALUE=\"DAILY\" >\n";
}
if ($weeklyflag == 1) {
	$webrotate .= "<INPUT TYPE=\"radio\" NAME=\"TERM\" "
	. "VALUE=\"WEEKLY\" CHECKED>轵\n";
} else {
	$webrotate .= "<INPUT TYPE=\"radio\" NAME=\"TERM\" "
	. "VALUE=\"WEEKLY\" >轵\n";
}
if ($monthlyflag == 1) {
	$webrotate .= "<INPUT TYPE=\"radio\" NAME=\"TERM\" "
	. "VALUE=\"MONTHLY\" CHECKED>\n";
} else {
	$webrotate .= "<INPUT TYPE=\"radio\" NAME=\"TERM\" "
	. "VALUE=\"MONTHLY\" >\n";
}
$webrotate .= "</TD></TR>\n";

#
# 
#
if ($sizeflag == 1) {
	$size =~ s/\s+//g;
	if ($size =~ /k$/i) {
		$size =~ s/k//i;
		$sizetype = 1;
	} elsif ($size =~ /m$/i) {
		$size =~ s/m//i;
		$sizetype = 2;
	} else {
		$sizetype = 0;
	}
}

$websize = "<TR>"
	. "<TD><BR></TD>"
	. "<TD COLSPAN=2>";

if ($sizeflag == 1) {
	$websize .= "<INPUT TYPE=\"radio\" NAME=\"ROTATE\" "
	. "VALUE=\"SIZE\" CHECKED>"
		. "ե륵ǹԤ</TD>\n";
} else {
	$websize .= "<INPUT TYPE=\"radio\" NAME=\"ROTATE\" "
	. "VALUE=\"SIZE\">"
		. "ե륵ǹԤ</TD>\n";
}
$websize .= "</TR>\n"
	. "<TR>\n"
	. "<TD><BR></TD>\n"
	. "<TD><BR></TD>\n";

if ($sizeflag == 1) {
	$websize .= "<TD><INPUT TYPE=\"text\" NAME=\"SIZE\" "
		. "SIZE=15 VALUE=\"$size\">";
} else {
	$websize .= "<TD><INPUT TYPE=\"text\" NAME=\"SIZE\" "
		. "SIZE=15 VALUE=\"\">";
}
$websize .= "<SELECT NAME=\"BYTE\">";

if ($sizetype == 1) {
	$websize .= "<OPTION VALUE=\"B\">byte \n"
		. "<OPTION VALUE=\"K\" SELECTED>kbyte \n"
		. "<OPTION VALUE=\"M\">Mbyte \n";
} elsif ($sizetype == 2) {
	$websize .= "<OPTION VALUE=\"B\">byte \n"
		. "<OPTION VALUE=\"K\">kbyte \n"
		. "<OPTION VALUE=\"M\" SELECTED>Mbyte \n";
} elsif ($sizetype == 0) {
	$websize .= "<OPTION VALUE=\"B\" SELECTED>byte \n"
		. "<OPTION VALUE=\"K\">kbyte \n"
		. "<OPTION VALUE=\"M\">Mbyte \n";
}


$websize .= "</SELECT>"
	. "</TD></TR>\n";

#
# ơȤʤ
#
$webnorotate = "<TR>"
	. "<TD><BR></TD>";
if ($rotateflag == 0) {
	$webnorotate .= "<TD COLSPAN=2>"
		. "<INPUT TYPE=\"radio\" NAME=\"ROTATE\" "
		. "VALUE=\"NOROTATE\" CHECKED>"
		. "ơȤʤ</TD>\n";
} else {
	$webnorotate .= "<TD COLSPAN=2>"
		. "<INPUT TYPE=\"radio\" NAME=\"ROTATE\" "
		. "VALUE=\"NOROTATE\" >"
		. "ơȤʤ</TD>\n";
}
$webnorotate .= "</TR>\n";

#
# 
#
$webgeneration = "<TR>\n"
	. "<TD>塧</TD>\n";
if ($generationflag == 1) {
	$webgeneration .= "<TD><INPUT TYPE=\"text\" SIZE=5 "
		. "NAME=\"GEN\" VALUE=\"$generation\"></TD>\n";
} else {
	$webgeneration .= "<TD><INPUT TYPE=\"text\" SIZE=5 "
		. "NAME=\"GEN\" VALUE=\"\"></TD>\n";
}
$webgeneration .= "<TD><BR></TD>\n"
	. "</TR>\n";

$submit = "<INPUT TYPE=\"button\" VALUE=\"\" "
##	. "onClick=\"func('$servicename', '$sectionname')\">";
 	. "onClick=\"func('$servicename', '$sectionname' , '$generation')\">";	##010703 mod fukuyama

$navibar = &getNavigation(
	"ƥ","../system.cgi",
	"","log.cgi",
	"","",
	"_back","log.cgi",
	"_help","logset_help.html"
	);
#----------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<TITLE></TITLE>

<SCRIPT LANGUAGE="JavaScript">
<!--
//	function func(arg1, arg2) {
	function func(arg1, arg2, arg3) {		/* 010703 mod fukuyama */
// 010703 add kokokara  fukuyama
		gen = Number (document.FORM1.GEN.value);
		if (!isNaN(gen) && gen < arg3) {
			if (window.confirm("夬ʤͤѹޤ\\nꤵ줿ͤŤեޤǤ\\n\\n[OK]ܥ򲡲硢եκԤꤵޤ\\n[󥻥]ܥ򲡲硢եκԤ鷺ꤵޤ")) {
				document.FORM1.ARG3.value = "delete";
			} else {
				document.FORM1.ARG3.value = "";
			}
		}
// 010703 add kokomade  fukuyama
		document.FORM1.ARG1.value = arg1;
		document.FORM1.ARG2.value = arg2;
		document.FORM1.submit();
	}
// -->
</SCRIPT>
</HEAD>

<BODY>

<FORM NAME="FORM1" METHOD="POST" ACTION="logset2.cgi">
<INPUT TYPE="hidden" NAME="ARG2">
<INPUT TYPE="hidden" NAME="ARG1">
<INPUT TYPE="hidden" NAME="ARG3">	<!--- 010703 add  fukuyama --->


<H4 ALIGN=center></H4>
<HR>
$navibar
<HR>

<CENTER>
<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1>
 <TR BGCOLOR="#000080">
  <TD><FONT COLOR="#FFFFFF"> <B></B></FONT></TD>
 </TR>
 <TR>
  <TD>
   <TABLE>

	$webservice

	$webrotate

	$websize

	$webnorotate

	$webgeneration

	<TR>
	 <TD COLSPAN=3 ALIGN="center">
	  $submit
	 </TD>
	</TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>

</FORM>
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>

END_OF_DATA
#=---------
