#!/usr/bin/perl
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: basic.cgi,v 1.1.1.1 2002/09/09 07:43:33 snavi Exp $

##000822 v4.1 6Ǥ꥽ɲ  Hori
##000822 v4.1 require -> Хѥѹ  Hori
##010228 v4.0.1 NN(v4.7)ǥ顼β̤ܥ󲡲б  fukuyama

require "../../../lib/wbmc.pl";

$network_file = "/etc/sysconfig/network";
$network_lock = "network";
$resolv_file = "/etc/resolv.conf";
$resolv_lock = "resolv.conf";

&readParam();

$cnt = 0;
$host_check = 0; 
$domain_check = 0; 

$hostname = $FORM{'HOST_NAME'};
$primary_domain = $FORM{'PRIMARY_DNS'};
$secondary_domain = $FORM{'SECONDARY_DNS'};
$gateway = $FORM{'GATEWAY'};
$gatewaydev = $FORM{'GATEWAYDEV'};

if ($hostname =~ /^\s*$/) {
    &showErrorPage("ۥ̾ϤƲ","./index.cgi");
    exit(1);
}

# ۥ̾FQDN
if (!&checkLongHostName($hostname)) {
    &showErrorPage("ۥ̾FQDNǻꤷƲ","./index.cgi");
    exit(1);
}

# ۥ̾ȥɥᥤ̾ʬΥ
$hostname_tmp = $hostname;
@ent = split(/\./, $hostname_tmp);
if ($#ent >= 1) {
    $domainname = $ent[1];
}
for($i = 2; $i < @ent; $i++) {
    $domainname .= ".".$ent[$i];
}

if ($domainname =~ /^\s*$/) {
    &showErrorPage("ۥ̾FQDNǻꤷƲ","./index.cgi");
    exit(1);
}

if ($gateway !~ /^\s*$/ && !&ipAddrCheck($gateway)) {
    &showErrorPage("ǥեȥȥηޤ","./index.cgi");
    exit(1);
}

if ($gatewaydev =~ /^\s*$/) {
    &showErrorPage("ȥǥХϤƤޤ","./index.cgi");
    exit(1);
}

if ($primary_domain !~ /^\s*$/ && !&ipAddrCheck($primary_domain)) {
    &showErrorPage("ץ饤ޥ͡ॵФηޤ","./index.cgi");
    exit(1);
}

if ($primary_domain =~ /^\s*$/ && $secondary_domain !~ /^\s*$/ ) {
    &showErrorPage("ץ饤ޥ͡ॵФꤷƤ","./index.cgi");
    exit(1);
}

if ($secondary_domain !~ /^\s*$/ && !&ipAddrCheck($secondary_domain)) {
    &showErrorPage("͡ॵФηޤ","./index.cgi");
    exit(1);
}

# 顼å

# ե뤬ʤк
if (-f $network_file) {
	;# exist
} else {
	system("/bin/touch $network_file");
}

if (!&readFile($network_file, $network_lock, *file)) {
    &showErrorPage("$network_file Υץ˼Ԥޤ","./index.cgi");
    exit(1);
}

# /etc/sysconfig/networkԽ

@line = ();
for (@file) {
    if (/^HOSTNAME\s*=/)  {
	$line[$cnt] = "HOSTNAME=$hostname\n";
	$host_check = 1; 
    } elsif (/^DOMAINNAME\s*=/) {
	$line[$cnt] = "DOMAINNAME=$domainname\n";
	$domain_check = 1; 
    } elsif (/^GATEWAY\s*=/) {
	$line[$cnt] = "GATEWAY=$gateway\n";
	$gateway_check = 1;
    } elsif (/^GATEWAYDEV\s*=/) {
	$line[$cnt] = "GATEWAYDEV=$gatewaydev\n";
	$gatewaydev_check = 1;
    } else {
	$line[$cnt] = $_;
    }
    $cnt++;
}

if (!$host_check && $hostname){
	$line[$cnt] = "HOSTNAME=$hostname\n";
	$cnt++;
}

if (!$domain_check && $domainname){
	$line[$cnt] = "DOMAINNAME=$domainname\n";
	$cnt++;
}

if (!$gateway_check && $gateway) {
    $line[$cnt] = "GATEWAY=$gateway\n";
    $cnt++;
}

if (!$gatewaydev_check && $gatewaydev) {
    $line[$cnt] = "GATEWAYDEV=$gatewaydev\n";
    $cnt++;
}

#ե
if(-f "$network_file.old"){
  if(system("/bin/rm -rf $network_file.old")>0){
    &showErrorPage("$network_file ˼Ԥޤ","./index.cgi");
    exit(1);
  }
}
if(system("/bin/cp -fp $network_file $network_file.old")>0){
  &showErrorPage("$network_file ˼Ԥޤ","./index.cgi");
  exit(1);
}

if (!&writeFile($network_file, $network_lock, @line)) {
    &showErrorPage("$network_fileν񤭹ߤ˼Ԥޤ","./index.cgi");
    system("/bin/mv -f $network_file.old $network_file");
    exit(1);
}

# /etc/resolv.conf 񤭤...

$cnt = 0;
$primary_check = 0; 
$secondary_check = 0; 
$domain_check = 0;

# ե뤬ʤк
if (-f $resolv_file) {
	;# exist
} else {
	system("/bin/touch $resolv_file");
}

if (!&readFile($resolv_file,$resolv_lock, *file3)) {


    &showErrorPage("/etc/resolv.confΥץ˼Ԥޤ","./index.cgi");
    system("/bin/mv -f $network_file.old $network_file");
    exit(1);
}

@line2 = ();
for ($i = 0; $i < @file3; $i++) {

    if ($file3[$i] =~ /^domain\s*/) {
	$line2[$cnt] = "domain $domainname\n";
	$domain_check = 1
    } elsif ($file3[$i] =~ /^nameserver\s*/)  {
	if ($primary_domain =~ /^\s*$/) {
	    splice(@file3, $i, 1);
	} elsif (!$primary_check) {
	    $line2[$cnt] = "nameserver $primary_domain\n";
	    $primary_check = 1; 
	}
    } elsif ($file3[$i] =~ /^nameserver\s*/) {
	if ($secondary_domain =~ /^\s*$/) {
	    splice(@file3, $i, 1);
	} elsif (!$secondary_check) {
	    $line2[$cnt] = "nameserver $secondary_domain\n";
	    $secondary_check = 1; 
	}
    } else {
	$line2[$cnt] = $_;
    }
    $cnt++;
}

if (!$domain_check && $domainname) {
	$line2[$cnt] = "domain $domainname\n";
	$cnt++
}

if (!$primary_check && $primary_domain !~ /^\s*$/){
	$line2[$cnt] = "nameserver $primary_domain\n";
	$primary_check = 1;
	$cnt++;
}

if (!$secondary_check && $secondary_domain !~ /^\s*$/){
	$line2[$cnt] = "nameserver $secondary_domain\n";
	$secondary_check = 1;
	$cnt++;
}

#ե
if(-f "$resolv_file.old"){
  if(system("/bin/rm -rf $resolv_file.old")>0){
    &showErrorPage("$resolv_file ˼Ԥޤ","./index.cgi");
    system("/bin/mv -f $network_file.old $network_file");
    exit(1);
  }
}
if(system("/bin/cp -fp $resolv_file $resolv_file.old")>0){
  &showErrorPage("$resolv_file ˼Ԥޤ","./index.cgi");
  system("/bin/mv -f $network_file.old $network_file");
  exit(1);
}
if (!&writeFile($resolv_file, $resolv_lock, @line2)) {
    &showErrorPage("$resolv_fileν񤭹ߤ˼Ԥޤ","./index.cgi");
    system("/bin/mv -f $resolv_file.old $resolv_file");
    system("/bin/mv -f $network_file.old $network_file");
    exit(1);
}

system("/bin/rm -rf $network_file.old");
system("/bin/rm -rf $resolv_file.old");

&showResultPage("ޤǥեȥȥѹϥƥκƵưͭˤʤޤ", "index.cgi");
