#!/usr/bin/perl

require "../../../lib/wbmc.pl";
require join ("/", $WBMC_BIN_DIR,"confinit.pl");

&readParam();

$hostname = $FORM{'HOST_NAME'};
$primary_domain = $FORM{'PRIMARY_DNS'};
$secondary_domain = $FORM{'SECONDARY_DNS'};
$gateway = $FORM{'GATEWAY'};
$gatewaydev = $FORM{'GATEWAYDEV'};

$network_file = "/etc/sysconfig/network";
$network_lock = "network";
$resolv_file = "/etc/resolv.conf";
$resolv_lock = "resolv.conf";

&readFile($network_file, $network_lock, *line);
$flag=0;
for(@line) {
    s/\s*$//;
    if (/^HOSTNAME\s*=\s*(.*)\s*/) {
        $old_hostname = $1;
        if($1 ne $hostname){
            $flag=1;
            $hosthtml="<tr><td align=right></td><td><font color=red>$hostname</font></td></tr>\n";
        }
    } elsif (/^GATEWAY\s*=\s*(.*)\s*/) {
        $old_gateway = $1;
        if($1 ne $gateway){
            $flag=1;
            $gatehtml="<tr><td align=right></td><td><font color=red>$gateway</font></td></tr>\n";
        }
    } elsif (/^GATEWAYDEV\s*=\s*(.*)\s*/) {
        $old_gatewaydev = $1;
        if($1 ne $gatewaydev){
            $flag=1;
            $devhtml="<tr><td align=right></td><td><font color=red>$gatewaydev</font></td></tr>\n";
        }
    }
}

&readFile($resolv_file, $resolv_lock, *line2);
for(@line2) {
    s/\s*$//;
    if (/^nameserver\s*(.*)\s*/) {
        if (!$old_primary_domain) {
            $old_primary_domain = $1;
        } elsif (!$old_secondary_domain) {
            $old_secondary_domain = $1;
        }
    }
}

if($old_primary_domain ne $primary_domain){
    $flag=1;
    $pnshtml="<tr><td align=right></td><td><font color=red>$primary_domain</font></td></tr>\n";
}
if($old_secondary_domain ne $secondary_domain){
    $flag=1;
    $snshtml="<tr><td align=right></td><td><font color=red>$secondary_domain</font></td></tr>\n";
}

if(!$flag){
    &showErrorPage("ѹ줿ܤޤ");
    exit(1);
}

if ($hostname =~ /^\s*$/) {
    &showErrorPage("ۥ̾ϤƲ");
    exit(1);
}

# ۥ̾FQDN
if (!&checkLongHostName($hostname)) {
    &showErrorPage("ۥ̾FQDNǻꤷƲ");
    exit(1);
}

&readFile("/etc/opt/nec/wbmc/domain.conf", "domain.conf", *line2);
foreach(@line2) {
    if(/^<DOMAINNAME\s+(.*?)\s*>/){
        if($1 eq $hostname && $old_hostname ne $hostname){
             &showErrorPage("Ʊ̾Υɥᥤ󤬴ϿƤޤ");
             exit(1);
        }
    }
}

# ۥ̾ȥɥᥤ̾ʬΥ
$hostname_tmp = $hostname;
@ent = split(/\./, $hostname_tmp);
if ($#ent >= 1) {
    $domainname = $ent[1];

# 010124 add start for IP/hostname change
    $shorthostname = $ent[0];
# 010124 add end for IP/hostname change
}
for($i = 2; $i < @ent; $i++) {
    $domainname .= ".".$ent[$i];
}

if ($domainname =~ /^\s*$/) {
    &showErrorPage("ۥ̾FQDNǻꤷƲ");
    exit(1);
}

if ($gateway !~ /^\s*$/ && !&ipAddrCheck($gateway)) {
    &showErrorPage("ǥեȥȥηޤ");
    exit(1);
}

if ($gatewaydev =~ /^\s*$/) {
    &showErrorPage("ȥǥХϤƤޤ");
    exit(1);
}

if ($gatewaydev !~ /^[a-zA-Z0-9]+$/) {
    &showErrorPage("ȥǥХηޤ");
    exit(1);
}

if (!-f "/etc/sysconfig/network-scripts/ifcfg-$gatewaydev") {
    &showErrorPage("ǥХ'$gatewaydev'¸ߤޤ");
    exit(1);
}

if ($primary_domain !~ /^\s*$/ && !&ipAddrCheck($primary_domain)) {
    &showErrorPage("ץ饤ޥ͡ॵФηޤ");
    exit(1);
}

if ($primary_domain =~ /^\s*$/ && $secondary_domain !~ /^\s*$/ ) {
    &showErrorPage("ץ饤ޥ͡ॵФꤷƤ");
    exit(1);
}

if ($secondary_domain !~ /^\s*$/ && !&ipAddrCheck($secondary_domain)) {
    &showErrorPage("͡ॵФηޤ");
    exit(1);
}


# ʥӥСѰ
$navibar = &getNavigation(
    "ƥ",     "../system.cgi",
    "ͥåȥ", "index.cgi",
    "", "",
    "_back",        "index.cgi",
    "_help",        "index_help.html");

#--------------------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>ͥåȥ</TITLE>
<SCRIPT>
<!--
function func() {
    return confirm("ͥåȥԤȡƥκƵư"
    + "Ԥɬפޤ\\n"
    + "ޤWebС᡼륵Сץ"
    + "ꤷƤΰꤵޤΤǤդ\\n"
    + "¹ԤƤǤ");
}
// -->
</SCRIPT>
</HEAD>
<BODY>
<H4 ALIGN=center>ͥåȥ (ǧ)</H4>
<HR>
$navibar
<HR>
<CENTER>
 <FORM METHOD="POST" ACTION="basic.cgi" onSubmit="return func()">
 <TABLE BORDER=0>
  <TR>
   <TD>

    <TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH="100%">
     <TR BGCOLOR="#000080">
      <TD><FONT COLOR="#FFFFFF"> <B></B></FONT></TD>
     </TR>
     <TR>
       <TD>
       <TABLE>
        <TR>
         <TD NOWRAP>ۥ̾</TD>
         <TD>$old_hostname
         <INPUT TYPE="hidden" NAME="HOST_NAME" VALUE="$hostname"></TD>
        </TR>
$hosthtml
        <TR>
         <TD NOWRAP>ǥեȥȥ</TD>
         <TD>$old_gateway
         <INPUT TYPE="hidden" NAME="GATEWAY" VALUE="$gateway"></TD>
        </TR>
$gatehtml
        <TR>
         <TD NOWRAP>ȥǥХ</TD>
         <TD>$old_gatewaydev
         <INPUT TYPE="hidden" NAME="GATEWAYDEV" VALUE="$gatewaydev"></TD>
        </TR>
$devhtml
        <TR>
         <TD NOWRAP>ץ饤ޥ͡ॵС</TD>
         <TD>$old_primary_domain
         <INPUT TYPE="hidden" NAME="PRIMARY_DNS" VALUE="$primary_domain"></TD>
        </TR>
$pnshtml
        <TR>
         <TD NOWRAP>͡ॵС</TD>
         <TD>$old_secondary_domain
         <INPUT TYPE="hidden" NAME="SECONDARY_DNS" VALUE="$secondary_domain"></TD>
        </TR>
$snshtml
        <TR>
         <TD COLSPAN=2 ALIGN="center">
          <INPUT TYPE="submit" VALUE="">
         </TD>
        </TR>
       </TABLE>
      </TD>
     </TR>
    </TABLE>

   </FORM>
  </CENTER>

  </TD>
 </TR>
</TABLE>

</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#--------------------------------------------------------------------------


