#!/usr/bin/perl
# Copyright (C) 2000-2002 NEC Corporation
# All Rights Reserved.

# RCS: $Id: interface.cgi,v 1.5 2002/10/19 08:57:16 snavi Exp $

##000802 v4.1 6Ǥ꥽ɲ  Hori
##000802 v4.1 require -> (./)  Hori
##000828 v4.1 COLSPAM  Hori
##001128 v5.1 󥿡եֽ Chikita

require "../../../lib/wbmc.pl";

$alias_total = 0;

$virtual_adapter = "vad";
$mode_file = "/etc/opt/nec/aft_alb";
$mode_lock = "aft_alb";

# ưּ
@up_interface = ();
open(IN, "/sbin/ifconfig |");
while (<IN>) {
    s/[\r\n]*$//;
	if (!/\s*Link encap\s*/) {
		next;
	}
    @ent = split(/\s+/);
	push(@up_interface, $ent[0]);
}
close(IN);

if (! -e $mode_file) {
    $current_mode = "NORMAL";
} else {
    if (!&readFile($mode_file, $mode_lock, *line2)) {
        &showErrorPage("$mode_fileեɤ߹ߤ˼Ԥޤ");
        exit(1);
    } else {
        for(@line2) {
            s/\s*$//;
            $current_mode = $_;
            last;
        }
    }
}

@adapters = "";

if ($current_mode eq "NORMAL") {
    while ($file = </etc/sysconfig/network-scripts/ifcfg-*>) {
        next if($file !~ /ifcfg-[a-zA-Z0-9:]+$/);
        next if($file =~ /ifcfg-$virtual_adapter.*$/);
        push (@adapters, $file);
    }
} elsif ($current_mode eq "AFT" or $current_mode eq "ALB") {
    while ($file = </etc/sysconfig/network-scripts/ifcfg-*>) {
        next if($file !~ /ifcfg-[a-zA-Z0-9:]+$/);
        next if($file =~ /ifcfg-eth.+/);
        push (@adapters, $file);
    }
}

# ͥåȥ󥿥եĴ٤
foreach $file (@adapters) {
    $mtu_flag = 0;

    $device = "";
    $netmask = "";
    $network = "";
    $broadcast = "";
    $ipaddr = "";
    $onboot = "";
    $bootproto = "";
    $mtu = "";

    @tmp = split(/\//, $file);
    $lockfile = $tmp[4];

    &readFile($file, $lockfile, *line);
    for (@line) {
        s/[\r\n]+$//;
        if (/^DEVICE\s*=\s*(.*)/) {
            $device = $1;
        } elsif (/^NETMASK\s*=\s*(.*)/) {
            $netmask = $1;
        } elsif (/^NETWORK\s*=\s*(.*)/) {
            $network = $1;
        } elsif (/^BROADCAST\s*=\s*(.*)/) {
            $broadcast = $1;
        } elsif (/^IPADDR\s*=\s*(.*)/) {
            $ipaddr = $1;
        } elsif (/^ONBOOT\s*=\s*(.*)/) {
            $onboot = $1;
        } elsif (/^BOOTPROTO\s*=\s*(.*)/) {
            $bootproto = $1;
        }
    }

    if ($device eq "") {
#    $device = "<BR>";
        next;
    }
    if ($ipaddr eq "") {
    $ipaddr = "<BR>";
    }
    if ($netmask eq "") {
    $netmask = "<BR>";
    }
    if ($broadcast eq "") {
    $broadcast = "<BR>";
    }

    open (IN, "/sbin/ifconfig -a |");

    while (<IN>) {
        next if ($mtu_flag == 0 and $_ !~ /^$device\s+/);
        if (/^$device\s+/) {
            $mtu_flag = 1;
            next;
        }
        if (/^\s+$/) {
            $mtu_flag = 0;
            next;
        }
        if ($mtu_flag == 1) {
            @mtu_line = split (/\s+/, $_);
            foreach $elm (@mtu_line) {
                if ($elm =~ /^MTU:(\d+)$/) {
                    $mtu = $1;
                    last;
                }
            }
        }
    }
    close(IN);
    if ($mtu eq "") {
        $mtu = "<BR>";
    }


	# ưּ
	$upstate = "<TH NOWRAP></TH>";
	for ($i = 0; $i < @up_interface; $i++) {
		if ($up_interface[$i] eq $device) {
			$upstate = " <TH BGCOLOR='#FFD0D0' NOWRAP><FONT COLOR='red'>ư</FONT></TH>";
		}
	}

	$e1flag=1 if ($device =~ /eth1/);
	$e2flag=1 if ($device =~ /eth2/);

	if ($device =~ /lo/) {
	    $iflist .= "<TR>"
	             . " <TD><INPUT TYPE='button' VALUE='Խ' onClick=\"func('$device')\"></TD>";
	} elsif ($device =~ /eth.:/ or $device =~ /$virtual_adapter:/) {
		$alias_total++;
		$onboot = "-";
	    $iflist .= "<TR>"
	             . " <TD><INPUT TYPE='button' VALUE='Խ' onClick=\"func('$device')\">"
	             . "     <INPUT TYPE='button' VALUE='' onClick=\"func3('$device')\"></TD>";
	} else {
		$alias_total++;
	    $iflist .= "<TR>"
	             . " <TD><INPUT TYPE='button' VALUE='Խ' onClick=\"func('$device')\"><BR>"
	             . "     <INPUT TYPE='button' VALUE='ꥢ' onClick=\"func2('$device')\"></TD>";
	}
	$iflist .= "<TD><INPUT TYPE='button' VALUE='ư' onClick=\"func4('$device','$ipaddr','$netmask','$broadcast')\"></TD>"
             . " <TD><INPUT TYPE='button' VALUE='' onClick=\"func5('$device','$ipaddr')\"></TD>"
	         . " $upstate"
	         . " <TD>$device</TD>"
	         . " <TD>$ipaddr</TD>"
	         . " <TD>$netmask</TD>"
	         . " <TD>$broadcast</TD>"
	         . " <TD>$mtu</TD>";

    if ($onboot ne "no") {
        $onboot = "yes";
    }
#    if ($onboot =~ /^\s*$/) {
#        $onboot = "no";
#    }
    $iflist .= " <TD>$onboot</TD>"
             . "</TR>\n";
}

if($e1flag!=1 and $current_mode eq "NORMAL"){
	$alias_total++;
	$device="eth1";
	$iflist .= "<TR>"
	         . " <TD><INPUT TYPE='button' VALUE='Խ' onClick=\"func('$device')\"></TD>"
	         . "<TD align=center>--</TD>"
	         . " <TD align=center>--</TD>"
	         . " <TD align=center><b>̤</b></TD>"
	         . " <TD>$device</TD>"
	         . " <TD>-----</TD>"
	         . " <TD>-----</TD>"
	         . " <TD>-----</TD>"
	         . " <TD>-----</TD>"
	         . " <TD align=center>--</TD>"
	         . "</TR>\n";
}
if($e2flag!=1 and $current_mode eq "NORMAL"){
	$alias_total++;
	$device="eth2";
	$iflist .= "<TR>"
	         . " <TD><INPUT TYPE='button' VALUE='Խ' onClick=\"func('$device')\"></TD>"
	         . "<TD align=center>--</TD>"
	         . " <TD align=center>--</TD>"
	         . " <TD align=center><b>̤</b></TD>"
	         . " <TD>$device</TD>"
	         . " <TD>-----</TD>"
	         . " <TD>-----</TD>"
	         . " <TD>-----</TD>"
	         . " <TD>-----</TD>"
	         . " <TD align=center>--</TD>"
	         . "</TR>\n";
}

$navibar = &getNavigation(
"ƥ", "../system.cgi",
"ͥåȥ", "index.cgi",
"󥿥ե", "",
"_back", "index.cgi",
"_help", "interface_help.html");

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>󥿥ե</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function func(arg1) {
    document.FORM1.DEVICE.value = arg1;
    document.FORM1.submit();
    return(false);
}
function func2(arg1) {
    document.FORM2.DEVICE.value = arg1;
    document.FORM2.ALIAS.value = $alias_total;
    document.FORM2.submit();
    return(false);
}
function func3(arg1) {
    if ( window.confirm( "󥿥ե̾" +  arg1 + "Υ󥿥եޤǤ")) {
    document.FORM3.ARG1.value = arg1;
    document.FORM3.submit();
    }
    return(false);
}
function func4(arg1,arg2,arg3,arg4) {
    document.FORM4.ARG1.value = arg1;
    document.FORM4.ARG2.value = arg2;
    document.FORM4.ARG3.value = arg3;
    document.FORM4.ARG4.value = arg4;
    document.FORM4.ARG5.value = "up";
    document.FORM4.submit();
    return(false);
}
function func5(arg1,arg2) {
    if ( window.confirm( "󥿥ե̾" +  arg1 + "Υ󥿥եߤޤǤ\\nʤ٤ƤΥ󥿥եߤ Management Console Ǥʤʤޤ\\nʤ餺ҤȤİʾΥ󥿥եưƤƤ")) {
	    document.FORM4.ARG1.value = arg1;
	    document.FORM4.ARG2.value = arg2;
	    document.FORM4.ARG3.value = "down";
	    document.FORM4.submit();
	}
    return(false);
}
// -->
</SCRIPT>
</HEAD>
<BODY>
<H4 ALIGN=center>󥿥ե</H4>
<HR>
$navibar
<HR>
<CENTER>
<TABLE BORDER=0>
 <TR>
  <TD>

   <FORM NAME="FORM1" METHOD="POST" ACTION="ifconfig.cgi">
    <INPUT TYPE="hidden" NAME="DEVICE">
   </FORM>
   <FORM>
   <TABLE BGCOLOR="#CCCCCC" BORDER=1 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
    <TR BGCOLOR="#000080">
     <TD>
      <FONT COLOR="#FFFFFF"> <B>󥿥ե</B></FONT>
     </TD>
    </TR>
    <TR BGCOLOR="#CCCCCC">
     <TD>
      <TABLE BORDER=1 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
       <TR>
        <TH></TH>
        <TH>ư</TH>
        <TH></TH>
        <TH></TH>
        <TH>󥿥ե̾</TH>
        <TH>IPɥ쥹</TH>
        <TH>֥ͥåȥޥ</TH>
        <TH>֥ɥ㥹ȥɥ쥹</TH>
        <TH>MTU</TH>
        <TH>OSưUP뤫</TH>
       </TR>
       $iflist

      </TABLE>
     </TD>
    </TR>
   </TABLE>
   </FORM>
  </TD>
 </TR>
</TABLE>

 <FORM NAME="FORM2" METHOD="POST" ACTION="if_add.cgi">
  <INPUT TYPE="hidden" NAME="DEVICE">
  <INPUT TYPE="hidden" NAME="ALIAS">
 </FORM>
 <FORM NAME="FORM3" METHOD="POST" ACTION="if_del.cgi">
  <INPUT TYPE="hidden" NAME="ARG1">
 </FORM>
 <FORM NAME="FORM4" METHOD="POST" ACTION="if_updown.cgi">
  <INPUT TYPE="hidden" NAME="ARG1">
  <INPUT TYPE="hidden" NAME="ARG2">
  <INPUT TYPE="hidden" NAME="ARG3">
  <INPUT TYPE="hidden" NAME="ARG4">
  <INPUT TYPE="hidden" NAME="ARG5">
 </FORM>

</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------

