#!/usr/bin/perl

# Copyright (C) 2002 NEC Corporation
# All Rights Reserved.

# RCS: $Id: mtu.pl,v 1.1 2002/09/26 10:05:24 snavi Exp $

require "../../../lib/wbmc.pl";

#
# ̾
#   mtu_autorun - /etc/rc.d/rc.localեMTUѹޥɲ
# 
#   mtu_autorun($device, $mtu_cmd)
# 
#   $device  ǥХ̾
#   $mtu_cmd MTUѹޥ
# 
#   ΤȤ 1
#   ԤΤȤ 0
#

sub mtu_autorun
{
    use File::Basename;

    my($device, $mtu_cmd) = @_;
    my($rc_local) = "/etc/rc.d/rc.local";
    my($rc_lock) = "rc.local";
    my(@elm) = "";
    my($cmd) = "/sbin/ifconfig";
    my($option) = "mtu";
    my($flag) = 0;

    if (!&readFile($rc_local, $rc_lock, *lines)) {
        return(0);
    }

    foreach (@lines) {
        @elm = split (/\s+/, $_);
        if ($elm[0] eq $cmd and $elm[1] eq $device and $elm[2] eq $option) {
            push (@mtu_lines, "$mtu_cmd\n");
            $flag = 1;
            next;
        }
        push (@mtu_lines, $_);
    }

    if ($flag == 0) {
        push (@mtu_lines, "$mtu_cmd\n");
    }

    if (!&writeFile($rc_local, $rc_lock, @mtu_lines)) {
        return(0);
    }

    return(1);
}

1;
