#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: sysgrubset.cgi,v 1.1 2002/10/18 04:46:30 snavi Exp $

require "../../../lib/wbmc.pl";

$grub_conf = "/boot/grub/grub.conf";
$grub_conf_lock = "grub.conf";

&readParam();

$timeout = $FORM{'TIMEOUT'};

# å
if ($timeout =~ /^\s*$/ || $timeout =~ /\D/) {
	&showErrorPage("ưԤ֤ͤϤƲ");
	exit(1);
}

# եɤ߹
if (!&readFile($grub_conf, $grub_conf_lock, *list)) {
	&showErrorPage("ե($grub_conf_lock)ɤ߹ߤ˼Ԥޤ");
	exit(1);
}
for ($i = 0; $i < @list; $i++) {
	if ($list[$i] eq "" || $list[$i] =~ /^#/) {
		next;
	}
	
	if ($list[$i] =~ /^\s*timeout\s*=\s*(.*)\s*$/) {
		$list[$i] = "timeout=$timeout\n";
	}
}

# ե񤭹
if (!&writeFile($grub_conf, $grub_conf_lock, @list)) {
	&showErrorPage("ե($grub_conf_lock)ν񤭹ߤ˼Ԥޤ");
	exit(1);
}

&showResultPage("", "./sysgrub.cgi");

