# Copyright (C) 2002 NEC Corporation
# All Rights Reserved.

# $Id: upload.pl,v 1.18 2002/10/17 14:19:23 snavi Exp $


package wbmcfileupload;

sub createUploadList {
 my ($prefix, $folder_in) = @_;
 my $path = "$prefix$folder_in";

 if(!-e $path) {
   &main::showErrorPage("\[$path\]¸ߤޤ");
   exit(1);
 }
 my $folder_url = &main::encodeUrl($folder_in);

 my $line;
 if(-d $path) {
   my $path_show = &main::encodeHtml($path);
   if ($path_show !~ /\/$/) {
     $path_show .= "/";
   }
   $line .= "<TR>";
   $line .= "<FORM ACTION=\"addfile.cgi\">";
   $line .= "<TD>";
   $line .= "<CENTER>";
   $line .= "<INPUT TYPE=\"SUBMIT\" VALUE=\"ɲ\">";
   $line .= "</CENTER>";
   $line .= "</TD>";
   $line .= "<TD>";
   $line .= "$path_show<INPUT TYPE=\"text\" SIZE=\"40\" NAME=\"NEWFILENAME\">";
   $line .= "<INPUT TYPE=\"hidden\" NAME=\"FOLDER\" VALUE=\"$folder_url\">";
   $line .= "</TD>";
   $line .= "</FORM>";
   $line .= "</TR>";
 }

 my $updir = $path;
 $updir =~ s/\/[^\/]+\/?$/\//;
 my $updir_url = $updir;
 $updir_url =~ s/^\Q$prefix\E//;
 $updir_url = &main::encodeUrl($updir_url);
 my $updir_show = &main::encodeHtml($updir);
 if($updir =~ /^\Q$prefix\E/) {
   $line .= "<TR>";
   $line .= "<TD>";
   $line .= "<CENTER>";
   $line .= "";
   $line .= "</CENTER>";
   $line .= "</TD>";
   $line .= "<TD>";
   $line .= "<a href=\"index.cgi?$updir_url\">$updir_show</a>";
   $line .= "</TD>";
   $line .= "</TR>";
 }
 if(-f $path) {
   return $line;
 }

 if(-d $path) {
   if ($path !~ /\/$/) {
     $path .= "/";
   }

   while (<$path*>) {
     my $file = $_;
     my $prefix_stripped = $file;
     $prefix_stripped =~ s/^\Q$prefix\E//;
     $file_show = &main::encodeHtml($file);
     $prefix_stripped_url = &main::encodeUrl($prefix_stripped);
     if (-d) {
       # ǥ쥯ȥ
       $line .= "<TR>";
       $line .= "<TD>";
       $line .= "<CENTER>";
       $line .= "";
       $line .= "</CENTER>";
       $line .= "</TD>";
       $line .= "<TD>";
       $line .= "<a href=\"index.cgi?$prefix_stripped_url\">$file_show/</a>";
       $line .= "</TD>";
       $line .= "</TR>";
     } else {
       # ʳ
       my $tmpname = $_;
        if (-f $tmpname) {
	 $line .= "<TR>";
	 $line .= "<FORM ACTION=\"viewfile.cgi\"><TD>";
	 $line .= "<CENTER>";
	 $line .= "<input type=\"hidden\" name=\"FILE\" value=\"$prefix_stripped_url\">";
	 $line .= "<input type=\"hidden\" name=\"FOLDER\" value=\"$folder_url\">";
	 $line .= "<input type=\"submit\" value=\"\">";
	 $line .= "</CENTER>";
	 $line .= "</TD>";
	 $line .= "<TD>";
	 $line .= "$file_show<A>";
	 $line .= "</TD></FORM>";
	 $line .= "</TR>";
       }
     }
   }
   closedir(DIR);
 }
 return $line;
}

sub dotdotClear {
  my ($path_str) = @_;
  $path_str =~ s/^\.\.\//\//g;
  $path_str =~ s/\/\.\./\//g;
  $path_str =~ s/\/\//\//g;
  return $path_str;
}

1;
