#!/usr/bin/perl

# Copyright (C) 2000-2003 NEC Corporation
# All Rights Reserved.

# RCS: $Id: adminf.pl,v 1.3 2003/03/26 04:40:49 snavi Exp $

#require "../../lib/wbmc.pl";
require join ("/", $WBMC_DOMADM_DIR, "account", "account.pl");

##==========================================================================
##  <̾>
##        getAllDomainAdmInf (ɥᥤԾؿ)
##  <>
##       /home/.wbmc/ɥᥤ̾/cur_domain.inf ե뤫
##       ٤ƤΥ桼μ塢ꤷֵѤ롣
##  <>
##       getAllDomainAdmInf($domainname,*alladminf)
##  <>
##       ($domainname) : ɥᥤ̾
##       (*alladminf)  : ɥᥤԾǼΰ(Ϣ)
##
##                       Ϣեޥå
##                        ѥ᡼̾ : ѥ᡼
##                       {'USERNAME'}  : 桼̾(@롼̾)
##                       {'CLASS'}     : YES/NO       #饹Ƚ
##                       {'ADMINF'}    : ALL/SHOW/NO  #Ծ
##                       {'USERINF'}   : ALL/SHOW/NO  #桼
##                       {'WEBSV'}     : ALL/SHOW/NO  #WEBо
##                       {'MAILSV'}    : ALL/SHOW/NO  #MAILо
##                       {'SYSTEM'}    : ALL/NO       #ƥ
##
##  <>
##        ｪλ :  ""
##        ۾ｪλ :  顼å
##           cur_domain.infե뤬¸ߤʤ()硢ｪλȤ롣
##==========================================================================
sub getAllDomainAdmInf
{
  local($domainname,*alladminf) = @_;
  local(@ent,@line) = ();
  local($i,$j)="";
  local($filename) = join("/", "/home/.wbmc/$domainname/", $ADMFILE);

  if(-f $filename){
    if(!&readFile($filename,$ADMFILE, *line)) {
      return("$filenameեɤ߹ߤ˼Ԥޤ\n");
    }

    for($i=0,$j=0;$i<@line;$i++){
      $line[$i] =~ s/^\s*//;
      $line[$i] =~ s/\s*$//;

      if($line[$i] eq "" || $line[$i] =~ /^domain_user_count:\s*/ || $line[$i] =~ /^web_user_count:\s*/){
        next;
     }

      @ent=();
      @ent = split(/\//,$line[$i]);
      $alladminf[$j]->{'USERNAME'} = "$ent[0]";
      $alladminf[$j]->{'CLASS'}    = "$ent[1]";
      $alladminf[$j]->{'ADMINF'}   = "$ent[2]";
      $alladminf[$j]->{'USERINF'}  = "$ent[3]";
      $alladminf[$j]->{'WEBSV'}    = "$ent[4]";
      $alladminf[$j]->{'MAILSV'}   = "$ent[5]";
      $alladminf[$j]->{'SYSTEM'}   = "$ent[6]";
      $j++;
    }
  }

  return("");
}


##==========================================================================
##  <̾>
##        setDomainAdmInf (ɥᥤԾؿ)
##  <>
##       /home/.wbmc/ɥᥤ̾/cur_domain.inf ե˴Ѥξꤹ롣
##       κݤWEBƥĤΥʡpasswdΥѥѹθ롣(ޥ)
##  <>
##       setDomainAdmInf($domainname,*adminf)
##  <>
##       ($domainname) : ɥᥤ̾
##       (%adminf)     : ɥᥤԾ
##  <>
##        ｪλ :  ""
##        ۾ｪλ :  顼å
##
##==========================================================================
sub setDomainAdmInf
{
  local($domainname,%adminf) = @_;
  local(@line,*adminname) = ();
  local($data) = "";
  local($filename) = join("/", "/home/.wbmc/$domainname/", $ADMFILE);

  $data = join ("/" , $adminf{'USERNAME'}
                    , $adminf{'CLASS'}
                    , $adminf{'ADMINF'}
                    , $adminf{'USERINF'}
                    , $adminf{'WEBSV'}
                    , $adminf{'MAILSV'}
                    , $adminf{'SYSTEM'} );

  if(!&readFile($filename,$ADMFILE, *line)) {
    return("$filenameեɤ߹ߤ˼Ԥޤ\n");
  }

  push(@line,"$data\n");

  if(!&writeFile($filename, $ADMFILE, @line)){
    return("$filenameեν񤭹ߤ˼Ԥޤ\n");
  }
  # Cluster(Mirroring)
  if (&cluster_typechk() eq "mirror") {
      $rc = system("/opt/nec/wbmc/bin/wbmc_mirroring &");
      if ($rc) {
        &writeLog("**** mirroring failed(useradd)", "wbmc_mirroring", "/var/log/wbmc_cluster");
        exit(1);
      }
  }

# ޥԤξ硢ɥᥤWEBƥĤ
# ʡ&passwdΥǥ쥯ȥѥѹԤʤ
  if($adminf{'CLASS'} eq "YES"){
    if(($rtn_code=&getSysAdminName(*adminname)) ne ""){
      return("$rtn_code");
    }
    if(($rtn_code = &setNewWebOwner($domainname,$username)) ne ""){
      return("$rtn_code");
    }
    if(($rtn_code = &chgLoginRoute_PasswdFile($domainname,$username,0)) ne ""){
      return("$rtn_code");
    }
  }

  return("");
}


##==========================================================================
##  <̾>
##        delDomainAdmInf (ɥᥤԾؿ)
##  <>
##       /home/.wbmc/ɥᥤ̾/cur_domain.inf ե뤫Ѥξ롣
##       κݤWEBƥĤΥʡpasswdΥѥѹθ롣(ޥ)
##  <>
##       delDomainAdmInf($domainname,$username)
##  <>
##       ($domainname) : ɥᥤ̾
##       ($username)   : 桼̾(@롼̾)
##  <>
##        ｪλ :  ""
##        ۾ｪλ :  顼å
##
##==========================================================================
sub delDomainAdmInf
{
  local($domainname,$username) = @_;
  local($i,$super_flg,$rtn_code)="";
  local(@ent,@line,*adminname) = ();
  local($filename) = join("/", "/home/.wbmc/$domainname/", $ADMFILE);

  if(!&readFile($filename,$ADMFILE, *line)) {
    return("$filenameեɤ߹ߤ˼Ԥޤ\n");
  }
  for($i=0;$i<@line;$i++){
    if($line[$i] =~ /^domain_user_count:\s*/ || $line[$i] =~ /^web_user_count:\s*/){
      next;
    }
    @ent = ();
    @ent = split(/\//,$line[$i]);

    if($username eq $ent[0]){
      if($ent[1] eq "YES"){ $super_flg=1; }
      splice(@line,$i,1);
      last;
    }
  }
  if(!&writeFile($filename, $ADMFILE, @line)){
    return("$filenameեν񤭹ߤ˼Ԥޤ\n");
  }
  # Cluster(Mirroring)
  if (&cluster_typechk() eq "mirror") {
      $rc = system("/opt/nec/wbmc/bin/wbmc_mirroring &");
      if ($rc) {
        &writeLog("**** mirroring failed(useradd)", "wbmc_mirroring", "/var/log/wbmc_cluster");
        exit(1);
      }
  }

# ޥԤ줿硢ƥԤɥᥤ
#WEBƥĤΥʡ&passwdΥǥ쥯ȥѥѹԤʤ
  if($super_flg == 1){
    if(($rtn_code=&getSysAdminName(*adminname)) ne ""){
      return("$rtn_code");
    }
    if(($rtn_code = &setNewWebOwner($domainname,$adminname{'ADMIN'})) ne ""){
      return("$rtn_code");
    }
    if(($rtn_code = &chgLoginRoute_PasswdFile($domainname,$username,1)) ne ""){
      return("$rtn_code");
    }
  }

  return("");
}


##==========================================================================
##  <̾>
##        modDomainAdmInf (ɥᥤԾԽ(ִ)ؿ)
##  <>
##       /home/.wbmc/ɥᥤ̾/cur_domain.inf եδԾѹ롣
##       κݤWEBƥĤΥʡpasswdΥѥѹθ롣(ޥ)
##  <>
##       modDomainAdmInf($domainname,$username,*adminf)
##  <>
##       ($domainname) : ɥᥤ̾
##       ($username)   : 桼̾(@롼̾)
##       (%adminf)     : ɥᥤԾ
##  <>
##        ｪλ :  ""
##        ۾ｪλ :  顼å
##
##==========================================================================
sub modDomainAdmInf
{
  local($domainname,$username,%adminf) = @_;
  local($data,$old_super,$rtn_code)="";
  local($i,$flg) = 0;
  local(@ent,@line,*adminname) = ();
  local($filename) = join("/", "/home/.wbmc/$domainname/", $ADMFILE);

  $data = join ("/" , $adminf{'USERNAME'}
                    , $adminf{'CLASS'}
                    , $adminf{'ADMINF'}
                    , $adminf{'USERINF'}
                    , $adminf{'WEBSV'}
                    , $adminf{'MAILSV'}
                    , $adminf{'SYSTEM'} );

  if(!&readFile($filename,$ADMFILE, *line)) {
    return("$filenameեɤ߹ߤ˼Ԥޤ\n");
  }
  for($i=0;$i<@line;$i++){
    if($line[$i] =~ /^domain_user_count:\s*/ || $line[$i] =~ /^web_user_count:\s*/){
      next;
    }
    @ent = ();
    @ent = split(/\//,$line[$i]);

    if($username ne "" && $username eq $ent[0]){
      $old_super = $ent[1];
      splice(@line,$i,1,"$data\n");
      $flg = 1;
      last;
    }
  }
  if(!&writeFile($filename, $ADMFILE, @line)){
    return("$filenameեν񤭹ߤ˼Ԥޤ\n");
  }
  # Cluster(Mirroring)
  if (&cluster_typechk() eq "mirror") {
      $rc = system("/opt/nec/wbmc/bin/wbmc_mirroring &");
      if ($rc) {
        &writeLog("**** mirroring failed(useradd)", "wbmc_mirroring", "/var/log/wbmc_cluster");
        exit(1);
      }
  }
  if($flg == 0){return("ѹоݥ桼¸ߤޤ\n");}


#ʲɥᥤ
#WEBƥĤΥʡ&passwdΥǥ쥯ȥѥѹԤʤ
#  ̴->ޥ ѹξ硢ޥԤ
#  ޥ->̴ ѹξ硢ƥԤ
  if(($rtn_code=&getSysAdminName(*adminname)) ne ""){
    return("$rtn_code");
  }

  if($adminf{'CLASS'} eq "YES" && $old_super eq "NO"){
    if(($rtn_code = &setNewWebOwner($domainname,$username)) ne ""){
      return("$rtn_code");
    }
    if(($rtn_code = &chgLoginRoute_PasswdFile($domainname,$username,0)) ne ""){
      return("$rtn_code");
    }
  }
  elsif($adminf{'CLASS'} eq "NO" && $old_super eq "YES"){
    if(($rtn_code = &setNewWebOwner($domainname,$adminname{'ADMIN'})) ne ""){
      return("$rtn_code");
    }
    if(($rtn_code = &chgLoginRoute_PasswdFile($domainname,$username,1)) ne ""){
      return("$rtn_code");
    }
  }
  else{
  }

  return("");
}

##==========================================================================
## ̾
##       setNewWebOwner - ɥᥤWEBϢե륪ʤꤹ
##                        碌passwdեΥǥ쥯ȥѥѹԤʤ
## 
##       setNewWebOwner($domainname,$new_username)
## 
##       $domainname     : ɥᥤ̾
##       $new_username   : ꤹ륪ʡ̾(@ޤ)
## 
##       ΤȤ : ""
##       ԤΤȤ : 顼å
## 
##   account.plΰܹԡƤʣɥᥤбǲ¤
##==========================================================================
sub setNewWebOwner
{
    local($domainname,$new_username) = @_;
    local(@dirs) = ();
    local($err, $docroot) = "";

    $docroot = &getDomainDir($domainname,"web");
    @dirs = &getFtpDirs();
    $err = &chgOwner($docroot, $new_username, @dirs);

DONE:
    return("$err");
}

##==========================================================================
#
# ʡѹоݳΥǥ쥯ȥ(桼Υۡʳ)
#
# 
#   ǥ쥯ȥ
#
# ­
# account.plܹԡ
##==========================================================================
sub getFtpDirs
{
    return(
        "bin",
        "etc",
        "ftp",
        "lib",
        "pub",
        "users",
    );
}

##==========================================================================
#
# ǥ쥯ȥ۲ˤ륪ʡѹ롣ǥ쥯ȥѤ롣
#
# 
#   $docdir     ɥȥ롼(/home/web/ɥᥤ)
#   $owner      ѹ륪ʡ
#   @elsedirs   ѹоݳΥǥ쥯ȥꡣ
#
# 
#   ""      ｪλ
#   ""ʳ  顼å
#
# ­
# account.plܹԡ ʣɥᥤб˲¤
##==========================================================================

sub chgOwner
{
  local($docdir, $owner, @elsedirs) = @_;
  local($err,$ownerid, $dir, ) = "";
  local(@files, @dirs,*docdir2) = ();
  local($i, $j, $elsedir);

  # ɥȥ롼Ȥ/ǽäƤ餽곰
  $docdir =~ s/\/*$//;

  # owner  id 
  $ownerid = (getpwnam($owner))[2];

# ɥȥ롼ȤΥʡѹ롣(-R к)
# ե륪й ɥȥ롼/home/web/domainname 
# ܥå󥯤Ǥ١ѹ
  if(-l $docdir){
    &getTruePath($docdir,*docdir2);
    $docdir2 = $docdir2[0];
    open(IN, "/bin/chown $ownerid $docdir2 2>&1 |");
  }
  else{
    open(IN, "/bin/chown $ownerid $docdir 2>&1 |");
  }
  @ans = <IN>;
  close(IN);
  if(@ans){
    $err .= "ʡѹ˼Ԥޤ<BR>@ans";
    goto done;
  }

#ɥȥ롼Ȥˤե롣
  @dirs = glob("$docdir/*");

#ե顢ѹоݳ
  $j = 0;
  OUTER: foreach $dir (@dirs) {
    foreach $elsedir (@elsedirs) {
      next OUTER if $dir eq "$docdir/$elsedir";
    }
    $files[$j++] = $dir;
  }

  # ѹоݤʤнꡣ
  if(@files < 1){
    goto done;
  }

  # ʡѹ
  open(IN, "/bin/chown -R $ownerid @files 2>&1 |");
  @ans = <IN>;
  close(IN);
  if(@ans){
    $err .= "ʡѹ˼Ԥޤ<BR>@ans";
    goto done;
  }

  # users Υʡѹ
  open(IN, "/bin/chown $ownerid $docdir/users 2>&1 |");
  @ans = <IN>;
  close(IN);
  if(@ans){
    $err .= "ʡѹ˼Ԥޤ<BR>@ans";
    goto done;
  }

done:
    return($err);
}


##==========================================================================
## ̾
##       chgLoginRoute_PasswdFile  - ɥᥤΥʡѹȼ
##                                    FTPΥ롼ȤѹԤʤ
## 
##       chgLoginRoute_PasswdFile($domainname,$username,$mode)
## 
##       $domainname     : ɥᥤ̾
##       $username       : 桼̾@ޤ)
##       $mode           : 0 -> ԤȤ
##                            /home/web/ɥᥤ̾/./users/桼̾/ftp/../
##                       : 1 -> ̥桼Ȥ
##                            /home/web/ɥᥤ̾/users/桼̾/ftp/./../
##
## 
##       ΤȤ : ""
##       ԤΤȤ : 顼å
##==========================================================================
sub chgLoginRoute_PasswdFile
{
  local($domainname,$username,$mode) = @_;
  local(@ans) = ();
  local($cmd,$short_username,$ret) = "";

  ##ѹоݥ桼¸ߤʤϤΤޤ޽λ
  if(!getpwnam($username)){
    goto done;
  }
  $short_username = $username;
  if($username =~ /@/){
    $short_username = (split(/@/,$username))[0];
  }
  ##ޥɺ
  if($mode == 0){
    $cmd = "/usr/sbin/usermod -d /home/web/$domainname/./users/$short_username/ftp/../ $username";
  }else{
    $cmd = "/usr/sbin/usermod -d /home/web/$domainname/users/$short_username/ftp/./../ $username";
  }

  ## usermodޥȯ 롼ѹ
  if(!open(IN, "$cmd 2>&1 |")) {
    return("桼μ˼Ԥޤ\n");
  }
  @ans = <IN>;
  close(IN);
  if(@ans){
    return("桼ѹǰʲΥ顼ޤϷٹȯޤ<BR>@ans");
  }
  # 20030326 passwd եƱ(writeFile()ȤäƤʤɬ)
  if (&cluster_typechk() =~  /(mirror|cluster)/ ) {
    $ret = &cluster_system_sync("/etc/passwd");
    if ($ret ne "") {
        return ($ret);
    }
    $ret = &cluster_system_sync("/etc/shadow");
    if ($ret ne "") {
      return ($ret);
    }
  }

done:
  return("");
}


1;
