
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: dir.pl,v 1.1.1.1 2002/09/09 07:43:34 snavi Exp $

#---------------------------------------------------------------------------

##000906 4.1 ¥ǥ쥯ȥ/home/web/$domainname		.haramoto
##001225 v5.1 VirtualHost IP б      S.Oku
##010216 v4.0.1 wbmc04-011 б   S.Oku

#---------------------------------------------------------------------------
#
# ǥ쥯ȥɲä
#
sub addDirectory
{
	local($server, $port, $dir) = @_;
	local(@lines, $target, @lines2, $targetline);
	local($i, $serveradmin_flag, $port_hit);
	# Ϥ줿ǥ쥯ȥΥå
	if ($dir =~ /(.+)\/$/) {
		$dir = $1;
	}
	if ($dir =~ /[^\x21-\x7E]/) {
		return("ǥ쥯ȥ̾ȾѱѿʸȾѵǻꤷƲ");
	}
	if ($dir !~ /^\//) {
#		return("ǥ쥯ȥ̾ХѥꤷƲ");		##000906
		return("ǥ쥯ȥ̾ϥ顼Ǥ");
	}

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		return("եɤ߹ߤ˼Ԥޤ");
	}

	# 񤭹򸫤Ĥ
	$target = 0;
#	for ($i = 0; $i <= $#lines; $i++) {
#		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
#			if ("$server:$port" eq $1) {
#				$target = 1;
#			}
#		}
#		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
#			if ($target == 1) {
#				$targetline = $i;
#			}
#			$target = 0;
#		}
#		elsif ($target == 0) {
#			next;
#		}
#		if ($lines[$i] =~ /^\s*<Directory\s+("|)([^\s"]*)("|)\s*>/i) {
#			if ($dir eq $2) {
#				return("ǤƱ̾Υǥ쥯ȥ꤬¸ߤޤ");
#			}
#		}
#	}

	$port_hit = 0;
	for ($i=0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			if ($1 !~ /\:$port/) {
				next;
			}
			else {
				$port_hit = 1;
			}
		}
		elsif (($lines[$i] =~ /^\s*ServerName\s+([^\s]+)\s*/i)&&($port_hit == 1)) {
			if ($server eq $1) {
				$target = 1;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {

			if ($target == 1) {
				$targetline = $i;
				last;							##000904 add
			}
			$target = 0;
			$port_hit = 0;
		}
		elsif ($target == 0) {
			next;
		}
		if ($lines[$i] =~ /^\s*<Directory\s+("|)([^\s"]*)("|)\s*>/i) {
			if ($dir eq $2) {
				return("ǤƱ̾Υǥ쥯ȥ꤬¸ߤޤ");
			}
		}
	}




	if ($targetline == 0) {
		return("˼Ԥޤ");
	}

	# <Directory></Directory>ɲä
	@lines2 = ();
	push(@lines2, "\t<Directory \"$dir\">\n");
	push(@lines2, "\t\tDirectoryIndex index.html index.htm default.htm\n");
	push(@lines2, "\t\tAllowOverride None\n");
	push(@lines2, "\t\tOptions -ExecCGI -Includes -Indexes -FollowSymLinks -MultiViews\n");
#	push(@lines2, "\t\tAuthType Basic\n");
#	push(@lines2, "\t\tAuthName \"Input username and password.\"\n");
#	push(@lines2, "\t\tAuthUserFile /etc/opt/nec/wbmc/shadow\n");
#	push(@lines2, "\t\tAuthGroupFile /etc/opt/nec/wbmc/group\n");
#	push(@lines2, "\t\tRequire valid-user\n");
	push(@lines2, "\t</Directory>\n");
	splice(@lines, $targetline, 0, @lines2);

	# wbmc.conf˽񤭹
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		return("եν񤭹ߤ˼Ԥޤ");
	}

	return("");
}

#
# ǥ쥯ȥɤ߽Ф
#
sub getDirectory
{
	local($server, $port, $dir) = @_;
	local($directoryIndex, $execCGI, $includes,
			$indexes, $followsymlinks, $multiviews,
			$authType);
	local($target);
	local(@ans);
	local($i, $i_buf, $port_hit, $server_hit);

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		&showErrorPage("եɤ߹ߤ˼Ԥޤ");
		exit(1);
	}

	$vtarget = 0;
	$dtarget = 0;
	$insert_this_line = 0;
	$directoryIndex = "index.html index.htm default.htm";
	$execCGI = "off";
	$includes = "off";
	$indexes = "off";
	$followsymlinks = "off";
	$allowoverride = "off";
	$authType = "off";
	$multiviews = "off";
	$i_buf = "";
	$port_hit = 0;
	$server_hit = 0;
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			if ($1 !~ /\:$port/){
				next;
			}
			$port_hit = 1;
			$i_buf = $i;
			if ($server_hit == 1) {
#				$port = $2;
				$vtarget = 1;
			}
		}
		elsif (($lines[$i] =~ /^\s*ServerName\s+([^\s]+)/i)&&($server_hit == 0)) {
			if (($server eq $1)&&($port_hit == 1)) {
				$server_hit = 1;
				$i = $i_buf - 1;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
			$vtarget = 0;
			$server_hit = 0;
			$port_hit = 0;
		}
		elsif ($vtarget == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\s*<Directory\s+("|)([^\s"]*)("|)\s*>/i) {
			if ($dir eq $2) {
				$dtarget = 1;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/Directory\s*>/i) {
			if ($dtarget) {
				$insert_this_line = $i;
			}
			$dtarget = 0;
		}
		elsif ($dtarget == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\s*DirectoryIndex\s+(.*)/i) {
			$directoryIndex = $1;
		}
		elsif ($lines[$i] =~ /^\s*Options\s+(.*)/i) {
			$options = $1;
			if ($options =~ /(\+|\-)ExecCGI/i) {
				if ($1 eq "+") { $execCGI = "on"; }
			}
			if ($options =~ /(\+|\-)Includes/i) {
				if ($1 eq "+") { $includes = "on"; }
			}
			if ($options =~ /(\+|\-)Indexes/i) {
				if ($1 eq "+") { $indexes = "on"; }
			}
			if ($options =~ /(\+|\-)FollowSymLinks/i) {
				if ($1 eq "+") { $followsymlinks = "on"; }
			}
			if ($options =~ /(\+|\-)MultiViews/i) {
				if ($1 eq "+") { $multiviews = "on"; }
			}
		}
		elsif ($lines[$i] =~ /^\s*AllowOverride\s+(.*)/i) {
			if ($1 =~ /^None$/i) {
				$allowoverride = "off";
			} else {
				$allowoverride = "on";
			}
		}
#		elsif ($lines[$i] =~ /^\s*AuthType\s+(.*)/i) {
#			if ($1 =~ /^Basic$/i) {
#				$authType = "on";
#			}
#		}
#		elsif ($lines[$i] =~ /^\s*AuthName\s+(.*)/i) {
#		}
#		elsif ($lines[$i] =~ /^\s*AuthUserFile\s+(.*)/i) {
#		}
#		elsif ($lines[$i] =~ /^\s*AuthGroupFile\s+(.*)/i) {
#		}
#		elsif ($lines[$i] =~ /^\s*Require\s+(.*)/i) {
#		}
	}

	@ans = ($directoryIndex, $execCGI, $includes, $indexes,
			$followsymlinks, $allowoverride, $authType);

	return(@ans);
}

#
# ǥ쥯ȥѹ
#
sub modDirectory
{
	local($server, $port, $dir,
		$directoryIndex, $execCGI, $includes, $indexes,
		$followsymlinks, $allowoverride, $authType) = @_;
	local(@lines, $vtarget, $dtarget);
	local(@options);
	local($i, $server_hit, $port_hit, $i_buf);

#print "Content-type: text/html\n\n";
#print "server = $server<BR>\n";
#print "port = $port<BR>\n";
#print "dir = $dir<BR>\n";
#print "directoryIndex = $directoryIndex<BR>\n";
#print "execCGI = $execCGI<BR>\n";
#print "includes = $includes<BR>\n";
#print "indexes = $indexes<BR>\n";
#print "allowoverride = $allowoverride<BR>\n";
#print "authType = $authType<BR>\n";

	# ǥߥ" "ѹ
	@ent = split(/[\s,]+/, $directoryIndex);
	for ($i = 0; $i <= $#ent; $i++) {
		if ($ent[$i] =~ /[^\x21-\x7E]/) {
		return("ե̾ȾѱѿʸȾѵǻꤷƲ");
		}
	}
	$directoryIndex = join(" ", @ent);

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		return("եɤ߹ߤ˼Ԥޤ");
	}

	# 񤭹򸫤Ĥ
	$vtarget = 0;
	$dtarget = 0;
	$insert_this_line = 0;
	$server_hit = 0;
	$port_hit = 0;
	$i_buf = "";
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			if ($1 !~ /\:$port/) {
				next;
			}
			$port_hit = 1;
			$i_buf = $i;
			if ($server_hit == 1) {
				$port = $2;
				$vtarget = 1;
			}
		}
		elsif (($lines[$i] =~ /^\s*ServerName\s+([^\s]+)/i)&&($server_hit == 0)) {
			if (($server eq $1)&&($port_hit == 1)) {
				$server_hit = 1;
				$i = $i_buf - 1;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
			if ($vtarget == 1) {
				last;
			}
			$server_hit = 0;
			$port_hit = 0;
			$vtarget = 0;
		}
		elsif ($vtarget == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\s*<Directory\s+("|)([^\s"]*)("|)\s*>/i) {
			if ($dir eq $2) {
				$dtarget = 1;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/Directory\s*>/i) {
			if ($dtarget) {
				$insert_this_line = $i;
			}
			$dtarget = 0;
		}
		elsif ($dtarget == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\s*DirectoryIndex\s+/i) {
			splice(@lines, $i, 1);
			$i--;
		}
		elsif ($lines[$i] =~ /^\s*Options\s+(.*)/i) {
			splice(@lines, $i, 1);
			$i--;
		}
		elsif ($lines[$i] =~ /^\s*AllowOverride\s+(.*)/i) {
			splice(@lines, $i, 1);
			$i--;
		}
#		elsif ($lines[$i] =~ /^\s*AuthType\s+(.*)/i) {
#			splice(@lines, $i, 1);
#			$i--;
#		}
#		elsif ($lines[$i] =~ /^\s*AuthName\s+(.*)/i) {
#			splice(@lines, $i, 1);
#			$i--;
#		}
#		elsif ($lines[$i] =~ /^\s*AuthUserFile\s+(.*)/i) {
#			splice(@lines, $i, 1);
#			$i--;
#		}
#		elsif ($lines[$i] =~ /^\s*AuthGroupFile\s+(.*)/i) {
#			splice(@lines, $i, 1);
#			$i--;
#		}
#		elsif ($lines[$i] =~ /^\s*Require\s+(.*)/i) {
#			splice(@lines, $i, 1);
#			$i--;
#		}
	}

	@lines2 = ();

	push(@lines2, "\t\tDirectoryIndex $directoryIndex\n");

	$tmp = "\t\tOptions";
	if ($execCGI eq "on") {
		$tmp .= " +ExecCGI";
	} else {
		$tmp .= " -ExecCGI";
	}
	if ($includes eq "on") {
		$tmp .= " +Includes";
	} else {
		$tmp .= " -Includes";
	}
	if ($indexes eq "on") {
		$tmp .= " +Indexes";
	} else {
		$tmp .= " -Indexes";
	}
	if ($followsymlinks eq "on") {
		$tmp .= " +FollowSymLinks";
	} else {
		$tmp .= " -FollowSymLinks";
	}
	$tmp .= " -MultiViews";
	$tmp .= "\n";
	push(@lines2, $tmp);

	if ($allowoverride eq "on") {
		push(@lines2, "\t\tAllowOverride AuthConfig FileInfo Indexes Limit\n");
	} else {
		push(@lines2, "\t\tAllowOverride None\n");
	}

#	if ($authType eq "on") {
#		push(@lines2, "\t\tAuthType Basic\n");
#		push(@lines2, "\t\tAuthName \"Input username and password.\"\n");
#		push(@lines2, "\t\tAuthGroupFile /etc/opt/nec/wbmc/group\n");
#		push(@lines2, "\t\tAuthUserFile /etc/opt/nec/wbmc/shadow\n");
#		push(@lines2, "\t\tRequire valid-user\n");
#	}

	if ($insert_this_line == 0) {
		return("˼Ԥޤ");
	}
	splice(@lines, $insert_this_line, 0, @lines2);

	# wbmc.conf˽񤭹
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		return("եν񤭹ߤ˼Ԥޤ");
	}

	return("");
}

#
# ǥ쥯ȥ
#
sub delDirectory
{
	local($server, $port, $dir) = @_;
	local($vtarget, $dtarget, $start, $end);
	local($i, $server_hit, $port_hit, $i_buf);

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		&showErrorPage("եɤ߹ߤ˼Ԥޤ");
		exit(1);
	}

	# 
	$vtarget = 0;
	$dtarget = 0;
	$start = -1;
	$end = -1;
	$server_hit = 0;
	$port_hit = 0;
	$i_buf = "";
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			if ($1 !~ /\:$port/) {
				next;
			}
			$port_hit = 1;
			$i_buf = $i - 1;
			if ($server_hit == 1) {
#				$port = $2;
				$vtarget = 1;
			}
		}
		elsif (($lines[$i] =~ /^\s*ServerName\s+([^\s]+)/i)&&($server_hit == 0)) {
			if (($server eq $1)&&($port_hit == 1)) {
				$server_hit = 1;
				$i = $i_buf;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
			$server_hit = 0;
			$port_hit = 0;
			$vtarget = 0;
		}
		elsif ($vtarget == 0) {
			next;
		}
		if ($lines[$i] =~ /^\s*<Directory\s+("|)([^\s"]*)("|)\s*>/i) {
			if ($dir eq $2) {
				$dtarget = 1;
				$start = $i;
			}
		}
		if ($lines[$i] =~ /^\s*<\/Directory\s*>/i) {
			if ($dtarget) {
				$end = $i;
				last;
			}
			$dtarget = 0;
		}
	}

	if (($start != -1) && ($end != -1)) {
		splice(@lines, $start, $end - $start + 1);
	}

	# wbmc.conf˽񤭹
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		&showErrorPage("եν񤭹ߤ˼Ԥޤ");
		exit(1);
	}

	# Ƶư
	if (&isServiceRunning("")) {
		&restartApache();
	}
}

1;

