#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: vpath.pl,v 1.1.1.1 2002/09/09 07:43:34 snavi Exp $

#-----------------------------------------------------------

##001226 v5.1 󥯥ȱ黻$i local   S.Oku
##010216 v4.0.1 wbmc04-011 б   S.Oku

#-----------------------------------------------------------

#---------------------------------------------------------------------------
#
# ۥѥɲä
#
sub addVirtualPath
{
	local($server, $port, $vpath, $rpath) = @_;
	local($target) = 0;
	local($i, $server_hit, $port_hit, $i_buf);

	if (!$server) {
		&showErrorPage("̾ꤵƤޤ");
		exit(1);
	}
	if (!$port) {
		&showErrorPage("ݡֹ椬ꤵƤޤ");
		exit(1);
	}
	if (!$vpath) {
		&showErrorPage("ۥѥ̾ꤵƤޤ");
		exit(1);
	}
	if ($vpath !~ /^\//) {
		&showErrorPage("ۥѥ̾ˤϥå(/)ǻϤޤѥ̾ꤷƤ");
		exit(1);
	}
	if ($vpath eq '/') {
		&showErrorPage("ۥѥ̾ˤϥå(/)Τߤꤹ뤳ȤϤǤޤ");
		exit(1);
	}
	if ($vpath =~ /(.+)\/$/) {
		$vpath = $1;
	}
	if ($vpath =~ /[^0-9a-zA-Z\%\+\.\-\/\:\;\=\@\^\_\~]/) {
		&showErrorPage("ۥѥ̾ˤŬڤȾѱѿʸȾѵǻꤷƲ");
		exit(1);
	}
	if ($vpath =~ /[\"\']/) {
		&showErrorPage("ۥѥ̾˥ơѤ뤳ȤϤǤޤ");
		exit(1);
	}
	if (!$rpath) {
		&showErrorPage("¥ǥ쥯ȥ̾ꤵƤޤ");
		exit(1);
	}
	if ($rpath !~ /^\//) {
		&showErrorPage("¥ǥ쥯ȥ̾ˤϥå(/)ǻϤޤѥ̾ꤷƤ");
		exit(1);
	}
	if ($rpath =~ /[^0-9a-zA-Z\%\+\.\-\/\:\;\=\@\^\_\~]/) {
		&showErrorPage("¥ǥ쥯ȥ̾ˤŬڤȾѱѿʸȾѵǻꤷƲ");
		exit(1);
	}
	# Ϥ줿ǥ쥯ȥ̵ͭå
	if ($rpath =~ /(.+)\/$/) {
		$rpath = $1;
	}

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		&showErrorPage("եɤ߹ߤ˼Ԥޤ");
		exit(1);
	}

	$target = 0;
	$server_hit = 0;
	$port_hit = 0;
	$i_buf = "";
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			if ($1 !~ /\:$port/) {
				next;
			}
			$port_hit = 1;
			$i_buf = $i;
			if ($server_hit == 1) {
				$target = 1;
			}
		}
		elsif (($lines[$i] =~ /^\s*ServerName\s+([^\s]+)/i)&&($server_hit == 0)) {
			if (($server eq $1)&&($port_hit == 1)) {
				$server_hit = 1;
				$i = $i_buf - 1;
			}
		}
## Alias εҤ AliasMatch ˽
#		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
		elsif (($lines[$i] =~ /^\s*AliasMatch\s+/i)||($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i)) {
			if ($target == 1) {
				$targetline = $i;
				last;
			}
			$target = 0;
			$server_hit = 0;
			$port_hit = 0;
		}
		elsif ($target == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\sAlias\s+([^\s]+)\s+([^\s]+)/i) {
			if ($vpath eq $1) {
				&showErrorPage("ǤƱ̾βۥѥ¸ߤޤ");
				exit(1);
			}
		}
	}

	# Alias
	if ($targetline == 0) {
		&showErrorPage("˼Ԥޤ");
		exit(1);
	}
	splice(@lines, $targetline, 0, "\tAlias $vpath $rpath\n");

	# wbmc.conf˽񤭹
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		&showErrorPage("եν񤭹ߤ˼Ԥޤ");
		exit(1);
	}

	# Ƶư
	if (&isServiceRunning("")) {
		&restartApache();
	}
}

#
# ۥѥѹ
#
sub modVirtualPath
{
	local($server, $port, $vpath, $rpath) = @_;
	local($target) = 0;
	local($i, $server_hit, $port_hit, $i_buf);

	if (!$server) {
		&showErrorPage("̾ꤵƤޤ");
		exit(1);
	}
	if (!$port) {
		&showErrorPage("ݡֹ椬ꤵƤޤ");
		exit(1);
	}
	if (!$vpath) {
		&showErrorPage("ۥѥ̾ꤵƤޤ");
		exit(1);
	}
	if ($vpath !~ /^\//) {
		&showErrorPage("ۥѥ̾ˤϥå(/)ǻϤޤѥ̾ꤷƤ");
		exit(1);
	}
	if ($vpath =~ /(.+)\/$/) {
		$vpath = $1;
	}
	if ($vpath =~ /[^\x20-\x7E]/) {
		&showErrorPage("ۥѥ̾ȾѱѿʸȾѵǻꤷƲ");
		exit(1);
	}
	if (!$rpath) {
		&showErrorPage("¥ǥ쥯ȥ̾ꤵƤޤ");
		exit(1);
	}
	if ($rpath !~ /^\//) {
		&showErrorPage("¥ǥ쥯ȥ̾ˤϥå(/)ǻϤޤѥ̾ꤷƤ");
		exit(1);
	}
	# Ϥ줿ǥ쥯ȥ̵ͭå
	if ($rpath =~ /(.+)\/$/) {
		$rpath = $1;
	}

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		&showErrorPage("եɤ߹ߤ˼Ԥޤ");
		exit(1);
	}

	$target = 0;
	$server_hit = 0;
	$port_hit = 0;
	$i_buf = "";
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			if ($1 !~ /\:$port/) {
				next;
			}
			$port_hit = 1;
			$i_buf = $i;
			if ($server_hit == 1) {
				$port = $2;
				$target = 1;
			}
		}
		elsif (($lines[$i] =~ /^\s*ServerName\s+([^\s]+)/i)&&($server_hit == 0)) {
			if (($server eq $1)&&($port_hit == 1)) {
				$server_hit = 1;
				$i = $i_buf - 1;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
			if ($target == 1) {
				$targetline = $i;
				last;
			}
			$server_hit = 0;
			$port_hit = 0;
			$target = 0;
		}
		elsif ($target == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\sAlias\s+([^\s]+)\s+([^\s]+)/i) {
			if ($vpath eq $1) {
				splice(@lines, $i, 1, "\tAlias $vpath $rpath\n");
				last;
			}
		}
	}

	# wbmc.conf˽񤭹
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		&showErrorPage("եν񤭹ߤ˼Ԥޤ");
		exit(1);
	}

	# Ƶư
	if (&isServiceRunning("")) {
		&restartApache();
	}
}

#
# ۥѥ
#
sub delVirtualPath
{
	local($server, $port, $vpath) = @_;
	local($target) = 0;
	local($i, $server_hit, $port_hit, $i_buf);

	if (!$server) {
		&showErrorPage("̾ꤵƤޤ");
		exit(1);
	}
	if (!$port) {
		&showErrorPage("ݡֹ椬ꤵƤޤ");
		exit(1);
	}
	if (!$vpath) {
		&showErrorPage("ۥѥ̾ꤵƤޤ");
		exit(1);
	}

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		&showErrorPage("եɤ߹ߤ˼Ԥޤ");
		exit(1);
	}

	$target = 0;
	$server_hit = 0;
	$port_hit = 0;
	$i_buf = "";
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			if ($1 !~ /\:$port/) {
				next;
			}
			$port_hit = 1;
			$i_buf = $i - 1;
			if ($server_hit == 1) {
				$port = $2;
				$target = 1;
			}
		}
		elsif (($lines[$i] =~ /^\s*ServerName\s+([^\s]+)/i)&&($server_hit == 0)) {
			if (($server eq $1)&&($port_hit == 1)) {
				$server_hit = 1;
				$i = $i_buf;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
			if ($target == 1) {
				last;
			}
			$server_hit = 0;
			$port_hit = 0;
			$target = 0;
		}
		elsif ($target == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\sAlias\s+([^\s]+)\s+([^\s]+)/i) {
			if ($vpath eq $1) {
				splice(@lines, $i, 1);
			}
		}
	}

	# wbmc.conf˽񤭹
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		&showErrorPage("եν񤭹ߤ˼Ԥޤ");
		exit(1);
	}

	# Ƶư
	if (&isServiceRunning("")) {
		&restartApache();
	}
}

1;

