# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: cert.pl,v 1.2 2002/09/27 12:27:24 snavi Exp $

#
# Ź渰ޤǤΰϢκȤԤ
#
sub make_cert
{
	# 
	local($err) = "";
	local($key) = "/etc/opt/nec/wbmchttpd/conf/ssl.key/server.key";
	local($csr) = "/etc/opt/nec/wbmchttpd/conf/ssl.csr/server.csr";
	local($crt) = "/etc/opt/nec/wbmchttpd/conf/ssl.crt/server.crt";
	
	# ̩κ
	if ($err = &gen_key($key)) {
		goto done;
	}
	
	# ̾׵κ
	if ($err = &gen_csr($key, $csr)) {
		goto done;
	}
	
	# κ
	if ($err = &gen_crt($key, $csr, $crt)) {
		goto done;
	}
	
	# ̾׵κ
	if ($err = &del_csr($csr)) {
		goto done;
	}

 done:
	return($err);
}

#
# ̩
#
sub gen_key
{
	local($key) = @_;
	local($err) = "";
	
	# Ź渰
	if (!open EXEC, "| /usr/bin/openssl genrsa -passout stdin -des 1024 > $key") {
		$err = "Ź渰κ˼Ԥޤ";
		goto done;
	}

	# ΥѥɤϤ
	print EXEC "wbmc\n";
	print EXEC "wbmc\n";
	close(EXEC);
	
	# Ź渰Υѥɤ
	if (!open EXEC, "| /usr/bin/openssl rsa -in $key -passin stdin -out $key") {
		$err = "Ź渰Υѥɤβ˼Ԥޤ";
		goto done;
	}
	print EXEC "wbmc\n";
	close(EXEC);
	
	# root Фɤ߼긢Τߤ
	if (!open CMD, "/bin/chmod 400 \"$key\" |") {
		$err = "Ź渰Υѡߥåѹ˼Ԥޤ";
		goto done;
	}
	close(CMD);

 done:
	return($err);
}

#
# ̾׵κ
#
sub gen_csr
{
	local($key, $csr) = @_;
	local($err) = "";
	local($hostname) = "";

	open(OUT, "/bin/cat /etc/HOSTNAME|");
	@tmp = <OUT>;

	$hostname = $tmp[0];

	if (!open EXEC, "| /usr/bin/openssl req -new -key $key -out $csr -config /opt/nec/wbmc/lib/ssl.conf") {
		$err = "̾׵κ˼Ԥޤ";
		goto done;
	}
	print EXEC "JP\n";
	print EXEC "State\n";
	print EXEC "City\n";
	print EXEC "Company\n";
	print EXEC "Section\n";
	print EXEC "$hostname\n";
	close(EXEC);

 done:
	return($err);
}

#
# ʽ̾κ
#
sub gen_crt
{
	local($err) = "";
	local($key, $csr, $crt) = @_;

	if (!open EXEC, "| /usr/bin/openssl x509 -in $csr -out $crt -days 365 -signkey $key -req") {
		$err = "ʽ̾κ˼Ԥޤ";
		goto done;
	}
	close(EXEC);

 done:
	return($err);
}

#
# ̾׵κ
#
sub del_csr
{
	local($err) = "";
	local($csr) = @_;

	if (!open CMD, "/bin/rm -f $csr |") {
		$err = "̾׵κ˼Ԥޤ";
		goto done;
	}
	close(CMD);

 done:
	return($err);
}

1;
