#!/usr/bin/perl

# Copyright (c) 2000 NEC Corporation
# All rights Reserved.

# RCS: $Id: usr.pl,v 1.1.1.1 2002/09/09 07:43:35 snavi Exp $

##010712 v4.1   إåμ¤From:ɲˡν     T.Shimizu
##010705 v4.1   إåMIME󥳡ɡFrom:ưɲõǽ T.Shimizu

;########################
;## WbMC Library usr
;########################
package usr;

$forward = ".forward";
$forward_f = ".forward.f";
$forward_v = ".forward.v";
$vacation_db = ".vacation.db";
$vacation_msg = ".vacation.msg";

sub mkDomFwd_novac {
;# vacationǽ̵ˤƥɥᥤ桼 .forward 롣
;# Ȥ
;# 	$ret = &usr::mkDomFwd_novac($domainname);
;# 
;# 	$domainname ... ɥᥤ̾
;# 
;# 	顼å(ʤ"")

	my($domainname) = @_;
	my($group, $mode);

	if (($group = &main::getDomainConf($domainname, "GROUPNAME")) eq "") {
		return "ɥᥤɤ߹ߤ˼Ԥޤ";
	}
	if (($mode = &main::getDomainConf($domainname, "MODE")) eq "") {
		return "ɥᥤɤ߹ߤ˼Ԥޤ";
	}

	my(@users) = ();
	my($line, $user, $ret, $err, @ent);
	local(@passwd) = ();

	;# ɥᥤ桼򸡺(user.cgiƱΤϤ)
	if (!&main::readFile("/etc/passwd", "passwd", *passwd)) {
		return "/etc/passwd ɤ߹ߤ˼Ԥޤ";
	}
	foreach $line (@passwd) {
		@ent = split(/:/, $line);
		;# ƥ桼(uid < 500)̵
		next if ($ent[2] < 500);
		;# /ۥɥᥤ
		if (($mode =~ /REAL/i) && ($ent[0] !~ /\@\S+/)) {
			push(@users, $ent[0]);
		}
		elsif (($mode =~ /VIRTUAL/i) && ($ent[0] =~ /\@$group$/)) {
			push(@users, $ent[0]);
		}
	}
	
	;# 桼 .forward 
	$ret = "";
	foreach $user (@users) {
		if ($err = &mkUsrFwd_novac($user)) {
			$ret .= $err;
		}
	}

	return $ret;
}

sub mkDomFwd_nofwd {
;# ᡼žǽ̵ˤƥɥᥤ桼 .forward 롣
;# Ȥ
;# 	$ret = &usr::mkDomFwd_nofwd($domainname);
;# 
;# 	$domainname ... ɥᥤ̾
;# 
;# 	顼å(ʤ"")

	my($domainname) = @_;
	my($group, $mode);

	if (($group = &main::getDomainConf($domainname, "GROUPNAME")) eq "") {
		return "ɥᥤɤ߹ߤ˼Ԥޤ";
	}
	if (($mode = &main::getDomainConf($domainname, "MODE")) eq "") {
		return "ɥᥤɤ߹ߤ˼Ԥޤ";
	}

	my(@users) = ();
	my($line, $user, $ret, $err, @ent);
	local(@passwd) = ();

	;# ɥᥤ桼򸡺(user.cgiƱΤϤ)
	if (!&main::readFile("/etc/passwd", "passwd", *passwd)) {
		return "/etc/passwd ɤ߹ߤ˼Ԥޤ";
	}
	foreach $line (@passwd) {
		@ent = split(/:/, $line);
		;# ƥ桼(uid < 500)̵
		next if ($ent[2] < 500);
		;# /ۥɥᥤ
		if (($mode =~ /REAL/i) && ($ent[0] !~ /\@\S+/)) {
			push(@users, $ent[0]);
		}
		elsif (($mode =~ /VIRTUAL/i) && ($ent[0] =~ /\@$group$/)) {
			push(@users, $ent[0]);
		}
	}
	
	;# 桼 .forward 
	$ret = "";
	foreach $user (@users) {
		if ($err = &mkUsrFwd_nofwd($user)) {
			$ret .= $err;
		}
	}

	return $ret;
}

sub mkUsrFwd_novac {
;# vacationǽ̵ˤ .forward 롣
;# Ȥ
;# 	$ret = &usr::mkUsrFwd_novac($user);
;# 
;# 	$user ... 桼̾
;# 
;# 	顼å(ʤ"")

	my($user) = @_;
	my($homedir) = (getpwnam($user))[7];
	my($ret) = "";

	;# .forward.v , .vacation.db 
	if (-f "$homedir/$forward_v") {
		unlink("$homedir/$forward_v") || ($ret .= "$homedir/$forward_vκ˼Ԥޤ\n");
	}
	if (-f "$homedir/$vacation_db") {
		unlink("$homedir/$vacation_db") || ($ret .= "$homedir/$vacation_dbκ˼Ԥޤ\n");
	}

	;# .forward 
	$ret .= &mkUsrFwd($user);

	return $ret;
}

sub mkUsrFwd_nofwd {
;# ᡼žǽ̵ˤ .forward 롣
;# Ȥ
;# 	$ret = &usr::mkUsrFwd_nofwd($user);
;# 
;# 	$user ... 桼̾
;# 
;# 	顼å(ʤ"")

	my($user) = @_;
	my(@userinfo)   = getpwnam($user);
	my($userid)     = $userinfo[2];
	my($groupid)    = $userinfo[3];
	my($homedir)    = $userinfo[7];
	my($ret) = "";
	my(@str) = ();

	;# .forward.f 
	if (!&main::writeFile("$homedir/$forward_f", $forward_f, @str)) {
    		return "$homedir/$forward_fν񤭹ߤ˼Ԥޤ";
	}
	chown($userid, $groupid, "$homedir/$forward_f");
	chmod(0600, "$homedir/$forward_f");

	;# .forward 
	$ret .= &mkUsrFwd($user);

	return $ret;
}

sub mkUsrFwdv {
;# .forward.v 롣
;# Ȥ
;# 	$ret = &usr::mkUsrFwdv($user, $domainname);
;# 
;# 	$user       ... 桼̾
;# 	$domainname ... ɥᥤ̾
;# 
;# 	顼å(ʤ"")

	my($user, $domainname) = @_;
	my(@str);

	my(@userinfo)   = getpwnam($user);
	my($userid)     = $userinfo[2];
	my($groupid)    = $userinfo[3];
	my($homedir)    = $userinfo[7];

	;# ۥɥᥤ桼ϥ롼̾ɥᥤ̾Ѵ
	$user =~ s/@.+$/_$domainname/;
	;# ʸ
	@str = ("\\$user\, \"| /usr/bin/vacation $user\"\n");

	;# .forward.v 
	if (!&main::writeFile("$homedir/$forward_v", $forward_v, @str)) {
    		return "$homedir/$forward_vν񤭹ߤ˼Ԥޤ";
	}
	chown($userid, $groupid, "$homedir/$forward_v");
	chmod(0600, "$homedir/$forward_v");

	return "";
}

sub mkUsrFwd {
;# .forward.f  .forward.v ޡ .forward 롣
;# .forward.f  .forward.v ̵Ƥⵤˤʤ.forward ̵롣
;# Ȥ
;# 	$ret = &usr::mkUsrFwd($user);
;# 
;# 	$user ... 桼̾
;# 
;# 	顼å(ʤ"")

	my($user) = @_;

	my(@userinfo)   = getpwnam($user);
	my($userid)     = $userinfo[2];
	my($groupid)    = $userinfo[3];
	my($homedir)    = $userinfo[7];

	local(@lines_f) = ();
	local(@lines_v) = ();

	;# .forward.f , .forward.v ¸ߤɤ߹
	&main::readFile("$homedir/$forward_f", $forward_f, *lines_f) if (-f "$homedir/$forward_f");
	&main::readFile("$homedir/$forward_v", $forward_v, *lines_v) if (-f "$homedir/$forward_v");

	;# .forward 
	if (!&main::writeFile("$homedir/$forward", $forward, (@lines_f, @lines_v))) {
    		return "$homedir/$forwardν񤭹ߤ˼Ԥޤ";
	}
	chown($userid, $groupid, "$homedir/$forward");
	chmod(0600, "$homedir/$forward");

	return "";
}

sub mkVacMsg {
;# .vacation.msg 롣
;# Ȥ
;# 	$ret = &usr::mkVacMsg($msg, $user, $domain);
;# 
;# 	$msg        ... å 
;# 	$user       ... 桼̾
;# 	$domain     ... ɥᥤ̾
;# 
;# 	顼å(ʤ"")

	my($msg, $user, $domain) = @_;
	my($userid, $groupid, $comment, $homedir) = (getpwnam($user))[2,3,6,7];
	my($header, $body);
	my($err);

	$msg .= "\n" if ($msg !~ /\n$/);
	$msg =~ s/\r//g;

	($header, $body) = &getheaderbody($msg);

	;# From:̵äɲ
	unless (&exist_header_from($header)) {
		my $name = $user;
		$name =~ s/\@.*$//;
		my $from = "From: $comment <$name\@$domain>\n";
		$header = $from . $header;
	}

	;# إåΥ󥳡
	$err = &encode_header(\$header);
	$err && return($err);

	$msg = $header . "\n" . $body;

	;# JISˤƽ񤭹
	require "jcode.pl";
	&jcode::convert(\$msg, 'jis');
	if (!&main::writeFile("$homedir/$vacation_msg", $vacation_msg, ($msg))) {
		return "$homedir/$vacation_msgν񤭹ߤ˼Ԥޤ";
	}
	chown($userid, $groupid, "$homedir/$vacation_msg");
	chmod(0600, "$homedir/$vacation_msg");

	return "";
}

sub rmVacMsg {
;# .vacation.msg 롣
;# Ȥ
;# 	$ret = &usr::rmVacMsg($user);
;# 
;# 	$user       ... 桼̾
;# 
;# 	顼å(ʤ"")

	my($user) = @_;
	my($homedir) = (getpwnam($user))[7];
	my($ret) = "";

	;# .vacation.msg 
	if (-f "$homedir/$vacation_msg") {
		unlink("$homedir/$vacation_msg") || ($ret .= "$homedir/$vacation_msgκ˼Ԥޤ\n");
	}

	return $ret;
}

;# EUC-JP ܸ칽ʸ
my $euc_jp = q{	
  	\x8E[\xA0-\xDF]			# Ⱦѥ (Хʸ)
	| \x8F[\xA1-\xFE][\xA1-\xFE]	# JIS X 0212-1990 (Хʸ)
	| [\xA1-\xFE][\xA1-\xFE]	# JIS X 0208-1997 (Хʸ)
};

sub encode_header {
;# إåMIME::Base64󥳡ɤ롣
;# 	&usr::encode_header(\$header);
;# 
;# 	\$header	إåʸؤΥե
;# 
;# 	顼å(ʤ"")
;#
	my($header) = @_;
	my $nkf = '/usr/bin/nkf -M';
	my(@header, @lines);
	my($err);

	;# EUC-JPѴ
	require "jcode.pl";
	&jcode::convert(\$$header, 'euc');

	;# إånkfǥ󥳡
	@header = split(/(\n)/, $$header);
	foreach (@header) {
		if (/$euc_jp/ox) {
			$_ = quotemeta $_;
			@lines  = (`echo $_ | $nkf`);
			$_ = join('', @lines);
			;# Ԥ
			$_ =~ s/\n//g;
		}
	}
	;# إåĹå
	$err = chk_header_length(@header);
	$err && return($err);

	$$header = join('', @header);
	return "";
}

sub chk_header_length {
;# إåĹå
;#	$err = chk_header_length(@header);
;# 
;# 	@header	إå
;# 
;# 	顼å(ʤ"")
;# 
	my(@header) = @_;

	$MAX_HEADER_LENGTH = 255;
	foreach (@header) {
		if (length($_) > $MAX_HEADER_LENGTH) {
			return "إåĹޤ\n";
		}
	}
	return '';
}

sub exist_header_from {
;# From: إå¸ߤ뤫ɤå롣
;#	if (&usr::exist_header_from($header)) {
;#		# From:إåͭ
;#	} else {
;#		# From: ̵
;#	}
;# 
;#	$header	᡼إå

	my($header) = @_;
	my(@header, $body);

	@header = split(/\n/, $header);
	foreach (@header) {
		return 1 if (/^From:/i);
	}
	return 0;
}

sub getheaderbody {
;# إåʸʬ䤷֤إåʸδ֤ζԤϼΤƤ롣
;# إåϰ԰إåΤߡԤޤΤϥإåȸʤʤ
;# إå¸ߤʤȽꤷϡ$header ˤ ''$body ˤϰΤޤ롣
;#	($header, $body) = &usr::getheaderbody($mail);
;# 
;#	$mail	᡼å(إåʸ)

	my($mail) = @_;
	my(@part, $header, $body);

	;# \n\n () ʬ
	@part = split(/\n\n/, $mail);

	$header = $part[0] . "\n";
	$body = $mail;
	substr($body, 0, length($header)+1) = '';

	;# إåå
	if (&chk_vacation_header($header)) {
		return ('', $mail);
	} else {
		return ($header, $body);
	}
}

sub chk_vacation_header {
;# vacation ǽǵĤإåΥå
;# From:, Subject:, Reply-To: ΤߵĤ
;# إå̾ SPACE/:/ܸ ޤޤƤԲ
;#	if (&usr::chk_vacation_header($header)) {
;#		# ʥإå¸ߤ롣
;#	} else {
;#		# OK
;#	}
;# 
;#	$header	᡼إå
;# 
;# 	顼å(ʤ"")

	my($header) = @_;
	my(@header, $incorrect);

	;# EUC-JPѴ
	require "jcode.pl";
	&jcode::convert(\$header, 'euc');

	@header = split(/\n/, $header);
	$incorrect = 0;
	foreach (@header) {
		@field = split(/:/);
		;# إå̾ SPACE/:/ܸ ޤޤƤϥإåǤϤʤ
		if (($field[0] =~ /[\s\:]/) || ($field[0] =~ /$euc_jp/ox)) {
			$incorrect = 1; last;
		}
		elsif (!(/^From:|Subject:|Reply-To:/i)) {
			$incorrect = 1; last;
		}
	}
	if ($incorrect) {
		return "ʥإå¸ߤޤ\n";
	}
	return '';
}

1;
