#!/usr/bin/perl
# Copyright (C) 2000-2005 NEC Corporation
# All Rights Reserved.

# RCS: $Id: disk.pl,v 1.9 2005/09/26 11:59:36 snavi Exp $

##001204 v5.1  ǥ̤edquotaˤ S.Oku
##010109 v5.1  NfsMount() ɲ S.Oku
##010116 v5.1  SmbMount() NfsUnMount() SmbUnMount() nfscheck() smbcheck() DiskFirst() putwbmcsmb() ɲ S.Oku
##010117 v5.1  getWorkgroup() ɲ S.Oku
##010117 v5.1  SmbMount() 桼̾ѥɾά S.Oku
##010123 3.10  /etc/rc.d/init.d/wbmcsmb Υ  S.Oku(haramoto)
##010208 v4.0.1   disk2_help 
##010418 v4.0.1  PartCapa() getDomainQuotaUsed() getUserQuotaUsed() 
##010507 v4.0.1  getRaidStatus() getRaidUse() getBadDevice() getRaidPart() getRecoverTime() getRecoverPart()   S.Oku
##010703 v4.1.0  quota KBñ б S.Oku
##010704 v4.1.0  \Q  \E б S.Oku
##010712 v4.1.0  getRaidUse() standaloneLB Raidɽ S.Oku
##021016 v5.0  smbmount ޥɤ mount ޥɤѤ褦ѹ oyama
##021025 v5.0  getDomainQuotaUsed2 ɲ getDomainQuotaUsed() 
##050926 v5.1.2 SmbMount  backup Ƥ wbmc_smbmnt ɵʤ褦 oyama

#--------------------------------------------------------------------------

require "/opt/nec/wbmc/lib/wbmc.pl";
require "$WBMC_DOMLIB_DIR/wbmc.pl";

############################################################################
#  <̾>
#        PartCapa
#  <>
#       ѡƥ̎̎Ψ
#  <>
#       PartCapa($part)
#  <>
#       ($part)     : ѡƥ̾
#  <>
#        ｪλ : (MB or KB):(MB or KB):Ψ(%)   (̤Ȼ̤Ͼʲڤ夲)
#        ۾ｪλ : -1
#
############################################################################


sub PartCapa{

	local($part,$kb) = @_;
	local($mkdir);
	local($mount,$umount);
	local($mntpoint);
	local($df);
	local($total,$used,$capa,$rtn_code,$found);

	$mkdir = "/bin/mkdir";
	$mount = "/bin/mount";
	$umount = "/bin/umount";
	$mntpoint = "/mnt/wbmc_chk";
	$df = "/bin/df";
	$rtn_code = -1;
	$found = 0;
	if($part eq ""){return($rtn_code);}

	if (!open(IN, "$mount |")) {
		return($rtn_code);
	}

	while (<IN>) {
		s/\s*$//;
		@ent = split();
		$ent[0] =~ s/^\s\s$//;
		if ($ent[0] eq $part) {
			$found = 1;
		}
	}
	close(IN);

	if ($found ne "1") {
		# ޥȤ
		if(!(-d "/mnt/wbmc_chk")){
			if (system("$mkdir $mntpoint")) {
				return($rtn_code);
			}
		}
		if (system("$mount $part $mntpoint > /dev/null")) {
			return($rtn_code);
		}
	}

	# /bin/df ޥɤ̎̎Ψ
	if (open(IN, "$df $part |")) {
		while (<IN>) {
			s/\s*$//;
			@ent = split();
			# ̤MBñ̤Ȥ
#			if($ent[0] eq $part){
## ޥȥݥȤǤ⸡Ǥ褦ѹ 010418
			if(($ent[0] eq $part)||($ent[5] eq $part)){
				if($ent[5] eq ""){return($rtn_code);}
					$total = $ent[2] + $ent[3];
					$used = $ent[2];
					$capa = $ent[4];
					if (($kb !~ /k/)&&($kb !~ /K/)) {
						$total = $total + 1023;
						$total = int($total / 1024);
						$used = $used + 1023;
						$used = int($used / 1024);
					}
				$capa =~ s/\D+$//;
			}
		}
		close(IN);
	}else{
		return($rtn_code);
	}

	if ($found ne "1") {
		system("$umount $mntpoint > /dev/null");
	}

	if($total eq ""){return($rtn_code);}
	elsif($used eq ""){return($rtn_code);}
	elsif($capa eq ""){return($rtn_code);}
	$rtn_code = join(":",$total,$used,$capa);
	return($rtn_code);
}


############################################################################
#  <̾>
#        DomainCapa
#  <>
#       Ϳ줿ǥ쥯ȥ۲λ̤
#  <>
#       DomainCapa($path,$km)
#  <>
#       ($path)     : Хѥʥեѥ
#       ($km)       : b ޤ k ޤ m  ñ(B or KB or MB)λ  ̵꤬MBȤư
#  <>
#        ｪλ : (MB)
#        ۾ｪλ : -1
#
############################################################################


sub DomainCapa{

	local($path,$km) = @_;
	local($du,$cd);
	local($rtn_code);
	
	$rtn_code = -1;
	$cd = "cd";
	$path =~ s/^\s*\s*$//;
	$km =~ s/^\s*\s*$//;

	if($path eq ""){
		return($rtn_code);
	}

	if(($km eq "m")||($km eq "M")||($km eq "")){
		$du = "/usr/bin/du -sm";
	}elsif(($km eq "b")||($km eq "B")){
		$du = "/usr/bin/du -sb";
	}elsif(($km eq "k")||($km eq "K")){
		$du = "/usr/bin/du -sk";
	}else{
		return($rtn_code);
	}

	if (!chdir($path)) {
		return($rtn_code);
	}
	if (open(IN, "$du |")) {
		while (<IN>) {
			s/\s*$//;
			@ent = split();
			$rtn_code = $ent[0];
			if($rtn_code == 0){
				$rtn_code = 1;
			}
		}
		close(IN);
	}else{
		return($rtn_code);
	}

	return($rtn_code);

}

############################################################################
#  <̾>
#        getClusterType
#  <>
#        INITCONF.INI鱿ѷ֤
#  <>
#        getClusterType()
#  <>
#        ʤ
#  <>
#        ｪλ : "" , "cluster" , "mirror"
#        ۾ｪλ : -1
#
############################################################################

sub getClusterType(){
	local($initconf_file , $initconf_lock);
	local(@file) = ();
	local($i , $type , $rtn_code);

	$initconf_file = "/etc/opt/nec/wbmc/INITCONF.INI";
	$initconf_lock = "INITCONF.INI";
	$i = 0;
	$rtn_code = -1;
	$type = "";

	if (!&readFile($initconf_file ,$initconf_lock, *file)) {
		return($rtn_code);
	}

	for ($i = 0; $i < @file; $i++) {
		if ($file[$i] =~ /WorkMode=/) {
			$type = $file[$i];
			$type =~ s/WorkMode=//;
			$type =~ s/^\s+\s+$//;
			$type =~ s/\n$//;
			if ($type eq "MailCluster") {
				$rtn_code = "cluster";
			}elsif ($type eq "WebLoadbalance") {
				$rtn_code = "mirror";
			}elsif ($type eq "Standalone") {
				$rtn_code = "";
			}
		}
	}
	return($rtn_code);
}

############################################################################
#  <̾>
#        diskWait
#  <>
#        mkfsΥॢȤɤ
#  <>
#        diskWait()
#  <>
#        ʤ
#  <>
#	 ʤ
############################################################################

sub diskWait
{
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>ե륷ƥ</TITLE>
</HEAD>
<BODY>
<TABLE BORDER=0 CELSPACING=0>
<TR>
<TD>
<H1 ALIGN"center">ե륷ƥƤޤ</H1>
<BR>ΤޤޤФ餯Ԥ
</TD>
</TR>
</TABLE>
<HR>
END_OF_DATA

$count = 0;
	for(;;) {
		if($count eq "0"){
		print "<TABLE><TR><TD></TD></TR></TABLE><H1>";
		}elsif(($count eq "0")||($count % 20)){
			print "";
		}else{
			print "<BR>";
		}
		# ॢбΤᡢSTDOUХåեեå夹롣
		#
		$buff = select(STDOUT);
		$| = 1;
		select($buff);
		sleep 1;         # 1äޤ
		$count++;
	}

}

############################################################################
#  <̾>
#        getDomainQuotaUsed2
#  <>
#        quotaޥɤˤꥰ롼ñ̤λ̤롣
#  <>
#        getDomainQuotaUsed2($domain)
#  <>
#        ɥᥤ̾
#  <>
#	      
#        ۾ -1
############################################################################

sub getDomainQuotaUsed2{

	local($domain) = @_;
	local($quota,$group,$part);
	local($rtn_code);
	local(@part2,@tmp,@tmp2,@lines) = ();

	local $quota_file = "/opt/nec/tmp/quota.tmp";
	
	$rtn_code = -1;
	$quota = "/usr/sbin/edquota -g";

	$domain =~ s/^\s*//;
	$domain =~ s/\s*$//;
	$group = &getDomainConf($domain , "GROUPNAME");
	$part = &getDomainConf($domain , "WEB_PART");
	@part2 = split(/:/,$part);
	$part = $part2[0];
	$part =~ s/\s//g;

	if(($group eq "")||($part eq "")){
		return($rtn_code);
	}

  $ENV{'EDITOR'} = $WBMC_BIN_DIR . "/wbmcedquota2";
  $ENV{'WBMC_QUOTA_FS'} = "";

#	if (open(IN, "$quota $group |")) {
## clusterбΰ١ 2>&1 ɲ  010418
#	if (open(IN, "$quota $group 2>&1 |")) {
#		while(<IN>) {
## edquota ¹Ը塢եɤ߹ߤʤʤΤǥեΥѥ֤
	if (system("$quota $group > $quota_file 2>&1") == 0) {
		return($quota_file);
#            @tmp = split(/:/);
#			$tmp[0] =~ s/\s//g;
#			if(($tmp[1] =~ /blocks in use/)&&($tmp[0] eq "$part")){   
#				@tmp2 = split(/,/,$tmp[2]);
#				$tmp2[0] =~ s/\s//g;
#				$rtn_code = $tmp2[0];
#				$rtn_code = int(($rtn_code + 1023) / 1024);
#				last;
#			}
#		}
	}else{
		return($rtn_code);
	}
	return($rtn_code);

}
############################################################################
#  <̾>
#        getDomainQuotaUsed
#  <>
#        quotaޥɤˤꥰ롼ñ̤λ̤롣
#  <>
#        getDomainQuotaUsed($domain)
#  <>
#        ɥᥤ̾
#  <>
#             롼ñ̤λ
#        ۾ -1
############################################################################
sub getDomainQuotaUsed {

        local($domain) = @_;
        local($quota,$group,$part);
        local($rtn_code);
        local $tmp;
        $rtn_code = -1;

	$domain =~ s/^\s*//;
	$domain =~ s/\s*$//;
	$group = &getDomainConf($domain , "GROUPNAME");
	$part = &getDomainConf($domain , "WEB_PART");
	@part2 = split(/:/,$part);
	$part = $part2[0];
	$part =~ s/\s//g;

        my $quota_file = &getDomainQuotaUsed2($domain);
        if ( $quota_file == -1 ){
                return($rtn_code);
        }
        open(IN,$quota_file);
        while (<IN>){
                $_ =~ /^\s+(.*)/;
                $tmp = $1;
                $tmp =~ s/(\s)+/$1/g;
                @tmp2 = split(/ /,$tmp);
                if ( ($part eq $tmp2[0]) && ($tmp2[1] =~ /^\d+/) && ($tmp2[2] =~ /^\d+/) ) {
                        $rtn_code = $tmp2[1];
                        last;
                }
        }
	unlink($quota_file);
        return($rtn_code);
}

############################################################################
#  <̾>
#        getUserQuotaUsed
#  <>
#        quotaޥɤˤ桼ñ̤λ̤롣
#  <>
#        getUserQuotaUsed($user)
#  <>
#        桼̾
#  <>
#	      
#        ۾ -1
############################################################################

sub getUserQuotaUsed{

	local($user) = @_;
	local($quota);
	local($rtn_code);
	
	$rtn_code = -1;
	$quota = "quota -u";

	if($user eq ""){
		return($rtn_code);
	}
#	if (open(IN, "$quota $user |")) {
## clusterбΰ١ 2>&1 ɲ  010418
	if (open(IN, "$quota $user 2>&1 |")) {
		while (<IN>) {
			s/\s*$//;
			@ent = split();
			$ent[0] =~ s/^\s+\s+$//;
			$ent[0] =~ s/^\s+\s+$//;
			if($ent[0] =~ /Filesystem/){
				next;
			}elsif(($ent[0] eq "Disk")&&($ent[1] eq "quotas")){
				next;
			}else{
				$ent[1] =~ s/\*$//;
				if($ent[1] =~ /\D+/){
					$rtn_code = -1;
					return($rtn_code);
				}else{
					$rtn_code = $ent[1];
#					$rtn_code = int(($rtn_code + 1023) / 1024);
					return($rtn_code);
				}
			}
		}
		close(IN);
	}else{
		return($rtn_code);
	}

	return($rtn_code);

}

############################################################################
#  <̾>
#        NfsMount
#  <>
#        NFSѤ¾ФΥե(ǥ쥯ȥ)ޥȤ
#  <>
#        NfsMount($server, $target, $mntpnt)
#  <>
#        $server ޥȤоݤȤʤޥ̾ or IPɥ쥹
#        $target ޥȤоݤȤʤǥ쥯ȥ̾
#        $mntpnt ޥȥݥ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub NfsMount{

	local($server, $target, $mntpnt) = @_;
	local($rtn_code, $cmd, $i, $fstab, $fstab_lock, $mtab, $mtab_lock, $line, $smbmnt, $smbmnt_lock) = "";
	local(@server, @target, @mntpnt, @line, @file) = ();
	local(*IN);

	$fstab = "/etc/fstab";
	$fstab_lock = "fstab";
	$mtab = "/etc/mtab";
	$mtab_lock = "mtab";
	$smbmnt = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$smbmnt_lock = "wbmc_smbmnt";
	$server =~ s/^\s+//;
	$server =~ s/\s+$//;
	$server2 =~ s/\.//g;
	$server2 =~ s/-//g;
	$server2 =~ s/_//g;
	$target =~ s/^\s+//;
	$target =~ s/\s+$//;
	$mntpnt =~ s/^\s+//;
	$mntpnt =~ s/\s+$//;
	$mntpnt =~ s/\/+$//;

## ͥå
	@server = split(/\s+/,$server);
	@target = split(/\s+/,$target);
	@mntpnt = split(/\s+/,$mntpnt);
	if ($server[1]) {
		return("̾Ǥ");
	}
	if ($target[1]) {
		return("ǥ쥯ȥ̾Ǥ");
	}
	if ($mntpnt[1]) {
		return("ޥȥݥȤǤ");
	}
	if (!$server) {
		return("ޥоݤΥ̾ꤷƲ");
	}
	elsif (!$target) {
		return("ޥоݤΥǥ쥯ȥ̾ꤷƲ");
	}
	elsif (!$mntpnt) {
		return("ޥȥݥȤꤷƲ");
	}
	if ($server =~ /^[^a-zA-Z0-9]/) {
		return("ޥоݤΥ̾Ǥ");
	}
	if ($server2 =~ /[^a-zA-Z0-9]/) {
		return("ޥоݤΥ̾Ǥ");
	}
	if ($target !~ /^\//) {
		return("ޥоݤΥǥ쥯ȥХѥǻꤷƲ");
	}
	if ($mntpnt !~ /^\/mnt\//) {
		return("ޥȥݥȤ /mnt/ ꤷƲ");
	}
	if ($mntpnt eq "/mnt/floppy") {
		return("$mntpnt ѤǤޤ");
	}
	if ($mntpnt eq "/mnt/cdrom") {
		return("$mntpnt ѤǤޤ");
	}

	#
	# /bin/mount , /etc/fstab , wbmc_smbmntޥȰơޥȥݥȤ
	# ˻ѤƤʤå롣
	if (!open(IN, "/bin/mount |")) {
		return("ޥȰǤޤǤ");
		exit(1);
	}
	@line = <IN>;
	close(IN);
	for ($i=0; $i<@line; $i++) {
		if ($line[$i] =~ /\s+on\s+\Q$mntpnt\E\s+/) {
			return("ޥȥݥ $mntpnt ϴ˻ѤƤޤ");
			exit(1);
		}
	}
	if (!&readFile($fstab ,$fstab_lock, *file)) {
		return("$fstab ɤ߹ߤ˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\s+\Q$mntpnt\E\s+/) {
			return("ޥȥݥ $mntpnt ϴ˻ѤƤޤ");
			exit(1);
		}
	}
	@file = ();
	if (!&readFile($smbmnt ,$smbmnt_lock, *file)) {
		return("$smbmnt ɤ߹ߤ˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\s+\Q$mntpnt\E\s+-o\s+username=/) {
			return("ޥȥݥ $mntpnt ϴ˻ѤƤޤ");
			exit(1);
		}
	}
	@file = ();

## ޥȥޥȯ
	if (!-d $mntpnt) {
		system("/bin/mkdir $mntpnt");
	}
	$cmd = "/bin/mount -t nfs -o soft $server:$target $mntpnt";
	if (system("$cmd")) {
		$mntpnt =~ s/\/$//;
		if ($mntpnt ne "/mnt/cdrom" && $mntpnt ne "/mnt/floppy") {
			system("/bin/rmdir $mntpnt");
		}
		return("ޥȤǤޤǤ");
	}

## /etc/fstab Խ
	$line = "";
	## /etc/mtab fstab˽񤭹
		if (!&readFile($mtab ,$mtab_lock, *file)) {
			return("$mtab ɤ߹ߤ˼ԤޤƥƵưˡޥȤޤ");
		}
		for ($i=0; $i<@file; $i++) {
			if ($file[$i] =~ /\s*\Q$server:$target\E\s+\Q$mntpnt\E\s+nfs/) {
				$line = $file[$i];
			}
		}
		if ($line eq "") {
			return("$fstab ˼ԤޤƥƵưˡޥȤޤ");
		}
	@file = ();
	if (!&readFile($fstab ,$fstab_lock, *file)) {
		return("$fstab ɤ߹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\s*\Q$server:$target\E\s+\Q$mntpnt\E\s+nfs/) {
			return($rtn_code);
		}
	}
	push(@file,$line);
	if (!&writeFile($fstab, $fstab_lock, @file)) {
        	return("$fstab ν񤭹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}

## ｪλ
	return($rtn_code);
}

############################################################################
#  <̾>
#        SmbMount
#  <>
#        SAMBAѤWindowsޥζͭեޥȤ
#  <>
#        SmbMount($server, $target, $mntpnt, $username, $passwd)
#  <>
#        $server ޥȤоݤȤʤޥ̾ or IPɥ쥹
#        $target ޥȤоݤȤʤǥ쥯ȥ̾
#        $mntpnt ޥȥݥ
#        $username 桼̾
#        $passwd ѥ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub SmbMount{

	local($server, $target, $mntpnt, $username, $passwd, $workgroup) = @_;
	local($rtn_code, $cmd, $server2, $i, $wbmcsmb, $wbmcsmb_lock, $wbmcsmb2, $wbmcsmb2_lock, $fstab, $fstab_lock) = "";
	local(@server, @target, @mntpnt, @username, @passwd, @line, @file, @workgroup) = ();
	local(*IN);

	$wbmcsmb = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$wbmcsmb_lock = "wbmc_smbmnt";
	$wbmcsmb2 = "/etc/opt/nec/wbmc/wbmc_smbunmnt";
	$wbmcsmb2_lock = "wbmc_smbunmnt";
	$fstab = "/etc/fstab";
	$fstab_lock = "fstab";
	$server =~ s/^\s+//;
	$server =~ s/\s+$//;
	$server2 = $server;
	$server2 =~ s/\.//g;
	$server2 =~ s/-//g;
	$server2 =~ s/[0-9A-Za-z_]//g;
	$target =~ s/^\s+//;
	$target =~ s/\s+$//;
	$mntpnt =~ s/^\s+//;
	$mntpnt =~ s/\s+$//;
	$mntpnt =~ s/\/+$//;
	$username =~ s/^\s+//;
	$username =~ s/\s+$//;
	$passwd =~ s/^\s+//;
	$passwd =~ s/\s+$//;
	$workgroup =~ s/^\s+//;
	$workgroup =~ s/\s+$//;

## ͥå
	@server = split(/\s+/,$server);
	@target = split(/\s+/,$target);
	@mntpnt = split(/\s+/,$mntpnt);
	@username = split(/\s+/,$username);
	@passwd = split(/\s+/,$passwd);
	@workgroup = split(/\s+/,$workgroup);
	if ($workgroup[1]) {
		return("롼̾Ǥ");
	}
	if ($server[1]) {
		return("Windowsޥ̾Ǥ");
	}
	if ($target[1]) {
		return("ͭ̾Ǥ");
	}
	if ($mntpnt[1]) {
		return("ޥȥݥȤǤ");
	}
	if ($username[1]) {
		return("桼̾Ǥ");
	}
	if ($passwd[1]) {
		return("ѥɤǤ");
	}
	if (!$workgroup) {
		return("롼̾ꤷƲ");
	}
	elsif (!$server) {
		return("ޥоݤWindowsޥ̾ꤷƲ");
	}
	elsif (!$target) {
		return("ޥоݤζͭե̾ꤷƲ");
	}
	elsif (!$mntpnt) {
		return("ޥȥݥȤꤷƲ");
	}
#	elsif (!$username) {
#		return("桼̾ꤷƲ");
#	}
#	elsif (!$passwd) {
#		return("ѥɤϤƲ");
#	}
	if ($server !~ /^[a-zA-Z0-9]/) {
		return("ޥоݤWindowsޥ̾Ǥ");
	}
#	if ($server2 !~ /[a-zA-Z0-9]/) {
#		return("ޥоݤWindowsޥ̾Ǥ");
#	}
	if ($server2) {
		return("ޥоݤWindowsޥ̾Ǥ");
	}
	if ($mntpnt !~ /^\/mnt\//) {
		return("ޥȥݥȤ /mnt/ ꤷƲ");
	}
	if ($mntpnt eq "/mnt/floppy") {
		return("$mntpnt ѤǤޤ");
	}
	if ($mntpnt eq "/mnt/cdrom") {
		return("$mntpnt ѤǤޤ");
	}

	#
	# /bin/mount fstab wbmc_smbmntޥȰơޥȥݥȤ
	# ˻ѤƤʤå롣
	if (!open(IN, "/bin/mount |")) {
		return("ޥȰǤޤǤ");
		exit(1);
	}
	@line = <IN>;
	close(IN);
	for ($i=0; $i<@line; $i++) {
		if ($line[$i] =~ /\s+on\s+\Q$mntpnt\E\s+/) {
			return("ޥȥݥ $mntpnt ϴ˻ѤƤޤ");
			exit(1);
		}
	}
	if (!&readFile($fstab ,$fstab_lock, *file)) {
		return("$fstab ɤ߹ߤ˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\s+\Q$mntpnt\E\s+/) {
			return("ޥȥݥ $mntpnt ϴ˻ѤƤޤ");
			exit(1);
		}
	}
	@file = ();
	if (!&readFile($wbmcsmb ,$wbmcsmb_lock, *file)) {
		return("$wbmcsmb ɤ߹ߤ˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\s+\Q$mntpnt\E\s+-o\s+username=/) {
			return("ޥȥݥ $mntpnt ϴ˻ѤƤޤ");
			exit(1);
		}
	}
	@file = ();

## ޥȥޥȯ
	if (!-d $mntpnt) {
		system("/bin/mkdir $mntpnt");
	}
#	$cmd = "/usr/sbin/smbmount //$server/$target $mntpnt -o username=$username/$workgroup\%$passwd";
	$cmd = "/bin/mount -t smbfs -o username=$username,password=$passwd,workgroup=$workgroup //$server/$target $mntpnt";
	if (system("$cmd")) {
		$mntpnt =~ s/\/$//;
		if ($mntpnt ne "/mnt/cdrom" && $mntpnt ne "/mnt/floppy") {
			system("/bin/rmdir $mntpnt");
		}
		return("ޥȤǤޤǤ");
	}
	# 2005/09/26 oyama
	# samba backup ƤФ줿ˤ wbmc_smbmnt ˽񤫤ʤ
	if ( $mntpnt =~ /^\/mnt\/.*_tmp_smbmnt.*$/ ){
		goto func_exit;
	}

## ƥ൯ưͭˤ٤ /etc/opt/nec/wbmc/wbmc_smbmnt Խ
	if (!&readFile($wbmcsmb ,$wbmcsmb_lock, *file)) {
		return("$wbmcsmb ɤ߹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\/usr\/sbin\/smbmount\s+\/\/\Q$server\E\/\Q$target\E\s+\Q$mntpnt\E\s+-o\s+username=\Q$username\E,password=\Q$passwd\E/) {
			return($rtn_code);
		}
	}
	push(@file,$cmd);
	push(@file,"\n");
	if (!&writeFile($wbmcsmb, $wbmcsmb_lock, @file)) {
        	return("$wbmcsmb ν񤭹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}

## ƥ߻˥ޥ
	@file = ();
	if (!&readFile($wbmcsmb2 ,$wbmcsmb2_lock, *file)) {
		return("$wbmcsmb2 ɤ߹ߤ˼ԤޤƥߤˡɬޥȤƲ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\/bin\/umount \Q$mntpnt\E\n/) {
			return($rtn_code);
		}
	}
	$cmd = "/bin/umount $mntpnt";
	push(@file,$cmd);
	push(@file,"\n");
	if (!&writeFile($wbmcsmb2, $wbmcsmb2_lock, @file)) {
        	return("$wbmcsmb2 ν񤭹ߤ˼ԤޤƥߤˡɬޥȤƲ");
	}
# 2005/09/26 oyama ٥ 
func_exit:

## ｪλ
	return($rtn_code);
}

############################################################################
#  <̾>
#        NfsUnMount
#  <>
#        NFSǥޥȤƤΤ򥢥ޥȤ롣
#  <>
#        NfsUnMount($mntpnt)
#  <>
#        $mntpnt ޥȥݥ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub NfsUnMount{

	local($mntpnt) = @_;
	local($rtn_code, $i, $fstab, $fstab_lock, $line, $hit) = "";
	local(@line, @file, @line2) = ();
	local(*IN);

	$fstab = "/etc/fstab";
	$fstab_lock = "fstab";
	$mntpnt =~ s/^\s+//;
	$mntpnt =~ s/\s+$//;
	$mntpnt =~ s/\/$//;
	$hit = 0;

	if (system("/bin/umount $mntpnt")) {
		if (!open(IN, "/bin/mount |")) {
		}
		else {
			@line2 = <IN>;
			close(IN);
			for ($i=0; $i<@line2; $i++) {
				if ($line2[$i] =~ /\s+on\s+\Q$mntpnt\E\s+/) {
					$hit = 1;
				}
			}
			if ($hit == 0) {
				goto ok;
			}
		}
		return("ǽޤǤ<BR>ǥХǤǽޤ");
	}
ok:
	if ($mntpnt ne "/mnt/cdrom" && $mntpnt ne "/mnt/floppy") {
		system("/bin/rmdir $mntpnt");
	}

	if (!&readFile($fstab ,$fstab_lock, *file)) {
		return("$fstab ɤ߹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}
	for ($i=0; $i<@file; $i++) {
		@line = split(/\s+/,$file[$i]);
		if ($line[1] eq $mntpnt) {
			splice(@file,$i,1);
			$i--;
			@line = ();
		}
	}
	push(@file,$line);
	if (!&writeFile($fstab, $fstab_lock, @file)) {
        	return("$fstab ν񤭹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}

## ｪλ
	return($rtn_code);

}

############################################################################
#  <̾>
#        SmbUnMount
#  <>
#        SAMBAǥޥȤƤΤ򥢥ޥȤ
#  <>
#        SmbUnMount($mntpnt)
#  <>
#        $mntpnt ޥȥݥ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub SmbUnMount{

	local($mntpnt) = @_;
	local($rtn_code, $i, $wbmcsmb, $wbmcsmb_lock, $wbmcsmb2, $wbmcsmb2_lock) = "";
	local(@mntpnt, @line, @file) = ();

	$wbmcsmb = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$wbmcsmb_lock = "wbmc_smbmnt";
	$wbmcsmb2 = "/etc/opt/nec/wbmc/wbmc_smbunmnt";
	$wbmcsmb2_lock = "wbmc_smbunmnt";
	$mntpnt =~ s/^\s+//;
	$mntpnt =~ s/\s+$//;
	$mntpnt =~ s/\/$//;

	system("/bin/sync > /dev/null 2>&1");
	if (system("/bin/umount $mntpnt")) {
		return("ǽޤǤ<BR>ǥХǤ뤫⤷ϥޥоݤΥޥߤƤǽޤ");
	}
	if ($mntpnt ne "/mnt/cdrom" && $mntpnt ne "/mnt/floppy") {
		system("/bin/rmdir $mntpnt");
	}

## /etc/opt/nec/wbmc/wbmc_smbmnt Խ
	if (!&readFile($wbmcsmb ,$wbmcsmb_lock, *file)) {
		return("$wbmcsmb ɤ߹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}
	for ($i=0; $i<@file; $i++) {
		$file[$i] =~ s/^\s+//;
		@line = split(/\s+/,$file[$i]);
		if ($line[2] eq $mntpnt) {
			splice(@file,$i,1);
			$i--;
			@line = ();
		}
		@line = ();
	}
	if (!&writeFile($wbmcsmb, $wbmcsmb_lock, @file)) {
        	return("$wbmcsmb ν񤭹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}

## /etc/opt/nec/wbmc/wbmc_smbunmnt Խ
	@file = ();
	if (!&readFile($wbmcsmb2 ,$wbmcsmb2_lock, *file)) {
		return("$wbmcsmb2 ɤ߹ߤ˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\/bin\/umount \Q$mntpnt\E\n/) {
			splice(@file,$i,1);
			$i--;
		}
	}
	if (!&writeFile($wbmcsmb2, $wbmcsmb2_lock, @file)) {
        	return("$wbmcsmb2 ν񤭹ߤ˼Ԥޤ");
	}

## ｪλ
	return($rtn_code);
}

############################################################################
#  <̾>
#        DiskFirst
#  <>
#        /etc/opt/nec/wbmc/wbmc_smbmnt (wbmc_smbunmnt) 
#        ¸ߤв⤷ʤ
#  <>
#        DiskFirst()
#  <>
#        ʤ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
#
#    wbmc_smbmnt  桼̾ȥѥɤʿʸǽ񤭹١
#          ownergroup root Ȥ 700 Ȥ롣
############################################################################

sub DiskFirst{

	local($rtn_code, $wbmcsmb, $wbmcsmb2, $err) = "";

	$wbmcsmb = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$wbmcsmb2 = "/etc/opt/nec/wbmc/wbmc_smbunmnt";

	if (!-f $wbmcsmb) {
		## ̵к
		if (system("/bin/touch $wbmcsmb")) {
			return("$wbmcsmb κ˼Ԥޤ");
		}
		## ѹ
		if (system("/bin/chmod 700 $wbmcsmb")) {
			system("/bin/rm -f $wbmcsmb");
			return("$wbmcsmb κ˼Ԥޤ");
		}
		if (system("/bin/chown root $wbmcsmb")) {
			system("/bin/rm -f $wbmcsmb");
			return("$wbmcsmb κ˼Ԥޤ");
		}
		if (system("/bin/chgrp root $wbmcsmb")) {
			system("/bin/rm -f $wbmcsmb");
			return("$wbmcsmb κ˼Ԥޤ");
		}
	}
	else {
		system("/bin/chmod 700 $wbmcsmb");
		system("/bin/chown root $wbmcsmb");
		system("/bin/chgrp root $wbmcsmb");
	}
	if (!-f $wbmcsmb2) {
		## ̵к
		if (system("/bin/touch $wbmcsmb2")) {
			return("$wbmcsmb2 κ˼Ԥޤ");
		}
		## ѹ
		if (system("/bin/chmod 700 $wbmcsmb2")) {
			system("/bin/rm -f $wbmcsmb2");
			return("$wbmcsmb2 κ˼Ԥޤ");
		}
		if (system("/bin/chown root $wbmcsmb2")) {
			system("/bin/rm -f $wbmcsmb2");
			return("$wbmcsmb2 κ˼Ԥޤ");
		}
		if (system("/bin/chgrp root $wbmcsmb2")) {
			system("/bin/rm -f $wbmcsmb2");
			return("$wbmcsmb2 κ˼Ԥޤ");
		}
	}
	else {
		system("/bin/chmod 700 $wbmcsmb2");
		system("/bin/chown root $wbmcsmb2");
		system("/bin/chgrp root $wbmcsmb2");
	}

	if ($err = &putwbmcsmb()) {
		return($err);
	}

	return($rtn_code);
}

############################################################################
#  <̾>
#        Smb2Network
#  <>
#        /etc/rc.d/init.d/network samba εưߥ񤭹
#  <>
#        Smb2Network()
#  <>
#        ʤ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub Smb2Network{

	local($rtn_code, $wbmcsmb, $wbmcsmb2, $network, $network_lock) = "";
	local($i, $start, $stop, $sh1, $sh2) = "";
	local(@file) = ();

	$wbmcsmb = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$wbmcsmb2 = "/etc/opt/nec/wbmc/wbmc_smbunmnt";
	$network = "/etc/rc.d/init.d/network";
	$network_lock = "network";

	if (!&readFile($network ,$network_lock, *file)) {
		return("$network ˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /source\s+$wbmcsmb/) {
			$start = 1;
		}
		if ($file[$i] =~ /source\s+$wbmcsmb2/) {
			$stop = 1;
		}
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\s+touch\s+\/var\/lock\/subsys\/network/) {
			if ($start) {
				next;
			}
			else {
				$sh1 = "\tsource $wbmcsmb\n";
				splice(@file,$i+1,0,$sh1);
				$start = 1;
			}
		}
		if ($file[$i] =~ /\sstop\)/) {
			if ($stop) {
				next;
			}
			else {
				$sh2 = "\tsource $wbmcsmb2\n";
				splice(@file,$i+1,0,$sh2);
				$stop = 1;
			}
		}
	}
	if (!&writeFile($network, $network_lock, @file)) {
        	return("$network ؤν񤭹ߤ˼Ԥޤ");
	}

	return($rtn_code);
}

############################################################################
#  <̾>
#        putwbmcsmb
#  <>
#        /etc/rc.d/init.d/ samba εưߥwbmcsmb
#  <>
#        putwbmcsmb()
#  <>
#        ʤ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub putwbmcsmb{

	local($rtn_code, $wbmcsmb, $wbmcsmb2) = "";

	$wbmcsmb = "/etc/opt/nec/wbmc/wbmcsmb";		##010123
	$wbmcsmb2 = "/etc/rc.d/init.d/wbmcsmb";

	if (!-f $wbmcsmb2) {
		if (system("/bin/cp $wbmcsmb $wbmcsmb2")) {
			return("$wbmcsmb2 κ˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
		}
	}
	##010123 add next 3 line
	if (system("/bin/chmod 755 $wbmcsmb2")) {
		return("$wbmcsmb2 κ˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
	}
	if (!-l "/etc/rc.d/rc0.d/K85wbmcsmb") {
		if (system("/bin/ln -s /etc/rc.d/init.d/wbmcsmb /etc/rc.d/rc0.d/K85wbmcsmb")) {
			return("$wbmcsmb2 Υܥå󥯺˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
		}
	}
	if (!-l "/etc/rc.d/rc1.d/K85wbmcsmb") {
		if (system("/bin/ln -s /etc/rc.d/init.d/wbmcsmb /etc/rc.d/rc1.d/K85wbmcsmb")) {
			return("$wbmcsmb2 Υܥå󥯺˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
		}
	}
	if (!-l "/etc/rc.d/rc2.d/K85wbmcsmb") {
		if (system("/bin/ln -s /etc/rc.d/init.d/wbmcsmb /etc/rc.d/rc2.d/K85wbmcsmb")) {
			return("$wbmcsmb2 Υܥå󥯺˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
		}
	}
	if (!-l "/etc/rc.d/rc3.d/S15wbmcsmb") {
		if (system("/bin/ln -s /etc/rc.d/init.d/wbmcsmb /etc/rc.d/rc3.d/S15wbmcsmb")) {
			return("$wbmcsmb2 Υܥå󥯺˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
		}
	}
	if (!-l "/etc/rc.d/rc4.d/S15wbmcsmb") {
		if (system("/bin/ln -s /etc/rc.d/init.d/wbmcsmb /etc/rc.d/rc4.d/S15wbmcsmb")) {
			return("$wbmcsmb2 Υܥå󥯺˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
		}
	}
	if (!-l "/etc/rc.d/rc5.d/S15wbmcsmb") {
		if (system("/bin/ln -s /etc/rc.d/init.d/wbmcsmb /etc/rc.d/rc5.d/S15wbmcsmb")) {
			return("$wbmcsmb2 Υܥå󥯺˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
		}
	}
	if (!-l "/etc/rc.d/rc6.d/K85wbmcsmb") {
		if (system("/bin/ln -s /etc/rc.d/init.d/wbmcsmb /etc/rc.d/rc6.d/K85wbmcsmb")) {
			return("$wbmcsmb2 Υܥå󥯺˼Ԥޤ ƥ߻ˤϡ³Ƥsambaե륷ƥɬǤƤߤƤ");
		}
	}
#	if (system("/etc/rc.d/init.d/wbmcsmb start > /dev/null")) {
#
#	}
	return($rtn_code);
}

############################################################################
#  <̾>
#        smbcheck
#  <>
#        wbmc_smbmnt , wbmc_smbunmnt ȸߥޥȤƤΤȤ٤ơ
#        н롣
#  <>
#        smbcheck()
#  <>
#        ʤ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub smbcheck{

	local($rtn_code, $wbmcsmb, $wbmcsmb2, $wbmcsmb_lock, $wbmcsmb2_lock) = "";
	local(@smbmnt, @smbunmnt, @line, @smb) = ();
	local(*IN);
	local($hit, $smbmp, $i, $j) = "";

	$wbmcsmb = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$wbmcsmb2 = "/etc/opt/nec/wbmc/wbmc_smbunmnt";
	$wbmcsmb_lock = "wbmc_smbmnt";
	$wbmcsmb2_lock = "wbmc_smbunmnt";

## wbmc_smbmnt ɤ߹
	if (!&readFile($wbmcsmb ,$wbmcsmb_lock, *smbmnt)) {
		return("$wbmcsmb ɤ߹ߤ˼Ԥޤ");
	}
## wbmc_smbunmnt ɤ߹
	if (!&readFile($wbmcsmb2 ,$wbmcsmb2_lock, *smbunmnt)) {
		return("$wbmcsmb2 ɤ߹ߤ˼Ԥޤ");
	}
## ޥȤƤΤΰ롣
	if (!open(IN, "/bin/mount |")) {
		return("ޥȰǤޤǤ");
	}
	@line = <IN>;
	close(IN);

## wbmc_smbmnt  ----> @smbmnt
## wbmc_smbunmnt ---> @smbunmnt
## mount -----------> @line

	for ($i=0; $i<@smbmnt; $i++) {
		$hit = 0;
		@smb = ();
		$smbmp = "";
		@smb = split(/\s+/,$smbmnt[$i]);
		$smbmp = $smb[2];
			for ($j=0; $j<@line; $j++) {
				if ($line[$j] !~ /\s+type\s+smbfs\s+/) {
					next;
				}
				if ($line[$j] =~ /\s+on\s+\Q$smbmp\E\s+/) {
					$hit = 1;
				}
			}
			if ($hit == 0) {
				splice(@smbmnt,$i,1);
				$i--;
			}
	}
	for ($i=0; $i<@smbunmnt; $i++) {
		$hit = 0;
		@smb = ();
		$smbmp = "";
		@smb = split(/\s+/,$smbunmnt[$i]);
		$smbmp = $smb[1];
			for ($j=0; $j<@line; $j++) {
				if ($line[$j] !~ /\s+type\s+smbfs\s+/) {
					next;
				}
				if ($line[$j] =~ /\s+on\s+\Q$smbmp\E\s+/) {
					$hit = 1;
				}
			}
			if ($hit == 0) {
				splice(@smbunmnt,$i,1);
				$i--;
			}
	}

	if (!&writeFile($wbmcsmb, $wbmcsmb_lock, @smbmnt)) {
        	return("$wbmcsmb ؤν񤭹ߤ˼Ԥޤ");
	}
	if (!&writeFile($wbmcsmb2, $wbmcsmb2_lock, @smbunmnt)) {
        	return("$wbmcsmb2 ؤν񤭹ߤ˼Ԥޤ");
	}

	return($rtn_code);
}

############################################################################
#  <̾>
#        nfscheck
#  <>
#        fstab ȸߥޥȤƤΤȤ٤ơ
#        н롣(NFS Τ)
#  <>
#        nfscheck()
#  <>
#        ʤ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub nfscheck{

	local($rtn_code, $fstab, $fstab_lock) = "";
	local(@line, @file, @nfs) = ();
	local(*IN);
	local($hit, $nfsmp, $i, $j) = "";

	$fstab = "/etc/fstab";
	$fstab_lock = "fstab";

## fstab ɤ߹
	if (!&readFile($fstab ,$fstab_lock, *file)) {
		return("$fstab ɤ߹ߤ˼Ԥޤ");
	}
## ޥȤƤΤΰ롣
	if (!open(IN, "/bin/mount |")) {
		return("ޥȰǤޤǤ");
	}
	@line = <IN>;
	close(IN);

## fstab  ----> @file
## mount -----------> @line

##  ӡ
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] !~ /\s+nfs\s+/) {
			next;
		}
		$hit = 0;
		@nfs = ();
		$nfsmp = "";
		@nfs = split(/\s+/,$file[$i]);
		$nfsmp = $nfs[1];
			for ($j=0; $j<@line; $j++) {
				if ($line[$j] !~ /\s+type\s+nfs\s+/) {
					next;
				}
				if ($line[$j] =~ /\s+on\s+\Q$nfsmp\E\s+/) {
					$hit = 1;
				}
			}
			if ($hit == 0) {
				splice(@file,$i,1);
				$i--;
			}
	}

## /etc/fstab 񤭹
	if (!&writeFile($fstab, $fstab_lock, @file)) {
        	return("$fstab ؤν񤭹ߤ˼Ԥޤ");
	}

	return($rtn_code);
}

############################################################################
#  <̾>
#        getWorkgroup
#  <>
#        smb.conf 롼̾
#  <>
#        getWorkgroup()
#  <>
#        ʤ
#  <>
#	      롼̾
#        ۾ NULL
############################################################################

sub getWorkgroup{

	local($rtn_code, $smbconf, $smbconf_lock) = "";
	local(@file, @smb) = ();
	local($i) = "";

	$smbconf = "/etc/smb.conf";
	$smbconf_lock = "smb.conf";

## smb.conf ɤ߹
	if (!&readFile($smbconf ,$smbconf_lock, *file)) {
		return($rtn_code);
	}
	for ($i=0; $i<@file; $i++) {
		$file[$i] =~ s/^\s+//;
		if ($file[$i] =~ /^\#/) {
			next;
		}
		if ($file[$i] =~ /^\;/) {
			next;
		}
		if ($file[$i] !~ /workgroup\s=\s/) {
			next;
		}
		@smb = split(/=/,$file[$i]);
		$smb[1] =~ s/^\s+//;
		$smb[1] =~ s/\s+$//;
		return($smb[1]);
	}
	return($rtn_code);
}

############################################################################
#  <̾>
#        getSmbStatus
#  <>
#        ư˥ޥȤƤ뤫ɤĴ٤롣
#  <>
#        getSmbStatus($mp)
#  <>
#        $mpޥȥݥ
#  <>
#	     ³桧 mounted
#        桧 unmounted
#           NULL
############################################################################

sub getSmbStatus{

	local($mp) = @_;
	local(@line) = ();
	local(*IN);
	local($i) = "";

	$mp =~ s/^\s+//;
	$mp =~ s/\s+$//;

	if ($mp eq "") {
		return("");
	}
## ޥȤƤΤΰ롣
	if (!open(IN, "/bin/mount |")) {
		return("");
	}
	@line = <IN>;
	close(IN);

	for ($i=0; $i<@line; $i++) {
		if ($line[$i] =~ /\s+on\s+\Q$mp\E\s+/) {
			return("mounted");
		}
	}

	return("unmounted");
}

############################################################################
#  <̾>
#        delFstab
#  <>
#        /etc/fstab 롣
#  <>
#        delFstab($server,$dir,$mntpnt)
#  <>
#        $server	̾
#        $dir		ǥ쥯ȥ̾
#        $mntpnt	ޥȥݥ
#  <>
#	      ̵
#        ۾ 顼å
############################################################################

sub delFstab{

	local($server,$dir,$mntpnt) = @_;
	local($rtn_code, $fstab, $fstab_lock) = "";
	local(@file) = ();
	local($i) = "";

	$fstab = "/etc/fstab";
	$fstab_lock = "fstab";

## /etc/fstab ɤ߹
	if (!&readFile($fstab ,$fstab_lock, *file)) {
		return("˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if (($file[$i] =~ /\Q$server\E/)&&($file[$i] =~ /\Q$dir\E/)&&($file[$i] =~ /\s+\Q$mntpnt\E\s+/)) {
			splice(@file,$i,1);
			$i--;
		}
	}
## /etc/fstab 񤭹
	if (!&writeFile($fstab, $fstab_lock, @file)) {
		return("˼Ԥޤ");
	}
	return($rtn_code);
}

############################################################################
#  <̾>
#        delSmb
#  <>
#        /etc/opt/nec/wbmc/wbmc_smbmnt  wbmc_smbunmnt 롣
#  <>
#        delSmb($server,$dir,$mntpnt)
#  <>
#        $server	̾
#        $dir		ǥ쥯ȥ̾
#        $mntpnt	ޥȥݥ
#  <>
#	      ̵
#        ۾ 顼å
############################################################################

sub delSmb{

	local($server,$dir,$mntpnt) = @_;
	local($rtn_code, $smbmnt, $smbunmnt, $smbmnt_lock, $smbunmnt_lock) = "";
	local(@file, @file2, @file3) = ();
	local($i) = "";

	$smbmnt = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$smbunmnt = "/etc/opt/nec/wbmc/wbmc_smbunmnt";
	$smbmnt_lock = "wbmc_smbmnt";
	$smbunmnt_lock = "wbmc_smbunmnt";

## wbmc_smbmnt ɤ߹
	if (!&readFile($smbmnt ,$smbmnt_lock, *file)) {
		return("˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if (($file[$i] =~ /\Q$server\E/)&&($file[$i] =~ /\Q$dir\E/)&&($file[$i] =~ /\s+\Q$mntpnt\E\s+/)) {
			splice(@file,$i,1);
			$i--;
		}
	}
## wbmc_smbmnt 񤭹
	if (!&writeFile($smbmnt, $smbmnt_lock, @file)) {
		return("˼Ԥޤ");
	}

	@file = ();
## wbmc_smbunmnt ɤ߹
	if (!&readFile($smbunmnt ,$smbunmnt_lock, *file)) {
		return("ޥȽκ˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		@file3 = ();
		$file2[$i] = $file[$i];
		$file2[$i] =~ s/^\s+//;
		$file2[$i] =~ s/\s+$//;
		@file3 = split(/\s+/,$file2[$i]);
		if ($file3[1] eq $mntpnt) {
			splice(@file,$i,1);
			$i--;
		}
	}
## wbmc_smbunmnt 񤭹
	if (!&writeFile($smbunmnt, $smbunmnt_lock, @file)) {
		return("ޥȽκ˼Ԥޤ");
	}
	return($rtn_code);
}

############################################################################
#  <̾>
#        SmbReMount
#  <>
#        SAMBA³
#  <>
#        SmbReMount($mntpnt)
#  <>
#        $mntpnt	ޥȥݥ
#  <>
#	      ̵
#        ۾ 顼å
############################################################################

sub SmbReMount{

	local($server,$dir,$mntpnt) = @_;
	local($rtn_code, $smbmnt, $smbmnt_lock) = "";
	local(@file, @file2) = ();
	local($i, $cmd) = "";

	$smbmnt = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$smbmnt_lock = "wbmc_smbmnt";

## wbmc_smbmnt ɤ߹
	if (!&readFile($smbmnt ,$smbmnt_lock, *file)) {
		return("³˼Ԥޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if (($file[$i] =~ /\Q$server\E/)&&($file[$i] =~ /\Q$dir\E/)&&($file[$i] =~ /\s+\Q$mntpnt\E\s+/)) {
			$cmd = $file[$i];
		}
	}
	if ($cmd eq "") {
		return("³˼Ԥޤ");
	}
	if (!-d $mntpnt) {
		system("/bin/mkdir $mntpnt");
	}
	if (system("$cmd")) {
		$mntpnt =~ s/\/$//;
		if ($mntpnt ne "/mnt/cdrom" && $mntpnt ne "/mnt/floppy") {
			system("/bin/rmdir $mntpnt");
		}
		return("³˼Ԥޤ");
	}

	return($rtn_code);
}

############################################################################
#  <̾>
#        NfsReMount
#  <>
#        NFSѤ¾ФΥե(ǥ쥯ȥ)ޥȤ
#        ³
#  <>
#        NfsMount($server, $target, $mntpnt)
#  <>
#        $server ޥȤоݤȤʤޥ̾ or IPɥ쥹
#        $target ޥȤоݤȤʤǥ쥯ȥ̾
#        $mntpnt ޥȥݥ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub NfsReMount{

	local($server, $target, $mntpnt) = @_;
	local($rtn_code, $cmd, $i, $fstab, $fstab_lock, $mtab, $mtab_lock, $line, $smbmnt, $smbmnt_lock) = "";
	local(@server, @target, @mntpnt, @line, @file) = ();
	local(*IN);

	$fstab = "/etc/fstab";
	$fstab_lock = "fstab";
	$mtab = "/etc/mtab";
	$mtab_lock = "mtab";
	$smbmnt = "/etc/opt/nec/wbmc/wbmc_smbmnt";
	$smbmnt_lock = "wbmc_smbmnt";
	$server =~ s/^\s+//;
	$server =~ s/\s+$//;
	$server2 =~ s/\.//g;
	$server2 =~ s/-//g;
	$server2 =~ s/_//g;
	$target =~ s/^\s+//;
	$target =~ s/\s+$//;
	$mntpnt =~ s/^\s+//;
	$mntpnt =~ s/\s+$//;
	$mntpnt =~ s/\/+$//;

## ͥå
	@server = split(/\s+/,$server);
	@target = split(/\s+/,$target);
	@mntpnt = split(/\s+/,$mntpnt);
	if ($server[1]) {
		return("̾Ǥ");
	}
	if ($target[1]) {
		return("ǥ쥯ȥ̾Ǥ");
	}
	if ($mntpnt[1]) {
		return("ޥȥݥȤǤ");
	}
	if (!$server) {
		return("̾Ǥ");
	}
	elsif (!$target) {
		return("ǥ쥯ȥ̾Ǥ");
	}
	elsif (!$mntpnt) {
		return("ޥȥݥȤǤ");
	}
	if ($server =~ /^[^a-zA-Z0-9]/) {
		return("̾Ǥ");
	}
	if ($server2 =~ /[^a-zA-Z0-9]/) {
		return("̾Ǥ");
	}
	if ($target !~ /^\//) {
		return("ǥ쥯ȥ̾Ǥ");
	}
	if ($mntpnt !~ /^\/mnt\//) {
		return("ޥȥݥȤǤ");
	}
	if ($mntpnt eq "/mnt/floppy") {
		return("ޥȥݥȤǤ");
	}
	if ($mntpnt eq "/mnt/cdrom") {
		return("ޥȥݥȤǤ");
	}

## ³ϥޥȥݥȤνʣåԤʤʤ

## ޥȥޥȯ
	if (!-d $mntpnt) {
		system("/bin/mkdir $mntpnt");
	}
	$cmd = "/bin/mount -t nfs -o soft $server:$target $mntpnt";
	if (system("$cmd")) {
		$mntpnt =~ s/\/$//;
		if ($mntpnt ne "/mnt/cdrom" && $mntpnt ne "/mnt/floppy") {
			system("/bin/rmdir $mntpnt");
		}
		return("ޥȤǤޤǤ");
	}

## /etc/fstab Խ
	$line = "";
	## /etc/mtab fstab˽񤭹
		if (!&readFile($mtab ,$mtab_lock, *file)) {
			return("$mtab ɤ߹ߤ˼ԤޤƥƵưˡޥȤޤ");
		}
		for ($i=0; $i<@file; $i++) {
			if ($file[$i] =~ /\s*\Q$server:$target\E\s+\Q$mntpnt\E\s+nfs/) {
				$line = $file[$i];
			}
		}
		if ($line eq "") {
			return("$fstab ˼ԤޤƥƵưˡޥȤޤ");
		}
	@file = ();
	if (!&readFile($fstab ,$fstab_lock, *file)) {
		return("$fstab ɤ߹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}
	for ($i=0; $i<@file; $i++) {
		if ($file[$i] =~ /\s*\Q$server:$target\E\s+\Q$mntpnt\E\s+nfs/) {
			return($rtn_code);
		}
	}
	push(@file,$line);
	if (!&writeFile($fstab, $fstab_lock, @file)) {
        	return("$fstab ν񤭹ߤ˼ԤޤƥƵưˡޥȤޤ");
	}

## ｪλ
	return($rtn_code);
}

############################################################################
#  <̾>
#        getRaidStatus
#  <>
#        raidξ֤
#  <>
#        getRaidStatus($partition,*raidstatus)
#  <>
#        $partitionѡƥ̾ (/dev/md0 )
#        *raidstatusraidξ֤Ǽ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub getRaidStatus{

	local($partition,*raidstatus) = @_;
	local($i, $raiddev, $device, $line, ) = "";
	local(@devname, @ent) = ();
	local(*IN);
	local($flag) = 0;
	local($tmp);

	$raidstatus = "";
	
	if (!open(IN, "/bin/cat /etc/raidtab |")) {
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		if ($line =~ /raiddev\s+$partition$/) {
			$raiddev = 1;
		}
		elsif ($line =~ /raiddev\s+/) {
			$raiddev = "";
		}
		elsif (($line =~ /device\s+(.+)/)&&($raiddev)) {
			$device = $1;
		}
		elsif (($line =~ /raid-disk\s+(.+)/)&&($device)) {
			$devname[$1] = $device;
			$device = "";
		}
	}
	close(IN);

	if (!open(IN, "/bin/cat /proc/mdstat |")) {
		return();
	}
	while(<IN>) {
		next if (/^\s*$/);
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		@ent = split(/\s+/,$line);
		if ($flag == 0 and $partition !~ /$ent[0]$/) {
			next;
		}
		if ($partition =~ /$ent[0]$/) {
			$tmp = $line;
			$flag = 1;
			next;
		}
		if ($flag == 1) {
			$tmp .= $line;
			$flag = 0;
		}

		$raidstatus ="";
		for ($i=0; $i<@devname; $i++) {
			$devname2[$i] = $devname[$i];
			$devname2[$i] =~ s/.+\///g;
			
			if ($tmp =~ /recovery=/) {
				$raidstatus = "";
				return();
			}
			elsif ($tmp !~ /$devname2[$i]\[/) {
				$raidstatus = "۾";
				return();
			}
			elsif ($tmp !~ /\s+active\s+/) {
				$raidstatus = "۾";
				return();
			}
			elsif ($tmp =~ /\[(\d+)\/(\d+)\]/) {
				if ($1 ne $2) {
					$raidstatus = "۾";
					return();
				}
			}
		}
	}
	close(IN);
	return();
}

############################################################################
#  <̾>
#        getRaidUse
#  <>
#        ƥबեraidѤƤ뤫ɤĴ٤
#  <>
#        getRaidUse(*raiduse)
#  <>
#        *raiduseեraidѾ֤Ǽ (ѻ1  ̤ѻ"")
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub getRaidUse{

	local(*raiduse) = @_;
	local($i, $line, $exist, $exist2) = "";
	local(@devname, @ent) = ();
	local(*IN);

	#  "̤"
	$raiduse = "";

	# ե륪з֤Τ߻
        if (&getClusterType() eq "cluster") {
                return();
        }
	
	# /etc/raidtab ¸ߤ뤫
	# ¸ߤʤ  "̤"
	if (!-f "/etc/raidtab") {
		return();
	}

	if (!open(IN, "/bin/cat /etc/raidtab |")) {
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		if ($line =~ /^#/) {
			next;
		}
		elsif ($line =~ /.+/) {
			$exist = 1;
		}
	}
	close(IN);

	if (!open(IN, "/bin/cat /proc/mdstat |")) {
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		if ($line =~ /^Personalities\s+:(.*)/) {
			if ($1) {
				$exist2 = 1;
			}
		}
	}
	close(IN);

	if ($exist && $exist2) {
		$raiduse = 1;
	}

	return();
}

############################################################################
#  <̾>
#        getBadDevice
#  <>
#        եraidѻɥǥХõ
#  <>
#        getBadDevice($partition, *baddevice)
#  <>
#        $partitionѡƥ̾ (/dev/md0 )
#        *baddeviceɥǥХ̾Ǽ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub getBadDevice{

	local($partition, *baddevice) = @_;
	local($i, $line, $exist, $exist2, $num, $num2) = "";
	local(@devname, @ent) = ();
	local(*IN);

	if (!open(IN, "/bin/cat /etc/raidtab |")) {
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		if ($line =~ /raiddev\s+$partition$/) {
			$raiddev = 1;
		}
		elsif ($line =~ /raiddev\s+/) {
			$raiddev = "";
		}
		elsif (($line =~ /device\s+(.+)/)&&($raiddev)) {
			$device = $1;
		}
		elsif (($line =~ /raid-disk\s+(.+)/)&&($device)) {
			$devname[$1] = $device;
			$device = "";
		}
	}
	close(IN);

	if (!open(IN, "/bin/cat /proc/mdstat |")) {
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		@ent = split(/\s+/,$line);
		if ($partition !~ /$ent[0]$/) {
			next;
		}
		for ($i=0; $i<@devname; $i++) {
			$devname2[$i] = $devname[$i];
			$devname2[$i] =~ s/.+\///g;
			
			if ($line =~ /$devname2[$i]\[(\d)\]/) {
				$num = $1;
			}
			if ($line =~ /\[(\d)\/(\d)\]/) {
				$num2 = $1;
			}
			if (($num && $num2)&&($num eq $num2)) {
				push(@baddevice,$devname[$i]);
				return();
			}
			elsif ($line !~ /$devname2[$i]\[/) {
				push(@baddevice,$devname[$i]);
				return();
			}
		}
	}
	close(IN);
	return();
}

############################################################################
#  <̾>
#        getRaidPart
#  <>
#        RaidƤѡƥ
#  <>
#        getRaidPart($partition, *raidpart)
#  <>
#        $partitionѡƥ̾ (/dev/md0 )
#        *raidpartRaidƤѡƥ̾Ǽ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub getRaidPart{

	local($partition,*raidpart) = @_;
	local($i, $raiddev, $device, $line, ) = "";
	local(@devname, @ent) = ();
	local(*IN);

	if (!open(IN, "/bin/cat /etc/raidtab |")) {
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		if ($line =~ /raiddev\s+$partition$/) {
			$raiddev = 1;
		}
		elsif ($line =~ /raiddev\s+/) {
			$raiddev = "";
		}
		elsif (($line =~ /device\s+(.+)/)&&($raiddev)) {
			$device = $1;
		}
		elsif (($line =~ /raid-disk\s+(.+)/)&&($device)) {
			$raidpart[$1] = $device;
			$device = "";
		}
	}
	close(IN);

	return();
}

############################################################################
#  <̾>
#        getRecoverTime
#  <>
#        ֤
#  <>
#        getRecoverTime($partition,*recovertime)
#  <>
#        $partitionѡƥ̾ (/dev/md0 )
#        *raidstatusraid֤Ǽ
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub getRecoverTime{

	local($partition,*recovertime) = @_;
	local($i, $raiddev, $device, $line, ) = "";
	local(@devname, @ent) = ();
	local(*IN);

	$recovertime = "";
	if (!open(IN, "/bin/cat /proc/mdstat |")) {
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		@ent = split(/\s+/,$line);
		if ($partition !~ /$ent[0]$/) {
			next;
		}
		if ($line =~ /\s+(recovery=.*)/) {
			$recovertime = $1;
			return();
		}
	}
	close(IN);
	return();
}

############################################################################
#  <̾>
#        getRecoverPart
#  <>
#        ֤
#  <>
#        getRecoverPart($partition,$raidpartition,*recoverpart)
#  <>
#        $partitionѡƥ̾ (/dev/md0 )
#        $raidpartitionRaidѡƥ̾ (/dev/hba5 )
#        *recoverpartΥѡƥǤ뤫ɤǼ桧1  ʳ""
#  <>
#	      ʤ(NULL)
#        ۾ 顼å
############################################################################

sub getRecoverPart{

	local($partition,$raidpartition,*recoverpart) = @_;
	local($i, $raiddev, $device, $line, $num, $num2, $master) = "";
	local(@devname, @ent, @raidpart) = ();
	local(*IN);

	$recoverpart = "";

	if (!open(IN, "/bin/cat /etc/raidtab |")) {
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		if ($line =~ /raiddev\s+$partition$/) {
			$raiddev = 1;
		}
		elsif ($line =~ /raiddev\s+/) {
			$raiddev = "";
		}
		elsif (($line =~ /device\s+(.+)/)&&($raiddev)) {
			$device = $1;
		}
		elsif (($line =~ /raid-disk\s+(.+)/)&&($device)) {
			$devname[$1] = $device;
			$device = "";
		}
	}
	close(IN);

	for ($i=0; $i<@devname; $i++) {
		if ($devname[$i]) {
			$master = $devname[$i];
			last;
		}
	}
	if ($master eq "") {
		$recoverpart = 2;
		return();
	}

	if (!open(IN, "/bin/cat /proc/mdstat |")) {
		$recoverpart = 2;
		return();
	}
	while(<IN>) {
		$line = $_;
		$line =~ s/^\s+//;
		$line =~ s/\s+$//;
		@ent = split(/\s+/,$line);
		if ($partition !~ /$ent[0]$/) {
			next;
		}
		if ($line !~ /recovery=/) {
			next;
		}
		
		$raidpartition =~ s/.+\///g;
		$raidpartition =~ s/^\s+//;
		$raidpartition =~ s/\s+$//;

		if ($line =~ /$raidpartition\[(\d)\]/) {
			$num = $1;
		}
		else {
			$recoverpart = 1;
			return();
		}
		if ($line =~ /\[(\d)\/(\d)\]/) {
			$num2 = $1;
			if (($line !~ /\[$num2\]/)&&(($line !~ /\[_U/)&&($line !~ /U_\]/))) {
				## ɤ餬椫ʬʤ
				$recoverpart = 1;
				return();
			}
			elsif (($line =~ /\[_U\]/)&&($master =~ /$raidpartition/)) {
				$recoverpart = 1;
				return();
			}
			elsif ($line !~ /\[$num2\]/) {
				$recoverpart = 1;
				return();
			}
		}
		else {
			$recoverpart = 2;
			return();
		}

		$num =~ s/^\s+//;
		$num =~ s/\s+$//;
		$num2 =~ s/^\s+//;
		$num2 =~ s/\s+$//;
		if (($num && $num2)&&($num eq $num2)) {
			$recoverpart = 1;
			return();
		}
		if (($line !~ /\[_U/)&&($line !~ /U_\]/)) {
			return();
		}
	}
	close(IN);
	return();
}

1;
