#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: domainssl.pl,v 1.2 2002/09/27 12:27:24 snavi Exp $

#--------------------------------------------------------------------------
##010228 v4.0.1 wbmc04-012 б domain۲ȼdomainssl.pl  haramoto(S.Oku)
##010307 v4.0.1 (wbmc04-012)SSL httpdƵư(ʣ¹ԤƤ)  S.Oku
##010308 v4.0.1 (wbmc04-012)SSL require(domain.plɲ)  S.Oku
##010322 v4.0.1 checkVirtualHost()  S.Oku
##010413 v4.0.1 SSL ֥եɲ
##010509 v4.0.1 cronδԤƥ᡼žбαĹopensslޥɤwarningб Uemukai
##010704 v4.1.0  \Q  \E б S.Oku
##010827 v4.10 LBֻ Slave  port80θ򳫤 Oku

#--------------------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
#require "/opt/nec/wbmc/domain/lib/wbmc.pl";
require join ("/", $WBMC_DOMADM_DIR, "httpd/dir.pl");
require join ("/", $WBMC_DOMADM_DIR, "httpd/rotate.pl");
require "$WBMC_ADM_DIR/domain/domain.pl";

#
# SSLξ֤
#  VirtualHost IP б 001222 S.Oku
sub getSslStatus
{
	local($server, $port, *status) = @_;
	local(@lines, $target, $sslstatus, $servername);
	local($err);
	local($i);

	$status = 0;
	$sslstatus = 0;
	$servername = 0;

	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		$err = "եɤ߹ߤ˼Ԥޤ";
		goto done;
	}

	$target = 0;
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			$sslstatus = 0;
			$servername = 0;
			$target = 1;
		}
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
			if ($sslstatus == 1 && $servername == 1) {
				$status = 1;
				goto done;
			}
			else {
				$target = 0;
			}
		}
		elsif ($target == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\s*SSLEngine\s+On\s+/i) {
			$sslstatus = 1;
		}
		elsif ($lines[$i] =~ /^\s*ServerName\s+([^\s]+)\s*/i) {
			if ($server eq $1) {
				$servername = 1;
			}
		}
	}

done:
	return($err);
}

#
# SSLξ֤ꤹ
#
sub setSslStatus
{
	local($server, $port, $status_flag) = @_;
	local(@lines, @lines2, $target, $insert_here);
	local($text, $status);
	local($err, $listen_line);
	local($i,$port_hit);

	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		$err = "եɤ߹ߤ˼Ԥޤ";
		goto done;
	}

	$target = 0;
	$insert_here = -1;
	$port_hit = 0;
	for ($i = 0; $i <= $#lines; $i++) {
		if (($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i)&&($target == 0)) {
##			if ("$server:$port" eq $1) {
#VirtualHost IP б
			if ($1 =~ /\:$port/) {
#				$target = 1;
				$port_hit = 1;
				$insert_here_buf = $i + 1;
			}
		}
		elsif (($lines[$i] =~ /^\s*ServerName\s+([^\s]+)\s*/i)&&($target == 0)) {
			if (($server eq $1)&&($port_hit == 1)) {
				$target = 1;
				$insert_here = $insert_here_buf;
				$i = $insert_here_buf - 1;
			}
		}
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
			$port_hit = 0;
			$target = 0;
			$insert_here_buf = -1;
		}
		elsif ($target == 0) {
			next;
		}
		elsif ($lines[$i] =~ /^\s*SSLEngine\s+/i) {
			#000906 create/deleteξϾäʤ
#			if (($status_flag eq "on") || ($status_flag eq "off")) {
				splice(@lines, $i, 1);
				$i--;
#			} else {
#				$insert_here = $i + 1;
#			}
		}
		elsif ($lines[$i] =~ /^\s*SSLCertificateFile\s+/i) {
			#000906 offξϾäʤ
#			if ($status_flag ne "off") {
				splice(@lines, $i, 1);
				$i--;
#			}
		}
		elsif ($lines[$i] =~ /^\s*SSLCertificateKeyFile\s+/i) {
			#000906 offξϾäʤ
#			if ($status_flag ne "off") {
				splice(@lines, $i, 1);
				$i--;
#			}
		}
		##001003
		elsif ($lines[$i] =~ /^\s*#+\s*wbmc:\s*Listen\s+([^\s]+)/i) {
			$listen_line  = $i;
		}
		##001003

	}

	if (($status_flag eq "on") && ($insert_here != -1)) {
		# ̩Ⱦ¸ߤ뤫å
		if ($err = &getSecretStatus($server, $port, *status)) {
			goto done;
		}
		if ($status == 0) {
			$err = "̩Ƥޤ";
			goto done;
		}
		if ($err = &getCertificate($server, $port, *text, *who, *exist)) {
			goto done;
		}
		if ($exist == 0) {
			$err = "Ƥޤ";
			goto done;
		}

		##001003
#		if ($lines[$listen_line] =~ /##/) {
#			$lines[$listen_line] =~ s/##/#/;
#		}
		##001003

		@lines2 = ();
		push(@lines2, "\tSSLEngine On\n");
		push(@lines2, "\tSSLCertificateFile /etc/httpd/conf/ssl.crt/crt_$server-ssl.pem\n");
		push(@lines2, "\tSSLCertificateKeyFile /etc/httpd/conf/ssl.key/key_$server-ssl.pem\n");
		splice(@lines, $insert_here, 0, @lines2);
	}

#000906 add start -----------------------
	if (($status_flag eq "off") && ($insert_here != -1)) {

		##001003
#		if ($lines[$listen_line] =~ /##/) {
#		}
#		elsif ($lines[$listen_line] =~ /#/) {
#			$lines[$listen_line] =~ s/#/##/;
#		}
		##001003

		@lines2 = ();
		push(@lines2, "\tSSLEngine Off\n");
		splice(@lines, $insert_here, 0, @lines2);
	}
	elsif (($status_flag eq "create") && ($insert_here != -1)) {

		##001003
#		if ($lines[$listen_line] =~ /##/) {
#		}
#		elsif ($lines[$listen_line] =~ /#/) {
#			$lines[$listen_line] =~ s/#/##/;
#		}
		##001003

		@lines2 = ();

		push(@lines2, "\tSSLEngine On\n");     ## 010227 add  "create"ξSSLEngine on
		push(@lines2, "\tSSLCertificateFile /etc/httpd/conf/ssl.crt/crt_$server-ssl.pem\n");
		push(@lines2, "\tSSLCertificateKeyFile /etc/httpd/conf/ssl.key/key_$server-ssl.pem\n");
		splice(@lines, $insert_here, 0, @lines2);
	}
#000906 add end -----------------------

	# Listen Ĵ
	&checkVirtualHost(*lines);
	&checkVirtualHost_realwbmc_domain(*lines);

	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		$err = "եν񤭹ߤ˼Ԥޤ";
		goto done;
	}

done:
	return($err);
}

#
# ̩ξ֤
#
sub getSecretStatus
{
	local($server, $port, *status) = @_;
	local($key) = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
	local($err);

	$status = 0;

	if (-e $key && -s $key) {
		$status = 1;
	}

	return($err);
}

#
# ̩
#
sub deleteSecret
{
	local($server, $port) = @_;
	local($key) = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
	local($err);

	if (!-e $key) {
		goto done;
	}
	if (!open CMD, "/bin/chmod 600 $key |") {
		$err = "̩Υѹ˼Ԥޤ";
		goto done;
	}
	close(CMD);
	if (!open CMD, "/bin/rm -f $key |") {
		$err = "̩κ˼Ԥޤ";
		goto done;
	}
	close(CMD);

	##000908
	if ($err = &cluster_system_syncdel($key)) {
		goto done;
	}

	# Listen Ĵ
	if ($err = &changeListen()) {
		goto done;
	}

 done:
	return($err);
}

#
# ̾׵
#
sub makeCertificateRequest
{
	local($server, $port, $country, $state, $city, $company,
		$section, $fqdn) = @_;
	local($key, $csr, $crt);
	local($err) = "";

	# ѥ᡼γǧ
	if ($err = &checkCertificateParameter($country, $state, $city,
		$company, $section, $fqdn)) {
		goto done;
	}

	# Υǥ쥯ȥγǧ
	if ($err = &checkDirectory()) {
		goto done;
	}

	## keyե򤹤롣  *_save 
	&saveSslKey($server);

	## ssl2.cgi ǥ뤷Ƥ  뤹褦ѹ 010413
	&deleteCertificate($server, $port);

	# 
	$key = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
	$csr = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
	$crt = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";

	# ̩κ
	if ($err = &createSecret($key)) {
		goto done;
	}

	##000908
	if ($err = &cluster_system_backup($key)) {
		goto done;
	}

	# ̾׵κ
	if ($err = &createCertificateRequest($key, $csr,
	 	$contry, $state, $city, $company, $section, $fqdn)) {
		goto done;
	}
	##000908
	if ($err = &cluster_system_backup($csr)) {
		goto done;
	}
	if ($err = &cluster_system_sync($key)) {
		goto done;
	}
	if ($err = &cluster_system_sync($csr)) {
		goto done;
	}

	# Listen Ĵ
	if ($err = &changeListen()) {
		goto done;
	}

done:

	if ($err) {
		## 򤷤Ƥkeyե򸵤᤹
		&restoreSslKey($server);
	}

	## ե *_save 롣
	&delSavedKey($server);

##010509 opensslޥɤwarning(cronδԤƥ᡼žбαĹ)
##ѿե
    if(-e "/tmp/.wbmcdata.dat"){
      system("/bin/rm -f /tmp/.wbmcdata.dat");
    }

	return($err);
}

#
# ̾׵Ƥ
#
sub getCertificateRequest
{
	local($server, $port, *text, *exist) = @_;
	local($csr) = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
	local($err);

	$exist = 0;
	if (!-e $csr || -z $csr) {
		goto done;
	}
	$exist = 1;

	if (!&readFile($csr, "csr.pem", *text)) {
		$err = "̾׵ɤ߹ߤ˼Ԥޤ";
		goto done;
	}

 done:
	return($err);
}

#
# ̾׵
#
sub deleteCertificateRequest
{
	local($server, $port) = @_;
	local($err);

	$csr = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
	if (!-e $csr) {
		goto done;
	}
	if (!open CMD, "/bin/rm -f $csr |") {
		$err = "̾׵κ˼Ԥޤ";
		goto done;
	}
	close(CMD);

	##000908
	if ($err = &cluster_system_syncdel($csr)) {
		goto done;
	}

 done:
	return($err);
}

#
# 
#
sub makeSelfCertificate
{
	local($server, $port, $country, $state, $city, $company,
		$section, $fqdn) = @_;
	local($key, $csr, $crt);
	local($err) = "";

	# ѥ᡼γǧ
	if ($err = &checkCertificateParameter($country, $state, $city,
		$company, $section, $fqdn)) {
		goto done;
	}

	if ($err = &checkDirectory()) {
		goto done;
	}
	$key = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
	$csr = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
	$crt = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";

	# keyե
	&saveSslKey($server);

	# ̩κ
	if ($err = &createSecret($key)) {
		goto done;
	}

	##000908
	if ($err = &cluster_system_backup($key)) {
		goto done;
	}

	# ̾׵κ
	if ($err = &createCertificateRequest($key, $csr,
	 	$contry, $state, $city, $company, $section, $fqdn)) {
		goto done;
	}

	# κ
	if ($err = &createCertificate($key, $csr, $crt)) {
		goto done;
	}

	##000908
	if ($err = &cluster_system_backup($crt)) {
		goto done;
	}

	# ̾׵κ
	if ($err = &deleteCertificateRequest($server, $port)) {
		goto done;
	}

	##000908
	if ($err = &cluster_system_sync($key)) {
		goto done;
	}
	if ($err = &cluster_system_sync($crt)) {
		goto done;
	}

	# Listen Ĵ
	if ($err = &changeListen()) {
		goto done;
	}

 done:

	if ($err) {
		# 򤷤Ƥkeyե򸵤᤹
		&restoreSslKey($server);
	}
	# 򤷤Ƥkeyե
	&delSavedKey($server);

##010509 opensslޥɤwarning(cronδԤƥ᡼žбαĹ)
##ѿե
    if(-e "/tmp/.wbmcdata.dat"){
      system("/bin/rm -f /tmp/.wbmcdata.dat");
    }

	return($err);
}

#
# Ͽ
#
sub registCertificate
{
	local($server, $port, @text) = @_;
	local($crt) = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";
	local($tmp) = "/etc/httpd/conf/tmp.$$";
	local($err);

	if (!writeFile($crt, "crt.pem", @text)) {
		$err = "Ͽ˼Ԥޤ";
		goto done;
	}

	if (!open CMD, "/usr/bin/openssl x509 -in $crt -out $tmp -text |") {
		&removeFile($crt);
		&removeFile($tmp);
		$err = "PEMξϿƲ";
		goto done;
	}
	close(CMD);
	&removeFile($tmp);

	# Listen Ĵ
	if ($err = &changeListen()) {
		goto done;
	}

 done:
	return($err);
}

#
# Ƥ
#
sub getCertificate
{
	local($server, $port, *text, *who, *exist) = @_;
	local($value) = 0;
	local(@issuer, $issuer) = ();
	local(@tmp) = ();
#	local(@buf, @tmp) = ();
#	local($who_flag) = 0;
	local($crt) = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";
	local($err);

	$exist = 0;

	if (!-e $crt || -z $crt) {
		goto done;
	}

	$exist = 1;

	# Ф
	if ($err = &getCertificateInfo($crt, "text", *text)) {
		goto done;
	}

 done:
	return($value);
}

#
# 
#
sub deleteCertificate
{
	local($server, $port) = @_;
	local($crt) = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";
	local($err);

	if (!-e $crt) {
		goto done;
	}
	if (!open CMD, "/bin/rm -f $crt |") {
		$err = "κ˼Ԥޤ";
		goto done;
	}
	close(CMD);

	##000908
	if ($err = &cluster_system_syncdel($crt)) {
		goto done;
	}

	$err = &changeListen();

 done:
	return($err);
}
#
# ̩
#
sub createSecret
{
	local($key) = @_;
	local($err);

	if (-e $key) {
		if (!open CMD, "/bin/chmod 600 \"$key\" |") {
			$err = "̩Υѡߥåѹ˼Ԥޤ";
			goto done;
		}
		close(CMD);
	}

##010509 opensslޥɤwarning(cronδԤƥ᡼žбαĹ)
# ADD Start
	# ѿȯ
	if(!open EXEC,"| /usr/bin/openssl dgst /tmp/.wbmcdata.dat > /tmp/.wbmcdata.dat"){
		$err = "ѿեκ˼Ԥޤ";
		goto done;
	}

	# ̩
    # REP -rand ץɲ
	if (!open(EXEC, "| /usr/bin/openssl genrsa -rand /tmp/.wbmcdata.dat -out $key -passout stdin -des 1024 > /dev/null 2>&1")) {
		$err = "̩κ˼Ԥޤ";
		goto done;
	}
# ADD End

	# ΥѥɤϤ
	print EXEC "wbmc\n";
	print EXEC "wbmc\n";
	close(EXEC);

	# ̩Υѥɤ
	if (!open EXEC, "| /usr/bin/openssl rsa -in $key -passin stdin -out $key > /dev/null 2>&1") {
		$err = "̩Υѥɤβ˼Ԥޤ";
		goto done;
	}
	print EXEC "wbmc\n";
	close(EXEC);

	# root Фɤ߼긢Τߤ
	if (!open CMD, "/bin/chmod 400 \"$key\" |") {
		$err = "̩Υѡߥåѹ˼Ԥޤ";
		goto done;
	}
	close(CMD);

 done:
	return($err);
}

#
# ̾׵
#
sub createCertificateRequest
{
	local($key, $csr,
	      $contry, $state, $city, $company, $section, $fqdn) = @_;
	local($err);

	# 
	if (!$country) {
		$country = "localhost";
	}
	if (!$state) {
		$state = "Some-State";
	}
	if (!$city) {
		$city = "Somewhere";
	}
	if (!$company) {
		$company = "Test server";
	}
	if (!$section) {
		$section = "Test Certificate";
	}
	if (!$fqdn) {
		$fqdn = "localhost";
	}

	if (!open EXEC, "| /usr/bin/openssl req -new -key $key -out $csr -config /opt/nec/wbmc/lib/ssl.conf > /dev/null 2>&1") {
		$err = "̾׵κ˼Ԥޤ";
		goto done;
	}
	print EXEC "$country\n";
	print EXEC "$state\n";
	print EXEC "$city\n";
	print EXEC "$company\n";
	print EXEC "$section\n";
	print EXEC "$fqdn\n";
	close(EXEC);

 done:
	return($err);
}

#
# ʽ̾
#
sub createCertificate
{
	local($key, $csr, $crt) = @_;
	local($err);

	if (!open EXEC, "| /usr/bin/openssl x509 -in $csr -out $crt -days 365 -signkey $key -req > /dev/null 2>&1") {
		$err = "ʽ̾κ˼Ԥޤ";
		goto done;
	}
	close(EXEC);

 done:
	return($err);
}

#
# ɬפʥǥ쥯ȥå̵к
#
sub checkDirectory
{
	local($err);

	if (! -d "/etc/httpd/conf/ssl.key") {
		if ($err = &makeDirectory("/etc/httpd/conf/ssl.key")) {
			goto done;
		}
	}
	if (! -d "/etc/httpd/conf/ssl.csr") {
		if ($err = &makeDirectory("/etc/httpd/conf/ssl.csr")) {
			goto done;
		}
	}
	if (! -d "/etc/httpd/conf/ssl.crt") {
		if ($err = &makeDirectory("/etc/httpd/conf/ssl.crt")) {
			goto done;
		}
	}

 done:
	return($err);
}

#
# ǥ쥯ȥ
#
sub makeDirectory
{
	local($dir) = @_;
	local($err);

	if (!open CMD, "/bin/mkdir -p \"$dir\" |") {
		$err = "ǥ쥯ȥκ˼Ԥޤ";
		goto done;
	}
	close(CMD);

 done:
	return($err);
}

#
# ξ
#
sub getCertificateInfo
{
	local($crt, $option, *text) = @_;
	local($tmp) = "/etc/httpd/conf/tmp.$$";
	local($err);

	if (!open CMD, "/usr/bin/openssl x509 -in $crt -out $tmp -$option |") {
		&removeFile($tmp);
		$err = "PEMξϿƲ";
		goto done;
	}
	close(CMD);
	@text = ();
	if (!-e $tmp || -z $tmp) {
		&removeFile($tmp);
		$err = "PEMξϿƲ";
		goto done;
	}
	if (!open IN, "$tmp") {
		&removeFile($tmp);
		$err = "ξɤ߹ߤ˼Ԥޤ";
		goto done;
	}
	while(<IN>) {
		push @text, $_;
	}
	close(IN);
	&removeFile($tmp);

done:
	return($err);
}

#
# եκ
#
sub removeFile
{
	local($err);

	local($file) = @_;
	if (-e $file) {
		unlink($file);
	}
	return($err);
}

#
# 񡢾̾׵Υѥ᡼å
#
sub checkCertificateParameter
{
	local($country, $state, $city,
				$company, $section, $fqdn) = @_;
	local($err);

	# 顼å
	if (!$country || $country =~ /^\s+$/) {
		$err = "񥳡ɤꤷƲ";
		goto done;
	}
	if (length($country) != 2) {
		$err = "񥳡ɤϣʸǻꤷƲ";
		goto done;
	}
	if ($country =~ /[^A-Za-z]/) {
		$err = "񥳡ɤȾѱʸǻꤷƲ";
		goto done;
	}
	$state =~ s/^\s*//;
	$state =~ s/\s*$//;
	if (!$state || $state =~ /^\s+$/) {
		$err = "ƻܸ̾ꤷƲ";
		goto done;
	}
	if ($state =~ /[^\x20-\x7E]/) {
		$err = "ƻܸ̾ȾѱѿȾѵǻꤷƲ";
		goto done;
	}
	$city =~ s/^\s*//;
	$city =~ s/\s*$//;
	if (!$city || $city =~ /^\s+$/) {
		$err = "ԶĮ¼̾ꤷƲ";
		goto done;
	}
	if ($city =~ /[^\x20-\x7E]/) {
		$err = "ԶĮ¼̾ȾѱѿȾѵǻꤷƲ";
		goto done;
	}
	$company =~ s/^\s*//;
	$company =~ s/\s*$//;
	if (!$company || $company =~ /^\s+$/) {
		$err = "̾ꤷƲ";
		goto done;
	}
	if ($company =~ /[^\x20-\x7E]/) {
		$err = "̾ȾѱѿȾѵǻꤷƲ";
		goto done;
	}
	$section =~ s/^\s*//;
	$section =~ s/\s*$//;
	if (!$section || $section =~ /^\s+$/) {
		$err = "̾ꤷƲ";
		goto done;
	}
	if ($section =~ /[^\x20-\x7E]/) {
		$err = "̾ȾѱѿȾѵǻꤷƲ";
		goto done;
	}
	$fqdn =~ s/^\s*//;
	$fqdn =~ s/\s*$//;
	if (!$fqdn || $fqdn =~ /^\s+$/) {
		$err = "ۥ̾ꤷƲ";
		goto done;
	}
	if (!&checkLongHostName($fqdn) && !&checkShortHostName($fqdn)) {
		$err = "ۥ̾FQDN⤷ϥۥ̾ꤷƲ";
		goto done;
	}

done:
	return($err);
}

#
# Listen ؼҤĴ
#
sub changeListen{
	local(@lines) = ();
	my($wbmc_conf);

	$wbmc_conf = "/etc/httpd/conf/wbmc.conf";
	if (!&readFile($wbmc_conf, "wbmc.conf", *lines)) {
		return("եɤ߹ߤ˼Ԥޤ");
	}

	&checkVirtualHost(*lines);
	&checkVirtualHost_realwbmc_domain(*lines);

	if (!&writeFile($wbmc_conf, "wbmc.conf", @lines)) {
		return("եν񤭹ߤ˼Ԥޤ");
	}
}

#
# VirtualHost򿷵Ͽ
#
sub addVirtualHost2
{
	local($server, $port,$port_80) = @_;
	local($ipaddr, $ipaddr_tmp);		##010122 ipaddr_tmpɲ
	local($serverport);
	local($err);
	local(@virtualhost);
#	local($port_80) = 80;
    if(!$port_80){$port_80 = 80};
	local($i,$port_hit,$port80_hit);

	if ($port eq "*") {
		$serverport = "$server";
	} else {
		$serverport = "$server-$port";
	}

	# ̾IPɥ쥹
##010122 delete 7 line
#	if ($server ne "_default_") {
#		$addr = gethostbyname($server);
#		if (!$addr) {
#		 	return("ФIPɥ쥹ޤǤ");
#		}
#		$ipaddr = sprintf("%u.%u.%u.%u", unpack("C*", $addr));
#	}

	# ݡֹå
	if ($port ne "*") {
		if (!&checkPortNum($port)) {
			return("ݡֹˤ1-65535ޤǤοͤꤷƤ");
		}
	}

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
		return("եɤ߹ߤ˼Ԥޤ");
	}

	$target = 0;
	$start = -1;
	$end = -1;
	@virtualhost = ();
	$port_hit = 0;
	$port80_hit = 0;
	$ipaddr = "";		##010122 add
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
			if ($1 =~ /\:$port/) {
				$port_hit = 1;
			}
			elsif ($1 =~ /:$port_80/) {
				$port80_hit = 1;
				$start_buf = $i;
			}

		}
		elsif ($lines[$i] =~ /^\s*ServerName\s+([^\s]+)\s*/i) {
			if ($server eq $1 && $port_hit == 1) {
				## ʣϰöƺƤӺ롣
				&delVirtualHost($server, $port);
#				return("βۥФϴϿƤޤ");
#				exit(1);
			}
			elsif ($server eq $1 && $port80_hit == 1) {
				$start = $start_buf;
				$target = 1;
			}
			else {
				$port_hit = 0;
			}
		}
##010122 add start----
		elsif ($lines[$i] =~ /^\s*#\s*wbmc:\s*Listen\s+([^\s]+):/i) {
			$ipaddr_tmp = $1;
		}
##010122 add end----
		elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
			if ($target) {
				$end = $i;
				$target = 0;
				$ipaddr = $ipaddr_tmp;		##010122 add
			}
		}
	}
	# port:80򥳥ԡƤ
	if (($start != -1) && ($end != -1)) {
		for($i = $start;$i <= $end; $i++) {
			$w_lines = $lines[$i];
			if ($w_lines =~ /\Q$server:$port_80\E/) {
				$w_lines =~ s/\Q$server:$port_80\E/$server:$port/;
			} elsif ($w_lines =~ /\Q$ipaddr:$port_80\E/) {
				$w_lines =~ s/\Q$ipaddr:$port_80\E/$ipaddr:$port/;
			} elsif ($w_lines =~ /\Qerror_log.$server\E/) {
				$w_lines =~ s/\Qerror_log.$server\E/error_log.$server-ssl/;
			} elsif ($w_lines =~ /\Qaccess_log.$server\E/) {
				$w_lines =~ s/\Qaccess_log.$server\E/access_log.$server-ssl/;
			}
			push(@virtualhost, $w_lines);
		}
		splice(@lines, $end+1, 0, @virtualhost);
	}

	# Listenå
	&checkVirtualHost(*lines);
	&checkVirtualHost_realwbmc_domain(*lines);

	# wbmc.conf˽񤭹
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		return("եν񤭹ߤ˼Ԥޤ");
	}

	# logrotate˽񤭲ä
	if ($serverport ne "_default_") {
# wbmc03-B23 update kokokara
#		if (&write_rotate($serverport, $serverport) == -1) {
		$err = &cluster_exec_all("write_rotate", "$server-ssl", "$server-ssl");
## update 001206 kokokara
		if ($err) {
#			return("եν񤭹ߤ˰Ԥޤ");
			return($err);
		}
## update 001206 kokomade
# wbmc03-B23 update kokomade
	}

	# ɥȥ롼Ȥɲä
#	if ($err = &addDirectory($server, $port, $document)) {
#		return($err);
#	}
	return("");
}

#
# VirtualHost
#
sub delVirtualHost
{
	local($server, $port) = @_;
	local(@lines);
	local($target, $start, $end);
	local($serverport);
	local($file);
	local($err) = "";
	local($i,$find_server);

	if ($port eq "*") {
		$serverport = "$server";
	} else {
		$serverport = "$server-$port";
	}

	# wbmc.confɤ߹
	if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
## update 001206 kokokara
#		&showErrorPage("եɤ߹ߤ˼Ԥޤ");
		return "եɤ߹ߤ˼Ԥޤ";
#		exit(1);
## update 001206 kokomade
	}

	$target = 0;
	$start = -1;
	$end = -1;
    $find_server = 0;
	for ($i = 0; $i <= $#lines; $i++) {
	  if($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i){
        if ($1 =~ /\:$port/) {
          $target = 1;
          $start = $i;
        }
      }
      elsif($lines[$i] =~ /^\s*ServerName\s+([^\s]+)\s*/i){
        if($server ne $1){
          next;
      	}
      	else{
          $find_server = 1;
        }
      }
      elsif($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i){
        if ($target == 1 && $find_server == 1) {
          $end = $i;
          last;
        }
		else {
			$target = 0;
			$start = -1;
			$find_server = 0;
        }
      }
	}
	if (($start != -1) && ($end != -1)) {
		splice(@lines, $start, $end - $start + 1);
		&checkVirtualHost(*lines);
		&checkVirtualHost_realwbmc_domain(*lines);
	}

	# wbmc.conf˽񤭹
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
## update 001206 kokokara
#		&showErrorPage("եν񤭹ߤ˼Ԥޤ");
		return "եɤ߹ߤ˼Ԥޤ";
#		exit(1);
## update 001206 kokomade
	}

	if ($serverport ne "_default_") {

# wbmc03-B07 
		# logrotate
# wbmc03-B23 update kokokara
#		if (&write_rotate($serverport, "") == -1) {
		$err = &cluster_exec_all("write_rotate", "$server-ssl", "");
## update 001206 kokokara
		if ($err) {
#			&showErrorPage("եν񤭹ߤ˰Ԥޤ");
			return $err;
#			exit(1);
		}
## update 001206 kokomade
# wbmc03-B23 update kokomade
# wbmc03-B07 

		# ե
		while ($file = </var/log/httpd/*>) {
			if ($file =~ /^\/var\/log\/httpd\/(error|access)\Q_log.$server-ssl\E(|\.\d+)$/) {
				unlink($file);
			}
		}

# wbmc03-B07 
		# ̩
#		if ($port ne "*") {
#			&deleteSecret($server, $port);
#			&deleteCertificateRequest($server, $port);
#			&deleteCertificate($server, $port);
#		}
	}

	# Ƶư
	if (&isServiceRunning("")) {
#		&restartApache();
	}
}

#
# Listen  NameVirtualHost Ĵ
#
sub checkVirtualHost
{
	local(*lines) = @_;
	local(%listen);
	my($i, $name, $value);
	my($vhost, $crt, $port, $ihost);

	for ($i = 0; $i <= $#lines; $i++) {
##		if ($lines[$i] =~ /^\s*<VirtualHost\s+([^:]+):\d+/i) {
		if ($lines[$i] =~ /^\s*ServerName\s+([^\s]+)\s*/i) {
			$vhost = $1;
		}
		elsif ($lines[$i] =~ /^\s*#\s*wbmc:\s*Listen\s+([^\s]+)/i) {
#			$listen{$1} = $vhost;
			$ihost = $1;
		}
		elsif ($lines[$i] =~ /^\s*Listen\s+/i) {
			splice(@lines, $i, 1);
			$i--;
		}
		elsif ($lines[$i] =~ /^\s*NameVirtualHost\s+/i) {
			splice(@lines, $i, 1);
			$i--;
		}
		elsif ($lines[$i] =~ m'^\s*</VirtualHost>'i) {
			$listen{$ihost} = $vhost;
			$ihost = "";
			$vhost = "";
		}
	}
	$crt = "/etc/httpd/conf/ssl.crt/crt";
	while (($name, $value) = each(%listen)) {
		$port = (split(/:/, $name))[1];
		## $name=="" λϽϤʤ褦˽(ǰΤ) 010322
#		if ((-e "$crt\_$value-ssl.pem")&&($name)) {
		if ($name) {
			push(@lines, "Listen $name\n");
		}
		if (($name !~ /^0\.0\.0\.0:/)&&($name)) {
			push(@lines, "NameVirtualHost $name\n");
		}
	}
}

#
# ApacheƵư(饹б)
#
sub restartApache
{
	local($err);

#	if ($err = &cluster_exec_all("restartApache_exec")) {
	if ($err = &cluster_exec_all("restartApache_domain")) {
		&showErrorPage("$err");
		exit(1);
	}
}

#
# SSL keyfile Ū򤹤롣
#	$key = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
#	$csr = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
#	$crt = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";
sub saveSslKey
{
	local($server) = @_;
	local($key, $csr, $crt);
	local($key_save, $csr_save, $crt_save);

	$key = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
	$csr = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
	$crt = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";

	$key_save = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem_save";
	$csr_save = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem_save";
	$crt_save = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem_save";

	$server =~ s/\s//g;
	if ($server eq "") {
		return();
	}

	#  *_save ä
	if (-f $key_save) {
		system("/bin/rm -f $key_save");
	}
	elsif (-f $csr_save) {
		system("/bin/rm -f $csr_save");
	}
	elsif (-f $crt_save) {
		system("/bin/rm -f $crt_save");
	}

	# *_save 
	if ((-f $key)&&(!-f $key_save)) {
		system("/bin/cp -f $key $key_save");
	}
	if ((-f $csr)&&(!-f $csr_save)) {
		system("/bin/cp -f $csr $csr_save");
	}
	if ((-f $crt)&&(!-f $crt_save)) {
		system("/bin/cp -f $crt $crt_save");
	}
	return ();
}

#
# 򤷤ƤSSL keyfile  ᤹
#	$key = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
#	$csr = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
#	$crt = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";
sub restoreSslKey
{
	local($server) = @_;
	local($key, $csr, $crt);
	local($key_save, $csr_save, $crt_save);

	$key = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
	$csr = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
	$crt = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";

	$key_save = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem_save";
	$csr_save = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem_save";
	$crt_save = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem_save";

	$server =~ s/\s//g;
	if ($server eq "") {
		return();
	}

	# *_save 鸵Υե
	if (-f $key_save) {
		system("/bin/cp -f $key_save $key");
	}
	if (-f $csr_save) {
		system("/bin/cp -f $csr_save $csr");
	}
	if (-f $crt_save) {
		system("/bin/cp -f $crt_save $crt");
	}

	# *_save 
	if (-f $key_save) {
		system("/bin/rm -f $key_save");
	}
	elsif (-f $csr_save) {
		system("/bin/rm -f $csr_save");
	}
	elsif (-f $crt_save) {
		system("/bin/rm -f $crt_save");
	}

}

#
# 򤷤ƤSSL keyfile 
#	$key = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem";
#	$csr = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem";
#	$crt = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem";
sub delSavedKey
{
	local($server) = @_;
	local($key_save, $csr_save, $crt_save);

	$key_save = "/etc/httpd/conf/ssl.key/key_$server-ssl.pem_save";
	$csr_save = "/etc/httpd/conf/ssl.csr/csr_$server-ssl.pem_save";
	$crt_save = "/etc/httpd/conf/ssl.crt/crt_$server-ssl.pem_save";

	$server =~ s/\s//g;
	if ($server eq "") {
		return();
	}

	# *_save 
	if (-f $key_save) {
		system("/bin/rm -f $key_save");
	}
	elsif (-f $csr_save) {
		system("/bin/rm -f $csr_save");
	}
	elsif (-f $crt_save) {
		system("/bin/rm -f $crt_save");
	}

}

1;
