#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: init2.cgi,v 1.1.1.1 2002/09/09 07:43:31 snavi Exp $

##000727 4.1  misa Require
##000817 4.1  misa path

#----------------------------------------------------------------------
require "../../../lib/wbmc.pl";

#000727 misa rep require
#require "server.pl";
#require "rotate.pl";
#require "dir.pl";
require join ("/", $WBMC_ADM_DIR,    "service/01httpd", "server.pl");

#
# httpd.conf  Include .....wbmc.conf ɲä
#
if (!&readFile("/etc/httpd/conf/httpd.conf", "httpd.conf", *lines)) {
	&showErrorPage("եɤ߹ߤ˼Ԥޤ");
	exit(1);
}
($already, $startseed, $connectseed) = (0, 0, 0);
for ($i = 0; $i <= $#lines; $i++) {
	if ($lines[$i] =~ /^\s*#/) {
		next;
	}
	elsif ($lines[$i] =~ /^\s*Listen\s+/i) {
		$lines[$i] = "#$lines[$i]";
		next;
	}
	elsif ($lines[$i] =~ /^\s*SSLRandomSeed\s+startup\s+/i) {
		$startseed = 1;
		next;
	}
	elsif ($lines[$i] =~ /^\s*SSLRandomSeed\s+connect\s+/i) {
		$connectseed = 1;
		next;
	}
	elsif ($lines[$i] =~ /^\s*Include\s+\/etc\/httpd\/conf\/wbmc.conf\s*$/i) {
		$already = 1;
	}
	elsif ($lines[$i] =~ /^\s*<VirtualHost\s+/i) {
		$vhost = 1;
	}
	elsif ($lines[$i] =~ /^\s*<\/VirtualHost>/i) {
		$vhost = 0;
	}
	elsif ($vhost == 1) {
		next;
	}
	elsif ($lines[$i] =~ /^\s*DocumentRoot\s+([^\s]+)/i) {
		$document = $1;
		if ($document =~ /^".*"$/) {
			$document =~ s/^"//;
			$document =~ s/"$//;
		}
	}
}
if ($already == 0) {
	push(@lines, "Include /etc/httpd/conf/wbmc.conf\n");
}
if (!&writeFile("/etc/httpd/conf/httpd.conf", "httpd.conf", @lines)) {
	&showErrorPage("եɤ߹ߤ˼Ԥޤ");
	exit(1);
}

#
# wbmc.conf
#
if (! -e "/etc/httpd/conf/wbmc.conf") {
	@lines = ();
	if (-e "/usr/libexec/libssl.so") {
		$tmp = "LoadModule ssl_module /usr/libexec/libssl.so\n";
	}
	elsif (-e "/usr/libexec/apache/libssl.so") {
		$tmp = "LoadModule ssl_module /usr/libexec/apache/libssl.so\n";
	}
	@lines = ();
	if (!&readFile("./wbmc.conf", "wbmc.conf", *lines)) {
		&showErrorPage("եɤ߹ߤ˼Ԥޤ");
		exit(1);
	}
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] !~ /^\s*#/) {
			last;
		}
	}
	splice(@lines, $i, 0, $tmp);
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*SSLRandomSeed\s+startup\s+/i
			&& $startseed == 1) {
			splice(@lines, $i, 1);
			$i--;
		}
		if ($lines[$i] =~ /^\s*SSLRandomSeed\s+connect\s+/i
			&& $connectseed == 1) {
			splice(@lines, $i, 1);
			$i--;
		}
	}
	if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
		&showErrorPage("եν񤭹ߤ˼Ԥޤ");
		exit(1);
	}

	&addVirtualHost("_default_", "*", $document);
}

#
# 줾Υڡ˥
#
if ($ARGV[0] eq "start") {
	&restartApache();
	&showPage("../menu.cgi");
}
else {
	#000817 misa rep path
	&showPage("../../httpd/index.cgi");
}

