
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: server.pl,v 1.2 2002/09/27 12:27:24 snavi Exp $

#--------------------------------------------------------------------------


#--------------------------------------------------------------------------
##000802 v4.1 require -> joinѹ Hori
##000804 v4.1 require -> wbmc.plɲ Hori
##000908 v4.1 饹б Hori

#require "../../../lib/wbmc.pl";
require join ("/", $WBMC_ADM_DIR,"service/01httpd/ssl.pl");

#
# VirtualHost򿷵Ͽ
#
sub addVirtualHost
{
    local($server, $port, $document) = @_;
    local($addr, $ipaddr, $ipaddr2, $port2);
    local($write_listen_flag) = 1;
    local($serverport);
    local($err);

    if ($port eq "*") {
        $serverport = "$server";
    } else {
        $serverport = "$server-$port";
    }

    # ̾IPɥ쥹
    if ($server ne "_default_") {
        $addr = gethostbyname($server);
        if (!$addr) {
            return("ФIPɥ쥹ޤǤ");
        }
        $ipaddr = sprintf("%u.%u.%u.%u", unpack("C*", $addr));
    }

    # ݡֹå
    if ($port ne "*") {
        if (!&checkPortNum($port)) {
            return("ݡֹˤ1-65535ޤǤοͤꤷƤ");
        }
    }

    # DocumentRootå
    if ($document) {
        if ($document !~ /^\//) {
            return("ɥȥ롼ȤˤХѥꤷƲ");
            exit(1);
        }
        if ($document =~ /(.+)\/$/) {
            $document = $1;
        }
    }
    # DocumentRoot̵Хǥե
    else {
        $document = "/home/httpd/html";
    }

    # wbmc.confɤ߹
    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        return("եɤ߹ߤ˼Ԥޤ");
    }

    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
            if ("$server:$port" eq $1) {
                return("βۥФϴϿƤޤ");
                exit(1);
            }
        }
    }

    push(@lines, "<VirtualHost $server:$port>\n");
    if ($ipaddr) {
        if ($port ne "*") {
            push(@lines, "\t# wbmc: Listen $ipaddr:$port\n");
        }
    }
    else {
        if ($port ne "*") {
            push(@lines, "\t# wbmc: Listen 0.0.0.0:$port\n");
        }
    }
    push(@lines, "\tServerName $server\n");
    push(@lines, "\tDocumentRoot $document\n");
#   if ($serverport ne "_default_") {
#       push(@lines, "\tErrorLog /var/log/httpd/error_log.$serverport\n");
#       push(@lines, "\tCustomLog /var/log/httpd/access_log.$serverport common\n");
#   }
    push(@lines, "\tDirectoryIndex index.html\n");
    push(@lines, "\tDefaultType text/plain\n");
    push(@lines, "</VirtualHost>\n");

    # Listenå
    &checkVirtualHost(*lines);

    # wbmc.conf˽񤭹
    if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
        return("եν񤭹ߤ˼Ԥޤ");
    }

    # logrotate˽񤭲ä
#   if ($serverport ne "_default_") {
#       if (&write_rotate($serverport, $serverport) == -1) {
#           return("եν񤭹ߤ˰Ԥޤ");
#       }
#   }

    # ɥȥ롼Ȥɲä
    if ($err = &addDirectory($server, $port, $document)) {
        return($err);
    }

    return("");
}

#
# VirtualHostѹ
#
sub modVirtualHost
{
    local($server, $port, $newdocument) = @_;
    local(@lines);
    local($target);

    # DocumentRootå
    if ($newdocument) {
        if ($newdocument !~ /^\//) {
            &showErrorPage("ɥȥ롼ȤˤХѥꤷƲ");
            exit(1);
        }
        if ($newdocument =~ /(.+)\/$/) {
            $newdocument = $1;
        }
    }
    # DocumentRoot̵Хǥե
    else {
        $newdocument = "/home/httpd/html";
    }

    # wbmc.confɤ߹
    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        &showErrorPage("եɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    $target = 0;
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
            if ("$server:$port" eq $1) {
                $target = 1;
            }
        }
        elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
            $target = 0;
        }
        elsif ($target == 0) {
            next;
        }
        elsif ($lines[$i] =~ /^\s*DocumentRoot\s+/i) {
            splice(@lines, $i, 1, "\tDocumentRoot $newdocument\n");
        }
    }

    # Listenå
    &checkVirtualHost(*lines);

    # wbmc.conf˽񤭹
    if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
        &showErrorPage("եν񤭹ߤ˼Ԥޤ");
        exit(1);
    }

    # Ƶư
    if (&isServiceRunning("")) {
        &restartApache();
    }
}

#
# VirtualHost
#
sub delVirtualHost
{
    local($server, $port) = @_;
    local(@lines);
    local($target, $start, $end);
    local($serverport);
    local($file);

    if ($port eq "*") {
        $serverport = "$server";
    } else {
        $serverport = "$server-$port";
    }

    # wbmc.confɤ߹
    if (!&readFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", *lines)) {
        &showErrorPage("եɤ߹ߤ˼Ԥޤ");
        exit(1);
    }

    $target = 0;
    $start = -1;
    $end = -1;
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*<VirtualHost\s+([^\s]+)\s*>/i) {
            if ("$server:$port" eq $1) {
                $target = 1;
                $start = $i;
            }
        }
        elsif ($lines[$i] =~ /^\s*<\/VirtualHost\s*>/i) {
            if ($target) {
                $end = $i;
                last;
            }
        }
    }

    if (($start != -1) && ($end != -1)) {
        splice(@lines, $start, $end - $start + 1);
        &checkVirtualHost(*lines);
    }

    # wbmc.conf˽񤭹
    if (!&writeFile("/etc/httpd/conf/wbmc.conf", "wbmc.conf", @lines)) {
        &showErrorPage("եν񤭹ߤ˼Ԥޤ");
        exit(1);
    }

    if ($serverport ne "_default_") {

#       # logrotate
#       if (&write_rotate($serverport, "") == -1) {
#           &showErrorPage("եν񤭹ߤ˰Ԥޤ");
#           exit(1);
#       }

        # ե
#       while ($file = </var/log/httpd/*>) {
#           if ($file =~ /^\/var\/log\/httpd\/(error|access)_log.$serverport(|\.\d+)$/) {
#               unlink($file);
#           }
#       }

        # ̩
        if ($port ne "*") {
            &deleteSecret($server, $port);
            &deleteCertificateRequest($server, $port);
            &deleteCertificate($server, $port);
        }
    }

    # Ƶư
    if (&isServiceRunning("")) {
        &restartApache();
    }
}

#
# Listen  NameVirtualHost Ĵ
#
sub checkVirtualHost
{
    local(*lines) = @_;
    local(%listen);
    my($i, $name, $value);
    my($vhost, $crt, $port);

    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*<VirtualHost\s+([^:]+):\d+/i) {
            $vhost = $1;
        }
        elsif ($lines[$i] =~ /^\s*#\s*wbmc:\s*Listen\s+([^\s]+)/i) {
            $listen{$1} = $vhost;
        }
        elsif ($lines[$i] =~ /^\s*Listen\s+/i) {
            splice(@lines, $i, 1);
            $i--;
        }
        elsif ($lines[$i] =~ /^\s*NameVirtualHost\s+/i) {
            splice(@lines, $i, 1);
            $i--;
        }
        elsif ($lines[$i] =~ m'^\s*</VirtualHost>'i) {
            $vhost = "";
        }
    }
    $crt = "/etc/httpd/conf/ssl.crt/crt";
    while (($name, $value) = each(%listen)) {
        $port = (split(/:/, $name))[1];
        if ($port != 443 || -e "$crt\_$value-$port.pem") {
            push(@lines, "Listen $name\n");
        }
        if ($name !~ /^0\.0\.0\.0:/) {
            push(@lines, "NameVirtualHost $name\n");
        }
    }
}

#
# ApacheƵư(饹б)
#
sub restartApache
{
	local($err);

	if ($err = &cluster_exec_all("restartApache_exec")) {
		&showErrorPage("$err");
		exit(1);
	}
}

#
# ApacheƵư ؿ̾ѹ
#
sub restartApache_exec
{
    local($errmsg, @col);
    local($i, @lines, $arg, $found, $wflag);

    # httpd.bootopt-DSSL̵ФĤ
    &readFile("/etc/httpd/conf/httpd.bootopt", "httpd.bootopt", *lines);
    $found = 0;
    $wflag = 0;
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*HTTPDOPT\s*=\s*(.*)/) {
            $arg = $1;
            $arg =~ s/\s*$//;
            if ($arg !~ /-DSSL(\s+|$)/) {
                $lines[$i] = "HTTPDOPT=\"-DSSL $arg\"\n";
                $wflag = 1;
            }
            $found = 1;
        }
    }
    if ($found == 0) {
        push(@lines, "HTTPDOPT=-DSSL\n");
        $wflag = 1;
    }
    if ($wflag) {
        &writeFile("/etc/httpd/conf/httpd.bootopt", "httpd.bootopt", @lines);
    }

    # Apache κƵư
    if (!open(CMD, "/etc/rc.d/init.d/httpd restart 2>&1 |")) {
#       &showErrorPage("Apache εư˼Ԥޤ");
#       exit(1);
        return "Apache εư˼Ԥޤ";
    }
    while (<CMD>) {
        $errmsg .= <CMD>;
    }
    close (CMD);

    if ($errmsg =~ /error/i) {
        $errmsg =~ s/\n/<BR>/g;
#       &showErrorPage("Apacheεư˼Ԥޤ<BR>$errmsg");
#       exit(1);
        return "Apacheεư˼Ԥޤ<BR>$errmsg";
    }

    if ($errmsg =~ /warning/i) {
        $errmsg =~ s/\n/<BR>/g;
#       &showErrorPage("ٹåޤ<BR>$errmsg");
#       exit(1);
        return "ٹåޤ<BR>$errmsg";
    }
}

1;

