#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: fml.pl,v 1.2 2002/09/24 06:03:19 snavi Exp $

## 010507 getListAliasesˤƤζƤս Nagashima
## 	  modListMemˤƶˤʬ䤷åԤäƤս Nagashima
## 010509 delListˤץեɲ T.Shimizu
## 010511 ᡼󥰥ꥹѥꥢΡåȤ Nagashima
## 	  ᡼󥰥ꥹȥФΡåȤ Nagashima
## 010703 ꥢ᡼륢ɥ쥹 | Υɲ Nagashima
## 010726 ꥢ᡼륢ɥ쥹 | Υɺ Nagashima
## 010730 /home/fml/$domainname/etc/qmail/alias ۲ץե Oku
## 020904 ⡼ȴޥɻѵļɲäȺɲ matumura

#--------------------------------------------------------------------

require "/opt/nec/wbmc/domain/lib/wbmc.pl";
# ᡼륢ɥ쥹åˡꥢå롼Ȥᡣ
require join ("/", $WBMC_DOMADM_DIR, "mail", "aliase.pl");

# ɬפʥѥ򥻥åȡ
$WBMC_FMLDIR		= "/usr/local/fml";
$WBMC_FMLSPOOLDIR	= "/home/fml";
$MAKEFML		= "$WBMC_FMLDIR/makefml";
$WBMC_FMLUSER		= "fml";
$WBMC_FMLGROUP		= "fml";
$WBMC_ALIASES		= "/etc/mail/aliases";
$WBMC_ALIASES_LOCKNAME	= "aliases";
$WBMC_ALIASEUSER	= "fml";
$domain_conf		= "$WBMC_CONF_DIR/domain.conf";
$domain_conf_lock	= "domain.conf";
$MEMBERS_ADMIN_LOCKNAME	= "menbers-admin";
$MEMBERS_ADMIN_ETC_PASSWD_LOCKNAME	= "etc-passwd";

#--------------------------------------------------------------------
# Function
#   fml ѥեɤ߹ࡣ cf/members/actives
# Parameters
#  $listname	᡼󥰥ꥹ̾
#  $path		ɤ߹ե̾(եѥ)
#  *lines		ɤ߹Хåե
# Return
#  ""     
#  ""ʳ 顼å
#
sub readFmlFile
{
	local($listname, $path, *lines)	= @_;
	local($mode, $err, $lockf);
	my($lockfmlflg, $openflg);
	
	$err		= "";
	$mode		= $WBMC_LOCK_R_NB;		# ɤ߹ߥå(Υ֥å⡼)
	$openflg	= 0;
	
	# fml å
	if ($err = lockFml($listname, $domainname, $mode, *lockf) ) {
		goto done;
	}
	$lockfmlflg	= 1;
	
	# оݥեΥץ
	if ( !open(LOCK, "$path") ) {
		$err = "ե $path Υץ˼Ԥޤ";
		goto done;
	}
	$openflg = 1;	#open
	
	# оݥե˥å򤫤
	if (!flock(LOCK, $mode)) {
		$err = "ե $path ɤ߹ߥå˼ԤޤФ餯äƤʤƤ";
		goto done;
	}
	
	# եɤ߹
	if (!open(IN, $path)) {
		$err = "ե $path ɤ߹ߤ˼Ԥޤ";
		goto done;
	}
	@lines = <IN>;
	
done:
	if ($openflg) {
		close(LOCK);
	}
	
	# fml å
	if ($lockfmlflg) {
		unlockFml($lockf);
	}
	
	return($err);
}


#--------------------------------------------------------------------
#
# Function
#   fml ѥեؽ񤭹ࡣ members/actives
#
# Parameters
#  $listname	᡼󥰥ꥹ̾
#  $path		ե̾(եѥ)
#  @lines		񤭹Хåե
# Return
#  ""     
#  ""ʳ 顼å
#
sub writeFmlFile
{
	local($listname, $path, @lines)	= @_;
	local($err, $mode, $tmpfile, $openflg, $lockf);
	my($filemode, $userid, $groupid, $lockfmlflg);
	
	$err		= "";
	$mode		= $WBMC_LOCK_W_NB;    # 񤭹ߥå(Υ֥å⡼)
	$tmpfile	= "$path.$$";
	$openflg	= 0;
	$lockfmlflg	= 0;
	
	# fml å
	if ($err = lockFml($listname, $domainname, $mode, *lockf) ) {
		goto done;
	}
	$lockfmlflg = 1;
	
	# å򤫤ȤǡºݤΥե񤭹߽롣
	# ե򥪡ץ
	if ( !open(LOCK, $path) ) {
		$err = "ե $path Υץ˼Ԥޤ";
		goto done;
	}
	$openflg = 1;	#open
	
	# ե˥å򤫤
	if (!flock(LOCK, $mode)) {
		$err = "ե $path ν񤭹ߥå˼ԤޤФ餯äƤʤƤ";
		goto done;
	}
	
	# եΥ⡼(ѡߥå)桼ID롼ID롣
	($filemode, $userid, $groupid) = (stat($path))[2,4,5];
	
	# ȥե򥪡ץ󤷤ƽ񤭹
	if (!open(OUT, "> $tmpfile")) {
		$err = "ȥեΥץ˼Ԥޤ";
		goto done;
	}
	if (!print(OUT @lines)) {
		close(OUT);
		$err = "եؤν񤭹ߤ˼Ԥޤ";
		goto done;
	}
	close(OUT);
	
	# Υե˥͡ह
	if (!rename($tmpfile, $path)) {
		$err = "ե $path Υ͡˼Ԥޤ";
		goto done;
	}
	
	# եΥѡߥå򸵤᤹
	chmod($filemode & 07777, $path);
	# եΥʡ򸵤᤹
	if (!chown($userid, $groupid, $path)) {
		$err = "ե $path Υʡ˼Ԥޤ";
		goto done;
	}
	
done:
	if ($openflg) {
		close(LOCK);
	}
	
	if (-f $tmpfile) {
		unlink($tmpfile);
	}
	
	# fml å
	if ($lockfmlflg) {
		unlockFml($lockf);
	}
	
	return($err);
}


#--------------------------------------------------------------------
#
# Function
#   fml Υ᡼󥰥ꥹñ̤Υå/var/spool/ml/ML/spool/å롣
#   ǥ쥯ȥ꤬ʤｪλ롣(ޤäΥꥹȥΤ)
#
# Parameters
#  $listname	᡼󥰥ꥹ̾
#  $domainname	ɥᥤ̾
#  $mode		å⡼(wbmc.pl Ѥ)
#               fml  2 ǥåƤ͡
#                 $WBMC_LOCK_R_B  = 1; # ɤ߹ߥå(֥å⡼)
#                 $WBMC_LOCK_W_B  = 2; # 񤭹ߥå(֥å⡼)
#                 $WBMC_LOCK_R_NB = 5; # ɤ߹ߥå(Υ֥å⡼)
#                 $WBMC_LOCK_W_NB = 6; # 񤭹ߥå(Υ֥å⡼)
#  *lockf		spool  open եϥɥ
# Return
#  ""     
#  ""ʳ 顼å
#
sub lockFml
{
	local($listname, $domainname, $mode, *lockf)	= @_;
	my($err) = "";
	local($sp, $spopenflg);
	
	$err	= "";
	$spopenflg = 0;
	
	# /var/spool/ml/ML/spool/ å
	$sp	= "$WBMC_FMLSPOOLDIR/$domainname/$listname/spool/";
	
	# spool/ ʤСｪλȤƥ꥿
	if (!-d $sp) {
		$lockf = 0;
		goto done;
	}
	
	# spool/ Υå
	# spool/ 򥪡ץ
	if (!open(LOCK, $sp)) {
		$err = "fml եΥץ˼Ԥޤ";
		goto done;
	}
	$spopenflg = 1;
	
	# spool/ ˥å򤫤
	if (!flock(LOCK, $mode)) {
		$err  = "᡼󥰥ꥹȤΥåǥ顼ȯޤ¾ǻǤ<BR>";
		$err .= "Ф餯äƤʤƤ";
		goto done;
	}
	$lockf = LOCK;
	
done:
	if ($spopenflg) {
		close(LOCK);
	}
	
	return($err);
}


#--------------------------------------------------------------------
#
# Function
#   fml Υ᡼󥰥ꥹñ̤Υå
#
# Parameters
#  $lockf		openեϥɥ
# Return
#  ʤ
#
sub unlockFml
{
	local($lockf)	= @_;
	
	close($lockf);
	
	return();
}


#--------------------------------------------------------------------
#
# Function
#   cf ؽ񤭹ߡconfig.ph ȿǤ롣
#
# Parameters
#  $listname	᡼󥰥ꥹ̾
#  $domainname	ɥᥤ̾
# Return
#  ""     
#  ""ʳ 顼å
#
sub writeCf
{
	local($listname, $domainname, @lines)	= @_;
	local($mode, $err, $cf, $tmpfile, $filemode, $userid, $groupid);
	my($lockfileflg, $lockfmlflg);
	
	$err	= "";
	$mode	= $WBMC_LOCK_W_NB;    # 񤭹ߥå(Υ֥å⡼)
	
	$cf			= "$WBMC_FMLSPOOLDIR/$domainname/$listname/cf";
	$tmpfile	= "$cf.$$";
	$lockfileflg= 0;
	$lockfmlflg	= 0;
	
	# fml å
	if ($err = lockFml($listname, $domainname, $mode, *lockf) ) {
		goto done;
	}
	$lockfmlflg = 1;
	
	# cf 򥪡ץ
	if ( !open(LOCK, $cf) ) {
		$err = "եcfΥץ˼Ԥޤ";
		goto done;
	}
	
	# cf ˥å򤫤
	if (!flock(LOCK, $mode)) {
		close(LOCK);
		$err = "եcfν񤭹ߥå˼Ԥޤ";
		goto done;
	}
	$lockfileflg = 1;
	
	# cfեΥ⡼(ѡߥå)桼ID롼ID롣
	($filemode, $userid, $groupid) = (stat($cf))[2,4,5];
	
	# ȥե򥪡ץ󤷤ƽ񤭹
	if (!open(OUT, "> $tmpfile")) {
		$err = "ȥեΥץ˼Ԥޤ";
		goto done;
	}
	if (!print(OUT @lines)) {
		close(OUT);
		$err = "եؤν񤭹ߤ˼Ԥޤ";
		goto done;
	}
	close(OUT);
	
	# Υե˥͡ह
	if (!rename($tmpfile, $cf)) {
		$err = "եcfΥ͡˼Ԥޤ";
		goto done;
	}
	
	# cfեΥѡߥå򸵤᤹
	chmod($filemode & 07777, $cf);
	# cfեΥʡ򸵤᤹
	if (!chown($userid, $groupid, $cf)) {
		$err = "ե $cf Υʡ˼Ԥޤ";
		goto done;
	}
	
	# cfե򥢥å롣
	close(LOCK);
	$lockfileflg = 0;
	
	# fml إå򤫤֤Τޤޡconfig.ph ؤιޤǹԤ
	&makeConfigPh($listname, $domainname);
	
done:
	if ($lockfileflg) {
		close(LOCK);
	}
	
	if (-f $tmpfile) {
		unlink($tmpfile);
	}
	
	# fml å
	if ($lockfmlflg) {
		unlockFml($lockf);
	}
	
	return($err);
}


#--------------------------------------------------------------------
#
# Function
#   cf  config.ph 롣
#   fmlλͤȴ
#       makefml update ML config.ph : re-create ML's config.ph
#	    make config.ph Ʊ̤
#	      % makefml update elena config.ph
#	        
#	      % (cd /var/spool/ml/elena; make config.ph) 
#	    ƱȤ򤹤롣ʤߤ
#	      % makefml update-config.ph elena
#	      % makefml elena::update-config.ph
#	    Ϥ alias Ǥ롣
#
# Parameters
#  $listname	᡼󥰥ꥹ̾
#  $domainname	ɥᥤ̾
# Return
#  ""     
#  ""ʳ 顼å
#
sub makeConfigPh
{
	local($listname, $domainname)	= @_;
	local($err, $stderrmsg);
	
	$err	= "";
	$MAKEFML .= " -f $WBMC_FMLSPOOLDIR/$domainname/.fml/system";

	# cf -> config.ph ȿǤ롣
	if (open(MKFML, "su -c \"/usr/bin/perl $MAKEFML update $listname config.ph \" $WBMC_FMLUSER 2>&1 |")) {
		# makefml ۾ｪλϡ*** Error: xxxxxxxxxxxxxxx *** ȽФ롣
		$err = "᡼󥰥ꥹԽ(makefml)ǥ顼ȯޤ";
		while (<MKFML>) {
			$stderrmsg = <MKFML>;
			if ($stderrmsg =~ /Error/i) {
				$err .= "<BR>$stderrmsg";
			}
		}
		close (MKFML);
		goto done;
	}
	close (MKFML);
	
done:
	return($err);
}


#--------------------------------------------------------------------
# Function
#   ᡼󥰥ꥹȤ򹹿
# Parameters
#	$listname	᡼󥰥ꥹ̾
#	$domainname	ɥᥤ̾
#	$PSTPERM		ѥ᡼
#	$PSTELSE		ѥ᡼
#	$CMDPERM		ѥ᡼
#	$CMDELSE		ѥ᡼
# Return
#  ""     
#  ""ʳ 顼å
#
sub modList
{
	local($listname, $domainname, $pstperm, $pstelse, $cmdperm, $cmdelse, $admcmd, $authtype, $limsize, $maxmem, $expire, $days, $artnum, $tagtype, $idnum, $replyto, $from) = @_;
	local(@lines) = ();
	local($err);
	my($i);
	my($new_pstperm, $new_pstelse, $new_cmdperm, $new_cmdelse, $new_admcmd, $new_authtype, $new_limsize, $new_maxmem, $new_expire, $new_days, $new_artnum, $new_tagtype, $new_idnum, $new_replyto, $new_from);
	my($flg_pstperm, $flg_pstelse, $flg_cmdperm, $flg_cmdelse, $flg_admcmd, $flg_authtype, $flg_limsize, $flg_maxmem, $flg_expire, $flg_days, $flg_artnum, $flg_tagtype, $flg_idnum, $flg_replyto, $flg_from) = 0;
	
	$err = "";
	
	# ͥåϥݡоݳͤ()ꤵƤ顢Ū˥ݡ
	# ͤؽѤ롣
	if ( ($pstperm eq "members_only") ||
		 ($pstperm eq "anyone")       ||
		 ($pstperm eq "moderator") ) { ; } else {
		# $err = "ƤΥݥꥷ꤬ݡϰϳǤ<BR>ǥեȤꤵޤ";
		$pstperm = "members_only";
	}
	if ( ($pstelse eq "reject") ||
		 ($pstelse eq "ignore") ||
		 ($pstelse eq "auto_regist") ) { ; } else {
		# $err = "СʳƤ꤬ݡϰϳǤ<BR>ǥեȤꤵޤ";
		$pstelse = "reject";
	}
	if ( ($cmdperm eq "members_only") ||
	 	 ($cmdperm eq "anyone") ) { ; } else {
		# $err = "⡼ȥޥɤΥݥꥷ꤬ݡϰϳǤ<BR>ǥեȤꤵޤ";
		$cmdperm = "members_only";
	}
#		 ($cmdelse eq "auto_asymmetric_regist")		# membersactivesȤоΤˤǤ
	if ( ($cmdelse eq "reject") ||
		 ($cmdelse eq "ignore") ||
		 ($cmdelse eq "auto_subscribe") ) { ; } else {
		# $err = "СʳΥ⡼ȥޥɤ꤬ݡϰϳǤ<BR>ǥեȤꤵޤ";
		$cmdelse = "reject";
	}
	if ( ($admcmd eq "0") ||
		 ($admcmd eq "1") ) { ; } else {
		# $err = "⡼ȴޥɤ꤬ݡϰϳǤ<BR>ǥեȤꤵޤ";
		$admcmd = "0";
	}
	if ( ($authtype eq "address") ||
		 ($authtype eq "crypt") ||
		 ($authtype eq "pgp") ) { ; } else {
		# $err = "⡼ȴޥɤ꤬ݡϰϳǤ<BR>ǥեȤꤵޤ";
		$authtype = "crypt";
	}
	
	# ᡼륵λͥå
	if ($limsize =~ /^\s*0\s*\n*$/i) {
		$limsize = "";
	} elsif ($limsize =~ /^\s*\n*$/i) {
		$limsize = "";
	} elsif ($limsize =~ /^\s*(\d+)\s*\n*$/i) {
		$limsize = $1;
	} elsif ($limsize =~ /^\s*(\d+)K\s*\n*$/i) {
		$limsize = $1 * 1024;
	} elsif ($limsize =~ /^\s*(\d+)M\s*\n*$/i) {
		$limsize = $1 * 1024 * 1024;
	} else {
		$err = "᡼륵ξ¤ͤǤ";
		goto done;
	}
	
	if ($limsize ne "") {
		if ($limsize > 1024*1024*1024) {
			$err = "᡼륵ξ¤ͤ礭ޤ";
			goto done;
		}
	}

        # пΥåѴ0,10ʳ-1
	if ($maxmem !~ /^\s*\d*\s*\n*$/) {
		$err = "пͤǤ";
		goto done;
	}
	if ($maxmem > 1024*1024*1024) {
		$err = "пͤ礭ޤ";
		goto done;
	}
	if ($maxmem > 0) { $maxmem -= 1; }

	# /Υå
	if ($expire =~ /days/ && $days !~ /^\s*[1-9][0-9]*\s*\n*$/) {
		$err = "λ꤬Ǥ";
		goto done;
	}
	if ($days > 1024*1024*1024) {
		$err = "λ꤬礭ޤ";
		goto done;
	}
	if ($expire =~ /articles/ && $artnum !~ /^\s*[1-9][0-9]*\s*\n*$/) {
		$err = "λ꤬Ǥ";
		goto done;
	}
	if ($artnum > 1024*1024*1024) {
		$err = "λ꤬礭ޤ";
		goto done;
	}

        # פΥå
        if (($tagtype eq "") ||
            ($tagtype =~ /\(\:\)|\[\:\]|\(\s\)|\[\s\]|\(\,\)|\[\,\]|\(\)|\[\]|\(ID\)|\[ID\]/)) { ; } else {
        #       $err = "פݡоݳǤǥեȤꤵޤ";
                $tagtype = "";
		goto done;
        }

        # IDΥå
        if ($idnum =~ /-1|2|3|4|5|6|7|8|9|10/) { ; } else {
                $err = "IDݡоݳǤǥեȤꤵޤ";
                $idnum = "";
		goto done;
        }
	@replylines = split(/,/, "$replyto");
	$replyto = "";
	$n = 0;
	foreach (@replylines) {
		if ($_ =~ /[^\w-\.@]/) {
			$err = "reply-toΥ᡼륢ɥ쥹Ǥ";
			$replyto = "";
			goto done;
		}
		else {
			if ($n == 0) {
				$replyto .= $_;
				$n = 1;
			}	
			else {
				$replyto .= ", ";
				$replyto .= $_;
			}
		}
	}
	if ($from =~ /[^\w-\.@]/) {
		$err = "fromΥ᡼륢ɥ쥹Ǥ";
		$from = "";
		goto done;
	}
	
	# Ԥκ
	$new_pstperm = "PERMIT_POST_FROM		$pstperm";
	$new_pstelse = "REJECT_POST_HANDLER		$pstelse";
	$new_cmdperm = "PERMIT_COMMAND_FROM		$cmdperm";
	$new_cmdelse = "REJECT_COMMAND_HANDLER		$cmdelse";
	$new_admcmd = "REMOTE_ADMINISTRATION		$admcmd";
	$new_authtype = "REMOTE_ADMINISTRATION_AUTH_TYPE		$authtype";
	$new_limsize = "INCOMING_MAIL_SIZE_LIMIT	$limsize";
        $new_maxmem  = "MAX_MEMBER_LIMIT                $maxmem";
	if ($expire =~ /days/) {
		$notusespool = "NOT_USE_SPOOL			0";
		$useexpire   = "USE_EXPIRE			1";
		$expirelimit = "EXPIRE_LIMIT			${days}days";
		$expiresmry  = "EXPIRE_SUMMARY			1";
	}
	elsif ($expire =~ /articles/) {
		$notusespool = "NOT_USE_SPOOL			0";
		$useexpire   = "USE_EXPIRE			1";
		$expirelimit = "EXPIRE_LIMIT			$artnum";
		$expiresmry  = "EXPIRE_SUMMARY			1";
	}
	elsif ($expire =~ /allsave/) {
		$notusespool = "NOT_USE_SPOOL			0";
		$useexpire   = "USE_EXPIRE			0";
		$expirelimit = "EXPIRE_LIMIT			";
		$expiresmry  = "EXPIRE_SUMMARY			";
	}
	else {
		$notusespool = "NOT_USE_SPOOL			1";
		$useexpire   = "USE_EXPIRE			";
		$expirelimit = "EXPIRE_LIMIT			";
		$expiresmry  = "EXPIRE_SUMMARY			";
	}
        $new_tagtype = "SUBJECT_TAG_TYPE                $tagtype";
        $new_idnum   = "SUBJECT_FORM_LONG_ID            $idnum";
	$new_replyto = "\&DEFINE_FIELD_FORCED(\"reply-to\", \'$replyto\')\;";
	$new_from    = "\&DEFINE_FIELD_FORCED(\"from\", \'$from\')\;";
	
	# cfɤ߹ࡣ
	if ($err = &readFmlFile($listname, "$WBMC_FMLSPOOLDIR/$domainname/$listname/cf", *lines)) {
		goto done;
	}
	
	# Ԥȿǡ1ԤȤϸ¤ʤΤǡƱΤȿǤ롣
	for ($i = 0; $i <= $#lines; $i++) {
		# ƤΥݥꥷ
		if ($lines[$i] =~ /^PERMIT_POST_FROM\s+/) {
			splice(@lines, $i, 1, "$new_pstperm\n");
			$flg_pstperm = 1;
			next;
		}
		# ƤΥС
		if ($lines[$i] =~ /^REJECT_POST_HANDLER\s+/) {
			splice(@lines, $i, 1, "$new_pstelse\n");
			$flg_pstelse = 1;
			next;
		}
		# ⡼ȥޥɤΥݥꥷ
		if ($lines[$i] =~ /^PERMIT_COMMAND_FROM\s+/) {
			splice(@lines, $i, 1, "$new_cmdperm\n");
			$flg_cmdperm = 1;
			next;
		}
		# ⡼ȥޥɤΥС
		if ($lines[$i] =~ /^REJECT_COMMAND_HANDLER\s+/) {
			splice(@lines, $i, 1, "$new_cmdelse\n");
			$flg_cmdelse = 1;
			next;
		}
		# ⡼ȴޥɤλ
		if (($lines[$i] =~ /^REMOTE_ADMINISTRATION\s*/) && ($lines[$i] !~ /^REMOTE_ADMINISTRATION_/)) {
			splice(@lines, $i, 1, "$new_admcmd\n");
			$flg_admcmd = 1;
			next;
		}
		# ⡼ȴǧ
		if (($lines[$i] =~ /^REMOTE_ADMINISTRATION_AUTH_TYPE\s*/)) {
			splice(@lines, $i, 1, "$new_authtype\n");
			$flg_authtype = 1;
			next;
		}
		# ᡼륵ξ
		if ($lines[$i] =~ /^INCOMING_MAIL_SIZE_LIMIT\s+/) {
			splice(@lines, $i, 1, "$new_limsize\n");
			$flg_limsize = 1;
			next;
		}
                # п
                if ($lines[$i] =~ /^MAX_MEMBER_LIMIT\s+/) {
                        splice(@lines, $i, 1, "$new_maxmem\n");
                        $flg_maxmem = 1;
                        next;
                }
                # EXPIRE
                if ($lines[$i] =~ /^NOT_USE_SPOOL\s+/) {
                        splice(@lines, $i, 1, "$notusespool\n");
			$flg_notusespool = 1; next;
                }
                if ($lines[$i] =~ /^USE_EXPIRE\s+/) {
                        splice(@lines, $i, 1, "$useexpire\n");
			$flg_useexpire = 1; next;
                }
                if ($lines[$i] =~ /^EXPIRE_LIMIT\s+/) {
                        splice(@lines, $i, 1, "$expirelimit\n");
			$flg_expirelimit = 1; next;
                }
                if ($lines[$i] =~ /^EXPIRE_SUMMARY\s+/) {
                        splice(@lines, $i, 1, "$expiresmry\n");
			$flg_expiresmry = 1; next;
                }
                # 
                if ($lines[$i] =~ /^SUBJECT_TAG_TYPE\s+/) {
                        splice(@lines, $i, 1, "$new_tagtype\n");
                        $flg_tagtype = 1;
                        next;
                }
                # ID
                if ($lines[$i] =~ /^SUBJECT_FORM_LONG_ID\s+/) {
                        splice(@lines, $i, 1, "$new_idnum\n");
                        $flg_idnum = 1;
                        next;
                }
                # LOCAL CONFIG YOU CONFIGURED
                # ֿ:reply-to
                if ($lines[$i] =~ /^&DEFINE_FIELD_FORCED\s*\(['"]reply-to['"]/) {
                        splice(@lines, $i, 1, "$new_replyto\n");
                        $flg_replyto = 1;
                        next;
                }
                # :from
                if ($lines[$i] =~ /^&DEFINE_FIELD_FORCED\s*\(['"]from['"]/) {
                        splice(@lines, $i, 1, "$new_from\n");
                        $flg_from = 1;
                        next;
                }
	}
	
	# ⤷ѥ᡼ʤäɲä롣¿ʬʤȤϻפǰΤᡣ
	# &DEFINE_FIELD_FORCEDʸ #; ˤȶ礬Ǥ
	if (!$flg_replyto) {
		splice(@lines, $#lines, 1, "$new_replyto\n");
		push(@lines, "#;\n");
	}
	if (!$flg_from) {
		splice(@lines, $#lines, 1, "$new_from\n");
		push(@lines, "#;\n");
	}
	if (!$flg_pstperm) {
		push(@lines, "$new_pstperm\n");
	}
	if (!$flg_pstelse) {
		push(@lines, "$new_pstelse\n");
	}
	if (!$flg_cmdperm) {
		push(@lines, "$new_cmdperm\n");
	}
	if (!$flg_cmdelse) {
		push(@lines, "$new_cmdelse\n");
	}
	if (!$flg_admcmd) {
		push(@lines, "$new_admcmd\n");
	}
	if (!$flg_authtype) {
		push(@lines, "$new_authtype\n");
	}
	if (!$flg_notusespool) { push(@lines, "$notusespool\n"); }
	if (!$flg_useexpire) { push(@lines,   "$useexpire\n"); }
	if (!$flg_expirelimit) { push(@lines, "$expirelimit\n"); }
	if (!$flg_expiresmry) { push(@lines,  "$expiresmry\n"); }
	
	# cfؽ񤭹ߡconfig.ph ȿǤ롣
	if ($err = &writeCf($listname, $domainname, @lines)) {
		goto done;
	}
	
done:
	return($err);
}


#--------------------------------------------------------------------
# Function
#   ᡼󥰥ꥹȤϿ
# Parameters
#	$listname	᡼󥰥ꥹ̾
#	$domainname	ɥᥤ̾
# Return
#  ""     
#  ""ʳ 顼å
#
sub addList
{
	local($listname, $domainname) = @_;
	local($err);
	local(@all_lists, @delfile) = ();
	my($stderrmsg, $doneflg, $i, $dir);
	
	$err = "";
	$stderrmsg = "";
	$doneflg = 0;
	$MAKEFML .= " -f $WBMC_FMLSPOOLDIR/$domainname/.fml/system";
	
	# ᡼󥰥ꥹ̾Υ顼å
	if ($err = &checkListName($listname)) {
		goto done;
	}
	
	# ᡼󥰥ꥹȤϼΤǥ쥯ȥʤΤǡʸʸ̤Ͽ롣
	# ꥢʸʸ̤ʤط塢᡼󥰥ꥹȤˤĤƤ⡢
	# ʸʸåƤ
	@all_lists = &getListName($domainname);
	for ($i = 0; $i <= $#all_lists; $i++) {
		#010703 Nagashima
		#if ($all_lists[$i] =~ /^\s*$listname\s*$/i) {
		if ($all_lists[$i] =~ /^\s*\Q$listname\E\s*$/i) {
			$err = "¸Υ᡼󥰥ꥹ̾ϿǤޤ";
			goto done;
		}
	}
	
#	# ᡼󥰥ꥹȤɲä롣
#	if (open(MKFML, "su -c /usr/bin/perl $WBMC_FMLUSER $MAKEFML newml  $listname 2>&1 |")) {
#		# makefml ۾ｪλϡ*** Error: xxxxxxxxxxxxxxx *** ȽФ롣
#		$err = "᡼󥰥ꥹȺ(makefml)ǥ顼ȯޤ";
#		while (<MKFML>) {
#			$stderrmsg = <MKFML>;
##			if ($stderrmsg =~ /Error/i) {
#				$err .= "<BR>$stderrmsg";
##			}
#		}
#		goto done;
#	}
#	close (MKFML);
	
	open(MKFML, "su -c \"/usr/bin/perl $MAKEFML newml  $listname           \" $WBMC_FMLUSER 2>&1 |");
	# makefml ۾ｪλϡ*** Error: xxxxxxxxxxxxxxx *** ȽФ롣
	$err2 = "";
	while (<MKFML>) {
		$stderrmsg = <MKFML>;
		if ($stderrmsg =~ /Error/i) {
			$err2 .= "<BR>$stderrmsg";
		}
	}
	close (MKFML);
	
	# fmlѥǥ쥯ȥ꤬ǤƤ뤫ɤǧ롣
	if (!-e "$WBMC_FMLSPOOLDIR/$domainname/$listname/config.ph") {
		$err = "᡼󥰥ꥹȺ(makefml)ǥ顼ȯޤ" . $err2;

		system("/bin/rm -fr $WBMC_FMLSPOOLDIR/$domainname/$listname > /dev/null 2>&1");

		# /home/fml/$domainname/etc/qmail/alias ۲ץե
                &delQmail($listname, $domainname);

		goto done;
	}
	
	# ᡼󥰥ꥹѥꥢ򡢼ưϿ롣
	if ($err = &addListAliases($listname, $domainname)) {
		# Ԥ顢ѤߤΥ᡼󥰥ꥹȤƴλ롣
		# ¿ʬ̤ʤϤʤΤǡ˼ԤƤⵤˤʤ
		system("/bin/rm -fr $WBMC_FMLSPOOLDIR/$domainname/$listname > /dev/null 2>&1");

		# /home/fml/$domainname/etc/qmail/alias ۲ץե
		&delQmail($listname, $domainname);

		goto done;
	}
	
done:
	return($err);
}


#--------------------------------------------------------------------
# Function
#   ᡼󥰥ꥹȤ
# Parameters
#	$listname	᡼󥰥ꥹ̾
#	$domainname	ɥᥤ̾
# Return
#  ""     
#  ""ʳ 顼å
#
sub delList
{
	local($listname, $domainname) = @_;
	local($err);
	local($dir, $file, @lines, @tmplines);
	
	$err = "";
	
	if (system("/bin/rm -fr $WBMC_FMLSPOOLDIR/$domainname/$listname") != 0) {
		$err = "$listname Υסǥ쥯ȥ˼Ԥޤ";
		goto done;
	}
	
	# ꥢ̾κ
	if ($err = &delListAliases($listname, $domainname)) {
		$err = "$listname Υꥢ˼Ԥޤ";
		goto done;
	}
	
	# ʲ /home/fml/ɥᥤ/etc/ ۲Υ߽ԤƤⵤˤʤ

	# /home/fml/ɥᥤ/etc/qmail/alias/ ۲ץե
        &delQmail($listname, $domainname);

	# /home/fml/ɥᥤ/etc/crontab/fml 
	# # msend for $listname 鼡 # msend for other-ml ޤǤ
	$file = "/home/fml/$domainname/etc/crontab/fml";
	&readFile($file, "fml", *lines);
	@tmplines = ();
	foreach(@lines) {
		if (/\#\s+msend\s+for\s+(\S+)\s*$/) {
			if ($1 eq $listname) {
				$delete_flg++;
			} else {
				$delete_flg = 0;
			}
		}
		$delete_flg || push(@tmplines, $_);
	}
	&writeFile($file, "fml", @tmplines);
	system("chown fml:fml $file");

	# /home/fml/ɥᥤ/etc/qmail/users/assign 
	# $listname ¸ߤԤ
	$file = "/home/fml/$domainname/etc/qmail/users/assign";
	&readFile($file, "assign", *lines);
	@tmplines = ();
	foreach(@lines) {
		/[\+\:]\Q$listname\E\:/ || push(@tmplines, $_);
	}
	&writeFile($file, "assign", @tmplines);
	system("chown fml:fml $file");
	
	# /home/fml/ɥᥤ/etc/aliases 
	# ꥢƥץ졼Ȥ
	$file = "/home/fml/$domainname/etc/aliases";
	&readFile($file, "aliases", *lines);
	@tmplines = ();
	foreach(@lines) {
		if (/^(\S+)\:\s\:include:.+\/include\s*$/) {
			if ($1 eq $listname) {
				$delete_flg++;
			} else {
				$delete_flg = 0;
			}
		}
		$delete_flg || push(@tmplines, $_);
	}
	&writeFile($file, "fml", @tmplines);
	system("chown fml:fml $file");

done:
	return($err);
}


#--------------------------------------------------------------------
# Function
# 	᡼󥰥ꥹѥꥢμưϿ
# Parameters
#	$listname	᡼󥰥ꥹ̾
#	$domainname	ɥᥤ̾
# Return
#  ""     
#  ""ʳ 顼å
#
sub addListAliases
{
	local($listname, $domainname, @aliasedir) = @_;
	local(@lines, @aliaseLists) = ();
	local($err, $err2, $realdomain, $realgroup, $groupname) ;
	my($WbMC_flag, $i, $j, $k, $dir);
	
	$err = "";
	$WbMC_flag = 0;
	@aliaseLists = ("$listname",
					"$listname-ctl",
					"$listname-request",  
					"$listname-admin", 
					"owner-$listname",  
					"owner-$listname-ctl");
	
	# 롼̾μ
	if (($groupname = &getDomainConf($domainname, "GROUPNAME")) eq "") {
		$err = "ɥᥤեɤ߹ߤ˼Ԥޤ";
		goto done;
	}
	# ɥʤ¥ɥᥤ̾μ
	if (!&cluster_typechk()) {
		if (!&getRealDomain(*realdomain, *realgroup)) {
			$err = "ɥᥤեɤ߹ߤ˼Ԥޤ";
			goto done;
		}
	}
	# ۥɥᥤʤ饨ꥢ˥ɥᥤ̾ղ
	# 饹ʤ鲾ۥɥᥤΤϤʤΤ̤
	# ɥʤɥᥤ̾å
	if ((&cluster_typechk()) || ($domainname ne $realdomain)) {
		foreach $alias (@aliaseLists) {
			$alias .= "_$domainname";
		}
	}

	#010726 СѲĤˤꡢۥɥᥤȤΥåԤ
	opendir(DIR_ALIASE, "/etc/opt/nec/wbmc/aliasesdir");
	for $dir (readdir(DIR_ALIASE)) {
		next if $dir =~ /^\./;
		
		push(@lines, "/etc/opt/nec/wbmc/aliasesdir/" . $dir);
	}
	closedir(DIR_ALIASE);
	
	# ꥢ̾νʣå
	for ($k = 0; $k <= $#lines; $k++) {
		if (!&readFile($lines[$k], "", *aliasedir)) {
			$err = "$lines[$k] եɤ߹ߤ˼Ԥޤ";
			goto done;
		}
		for ($j = 0; $j <= $#aliaseLists; $j++) {

			for ($i = 0; $i <= $#aliasedir; $i++) {
				# ǽ餬# ʤ饳ȡʤιԤ³ʤΤǥåס
				if ($aliasedir[$i] =~ /^[#\s]/) {
					next;
				}
				# ʲꥢ̾ϿѤߤȽ(ʸʸ̤ʤ)
				if ($aliasedir[$i] =~ /^\Q$aliaseLists[$j]\E:/i) {
					$err = "᡼󥰥ꥹ̾¾ǻѤ줿ꥢȽʣޤ"
					 . "<BR>̤Υ᡼󥰥ꥹ̾ϿʤƤ";
					goto done;
				}
			}
		}
	}
	
#	# ɥᥤ alias եɤ߹ࡣ
#	if (!&readFile("$ALIASE_DIR/aliases_$groupname", "aliases_$groupname", *lines)) {
#		$err = "ե aliases_$groupname ɤ߹ߤ˼Ԥޤ";
#		goto done;
#	}
	
#	# ɥᥤΥꥢ̾Ȥνʣå
#	for ($j = 0; $j <= $#aliaseLists; $j++) {
#		for ($i = 0; $i <= $#lines; $i++) {
#			# ǽ餬# ʤ饳ȡʤιԤ³ʤΤǥåס
#			if ($lines[$i] =~ /^[#\s]/) {
#				next;
#			}
#			# ʲꥢ̾ϿѤߤȽ(ʸʸ̤ʤ)
#			#010703 Nagashima
#			#if ($lines[$i] =~ /^$aliaseLists[$j]:/i) {
#			if ($lines[$i] =~ /^\Q$aliaseLists[$j]\E:/i) {
#				$err = "᡼󥰥ꥹ̾¾ǻѤ줿ꥢȽʣޤ"
#					 . "<BR>̤Υ᡼󥰥ꥹ̾ϿʤƤ";
#				goto done;
#			}
#		}
#	}
	
	
	# /etc/mail/aliases ɤ߹ࡣ
	if (!&readFile($WBMC_ALIASES, $WBMC_ALIACES_LOCKNAME, *lines)) {
		$err = "ե $WBMC_ALIASES ɤ߹ߤ˼Ԥޤ";
		goto done;
	}
	
	for ($j = 0; $j <= $#aliaseLists; $j++) {
		for ($i = 0; $i <= $#lines; $i++) {
			# "#WbMC Update" Ƚ񤫤줿Ԥ뤫å롣
			if ($lines[$i] =~ /^#WbMC Update\n$/) {
				$WbMC_flag = 1;
				next;
			}
			# ǽ餬# ʤ饳ȡʤιԤ³ʤΤǥåס
			if ($lines[$i] =~ /^[#\s]/) {
				next;
			}
			# ʲꥢ̾ϿѤߤȽ(ʸʸ̤ʤ)
			#010703 Nagashima
			#if ($lines[$i] =~ /^$aliaseLists[$j]:/i) {
			if ($lines[$i] =~ /^\Q$aliaseLists[$j]\E:/i) {
				$err = "᡼󥰥ꥹ̾¸ΥꥢȽʣޤ"
					 . "<BR>̤Υ᡼󥰥ꥹ̾ϿʤƤ";
				goto done;
			}
		}
	}
	
	# WbMC Ĥä顢 WbMC Update 򥻥åȤơʹߤ
	# WbMC ԽоݤȤ롣
	if (!$WbMC_flag) {
		push(@lines, "#WbMC Update\n");
	}
	
	# ᡼󥰥ꥹѥꥢɲá
	push(@lines, "#WbMC Mailing List -- $listname\@$domainname\n");
	push(@lines, "$aliaseLists[0]: :include:$WBMC_FMLSPOOLDIR/$domainname/$listname/include\n");
	push(@lines, "$aliaseLists[1]: :include:$WBMC_FMLSPOOLDIR/$domainname/$listname/include-ctl\n");
	push(@lines, "$aliaseLists[2]: $WBMC_ALIASEUSER\n");
	push(@lines, "$aliaseLists[3]: $WBMC_ALIASEUSER\n");
	push(@lines, "$aliaseLists[4]: $WBMC_ALIASEUSER\n");
	push(@lines, "$aliaseLists[5]: $WBMC_ALIASEUSER\n");
	
	# /etc/mail/aliases ؤν񤭹ߡ
	if (!&writeFile($WBMC_ALIASES, $WBMC_ALIACES_LOCKNAME, @lines)) {
		$err = "ե $WBMC_ALIASES ν񤭹ߤ˼Ԥޤ";
		goto done;
	}
	
	# /etc/mail/aliases ǡ١Ѵ
	if (system("/usr/bin/newaliases >/dev/null 2>&1") != 0){
		$err = "newaliasesޥɤǥ顼ȯޤ";
		# ɲäκȤߤʤ롣
		if ($err2 = &delListAliases($listname, $domainname)) {
			$err .= "<BR>";
			$err .= "fml ѥꥢκǤ⡢Υ顼ȯޤ<BR>";
			$err .= "---<BR>";
			$err .= $err2;
		}
		goto done;
	}
	
done:
	return($err);
}


# ̾
#	¥ɥᥤ̾롼̾
# 
#	getRealDomain(*domainname, *groupname)
# 
#	*domainname		ɥᥤ̾
#	*groupname		롼̾
# 
#	0	顼
#	1	OK
#
sub getRealDomain
{
	local(*domainname, *groupname) = @_;
	local(@lines) = ();
	my($tempdomain, $mydomain, $mygroup) = "";
	my($ret, $target) = 0;
	my($i);
	
	# ɥᥤեɤ߽Ф
	if (!&readFile("$WBMC_DOMAIN_DIR/domain.conf", "domain.conf", *lines)) {
		goto done;
	}
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<DOMAINNAME\s+([^\s]+)\s*>/i) {
			$tempdomain = $1;
			next;
		}
		if ($lines[$i] =~ /^\s*MODE\s+REAL\s*/i) {
			$mydomain = $tempdomain;
			last;
		}
	}
	
	if ($mydomain eq "") {
		goto done;
	}
	
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^\s*<DOMAINNAME\s+([^\s]+)\s*>/i) {
			if ($target == 1) {
				last;
			}
			elsif ($mydomain eq $1) {
				$target = 1;
			}
		}
		if ($target == 0) {
			next;
		}
		if ($lines[$i] =~ /^\s*GROUPNAME\s+([^\s]+)\s*/i) {
			$mygroup = $1;
			last;
		}
	}
	
	if ($mygroup eq "") {
		goto done;
	}
	
	$domainname = $mydomain;
	$groupname	= $mygroup;
	$ret		= 1;
	
done:
	return ($ret);
}


#--------------------------------------------------------------------
# Function
# 	᡼󥰥ꥹѥꥢμư
# Parameters
#	$listname	᡼󥰥ꥹ̾
#	$domainname	ɥᥤ̾
# Return
#  ""     
#  ""ʳ 顼å
#
sub delListAliases
{
	local($listname, $domainname) = @_;
	local(@lines, @aliaseLists, @delfile) = ();
	local($err, $realdomain, $groupname) ;
	my($i, $j, $continuation, $dir);
	$continuation = 0;
	$err = "";
	@aliaseLists = ("$listname",
					"$listname-ctl",
					"$listname-request",  
					"$listname-admin", 
					"owner-$listname",  
					"owner-$listname-ctl");
	
#  if( $TYPE eq "VIRTUAL" ){
#    foreach $i (@aliaseLists){
#      $i .= "_$DomainName";
#    }
#  }

        if (!&getRealDomain(*realdomain, *groupname)) {
                $err = "ɥᥤեɤ߹ߤ˼Ԥޤ";
                goto done;
        }

        if ($domainname ne $realdomain) {
                foreach $alias (@aliaseLists) {
                        $alias .= "_$domainname";
                }
        }

	# /etc/mail/aliases ɤ߹ࡣ
	if (!&readFile($WBMC_ALIASES, $WBMC_ALIACES_LOCKNAME, *lines)) {
		$err = "ե $WBMC_ALIASES ɤ߹ߤ˼Ԥޤ";
		goto done;
	}
	
	# оݤΥꥢ̾СιԤ
	# оݤΥꥢ̾ʤƤѤߤȽǤƵˤʤ
	for ($j = 0; $j <= $#aliaseLists; $j++) {
		for ($i = 0; $i <= $#lines; $i++) {
			#010703 Nagashima
			#if ($lines[$i] =~ /^#WbMC Mailing List\s*--\s*$listname\@$domainname\s*$/) {
			if ($lines[$i] =~ /^#WbMC Mailing List\s*--\s*\Q$listname\E\@\Q$domainname\E\s*$/) {
				splice(@lines, $i, 1);
				$i--;
				next;
			}
			if ($continuation) {
				# ƬʸǤʤСλʤΤǡҤȤʬ롼פȴ롣
				if ($lines[$i] !~ /^\s/) {
					$continuation = 0;
					last;
				}
				# Ƭʸä顢ιԤ1Ժ(ꥢ³ʸȸʤ)
				splice(@lines, $i, 1);
				$i--;
			}
			#010703 Nagashima
			#elsif ($lines[$i] =~ /^$aliaseLists[$j]:/i) {
			elsif ($lines[$i] =~ /^\Q$aliaseLists[$j]\E:/i) {
				splice(@lines, $i, 1);
				$i--;
				$continuation = 1;
			}
		}
	}
	
	# /etc/mail/aliases ؤν񤭹ߡ
	if (!&writeFile($WBMC_ALIASES, $WBMC_ALIACES_LOCKNAME, @lines)) {
		$err = "ե $WBMC_ALIASES ν񤭹ߤ˼Ԥޤ";
		goto done;
	}
	
	# /etc/mail/aliases ǡ١Ѵ
	if (system("/usr/bin/newaliases >/dev/null 2>&1") != 0){
		$err = "newaliasesޥɤǥ顼ȯޤ";
		goto done;
	}
	

done:
	return($err);
}


#--------------------------------------------------------------------
# Function
# 	᡼󥰥ꥹѥꥢμ
# Parameters
#	$aliaseList	get륨ꥢ̾
#	*aliaseMem	ꥢ̾б
# Return
#  ""     
#  ""ʳ 顼å
#
sub getListAliases
{
	local($aliaseList, *aliaseMem) = @_;
	local(@lines) = ();
	local($err) ;
	my($continuation, $i) ;
	
	$err = "";
	$continuation = 0;
	
	# /etc/mail/aliases ɤ߹ࡣ
	if (!&readFile($WBMC_ALIASES, $WBMC_ALIACES_LOCKNAME, *lines)) {
		$err = "ե $WBMC_ALIASES ɤ߹ߤ˼Ԥޤ";
		goto done;
	}
	
	for ($i = 0; $i <= $#lines; $i++) {
		if ($lines[$i] =~ /^#/) {
			next;
		}
		if ($continuation) {
			# ԤƬǤʤС롼פȴ롣
			if ($lines[$i] !~ /^\s/) {
				last;
			}
			$aliaseMem .= $lines[$i];
		}

#010511 ꤵ줿եƬTABޤǼʤ Nagashima
#		elsif ($lines[$i] =~ /^\Q$aliaseList\E\:(.+)$/) {
		elsif ($lines[$i] =~ /^\Q$aliaseList\E\:[\s\t](.+)$/) {
			$aliaseMem = $1;
			$continuation = 1;
		}
	}

	#2001/05/07 Nagashima
	#$aliaseMem =~ s/\s//g;
	#010511 ꤵ줿ޤޤɽΤǺ  Nagashima
	#$aliaseMem =~ s/,\s/,/g;
	
done:
	return($err);
}


#--------------------------------------------------------------------
# Function
# 	᡼󥰥ꥹѥꥢԽ(ݤҤȤĤ)
# Parameters
#	$listname	᡼󥰥ꥹ̾
#	$aliase		ꥢα
#	$aliaseMem	ꥢκ
# Return
#  ""     
#  ""ʳ 顼å
#
sub modListAliases
{
	local($listname, $aliase, $aliaseMem) = @_;
	local(@member, @lines) = ();
	local($err, $err2) ="";
	my($i, $new_aliase, $continuation);
	
	$err = "";
	$new_aliase = "$aliase:\t";
	$continuation = 0;
	
	# ͥå
	if ($aliaseMem =~ /^\s*$/) {
		$err = "$aliase ΥꥢФϤƲ";
		goto done;
	}
	# 顼å(ڤʸϲԤȥޤΤ) misa
#	@member = split(/[\s,]+/, $aliaseMem);
#010511	@member = split(/[\r\n,]+/, $aliaseMem);
	@member = split(/[\r\n]+/, $aliaseMem);
	for ($i = 0; $i <= $#member; $i++) {
        	# ꥢФζڤʸȶ̤ĤʤΤǡ
        	# ϥ顼
        	# ǽζȡǸζϥץ쥹 misa
        	$err = "$aliase Υꥢ $member[$i] Ǥ";
        	$member[$i] =~ s/^\s+//;
        	$member[$i] =~ s/\s+$//;
        	next      unless length($member[$i]);
	#010511        goto done if     $member[$i] =~ /\:/;
	#010511        goto done unless &checkMailAddr($member[$i]);
		#010703 Nagashima 010726 
	        #goto done if ($member[$i] =~ /^\s*\|.+/ || $member[$i] =~ /^\s*\"\s*\|.+/);
        	$err = "";
		
		if ($i != 0) {
			$new_aliase .= ", ";
		}
		$new_aliase .= "$member[$i]";
	}
	
	if (!&readFile($WBMC_ALIASES, $WBMC_ALIACES_LOCKNAME, *lines)) {
		$err = "ե $WBMC_ALIASES ɤ߹ߤ˼Ԥޤ";
		goto done;
	}
	
	# ꥢԽ
	for ($i = 0; $i <= $#lines; $i++) {
		if ($continuation) {
			if ($lines[$i] !~ /^\s/) {
				last;
			}
			splice(@lines, $i, 1);
			$i--;
		}
		elsif ($lines[$i] =~ /^\Q$aliase\E\:/) {
			splice(@lines, $i, 1, "$new_aliase\n");
			$continuation = 1;
		}
	}
	
	if (!$continuation) {
		push(@lines, "$new_aliase\n");
	}
	
	if (!&writeFile($WBMC_ALIASES, $WBMC_ALIACES_LOCKNAME, @lines)) {
		$err = "ե $WBMC_ALIASES ν񤭹ߤ˼Ԥޤ";
		goto done;
	}
	
	# /etc/mail/aliases ǡ١Ѵ
	if (system("/usr/bin/newaliases >/dev/null 2>&1") != 0){
		$err = "newaliasesޥɤǥ顼ȯޤ";
		# ɲäκȤߤʤ롣
		for ($i = 0; $i <= $#lines; $i++) {
			#010703 Nagashima
			#if ($lines[$i] =~ /^$aliase:/i) {
			if ($lines[$i] =~ /^\Q$aliase\E:/i) {
				splice(@lines, $i, 1);
				last;
			}
		}
		if (!&writeFile($WBMC_ALIASES, $WBMC_ALIACES_LOCKNAME, @lines)) {
			$err .= "<BR>ե $WBMC_ALIASES ν񤭹ߤˤ⼺Ԥޤ";
			$err .= "<BR>$WBMC_ALIASES ˤʤäƤǽޤ";
			goto done;
		}
		
		# ǸäϤʤΤǤǥ顼ϽФʤϤ
		# 礻󥨥顼ФƤΤǡʾθФϤʤ
		system("/usr/bin/newaliases >/dev/null 2>&1");
		goto done;
	}
	
done:
	return($err);
}


#--------------------------------------------------------------------
# Function
#	ꥹ̾Υ顼å
#   	ꥢˤ̾ϿΤǡ⤷ξΤ _ ϻԲġ
#   	ɥᥤѤΥꥢ롼̾ĤΤǡ롼פζڤ
#   	_ ȽǤƤ뤫顣
# Parameters
#	$listname	᡼󥰥ꥹ̾
# Return
#  ""     
#  ""ʳ 顼å
#
sub checkListName
{
	local($listname) = @_;
	local($err);
	my($len);
	
	$err = "";
	
	if (!defined($listname) || $listname eq "") {
		$err = "᡼󥰥ꥹ̾ϤƲ";
		goto done;
	}
	
	# Ƭѻ
	if ($listname =~ /^[^A-Za-z]/) {
		$err = "᡼󥰥ꥹ̾Ǥ";
		goto done;
	}
	# ѿϥե󡢥ԥꥪɤ
	if ($listname =~ /[^A-Za-z0-9\-\._]/) {
		$err = "᡼󥰥ꥹ̾Ǥ";
		goto done;
	}
	
	# ưϿ륨ꥢ̾Ǥϡowner-$listname-ctl ǤĹΤ
	# ȤꤢˤơʲĹȤ롣
	$len = length("owner-$listname-ctl");
	if(!&checkNum($len, 1, 32)) {
		$err = "᡼󥰥ꥹ̾Ǥ";
		goto done;
	}
	
done:
	
	return($err);
}


#--------------------------------------------------------------------
# Function
#	members/actives եԽ
#   ľԽСϿ/
# Parameters
#	$listname		᡼󥰥ꥹ̾
#	$domainname		ɥᥤ̾
#	$listmembers		membersե
# Return
#  ""     
#  ""ʳ 顼å
#
sub modListMem
{
	local($listname, $domainname, $listmembers) = @_;
	local(@lines, @mem) = ();
	local($err, $continue);
	my($i);
	
	$err = "";
	$continue = 0;
	
	# membersΥСåϰʲΤȤ
	# ɥ쥹	ץ	# 
	# Ƭ ##(դ) ϥȤƬ #(ҤȤĤ) ͭ
	@mem = split(/[\n]+/, $listmembers);
	for ($i = 0; $i <= $#mem; $i++) {
		# #.FML#.endFML ޤǤϡfmlĤ륳ȡ̵ɤФ
#		$mem[$i] =~ s/^\s*//;
		$mem[$i] =~ s/\s*\n*$//;

		if ($mem[$i] =~ /^#.FML/) {
			push(@lines, "$mem[$i]\n");
			$continue = 1;
			next;
		}
		if ($mem[$i] =~ /^#.endFML/) {
			push(@lines, "$mem[$i]\n");
			$continue = 0;
			next;
		}
		if ($continue) {
			push(@lines, "$mem[$i]\n");
			next;
		}

		# Ƭ ## ϥȡ# ͭ
		if ($mem[$i] =~ /^##/) {
			push(@lines, "$mem[$i]\n");
			next;
		}
		
		# ץʬ䡣
#		@opt = split(/[\s]+/, $mem[$i]);
#010511 Ρåˤ롣 Nagashima
#		@opt = split(/\@[\S]+[\s]+/, $mem[$i]);
#		if ($#opt > 0) {
#			$opt[0] =~ s/^#//;
#			if (!&checkMailAddr($opt[0])) {
#				return("᡼󥰥ꥹȥФʥ᡼륢ɥ쥹 $opt[0] ޤ");
#			}
#		}
#		if ($#opt > 1) {
#			if ($opt[2] !~ /^#/) {
#				return("᡼󥰥ꥹȥФΥեޥåȤǤ");
#			}
#		}
#    if(!&checkMailAddr($mem[$i]) && $mem[$i] =~ /\S+/ ){
#      return("᡼륢ɥ쥹<BR>$mem[$i]<BR>ΥեޥåȤǤ");
#    }
		# 010703 Nagashima 010726 
		#if ($mem[$i] =~ /^\s*\|.+/ || $mem[$i] =~ /^\s*\"\s*\|.+/){
		#	return("᡼󥰥ꥹȥФʥ᡼륢ɥ쥹ޤ");
		#}

		push(@lines, "$mem[$i]\n");
	}
	# եؽ񤭹ࡣ
	if ($err = &writeFmlFile($listname, "$WBMC_FMLSPOOLDIR/$domainname/$listname/members", @lines)) {
		goto done;
	}
	
	# activesضŪ˥ԡۥȤȤ򸫤ۤɻ֤ʤäơ
	# եؽ񤭹ࡣ
	if ($err = &writeFmlFile($listname, "$WBMC_FMLSPOOLDIR/$domainname/$listname/actives", @lines)) {
		goto done;
	}
	
done:
	return($err);
}


#--------------------------------------------------------------------
#
# Function
#	ɥᥤΥ᡼󥰥ꥹ̾
#	ML ϡʲǥ쥯ȥ
#	.  @ ǻϤޤǥ쥯ȥꡢ
#	config.ph ¸ߤʤǥ쥯ȥꡢ
#	etc
# Parameters
#	$domainname	ɥᥤ̾(FQDN)	
# Return
#	@listname	᡼󥰥ꥹȰ
#
sub getListName
{
#	local(*all_lists) = @_;
	my(@all_lists) = ();
	my($domainname) = @_;
	opendir(DIR_FML, "$WBMC_FMLSPOOLDIR/$domainname");
	for $dir (readdir(DIR_FML)) {
		next if $dir =~ /^\./;
		next if $dir =~ /^\@/;
		next unless -f "$WBMC_FMLSPOOLDIR/$domainname/$dir/config.ph";
		next if $dir eq 'etc';
		
		push(@all_lists, $dir);
	}
	closedir(DIR_FML);
	
	return(@all_lists);
}

#--------------------------------------------------------------------
# checkMailAddr() ȤΤǡϺ
# 
# Function
#  Ϳ줿ʸ󤬥᡼륢ɥ쥹ɤȽ
# Parameters
#  $add Ƚоʸ
# Return
#  1 ᡼륢ɥ쥹Ǥ
#  0 ᡼륢ɥ쥹ǤϤʤ
#
#sub isMailaddrCheck
#{
#  return(1) if( $_[0] =~ /@/ && checkUserName($`) && checkDomainName($'));
#  return(0);
#}

#
# 2001.02 add
#

#
# ̾
#   getAllDomainName - domain.conf ¥ɥᥤ̾Ȳۥɥᥤ̾ΥꥹȤ
# 
#   getAllDomainName()
# 
#   ʤ
# 
#    - ɥᥤ̾Υꥹ
#    - ""
#
sub getAllDomainName
{
    my(@domainnames)=();
    local(@conf)=();

    if (!&readFile($domain_conf, $domain_conf_lock, *conf)) {
        return("");
    }
    foreach(@conf){
        push(@domainnames,$1) if( /^\s*<DOMAINNAME\s*(\S*)\s*>/ );
        # 饹ξϡ¥ɥᥤ
        if(&cluster_typechk() && (/^\s*MODE\s+REAL\s*$/)) {
        	pop(@domainnames);
		}
    }

    return(@domainnames);
}


#
# ̾
#   lockDomainFml - fml Υɥᥤñ̤Υå
# 
#   lockDomainFml($domainname,$mode,*lockf)
# 
#   $domainname - ɥᥤ̾
#   $mode       - å⡼
#   *lockf      - åե̾
# 
#    - ""
#    - 顼å
#
sub lockDomainFml
{
  local($domainname,$mode,*lockf)=@_;
  my($listname);
  my($err)="";
  my($list_d,$list_ML);

  @listname=&getAllList();
  foreach (@listname){
    ($list_d,$list_ML)=&sepDomainML($_);
    if( $list_d eq "$domainname" ){
      $err = lockFml($_, $domainname, $mode, *lockf);
      return($err) if( $err ne "" );
    }
  }
  return("");
}

#
# ̾
#   unlockDomainFml - fml Υɥᥤñ̤Υå
# 
#   unlockDomainFml($lockf)
# 
#   $lockf - åե̾
# 
#   ʤ
#
sub unlockDomainFml
{
  local($lockf)=@_;
#  my($listname);
#  my($err)="";
#  my($list_d,$list_ML);

#  @listname=&getAllList();
#  foreach (@listname){
#    ($list_d,$list_ML)=&sepDomainML($_);
#    if( $list_d eq "$domainname" ){
#      $err = unlockFml($_, $domainname, $mode, *lockf);
	close($lockf);
#      return($err) if( $err ne "" );
#    }
#  }
#  return("");
	return();
}


#
# ̾
#   getAllList - ¥ɥᥤȲۥɥᥤ fml ᡼󥰥ꥹ̾
# 
#   getAllList()
# 
#   ʤ
# 
#   ꥹ̾ "ɥᥤ̾/ML̾" η
#
sub getAllList
{
    my(@all_lists)=();
    my(@domains)=&getAllDomainName();
    my($domain,$spooldir,$dir);

    foreach $domain (@domains){
        $spooldir="$WBMC_FMLSPOOLDIR/$domain";
        opendir(DIR_FML, $spooldir);
        foreach $dir (readdir(DIR_FML)) {
            next if $dir =~ /^\./;
            next if $dir =~ /^\@/;
            next unless -f "$spooldir/$dir/config.ph";
            next if $dir eq 'etc';
            push(@all_lists, "$domain/$dir");
        }
        closedir(DIR_FML);
    }
    return(@all_lists);
}

#
# ̾
#   sepDomainML - ɥᥤ̾ȽML̾ʬ
# 
#   sepDomainML(mlname)
# 
#   mlname "<ML̾>/<ۥɥᥤ̾>"  ML̾
# 
#   (ɥᥤ̾,ML̾) Υꥹ
#   "/<ۥɥᥤ̾>" ʤ硢ɥᥤ̾ϼ¥ɥᥤ̾ˤʤ
#
sub sepDomainML
{
    my($mlname)=$_[0];
    my($domain,$purename);

    if( $mlname =~ /(.+)\/(.+)/ ){
        $domain=$1;
        $purename=$2;
    }
    return ($domain,$purename);
}

#--------------------------------------------------------------------
# Function
#	MLե̾
# Usage
#	getListLogFile($listname, $domainname, *filelist);
# Parameters
#	$listname	ML̾
#	$domainname	ɥᥤ̾
#	*filelist	եΥꥹ(եѥ)
# Return
#	顼å(ʤ"")  顼ˤϤʤʤ
#
sub getListLogFile
{
	local($listname, $domainname, *filelist) = @_;
	
	my($ret, $file, @files);

	# о
	my($logdir) = "$WBMC_FMLSPOOLDIR/$domainname/$listname";
	my($rotatedir) = "$logdir/var/log";
	
	# ȥ(̵Ƥⵤˤʤ)
	if (-f "$logdir/log") {
		push(@filelist, "$logdir/log");
	}

	# ơȥ(̵Ƥⵤˤʤ)
	opendir(LOGDIR, "$rotatedir");
	@files = readdir(LOGDIR);
	close(LOGDIR);
	foreach $file (sort @files) {
		if($file =~ /^log\.\d+$/) { push(@filelist, "$rotatedir/$file"); }
	}

	return ($ret);
}

#--------------------------------------------------------------------
# Function
#	cf ͤ
# Usage
#	$value = getCfValue($listname, $domainname, $param);
# Parameters
#	$listname	ML̾
#	$domainname	ɥᥤ̾
#	$param		ѥ᡼()
# Return
#	ѥ᡼() (ѿ¸ߤʤƤⵤˤʤ)
#
sub getCfValue
{
	my($listname, $domainname, $param) = @_;
	my($cf, $ret);
	local(@lines);

	$cf = "$WBMC_FMLSPOOLDIR/$domainname/$listname/cf";

	if (!&readFile($cf, "cf", *lines)) {
		return "";
	}
	foreach $line (@lines) {
		if($line =~ /^\s*\Q$param\E\s+(\S+)\s*$/i) {
			$ret = $1;
			last;
		}
	}
	return ($ret);
}


#--------------------------------------------------------------------
# Function
#       /home/fml/$domainname/etc/qmail/alias ۲ץե
# Usage
#       $value = delQmail($listname, $domainname);
# Parameters
#       $listname       ᡼󥰥ꥹ̾
#       $domainname     ɥᥤ̾
# Return
#       ʤ
#
sub delQmail
{
        my($listname, $domainname) = @_;
        my($del, $dir);
        my(@delfile);

	$domainname =~ s/\s//g;
	$listname =~ s/\s//g;
	if(!$domainname || !$listname){
		return();
	}

        # /home/fml/$domainname/etc/qmail/alias ۲ץե
        $dir = "/home/fml/$domainname/etc/qmail/alias";
        @delfile = ("$dir/.qmail-$listname","$dir/.qmail-$listname-ctl","$dir/.qmail-$listname-request","$dir/.qmail-owner-$listname-ctl","$dir/.qmail-$listname-admin","$dir/.qmail-$listname-default","$dir/.qmail-owner-$listname");
        for($del=0;$del<@delfile;$del++){
                system("/bin/rm -f $delfile[$del]");
        }
	return();
}


#--------------------------------------------------------------------
# Function
#       /home/fml/$domainname/$listname/members-adminϿ
#       /home/fml/$domainname/$listname/etc/passwdϿ
# Usage
#       $value = addadmcmduser($listname, $domainname, $admcmduser, $passwd);
# Parameters
#       $listname
#       $domainname
#       $admcmduser
#       $passwd
# Return
#       $msg
#
sub addadmcmduser
{
        local($listname, $domainname, $admcmduser, $passwd)   = @_;
        local($err, $stderrmsg);
        local(@lines);

        $MAKEFML .= " -f $WBMC_FMLSPOOLDIR/$domainname/.fml/system";
        $err    = "";
	# åѿ .  _  -  @ ʳϥ
	if ($admcmduser =~ /[^\w\.\-@]/) {
		$err = "ѵļԥɥ쥹Ǥ";
		goto done;
	}
	# passwordå '  ڡϥ
	if ($passwd =~ /['\s]/) {
		$err = "ѥɤǤ";
		goto done;
	}
        # members-admin
	if (! -e "$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin") {
		if (! open(FILE1, "su -c \"/bin/touch $WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin \" $WBMC_FMLUSER 2>&1 |")) {
                	$err = "᡼󥰥ꥹԽ(members-admin)ǥ顼ȯޤ";
                	while (<FILE1>) {
                               	$err .= "<BR>$_";
                	}
                	close (FILE1);
                	goto done;
        	}
        	close (FILE1);
	}
        # ԥޥɻѵļԤɲä롣
        if (open(MKFML, "su -c \"/usr/bin/perl $MAKEFML passwd $listname \'$admcmduser\' \'$passwd\' \'$passwd\' \" $WBMC_FMLUSER 2>&1 |")) {
                # makefml ۾ｪλϡ*** Error: xxxxxxxxxxxxxxx *** ȽФ롣
                while (<MKFML>) {
                        $stderrmsg = <MKFML>;
                        if ($stderrmsg =~ /Error/i) {
                		$err = "᡼󥰥ꥹԽ(makefml)ǥ顼ȯޤ";
                               	$err .= "<BR>$stderrmsg";
                        }
                }
                close (MKFML);
		if ($err ne "") {
                	goto done;
		}
        }
        close (MKFML);
        # members-admin˽񤭹ࡣ
	if (!&readFile("$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin", $MEMBERS_ADMIN_LOCKNAME, *lines)) {
		$err = "$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin ɤ߹ߤ˼Ԥޤ";
		return($err);
	}
	$exist_flg = 0;
	# ̾ʣå
	foreach (@lines) {
		$file_line = $_;
		$file_line =~ s/\s*$//;
        	if ($file_line =~ /^#/) {
        		next;
        	}
		if ($file_line eq $admcmduser) {
			$exist_flg = 1;
		}
	}
	if ($exist_flg == 0) {
		push(@lines, "$admcmduser\n");
	}
	$err = &writeFmlFile("$listname", "$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin", @lines);
	done:
        return($err);
}

#--------------------------------------------------------------------
# Function
#       /home/fml/$domainname/$listname/members-adminϿ
#       /home/fml/$domainname/$listname/etc/passwdϿ
# Usage
#       $value = addadmcmduser($listname, $domainname, $admcmduser, $passwd);
# Parameters
#       $listname
#       $domainname
#       $admcmduser
#       $passwd
# Return
#       $msg
#
sub deladmcmduser
{
        local($listname, $domainname, $admcmduser)   = @_;
        local($err);
        local(@lines);
        local(@ent);
        $err    = "";

        # members-admin롣
	if (!&readFile("$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin", $MEMBERS_ADMIN_LOCKNAME, *lines)) {
		$err = "$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin ɤ߹ߤ˼Ԥޤ";
		return($err);
	}
        for ($i = 0; $i <= $#lines; $i++) {
                $file_line = $lines[$i];
                $file_line =~ s/\s*$//;
                if ($file_line =~ /^#/) {
                        next;
                }
		if ($file_line eq $admcmduser) {
                        splice(@lines, $i, 1);
                        $i--;
                }
        }
        # members-admin˽񤭹ࡣ
	$err = &writeFmlFile("$listname", "$WBMC_FMLSPOOLDIR/$domainname/$listname/members-admin", @lines);
	if ($err ne "") {
		return($err);
	}
        # etc/passwd롣
	if (!&readFile("$WBMC_FMLSPOOLDIR/$domainname/$listname/etc/passwd", $$MEMBERS_ADMIN_ETC_PASSWD_LOCKNAME, *lines)) {
		$err = "$WBMC_FMLSPOOLDIR/$domainname/$listname/etc/passwd ɤ߹ߤ˼Ԥޤ";
		return($err);
	}
        for ($i = 0; $i <= $#lines; $i++) {
                $file_line = $lines[$i];
    		@ent = split(/\s/, "$file_line");
                if ($ent[0] =~ /^#/) {
                        next;
                }
		if ($ent[0] eq $admcmduser) {
                        splice(@lines, $i, 1);
                        $i--;
                }
        }
        # etc/passwd˽񤭹ࡣ
	$err = &writeFmlFile("$listname", "$WBMC_FMLSPOOLDIR/$domainname/$listname/etc/passwd", @lines);

        return($err);
}

1;
