#!/usr/bin/perl

#----------------------------------------------------------------------------
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "named.pl";
require "namedapi.pl";
#------------------------------------------------------------
if ($err = &readParam()) {
	$err = $STR_ERR_SYSTEM;
	&showErrorPage("$err", "");
	exit(1);
}

$zname = $FORM{'ZONE_NAME'};
$zfile = $FORM{'ZONE_FILE'};
$zline = $FORM{'ZONE_LINE'};
$n = 0;
$lastowner = "";
$data = "";

open(ZONEFILE,"/var/named/$zfile");
while(<ZONEFILE>){
    $n++;
    if(/^(\S+)\s+.*IN\s+(\S+)\s+(.*)$/){
        if($2 ne "SOA"){
            $lastowner = $1;
        }
    }
    if ($zline == $n){
	if($lastowner ne ""){
	    $n++;
	    $nextline = <ZONEFILE>;
	    if($nextline =~ /^\s+(.*)$/){
		$entity = $1;
		if($entity =~ /^(\d+)\s+IN\s+(.*)$/){
		    $ttl = $1;
		    $entity = $2;
		} else{
		    $entity =~ /^IN\s+(.*)$/;
		    $entity = $1;
		    $ttl = "";
		}
		$tablist = "";
		$tabs = 1 - length($lastowner) / 8;
		for($l = 0; $l < $tabs; $l++){
		    $tablist .= "\t";
		}
		$data .= $lastowner . "\t" . $ttl . $tablist . "\t" . "IN" . "\t" . $entity . "\n";
	    } else{
		$data .= $nextline;
	    }
	}
	next;
    }
    $data .= $_;
}
close(ZONEFILE);

open(ZONEFILE, ">/var/named/$zfile");
print(ZONEFILE $data);
close(ZONEFILE);

#system("/opt/nec/wbmc/adm/service/dns/named.cgi");
if (&checkPid("named")) {
    if ($err = restartService("named")) {
	&showErrorPage("$err", "named.cgi");
	exit(1);
    }
}

&showResultPage("","editzone.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");

