#!/usr/bin/perl

#----------------------------------------------------------------------------
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

##011212 v4.3 DNSSOAԽǴԺĹб hirano

#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "named.pl";
require "namedapi.pl";
#------------------------------------------------------------

if ($err = &readParam()) {
	$err = $STR_ERR_SYSTEM;
	&showErrorPage("$err", "");
	exit(1);
}

$zname = $FORM{'ZONE_NAME'};
$zfile = $FORM{'ZONE_FILE'};
$zline = $FORM{'ZONE_LINE'};

for($i = 0; $i < 1; $i++){
  $owner[$i] = $FORM{"LEFT$i"};
  $record[$i] = $FORM{"SELECT$i"};
  $value[$i] = $FORM{"RIGHT$i"};
  $mx[$i] = $FORM{"MX$i"};

  $value[$i] =~ s/\s+$//;
  $value[$i] =~ s/^\s+//;
  $owner[$i] =~ s/\s+$//;
  $owner[$i] =~ s/^\s+//;
}


# check parameters
$bErr = 0;
$noitems = 0;
for($i = 0; $i < 1; $i++){
    if($value[$i] eq ""){
         &showErrorPage("ͤϤƤޤ", "modrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_LINE=$zline");
         exit(1);
    }

# records: A, PTR, CNAME, NS, MX, HINFO, TXT, WKS
    if($record[$i] eq "A"){
        if(ipAddrCheck($value[$i]) == 0){
             &showErrorPage("Ϥ줿ɥ쥹Ǥ", "modrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_LINE=$zline");
	     exit(1);
        }
    } elsif(($record[$i] eq "PTR") || ($record[$i] eq "CNAME")
	    || ($record[$i] eq "NS")){
	if($value[$i] !~ /^(.+)\.$/){
		$checkname = join(".", $value[$i], $zname);
	}else{
		$checkname = $1;
	}

        if(&checkDomainName2($checkname) == 0){
             &showErrorPage("Ϥ줿ɥᥤ̾Ǥ", "modrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_LINE=$zline");
             exit(1);
        }
    } elsif($record[$i] eq "MX"){
	if($value[$i] !~ /^(.+)\.$/){
		$checkname = join(".", $value[$i], $zname);
	}else{
		$checkname = $1;
	}

        if(&checkDomainName2($checkname) == 0){
             &showErrorPage("Ϥ줿ɥᥤ̾Ǥ", "modrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_LINE=$zline");
             exit(1);
        }
        if($mx[$i] eq ""){
             &showErrorPage("ͥ٤ϤƤޤ", "modrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_LINE=$zline");
             exit(1);
        }
        if(($mx[$i] =~ /[^0-9]/) || ($mx[$i] > 32767)){
             &showErrorPage("ͥ٤032767ͤꤷƤ", "modrecord.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile&ZONE_LINE=$zline");
             exit(1);
        }
    }

    if($record[$i] ne "MX"){
        $mx[$i] = "";
    } else{
        $mx[$i] .= "\t";
    }

}


$lastowner = "";

open(ZONEFILE,"/var/named/$zfile");
while(<ZONEFILE>){
    $n++;

    $tty = "";
    if(/^(\S+)\s+(.*)IN\s+(\S+)\s+(.*)$/){
	if($3 ne "SOA"){
            $lastowner = $1;
	    $thislineowner = $1;
	    $tty = $2;
        }
    } elsif(/^\s+(.*?)IN/){
	$thislineowner = "";
	$tty = $1;
    }
    $tty =~ s/\s//g;

    # find new line
    if ($zline == $n){

#        &showErrorPage("$lastowner, $thislineowner, $tty", "");

        # generate new line
	$newline = $owner[0] . "\t" . $tty;
	# owner omit and not changed case
	if(($lastowner eq $owner[0]) && ($thislineowner eq "")){
	    $newline = "\t" . $tty;
	}
	$tabs = 1 - (length($owner[0])) / 8;
	for($l = 0; $l < $tabs; $l++){
	    $newline .= "\t";
	}
	$newline .= "\tIN\t$record[0]\t$mx[0]$value[0]\n";
	$data .= $newline;

	# check if owner changed.
	# -> if next line owner omitted, insert owner
	if($lastowner ne $owner[0]){
	    if($nextline = <ZONEFILE>){
		if($nextline =~ /^\s+(.*)IN\s+(.*)$/){
		    $tty = $1;
		    $entity = $2;
		    $tty =~ s/\s//g;
		    
		    $newline = $lastowner . "\t" . $tty;
		    $tabs = 1 - length($lastowner) / 8;
		    for($l = 0; $l < $tabs; $l++){
			$newline .= "\t";
		    }
		    $newline .= "\t" . "IN" . "\t" . $entity;
		    $data .= $newline . "\n";
		    next;
		} else{
		    $data .= $nextline;
		}
	    }
	}
	next;
    }
    $data .= $_;
}
close(ZONEFILE);

open(ZONEFILE, ">/var/named/$zfile");
print(ZONEFILE $data);
close(ZONEFILE);

#system("/opt/nec/wbmc/adm/service/dns/named.cgi");
if (&checkPid("named")) {
    if ($err = restartService("named")) {
	&showErrorPage("$err", "named.cgi");
	exit(1);
    }
}

&showResultPage("","editzone.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
