#!/usr/bin/perl

#----------------------------------------------------------------------------
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

##011212 v4.3 DNSSOAԽǴԺĹб hirano

#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "named.pl";
require "namedapi.pl";
#------------------------------------------------------------

if ($err = &readParam()) {
	$err = $STR_ERR_SYSTEM;
	&showErrorPage("$err", "named.cgi");
	exit(1);
}

@fieldname = ( "", "ꥢֹ", "եå", "ȥ饤",
	       "ͭ", "ǾTTL" );

$zname = $FORM{'ZONE_NAME'};
$zfile = $FORM{'ZONE_FILE'};
$host = $FORM{'hostname'};
$mail = $FORM{'mail'};
$soa[1] = $FORM{'soa1'};
$soa[2] = $FORM{'soa2'};
$soa[3] = $FORM{'soa3'};
$soa[4] = $FORM{'soa4'};
$soa[5] = $FORM{'soa5'};


# check paramaters range
#if(&checkDomainName2($mail) == 0){

	if($mail !~ /^(.+)\.$/){
		$checkmail = join(".", $mail, $zname);
	}else{
		$checkmail = $1;
	}

if(&checkMailName($checkmail) == 0){
    &showErrorPage("ԤͤǤ", "soaedit.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
    exit(1);
}

$bErr = 0;
for($i = 1; $i <= 5; $i++){
    $soa[$i] =~ s/\s//g;
    if($soa[$i] eq ""){
	$bErr = 1;
	&showErrorPage("$fieldname[$i]ͤϤƤޤ",
		   "soaedit.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
	exit(1);
    }
    if($soa[$i] =~ /[^0-9]/){
	if(($i == 1) || ($soa[$i] !~ /^\d+[\dwdhms]$/i)){
	    $bErr = 1;
	}
    } else{
	if($soa[$i] > 4294967295){
	    $bErr = 1;
	}
    }
    if($bErr == 1){
	&showErrorPage("$fieldname[$i]ͤǤ",
		   "soaedit.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
	exit(1);
    }
}


$newline = "IN\tSOA\t" . $host . "\t" . $mail . " (\n\t\t\t" . $soa[1] . "\n\t\t\t" . $soa[2] . "\n\t\t\t" . $soa[3]. "\n\t\t\t" . $soa[4] . "\n\t\t\t" . $soa[5] . "\n)\n";

$insert = 0;
open(ZONEFILE,"/var/named/$zfile");
while(<ZONEFILE>){
    # comment out
    if((/^(.*?)\;/) || (/^(.*?)\/\//)){
        $chk = $1;
    } else{
	$chk = $_;
    }
    # find SOA record
    if($chk =~ /^(.*\s+)IN\s+SOA\s+/){
	$owner = $1;
	while(<ZONEFILE>){
	    if((/^(.*?)\;/) || (/^(.*?)\/\//)){
		$chk = $1;
	    } else{
		$chk = $_;
	    }
	    if($chk =~ /\)/){
		$data .= $owner . $newline;
		$insert = 1;
		last;
	    }
	}
	next;
    }
    $data .= $_;
}
close(ZONEFILE);

if($insert == 0){
    chomp($host =`hostname`);
    $newline = "IN\tSOA\t" . $host . ".\t" . $mail . " (\n\t\t\t" . $soa[1] . "\n\t\t\t" . $soa[2] . "\n\t\t\t" . $soa[3]. "\n\t\t\t" . $soa[4] . "\n\t\t\t" . $soa[5] . "\n)\n";
    $data = "@  " . $newline . $data;

}

#### ($data1,$data2) = $data =~ /^(\@\s+IN\s+SOA\s+.*?\s+.*?\s*\n*\(.*?\n*\d+.*?\n*\d+.*?\n*\d+.*?\n*\d+.*?\n*\d+.*?\n*\)\s*\n)(.*)/s;

## ($data1,$data2) = $data =~ /([^\n].*)\s+IN\s+SOA\s+\S+\s+\S+\s*\(\s*\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+\)\s*\n(.*)/s;

## $data = "$data1\tIN\tSOA\t".$host." ".$mail."\n(\n\t\t\t".$soa[1]."\n"."\t\t\t".$soa[2]."\n"."\t\t\t".$soa[3]."\n"."\t\t\t".$soa[4]."\n"."\t\t\t".$soa[5]."\n)\n".$data2;


open(ZONEFILE,">/var/named/$zfile");
print(ZONEFILE $data);
close(ZONEFILE);

if (&checkPid("named")) {
    if ($err = restartService("named")) {
	&showErrorPage("$err", "named.cgi");
        exit(1);
    }
}

&showResultPage("","editzone.cgi?ZONE_NAME=$zname&ZONE_FILE=$zfile");
