#!/usr/bin/perl
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# 021012 v5.0  oyama

sub sanitize {
	my $input = $_[0];
	$input =~ s/&/&amp;/g;         # &  &amp;
	$input =~ s/</&lt;/g;          # <  &lt;
	$input =~ s/>/&gt;/g;          # >  &gt;
	$input =~ s/"/&quot;/g;        # "  &quot;
	$input =~ s/'/&#39;/g;         # '  &#39;
	return $input;
}

require "../../../lib/wbmc.pl";
require "./ldap.pl";
use Jcode;
use MIME::Base64;

$navibar = &getNavigation(
"ӥ", "../menu.cgi",
"ɥ쥹Ģ(ldap)", "index.cgi",
"Խ", "",
"_back", "index.cgi",
"_help", "modify_help.html");

# եɤ߹
$suffix = &get_conf("suffix");
$rootdn = &get_conf("rootdn");
$rootpw = &get_conf("rootpw");

$id = $ARGV[0];
$ldap_uid = "cn=$id,$suffix";

# ldap_uid 򸵤˥桼򸡺
if (&check_id_exist($ldap_uid)) {
	&showErrorPage("Խоݤ¸ߤޤ");
	exit;
}
%record = ();
%record = &get_record($ldap_uid);

foreach $i (@item){
	$record{$i} = sanitize($record{$i});
}

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>ɥ쥹Խ</TITLE>
</HEAD>
<BODY>
<H4 ALIGN="center">ɥ쥹Խ</H4>
<HR>
$navibar
<HR>
<CENTER>
 <FORM METHOD="POST" ACTION="modify_submit.cgi?$id">
 <TABLE BORDER=1 BGCOLOR="#CCCCCC" CELLSPACING=0 CELLPADDING=1 WIDTH="450">
  <TR BGCOLOR="#000080">
   <TD COLSPAN=2><FONT COLOR="#FFFFFF"> <B>ɥ쥹Խ</B></FONT></TD>
  </TR>
  <TR>
  <TH>
  <TABLE>
<TD>̾</TD>
   <TD><INPUT TYPE="text" SIZE=40 NAME="NAME" VALUE="$record{'cn'}"></TD>
  </TR>
  <TR>
<TD>᡼륢ɥ쥹</TD>
   <TD><INPUT TYPE="text" SIZE=40 NAME="MAIL" VALUE="$record{'mail'}"></TD>
  </TR>
  <TR>
<TD>̾</TD>
   <TD><INPUT TYPE="text" SIZE=40 NAME="COMPANY" VALUE="$record{'o'}"></TD>
  </TR>
  <TR>
<TD>ȿ̾</TD>
   <TD><INPUT TYPE="text" SIZE=40 NAME="OU" VALUE="$record{'ou'}"></TD>
  </TR>
  <TR>
<TD>򿦡</TD>
   <TD><INPUT TYPE="text" SIZE=40 NAME="TITLE" VALUE="$record{'title'}"></TD>
  </TR>
  <TR>
<TD>ֹ桧</TD>
   <TD><INPUT TYPE="text" SIZE=40 NAME="TELEPHONE" VALUE="$record{'telephoneNumber'}"></TD>
  </TR>
  <TR>
  <TH COLSPAN=2><INPUT TYPE="submit" VALUE=""></TH>
  </TR>
  </TABLE>
  </TH>
  </TR>
 </TABLE>
</FORM>
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------
