#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: init2.cgi,v 1.2 2002/10/18 12:23:47 snavi Exp $
# 000728 v4.1 requireν (oku)

require "../../../lib/wbmc.pl";
require join ("/",$WBMC_ADM_DIR,"service/62smbd/samba.pl");

$smb_file = "/etc/samba/smb.conf";
$smb_lock = "smb.conf";

$global_flag = 0;
$global_line = 0;
$encrypt_find = 0;
$smbpasswd_find = 0;
$deadtime_find = 0;
$write_flag = 0;

$global_find = 0;

# smb.conf ɤ߹
if (!&readFileS2E($smb_file, $smb_lock, *file)) {
  &showErrorPage("$smb_file ɤ߹ߤ˼Ԥޤ");
  exit(1);
}

for ($i = 0; $i < @file; $i++) {
  if ($file[$i] =~ /^\s*#/) {
    next;
  }
  if ($file[$i] =~ /^\s*;/) {
    next;
  }

  if ($global_flag == 1 && $file[$i] =~ /^\s*\[/) {
    $global_flag = 0;
  }
  if ($file[$i] =~ /^\s*\[global\]\s*$/i) {
    $global_flag = 1;
    $global_find = 1;
    $global_line = $i;
    next;
  }

  # encrypt password : exist
  if ($global_flag == 1 && 
      $file[$i] =~ /^\s*encrypt\s+passwords\s*=\s*yes\s*$/i) {
    $encrypt_find = 1;
  }
  # encrypt password = no -> yes ѹ
  if ($global_flag == 1 && 
      $file[$i] =~ /^\s*encrypt\s+passwords\s*=/i) {
    $file[$i] = "\tencrypt passwords = yes\n";
    $encrypt_find = 1;
    $write_flag = 1;
  }

  # smb passwd file : exist
  if ($global_flag == 1 &&
      $file[$i] =~ /^\s*smb\s+passwd\s+file\s*=\s*\/etc\/smbpasswd\s*$/i) {
    $smbpasswd_find = 1;
  }
  # smb passwd file = /etc/smbpasswd ѹ
  if ($global_flag == 1 && $smbpasswd_find != 1 &&
      $file[$i] =~ /^\s*smb\s+passwd\s+file\s*=\s*/i) {
    $file[$i] = "\tsmb passwd file = /etc/smbpasswd\n";
    $smbpasswd_find = 1;
    $write_flag = 1;
  }

  # deadtime = : exist
  if ($global_flag == 1 && 
      $file[$i] =~ /^\s*deadtime\s*=\s*([^\s]+)/i) {
    $deadtime_find = 1;
    if (&parseUint($1) < 0) {
      $file[$i] = "\tdeadtime = 5\n";
      $write_flag = 1;
    }
  }
}

if (!$global_find) {
  splice(@file,$global_line,0,"[global]\n");
  splice(@file,$global_line+1,0,"\tencrypt passwords = yes\n");
  splice(@file,$global_line+1,0,"\tsmb passwd file = /etc/smbpasswd\n");
  splice(@file,$global_line+1,0,"\tdeadtime = 5\n");
  $encrypt_find = 1;
  $smbpasswd_find = 1;
  $deadtime_find = 1;
  $write_flag = 1;
}

# encrypt password ɲ
if ($encrypt_find == 0) {
  splice(@file,$global_line+1,0,"\tencrypt passwords = yes\n");
  $write_flag = 1;
}

# smb passwd file ɲ
if ($smbpasswd_find == 0) {
  splice(@file,$global_line+1,0,"\tsmb passwd file = /etc/smbpasswd\n");
  $write_flag = 1;
}

# deadtime ɲ
if ($deadtime_find == 0) {
  splice(@file,$global_line+1,0,"\tdeadtime = 5\n");
  $write_flag = 1;
}

# ե񤭹
if ($write_flag == 1) {
  if (!writeFileE2S($smb_file, $smb_lock, @file)) {
    &showErrorPage("$smb_file ν񤭹ߤ˼Ԥޤ");
    exit(1);
  }
}


#ư
if (&isServiceRunning("")) {
  system("/etc/rc.d/init.d/smb stop");
  system("/etc/rc.d/init.d/smb start");
} else {
  system("/etc/rc.d/init.d/smb start");
} 

&showPage("./../menu.cgi");
#-------------------------------------------------------------------------
