#!/usr/bin/perl
# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: share_submit.cgi,v 1.2 2002/10/18 12:23:47 snavi Exp $
# 000728 v4.1 requireν (oku)

require "../../../lib/wbmc.pl";
require join ("/",$WBMC_ADM_DIR,"service/62smbd/samba.pl");

$cfile = "/etc/samba/smb.conf";

$tmp_flag = 0;
$available_flag = 0;
$path_flag = 0;
$comment_flag = 0;
$writeable_flag = 0;
$browseable_flag = 0;
$available_string = "";
$writeable_string = "";
$browseable_string = "";
$dir_string = "";

$share = $ARGV[0];
$share =~ s/\\(.)/$1/g;
$share =~ s/^\s+//;
$share =~ s/\s+$//;

&readParam();

#եफ
$available = $FORM{'AVAILABLE'};
$dir = $FORM{'DIR'};
$comment = $FORM{'COMMENT'};
$writeable = $FORM{'WRITEABLE'};
$browseable = $FORM{'BROWSEABLE'};
$guest = $FORM{'GUEST'};

$comment_len = length($comment);

# ǥ쥯ȥ꤬ϤƤ뤫å 
if (($dir =~ /^\s*$/) && ($share ne "homes") && ($share ne "printers")) {
  &showErrorPage("ǥ쥯ȥ꤬ϤƤޤ ");
  exit(1);
}
if (($dir !~ /^\s*\//) && ($share ne "homes") && ($share ne "printers")) {
        &showErrorPage("ǥ쥯ȥηޤ");
        exit(1);
}
if ($comment_len > 255) {
  &showErrorPage("Ȥ255ʸǻꤷƲ");
  exit(1);
}

# եեɤ߹
if (!&readFileS2E("$cfile","smb.conf",*conf)) {
        &showErrorPage("$cfile Υץ˼Ԥޤ");
        exit(1);
}

$browseable_org = "";
@orgconf = @conf;

if ($available eq "on") {
  $available_string = "";
} else {
  $available_string = "ʤ";
}
if ($writeable eq "on") {
  $writeable_string = "Ĥ";
} else {
  $writeable_string = "Ĥʤ";
}
if ($browseable eq "on") {
  $browseable_string = "ɽ";
} else {
  $browseable_string = "ɽʤ";
}

for ($i = 0; $i < @conf; $i++) {
        $conf[$i] =~ s/\s*$//;
  $conf[$i] =~ s/^\s*//;
  @line = split(/\s*=\s*/, $conf[$i]);

  if ($conf[$i] =~ /^\s*\[/) {

    if ($tmp_flag) {
      if (!$available_flag) {
        if ($available eq "on") {
          push(@tmp,"\tavailable = no\n");
        }
      }
      if (!$path_flag) {
        if ($dir !~ /^\s*$/) {
          push(@tmp,"\tpath = $dir\n");
        }
      }
      if (!$comment_flag) {
        if ($comment !~ /^\s*$/) {
          push(@tmp,"\tcomment = $comment\n");
        }
      }
      if (!$writeable_flag) {
        if ($writeable eq "on") {
          push(@tmp,"\tread only = no\n");
        } 
      }
      if (!$browseable_flag) {
        if ($share eq "homes") {
          # homes λɬ"no"
          push(@tmp,"\tbrowseable = no\n");
        } else {
          if ($browseable eq "on") {
            push(@tmp,"\tbrowseable = yes\n");
          } else {
            push(@tmp,"\tbrowseable = no\n");
          }
        }
      }
      if (!$guest_flag) {
        if ($guest eq "on") {
          push(@tmp, "\tguest ok = yes\n");
        }
      }
      $tmp_flag = 0;
    }

    # [global]ɲ
    if ($global_flag) {
      if (!$browseable_global_flag && $share eq "homes") {
        if ($browseable eq "on") {
          push(@tmp, "\tbrowseable = yes\n");
        } else {
          push(@tmp, "\tbrowseable = no\n");
        }
      }
      $global_flag = 0;
    }


    $conf[$i] =~ s/[\s\[\]]//g;
    if ($conf[$i] eq $share) {
      $tmp_flag = 1;
    } elsif ($conf[$i] eq "global") {
      $global_flag = 1;
    }

    push(@tmp,$orgconf[$i]);
    next;
  }
# available path comment read only browseable parameter check
  if ($global_flag) {
    if ($line[0] =~ /^browseable$/i) {

      $browseable_org = $line[1];

      if ($browseable eq "on") {
        push(@tmp,"\tbrowseable = yes\n");
      } else {
        push(@tmp,"\tbrowseable = no\n");
      }
      $browseable_global_flag = 1;
    } else {
      push(@tmp,$orgconf[$i]);
    }
    next;
  }
  

  if ($tmp_flag) {
    if ($line[0] =~ /^available$/i) {
      if ($available eq "on") {
        push(@tmp,"\tavailable = no\n");
      } else {
        push(@tmp,"\tavailable = yes\n");
      }
      $available_flag = 1;
    } elsif ($line[0] =~ /^path$/i) {
      if ($dir !~ /^\s*$/) {
        push(@tmp,"\tpath = $dir\n");
      }
      $path_flag = 1;
    } elsif ($line[0] =~ /^comment$/i) {
      if ($comment !~ /^\s*$/) {
        push(@tmp,"\tcomment = $comment\n");
      }
      $comment_flag = 1;
    } elsif ($line[0] =~ /^read only$/i) {
      if ($writeable eq "on") {
        push(@tmp,"\tread only = no\n");
      } else {
        push(@tmp,"\tread only = yes\n");
      }
      $writeable_flag = 1;
    } elsif ($line[0] =~ /^writeable$/i) {
      if ($writeable eq "on") {
        push(@tmp,"\twriteable = yes\n");
      } else {
        push(@tmp,"\twriteable = no\n");
      }
      $writeable_flag = 1;
    } elsif ($line[0] =~ /^write ok$/i) {
      if ($writeable eq "on") {
        push(@tmp,"\twrite ok = yes\n");
      } else {
        push(@tmp,"\twrite ok = no\n");
      }
      $writeable_flag = 1;
    } elsif ($line[0] =~ /^browseable$/i) {
      # homes λɬ"no"
      if ($share eq "homes") {
        push(@tmp,"\tbrowseable = no\n");
      } elsif ($browseable eq "on") {
        push(@tmp,"\tbrowseable = yes\n");
      } else {
        push(@tmp,"\tbrowseable = no\n");
      }
      $browseable_flag = 1;
    } elsif ($line[0] =~ /^guest ok$/i) {
      if ($guest eq "on") {
        push(@tmp,"\tguest ok = yes\n");
      } else {
        push(@tmp,"\tguest ok = no\n");
      }       
      $guest_flag = 1;
    } else {
      push(@tmp,$orgconf[$i]);
    }
    next;
  }
  push(@tmp,$orgconf[$i]);
}
if ($tmp_flag) {
  if (!$available_flag) {
    if ($available eq "on") {
      push(@tmp,"\tavailable = no\n");
    }
  }
  if (!$path_flag) {
    if ($dir !~ /^\s*$/) {
      push(@tmp,"\tpath = $dir\n");
    }
  }
  if (!$comment_flag) {
    if ($comment !~ /^\s*$/) {
      push(@tmp,"\tcomment = $comment\n");
    }
  }
  if (!$writeable_flag) {
    if ($writeable eq "on") {
      push(@tmp,"\tread only = no\n");
    } 
  }
  if (!$browseable_flag) {
    if ($browseable ne "on") {
      push(@tmp,"\tbrowseable = no\n");
    } 
  }
  if (!$guest_flag) {
    if ($guest eq "on") {
      push(@tmp,"\tguest ok = yes\n");
    }
  }
  $tmp_flag = 0;
}


# homes ˡ[global][homes]ʳΥbrowseable ͤ񤭹
if ($share eq "homes") {
  @tmp_org = @tmp;
  $skip_flag = 0;
  $browseable_find = 0;

  if ($browseable_org eq "") {
    $browseable_org = "yes";
  }

  for($i = 0; $i < @tmp; $i++) {
          $tmp[$i] =~ s/\s*$//;
    $tmp[$i] =~ s/^\s*//;
    @line = split(/\s*=\s*/, $tmp[$i]);

    if ($tmp[$i] =~ /^\s*\[/) {
      $tmp[$i] =~ s/[\s\[\]]//g;
      # global homes ϤΤޤ
      if ($tmp[$i] eq "global" || $tmp[$i] eq "homes") {
        $skip_flag = 1;
      } else {
        if (!$skip_flag && !$browseable_find) {
          push(@tmp2, "\tbrowseable = $browseable_org\n");
        }
        $skip_flag = 0;
      }
      $browseable_find = 0;
    }
    if ($skip_flag) {
      # global homes ϤΤޤ
      push(@tmp2, $tmp_org[$i]);
    } elsif ($line[0] =~ /^\s*browseable\s*$/) {
      # browseable꤬ФΤޤ޵
      $browseable_find = 1;
      push(@tmp2, $tmp_org[$i]);
    } else {
      push(@tmp2, $tmp_org[$i]);
    }
  }
  if (!$browseable_find) {
    push(@tmp2, "\tbrowseable = $browseable_org\n");
  } 
} else {
  # ѹ̵
  @tmp2 = @tmp;
}

# եե˽񤭹
if (!&writeFileE2S("$cfile","smb.conf",@tmp2)) {
        &showErrorPage("$cfile Υץ˼Ԥޤ");
        exit(1);
}
# Samba κƵư
if (&isServiceRunning("")) {
  system("/etc/rc.d/init.d/smb stop");
  system("/etc/rc.d/init.d/smb start");
}

&showPage("./global.cgi");
#------------------------------------------------------
