#!/usr/bin/perl

# Copyright (C) 2000-2003 NEC Corporation
# All Rights Reserved.

# RCS: $Id: snmpapi.pl,v 1.6 2003/05/20 05:43:41 snavi Exp $

##000411 1.2  եιǴ¸ȥΥåˡ
##000419 1.3  ȥԽ˴ؤХ 
##000421 1.4  checkPid(), restartService()ɲ
##000515 1.5  view, accessκν
##011210 v4.2 ߥ˥ƥɽб oku
##030225 V5.1 Ʊ쥳ߥ˥ƥʣIPɥ쥹λѤб oyama

#----------------------------------------------------------------------------
$WBMCCOMMONAPIS = "../../../lib/wbmc.pl";
$SNMPDCONFIG = "/etc/snmp/snmpd.conf";

#----------------------------------------------------------------------------
require "$WBMCCOMMONAPIS";
use POSIX qw(strftime);

#----------------------------------------------------------------------------
sub snmpApi {
	local(*av) = @_;
	my($err, @tk, @elm);

	$err = 0;
	$cfname = $SNMPDCONFIG;
	@tk = ();
	@elm = ();

	if ($#av == -1) {
		$err = 1;
	}

	$j = 0;
	for ($i = 0; $i <= $#av; $i++) {
		$tk[$j]->{cmd} = $av[$i];
		$tk[$j]->{argc} = -1;
		if (($av[$i] eq "-ca") || ($av[$i] eq "-cd")) {
			if (($#av-$i) < 3) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 3;
			$tk[$j]->{0} = "com2sec";
			$max = 3;
		}
		elsif (($av[$i] eq "-ga") || ($av[$i] eq "-gd")) {
			if (($#av-$i) < 3) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 3;
			$tk[$j]->{0} = "group";
		}
		elsif (($av[$i] eq "-va") || ($av[$i] eq "-vd")) {
			if (($#av-$i) < 4) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 4;
			$tk[$j]->{0} = "view";
		}
		elsif (($av[$i] eq "-aa") || ($av[$i] eq "-ad")) {
			if (($#av-$i) < 8) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 8;
			$tk[$j]->{0} = "access";
		}
		elsif (($av[$i] eq "-sL")) {
			if (($#av-$i) < 1) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 1;
			$tk[$j]->{0} = "syslocation";
		}
		elsif (($av[$i] eq "-sC")) {
			if (($#av-$i) < 1) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 1;
			$tk[$j]->{0} = "syscontact";
		}
		elsif (($av[$i] eq "-A")) {
			if (($#av-$i) < 1) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 1;
			$tk[$j]->{0} = "authtrapenable";
		}
		elsif (($av[$i] eq "-tc")) {
			if (($#av-$i) < 1) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 1;
			$tk[$j]->{0} = "trapcommunity";
		}
		elsif (($av[$i] eq "-ta") || ($av[$i] eq "-td")) {
			if (($#av-$i) < 2) {
				$err = 1;
				last;
			}
			$tk[$j]->{argc} = 2;
			$tk[$j]->{0} = "trapsink";
		}
		elsif ($av[$i] eq "-c") {
			if (($#av-$i) < 1) {
				$err = 1;
				last;
			}
			$cfname = $av[++$i];
			next;
		}
		else {
			$err = 1;
			last;
		}
		for ($k = 1; $k <= $tk[$j]->{argc}; $k++) {
			$tk[$j]->{$k} = $av[++$i];
		}
		$j++;
	}
	if ($err != 0) {
		$err = "ޥɤΰǤ";
		return $err;
	}

	#----------------------------------------------------------------
	# snmpd.confեɤ߹
	#----------------------------------------------------------------
	splice(@elements, 0, $#elements+1);
	if (!&readFile($cfname, "snmpd.conf", *elements)) {
		$err = "$cfnameեɤ߹ߤ˼Ԥޤ(sub snmpApi)";
		return $err;
	}
	$i = 0;
	for ($lineno =0; $lineno <= $#elements; $lineno++) {
		$line = $elements[$lineno];

		$line =~ s/\s*$//;
		@col = split(/\s+/, $line);

		if ($#col >= 0) {
			if (($col[0] eq "com2sec")
				|| ($col[0] eq "group")
				|| ($col[0] eq "view")
				|| ($col[0] eq "access")
				|| ($col[0] eq "authtrapenable")
				|| ($col[0] eq "trapcommunity")
				|| ($col[0] eq "trapsink")) {
				$elm[$i]->{argc} = $#col;
				for ($j = 0; $j <= $#col; $j++) {
					$elm[$i]->{$j} = "$col[$j]";
				}
			}
			elsif (($col[0] eq "syslocation")
					|| ($col[0] eq "syscontact")) {
				$elm[$i]->{argc} = 1;
				$elm[$i]->{0} = $col[0];
				$line =~ s/$col[0]//;
				$line =~ s/\s+//;
				$elm[$i]->{1} = $line;
			}
			else {
				$elm[$i]->{argc} = 0;
				$elm[$i]->{0} = "$line";
			}
		}
		else {
			$elm[$i]->{argc} = 0;
			$elm[$i]->{0} = "$line";
		}
		$i++;
	}
	#----------------------------------------------------------------
	# եƤι
	#----------------------------------------------------------------
	for ($i = 0; $i <= $#tk; $i++) {

		if ($tk[$i]->{argc} < 0) {
			next;
		}

		$exist = 0;
		$max = $#elm;

		for ($j = 0; $j <= $#elm; $j++) {

			$same = 0;

			if (($elm[$j]->{argc} < 0) 
				|| ($tk[$i]->{0} ne $elm[$j]->{0})) {
				next;
			}
			#------------#
			# Ʊ #
			#------------#
			if ($tk[$i]->{argc} <= $elm[$j]->{argc}) {
				$min = $tk[$i]->{argc};
			}
			else {
				$min = $elm[$j]->{argc};
			}
			if (($tk[$i]->{cmd} eq "-vd")
					|| ($tk[$i]->{cmd} eq "-ad")) {
				if ($tk[$i]->{1} eq $elm[$j]->{1}) {
					$same = 1;
				}
			}
			else {
				for ($m = 1; $m <= $min; $m++) {
					if ($tk[$i]->{$m} ne $elm[$j]->{$m}) {
						last;
					}
				}
				#-----------------#
				# ƤǤƱ#
				#-----------------#
				if ($m > $min) {
					$same = 1;
				}
			}
			if ($same == 1) { #Ʊ
				#
				if (($tk[$i]->{cmd} eq "-cd")
					|| ($tk[$i]->{cmd} eq "-gd")
					|| ($tk[$i]->{cmd} eq "-vd")
					|| ($tk[$i]->{cmd} eq "-ad")
					|| ($tk[$i]->{cmd} eq "-td")) {
					$elm[$j]->{argc} = -1;
				}
				$exist = 1;
			}
			else { #ƱǤ㤦
				#ѹ(ƥǥˡʤΤξ)
				if (($tk[$i]->{cmd} eq "-sL")
					|| ($tk[$i]->{cmd} eq "-sC")
					|| ($tk[$i]->{cmd} eq "-A")
					|| ($tk[$i]->{cmd} eq "-tc")) {
					$elm[$j]->{argc} = $tk[$i]->{argc};
					for ($m = 1; $m <= $tk[$i]->{argc}; $m++) {
						$elm[$j]->{$m} = $tk[$i]->{$m};

					}
					$exist = 1;
				}
			}
		}
		if ($exist == 0) { #ƱΤϤʤ
			#ɲ
			if (($tk[$i]->{cmd} eq "-ca")
				|| ($tk[$i]->{cmd} eq "-ga")
				|| ($tk[$i]->{cmd} eq "-va")
				|| ($tk[$i]->{cmd} eq "-aa")
				|| ($tk[$i]->{cmd} eq "-ta")
				|| ($tk[$i]->{cmd} eq "-sL")
				|| ($tk[$i]->{cmd} eq "-sC")
				|| ($tk[$i]->{cmd} eq "-A")
				|| ($tk[$i]->{cmd} eq "-tc")) {
				$elm[++$max]->{argc} = $tk[$i]->{argc};
				for ($m = 0; $m <= $tk[$i]->{argc}; $m++) {
					$elm[$max]->{$m} = $tk[$i]->{$m};
				}
			}
		}
	}

	#----------------------------------------------------------------
	# snmpd.conf.tmpեؤν
	#----------------------------------------------------------------
	if (!&lockFile("snmpd.conf", $WBMC_LOCK_W_B, *LOCK)) {
		$err = "եΥå˼Ԥޤ";
		return $err;
	}
	if (!open(OUT, "> $cfname.tmp")) {
		$err = "$cfn.tmpեΥץ˼Ԥޤ";
		close(LOCK);
		return $err;
	}
	for ($i = 0; $i <= $#elm; $i++) {
		if ($elm[$i]->{argc} < 0) {
			next;
		}
		for ($j = 0; $j <= $elm[$i]->{argc}; $j++) {
			if ($j > 0) {
				print OUT "    ";
			}
			print OUT "$elm[$i]->{$j}";	
		}
		print OUT "\n";
	}
	close(OUT);
	close(LOCK);

	rename("$cfname.tmp", "$cfname");

	return $err;
}

#----------------------------------------------------------------
# ưå
# : 0 ()
#         1 (ư)
#----------------------------------------------------------------
sub checkPid {
	my($srv) = @_;
	my($result, @elm);

	$result = 0;
	@elm = ();
	if (!open(IN, "/bin/ps -ef |")) {
		goto done;
	}
	while (<IN>) {
		s/\s*$//;
		@elm = split(/\s+/);
		if ($#elm < 7) {
			next;
		}
		$elm[7] =~ s/.*\///;
		if ($elm[7] eq $srv) {
			$result = 1;
			close(IN);
			goto done;
		}
	}
	close(IN);
done:
	return($result);
}

#----------------------------------------------------------------
# ӥκƵư
#----------------------------------------------------------------
sub restartService {
	my($srv) = @_;
	my($err, $cmd);

	$err = 0;
	if (!$srv) {
		$err = "ꤷͤǤ";
		goto done;
	}
	$err = system("/etc/rc.d/init.d/$srv restart > /dev/null 2>&1");
done:
	return($err);
}

#----------------------------------------------------------------
# ߥ˥ƥ̾ʣå
# : "" (ʣ̵)
#         顼å (ʣͭ)
#----------------------------------------------------------------
sub checkComm {
#	my($commname) = @_;
	my($commname, $ipaddress) = @_;
	my($i_snmp, $cfname) = "";
	local(@snmpconf) = ();
	$cfname = "/etc/snmp/snmpd.conf";

#	if (length($commname) > 204) {
#		return("ߥ˥ƥ̾ 1204 ʸꤷƲ");
	if (!$ipaddress){
		$ipaddress = "default";
	}
	if (length($commname) > 32) {
		return("ߥ˥ƥ̾ 132 ʸꤷƲ");
	}
	if (!&readFile($cfname, "snmpd.conf", *snmpconf)) {
		return("$cfnameեɤ߹ߤ˼Ԥޤ");
	}
	for ($i_snmp=0; $i_snmp<@snmpconf; $i_snmp++) {
		if ($snmpconf[$i_snmp] =~ /^\s*#/) {
			next;
		}
		if ($snmpconf[$i_snmp] =~ /^\s*com2sec\s+(.+)\s+(.+)\s+\Q$commname\E\s*$/) {
#			return("Υߥ˥ƥ̾ϴ˻ѤƤޤ");
			if ($1 =~ /\s+$ipaddress\s*$/){
				return("Υߥ˥ƥ̾ȵĤ륢ɥ쥹Ȥ߹碌ϴ˻ѤƤޤ");
			}
		}
	}
	return();
}
#----------------------------------------------------------------
# ƥ̾ؿ
# ͡"աץֹ"(ʣ̵)
#         顼å̵
#----------------------------------------------------------------
sub get_uniq_secname {
	my($time_str) = strftime("%Y%m%d%H%M%S", localtime);
	return "$time_str-$$";
}

#----------------------------------------------------------------

1;
