#!/usr/bin/perl
# Copyright (C) 2001 NEC Corporation
# All Rights Reserved.

# RCS: $Id: confirm.cgi,v 1.1 2002/09/17 05:49:10 snavi Exp $

##### 2001.01.31 BossSystem Tsuno
require "/opt/nec/wbmc/language.pl";
if($mes_language eq "Japanese"){
    require "./lang_j.pl";          # ܸå
} else {
    require "./lang_e.pl";          # Ѹå
}
$mes_work_string = "";
##### 2001.01.31 BossSystem Tsuno

#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "olud.pl";
#------------------------------------------------------------

# use strict;

my($i, $tmp, $err, $file, $value, @pakfile, $name) = ();
my(%pak, @pakurl, @rpmfile) = ();
my(@pakmd5, $md5sum, $table, $form) = ();

# STDOUTեå
my $old = select(STDOUT);
$| = 1;
select($old);

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$mes_confirm_05</TITLE>
</HEAD>
<BODY>
END_OF_DATA
#------------------------------------------------------------
# for MSIE
print "<!--" . "-" x 1024 . "-->\n";

# ѥåե̾ɤ߹
&readParam();
$i = 0;
while ( $value = $FORM{"PAKFILE${i}"} ) {
    push(@pakfile, $value);
    $i++;
}

# ѥåեɤ߹
for ( @pakfile ) {
    $file = &olud::datdir . "/$_";
    $err = &olud::readDatFile($file, \%pak);
    if ( $err ) {
        &olud::showErrorBody($err);
        exit(1);
    }
}

# ѥåեURL, md5sum
for $name ( keys %pak ) {
    push(@pakurl, $pak{$name}{'File'});
    push(@pakmd5, $pak{$name}{'md5sum'});
}

# ե
for ( @pakurl ) {
    ($err, $tmp) = &olud::DownloadFile($_);
    if ( $err ) {
        &olud::showErrorBody($err);
        exit(1);
    }
    $file = &olud::datdir . &olud::basename($tmp);
    rename($tmp, $file) or &olud::showErrorBody("$mes_confirm_13: $!");
    push(@rpmfile, $file);
}

# 
# rpm -K --nogpg
for ( @rpmfile ) {
    next unless (/\.rpm$/);
    $err = &olud::VerifyPackage($_);
    if ( $err ) {
        &olud::showErrorBody($err);
        exit(1);
    }
}

# md5sum å, ơ֥
for $i ( 0 .. $#rpmfile ) {
    $err = olud::check_md5sum($rpmfile[$i], $pakmd5[$i]);
    if ( $err ) {
        $file = &olud::basename($rpmfile[$i]);
        $mes_work_string = sprintf($mes_confirm_02, &encodeHtml($file));
        &olud::showErrorBody($mes_work_string);
        exit(1);
    }
    $table .="<TR>\n"
           . "<TD NOWRAP>" . &olud::basename($rpmfile[$i]) . "</TD>\n"
           . "<TD NOWRAP>$pakmd5[$i]</TD>\n"
           . "</TR>\n";
}

# ѤFORM
$form .= "<INPUT TYPE=\"hidden\" NAME=\"MODNAME\" VALUE=\"$FORM{'MODNAME'}\">\n";
for $i ( 0 .. $#pakfile ) {
    $form .= "<INPUT TYPE=\"hidden\" NAME=\"PAKFILE${i}\" VALUE=\"$pakfile[$i]\">\n";
}

# ʥӥСκ
#------------------------------------------------------------
$navibar = &getNavigation(
    $mes_confirm_03, "package.cgi",
    $mes_confirm_04, "pkg_list.cgi",
    $mes_confirm_05, "",
    "_back", "pkg_list.cgi",
    "_help", "confirm_help.cgi",
);

#------------------------------------------------------------
print <<END_OF_DATA;

<H4 ALIGN="center">$mes_confirm_05</H4>
<HR>
$navibar
<HR>
<CENTER>
 <FORM NAME="form1" METHOD="POST" ACTION="install.cgi">
  <TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH=500>
   <TR BGCOLOR="#000080">
    <TD><FONT COLOR="#FFFFFF">$mes_confirm_06</FONT></TD>
   </TR>
   <TR>
    <TH>
     <TABLE>
      <TR>
       <TD>
       $mes_confirm_07
       <P>
       <CENTER>
       <TABLE BORDER=1 CELLSPACING=0 CELLPADDING=1>
        <TR>
     <TD>$mes_confirm_08</TD>
     <TD>$mes_confirm_09</TD>
    </TR>
$table
$form
       </TABLE>
       </CENTER>
       <P>
       $mes_confirm_10
       </TD>
      </TR>
      <TR>
       <TD COLSPAN=2 ALIGN="center">
        <INPUT TYPE="submit" VALUE="$mes_confirm_11">
        <INPUT TYPE="button" VALUE="$mes_confirm_12" onClick="location.href='pkg_list.cgi'">
       </TD>
      </TR>
     </TABLE>
    </TH>
   </TR>
  </TABLE>
 </FORM>
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------

