# Copyright (C) 2001 NEC Corporation
# All Rights Reserved.

# RCS: $Id: olud.pl,v 1.3 2002/10/21 10:47:09 snavi Exp $

use strict;

#
#    olud.pl - Express5800/CacheServer 饤󥢥åץǡѥ饤֥
#
#    ե/var/log/wbmc˽ϡwriteLogؿѡ2002.04.19 Honda
package olud;

#
#    ǥХåѿ
#
$olud::debug = 0; 

#
#    å(Japanese/English)
#
package main;
$ENV{'HOME'} = '';
require "/opt/nec/wbmc/language.pl";
if ($main::mes_language eq "Japanese"){
    require "/opt/nec/wbmc/adm/softpkg/lang_j.pl";
} else {
    require "/opt/nec/wbmc/adm/softpkg/lang_e.pl";
}
package olud;
my $mes_work_string = "";


#
#    ǧURL
#
my @authurl = (
    'http://info.ace.comp.nec.co.jp/linux/info/ilogin.asp',
#    'http://ppsg02.td3.bs1.fc.nec.co.jp/linux/info/ilogin.asp',
);
sub authurl { return @authurl; }

#
#    ǡեURL
#
my @daturl = (
    'http://info.ace.comp.nec.co.jp/linux/upgrade/mailweb/',
#    'http://ppsg02.td3.bs1.fc.nec.co.jp/linux/upgrade/mailweb/',
);
sub daturl { return @daturl; }

#
#    ե¸ǥ쥯ȥ
#
my $datdir = '/var/opt/nec/wbmc/olud/dat/';
sub datdir { return $datdir; }

#
#    ǥ쥯ȥ
#
my $tmpdir = '/var/opt/nec/wbmc/olud/tmp/';
sub tmpdir { return $tmpdir; }

#
#    ե
#
my $logdir = '/var/log/wbmc_olud/';
my $logfname = '';
sub logfname { $logfname = $_[0]; }

my $wbmclogname = '/var/log/wbmc'; #degubolud logfile 2002.4.18 add honda

#
#    oludregist
#
my $oludregist = '/opt/nec/wbmc/adm/softpkg/oludregist';

#
#    &main::readFile() ѤΥǡǼ
#
local @olud::data;


## MailWebServer ˲ 2002.6.21 kima
my $wbmc_http_proxy_file = '/etc/opt/nec/wbmc/wbmchttpproxy.conf';
my $wbmc_http_proxy_file_lock_name = 'wbmchttpproxy.conf';
sub getProxy {
  if(!-e $wbmc_http_proxy_file) {
    return ('', undef, undef);
  }
  local @olud::file;
  if (!&main::readFile($wbmc_http_proxy_file,
		 $wbmc_http_proxy_file_lock_name, *olud::file)) {
    return ("եɤ߹ߤ˼Ԥޤ($wbmc_http_proxy_file)",
	    undef,
	    undef);
  }
  foreach (@olud::file) {
    my $line = $_;
    next if($line =~ /^\s*\#/);
    chomp($line);
    if($line =~ /([^:]+)\:(\d+)/) {
      my $addr = $1;
      my $port = $2;
      return ('', $addr, $port);
    }
  }
  return ("ե뤬Ǥ($wbmc_http_proxy_file)",
	  undef,
	  undef);
}

sub writeProxyConfFile {
  my ($addr, $port) = @_;
  $addr =~ s/\s*(\S+)\s*/\1/;
  $port =~ s/\s*(\d+)\s*/\1/;
  if(!$addr || $addr =~ /^\s*$/) {
    unlink($wbmc_http_proxy_file);
    return;
  }
  my @fileimg = ("$addr:$port");
  my $tmp_name = $wbmc_http_proxy_file . ".tmp$$";
  if(!&main::writeFile($tmp_name,
		 $wbmc_http_proxy_file_lock_name, @fileimg)) {
    unlink($tmp_name);
    return "եν񤭹ߤ˼Ԥޤ($wbmc_http_proxy_file)";
  }
  if(!rename($tmp_name, $wbmc_http_proxy_file)) {
    unlink($tmp_name);
    return "եν񤭹ߤ˼Ԥޤ($wbmc_http_proxy_file)";
  }
  return;
}

#
# ̾
#       getProxy - ץФIP/ݡȤ
# 
#       ($err, $ip, $port) = &olud::getProxy();
# 
#
# 
#   $err    顼å(ʤ'')
#   $ip IPɥ쥹
#   $port   ݡ
#
#  sub getProxy
#  {
#      package main;
#      require '/opt/nec/wbmc/adm/proxy/common_roma.pl';
#      package olud;

#      local (@olud::basicproxy) = ();
#      my ($key, $ip, $port) = ();

#      if (!&main::readFile($main::roma_conf, $main::roma_conf_lock, *olud::data)) {
#          return $main::mes_olud_pl_25;
#      }

#      if (!&main::romaGetWbMCSection(*olud::data, "basicproxy", *olud::basicproxy)) {
#          return $main::mes_olud_pl_25;
#      }

#      for ( @olud::basicproxy ) {
#          chomp;
#          ($key, $ip, $port) = split;
#          if ( $key eq "main_http_host_port" ) {
#              return ('', $ip, $port);
#          }
#      }

#      return $main::mes_olud_pl_26;
#}

#
# ̾
#       DownloadFile - եɤ $tmpdir ¸
# 
#       ($err, $file) = &olud::DownloadFile($url, $uname, $pass);
# 
#       $url    ɥեURL
#       $uname  桼̾
#       $pass   ѥ
# 
#       $err    顼å
#       $file   ¸եΥѥ
#
sub DownloadFile
{
    my ($url, $uname, $pass) = @_;
    my ($file, $socket, $HTTP200, $content_length, $start_body, $dl_size) = ();
    my ($status, $status_count, $count_size, $auth_str, $err) = ();
    my ($proxy_host, $proxy_port) = ();
    my ($res_num);
    my ($disp_url); #log file output

    my $debug = 0;


    ($err, $proxy_host, $proxy_port) = &getProxy();
    $err and return $err; 

    # ¸ǥ쥯ȥư
    if ( -e $tmpdir && !-d $tmpdir ) {
        unlink($tmpdir);
    }
    system("/bin/mkdir","-p",$tmpdir) if ( !-e $tmpdir);
    chdir $tmpdir or return $main::mes_olud_pl_02;

    # ե뤬¸ߤƤϺ
    $file = "$tmpdir/" . &basename($url);
    unlink($file) if ( -f $file );

    # ֥饦 status bar ɽʸ
    $count_size = $status_count = 100000;
    $status = "Now Downloading ... ";

    # ǧڥإå
    use MIME::Base64;
    $auth_str = &main::encodeCmdArg("$uname:$pass");
#    $auth_str = `echo $auth_str | /usr/bin/mimencode`;
    $auth_str = encode_base64($auth_str);
    $debug and print "auth_str : $auth_str\n";

    # ɳ
    $debug && print "Download $url\n";
    &print_status($status);

    #url򱣤
    $url =~ /.*\/(.*)$/;
    $disp_url = $1;

    # ³
    $debug and print "connect $proxy_host:$proxy_port\n";
    use IO::Socket;
    use URI::URL;

    my $peer_addr;
    my $peer_port;
    my $url_path;
    if($proxy_host && $proxy_host !~ /^\s*$/) {
      $peer_addr = $proxy_host;
      $peer_port = $proxy_port;
      $url_path = $url;
    } else {
      my $url_obj = new URI::URL($url);
      $peer_addr = $url_obj->host;
      $peer_port = $url_obj->port;
      $url_path = $url_obj->path;
    }

    $socket = IO::Socket::INET->new(PeerAddr => $peer_addr,
                                    PeerPort => $peer_port,
                                    Proto    => "tcp",
                                    Type     => SOCK_STREAM);
    if ( !$socket ) {
        return "can't connect $peer_addr:$peer_port : $@";
    }

    # ꥯ
    $debug and print "GET $url_path\n";
    print $socket "GET $url_path HTTP/1.0\r\n";
    print $socket "Pragma: no-cache\r\n";
    print $socket "Authorization: Basic $auth_str\r\n";
    print $socket "\r\n";



    #եɤ߹ߥ
    &main::writeLog("$disp_url: GetStart", "olud" , $wbmclogname);

    # header 
    while (<$socket>) {
        $debug and print "Res: $_";
        if (/^HTTP\/1\.\d +(\d+)/) {
            $res_num = $1;
            if ($res_num eq '200') {
                $HTTP200++;
                $debug and print "HTTP 200 OK\n";
            }
            elsif ($res_num eq '407') {
                $err .= $main::mes_olud_pl_35;
                last;
            }
        }
        elsif (/^Content-Length: *(\d+)\r?\n+$/i) {
            $content_length = $1;
            $debug and print "Content-Length OK : $content_length\n";
        }
        elsif (/^\r?\n+$/) {
            $start_body++;
            $debug and print "header is finish, start body\n";
            last;
        }
    }



    # body ե˽
    if ( !$err && $HTTP200 && ($content_length ne '') && $start_body ) {
        # ե륪ץܥå
        open(OUT, "+> $file") or return "can't open: $!";
        flock(OUT, 2) or return "can't lock: $!";
        truncate(OUT, 0) or return "can't truncate: $!";
        seek(OUT, 0, 0) or return "can't seek: $!";
        $debug and print "Save file lock OK : $file\n";

        while (<$socket>) {
            print OUT $_;
            $dl_size += length;
            if ( $dl_size >= $status_count ) {
                $status .= '#';
                print_status($status);
                $status_count += $count_size;
            }
        }

        close(OUT) or return "can't close: $!";
    }

    close($socket) or return "can't close socket: $!";

    return $err if $err;
    
    if ( !$HTTP200 || ($content_length eq '') || !$start_body ) {
        &main::writeLog("[ERROR] $disp_url: not HTTP 200 error or no body or no content_length", "olud" , $wbmclogname);
        unlink($file);
        return $main::mes_olud_pl_03;
    }

    #content_length,body_size
    &main::writeLog("$disp_url:  Content_Length: $content_length  dl_size: $dl_size", "olud" , $wbmclogname);

    $debug and print "download size : $dl_size\n";
    if ( $content_length != $dl_size ) {
        unlink($file);
        return $main::mes_olud_pl_04;
    }

    # ե뤬ǤƤХѥ֤
    if ( -r $file && (-s $file == $content_length) ) {
        $status .= " OK!!";
        print_status($status);
        return ('', $file);
    }
    
    &main::writeLog("[ERROR] $disp_url: file not found", "olud" , $wbmclogname);
    $debug && print "file not found : $file\n";
    unlink($file);
    return $main::mes_olud_pl_24;
}

#
# ̾
#       readDatFile - ǡեɤ߹
# 
#       $err = &olud::readDatFile($file, \%dat);
# 
#       $file   ե̾
#       \$dat   ǡǼϥåؤΥե
# 
#       顼åʤ''
#
sub readDatFile
{
    my ($file, $dat) = @_;
    my ($lock, $key1, $key2) = ();
    my ($i, $line) = ();

    $lock = &basename($file);
    if (!&main::readFile($file, $lock, *olud::data)) {
        return $main::mes_olud_pl_11;
    }

    $key1 = $lock;

    # %ФƤޤɤ߹
    $i = 0;
    for ( @olud::data ) {
        last if (/^\s*\%.+/);
        if (/^([^:]+):\s*(.*)$/) {
            $dat->{$key1}->{$1} = $2;
        }
        $i++
    }
    return '' if ($i > $#olud::data);
    # %ɤ߹
    $line = $i;
    for $i ($line .. $#olud::data) {
        # Ԥ̵
        next if ($olud::data[$i] =~ /^[\r\n]+$/);
        # "#"ǻϤޤԤ̵
        next if ($olud::data[$i] =~ /^\#/);
        # 
        if ($olud::data[$i] =~ /^\s*\%(.+)/) {
            $key2 = $1;
            next;
        }
        next if ($key2 eq '');
        # ƳǼ
        $dat->{$key1}->{$key2} .= $olud::data[$i];
    }
    return '';
}

#
# ̾
#       basename - ѥ̾ե̾
# 
#       $name = &olud::basename($path);
# 
#       $path   ѥ̾
# 
#       $name   ե̾
#
sub basename
{
    my ($path, $del) = @_;
    # "/" ޤǤ
    $path =~ s#.*/##;
    return $path;
}

#
# ̾
#       deleteExt - ĥҤ
# 
#       $name = &olud::deleteExt($fname);
# 
#       $fname  ĥͭե̾
# 
#       $name   ĥ̵ե̾
#
sub deleteExt
{
    my ($fname) = @_;
    # Ǹ "." ʸ
    $fname =~ s/\.[^\.]*?$//;
    return $fname;
}

#
# ̾
#       VerifyPackage - ѥå򸡾ڤ
# 
#       $err = &olud::VerifyPackage($file);
# 
#       $file   RPMե
# 
#       $err    顼å(ʤ '')
#
sub VerifyPackage
{
    my ($file) = @_;
    my ($ret) = ();
    my ($disp_file);

    $file =~ /.*\/(.*)$/;
    $disp_file = $1;

    $ret = `(export LANG=C; export LC_ALL=C; /bin/rpm -K --nogpg $file 2>&1)`;

    if ( $ret =~ /^$file: md5 OK\s*$/) {
        #md5 ok
        &main::writeLog("$disp_file: md5 OK", "olud" , $wbmclogname);
        return '';
    }

    #md5 error
    &main::writeLog("[ERROR] $disp_file: md5 get error", "olud" , $wbmclogname);

    $mes_work_string = sprintf($main::mes_olud_pl_19, &main::encodeHtml($ret));
    return $mes_work_string;
}

#
# ̾
#       InstallPackage - ѥå򥤥󥹥ȡ뤹
# 
#       ($err, $msg) = &olud::InstallPackage($file);
# 
#       $file   ѥåǡե
# 
#       $err    顼å(ʤ '')
#       $msg    󥹥ȡ봰λɽå
#
sub InstallPackage
{
    my ($file) = @_;
    my ($err, $ret, $rets, %pak, $name, @cmd, $msg, $rpm) = ();

    $err = &readDatFile($file, \%pak);
    $err and return $err;

    chdir $datdir or return $main::mes_olud_pl_02;

    # 󥹥ȡ (Υ롼פϰ٤¹ԤʤϤ)
    for $name ( keys %pak ) {
        $logfname or $logfname = "$name.$$";
        # &Log("chdir $datdir");
        &Log("install $name");
        &Log("md5sum $pak{$name}{'md5sum'}");

        # %install Υץȼ¹
        if ( $pak{$name}{'install'} ) {
            @cmd = split /\n/, $pak{$name}{'install'};
            for ( @cmd ) {
                &Log("exec $_");
                $ret = `(export LANG=C; export LC_ALL=C; $_)`;
                if ( $ret ) {
                    $rets .= $ret;
                    &Log("$ret");
                }
            }
        }

        # msg_after
        $msg = $pak{$name}{'msg_after'};

        # 
        $rpm = &basename($pak{$name}{'File'});
        unlink($rpm) if ( -e $rpm );
    }

    return ($rets, $msg);
}

#
# ̾
#       UserAuth - 桼ǧڤ
# 
#       ($err, $key) = &olud::UserAuth($url, $num, $class, $pass);
# 
#       $url    URL
#       $num    ֹ
#       $class  Ͽʬ
#       $pass   ѥ
# 
#       $err    顼åʤ''
#       $key    桼̥
#
sub UserAuth
{
    my ($url, $num, $class, $pass) = @_;
    my ($socket, @res, $err) = ();
    my ($res_num, @cookie, $location) = ();
    my ($form, %form, $type, $action) = ();
    my ($form_data_set, $send_cookie, $content_type, $content_length) = ();
    my ($name, $value, $param, $key) = ();
    my ($method, @send_header, @send_body) = ();
    #2002.10.7 Nines Honda edit
    my (@model, $expire, $day, $mon, $year, $expire_time) = ();
    my ($proxy_host, $proxy_port) = ();
    my ($n_code) = ();
    my ($model_check)=0;

    my $debug = 0;

    $logfname = ".authlog";

    ($err, $proxy_host, $proxy_port) = &getProxy();
    $err and return $err;

    ($err, $n_code) = &getModelName();
    $err and return $err;

    use IO::Socket;
    use URI::URL;

    $method = "GET";

    # ֥롼Υͥ(Perlå֥åP368)
    local *getPage = sub
    {
        my($err);
        do {
            (@res, $res_num, @cookie, $location) = ();
        
            # ³ (Perlå֥å P618)
            $debug and print "  connect: $url by $proxy_host:$proxy_port\n";

	    my $peer_addr;
	    my $peer_port;
	    my $url_path;
	    if($proxy_host && $proxy_host !~ /^\s*$/) {
	      $peer_addr = $proxy_host;
	      $peer_port = $proxy_port;
	      $url_path = $url;
	    } else {
	      my $url_obj = new URI::URL($url);
	      $peer_addr = $url_obj->host;
	      $peer_port = $url_obj->port;
	      $url_path = $url_obj->full_path;
	    }
	    
            $socket = IO::Socket::INET->new(PeerAddr => $peer_addr,
                                            PeerPort => $peer_port,
                                            Proto    => "tcp",
                                            Type     => SOCK_STREAM)
                or return "can't connect $peer_addr:$peer_port : $@";
        
            # ꥯ
            print $socket "$method $url_path HTTP/1.0\r\n";
            print $socket "Pragma: no-cache\r\n";
            $send_cookie and print $socket $send_cookie;
            if ( $method eq 'POST' ) {
                $content_type and print $socket $content_type;
                $content_length and print $socket $content_length;
                print $socket "\r\n";
                $form_data_set and print $socket $form_data_set;
            }
            print $socket "\r\n";
        
            # إå
            while (<$socket>) {
                $debug and print $_;
                last if (/^\r?\n$/);
                if (/^HTTP\/1\.\d (\d+) .+/) {
                    $res_num = $1;
                    $debug and print "  response number: $res_num\n";
                    # ʱ
                    if ( $res_num eq '407' ) {
                        $err .= $main::mes_olud_pl_35;
                        last;
                    }
                    elsif ( $res_num !~ /^200|302$/ ) {
                        $err .= "unknown response: $res_num\n";
                        last;
                    }
                }
                elsif (/^Set-Cookie:\s*([^\r\n]+)\r?\n$/) {
                    push(@cookie, $1);
                    $debug and print "  find Cookie: $1\n";
                }
                elsif (/^Location:\s*([^\r\n]+)\r?\n$/) {
                    $location = $1;
                    $debug and print "  find Location: $1\n";
                }
            }
        
            # HTTP 302 Moved Temporarily
            if ( ! $err and $res_num == 302 ) {
                # Location: إå
                if ( $location ) {
                    # absoluteURI ʤ餽Τޤ޼URL
                    if ( $location =~ /^http:\/\// ) {
                        $url = $location;
                        $debug and print "  find absoluteURI.\n";
                    }
                    # Хѥʤ
                    elsif ( $location =~ /^\/.+/ ) {
                        $url =~ s/^(http:\/\/[^\/]+)\/.*$/$1/;
                        $url .= $location;
                        $debug and print "  find soutai URI.\n";
                    }
                    elsif ( $location =~ /^\..+/ ) {
                        $url =~ s/^(.+\/).*/$1/;
                        $url .= $location;
                        $debug and print "  find soutai URI.\n";
                    }
                    # ¾
                    else {
                        $err .= "unknown Location: $location\n";
                        $debug and print "  unknown Location: $location\n";
                    }
                }
                else {
                    $err .= "can't find Location.\n";
                    $debug and print "can't find location.\n";
                }
            }
        
            # HTTP 200 OK
            if ( ! $err and $res_num == 200 ) {
                @res = <$socket>;
                $debug and print "  HTTP 200 OK. get body.\n";
            }

            close($socket) or $err .= "can't close socket: $!\n";

            $err && return($err);

            $method = 'GET';
        
        } while ( ! $err and $res_num == 302 );
    };

    $err = &getPage();
    return $err if ( $err );

    # ֥롼Υͥ(Perlå֥åP368)
    local *login_page = sub
    {
        # FORM
        ($form, %form) = ();
        for ( @res ) {
            $debug and print $_;
            if (/<FORM METHOD=\"?POST\"? ACTION=\"([^\"]+)\">/) {
                $action = $1;
                $form++;
            }
            elsif (/<\/FORM>/) {
                $form = 0;
            }
            elsif ( $form ) {
                if (/<INPUT TYPE=\"?TEXT\"? NAME=\"((?:linux)?ID)\"/) {
                    $form{'id'}{'name'} = $1;
                    $form{'id'}{'value'} = $num;
                }
                elsif (/<INPUT TYPE=\"?TEXT\"? NAME=\"((?:linux)?SubID)\"/) {
                    $form{'subid'}{'name'} = $1;
                    $form{'subid'}{'value'} = $class;
                }
                elsif (/<INPUT TYPE=\"?PASSWORD\"? NAME=\"(password)\"/) {
                    $form{'pass'}{'name'} = $1;
                    $form{'pass'}{'value'} = $pass;
                }
                elsif (/<INPUT TYPE=\"?SUBMIT\"? NAME=\"(command)\" VALUE=\"( *O *K *)\">/) {
                    $form{'submit'}{'name'} = $1;
                    $form{'submit'}{'value'} = $2;
                }
            }
        }

        # FORM󤬤 return 1
        if ( $form{'id'}{'name'}   and $form{'subid'}{'name'} and
             $form{'pass'}{'name'} and $form{'submit'}{'name'}) {
            return 1;
        }
        return 0;
    };

    if ( not &login_page() ) {
      my $aaa = join('', @res);
        return "can't find login page. $aaa";
    }
    $debug and print "  find login page.\n";

    # URL
    $url =~ s/^(.+\/).*$/$1/;
    $url .= $action;

    # Cookie
    $send_cookie = "Cookie:";
    for ( @cookie ) {
        if (/^\s*([^=]+)=([^\;]+)\;\s*(.+)\s*$/) {
            ($name, $value, $param) = ($1, $2, $3);
            # expire ̵ŪʥåCookieΤ
            if ($param =~ /^path=\/\s*$/) {
                $send_cookie .= " $name=$value";
            }
        }
    }
    $send_cookie .= "\r\n";
    $debug and print "  send cookie: $send_cookie";

    # Content-Type: 
    $content_type = "Content-type: application/x-www-form-urlencoded\r\n";
    $debug and print "  content-type: $content_type";

    # form data set 
    for $type ( keys %form ) {
        $form{$type}{'name'} =~ s/([^\w ])/'%' . unpack('H2', $1)/eg;
        $form{$type}{'name'} =~ tr/ /+/;
        $form{$type}{'value'} =~ s/([^\w ])/'%' . unpack('H2', $1)/eg;
        $form{$type}{'value'} =~ tr/ /+/;
    }
    $form_data_set = "$form{'id'}{'name'}=$form{'id'}{'value'}"
               . "\&$form{'subid'}{'name'}=$form{'subid'}{'value'}"
               . "\&$form{'pass'}{'name'}=$form{'pass'}{'value'}"
               . "\&$form{'submit'}{'name'}=$form{'submit'}{'value'}"
               . "\r\n";
    $debug and print "  send_body: $form_data_set";

    # Content-Length: 
    $content_length = length($form_data_set) - 2;
    $content_length = "Content-Length: $content_length\r\n";
    $debug and print "  content-length: $content_length";

    $method = "POST";

    # &getPage();
    $err = &getPage();
    return $err if ( $err );

    # ڡäǧڼ
    if ( &login_page() ) {
        &Log("Authentication failed.");
        return "Authentication failed.";
    }

    for ( @res ) {
        $debug and print $_;
        # ǥ̾
        if (/\<\!\-\- +model\=(N\d+-\d+).+\-\-\>/) {
            #2002.10.7 Nines Honda edit
            push(@model ,$1);
            $debug and print "  find model: $1\n";
        }
        # λ - դΤ
        elsif (/\<\!\-\- +EXPIRE_DATE\=(\d+\/\d+\/\d+) +\-\-\>/) {
            $expire = $1;
            $debug and print "  find expire: $expire\n";
        }
        # λ - +
        elsif (/\<\!\-\- +EXPIRE_DATE\=(\d+\/\d+\/\d+) +\d+\:\d+\:\d+ +\-\-\>/) {
            $expire = $1;
            $debug and print "  find expire: $expire\n";
        }
    }

    #2002.10.7 Nines Honda edit
    if ( !@model or !$expire ) {
        &Log("can't find EXPIRE_DATE and model.");
        return $main::mes_olud_pl_20;
    }
    $debug and print "  get model and expire.";

    # ǥ̾
    #2002.10.7 Nines Honda edit
    for( @model ){
        if ( $_ eq $n_code ) {
            $model_check =1;
        }
    }
    if(!$model_check){
        &Log("Invalid model name.");
        return $main::mes_olud_pl_21;
    }

    $debug and print "  model name OK.";

    $expire =~ s/^\s*//;
    $expire =~ s/\s*$//;
    ($year, $mon, $day) = split /\//, $expire;
    $debug and print "  expire day = $year/$mon/$day\n";
    $day = Round($day,1,31);
    $mon = Round($mon-1,0,11);
    # year 4Ѵ
    if ($year < 0) { $year = 1902; }
    elsif ($year < 70) { $year += 2000; }
    elsif ($year < 100) { $year += 1900; }
    elsif ($year < 1000) { $year += 2000; }
    $year = Round($year,1902,2037);

    use Time::Local 'timelocal';
    # $year-1900  38-51 ǥ顼ˤʤΤǣΤޤϤ
    $expire_time = timelocal(59,59,23,$day,$mon,$year);

    # ڤ
    if ( time > $expire_time ) {
        &Log("over the expire date.");
        return $main::mes_olud_pl_22;
    }
    $debug and print "  expire date OK.";

    # 
    $key = `$oludregist add $num, $class, $pass 2>/dev/null`;
    &Log("Authentication succeeded.");
    $debug and print "  Authentication succeeded.";
    return ('', $key);
}

#
# ̾
#       Log - 
# 
#       $err = &olud::Log($str);
# 
#       $str    ʸ
# 
#       $err    顼åʤ''
#
sub Log
{
    my ($str) = @_;
    my $LOCK_EX = 2; # 񤭹å(֥å⡼)
    my ($logfile, $date) = ();

    $logfname or return '';
    $logfile = "$logdir/$logfname";

    if ( ! -d $logdir ) {
        mkdir($logdir, 0600) or return $main::mes_olud_pl_23;
    }

    if ( -e $logfile ) {
        open(LOG, ">> $logfile") or return $main::mes_olud_pl_05;
    } else {
        open(LOG, "> $logfile") or return $main::mes_olud_pl_05;
    }

    flock(LOG, $LOCK_EX) or return $main::mes_olud_pl_06;

    $date = scalar localtime;

    print LOG "[$date]: $str\n";

    close(LOG) or return $main::mes_olud_pl_07;

    chmod(0600, $logfile);

    return '';
}

#
# ̾
#       setDatFile - ǡեƤѹ
# 
#       $err = &olud::setDatFile($file, $tag, $str);
# 
#       $file   ե̾(եѥ)
#       $tag    ̾
#       $str    ʸ
# 
#       $err    顼åʤ''
#
sub setDatFile
{
    my($file, $tag, $str) = @_;
    my($ret, $lock, @new, $flag, $line);
    my($i, @single, @multi, $exist);

    $lock = basename($file);
    if ( -r $file ) {
        $ret = &main::readFile($file, $lock, *olud::data);
        if ( $ret == 0 ) {
            return $main::mes_olud_pl_11;
        }
    }

    if ( $tag =~ /^\%/ ) {
        # ʣ
        # $tag ưʳɤ߹
        for ( @olud::data ) {
            if ( /^(\%.+)$/ ) {
                $flag = ( $1 eq $tag ) ? 1 : 0;
            }
            elsif ( $flag ) {
                # Ƭ"#"ȶ԰ʳä
                next unless ( /^\s*#/ || /^$/ );
            }
            push(@new, $_);
        }

        # ɲ(¸ߤʤкǸɲ)
        $line = -1;
        for ( @new ) {
            $line++;
            last if ( /^\Q$tag\E$/ );
        }
        $line = $#new if ( $line == -1 );
        splice(@new, $line+1, 0, $str);
    }
    else {
        # ñԤʣԤʬ
        (@single,@multi) = ();
        for ( @olud::data ) {
            last if (/^\s*\%.+/);
            push(@single, $_);
        }
        for $i ( $#single+1 .. $#olud::data ) {
            push(@multi, $olud::data[$i]);
        }
        # ɲ(¸ߤʤкǸɲ)
        $exist = 0;
        for ( @single ) {
            if (/^\Q$tag\E:/) {
                $_ = "$tag: $str\n";
                $exist++;
                last;
            }
        }
        if ( not $exist ) {
            for ($i = $#single; $i >= 0; $i--) {
                last if ($single[$i] =~ /\S/);
            }
            splice(@single, $i+1, 0, "$tag: $str\n");
        }
        @new = (@single,@multi);
    }

    $ret = &main::writeFile($file, $lock, @new);
    if ( $ret == 0 ) {
        return $main::mes_olud_pl_12;
    }
    
    return '';
}

#
# ̾
#       checkDatSum - ǡե1ܤΥåǧ
# 
#       $err = &olud::checkDatSum($file);
# 
#       $file   ǡե̾(եѥ)
# 
#       $err    顼åʤ''
#
sub checkDatSum
{
    my($file) = @_;
    my($err, $lock, $sum, $md5, $newsum, $newmd5) = ();

    my ($disp_file);
    my $debug = 0;

    $file =~ /.*\/(.*)$/;
    $disp_file =$1;

    return '' if ( -s $file == 0 );

    $debug and print "in file = $file\n";
    $lock = &basename($file);
    if (!&main::readFile($file, $lock, *olud::data)) {
        return $main::mes_olud_pl_13;
    }

    # 1ܤΥå
    $sum = shift(@olud::data);
    $debug and print "first line = $sum\n";

    if ( $sum =~ /^([0-9a-f]{32}) +(\d+)\s*$/ ) {
        $md5 = $1;
        $sum = $2;
    }
    else {
        return $main::mes_olud_pl_08;
    }
    $debug and print "md5 = $md5 sum = $sum\n";

    # åΥåǧ
    $newsum = unpack("%32C*", $md5);
    if ( $sum ne $newsum ) {

        &main::writeLog("[ERROR] $disp_file: md5 get error", "olud" , $wbmclogname);
        return $main::mes_olud_pl_09;
    }
    $debug and print "OK\n";

    # ե빹
    if (!&main::writeFile($file, $lock, @olud::data)) {
        &main::writeLog("[ERROR] $disp_file: file write error", "olud" , $wbmclogname);
        return $main::mes_olud_pl_14;
    }
    $debug and print "update file $file\n";

    # եmd5sumå
    $err = check_md5sum($file, $md5);
    if($err){
        &main::writeLog("[ERROR] $disp_file: md5 write error", "olud" , $wbmclogname);
        return $err;
    }

    $debug and print "md5sum OK\n";
    &main::writeLog("$disp_file: md5 OK", "olud" , $wbmclogname);

    return '';
}

#
# ̾
#       print_status - ֥饦ΥơСɽHTML
# 
#       &olud::print_status($str);
# 
#       $str   ʸ
# 
#       ʤ
#
sub print_status
{
    my($str) = @_;
    print "<SCRIPT Language=\"JavaScript\">\n";
    print "<!--\n";
    print "status = \"$str\";\n";
    print "// -->\n";
    print "</SCRIPT>\n";
}

#
# ̾
#        showErrorBody - 顼ɽؿΤ뤿˺ǽ<BODY>ޤ
#                   Ϥ̾ showErrorPage() ȤʤʤäΤȼ˺
#                   <BODY> μϤ롣ȥϡ֥顼ΡפǸꡣ
# 
#        &olud::showErrorBody($msg, $button, $newpage);
# 
#        $msg        å
#        $button     ܥʸ
#        $newpage    ڡ
# 
#        ʤ
#
sub showErrorBody
{
    my($title, $title2, $message, $button, $newpage) = ();
    $title = $main::mes_olud_pl_15;
    $title2 = $main::mes_olud_pl_16;
    $message = $_[0] || $main::mes_olud_pl_17;
    $button = $_[1] || $main::mes_olud_pl_18;
    if ( $_[2] ) {
        $newpage = "location.href='" . $_[2] . "'";
    } else {
        $newpage = "history.back()";
    }
#------------------------------------------------------------
print <<END_OF_DATA;
<H4 ALIGN="center">$title</H4>
<HR>

<CENTER>
 <FORM>
  <TABLE BGCOLOR="#CCCCCC" WIDTH=300 BORDER=1 CELLSPACING=0 CELLPADDING=1>
   <TR BGCOLOR="#000080">
    <TD>
     <FONT COLOR="#FFFFFF">$title2</FONT>
    </TD>
   </TR>
   <TR>
    <TD>
     <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD>
        $message
       </TD>
      </TR>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD ALIGN="center">
        <INPUT TYPE="button" VALUE="$button" onClick="$newpage">
       </TD>
      </TR>
     </TABLE>
    </TD>
   </TR>
  </TABLE>
 </FORM>
</CENTER>

$main::WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------
}

#
# ̾
#        getModelName - ǥ̾(N+ץ)
# 
#        ($err, $n_code, @opt) = &olud::getModelName();
# 
#
# 
#        $err     顼å
#        $n_code  η
#        @opt     ץʤ
#        
sub getModelName
{
    my($file, $lock, $n_code, @opt);

    $file = '/etc/opt/nec/N-code';
    $lock = basename($file);

    if (!main::readFile($file, $lock, *olud::data)) {
        return $main::mes_olud_pl_27;
    }

    for ( @olud::data ) {
        if (/^\s*(N[\d\-]+)/) {
            $n_code = $1;
        }
        elsif (/([\w\-]+)/) {
            push(@opt, $1);
        }
    }

    if ( defined $n_code && $n_code ne '' ) {
        return ('', $n_code, @opt);
    }

    return $main::mes_olud_pl_27;
}

#
# ̾
#        UpdateDatFile - ǡեǿˤ
# 
#        $err = &olud::UpdateDatFile($auth_key);
# 
#        $auth_key  桼ǧڥ
# 
#        $err       顼å
#        
sub UpdateDatFile
{
    my($auth_key) = @_;

    my($err, $i, $file, $name, @tmp);
    my($auth, $uname, $pass);
    my($n_code, @opt, $opt, $url);
    my(@datfile, @n_codeurl, @opturl, %dat);
    my(@modurl, @modfile, %mod, @modkind, $newmod);
    my(@pakurl, @pakfile, %pak, @pakname, $newpak);
    my(@delmod, @modpak);

    my $debug = 0;

    $auth = `$oludregist check $auth_key 2>/dev/null`;
    $uname = `$oludregist uname $auth_key 2>/dev/null`;
    $pass = `$oludregist passwd $auth_key 2>/dev/null`;

    # ¸ե
    system("/bin/rm","-rf",$datdir) && return $main::mes_olud_pl_30;
    system("/bin/rm","-rf",$tmpdir) && return $main::mes_olud_pl_30;

    ($err, $n_code, @opt) = getModelName();
    $err and return $err;

    # ǡե
    for $url ( @daturl ) {
        # dat եURL
        (@n_codeurl, @opturl) = ();
        push(@n_codeurl, "$url${n_code}_online_update.dat");
        for $opt ( @opt ) {
            push(@opturl, "$url${n_code}_${opt}_online_update.dat");
        }

        # 
        (@datfile) = ();
        for ( @n_codeurl, @opturl ) {
            warn "Donwload $_" if $debug;
            ($err, $file) = DownloadFile($_, $uname, $pass);
            if ( $err ) {
                system("/bin/rm","-rf",$tmpdir);
                return $err;
            }
            # åม
            $err = checkDatSum($file);
            if ( $err ) {
                system("/bin/rm","-rf",$tmpdir);
                return $err;
            }
            push(@datfile, $file);
        }

        # ե뤬̵
        unless ( @datfile ) {
            return $main::mes_olud_pl_28;
        }

        # dat եɤ߹
        # ϥåkey˥ե̾ȤäƤΤǥե̾ϥ֤ʤ褦
        for ( @datfile ) {
            $err = readDatFile($_, \%dat);
            if ( $err ) {
                system("/bin/rm","-rf",$tmpdir);
                return $err;
            }
        }

        # mod եURL
        for $name ( keys %dat ) {
            (@modkind, @modurl) = ();
            @tmp = split /\n/, $dat{$name}{'modules'};
            # ": URL" ηʬΥ
            for ( @tmp ) {
                if (/^([^:]+):\s*(.+)\s*$/) {
                    push(@modkind, $1);
                    push(@modurl, $2);
                }
            }
            # relativeURI -> absoluteURI
            for ( @modurl ) {
                if ( relativeURI($_) ) {
                    $_ = "$url$_";
                }
            }
            $dat{$name}{'modkind'} = [ @modkind ];
            $dat{$name}{'modurl'} = [ @modurl ];
        }

        # mod ե
        for $name ( keys %dat ) {
            $i = -1;
            (@modfile, @modkind) = ();
            for ( @{ $dat{$name}{'modurl'} } ) {
                $i++;
                warn "Donwload $_" if $debug;
                ($err, $file) = DownloadFile($_, $uname, $pass);
                if ( $err ) {
                    system("/bin/rm","-rf",$tmpdir);
                    return $err;
                }
                # åม
                $err = checkDatSum($file);
                if ( $err ) {
                    system("/bin/rm","-rf",$tmpdir);
                    return $err;
                }
                push(@modfile, $file);
                push(@modkind, $dat{$name}{'modkind'}[$i]);
            }
            $dat{$name}{'modfile'} = [ @modfile ];
            $dat{$name}{'modkind'} = [ @modkind ];
        }

        # dat եѴ
        for $name ( keys %dat ) {
            $newmod = '';
            for $i ( 0 .. $#{ $dat{$name}{'modfile'} } ) {
                $file = basename($dat{$name}{'modfile'}[$i]);
                $newmod .= "$dat{$name}{'modkind'}[$i]: $file\n";
            }
            $err = setDatFile("$tmpdir/$name", '%modules', $newmod);
            if ( $err ) {
                system("/bin/rm","-rf",$tmpdir);
                return $err;
            }
        }

        # mod եɤ߹
        for $name ( keys %dat ) {
            for ( @{ $dat{$name}{'modfile'} } ) {
                $err = readDatFile($_, \%mod);
                if ( $err ) {
                    system("/bin/rm","-rf",$tmpdir);
                    return $err;
                }
            }
        }

        # pak եURL
        for $name ( keys %mod ) {
            (@pakname, @pakurl) = ();
            @tmp = split /\n/, $mod{$name}{'packages'};
            # "ѥå̾: URL" ηʤΤ URLФ
            for ( @tmp ) {
                if (/^([^:]+):\s*(.+)\s*$/) {
                    push(@pakname, $1);
                    push(@pakurl, $2);
                }
            }
            # relativeURI -> absoluteURI
            for ( @pakurl ) {
                if ( relativeURI($_) ) {
                    $_ = "$url$_";
                }
            }
            $mod{$name}{'pakname'} = [ @pakname ];
            $mod{$name}{'pakurl'} = [ @pakurl ];
        }

        # pak ե
        for $name ( keys %mod ) {
            (@pakfile) = ();
            for ( @{ $mod{$name}{'pakurl'} } ) {
                warn "Donwload $_" if $debug;
                ($err, $file) = DownloadFile($_, $uname, $pass);
                if ( $err ) {
                    system("/bin/rm","-rf",$tmpdir);
                    return $err;
                }
                # åม
                $err = checkDatSum($file);
                if ( $err ) {
                    system("/bin/rm","-rf",$tmpdir);
                    return $err;
                }
                push(@pakfile, $file);
            }
            $mod{$name}{'pakfile'} = [ @pakfile ];
        }

        # mod եѴ
        for $name ( keys %mod ) {
            $newpak = '';
            for $i ( 0 .. $#{ $mod{$name}{'pakfile'} } ) {
                $file = basename($mod{$name}{'pakfile'}[$i]);
                $newpak .= "$mod{$name}{'pakname'}[$i]: $file\n";
            }
            $err = setDatFile("$tmpdir/$name", '%packages', $newpak);
            if ( $err ) {
                system("/bin/rm","-rf",$tmpdir);
                return $err;
            }
        }

        # pak եɤ߹
        for $name ( keys %mod ) {
            for ( @{ $mod{$name}{'pakfile'} } ) {
                $err = readDatFile($_, \%pak);
                if ( $err ) {
                    system("/bin/rm","-rf",$tmpdir);
                    return $err;
                }
            }
        }

        my($sum, @file, $fname);
        # QueryFileExec: 
        for $name ( keys %pak ) {
            if ( $pak{$name}{'QueryFileExec'} ) {
                $url = $pak{$name}{'QueryFileExec'};
                if ( absoluteURI($url) ) {
                    warn "Donwload $url" if $debug;
                    ($err,$file) = DownloadFile($url, $uname, $pass);
                    if ( $err ) {
                        system("/bin/rm","-rf",$tmpdir);
                        return $err;
                    }
                    # åม
                    if ( $pak{$name}{'QueryFileSum'} ) {
                        $sum = $pak{$name}{'QueryFileSum'};
                        $err = check_md5sum($file, $sum);
                        if ( $err ) {
                            system("/bin/rm","-rf",$tmpdir);
                            return $err;
                        }
                        ($err,@file) = ExtractFile($file);
                        if ( $err ) {
                            system("/bin/rm","-rf",$tmpdir);
                            return $err;
                        }
                        $fname = $file[0];
                        unlink($file);
                    }
                    else {
                        $err = checkDatSum($file);
                        if ( $err ) {
                            system("/bin/rm","-rf",$tmpdir);
                            return $err;
                        }
                        # ¹Բǽ
                        unless (chmod(0755, $file)) {
                            system("/bin/rm","-rf",$tmpdir);
                            return $main::mes_olud_pl_31;
                        }
                        $fname = basename($url);
                    }
                    # pak  URL
                    $err = setDatFile("$tmpdir/$name", 'QueryFileExec', $fname);
                    if ( $err ) {
                        system("/bin/rm","-rf",$tmpdir);
                        return $err;
                    }
                    # ߤѿͤѹ
                    $pak{$name}{'QueryFileExec'} = $fname;
                }
                else {
                    system("/bin/rm","-rf",$tmpdir);
                    return $main::mes_olud_pl_32;
                }
            }
        }
    }

    # ǧڤƤʤͭ⥸塼
    if ( !$auth ) {
        # dat ե뽤(ContractԺ)
        @delmod = ();
        for $name ( keys %dat ) {
            $newmod = '';
            for $i ( 0 .. $#{ $dat{$name}{'modfile'} } ) {
                if ( $dat{$name}{'modkind'}[$i] eq 'Contract' ) {
                    push(@delmod, $dat{$name}{'modfile'}[$i]);
                }
                else {
                    $file = basename($dat{$name}{'modfile'}[$i]);
                    $newmod .= "$dat{$name}{'modkind'}[$i]: $file\n";
                }
            }
            $err = setDatFile("$tmpdir/$name", '%modules', $newmod);
            if ( $err ) {
                system("/bin/rm","-rf",$tmpdir);
                return $err;
            }
        }

        # mod ե
        for ( @delmod ) {
            if ( $debug ) { warn "unlink $_"; }
            unlink;
        }

        # pak ե븡
        @modpak = ();
        for $name ( keys %mod ) {
            for $file ( @delmod ) {
                # keyϥե̾ˤʤäƤ
                if ( $name eq basename($file) ) {
                    for ( @{ $mod{$name}{'pakfile'} } ) {
                        push(@modpak, $_);
                    }
                }
            }
        }
        for $file ( @modpak ) {
            #$err = readDatFile($file, \%pak);
            #if ( $err ) {
            #    system("/bin/rm","-rf",$tmpdir);
            #    return $err;
            #}
            $name = basename($file);
            $newpak = "Name: $pak{$name}{'Name'}\n"
                    . "Version: $pak{$name}{'Version'}\n"
                    . "File: " . basename($pak{$name}{'File'}) . "\n";
            if ( $pak{$name}{'QueryFileExist'} ) {
                $newpak .= "QueryFileExist: $pak{$name}{'QueryFileExist'}\n";
            }
            if ( $pak{$name}{'QueryFileExec'} ) {
                $newpak .= "QueryFileExec: "
                        . basename($pak{$name}{'QueryFileExec'}) . "\n";
            }
            if ( $pak{$name}{'Old'} ) {
                $newpak .= "Old: $pak{$name}{'Old'}\n";
            }
            if (!&main::writeFile($file, basename($file), $newpak)) {
                return $main::mes_olud_pl_12;
            }
            warn "write $file" if $debug;
        }
    }

    system("/bin/mv","-f",$tmpdir,$datdir) && return $main::mes_olud_pl_29;

    return '';
}

#
# ̾
#        Round - ꤷͤϰϤ˴ݤ
# 
#        $num = &olud::Round($num, $min, $max);
# 
#        $num  ݤо
#        $min  Ǿ(ά undef)
#        $max  (ά undef)
# 
#        $num  ݤ()
#        
sub Round
{
    my($num, $min, $max) = @_;

    return undef if (not defined $num);
    $num = int $num;

    $min = int $min if (defined $min);
    $max = int $max if (defined $max);

    $num = $min if (defined $min and $num < $min);
    $num = $max if (defined $max and $num > $max);

    return $num;
}

#
# ̾
#        absoluteURI - URIɤȽ
# 
#        $ret = &olud::absoluteURI($uri);
# 
#        $uri  URI
# 
#        1  URIǤ
#        0  URIǤϤʤ
#        
sub absoluteURI
{
    my($uri) = @_;
    my(@scheme);

    # Scheme list. From `$ man uri'.
    @scheme = qw(
        http:// https:// ftp:// gopher:// mailto: news:
        telnet:// file: man: info: whatis: ghelp: ldap:// wais://
    );

    for ( @scheme ) {
        return 1 if ( $uri =~ /^\Q$_\E/i );
    }

    return 0;
}

#
# ̾
#        relativeURI - URIɤȽ
# 
#        $ret = &olud::relativeURI($uri);
# 
#        $uri  URI
# 
#        1  URIǤ
#        0  URIǤϤʤ
#        
sub relativeURI
{
    return ( (absoluteURI($_[0])) ? 0 : 1 );
}

#
# ̾
#        ExecQueryFile - ŬѾȽե¹Ԥ̤֤
# 
#        ($err,$status) = &olud::ExecQueryFile($file);
# 
#        $file    ¹Բǽե
# 
#        $err     顼å
#        $status  ŬѺ 1 ̤Ŭ 0
#        
sub ExecQueryFile
{
    my($file) = @_;
    my($ret);

    return $main::mes_olud_pl_33 if ($file !~ /^\//);

    chmod(0755, $file) if (! -x $file);
    return $main::mes_olud_pl_33 if (! -x $file);

    $ret = `$file`;

    return ('', 1) if $ret;
    return ('', 0);
}

#
# ̾
#        check_md5sum - md5sum ޥɤǥե򸡺
# 
#        $err = &olud::check_md5sum($file, $sum);
# 
#        $file    եեѥ
#        $sum     å
# 
#        $err     顼å(ʤ'')
#        
sub check_md5sum
{
    my($file, $sum) = @_;
    my($out, $out_sum);

    my $md5sum = "/usr/bin/md5sum";

    $out = `$md5sum $file 2>&1`;
    if ($out =~ /^([0-9a-f]{32}) +$file\r?\n$/) {
        $out_sum = $1;
    }
    else {
        return $main::mes_olud_pl_10;
    }

    if ($sum ne $out_sum) {
        return $main::mes_olud_pl_09;
    }

    return '';
}

#
# ̾
#        ExtractFile - եह
# 
#        ($err, @file) = &olud::ExtractFile($file);
# 
#        $file    ̥ե
# 
#        $err     顼å(ʤ'')
#        @file    ե
#        
sub ExtractFile
{
    my($file) = @_;
    my($dir, @file);

    $dir = $file;
    return $main::mes_olud_pl_02 if ($file !~ /^\//);
    $dir =~ s/^(.*\/).*$/$1/;

    system("/bin/mkdir","-p",$dir) if (!-e $dir);
    chdir($dir) or return $main::mes_olud_pl_02;

    if ($file =~ /\.tar\.gz$/ or $file =~ /\.tgz$/) {
        open(CMD, "/bin/tar xzvf $file 2>&1 |") or return $main::mes_olud_pl_34;
        @file = <CMD>;
        close(CMD) or return $main::mes_olud_pl_34;
        return $main::mes_olud_pl_34 unless (scalar @file);
        for (@file) {
            chomp;
            return $main::mes_olud_pl_34 if (!-e "$dir/$_");
        }
        return ('', @file);
    }

    return $main::mes_olud_pl_34;
}

1;

