#!/usr/bin/perl
# Copyright (C) 2001 NEC Corporation
# All Rights Reserved.

# RCS: $Id: pkg_list.cgi,v 1.3 2003/04/24 03:58:57 snavi Exp $

##### 2001.01.31 BossSystem Tsuno
require "/opt/nec/wbmc/language.pl";
if($mes_language eq "Japanese"){
    require "./lang_j.pl";          # ܸå
} else {
    require "./lang_e.pl";          # Ѹå
}
my $mes_work_string = "";
##### 2001.01.31 BossSystem Tsuno

#------------------------------------------------------------
require "/opt/nec/wbmc/lib/wbmc.pl";
require "olud.pl";
#------------------------------------------------------------

# use strict;

my($i, $j, $k, $err, $name, $file, @tmp);
my($update, $auth_key);
my(%dat, $datdir, @datfile);
my(%mod, @modkind, @modfile);
my(%allpak, @pakname, @pakfile);
my($lastdate, $mtime);
my($status, @status, $pakname, $pakfile, $installed);
my($rowspan, $date, $descript, $detail, $body, $form);
my(@mypackages, $exist_module);
my(@stat_str, @installed_pak, @old_pak);
my($exist_new_pak);
my(@sort_mod, %mod_date, $year, $month, $day);
my($queryfile);

$update = $ARGV[0];
$auth_key = $ARGV[1];
$proxy_flag = 0;

&readParam();
$proxy_addr = $FORM{'PROXY_ADDR'};
$proxy_port = $FORM{'PROXY_PORT'};
$proxy_flag = $FORM{'PROXY_FLAG'};
if( $update eq 'update' && $proxy_flag == 1) {
  my $err = &olud::writeProxyConfFile($proxy_addr, $proxy_port);
  if($err) {
    &showErrorPage('proxy եι˼Ԥޤ');
    exit(1);
  }
}

# ǡեǼǥ쥯ȥ
$datdir = &olud::datdir();
if ( !defined $datdir or $datdir eq '' ) {
    &showErrorPage($mes_pkg_list_01);
    exit(1);
}

# update ե饰̵ĥꥸե뤬̵Х桼ǧ
@datfile;
if ( $update ne 'update' ) {
    @datfile = glob("$datdir/*.dat");
    unless ( @datfile ) {
        &showPage("auth.cgi");
        exit(0);
    }
}

# STDOUTեå
my $old = select(STDOUT);
$| = 1;
select($old);

# <BODY> ޤǽ
#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$mes_pkg_list_10</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function func_install(num) {
    if (window.confirm("$mes_pkg_list_11")) {
        document.forms[num].submit();
    }
    return(false);
}
// -->
</SCRIPT>
</HEAD>
<BODY>
END_OF_DATA
#------------------------------------------------------------
# for MSIE
print "<!--" . "-" x 1024 . "-->\n";

# ǿե
# dat ե뤬̵ȥ顼åץǡȥ⥸塼뤬¸ߤʤƤ dat ֤Ƥ
if ( $update eq 'update' ) {
    $err = &olud::UpdateDatFile($auth_key);
    if ( $err ) {
        &olud::showErrorBody($err, $mes_pkg_list_20, "auth.cgi");
        exit(1);
    }
    @datfile = glob("$datdir/*.dat");
    unless ( @datfile ) {
        &olud::showErrorBody($mes_pkg_list_02, $mes_pkg_list_20, "auth.cgi");
        exit(1);
   }
}

# dat եɤ߹
# ϥåkey˥ե̾ȤäƤΤǥե̾ϥ֤ʤ褦
for ( @datfile ) {
    $err = &olud::readDatFile($_, \%dat);
    if ( $err ) {
        &olud::showErrorBody($err, $mes_pkg_list_20, "auth.cgi");
        exit(1);
    }
}

# ǽռ
$lastdate = $mes_pkg_list_23;
if ( -f $datfile[0] ) {
    $mtime = (stat $datfile[0])[9];
    ($day, $month, $year) = (localtime($mtime))[3,4,5];
    $lastdate = sprintf("%04d/%02d/%02d", $year+1900, $month+1, $day);
}

# mod ե̾
$exist_module = 0;
for $name ( keys %dat ) {
    (@modkind, @modfile) = ();
    @tmp = split /\n/, $dat{$name}{'modules'};
    # ": ե̾" ηʬΥ
    for ( @tmp ) {
        if (/^([^:]+):\s*(.+)\s*$/) {
            push(@modkind, $1);
            push(@modfile, $2);
        }
    }
    $dat{$name}{'modkind'} = [ @modkind ];
    $dat{$name}{'modfile'} = [ @modfile ];
    $exist_module += scalar @modfile;
}

# mod եɤ߹
# ϥåkey˥ե̾ȤäƤΤǥե̾ϥ֤ʤ褦
for $name ( keys %dat ) {
    for $file ( @{ $dat{$name}{'modfile'} } ) {
        if ( $file !~ /^\// ) {
            $file = "$datdir/$file";
        }
        # ¸ߥå
        if ( !-s $file || !-r $file ) {
            &olud::showErrorBody($mes_pkg_list_03, $mes_pkg_list_20, "auth.cgi");
            exit(1);
        }
        $err = &olud::readDatFile($file, \%mod);
        if ( $err ) {
            &olud::showErrorBody($err, $mes_pkg_list_20, "auth.cgi");
            exit(1);
        }
    }
}

# pak ե̾
for $name ( keys %mod ) {
    (@pakname, @pakfile) = ();
    @tmp = split /\n/, $mod{$name}{'packages'};
    # "ѥå̾: ե̾" ηʬΥ
    for ( @tmp ) {
        if (/^([^:]+):\s*(.+)\s*$/) {
            push(@pakname, $1);
            push(@pakfile, $2);
        }
    }
    $mod{$name}{'pakname'} = [ @pakname ];
    $mod{$name}{'pakfile'} = [ @pakfile ];
}

# pak ե¸ߥå
for $name ( keys %mod ) {
    for $file ( @{ $mod{$name}{'pakfile'} } ) {
        if ( $file !~ /^\// ) {
            $file = "$datdir/$file";
        }
        if ( !-s $file || !-r $file ) {
            &olud::showErrorBody($mes_pkg_list_22, $mes_pkg_list_20, "auth.cgi");
            exit(1);
        }
    }
}

# 󥹥ȡѤѥå
@mypackages = split /\n/, `/bin/rpm -qa`;
unless ( @mypackages ) {
    &olud::showErrorBody($mes_pkg_list_04);
    exit(1);
}

# pak եɤ߹
for ( glob("$datdir/*.pak") ) {
    $err = &olud::readDatFile($_, \%allpak);
    if ( $err ) {
        &olud::showErrorBody($err, $mes_pkg_list_20, "auth.cgi");
        exit(1);
    }
}

# ⥸塼ŬѾָ
for $name ( keys %allpak ) {
    $installed = 0;
    $pakname = $allpak{$name}{'Name'};
    $pakname .= "-$allpak{$name}{'Version'}" if ( $allpak{$name}{'Version'} );
    # rpm -q Ƚ
    if ( $allpak{$name}{'File'} =~ /\.rpm$/ ) {
        for ( @mypackages ) {
            chomp;
            if ( $pakname eq $_ ) {
                $installed++;
                last;
            }
        }
    }
    # QueryFileXXXX:
    if ( $allpak{$name}{'QueryFileExist'} ) {
        $queryfile = $allpak{$name}{'QueryFileExist'};
        if ( $queryfile =~ /^\// ) {
            $installed = (-e $queryfile) ? 1 : 0;
        }
    }
    if ( $allpak{$name}{'QueryFileExec'} ) {
        $queryfile = $allpak{$name}{'QueryFileExec'};
        $queryfile = "$datdir/$queryfile" if ($queryfile !~ /^\//);
        ($err,$installed) = olud::ExecQueryFile($queryfile);
        if ( $err ) {
            &olud::showErrorBody($err, $mes_pkg_list_20, "auth.cgi");
            exit(1);
        }
    }
    if ( $installed ) {
        push(@installed_pak, $pakname);
        # Old: ŬѺѤ
        push(@old_pak, split(/\s*,\s*/, $allpak{$name}{'Old'}));
    }
}

# ɽ⥸塼ŬѾָ
for $name ( keys %mod ) {
    (@status) = ();
    for ( @{ $mod{$name}{'pakfile'} } ) {
        $installed = 0;
        $pakfile = olud::basename($_);
        $pakname = $allpak{$pakfile}{'Name'}; # ե̾ key
        $pakname .= "-$allpak{$pakfile}{'Version'}" if ($allpak{$pakfile}{'Version'});
        for ( @installed_pak ) {
            if ( $pakname eq $_ ) {
                $installed++;
                last;
            }
        }
        $old = 0;
        for ( @old_pak ) {
            if ( $pakname eq $_ ) {
                $old++;
                last;
            }
        }
        # ŬѺ=1, Ť=2, ̤Ŭ=0, ¾=3
        if ( $installed ) {
            push(@status, 1);
        }
        elsif ( $old ) {
            push(@status, 2);
        }
        elsif ($allpak{$pakfile}{'File'} =~ /\.rpm$/) {
            push(@status, 0);
        }
        elsif ($allpak{$pakfile}{'QueryFileExist'} or
               $allpak{$pakfile}{'QueryFileExec'}) {
            push(@status, 0);
        }
        else {
            push(@status, 3);
        }
    }
    $mod{$name}{'pakstat'} = [ @status ];
}

# ŬѾ֤ɽʸ(̤ѡ졦̵)
$stat_str[0] = $mes_pkg_list_05;
$stat_str[1] = $mes_pkg_list_06;
$stat_str[2] = $mes_pkg_list_25;
$stat_str[3] = $mes_pkg_list_27;

# ս˥
#use Time::Local 'timelocal_nocheck';
use Time::Local;
for $name ( keys %mod ) {
    ($year, $month, $day) = split /\//, $mod{$name}{'Date'};
    $day = &olud::Round($day,1,31);
    if(!$day || $day < 1) {
      $day = 1;
    }
    $month = &olud::Round($month-1,0,11);
    if(!$month || $month < 0) {
      $month = 0;
    }
    # ǤʤǰΤб
    if ($year < 0) { $year = 1902; }
    elsif ($year < 70) { $year += 2000; } 
    elsif ($year < 100) { $year += 1900; } 
    elsif ($year < 1000) { $year += 2000; } 
    $year = &olud::Round($year,1902,2037);
    # $year-1900  38-51 ǥ顼ˤʤΤǣΤޤϤ
#    $mod_date{$name} = timelocal_nocheck(0,0,0,$day,$month,$year);
    $mod_date{$name} = timelocal(0,0,0,$day,$month,$year);
}
# ϥå key  value οͽǥ()
@sort_mod = sort { $mod_date{$a} <=> $mod_date{$b} } (keys %mod_date);

# ʤơ֥
$j = 0;
for $name ( @sort_mod ) {
    $k = 0;

    # ""äɽʤ
    $exist_new_pak = 0;
    $status = 0;
    for ( @{ $mod{$name}{'pakstat'} } ) {
        $exist_new_pak = 1 if ( $_ == 0 );
        $status += $_;
    }
    next if ( !$exist_new_pak && $status == scalar @{ $mod{$name}{'pakstat'} } );
    # "", "-"ɽʤ
    next if ( !$exist_new_pak && $status > scalar @{ $mod{$name}{'pakstat'} } );

    # ơ֥
    $rowspan = @{ $mod{$name}{'pakfile'} };
    $date = &encodeHtml($mod{$name}{'Date'});
    $descript = &encodeHtml($mod{$name}{'description'});
    if ( $mod{$name}{'detail'} ) {
        $descript .= " <A HREF=\"mod_detail.cgi?".&encodeUrl($name)."\">[$mes_pkg_list_26]</A>";
    }
    $pakname = $mod{$name}{'pakname'}[0];
    $status = $stat_str[ $mod{$name}{'pakstat'}[0] ];
    $pakfile = $mod{$name}{'pakfile'}[0];
    $pakfile = &olud::basename($pakfile);

    $body .="<TR>\n"
          . "<TD ROWSPAN=$rowspan>$date</TD>\n"
          . "<TD ROWSPAN=$rowspan>$descript</TD>\n"
          . "<TD NOWRAP><A HREF=\"pkg_detail.cgi?".&encodeUrl($pakfile)."\">$pakname</A></TD>\n"
          . "<TD>$status</TD>\n"
          . "<TD ROWSPAN=$rowspan><FORM><INPUT TYPE =\"button\" NAME=\"INSTALL\" VALUE=\"$mes_pkg_list_07\" onClick=\"return func_install($j)\"></FORM></TD>\n"
          . "</TR>\n";

    # confirm.cgi ϤFORM
    $form .="<FORM NAME=\"MOD${j}\" METHOD=\"POST\" ACTION=\"confirm.cgi\">\n";
    $form .="<INPUT TYPE=\"hidden\" NAME=\"MODNAME\" VALUE=\"$name\">\n";
    if ($mod{$name}{'pakstat'}[0] == 0 or
        $mod{$name}{'pakstat'}[0] == 3 ) {
        $form .= "<INPUT TYPE=\"hidden\" NAME=\"PAKFILE${k}\" VALUE=\"$pakfile\">\n";
        $k++;
    }

    if ( $rowspan >= 2 ) {
        for $i ( 1 .. ($rowspan - 1) ) {
            $pakname = $mod{$name}{'pakname'}[$i];
            $status = $stat_str[ $mod{$name}{'pakstat'}[$i] ];
            $pakfile = $mod{$name}{'pakfile'}[$i];
            $pakfile = &olud::basename($pakfile);

            $body .="<TR>\n"
                  . "<TD NOWRAP><A HREF=\"pkg_detail.cgi?".&encodeUrl($pakfile)."\">$pakname</A></TD>\n"
                  . "<TD>$status</TD>\n"
                  . "</TR>\n";

            if ($mod{$name}{'pakstat'}[$i] == 0 or
                $mod{$name}{'pakstat'}[$i] == 3 ) {
                $form .= "<INPUT TYPE=\"hidden\" NAME=\"PAKFILE${k}\" VALUE=\"$pakfile\">\n";
                $k++;
            }
        }
    }

    $form .= "</FORM>\n";

    $j++;
}

# ɽ⥸塼̵
unless ( $body ) {
    if ( $exist_module ) {
        $body = "<TR><TD COLSPAN=5>$mes_pkg_list_21</TD></TR>";
    }
    else {
        $body = "<TR><TD COLSPAN=5>$mes_pkg_list_24</TD></TR>";
    }
}

# ʥӥСκ
#------------------------------------------------------------
my $navibar = &getNavigation(
    $mes_pkg_list_08, "package.cgi",
    $mes_pkg_list_09, "",
    "_back", "package.cgi",
    "_help", "pkg_list_help.cgi",
);

#------------------------------------------------------------
print <<END_OF_DATA;
<H4 ALIGN="center">$mes_pkg_list_10</H4>
<HR>
$navibar
<HR>

$form

<CENTER>
  <BR>
  $mes_pkg_list_12 $lastdate
  <BR>
   <FORM><INPUT TYPE="button" NAME="DAT_UPDATE" VALUE="$mes_pkg_list_13" onClick="location.href='auth.cgi'"></FORM>
  <BR>
  <TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1>
   <TR BGCOLOR="#000080">
    <TD><FONT COLOR="#FFFFFF">$mes_pkg_list_14</FONT></TD>
   </TR>
   <TR>
    <TH>
     <TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1>
      <TR>
       <TH>$mes_pkg_list_15</TH>
       <TH>$mes_pkg_list_16</TH>
       <TH>$mes_pkg_list_17</TH>
       <TH>$mes_pkg_list_18</TH>
       <TH>$mes_pkg_list_19</TH>
      </TR>
$body
     </TABLE>
    </TH>
   </TR>
  </TABLE>
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------

