#!/usr/bin/perl

# Copyright (C) 2002 NEC Corporation
# All Rights Reserved.

# RCS: $Id: aftalb_set.cgi,v 1.6 2002/10/11 12:38:46 snavi Exp $

require "../../../lib/wbmc.pl";
require "./aftalb.pl";

$virtual_adapter = "vad";
$virtual_adapter_file = "/etc/sysconfig/network-scripts/ifcfg-$virtual_adapter";
$virtual_adapter_lock = "ifcfg-$virtual_adapter";
$init_cmd = "/opt/nec/wbmc/adm/system/aftalb/ians/aft_alb_init_mw03.sh";
$aftalb_file = "/etc/opt/nec/aft_alb";
$network_file = "/etc/sysconfig/network-scripts/ifcfg-eth0";
$network_lock = "ifcfg-eth0";
$ians_conf_file = "/etc/ians/ians.conf";
$ians_conf_lock = "ians.conf";

$normal_mode = "NORMAL";
$aft_mode = "AFT";
$alb_mode = "ALB";

$ipaddr = "";
$netmsk = "";
$netaddr = "";
$bcastaddr = "";
$cmd_mode = "";
$result = "";
$init_result = "";
@ianslist = "";
@ent = "";

&readParam();

$mode = $FORM{'MODE'};
$current_mode = $FORM{'CURRENT_MODE'};
$init = $FORM{'INIT'};

# ⡼ɥå
if ($mode eq $current_mode) {
    &showErrorPage("⡼ѹƤޤ", "./aftalb.cgi");
    exit(1);
}

# ⡼ѹ
if ($init eq "YES") {
    if (-e $virtual_adapter_file) {
        &showErrorPage("⡼ɤ礬ȯƤޤ", "./aftalb.cgi");
        exit(1);
    }

    # ͥåȥ
    if (!&readFile($network_file, $network_lock, *line)) {
        &showErrorPage("ե($network_file)ɤ߹ߤ˼Ԥޤ", "./aftalb.cgi");
        exit(1);
    } else {
        for(@line) {
            s/\s*$//;
            if (/^IPADDR\s*=\s*(.*)\s*/) {
                $ipaddr = $1;
            } elsif (/^NETMASK\s*=\s*(.*)\s*/) {
                $netmsk = $1;
            } elsif (/^NETWORK\s*=\s*(.*)\s*/) {
                $netaddr = $1;
            } elsif (/^BROADCAST\s*=\s*(.*)\s*/) {
                $bcastaddr = $1;
            }
        }
    }

    # ץȼ¹
    $init_result = system ("$init_cmd $ipaddr $netmsk $netaddr $bcastaddr $mode &> /dev/null");
    system ("echo $mode > $aftalb_file");

    # ͥåȥץѹ
    if (!&chg_onboot($mode, $virtual_adapter)) {
        &showErrorPage("ͥåȥץѹ˼Ԥޤ", "./aftalb.cgi");
        exit(1);
    }

    # ƥƵư 
    exec ("./reboot.cgi");

# ܰʹߤΥ⡼ѹ
} else {
    if (! -e $virtual_adapter_file) {
        &showErrorPage("⡼ɤ礬ȯƤޤ", "./aftalb.cgi");
        exit(1);
    }

    # NORMAL -> AFT/ALB⡼ɤؤѹ
    if ($current_mode eq $normal_mode) {

        # ͥåȥѤ
        system ("/bin/cp -f $virtual_adapter_file $virtual_adapter_file.old");
        system ("/bin/cp -f $network_file $virtual_adapter_file");

        if (!&readFile($virtual_adapter_file, $virtual_adapter_lock, *virtual_line)) {
            &showErrorPage("$virtual_adapter_fileեɤ߹ߤ˼Ԥޤ", "./aftalb.cgi");
            exit(1);
        }
        foreach (@virtual_line) {
            if (/^DEVICE=/) {
                s/^DEVICE=.+/DEVICE=$virtual_adapter/;
            }
            push (@virtual_tmp, $_);
        }
        if (!&writeFile($virtual_adapter_file, $virtual_adapter_lock, @virtual_tmp)) {
            &showErrorPage("$virtual_adapter_fileν񤭹ߤ˼Ԥޤ","./aftalb.cgi");
            system("/bin/mv -f $virtual_adapter_file.old $virtual_adapter_file");
            exit(1);
        }

        # ͥåȥץѹ
        if (!&chg_onboot($mode, $virtual_adapter)) {
            &showErrorPage("ͥåȥץѹ˼Ԥޤ", "./aftalb.cgi");
            exit(1);
        }

        # iansե빹
        if (!&readFile($ians_conf_file, $ians_conf_lock, *ians_line)) {
            &showErrorPage("ե($ians_conf_file)ɤ߹ߤ˼Ԥޤ", "./aftalb.cgi");
            exit(1);
        } else {
            for(@ians_line) {
                $org = $_;
                s/\s*$//;
                if (/^\s*TEAMING_MODE\s+/) {
                    push (@ianslist, "        TEAMING_MODE\t$mode\n");
                } else {
                    push (@ianslist, $org);
                }
            }
        }

        # ե
        $result = &preserve_file($ians_conf_file);
        if ($result != 1) {
            &showErrorPage("$ians_conf_file ˼Ԥޤ","./aftalb.cgi");
            exit(1);
        }

        # եؤν񤭹
        if (!&writeFile($ians_conf_file, $ians_conf_lock, @ianslist)) {
            &showErrorPage("$ians_conf_fileν񤭹ߤ˼Ԥޤ","./aftalb.cgi");
            system("/bin/mv -f $ians_conf_file.old $ians_conf_file");
            exit(1);
        }

        # AFT/ALB⡼ɥե빹
        system ("echo $mode > $aftalb_file");

        # ansǡư
        system ("/sbin/chkconfig ans on");

        # ƥƵư 
        exec ("./reboot.cgi");

    # AFT/ALB⡼ -> NORMALؤѹ
    } elsif (($current_mode eq $aft_mode or $current_mode eq $alb_mode) and $mode eq $normal_mode) {
         
        # ͥåȥץѹ
        if (!&chg_onboot($mode, $virtual_adapter)) {
            &showErrorPage("ͥåȥץѹ˼Ԥޤ", "./aftalb.cgi");
            exit(1);
        }

        # AFT/ALB⡼ɥե빹
        system ("echo $mode > $aftalb_file");

        # ansǡư
        system ("/sbin/chkconfig ans off");

        # ƥƵư 
        exec ("./reboot.cgi");

    # AFT⡼ -> ALB⡼ɤؤѹޤϡALB⡼ -> AFT⡼ɤؤѹ
    } elsif (($current_mode eq $aft_mode or $current_mode eq $alb_mode) and ($mode eq $aft_mode or $mode eq $alb_mode)) {
        open (IN, "/usr/sbin/ianscfg -s |");
        while (<IN>) {
            s/\s*$//;
            s/^\s*//;
            s/\s*$//;
            @ent = split(/\s+/);
            if ($ent[0] eq "Teaming" and $ent[1] eq "Mode") {
                $cmd_mode = $ent[2];
                last;
            }
        }
        close(IN);

        # ⡼ɥå
        if ($current_mode ne $cmd_mode) {
            &showErrorPage("⡼ɤ礬ȯƤޤ", "./aftalb.cgi");
            exit(1);
        }
            
        # iansե빹
        if (!&readFile($ians_conf_file, $ians_conf_lock, *ians_line)) {
            &showErrorPage("ե($ians_conf_file)ɤ߹ߤ˼Ԥޤ", "./aftalb.cgi");
            exit(1);
        } else {
            for(@ians_line) {
                $org = $_;
                s/\s*$//;
                if (/^\s*TEAMING_MODE\s+/) {
                    push (@ianslist, "        TEAMING_MODE\t$mode\n");
                } else {
                    push (@ianslist, $org);
                }
            }
        }

        # ե
        $result = &preserve_file($ians_conf_file);
        if ($result != 1) {
            &showErrorPage("$ians_conf_file ˼Ԥޤ","./aftalb.cgi");
            exit(1);
        }

        # եؤν񤭹
        if (!&writeFile($ians_conf_file, $ians_conf_lock, @ianslist)) {
            &showErrorPage("$ians_conf_fileν񤭹ߤ˼Ԥޤ","./aftalb.cgi");
            system("/bin/mv -f $ians_conf_file.old $ians_conf_file");
            exit(1);
        }

        # AFT/ALB⡼ɥե빹
        system ("echo $mode > $aftalb_file");

        # ansǡƵư (ƥκƵư)
        system ("/etc/rc.d/init.d/ans restart &> /dev/null");

        &showResultPage("ޤ", "aftalb.cgi");
    } else {
        &showErrorPage("⡼ɤѹ˼Ԥޤ", "./aftalb.cgi");
        exit(1);
    }

}


