#!/usr/bin/perl

# Copyright (C) 2000-2005 NEC Corporation
# All Rights Reserved.

# RCS: $Id: showarchive2.cgi,v 1.7 2005/09/26 11:59:36 snavi Exp $

##20030325 v5.1.0 ॢбɲ oyama
##20040224 v5.1.1 Samba Unmountб(Samba꤬Ĥ) Ishiyama
##20050926 v5.1.2 ॢץ fork Ի samba umount ɲ oyama

use POSIX;

require "../../../lib/wbmc.pl";
require join ("/", $WBMC_ADM_DIR,"system/backup/date.pl");
&readParam();

#Ǥ
#$backup_conf = "$WBMC_CONF_DIR/backup.conf";
#$backup_conf_lock = "backup.conf";
$restorefile_lock = "backup";


$backup_dir = $ARGV[0];
$backupmode = $ARGV[1];
$restorefile = $ARGV[2];
$restorefile =~ s/\\(.)/$1/g;
$item = $ARGV[3];
$item =~ s/\\(.)/$1/g;
$linenum = $ARGV[4];	# 010426 add

## ʬХåå/smbmount б 2002.6.10 kima
require join ("/", $WBMC_ADM_DIR,"system/backup/split_backup.pl");
require join ("/", $WBMC_ADM_DIR,"disk/disk.pl");
$conf_file = "$WBMC_CONF_DIR/backup.conf";
$conf_lock = "backup.conf";

chdir("$backup_dir");

## ʬХåå/smbmount б 2002.6.10 kima
if ($backupmode eq "SMB") {
  if (!&readFile("/etc/sysconfig/network-scripts/ifcfg-eth0", "ifcfg-eth0", *file)) {
    &showErrorPage("ͥåȥ󥿥եեɤ߹ߤ˼Ԥޤ");
    exit(1);
  }
  $ipaddr = "";
  for ($i = 0; $i < @file; $i++) {
    if ($file[$i] =~ /^\s*IPADDR\s*=\s*(.*)\s*$/) {
      $ipaddr = $1;
    }
  }
  if(!mkdir($backup_dir_smbmnt, 0755)) {
    &showErrorPage("samba ³˼Ԥޤ mkdir error backup_dir_smbmnt : $backup_dir_smbmnt ($item)");
    exit(1);
  }

  if (!&readFile($conf_file, $conf_lock, *conf)) {
    &showErrorPage("Хååեɤ߹ߤ˼Ԥޤ read file error '$conf_file' ($item)\n");
    exit(1);
  }
  $item_flag = 0;
  for ($i = 0; $i < @conf; $i++) {
    if ($conf[$i] =~ /^\s*$item\s*{\s*$/) {
      $item_flag = 1;
    }
    if ($item_flag && $conf[$i] =~ /^\s*}\s*$/) {
      $item_flag = 0;
    }
    if ($item_flag && $conf[$i] =~ /^\s*TARGET\s*=\s*(.*)\s*$/) {
      $target_dir = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*BACKUP\s*=\s*(.*)\s*$/) {
      $backup_dir = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*ROTATE\s*=\s*(.*)\s*$/) {
      $rotate_max = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*BACKUPMODE\s*=\s*(.*)\s*$/) {
      $backupmode = &getValue($1);
      @line = split(/\s+/, $backupmode);
    }
    if ($item_flag && $conf[$i] =~ /^\s*WORKGROUP\s*=\s*(.*)\s*$/) {
      $workgroup = &getValue($1);
      $workgroup_arg = &encodeCmdArg($workgroup);
    }
    if ($item_flag && $conf[$i] =~ /^\s*WINMACHINE\s*=\s*(.*)\s*$/) {
      $winmachine = &getValue($1);
      $winmachine_arg = &encodeCmdArg($winmachine);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SHARE\s*=\s*(.*)\s*$/) {
      $share = &getValue($1);
      $share_arg = &encodeCmdArg($share);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SMBUSER\s*=\s*(.*)\s*$/) {
      $smbuser = &getValue($1);
      $smbuser_arg = &encodeCmdArg($smbuser);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SMBPASSWD\s*=\s*"(.*)"\s*$/) {
      $smbpasswd = &getValue($1);
      $smbpasswd_arg = &encodeCmdArg($smbpasswd);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FTPSERVER\s*=\s*(.*)\s*$/) {
      $ftpserver = &getValue($1);
      $ftpserver_arg = &encodeCmdArg($ftpserver);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FTPUSER\s*=\s*(.*)\s*$/) {
      $ftpuser = &getValue($1);
      $ftpuser_arg = &encodeCmdArg($ftpuser);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FTPPASSWD\s*=\s*"(.*)"\s*$/) {
      $ftppasswd = &getValue($1);
      $ftppasswd_arg = &encodeCmdArg($ftppasswd);
    }
    if ($item_flag && $conf[$i] =~ /^\s*DOMAINBACKUPTYPE\s*=\s*(.*)\s*$/) {
      $domainbackuptype = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*DOMAINNAME\s*=\s*(.*)\s*$/) {
      $domainname = &getValue($1);
      @domainlist = split(/\s+/, $domainname);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FMLBACKUPTYPE\s*=\s*(.*)\s*$/) {
      $fmlbackuptype = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*FMLNAME\s*=\s*(.*)\s*$/) {
      $fmlname = &getValue($1);
      @fmllist = split(/\s+/, $fmlname);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SPOOL\s*=\s*(.*)\s*$/) {
      $spool = &getValue($1);
    }
    if ($item_flag && $conf[$i] =~ /^\s*SYMLINK\s*=\s*(.*)\s*$/) {
      $cluster_symlink = &getValue($1);
      @symlinklist = split(/\s+/, $cluster_symlink);
    }
  }

  my $result = &SmbMount($winmachine, $share, $backup_dir_smbmnt, $smbuser_arg, $smbpasswd_arg, $workgroup_arg);
  if ($result) {
    &showErrorPage("Хååץեɤ߹ߤ˼Ԥޤsmbmount failed($item, $backup_dir_smbmnt) : $result");
    exit(1);
  }
  chdir("$backup_dir_smbmnt/$ipaddr");
}
# fork ơҥץ¦ǥॢȤʤ褦
# ȥǡ³ 20030325 oyama
if ( $pid = fork ){
        if( $pid == -1 ){
                &showErrorPage("եꥹȼץ˼Ԥޤ","main.cgi");
		#2005/09/26 mkdir Ի umount ɲ oyama
		my $UMOUNT_RETRY = 5;
		my $result_smbmnt = &SmbUnMount($backup_dir_smbmnt);
		if($result_smbmnt) {
		  my $umount_count = 0;
		  while($result_smbmnt && $umount_count < $UMOUNT_RETRY) {
		    if($result_smbmnt) {
		    ## err˹ err ȯʤΤǥåɽʤ
		      # &writeError("&SmbUnMount retry : $result_smbmnt");
		    }
		    sleep(5);
		    $result_smbmnt = &SmbUnMount($backup_dir_smbmnt);
		    $umount_count++;
		  }
		}
		my $err = &delSmb($winmachine, $share, $backup_dir_smbmnt);
		if ($err) {
		  ## err˹ err ȯʤΤǥåɽʤ
		  # &writeError("&delSmb error : $err");
		}
		#2005/09/26 end
                exit(1);
        }
} elsif  ( defined $pid ) {
        &run_child_process;
}

# ɽ
# update /bin/tar -> /opt/nec/baktar/baktar 001227
# 010426 kokokara rep ɽ饤
if ($linenum eq "") {
	#if (!&readFile("/bin/cat $restorefile$split_postfilx* | /opt/nec/baktar/baktar tvfz - |", $restorefile_lock, *tarfile)) {
	if (!&readFile("/bin/cat $restorefile$split_postfix* | /opt/nec/baktar/baktar tvfz - |", $restorefile_lock, *tarfile)) {
	  if ($backupmode eq "SMB") {
	    chdir($backup_dir);
	    my $result = &SmbUnMount($backup_dir_smbmnt);
	    if($result) {
	      kill('TERM',$pid);
	      sleep 4;
              &showErrorPageWithoutHeader("Хååץեɤ߹ߤ˼Ԥޤsamba ͭ˼Ԥޤ($result)");
	      exit(1);
	    }
	    # 2004/02/24 add by Ishiyama
	    my $err = &delSmb($winmachine, $share, $backup_dir_smbmnt);
	    if ($err) {
	      &showErrorPageWithoutHeader("samba κ˼Ԥޤ($err)");
	    }
	    #
	  }
	  kill('TERM',$pid);
	  sleep 4;
	  &showErrorPageWithoutHeader("Хååץեɤ߹ߤ˼Ԥޤ");
	  exit(1);
	}
} else {
	#if (!&readFile("/bin/cat $restorefile$split_postfilx* | /opt/nec/baktar/baktar tvfz - | head -n $linenum |", $restorefile_lock, *tarfile)) {
	if (!&readFile("/bin/cat $restorefile$split_postfix* | /opt/nec/baktar/baktar tvfz - | head -n $linenum |", $restorefile_lock, *tarfile)) {
	  if ($backupmode eq "SMB") {
	    chdir($backup_dir);
	    my $result = &SmbUnMount($backup_dir_smbmnt);
	    if($result) {
	      kill('TERM',$pid);
	      sleep 4;
	      &showErrorPageWithoutHeader("Хååץեɤ߹ߤ˼Ԥޤsamba ͭ˼Ԥޤ($result)");
	      exit(1);
	    }
	    # 2004/02/24 add by Ishiyama
	    my $err = &delSmb($winmachine, $share, $backup_dir_smbmnt);
	    if ($err) {
	      &showErrorPageWithoutHeader("samba κ˼Ԥޤ($err)");
	    }
	    #
	  }
	  kill('TERM',$pid);
	  sleep 4;
	  &showErrorPageWithoutHeader("Хååץեɤ߹ߤ˼Ԥޤ");
	  exit(1);
	}
}
kill('TERM',$pid);
sleep 4;

if (@tarfile == $linenum) {
    push(@tarfile,"------------------------------ (ʲά) ------------------------------\n");
}
# 010426 kokomade rep

@tmp = @tarfile;
for ($i = 0 ; $i < @tmp; $i++) {
    $tmp[$i] =~ s/&/&amp;/g ;
    $tmp[$i] =~ s/</&lt;/g ;
    $tmp[$i] =~ s/>/&gt;/g ;
}

# եκ
## smbmount ѤѹˤʤäΤ smb ξϺʤ
## 2002.6.10 kima
#if ($backupmode eq "SMB" || $backupmode eq "FTP") {
if ($backupmode eq "FTP") {
    unlink($restorefile);
}

## smbmount б
if ($backupmode eq "SMB") {
  chdir($backup_dir);
  my $result = &SmbUnMount($backup_dir_smbmnt);
  if($result) {
    &showErrorPageWithoutHeader("samba ͭβ˼Ԥޤsmbumount failed($item, $backup_dir_smbmnt) : $result");
    exit(1);
  }
  # 2004/02/24 add by Ishiyama
  my $err = &delSmb($winmachine, $share, $backup_dir_smbmnt);
  if ($err) {
    &showErrorPageWithoutHeader("samba κ˼Ԥޤ($err)");
  }
  #
}

#Хååץե̾
#$backup_dir$brestorefileδ֤'/'롣
if ($backup_dir =~ /[^\/]$/) {
    $backup_dir .= "\/";
}

$navibar = &getNavigation(
    "ƥ", "../system.cgi",
    "Хåå/ꥹȥ","main.cgi",
#   "Խ", "index.cgi?$item",
    "ꥹȥ","restore.cgi?$item+$backupmode",
    "ɽ","",
    "_back","restore.cgi?$item+$backupmode",
    "_help","showarchive_help.html"
    );

$backup_arg = "$backup_dir$restorefile";

$backup_arg =~ s/([^\-\_\.a-zA-Z0-9])/sprintf("%%%02X", ord($1))/eg;
$restorefile =~ s/([^\-\_\.a-zA-Z0-9])/sprintf("%%%02X", ord($1))/eg;
$item =~ s/([^\-\_\.a-zA-Z0-9])/sprintf("%%%02X", ord($1))/eg;
$savefile = $restorefile;
$savefile =~ s/\.tgz$/\.txt/;
#----------
#20030325 ॢкȤƥإåϴɽƤΤɽʤ
print <<END_OF_DATA;
<TITLE>ɽ</TITLE>
</HEAD>

<BODY>


<H4 ALIGN="center">ɽ</H4>
<HR>
$navibar
<HR>

<CENTER>

<TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACIN=0 CELLPADDING=1>
 <TR BGCOLOR="#000080">
  <TD><FONT COLOR="#FFFFFF"> <B>Хååץեɽ</B>
  </FONT></TD>
 </TR>
 <TR>
  <TD>
   <TABLE>
    <TR>
     <TD>
      ɽƤɤˤ
      <A target=_blank HREF="./download.cgi/$savefile?$backup_arg+$backupmode+$restorefile+$item"><B></B></A>
      򥯥åɥե¸Ʋ
     </TD>
    </TR>
    <TR>
     <TD>
      <TABLE BORDER=1>
       <TR>
        <TD>
         <PRE> @tmp</PRE>
        </TD>
       </TR>
      </TABLE>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE> 
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#----------
