#!/usr/bin/perl

# Copyright (C) 2001 NEC Corporation
# All Rights Reserved.

# RCS: $Id: tripwire.pl,v 1.4 2003/03/20 07:35:38 snavi Exp $


require "/opt/nec/wbmc/lib/wbmc.pl";
require "/opt/nec/wbmc/lib/cluster_com.pl";

########################################
# ѥե졼μ           #
# &GetPassphrase()                     #
#  : ̵                          #
# ｪλǥɤ줿ѥե졼 #
# ۾ｪλ-1                         #
########################################

sub GetPassphrase {

	my($phrase);
	my($trip_conf) = "/etc/opt/nec/wbmc/wbmc_tripconf";
	my($trip_conf_lock) = "wbmc_tripconf";
	local(@conf) = ();
	my($ret) = -1;

# /etc/opt/nec/wbmc/wbmc_tripconf ɤ߹
	if (-f $trip_conf) {
		if (!&readFile($trip_conf, $trip_conf_lock, *conf)) {
			return ($ret);
		}
	} else {
		return ($ret);
	}

# ĶեƤѿ˳Ǽ
	for ($i = 0; $i < @conf; $i++) {
		if ($conf[$i] =~ /^\s*PHRASE\s*=\s*(.*)\s*$/) {
			$phrase = $1;
		}
	}

# ѥե졼ǥɽ
# ѥե졼ϡ󥳡ɤƳǼƤ뤿
	use MIME::Base64 qw(decode_base64);
	local($/) = undef;
	$ret = decode_base64($phrase);

	return ($ret);
}

########################################
# åޥɤμ         #
# &GetCheckcmd()                       #
# ̵                           #
# ｪλ åޥ    #
# ۾ｪλ-1                         #
########################################

sub GetCheckcmd {

	my($chkcmd) = -1;
	my($trip_conf) = "/etc/opt/nec/wbmc/wbmc_tripconf";
	my($trip_conf_lock) = "trip.conf";
	local(@conf) = ();

# /etc/opt/nec/wbmc/wbmc_tripconf ɤ߹
	if (-f $trip_conf) {
		if (!&readFile($trip_conf, $trip_conf_lock, *conf)) {
			return ($chkcmd);
		}
	} else {
		return ($ret);
	}

# ĶեƤѿ˳Ǽ
	for ($i = 0; $i < @conf; $i++) {
		if ($conf[$i] =~ /^\s*EMAIL_CMD\s*=\s*(.*)\s*$/) {
			$chkcmd = $1;
		}
	}

	return ($chkcmd);
}

####################################################################
# wbmc_tripconfɤ߼ꡢݡȥե        #
# &DelReport()                                                     #
# ̵                                                       #
# ｪλNULL                                                   #
# ۾ｪλ顼å                                       #
####################################################################

sub DelReport {

	my($reportfile_lock) = "report.lock";
	local(@reportfile) = ();
	my($report_num) = 0;
	my($ret) = "";
	my(@tmp) = ();

# ݡݻ
 
# Ķեɤ߹
	my($trip_conf) = "/etc/opt/nec/wbmc/wbmc_tripconf";
	my($trip_conf_lock) = "trip.conf";
	local(@conf) = ();
	if (-f $trip_conf) {
		if (!&readFile($trip_conf, $trip_conf_lock, *conf)) {
			return("Ķեɤ߹ߤ˼ԤޤݡȥեϺޤǤ");
		}
	}
# եƤѿ˳Ǽ
	for ($i = 0; $i < @conf; $i++) {
		if ($conf[$i] =~ /^\s*SAVEREPORT_NUM\s*=\s*(.*)\s*$/) {
			$report_num = $1;
		}
	}

# ݡȿå(ʤСʤ)
	if ($report_num == 0) { return ("") ;}

# ݡȥեꥹȤ
	open(IN, "/bin/ls -lrt /var/lib/tripwire/report/tripreport-[0-9]*-[0-9]*.twr|");
	@reportfile = <IN>;
	close(IN);

# ݡȥեꤵƤݻ
# äƤ硢ָŤΤ
	for($i=@reportfile ; $i > $report_num ; $i--){
		@tmp = split(/\s+/,$reportfile[($i - $report_num)-1]);
		if(system("rm -f $tmp[8] >/dev/null 2>&1")) {
			return ("ݡȥեκ˼Ԥޤ") 
		}
	}

	return ($ret);
}

###########################################################
#   NITCONF.INIߥ顼ǥΥޥȥݥȤ #
#   &GetMountpoint()                                      #
#   ̵                                            #
#   ｪλ : ޥȥݥ                           #
#   ۾ｪλ : -1                                         #
###########################################################

sub GetMountpoint(){

# ѿ
	my($initconf_file , $initconf_lock);
	local(@file) = ();
	my($i , $type , $ret);

	$initconf_file = "/etc/opt/nec/wbmc/INITCONF.INI";
	$initconf_lock = "INITCONF.INI";
	$i = 0;
	$ret = -1;
	$type = "";

# ޥȥݥȤǼƤեɤ߹
	if (!&readFile($initconf_file ,$initconf_lock, *file)) {
		return($ret);
	}

# ޥȥݥȤμФ
	for ($i = 0; $i < @file; $i++) {
		if ($file[$i] =~ /^MountPoint=(.*)/) {
			$ret = "$1\/";
		}
	}
	return($ret);
}

#########################################################################
# ݥꥷƤ񤭴ʥե˽񤭹ߤϤʤ              #
# &WritePolicy()                                                        #
# :ɥᥤ,åо,ɲáѹƥ,ݥꥷե) #
# ｪλNULL                                                        #
# 顼顼å                                            #
#########################################################################
sub WritePolicy {

# ѿ
	local($domain,$chk_directory,*addtxt,*conf) = @_;
	my($i,$addpass,$addflg,$changeflg);

# 䴰ѥ
	if (&cluster_typechk() eq "cluster") {
		$addpass = &GetMountpoint() . "web/";
		if ($addpass == -1) {
			return ("ޥȥݥȤμ˼Ԥޤ");
		}
	} else {
		$addpass = "/home/web/";
	}

# 
# ꤵƤϡ֤
# ꤵƤʤåоݤϡɥᥤΰֲɲä
# ɥᥤñ̤ɲä硢ݥꥷեƬɲä

	# ꤵƤƤɲáѹ
	for ($i = 0; $i < @conf; $i++) {
		if ($conf[$i] =~ /\s*#\s+$domain\s+start\s*/) {
			# $addflgϡɲäȤڤʬΤ˻
			$addflg = 1;
			# ɥᥤκǸ夬Ĥޤǡ롼פ
			while($conf[$i] !~ /\s*#\s+$domain\s+end\s*/) {
				# ꤵƤ硢֤
				if ($conf[$i] =~ /\s*#\s+start\s+$chk_directory\s*/) {
					while() {
						if ($conf[$i] =~ /\s*#\s+end\s+$chk_directory\s*/) {
							# Ѥߤѹ
							# "end "ФƤ顢֤ƥ롼פȴ
							splice(@conf,$i,1,@addtxt);
							# ѹԤ줿Ȥ򼨤ե饰ΩƤ
							$changeflg = 1;
							last;
						} else {
							# ݥꥷ򿷤˺ʤᡢꤵƤݥꥷϺƤ
							splice(@conf,$i,1,"");
							$i++;
						}
					}
				# åоݤ̤ʪɲä
				# "}"ФƤ顢֤ƥ롼פȴ
				} elsif ($conf[$i] =~ /^\}\s*/) {
					# "}"@addtxt̵Τɲ
					if ($changeflg != 1) {
						push(@addtxt,"}\n");
						splice(@conf,$i,1,@addtxt);
					}
					last;
				}
				# 桼ftpεҤѹ
				# UC,DCɲäϡüUF,DFΰ򥳥ȥȡ
				# UF,DFɲäϡɲåƥȺü򤹤
				if ($chk_directory eq "UC") {
					if ($conf[$i] =~ m|!$addpass$domain/users/.*/ftp/public_html/;|) {
						$conf[$i] =~ s/^!/#!/;
					}
				} elsif ($chk_directory eq "DC") {
					if ($conf[$i] =~ m|!$addpass$domain/htdocs/;|) {
						$conf[$i] =~ s/^!/#!/;
					}
				}
				$i++;
			}
			last;
		}
	}

# ɥᥤñ̤ɲýݥꥷեƬɲä롣emailtoμ
	if ($addflg != 1) {
		# ɥᥤñ̤ΥݥꥷϤȽλ򼨤ʸɲåƥȤɲ
		unshift(@addtxt,"# $domain start\n","(rulename=\"$domain\"){\n");
		push(@addtxt,"}\n","# $domain end\n");
		# ݥꥷɲ
		for ($i = 0; $i < @conf; $i++) {
			if ($conf[$i] =~ /^\s*\(emailto\s*=\s*\"\s*.*\s*\"\)\{\s*$/ ) {
				splice(@conf,$i+1,0,@addtxt);
				last;
			}
		}
	}
# Ź沽ݥꥷե -> ƥȥݥꥷѴˤĤƤޤԤ
	chomp($conf[@conf-1]);
	return ("");

}

#############################################################
# ݥꥷեƼ                                #
# &GetPolicy()                                              #
# (åо,åоݥɥᥤ,ݥꥷ)  #
# ｪλǻꤵ줿åоݤΥݥꥷ  #
# ۾ｪλNULL                                            #
#############################################################
sub GetPolicy {

# ѿ
	my(@chk_directory_contents) = ();
	local($chk_directory,$chk_domain,*conf) = @_;
	my($i) = 0;

# ݥꥷ򸡺ǻꤵ줿åоݤΥݥꥷ
	for ($i = 0; $i < @conf; $i++) {
		# # ɥᥤ̾ startפ򸡺 
		if ($conf[$i] =~ /^\s*#\s+$chk_domain\s+start\s*$/) {
			while ($conf[$i] !~ /^\s*#\s+$chk_domain\s+end\s*$/) {
				# UF,UC,DC,DF椫顢ǻꤵ줿åоݤ򸡽
				if ($conf[$i] =~ /^\s*#\s+start\s+$chk_directory\s*$/) {
					$i++;
					# åоݤޤǡѿ˳Ǽ
					while($conf[$i] !~ /^\s*#\s+end\s+$chk_directory\s*$/) {
						push(@chk_directory_contents , $conf[$i]);
						$i++;
					}
				}
				$i++;
			}
			last;
		}
	}
	return (@chk_directory_contents);

}

##########################################################################
# ݥꥷƤ顢ꤷɥᥤ󡢥åоݤƤ #
# &GetPolsetitem()                                                       #
# åо,åоݥɥᥤ,åоݤ             #
# ｪλå,åоݳꥹ                            #
# ۾ｪλNULL                                                         #
##########################################################################

sub GetPolsetitem {

# ѿ
	local($chk_directory,$chk_domain,*chk_directory_contents) = @_;
	my($i,$chk_item,$addpass,$ret_nochk_file_list);
	my(@ret,@nochk_file_list) = ();

# 䴰ѥ
	if (&cluster_typechk() eq "cluster") {
		$addpass = &GetMountpoint() . "web/";
	} else {
		$addpass = "/home/web/";
	}

# åܤˤʬ
# 줾졢ɽʤΤޤޤ뤿ᡢѥ
######## ѥꤳ ############
########## UC:桼ƥ ##############
	if ($chk_directory eq "UC"){
		for ($i = 0; $i < @chk_directory_contents; $i++) {
			# Ȥ#򸫤Ĥ顢
			if ($chk_directory_contents[$i] =~ /^\s*#/) {
				next;
			}
			# åܸ +xxxxxxxxxxx ʬФ
			elsif ($chk_directory_contents[$i] =~ m|^\s*$addpass$chk_domain/users/.*/ftp/public_html/\s*\-\>\s*\+r\s*(.*)\;\s*|) {
				$chk_item = $1;
			}
			# åоݳΥեꥹȤ˳Ǽ
			elsif ($chk_directory_contents[$i] =~ m|^\s*\!$addpass$chk_domain/users/.*\/ftp/public_html/(.*)\;\s*$|) {
				push(@nochk_file_list,"$1");
			}
		}
	}

########## UF:桼FTP ###############
	if ($chk_directory eq "UF"){
		for ($i = 0; $i < @chk_directory_contents; $i++) {
			# Ȥ#򸫤Ĥ顢
			if ($chk_directory_contents[$i] =~ /^\s*#/) {
				next;
			}
			# åܸ +xxxxxxxxxxx ʬФ
			elsif ($chk_directory_contents[$i] =~ m|^\s*$addpass$chk_domain/users/.*/ftp/\s*\-\>\s*\+r\s*(.*)\;\s*$|) {
				$chk_item = $1;
			}
			# åоݳΥեꥹȤ˳Ǽ
			# bin,lib,public_htmlϽᤫоݳǥ쥯ȥ
			elsif ($chk_directory_contents[$i] =~ m|^\s*\!$addpass$chk_domain/users/.*/ftp/(.*);\s*$|) {
				if ($1 =~ /bin\/|lib\/|public_html\//) {
					next;
				}
				push(@nochk_file_list,"$1");
			}
		}
	}

########## DC:ɥᥤ󥳥ƥ ###############
	elsif ($chk_directory eq "DC"){
		for ($i = 0; $i < @chk_directory_contents; $i++) {
			# Ȥ#򸫤Ĥ顢
			if ($chk_directory_contents[$i] =~ /^\s*#/) {
				next;
			}
			# åܸ +xxxxxxxxxxx ʬФ
			elsif ($chk_directory_contents[$i] =~ m|^\s*$addpass$chk_domain/htdocs/\s*\-\>\s*\+r\s*(.*)\;\s*$|) {
				$chk_item = $1;
			}
			# åоݳΥեꥹȤ˳Ǽ
			elsif ($chk_directory_contents[$i] =~ m|^\s*\!$addpass$chk_domain/htdocs/(.*);\s*$|) {
				push(@nochk_file_list,"$1");
			}
		}
	}

########## DF:ɥᥤFTP ################
	elsif ($chk_directory eq "DF"){
		for ($i = 0; $i < @chk_directory_contents; $i++) {
			# Ȥ#򸫤Ĥ顢
			if ($chk_directory_contents[$i] =~ /^\s*#/) {
				next;
			}
			# åܸ +xxxxxxxxxxx ʬФ
			elsif ($chk_directory_contents[$i] =~ m|^\s*$addpass$chk_domain/\s*\-\>\s*\+r\s*(.*)\;\s*$|) {
				$chk_item = $1;
			}
			# åоݳΥեꥹȤ˳Ǽ
			# bin,lib,etc,pub,users,ftp,htdocsоݳǥ쥯ȥ
			elsif ($chk_directory_contents[$i] =~ m|^\s*\!$addpass$chk_domain/(.*);\s*$|) {
				if ($1 =~ /bin\/|lib\/|etc\/|pub\/|users\/|ftp\/|htdocs\//) {
					next;
				}
				push(@nochk_file_list,"$1");
			}
		}
	}

######## ѥꤳޤ ############

# UF,UCξ硢åоݳΥꥹȤ@nochk_file_list ˳Ǽ
# Ƥ뤬桼ƱǤäƤ롣
# ΤᡢʣʬԤ
	if ($chk_directory eq "UC" || $chk_directory eq "UF") {
		@nochk_file_list = sort(@nochk_file_list);
		for($i=0;$i<@nochk_file_list;$i++){
			while($nochk_file_list[$i] eq $nochk_file_list[$i+1]) {
				splice(@nochk_file_list,$i+1,1);
			}
		}
	}

# ֤ͤꤹ
# ǤˤϲԤ̵ᡢԤĤƳǼ
	foreach (@nochk_file_list){
		$ret_nochk_file_list .= "$_\n";
	}
	push(@ret, "$chk_item", "$ret_nochk_file_list");

	return (@ret);

}

######################################################################
# ݥꥷեϿѤʸ                           #
# &MakePolicy()                                                      #
# :ɥᥤ̾åоݡåܡåоݳꥹ  #
# ｪλ :ݥꥷǼʸ                             #
# ۾ｪλ : -1 (ɥᥤ˥桼ͤ⤤ʤȤ)                 #
######################################################################
sub MakePolicy {

	# ѿ
	local($chk_domain,$chk_directory,$chk_item,*nochk_file_list) = @_;
	my(@add_txt,@user_list,@find_cmd,@tmp,@find_list);
	my($i,$j,$addpass,$user_name,$set_find_cmd,$find_object_list);

	# 䴰ѥ
	if (&cluster_typechk() eq "cluster") {
		$addpass = &GetMountpoint() . "web/";
	} else {
		$addpass = "/home/web/";
	}

	# åܤꤵʤäн
	if($chk_item eq "") {
		$chk_item = '+r -r';
	} else {
		$chk_item = "+r" . "$chk_item";
	}

	# 
	# ʸɲ
	push(@add_txt,"# start $chk_directory\n");

# UC,UF,DC,DF Σѥξʬ
############# ѥξʬ  #############
############ 桼ƥĤξ #################
	if ($chk_directory eq "UC") {
		#UC,UFξϡ桼ꥹȺ
		# 桼$addpass$chk_domain/users/۲ǥ쥯ȥ˼
		opendir (TDR , "$addpass$chk_domain/users/");
		@user_list = readdir(TDR);
		close (TDR);
		shift(@user_list); # ./  ä
		shift(@user_list); # ../ ä
		if ($user_list[0] eq "") {
			return ("-1");
		}

		# 桼оݳե
		foreach $user_name (@user_list) {
			# ѿ
			@find_cmd = ();
			$set_find_cmd = "";
			# åܤꤹ
			push(@add_txt,"$addpass$chk_domain/users/$user_name/ftp/public_html/ -> $chk_item\;\n");
			# åоݳ
			for ($i=0;$i<@nochk_file_list;$i++) {
				if ($nochk_file_list[$i] eq "") {
					next;
				}
				# åоݳ*ޤޤʸ󤬤ϡfindޥɤѤơоݳեΰ
				elsif ($nochk_file_list[$i] =~ /.*\*.*/) {
					# findޥɤ˻Ѥʸ
					push(@find_cmd," -o"," -name \"$nochk_file_list[$i]\"");
				# åоݳȤե*ޤޤʸ̵ϡեѥ䴰˳Ǽ
				} else {
					$nochk_file_list[$i] = &modPolChar($nochk_file_list[$i]);
					push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/public_html/$nochk_file_list[$i]\;\n");
				}
			}
			### findޥɺ+ȯ ###
			if ($find_cmd[0] ne "") {
				shift(@find_cmd);
				foreach (@find_cmd) {
					$set_find_cmd .= $_;
				}
				$set_find_cmd = "/usr/bin/find $addpass$chk_domain/users/$user_name/ftp/public_html/ \\( " ."$set_find_cmd" . " \\) |";
				# findޥɤǥꥹȥå
				open(FIND,"$set_find_cmd");
				@find_list = <FIND>;
				close(FIND);
				chomp(@find_list);
				# public_htmlȤФ뤳Ȥ뤿ᡢ
				for($j=0; $j<@find_list; $j++) {
					if (($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/public_html/$|) ||($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/public_html$|)) {
						splice(@find_list,$j,1);
						$j--;
						next;
					}
				}
				# ꥹȥåפ줿եѿ˳Ǽ
				foreach $find_object_list (@find_list) {
					$find_object_list = &modPolChar($find_object_list);
					push(@add_txt,"!$find_object_list\;\n");
				}
			}
		}
############ 桼ftpξ #################
	}
	elsif ($chk_directory eq "UF") {
		#UC,UFξϡ桼ꥹȺ
		# 桼$addpass$chk_domain/users/۲ǥ쥯ȥ˼
		opendir (TDR , "$addpass$chk_domain/users/");
		@user_list = readdir(TDR);
		closedir (TDR);
		shift(@user_list); # ./  ä
		shift(@user_list); # ../ ä
		if ($user_list[0] eq "") {
			return ("-1");
		}

		# 桼оݳե
		foreach $user_name (@user_list) {
			# ѿ
			@find_cmd = ();
			$set_find_cmd = "";
			# åܤꤹ
			push(@add_txt,"$addpass$chk_domain/users/$user_name/ftp/ -> $chk_item\;\n");
			push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/lib/;\n");
			push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/bin/;\n");
			# public_htmlϡUCåƤ뤫ɤʬ
			@tmp = &GetPolicy("UC",$chk_domain);
			if ($tmp[0] eq "") {
				push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/public_html/;\n");
			} else {
				push(@add_txt,"#!$addpass$chk_domain/users/$user_name/ftp/public_html/;\n");
			}
			# åоݳꤹ
			for ($i=0;$i<@nochk_file_list;$i++) {
				if ($nochk_file_list[$i] eq "") {
					next;
				}
				# åоݳ*ޤޤʸ󤬤ϡfindޥɤѤơоݳեΰ
				elsif ($nochk_file_list[$i] =~ /.*\*.*/) {
					# findޥɤ˻Ѥʸ
					push(@find_cmd," -o"," -name \"$nochk_file_list[$i]\"");
				# åоݳȤե*ޤޤʸ̵ϡեѥ䴰˳Ǽ
				} else {
					$nochk_file_list[$i] = &modPolChar($nochk_file_list[$i]);
					push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/$nochk_file_list[$i]\;\n");
				}
			}
			### findޥɺ+ȯ ###
			if ($find_cmd[0] ne "") {
				shift(@find_cmd);
				foreach (@find_cmd) {
					$set_find_cmd .= $_;
				}
				$set_find_cmd = "/usr/bin/find $addpass$chk_domain/users/$user_name/ftp/ \\( " ."$set_find_cmd" . " \\) |";
				# findޥɤǥꥹȥå
				open(FIND,"$set_find_cmd");
				@find_list = <FIND>;
				close(FIND);
				chomp(@find_list);
				# bin,lib,public_html۲ΥեоݳΤ
				for($j=0; $j<@find_list; $j++) {
					if (($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/lib/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/lib$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/bin/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/bin$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/public_html/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users/$user_name/ftp/public_html$|)) {
						splice(@find_list,$j,1);
						$j--;
						next;
					}
				}
				# ꥹȥåפ줿եѿ˳Ǽ
				foreach $find_object_list (@find_list) {
					$find_object_list = &modPolChar($find_object_list);
					push(@add_txt,"!$find_object_list\;\n");
				}
			}
		}
############ ɥᥤ󥳥ƥĤξ #################
	}
	elsif ($chk_directory eq "DC") {
		# ѿ
		@find_cmd = ();
		$set_find_cmd = "";
		# åܤꤹ
		push(@add_txt,"$addpass$chk_domain/htdocs/ -> $chk_item\;\n");
		# åоݳꤹ
		for ($i=0;$i<@nochk_file_list;$i++) {
			if ($nochk_file_list[$i] eq "") {
				next;
			}
			# åоݳ*ޤޤʸ󤬤ϡfindޥɤѤơоݳեΰ
			elsif ($nochk_file_list[$i] =~ /.*\*.*/) {
				# findޥɤ˻Ѥʸ
				push(@find_cmd," -o"," -name \"$nochk_file_list[$i]\"");
			# åоݳȤե*ޤޤʸ̵ϡեѥ䴰˳Ǽ
			} else {
				$nochk_file_list[$i] = &modPolChar($nochk_file_list[$i]);
				push(@add_txt,"!$addpass$chk_domain/htdocs/$nochk_file_list[$i]\;\n");
			}
		}
		### findޥɺ+ȯ ###
		if ($find_cmd[0] ne "") {
			shift(@find_cmd);
			foreach (@find_cmd) {
				$set_find_cmd .= $_;
			}
			$set_find_cmd = "/usr/bin/find $addpass$chk_domain/htdocs/ \\( " ."$set_find_cmd" . " \\) |";
			# findޥɤǥꥹȥå
			open(FIND,"$set_find_cmd");
			@find_list = <FIND>;
			close(FIND);
			chomp(@find_list);
			# /usr/bin/find $addpass$chk_domain/htdocs/ ȤФ뤳Ȥ뤿ᡢ
			for($j=0; $j<@find_list; $j++) {
				if (($find_list[$j] =~ m|^$addpass$chk_domain/htdocs/$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/htdocs$|)) {
					splice(@find_list,$j,1);
					$j--;
					next;
				}
			}
			# ꥹȥåפ줿եѿ˳Ǽ
			foreach $find_object_list (@find_list) {
				$find_object_list = &modPolChar($find_object_list);
				push(@add_txt,"!$find_object_list\;\n");
			}
		}
############ ɥᥤftpξ #################
	}
	elsif ($chk_directory eq "DF") {
		# ѿ
		@find_cmd = ();
		$set_find_cmd = "";
		# åܤꤹ
		push(@add_txt,"$addpass$chk_domain/ -> $chk_item\;\n");
		# 餫åоݳȤǥ쥯ȥꤹ
		push(@add_txt,"!$addpass$chk_domain/lib/;\n");
		push(@add_txt,"!$addpass$chk_domain/bin/;\n");
		push(@add_txt,"!$addpass$chk_domain/etc/;\n");
		push(@add_txt,"!$addpass$chk_domain/pub/;\n");
		push(@add_txt,"!$addpass$chk_domain/ftp/;\n");
		push(@add_txt,"!$addpass$chk_domain/users/;\n");
		# htdocsϡDCåƤ뤫ɤʬ
		@tmp = &GetPolicy("DC",$chk_domain);
		if ($tmp[0] eq "") {
			push(@add_txt,"!$addpass$chk_domain/htdocs/;\n");
		} else {
			push(@add_txt,"#!$addpass$chk_domain/htdocs/;\n");
		}
		# åоݳȤե롿ǥ쥯ȥꤹ
		for ($i=0;$i<@nochk_file_list;$i++) {
			if ($nochk_file_list[$i] eq ""){
				next;
			}
			# åоݳ*ޤޤʸ󤬤ϡfindޥɤѤơоݳեΰ
			elsif ($nochk_file_list[$i] =~ /.*\*.*/) {
				# findޥɤ˻Ѥʸ
				push(@find_cmd," -o"," -name \"$nochk_file_list[$i]\"");
			# åоݳȤե*ޤޤʸ̵ϡեѥ䴰˳Ǽ
			} else {
				$nochk_file_list[$i] = &modPolChar($nochk_file_list[$i]);
				push(@add_txt,"!$addpass$chk_domain/$nochk_file_list[$i]\;\n");
			}
		}
		### findޥɺ+ȯ ###
		if ($find_cmd[0] ne "") {
			shift(@find_cmd);
			foreach (@find_cmd) {
				$set_find_cmd .= $_;
			}
			$set_find_cmd = "/usr/bin/find $addpass$chk_domain/ -type f \\( " ."$set_find_cmd" . " \\) |";
			# findޥɤǥꥹȥå
			open(FIND,"$set_find_cmd");
			@find_list = <FIND>;
			close(FIND);
			chomp(@find_list);
			# bin,lib,public_html۲ΥեоݳΤ
			for($j=0; $j<@find_list; $j++) {
				if (($find_list[$j] =~ m|^$addpass$chk_domain/$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/bin/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/bin$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/lib/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/lib$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/etc/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/etc$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/pub/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/pub$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/ftp/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/ftp$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/htdocs/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/htdocs$|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users/.*|) ||
					($find_list[$j] =~ m|^$addpass$chk_domain/users$|)) {
					splice(@find_list,$j,1);
					$j--;
					next;
				}
			}
			# ꥹȥåפ줿եʸ˵ƳǼ
			foreach $find_object_list (@find_list) {
				$find_object_list = &modPolChar($find_object_list);
				push(@add_txt,"!$find_object_list\;\n");
			}
		}
	}
############# ѥξʬ ޤ #############

	# Ǹˡendդäơ񤭹ѥƥȴ
	push(@add_txt,"# end $chk_directory\n");
	return (@add_txt);
}

##########################################################
# 塼/etc/crontabؤν񤭹             #
# &WriteCrontab()                                        #
# crontabɲѥƥȺ                              #
# CYCLEʳξϡwbmc_tripϿCYCLEξ硢    #
# ֤ưcrontab񤭴ޥɤϿ#
# ｪλNULL                                         #
# 顼顼å                             #
##########################################################

sub WriteCrontab{

# ѿ
	my($chkpiriod,$chkhour,$chkmin,$chkcycletime,$chkstarttime,$datapiriod,$datahour,$datamin) = @_;

	my($tripchkcmd,$tripdatacmd);
	my($i);
	my($ret) ="";
	local(@crontab) = ();

# ޥɺ
# ư¹ԣѥDBѥǣߣΣ̤ξʬ
# (NO,DAILY,CYCLE)    (NO,SAME,DAILY)
	if ($chkpiriod eq "NO") {
		if ($datapiriod eq "NO") {
			$tripchkcmd = "";
			$tripdatacmd = "";
		} elsif ($datapiriod eq "SAME") {
			$tripchkcmd = "";
			$tripdatacmd = "";
		} elsif ($datapiriod eq "DAILY") {
			$tripchkcmd = "";
			$tripdatacmd = "$datamin $datahour * * * root /opt/nec/wbmc/bin/wbmc_trip -d\n";
		}
	} elsif ($chkpiriod eq "DAILY") {
		if ($datapiriod eq "NO") {
			$tripchkcmd = "$chkmin $chkhour * * * root /opt/nec/wbmc/bin/wbmc_trip -c\n";
			$tripdatacmd = "";
		} elsif ($datapiriod eq "SAME") {
			$tripchkcmd = "$chkmin $chkhour * * * root /opt/nec/wbmc/bin/wbmc_trip -i\n";
			$tripdatacmd = "";
		} elsif ($datapiriod eq "DAILY") {
			$tripchkcmd = "$chkmin $chkhour * * * root /opt/nec/wbmc/bin/wbmc_trip -c\n";
			$tripdatacmd = "$datamin $datahour * * * root /opt/nec/wbmc/bin/wbmc_trip -d\n";
		}
	} elsif ($chkpiriod eq "CYCLE") {
		if ($datapiriod eq "NO") {
			$tripchkcmd = "0 $chkstarttime * * * root /opt/nec/wbmc/bin/wbmc_tripcron\n";
		} elsif ($datapiriod eq "SAME") {
			$tripchkcmd = "0 $chkstarttime * * * root /opt/nec/wbmc/bin/wbmc_tripcron\n";
		} elsif ($datapiriod eq "DAILY") {
			$tripchkcmd = "0 $chkstarttime * * * root /opt/nec/wbmc/bin/wbmc_tripcron\n";
			$tripdatacmd = "$datamin $datahour * * * root /opt/nec/wbmc/bin/wbmc_trip -d\n";
		}
	}

# crontabɲý
#  ¸õ
#  ɲ

# Ķեɤ߹
# ɤ߹桢եƤѹʤ褦å򤫤롣
# ХååκȤȽŤʤäˡåͭˤʤ褦
# åե̾¾ΥץǻѤƤΤѤ

	if (!&readFile("/etc/crontab", "crontab", *crontab)) {
		return("ե(/etc/crontab)ɤ߹ߤ˼Ԥޤ");
	}

# ˤ
	for ($i = 0; $i < @crontab; $i++) {
		if (($crontab[$i] =~ m|/opt/nec/wbmc/bin/wbmc_tripcron\s*|) || ($crontab[$i] =~ m|/opt/nec/wbmc/bin/wbmc_trip\s+\-[cdi]\s*|)) {
			splice(@crontab, $i, 1, "");
		}
	}
# ɲåޥ
	push(@crontab, $tripchkcmd, $tripdatacmd);

# ե˽񤭹
	if (!&writeFile("/etc/crontab", "crontab", @crontab)) {
		return("ե(/etc/crontab)ν񤭹ߤ˼Ԥޤ");
	}
	system ("/etc/rc.d/init.d/crond restart &> /dev/null");

	return($ret);
}


########################################################
# ݥꥷեϿƤɥᥤΰ #
# &GetPolsetdomainlist()                               #
# ݥꥷ                                 #
# ｪλ : ɥᥤꥹȤ                      #
# ۾ｪλ : ̵                                  #
########################################################

sub GetPolsetdomainlist {

## ѿ
	my($i);
	local(*conf) = @_;
	my(@ret) = ();

## ɥᥤ̾
	for ($i = 0; $i < @conf; $i++ ) {
		if ($conf[$i] =~ /^#\s+(.*)\s+start\s*$/) {
			push(@ret,$1);
		}
	}

	return (@ret);

}

#################################################################
# ݥꥷؿ                                              #
# &DelPolicy()                                                  #
#  : оݥɥᥤ󡢺оݡݥꥷե     #
# ｪλʬΤߺݥꥷե          #
# ۾ｪλƬǡ-1                                  #
#           Σܤǡ顼å                #
#################################################################

sub DelPolicy {

# ѿ
	local($chk_domain,$chk_directory,*conf) = @_;
	my(@err_msg) = ();
	my($i,$domain_flg,$chk_directory_flg);

# ݥꥷ⤫顢# $domainname startˤ򸡺
# ĤäΤϡˡ# start $chk_directoryˤ򸡺
	for ($i = 0; $i < @conf; $i++) {
		if ($conf[$i] =~ /^#\s+$chk_domain\s+start\s*$/) {
			# ɥᥤȯե饰ΩƤʥ顼ǻѡ
			$domain_flg = 1;

			###### ɥᥤñ̤κξ ##########
			if($chk_directory eq "ALL") {
				# åоȯե饰ΩƤʥ顼ǻѡ
				$chk_directory_flg = 1;
				# ɥᥤν򸫤Ĥޤǡñ̺
				while($conf[$i] !~ /^#\s+$chk_domain\s+end\s*$/) {
					splice(@conf,$i,1,"");
					$i++;
				}
				splice(@conf,$i,1,"");
				goto done;
			}
			###### ɥᥤñ̺ ޤ #########
			while ($conf[$i] !~ /^#\s+$chk_domain\s+end\s*$/) {
				# UF,UC,DC,DF椫鳺ܤ򸡽
				if ($conf[$i] =~ /^#\s+start\s+$chk_directory\s*$/) {
					# åоȯե饰ΩƤʥ顼ǻѡ
					$chk_directory_flg = 1;
					# åоݤν򸫤Ĥޤǡñ̺
					while($conf[$i] !~ /^#\s+end\s+$chk_directory\s*$/) {
						splice(@conf,$i,1,"");
						$i++;
					}
					splice(@conf,$i,1,"");
				}
####### ȥȤ
				elsif ($chk_directory eq "UC") {
					$conf[$i] =~ s/^#(.*\/$chk_domain\/users\/.*\/ftp\/public_html\/;)/$1/;
				}
				elsif ($chk_directory eq "DC") {
					$conf[$i] =~ s/^#(.*\/$chk_domain\/htdocs\/;)/$1/;
				}
###### ȥȤޤ
				$i++;
			}
			goto done;
		} 
	}
	done:
# 顼å
	if ($domain_flg != 1) {
		@err_msg = ("-1","ɥᥤ󤬥ݥꥷƤޤ")
	} elsif ($chk_directory_flg != 1) {
		@err_msg = ("-1","åоݤݥꥷƤޤ")
	}

# Ź沽ݥꥷե -> ƥȥݥꥷѴˤĤƤޤԤ
	chomp($conf[@conf-1]);
	return (@err_msg);

}

##################################################################
# ݥꥷ˵ҤƤɥᥤΥåоݤؿ #
# &GetCheckdirectory()                                           #
# ɥᥤ̾ݥꥷե                       #
# ｪλɥᥤꤵƤåо               #
# ۾ｪλ֤Σܤǡ-1                         #
# ܤǡ顼å                       #
##################################################################

sub GetCheckdirectory {

# ѿ
	local($chk_domain,*conf) = @_;
	my($i,$domain_flg);
	my(@chk_directory) = ();

# ݥꥷ⤫顢# ɥᥤ̾ startˤ򸡺
# ĤäΤϡˡ# åоݡˤ򸡺
	for ($i = 0; $i < @conf; $i++) {
		# ɥᥤγϤ򸫤Ĥ顢ɥᥤ̾νλ򸡽Фޤǡ
		# åоݤ̵ɤ
		if ($conf[$i] =~ /^#\s+$chk_domain\s+start\s*$/) {
			# ɥᥤ󤬸Ĥäե饰ΩƤ
			$domain_flg =1;
			while ($conf[$i] !~ /^#\s+$chk_domain\s+end\s*$/) {
				# UF,UC,DC,DFܥɥᥤνλθ
				if ($conf[$i] =~ /^#\s+start\s+DC\s*$/i) {
					push (@chk_directory,"DC");
				} elsif ($conf[$i] =~ /^#\s+start\s+DF\s*$/i) {
					push (@chk_directory,"DF");
				} elsif ($conf[$i] =~ /^#\s+start\s+UC\s*$/i) {
					push (@chk_directory,"UC");
				} elsif ($conf[$i] =~ /^#\s+start\s+UF\s*$/i) {
					push (@chk_directory,"UF");
				}
				$i++;
			}
			last;
		}
	}
	if ($domain_flg != 1) {
		push (@chk_directory,"-1","ݥꥷե˻ꤷɥᥤ¸ߤޤ󡣥ݥꥷǤޤǤ");
	}

	return (@chk_directory);
}

#############################################################
# ǡ١Υॢɻ߽ɽ  #
# &RunDbupdate()                                            #
# ѥե졼̤إ󥯤ե̾      #
# ̵֤͡ʤδؿǽλ                #
#############################################################

sub RunDbupdate {
    # ѿ
    my($phrase,$backpage) = @_;

    #### ॢɻ߽ ####
    if ( $pid = fork ) {
    # ƥץν
    
        # ǡ١ޥɼ¹
		system("/usr/sbin/tripwire -m i -P $phrase >/dev/null 2>&1");
	    $? = $?/1024;
	    if ($?) {
  	        if ($? == 2) {
    	        print "<FONT COLOR=red>ERROR_OR_FATAL:<BR>\n";
	            print "ǡ١ι˼Ԥޤ<BR>\n";
	            print "ݥꥷ꤬ȤʤäƤǽޤ<BR>\n";
  	        }
        } else {
            print "ǡ١ι˽λޤ<BR>\n";
        }
	    print "<A HREF=\"$backpage\">[BACK]</A>\n";
	    print "</BODY>\n";
	    print "</HTML>\n";
    
        system("kill $pid");
        exit(0);

    } elsif ( defined $pid ) {
    # ҥץν
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>ǡ١</TITLE>
</HEAD>
<BODY>
<TABLE><TR><TD></TD></TR></TABLE>
<HR>
ǡ١桦<BR>
END_OF_DATA
        # ˲ɽ褦ߡǡ
        print "<!--\n";
        print "A" x 1024;
        print "-->\n";

        $count = 0;
	    for(;;) {
		    if($count eq "0"){
		    print "<TABLE><TR><TD></TD></TR></TABLE>";
		    }elsif($count % 5){
			    print "";
		    }else{
			    print "<BR>";
		    }
		    # ॢбΤᡢSTDOUХåեեå夹롣
		    $buff = select(STDOUT);
		    $| = 1;
		    select($buff);
		    sleep 5;         # 5äޤ
		    $count++;
	    }
    }
}

######################################################################
# ֥ݥꥷեϿѤʸ                       #
# &MakeMiddlePolicy()                                                #
# :ɥᥤ̾åоݡåܡåоݳꥹ  #
# ｪλ :ݥꥷǼʸ                             #
# ۾ｪλ : -1 (ɥᥤ˥桼ͤ⤤ʤȤ)                 #
######################################################################
sub MakeMiddlePolicy {

	# ѿ
	local($chk_domain,$chk_directory,$chk_item,*nochk_file_list) = @_;
	my(@add_txt,$addpass);
	my(@user_list);
	my($i);

	# 䴰ѥ
	if (&cluster_typechk() eq "cluster") {
		$addpass = &GetMountpoint() . "web/";
	} else {
		$addpass = "/home/web/";
	}

	# åܤꤵʤäн
	if($chk_item eq "") {
		$chk_item = '+r -r';
	} else {
		$chk_item = "+r" . "$chk_item";
	}

	# 
	# ʸɲ
	push(@add_txt,"# start $chk_directory\n");

# UC,UF,DC,DF Σѥξʬ
############# ѥξʬ  #############
############ 桼ƥĤξ #################
	if ($chk_directory eq "UC") {
		#UC,UFξϡ桼ꥹȺ
		# 桼$addpass$chk_domain/users/۲ǥ쥯ȥ˼
		opendir (TDR , "$addpass$chk_domain/users/");
		@user_list = readdir(TDR);
		closedir (TDR);
		shift(@user_list); # ./  ä
		shift(@user_list); # ../ ä
        if ($user_list[0] eq "") {
            return ("-1");
        }

		# 桼оݳե
		foreach $user_name (@user_list) {
			# åܤꤹ
			push(@add_txt,"$addpass$chk_domain/users/$user_name/ftp/public_html/ -> $chk_item\;\n");
			# åоݳ
			for ($i=0;$i<@nochk_file_list;$i++) {
				if ($nochk_file_list[$i] eq "") {
					next;
				# եѥ䴰˳Ǽ
				} else {
					push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/public_html/$nochk_file_list[$i]\;\n");
				}
			}
		}
############ 桼ftpξ #################
	} elsif ($chk_directory eq "UF") {
		#UC,UFξϡ桼ꥹȺ
		# 桼$addpass$chk_domain/users/۲ǥ쥯ȥ˼
		opendir (TDR , "$addpass$chk_domain/users/");
		@user_list = readdir(TDR);
		closedir (TDR);
		shift(@user_list); # ./  ä
		shift(@user_list); # ../ ä
		if ($user_list[0] eq "") {
			return ("-1");
		}

		# 桼оݳե
		foreach $user_name (@user_list) {
			# åܤꤹ
			push(@add_txt,"$addpass$chk_domain/users/$user_name/ftp/ -> $chk_item\;\n");
			push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/lib/;\n");
			push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/bin/;\n");
			# public_htmlϡUCåƤ뤫ɤʬ
			@tmp = &GetPolicy("UC",$chk_domain);
			if ($tmp[0] eq "") {
				push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/public_html/;\n");
			} else {
				push(@add_txt,"#!$addpass$chk_domain/users/$user_name/ftp/public_html/;\n");
			}
			# åоݳꤹ
			for ($i=0;$i<@nochk_file_list;$i++) {
				if ($nochk_file_list[$i] eq "") {
					next;
				# եѥ䴰˳Ǽ
				} else {
					push(@add_txt,"!$addpass$chk_domain/users/$user_name/ftp/$nochk_file_list[$i]\;\n");
				}
			}
		}
############ ɥᥤ󥳥ƥĤξ #################
	} elsif ($chk_directory eq "DC") {
		# åܤꤹ
		push(@add_txt,"$addpass$chk_domain/htdocs/ -> $chk_item\;\n");
		# åоݳꤹ
		for ($i=0;$i<@nochk_file_list;$i++) {
			if ($nochk_file_list[$i] eq "") {
				next;
			# եѥ䴰˳Ǽ
			} else {
				push(@add_txt,"!$addpass$chk_domain/htdocs/$nochk_file_list[$i]\;\n");
			}
		}
############ ɥᥤftpξ #################
	} elsif ($chk_directory eq "DF") {
		# åܤꤹ
		push(@add_txt,"$addpass$chk_domain/ -> $chk_item\;\n");
		# 餫åоݳȤǥ쥯ȥꤹ
		push(@add_txt,"!$addpass$chk_domain/lib/;\n");
		push(@add_txt,"!$addpass$chk_domain/bin/;\n");
		push(@add_txt,"!$addpass$chk_domain/etc/;\n");
		push(@add_txt,"!$addpass$chk_domain/pub/;\n");
		push(@add_txt,"!$addpass$chk_domain/ftp/;\n");
		push(@add_txt,"!$addpass$chk_domain/users/;\n");
		# htdocsϡDCåƤ뤫ɤʬ
		@tmp = &GetPolicy("DC",$chk_domain);
		if ($tmp[0] eq "") {
			push(@add_txt,"!$addpass$chk_domain/htdocs/;\n");
		} else {
			push(@add_txt,"#!$addpass$chk_domain/htdocs/;\n");
		}
		# åоݳȤե롿ǥ쥯ȥꤹ
		for ($i=0;$i<@nochk_file_list;$i++) {
			if ($nochk_file_list[$i] eq ""){
				next;
			# եѥ䴰˳Ǽ
			} else {
				push(@add_txt,"!$addpass$chk_domain/$nochk_file_list[$i]\;\n");
			}
		}
	}
############# ѥξʬ ޤ #############

	# Ǹˡendդäơ񤭹ѥƥȴ
	push(@add_txt,"# end $chk_directory\n");

	return (@add_txt);
}

#############################################
# TripwireѤ뤿νԤ    #
# &TripInstall()                            #
# ̵                              #
# ｪλNULL                            #
# ۾ｪλ顼å                #
#############################################

sub TripInstall {

# 
# twpol.txt,twcfg.txtWbMCѤˤΤ֤
# twinstall.sh Ƥ񤭴Τ
# ƥݥ twinstall.sh ¹

# ѿ
	my($trip_init,$trip_init_lock,$i,$tmpfilename,$tmpfile_lock,$file_num,$err);
	local(@conf,@gettime);


# ݥꥷեΥԡ
	system("/bin/cp -pf /opt/nec/wbmc/adm/system/tripwire/wbmc_pol /etc/tripwire/twpol.txt");
	chmod(0600,"/etc/tripwire/twpol.txt");

# ֥եΥԡ
	system("/bin/cp -pf /opt/nec/wbmc/adm/system/tripwire/wbmc_pol /etc/opt/nec/wbmc/wbmc_middlepolicy");
	chmod(0600,"/etc/opt/nec/wbmc/wbmc_middlepolicy");

# եΥԡ
	system("/bin/cp -pf /opt/nec/wbmc/adm/system/tripwire/wbmc_cfg /etc/tripwire/twcfg.txt");
	chmod(0600,"/etc/tripwire/twcfg.txt");

# ĶեΥԡ
	system("/bin/cp -pf /opt/nec/wbmc/adm/system/tripwire/wbmc_tripconf /etc/opt/nec/wbmc/wbmc_tripconf");
	chmod(0600,"/etc/opt/nec/wbmc/wbmc_tripconf");

## twinstall.sh Υԡ
# ѥե졼ꤷ twinstall.sh ¹Ԥ
# twinstall.sh ɤ߹
# ݥꥷե
	$trip_init = "/etc/tripwire/twinstall.sh";
	$trip_init_lock = "twinstall.sh";

	@conf = ();
	if (!&readFile($trip_init, $trip_init_lock, *conf)) {
		$err = "ݥꥷեɤ߹ߤ˼Ԥޤ";
		goto done;
	}

# ǡù
# ѥե졼ڤӡ륭ե̾
	for($i=0;$i<@conf;$i++) {
		if($conf[$i] =~ s/^\s*(TW_SITE_PASS=)""/$1\"MaItrToxA\"/) {next;}
		if($conf[$i] =~ s/^\s*(TW_LOCAL_PASS=)""/$1\"MaItrToxA\"/) {next;}
		if($conf[$i] =~ s/^\s*(LOCAL_KEY=)".*"/$1\"\/etc\/tripwire\/local.key\"/) {last;}
	}

## ƥݥե̾
	@gettime = localtime(time);
	$tmpfilename = "tmp_tripinit-$gettime[2]-$gettime[1]-$gettime[0].sh";
	$tmpfile_lock = "$tmpfilename";
# /tmp۲ذư
	chdir("/tmp");

# ƥݥե˽񤭹
	if (!&writeFile("/tmp/$tmpfilename", $tmpfile_lock, @conf)) {
		$err = "Tripwire Υƥݥե˼Ԥޤ";
		goto done;
	}

### ƥݥե¹ ###
	$file_num = 0;
	$file_num = chmod(0700,"/tmp/$tmpfilename");
	if(!$file_num) {
		$err = "Tripwire ΥƥݥեΥѡߥåѹ˼Ԥޤ";
		goto done;
	}

# TripwireꥹץȤμ¹
	system("/bin/sh /tmp/$tmpfilename >/dev/null 2>&1");

### ¹Ը塢ƥݥեϺ ###
	$file_num = 0;
	$file_num = unlink("/tmp/$tmpfilename");
	if(!$file_num) {
		$err = "Tripwire Υƥݥեκ˼Ԥޤ";
		goto done;
	}

done:
	return($err);
}


######################################################################
# ݥꥷϿоݳե̾ǡüʸ""դ #
# &modPolChar()                                                      #
#    åоݳȤե̾                              #
# ֤ üʸ""ǰϤե̾                              #
######################################################################

sub modPolChar {

# ѿ
	my($char) = @_;

# üʸ""Ĥ֤

	$char =~ s/\!/"\!"/g;
	$char =~ s/\{/"\{"/g;
	$char =~ s/\}/"\}"/g;
	$char =~ s/\</"\<"/g;
	$char =~ s/\>/"\>"/g;
	$char =~ s/\(/"\("/g;
	$char =~ s/\)/"\)"/g;
	$char =~ s/\s/" "/g;
	$char =~ s/\,/"\,"/g;
	$char =~ s/\;/"\;"/g;
	$char =~ s/\=/"\="/g;
	$char =~ s/\$/"\$"/g;
	$char =~ s/\#/"\#"/g;
	$char =~ s/\|/"\|"/g;
	$char =~ s/\'/"\'"/g;
	$char =~ s/\+/"\+"/g;

	return ($char);

}


1;
