#!/usr/bin/perl

$WBMC_SERVERS_CONF = "/etc/opt/nec/wbmc/servers.conf";
$WBMC_SERVERS_LOG = "/var/log/getdata";
$WBMC_GETDATA_PID = "/var/run/getdata.pid";
$WBMC_MSVD_PID = "/var/run/wbmcmsvd.pid";

# ̾
#   msvshowErrorPage - 顼åɽ
# 
#   msvshowErrorPage($message, $page)
# 
#   $message ɽ륨顼å
#       ꤷʤ""ꤹȡ"ϼԤޤ"ɽ
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
# 
#   ʤ
#
sub msvshowErrorPage
{
    my($message, $page) = @_;
    my($msg);

    if (!defined($message) || $message eq "") {
    $msg = "ϼԤޤ";
    } else {
    $msg = $message;
    }

    &msvshowMessagePage("顼", $msg, $page);
}

#
# ̾
#   msvshowResultPage - ()ɽ
# 
#   msvshowResultPage($message, $page, $page2)
# 
#   $message ɽ̥å
#       ꤷʤ""ꤹȡ"ޤ"ɽ
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
#   $page2 ɲåܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡܥΤɽʤ
# 
#   ʤ
#
sub msvshowResultPage
{
    my($message, $page, $page2) = @_;
    my($msg);

    if (!defined($message) || $message eq "") {
    $msg = "ޤ";
    } else {
    $msg = $message;
    }

    &msvshowMessagePage("", $msg, $page, $page2);
}

#
# ̾
#   msvshowMessagePage - åɽ()
#           showErrorPageshowResultPageμ
# 
#   msvshowMessagePage($title, $message, $page, $page2)
# 
#   $title ɽ륿ȥ
#   $message ɽå
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
#   $page2 ɲåܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡܥΤɽʤ
# 
#   ʤ
#
sub msvshowMessagePage
{
    my($title, $message, $page, $page2) = @_;
    my($newpage, $newpage2);

    if (!defined($page) || $page eq "") {
    $newpage = "history.back()";
    } else {
    $newpage = "location.href='$page'";
    }

    if (!defined($page2) || $page2 eq "") {
    $newpage2 = "";
    } else {
    $newpage2 = "<INPUT TYPE='button' VALUE='ɲ' onClick=\"location.href='$page2'\">";
    }

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY BGCOLOR="#E0FFFF">
<H4 ALIGN="center" COLOR="#7B68EE">$title</H4>
<HR>

<CENTER>
 <FORM>
  <TABLE BGCOLOR="#F0F8FF" WIDTH=300 BORDER=1 CELLSPACING=0 CELLPADDING=1>
   <TR BGCOLOR="#000080">
    <TD>
     <FONT COLOR="#FFFFFF"> <B>$title</B></FONT>
    </TD>
   </TR>
   <TR>
    <TD>
     <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD>
        $message
       </TD>
      </TR>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD ALIGN="center">
        <INPUT TYPE="button" VALUE="" onClick=$newpage>
        $newpage2
       </TD>
      </TR>
     </TABLE>
    </TD>
   </TR>
  </TABLE>
 </FORM>
</CENTER>

</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------
}


#
# ̾
#   msvreadParam - եफΥѥ᡼ɤ߹
# 
#   msvreadParam()
# 
#   ʤ
# 
#   ΤȤʸ
#   ԤΤȤ顼å
#
sub msvreadParam
{
    local($err, $buf, $name, $value);

    if ($ENV{'REQUEST_METHOD'} eq "POST") {
        read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
    } elsif ($ENV{'REQUEST_METHOD'} eq "GET") {
        $buf = $ENV{'QUERY_STRING'};
    } else {
        $err = "Invalid request method.";
        return($err);
    }

    foreach (split(/&/, $buf)) {
        ($name, $value) = split(/=/);
        $value =~ tr/+/ /;
        $value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
        $FORM{$name} = $value;
    }

    return($err);
}

#
# ̾
#   msvgetNavigation - ʥӥС֤
# 
#   msvgetNavigation($name1, $page2, $name2, $page2, ...)
# 
#   $nameN ɽ̾
#       _backб
#       _helpϥإפб
#   $pageN Ȥɽڡ
#       ꤷʤ""ꤹȡ󥯤ɽʤ
#       ΤȤ_back_helpξ̾ɽʤ
# 
#   ʥӥС(ʸ)
#
sub msvgetNavigation
{
    my(@argv) = @_;

    my(@name);
    my(@page);
    my($backpage);
    my($helppage);
    my($i);
    my($buf);

    $backpage = "";
    $helppage = "";
    for ($i = 0; $i <= $#argv; $i++) {
    if ($argv[$i] eq "_back") {
        if (($i + 1) <= $#argv) {
        $backpage = $argv[$i + 1];
        $i++;
        }
    } elsif ($argv[$i] eq "_help") {
        if (($i + 1) <= $#argv) {
        $helppage = $argv[$i + 1];
        $i++;
        }
    } else {
        push(@name, $argv[$i]);
        if (($i + 1) <= $#argv) {
        push(@page, $argv[$i + 1]);
        $i++;
        } else {
        push(@page, "");
        }
    }
    }

    $buf = ""
    . "<TABLE WIDTH='100%'>\n"
    . " <TR>\n"
    . "  <TD ALIGN='left'>\n";

    for ($i = 0; $i <= $#name; $i++) {
    if ($page[$i] ne "") {
        $buf .= "   <A HREF='$page[$i]'>$name[$i]</A> &gt;\n";
    } else {
        $buf .= "   $name[$i]\n";
    }
    }

    $buf .= ""
    . "  </TD>\n"
    . "  <TD ALIGN='right'>\n";

    if ($backpage ne "") {
    $buf .= "   <A HREF='$backpage'>[]</A>\n";
    }
    if ($helppage ne "") {
    $buf .= "   <A HREF='$helppage' TARGET='help'>[إ]</A>\n";
    }

    $buf .= ""
    . "  </TD>\n"
    . " </TR>\n"
    . "</TABLE>\n";

    return($buf);
}

#
# ̾
#   readDataFile - եɤƤ֤
# 
#   readDataFile($filename, *line)
# 
#   $filename ɤ߹ե̾
#   *line եƤ
# 
#    1
#    NULL
#
sub readDataFile
{
    local($filename, *line) = @_;

    local(*IN);
    my($ret);

    $ret = "";

    if ($filename eq "") {
    goto done;
    }


    # ե򥪡ץ󤷤ɤ߹
    if (!open(IN, $filename)) {
    goto done;
    }

    @line = <IN>;
    close(IN);

    $ret = 1;

done:

    return($ret);
}

# եåΥ⡼
$DATA_LOCK_R_B = 1; # ɤ߹ߥå(֥å⡼)
$DATA_LOCK_W_B = 2; # 񤭹ߥå(֥å⡼)
$DATA_LOCK_R_NB = 5;    # ɤ߹ߥå(Υ֥å⡼)
$DATA_LOCK_W_NB = 6;    # 񤭹ߥå(Υ֥å⡼)
$WBMC_VAR_DIR = "/var/opt/nec/wbmc";

#
# ̾
#   lockDataFile - ꤵ줿ե˥å򤫤
# 
#   lockDataFile($lockfile, $mode, *LOCK)
# 
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   $mode åΥ⡼(β줫)
#       $DATA_LOCK_R_B  ɤ߹ߥå(֥å⡼)
#       $DATA_LOCK_W_B  񤭹ߥå(֥å⡼)
#       $DATA_LOCK_R_NB ɤ߹ߥå(Υ֥å⡼)
#       $DATA_LOCK_W_NB 񤭹ߥå(Υ֥å⡼)
#   *LOCK եϥɥ
#       åˤϤΥեϥɥclose
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub lockDataFile
{
    local($lockfile, $mode, *LOCK) = @_;

    my($ret);
    my($lockdir);

    $ret = 0;
    $lockdir = "$WBMC_VAR_DIR/lock";

    if ($lockfile eq "") {
    goto done;
    }

    # åեѤΥǥ쥯ȥ(̵)
    if (! -d $lockdir) {
    if (!mkdir($lockdir, 0755)) {
        goto done;
    }
    }

    # åե򥪡ץ󤹤
    if (!open(LOCK, "> $lockdir/$lockfile")) {
    goto done;
    }

    # å򤫤
    if (!flock(LOCK, $mode)) {
    close(LOCK);
    goto done;
    }

    $ret = 1;

done:
    return($ret);
}


#
# ̾
#   writeDataFile - ꤵ줿Ƥե˽񤭹(åդ)
# 
#   writeDataFile($filename, $lockfile, @line)
# 
#   $filename 񤭹ե̾
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   @line ե˽񤭹Ƥ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub writeDataFile
{
    local($filename, $lockfile, @line) = @_;

    local(*LOCK);
    local(*OUT);
    my($ret);
    my($lockfileflag);
    my($tmpfile);
    my($filemode);

    $ret = 0;
    $lockfileflag = 0;
    $tmpfile = "$filename.$$";

    if ($filename eq "") {
    goto done;
    }

    if ($lockfile ne "") {
    # 񤭹ߥå(֥å⡼)򤫤
    if (&lockDataFile($lockfile, $DATA_LOCK_W_B, *LOCK) == 0) {
        goto done;
    }
    $lockfileflag = 1;
    }

    # ȥե򥪡ץ󤷤ƽ񤭹
    if (!open(OUT, "> $tmpfile")) {
    goto done;
    }

    if (!print(OUT @line)) {
    close(OUT);
    goto done;
    }
    close(OUT);

    # եΥ⡼ɤ
    if (-e $filename) {
    $filemode = (stat($filename))[2];
    } else {
    $filemode = 0644;
    }

    # Υե˥͡ह
    if (!rename($tmpfile, $filename)) {
    goto done;
    }

    # եΥ⡼ɤꤹ
    chmod($filemode & 07777, $filename);

    $ret = 1;

done:
    if ($lockfileflag != 0) {
    close(LOCK);
    }

    if (-f $tmpfile) {
    unlink($tmpfile);
    }

    return($ret);
}



#
# ̾
#   server_TypeChk - Фαѷ֤
# 
#   server_TypeChk
# 
#   ʤ
# 
#   ɥ     Standalone
#   ե륪Х饹   MailCluster
#   ɥХ WebLoadbalance
#				NG
sub server_TypeChk
{
	local($filename) = "";
	local(@line) = ();
	my($i, $cluster_type) = "";
	$cluster_type = "NG";

	# 饹פ

	$filename = "/etc/opt/nec/wbmc/INITCONF.INI";
	if(!(&readDataFile("$filename", *line))){
		$cluster_type = "NG";
	}else{
	   	for ($i = 0; $i < @line; $i++) {
			if($line[$i] =~ /^WorkMode=(.+)/){
				$cluster_type = $1;
				$cluster_type =~ s/^\s*//;
			}
		}
	} 
	return($cluster_type);
}

#
# ̾
#   cluster_MasterChk - Фޥ졼֤
# 
#   cluster_MasterChk
# 
#   ʤ
# 
#   ɥnull
#   ޥ        master
#   졼      slave
#
sub cluster_MasterChk
{
	my($filename,$type);
	local(*MT);
	local($cluster_type);
	my(@line);
	
	$type = "";
	$cluster_type = &server_TypeChk();
	if ($cluster_type eq "MailCluster") {
		# 饹פ
		if(-d "/home/.wbmc/.wbmcsys/") {
			$type = "master";
	    } else {
			$type = "slave";
		}
	} elsif ($cluster_type eq "WebLoadbalance") {
		# 饹פ
		$filename = "/etc/opt/nec/cluster_flg";
		if (-e $filename) {
			if (open(MT, $filename)) {
				@line = <MT>;
				close(MT);
				
				if (defined($line[0])) {
					$line[0] =~ s/^\s*//;
					$line[0] =~ s/\s*$//;
					if ($line[0] ne "") {
						$type = $line[0];
					}
				}
			}
	  }
	}
	return $type;
}

#
# ̾
#   server_IP - 饹Ʊ롼פΥФΣɣХɥ쥹֤
# 
#   server_IP
# 
#   ʤ
# 
#			饹Ʊ롼פΥФΣɣХɥ쥹
#			̥
#


sub server_IP
{
	local($filename) = "";
	local(@line) = "";
	local(@ent) = "";
	my($i, $ipadd) = "";

	# 饹פ

	$filename = "/etc/opt/nec/cluster_server";
	if(&readDataFile("$filename", *line)){
   	for ($i = 0; $i < @line; $i++) {
			#$ipadd .= "(split(/\s+/,$line[$i]))[0]\n";
			#@ent = split(/\s+/,$line[$i]);
			@ent = split(/\s/,$line[$i]);
			$ipadd .= $ent[0];
			$ipadd .= "\n";
		}
	}
 	return $ipadd;
}

#
# ̾
#   serverTitle - а̤Ǥαѷ֤ɽ
# 
#   serverTitle($servertitle, $type)
# 
#   $servertype	Фαѷ
#		$type		ȥ뤫롼פڤʬ
# 
#		ɽ뤿ξ
#

sub serverTitle
{
	my($servertitle, $type) = @_;
	my($body);

	if($type eq "title"){
		$body .= "<TR BGCOLOR=\"#003399\">\n";
		$body .= "<TD COLSPAN=\"4\"><FONT COLOR=\"#FFFFFF\"> <B>$servertitle</B></FONT></TD>\n";
		$body .= "</TR>\n";
	}elsif($type eq "group"){
		$body .= "<TR BGCOLOR=\"#006699\">\n";
		$body .= "<TD COLSPAN=\"4\"><FONT COLOR=\"#FFFFFF\"> <B>$servertitle</B></FONT></TD>\n";
		$body .= "</TR>\n";
	}
	return($body);
}

#
# ̾
#   serverScreen - а̤ǤγƥФɽ
# 
#   serverScreen($one, $ipadd, $host, $comment, $port)
# 
#   $one		мΤλȽǷ
#		$ipadd	ФIPɥ쥹
#		$host		ФΥۥ̾
#		$comment	
#		$port		ManagementConsoleportֹ
# 
#		ɽ뤿ξ
#

sub serverScreen
{
	my($one, $ipadd, $host, $comment, $port, $type) = @_;
	my($body, $num, $tcolor) = "";
	
	if($type){
		if($type == 20 || $type ==30){
			$tcolor = "BGCOLOR = \"#99FF99\"";
		}
	}

	if($one eq "off"){
		$body .= "<TR>\n";
		$body .= "<TD><CENTER>\n";
		$body .= "<INPUT TYPE=\"button\" VALUE=\"ܺ\" onClick=\"location.href='./servers2.cgi?$ipadd'\"><BR>\n";
		$body .= "<INPUT TYPE=\"button\" VALUE=\"Խ\" onClick=\"location.href='./servermod.cgi?$ipadd'\">";
		$body .= "<INPUT TYPE=\"button\" VALUE=\"\" onClick=\"funcDelete('$ipadd','$host')\"></CENTER></TD>\n";
		$body .= "<TH>$host</TH>\n";
		$body .= "<TH>$ipadd</TH>\n";
		$body .= "<TH>$comment</TH>\n";
		$body .= "</TR>\n";
	}elsif($one eq "on"){
		$body .= "<TR $tcolor>\n";
		$body .= "<TD><CENTER>\n";
		$body .= "<INPUT TYPE=\"button\" VALUE=\"ܺ\" onClick=\"location.href='./servers2.cgi?$ipadd'\"><BR>\n";
		$body.= "<INPUT TYPE=\"button\" VALUE=\"Խ\" onClick=\"location.href='./servermod.cgi?$ipadd'\">";
		$body .= "<INPUT TYPE=\"button\" VALUE=\"\" onClick=\"funcDelete('$ipadd','$host')\"></CENTER></TD>\n";
		if($port == 50090){
			$body .= "<TH><A href=\"http://$ipadd:$port/\" TARGET=\"_blank\">$host</A></TH>\n";
		}elsif($port == 50453){
			$body .= "<TH><A href=\"https://$ipadd:$port/\" TARGET=\"_blank\">$host</A></TH>\n";
		}
		$body .= "<TH>$ipadd</TH>\n";
		$body .= "<TH>$comment</TH>\n";
		$body .= "</TR>\n";
	}
	return($body);
}

#
# ̾
#   writeDataLog - wbmcѥɲ
# 
#   writeDataLog($message, $tag, $file)
# 
#   $message ɲäå
#   $tag     ˵Ҥ륿̾(ޥ̾)
#   $file    Ҥե̾
# ϥեޥå
#   YYYY/MM/DD hh:mm:ss TAG: MESSAGE ...
# 
#   λ 1
#   Ԥλ 0
#
sub writeDataLog {
    my($message, $tag, $file) = @_;
    local(*OUT);
    my($time);
    my($ret);

    $ret = 0;

    if ($file eq "") {
        goto done;
    }
    $time = &getTime();
    if (!open(OUT, ">> $file")) {
        goto done;
    }
    if (!flock(OUT, $DATA_LOCK_W_B)) {
        goto done;
    }
    if (!print OUT "$time $tag: $message\n") {
        goto done;
    }
    close(OUT);

    $ret = 1;

done:
    return(1);
}

#
# ̾
#   getTime - ߤλ
# 
#   getTime()
# 
#   ʤ
# 
#   ߤλ(ʸ)
#
sub getTime
{
    local($year, $mon, $mday, $hour, $min, $sec);

    ($sec, $min, $hour, $mday, $mon, $year) = localtime();
    return(sprintf("%04d/%02d/%02d %02d:%02d:%02d",
    $year + 1900, $mon + 1, $mday, $hour, $min, $sec));
}

#
# ̾
#   ServersShow - TOP̤˳ƥФΥǡɽ
# 
#   ServersShow($sort, $sort_befor, *line)
# 
#  	@sote	Ȥξ
#		*line ƾ֤Υǡ
# 
#   ɽΤΥǡ
#
sub ServersShow
{
# Ƽ掠ФɬפʾΤ
	local($sort, *line) = @_;
	my($j, $flg, $body) = "";
	my($ipadd, $host_f, $type_f, $url_f, $one_f, $comment_f) = "";
	my(@keywords) = ();
	my(@slines) =();
	local($i, $ip, $type, $url, $one, $comment, $title) = "";
	local(@host) = ();

	if(!@line){
		goto done;
	}

	$flg = 0;
	for($i = 0; $i < @line; $i++){
		if($line[$i] =~ /<SERVER\s+(.+)>/){
			$ipadd = "";
			$ipadd = $1;
			$ipadd =~ s/\s+//g;
			$flg = 1;
		}elsif($line[$i] =~ /<\/SERVER>/){

# ۥ̾򥽡Ȥ뤿ν

			push(@host,$host_f);
			$ip{$host_f} = $ipadd;
			$type{$host_f} = $type_f;
			$url{$host_f} = $url_f;
			$one{$host_f} = $one_f;
			$comment{$host_f} = $comment_f;
			$flg = 0;
		}
	

		if($flg ==1){
			if($line[$i] =~ /^HOST/){
				$host_f = (split(/\s+/,$line[$i]))[1];
			}elsif($line[$i] =~ /^TYPE/){
				$type_f = (split(/\s+/,$line[$i]))[1];
			}elsif($line[$i] =~ /^PORT/){
				$url_f = (split(/\s+/,$line[$i]))[1];
			}elsif($line[$i] =~ /^ONE/){
				$one_f = (split(/\s+/,$line[$i]))[1];
			}elsif($line[$i] =~ /^COMMENT/){
				$comment_f = (split(/\s+/,$line[$i]))[1];
				if(!($comment_f)){
					$comment_f = "<BR>";
				}
			}
		}
	}

# ƾ֤Υȥ

	if($type{$host[0]} eq ""){
		$title = "";
	}elsif($type{$host[0]} == 10){
		$title = "ɥ";
	}

	$body .= &serverTitle("$title", "title");

# ۥ̾򥭡˥

	if ($sort == 1) {
		@keywords = sort { $a cmp $b } (@host);# 
	} else {
		@keywords = sort { $b cmp $a } (@host);# ߽
	}

# ɽ

	for($i = 0; $i < @keywords; $i++){
		$body .= &serverScreen($one{$keywords[$i]}, $ip{$keywords[$i]}, $keywords[$i], $comment{$keywords[$i]}, $url{$keywords[$i]});
	}

done:

return($body);
}

#
# ̾
#   ServersShow_2 - TOP̤˳ƥФΥǡɽ
# 
#   ServersShow_2($sort, $sort_befor, *line)
# 
#  	$sote	Ȥξ
#		$sort_befor Ȥΰ
#		*line ƾ֤Υǡ
# 
#   ɽΤΥǡ
#
sub ServersShow_2
{
# Ƽ掠ФɬפʾΤ
	local($sort, *line) = @_;
	my($flg, $body, $flg_g) = "";
	my($j, $host_fg, $ipadd, $host_f, $type_f, $url_f, $one_f, $comment_f) = "";
	my(@keywords) = ();
	my(@slines) =();
	my(@group) = ();
	local($i, $k,  $ip, $type, $url, $one, $comment, $title, $count) = "";
	local(@host) = ();

	$flg = 0;
	for($i = 0; $i < @line; $i++){
		if($line[$i] =~ /<SERVER\s+(.+)>/){
			$ipadd = "";
			$ipadd = $1;
			$flg = 1;
			splice(@line, $i, 1);
			$i--;
		}elsif($line[$i] =~ /<\/SERVER>/){
			push(@host,$host_f);
			$ip{$host_f} = $ipadd;
			$type{$host_f} = $type_f;
			$url{$host_f} = $url_f;
			$one{$host_f} = $one_f;
			$comment{$host_f} = $comment_f;
			$flg = 0;
			splice(@line, $i, 1);
			$i--;

# Ʊ롼פΥФξμˤ
			if(@group){
				for($j = 0; $j < @group; $j++){
				$flg_g = 0;
				for($k = 0; $k < @line; $k++){
					if($line[$k] =~ /^<SERVER\s+(.+)>/){
							$ipadd = "";
							$ipadd = $1;
							if($group[$j] eq $ipadd){
								$flg_g = 1;
								splice(@line, $k, 1);
								$k--;
								next;
							}
						}
					
						if($flg_g != 1){
							next;
						}else{
							if($line[$k] =~ /^HOST/){
								$host_fg = (split(/\s+/,$line[$k]))[1];
								splice(@line, $k, 1);
								$k--;
							}elsif($line[$k] =~ /^PORT/){
								$url_f = (split(/\s+/,$line[$k]))[1];
								splice(@line, $k, 1);
								$k--;
							}elsif($line[$k] =~ /^TYPE/){
								$type_f = (split(/\s+/,$line[$k]))[1];
								splice(@line, $k, 1);
								$k--;
							}elsif($line[$k] =~ /^GROUP/){
								splice(@line, $k, 1);
								$k--;
							}elsif($line[$k] =~ /^ONE/){
								$one_f = (split(/\s+/,$line[$k]))[1];
								splice(@line, $k, 1);
								$k--;
							}elsif($line[$k] =~ /^COMMENT/){
								$comment_f = (split(/\s+/,$line[$k]))[1];
								splice(@line, $k, 1);
								$k--;
								if(!($comment_f)){
									$comment_f = "<BR>";
								}
							}elsif($line[$k] =~ /^<\/SERVER>/){
								push(@host,$host_fg);
								$ip{$host_fg} = $ipadd;
								$type{$host_fg} = $type_f;
								$url{$host_fg} = $url_f;
								$one{$host_fg} = $one_f;
								$comment{$host_fg} = $comment_f;
								$flg_g = 0;
								splice(@line, $k, 1);
								$k--;
								last;
							}
						}
					}
				}
			}
		}
		if($flg ==1){
			if($line[$i] =~ /^HOST/){
				$host_f = (split(/\s+/,$line[$i]))[1];
				splice(@line, $i, 1);
				$i--;
			}elsif($line[$i] =~ /^TYPE/){
				$type_f = (split(/\s+/,$line[$i]))[1];
				splice(@line, $i, 1);
				$i--;
			}elsif($line[$i] =~ /^PORT/){
				$url_f = (split(/\s+/,$line[$i]))[1];
				splice(@line, $i, 1);
				$i--;
			}elsif($line[$i] =~ /^ONE/){
				$one_f = (split(/\s+/,$line[$i]))[1];
				splice(@line, $i, 1);
				$i--;
			}elsif($line[$i] =~ /^COMMENT/){
				$comment_f = (split(/\s+/,$line[$i]))[1];
				splice(@line, $i, 1);
				$i--;
				if(!($comment_f)){
					$comment_f = "<BR>";
				}
			}elsif($line[$i] =~ /^GROUP/){
				#$group_f =(split(/\s+/,$line[$i]))[1];
                                @ent = split(/\s+/,$line[$i]);
                                $group_f = $ent[1];
				splice(@line, $i, 1);
				$i--;
				@group = ();
				if($group_f){
					@group = split(/:/,$group_f);
				}
			}
		}
# ե륪ФӥɥХ󥹤ΤȤΤ߽Ԥ

		if(($type{$host[0]} != 10) && (@host)){
			$count++;
# ƾ֤Υȥ
			if($count == 1){
				if(($type{$host[0]} == 20) || ($type{$host[0]} == 21)){
					$title = "ե륪з";
				}elsif(($type{$host[0]} == 30) || ($type{$host[0]} == 31)){
					$title = "ɥХ󥹷";
				}
				$body .= &serverTitle("$title","title");
			}
			
			$body .= &serverTitle("롼$count","group");

# ۥ̾򥭡˥Ȥ롣

			if ($sort == 1) {
				@keywords = sort { $a cmp $b } (@host);# 
			} else {
				@keywords = sort { $b cmp $a } (@host);# ߽
			}


# ɽ

			for($j = 0; $j < @keywords; $j++){
				$body .= &serverScreen($one{$keywords[$j]}, $ip{$keywords[$j]}, $keywords[$j], $comment{$keywords[$j]}, $url{$keywords[$j]}, $type{$keywords[$j]});
			}
			@host = ();
		}
	}
return($body);
}

# ̾
#   JugmentService - ӥξ˹碌Ƥطʿοʬ
# 
#   JugmentService($servicename)
# 
#   $service ƥӥεư
# 
#		ɽ
#
sub JugmentService
{
	local($service) = @_;
	my($jug);

	$jug = "";
	if($service eq "on"){
		$jug = "<TH BGCOLOR='#CCFF99' NOWRAP><FONT COLOR = '#008000'>ư</FONT></TH>\n";
	}else{
		$jug = "<TH BGCOLOR='#FFD0D0' NOWRAP><FONT COLOR='#FF0000'></FONT></TH>\n";
	}
	return($jug);
}

# ̾
#   Screen - ƥӥɽ
# 
#   Screen($name,$service)
# 
#   $name ƥӥ̾
#   $service ƥӥεư
# 
#		ɽ
#
sub Screen
{
	local($name, $service) = @_;
	my($screen);
	$screen .= "<TR>\n";
	$screen .= "<TH ALIGN=\"left\">$name</TH>\n";
	$screen .= &JugmentService($service);
	$screen .= "</TR>\n";
	return($screen);
}

#
# ̾
#   msvcheckAppDomainName - ɥᥤ̾ηå
# 
#   msvcheckAppDomainName($domain)
# 
#   $domain ɥᥤ̾
#     ʸػ
#     ǤƬ a-z, 0-9ǹƤ뤳
#     Ǥʸ a-z, 0-9, ϥե(-)ǹƤ뤳
#     ġǤ163ʸǤ뤳
#     Τ1230ʸǤ뤳
#     ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub msvcheckAppDomainName
{
    my($domain) = @_;
    my($ret);
    my($len);
    my(@ent);
    my($i);

    $ret = 0;

    if (!defined($domain) || $domain eq "") {
    goto done;
    }
    if ($domain =~ /^\./) {
    goto done;
    }
    if ($domain =~ /\.$/) {
    goto done;
    }


    $len = length($domain);
    if (!&msvcheckNum($len, 1, 230)) {
    goto done;
    }

    if ($domain =~ /^[0-9\.]+$/) {
    goto done;
    }

    @ent = split(/\./, $domain);
    for ($i = 0; $i <= $#ent; $i++) {
    $len = length($ent[$i]);
    if (!&msvcheckNum($len, 1, 63)) {
        goto done;
    }

    if ($ent[$i] !~ /^[a-z0-9]([a-z0-9\-]*[a-z0-9]|)$/) {
        goto done;
    }
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   msvcheckNum - ͤꤵ줿ϰϤˤ뤫ɤå
# 
#   msvcheckNum($num, $min, $max)
# 
#   $num 
#   $min Ǿ
#   $max 
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub msvcheckNum
{
    my($num, $min, $max) = @_;
    my($ret);

    $ret = 0;

    if (!defined($num) || $num eq "") {
    goto done;
    }
    if ($num =~ /\D+/) {
    goto done;
    }
    if ($num < $min || $num > $max) {
    goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   msvipAddrCheck - IPɥ쥹Υ󥿥ååԤ
# 
#   msvipAddrCheck($addr)
# 
#   $addr ɥåɽIPɥ쥹
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub msvipAddrCheck
{
    local($addr) = @_;

    if ($addr !~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
        return(0);
    }

    if (($1 < 0) || (255 < $1)
     || ($2 < 0) || (255 < $2)
     || ($3 < 0) || (255 < $3)
     || ($4 < 0) || (255 < $4)) {
        return(0);
    }

    return(1);
}


1;

