#!/usr/bin/perl

# Copyright (C) 2000-2002 NEC Corporation
# All Rights Reserved.

# RCS: $Id: confinit.pl,v 1.55 2005/09/26 11:59:36 snavi Exp $

##000802 v4.1 require mail.pl  Hori
##000802 v4.1 require account.pl Υѥѹ Hori
##000804 v4.1 require dir.pl  Hori
##000910 v4.1 10eб Seki
##001009 v4.1 wbmcipchains Haramoto
##001109 v5.1 WebLoadbalance by haramoto
##001110 v5.1 Appliance3.0 б
##001120 v5.1 WebLoadbalance(sshd)б haramoto
##001121 v5.1 WebLoadbalance()б haramoto
##010305 v4.0.1 cluster б  Chikita
##010327 v4.0.1 [Mail]ɲ seki
##010704 v4.1.0  \Q  \E б S.Oku
##010713 v4.10 wbmcdaily delete.     haramoto
##011106 v4.3.0 ƥ̾ѹǽɲ  oku
##020123 v5.0.0 ѥɷ絡ǽɲ(/usr/sbin/chpasswd -> /usr/bin/passwd) Hori
##020116 v5.0 tripwire νɲ murakami
##020926 v5.0.1 RedHatѤxinetd.dν(wu-ftpd,telnet)ɲ matumura
##021008 v5.0.1 openldapɲ oyama
##030325 v5.1.0 hosts.allow  sshd,snmpd,in.telnetd,in.ftpd,portmap ɲ


#
# 
#   եγƹܤ˽ƼեνԤ
#   ƳFDˤ뵯ưWbMCΥͥåȥαĹǸƤФ롣
#
# Ϣե
#   INITCONF.INI
#   /etc/opt/nec/wbmc/INITCONF.INI
#   /etc/passwd
#   /etc/shadow
#   /etc/shells
#   /etc/ftpusers
#   /etc/crontab			##010713 delete.
#   /etc/sysconfig/network
#   /etc/sysconfig/network-scripts/ifcfg-*
#   /etc/HOSTNAM
#   /etc/hosts
#   /etc/resolv.conf
#   /etc/hosts.allow
#   /etc/inetd.conf
#   /etc/xinetd.d (/etc/xinetd.d/wu-ftp, /etc/xinetd.d/telnet)	##020926 matumura
#   /etc/opt/nec/wbmc/Ipchains.conf
#   /etc/opt/nec/wbmchttpd/conf/*
#   /etc/named.conf
#   /var/named/*
#   /etc/httpd/conf/*
#   /home/webalizer/*
#   /etc/sendmail.cf
#   /etc/dhcpd.conf
#   /etc/rc.d/init.d/dhcpd
#   /etc/squid/squid.conf
#   /etc/smb.conf
#   /etc/logrotate.d/syslog     ##001121 add haramoto
#   /etc/tripwire/twinstall.sh     ##020116 add murakami
#
# եν
#   [WbMC]
#   WorkMode= [ Standalone | MailCluster | WebLoadbalance ]
#   ParSize=                    ##010414 add
#
#   [Config]
#   GroupName=
#
#   [IPLB]
#   IplbType= [ Coor | Back ]
#
#   [Account]
#   RootPassword=
#   RootPasswordAgain=
#
#   [IfEth0]
#   HostName= ShortHostName.DomainName
#   IpAddr=
#   NetMask=
#   Gateway=
#   PrimaryNameServer=
#   SecondaryNameServer=
#   ShortHostName=    # HostName
#   DomainName=       # HostName
#
#   [IfEth1]
#   IpAddr=
#   NetMask=
#
#   [Mail]
#   TransMode=SmartHost
#   SmartHostName= FQDN
#   DirectHostName= FQDN ...
#

#
# 饤֥ɤ߹
#
require "/opt/nec/wbmc/lib/wbmc.pl";
require "/opt/nec/wbmc/lib/dns/hosts2zone.pl";
require "/opt/nec/wbmc/domain/adm/httpd/dir.pl";
require "/opt/nec/wbmc/domain/adm/account/account.pl";
require "/opt/nec/wbmc/adm/service/01httpd/server.pl";
require "/opt/nec/wbmc/adm/service/11sendmail/mail.pl";
#require "/opt/nec/wbmc/adm/service/samba/samba.pl";
require "/opt/nec/wbmc/adm/domain/domainalldel.pl";
require "/opt/nec/wbmc/adm/system/tripwire/tripwire.pl"; ##020116 add murakami
require "/opt/nec/wbmc/lib/cert.pl";

#
# Ƽ
#
sub confInit
{
    my($filename) = @_;

    # INITCONF.INIɤ߹
    # confinit ˤƸƤӽФѤ
#   if ($err = &readConfFile($filename)) {
#       goto done;
#   }

    # ѥ᡼å
    # confinit ˤƸƤӽФѤ
#   if ($err = &checkConfParam()) {
#       goto done;
#   }

    # (/etc/passwd)
    # (/etc/shadow)
    if ($err = &writeShadow()) {
        goto done;
    }

    # (/etc/shells)
    if ($err = &writeShells()) {
        goto done;
    }

    # (/etc/ftpusers)
    # Υ桼ftpԲĤˤ
#    if ($err = &writeFtpUsers()) {
#       goto done;
#    }

    # (/etc/lftp.conf)
    if ($err = &writeLftpConf()) {
        goto done;
    }

    # (/etc/fstab)
    # ($homedir/aquota.user)
    # ($homedir/aquota.group)
    if ($err = &writeFstab()) {
        goto done;
    }

##010713 
##    # (/etc/crontab)
##    if ($err = &writeCrontab()) {
##        goto done;
##    }

    # (/etc/sysconfig/network)
    if ($err = &writeNetwork()) {
        goto done;
    }

    # (/etc/sysconfig/network-scripts/ifcfg-*)
    if ($err = &writeInterface()) {
        goto done;
    }

    # (/etc/HOSTNAME)
    if ($err = &writeHOSTNAME()) {
        goto done;
    }

    # (/etc/hosts)
    if ($err = &writeHosts()) {
        goto done;
    }

    # (/etc/resolv.conf)
    if ($err = &writeResolvConf()) {
        goto done;
    }

    # (/etc/hosts.allow)
    if ($err = &writeHostsAllow()) {
        goto done;
    }

    # (/etc/hosts.deny)
    if ($err = &writeHostsDeny()) {
        goto done;
    }

    # (/etc/inetd.conf)
    # xinetdѹˤ
#    if ($err = &writeInetdConf()) {
#        goto done;
#    }

    # (/etc/xinetd.d/wu-ftpd, /etc/xinetd.d/telnet)
    if ($err = &writeXinetdConf()) {
        goto done;
    }

    # (/etc/opt/nec/wbmc/Ipchains.conf)
#   if ($err = &writeIpchainsConf()) {
#       goto done;
#   }

    # (/etc/opt/nec/wbmchttpd/conf/*)
    if ($err = &writeWbmcHttpd()) {
        goto done;
    }

    # (/etc/named.conf)
    # (/var/named/*)
#   if ($err = &writeNamedConf()) {
#       goto done;
#   }

    if ($WBMC_MACHINE_TYPE ne "mail") {
        # (/etc/httpd/conf/*)
        if ($err = &writeHttpdConf()) {
            goto done;
        }
        
        # (/home/webalizer/*)
        if ($err = &writeWebalizer()) {
            goto done;
        }
    }
    
    if ($WBMC_MACHINE_TYPE ne "web") {
        # (/etc/sendmail.cf)
# 2004/9/9 Ȥꤢ顼ФΤǾõ
#        if ($err = &writeMail()) {
#            goto done;
#        }
        
        # admin桼
        if ($err = &setMailUser("admin", "$IfEth0{'HostName'}",
                     "$Account{'RootPassword'}", "180", "0")) {
            goto done;
        }
        
        # fml桼
        if ($err = &setMailUser("fml", "$IfEth0{'HostName'}",
                     "$Account{'RootPassword'}", "0", "0")) {
            goto done;
        }
    }

    # (/etc/dhcpd.conf)
    # (/etc/rc.d/init.d/dhcpd)
#   if ($err = &writeDhcpdConf()) {
#       goto done;
#   }

    # (/etc/squid/squid.conf)
#   if ($err = &writeSquidConf()) {
#       goto done;
#   }

    # (/etc/smb.conf)
#    if ($err = &writeSmbConf()) {
#       goto done;
#    }

##001121 ƥ(饹SMTPХPOP/IMAPХΥơȤ򤷤ʤ)
    # (/etc/logrotate.d/syslog)
    if ($WbMC{'WorkMode'} eq "WebLoadbalance") {
        if ($err = &writeSyslog()) {
            goto done;
        }
    }

    # 󥯥饹 ARM߽
    # IPLB֤ǤʤġStandalone֤ξߤ
    if (!defined($IPLB{'IplbType'}) && ($WbMC{'WorkMode'} eq "Standalone")) {
        if ( -e "/etc/clusterpro/armstartup" ) {
            system("/etc/clusterpro/armstartup -drvmanual > /dev/null");
        }
    }

    # IPLB
    if (-e "/etc/iplb.d/iplbset.pl") {
        require "/etc/iplb.d/iplbset.pl";
        if (!&writeIPLBServerType()) {
            exit(1);
        }
    }

    # IPLB֤ǤʤġStandalone֤ξϡIPLB ߤ롣wbmc03-046
    if (!defined($IPLB{'IplbType'}) && ($WbMC{'WorkMode'} eq "Standalone")) {
##010520 add:ե¸߳ǧ
        if ( -e "/etc/rc.d/init.d/iplbd" ) {
            system("/sbin/chkconfig --del iplbd > /dev/null");
        }
    }
##010305 add:饹IPLBߤ롣
    if($WbMC{'WorkMode'} eq "MailCluster"){
##010520 add:ե¸߳ǧ
        if ( -e "/etc/rc.d/init.d/iplbd" ) {
            system("/sbin/chkconfig --del iplbd > /dev/null");
        }
    }

    # ssh ԡ
    #if ($err = &ssh_key_copy()) {
    #    goto done;
    #}

    # /root/.ssh/config Խ
    if ($err = &config_root_ssh_config()) {
        goto done;
    }

    # ܥå󥯺(wbmcinit, wbmccopy, wbmcipchains)
    if ($err = &wbmc_slink_set()) {
        goto done;
    }

    # ssh ӥ߽ wbmc03-005:add
#    if (-e "/etc/rc.d/init.d/sshd") {
#       system("/etc/rc.d/init.d/sshd stop > /dev/null");
#       system("/sbin/chkconfig --del sshd > /dev/null");
#    }
##001120 mod:饹sshdư
    if (-e "/etc/rc.d/init.d/sshd" && ($WbMC{'WorkMode'} eq "Standalone") ) {
        system("/etc/rc.d/init.d/sshd stop > /dev/null");
        system("/sbin/chkconfig --del sshd > /dev/null");
    }
##010305 add:饹webߤ롣
    if($WbMC{'WorkMode'} eq "MailCluster"){
        system("/etc/rc.d/init.d/httpd stop > /dev/null");
        system("/sbin/chkconfig --del httpd > /dev/null");
    }

##010414 add ߥ顼ǥѡƥconfinitˤƺ
    # ߥ顼ѥǥѡƥ
    if ($WbMC{'WorkMode'} eq "MailCluster") {
        if ($err = &makeClusterPartition()) {
            goto done;
        }
    }

    # fml󥹥ȡ
    #if ( @fml_rpm = glob ("/opt/nec/tmp/fml-*.rpm")) {
    #    system("/bin/rpm -i --nodeps @fml_rpm >> /tmp/postrun.log 2>&1");
    if ( @fml_srpm = glob ("/opt/nec/tmp/fml-*.src.rpm")) {
        system("/bin/rpm --rebuild @fml_srpm >> /tmp/postrun.log 2>&1");
        if ( @fml_rpm = glob ("/usr/src/redhat/RPMS/i386/fml-*.rpm")) {
            system("/bin/rpm -i --nodeps @fml_rpm >> /tmp/postrun.log 2>&1");
            system("/bin/rm -f @fml_srpm");
            system("/bin/rm -f @fml_rpm");
            system("/etc/mail/enable_smrsh.sh >> /tmp/postrun.log 2>&1");
        }
    }

    # /etc/group.lock
    if (-e "/etc/group.lock") {
        system("/bin/rm -f /etc/group.lock");
    }

##020116 add Tripwire Ѥ뤿νԤ
    # Tripwire 
    if ($err = &TripInstall()) {
		goto done;
    }
##020116 end

##021007 add openldap ɥ쥹Ģ
    # openldap 
    if ($err = &openldapInitSetup()) {
        goto done;
    }
##20021027 ¾
    # 20021004 add sendmailѤlocal-host-names롣
    if(! -e "/etc/mail/local-host-names"){
        system("/bin/touch /etc/mail/local-host-names > /dev/null 2>&1");
    }
    # 20021027 add makewhatis.cronưʤ(zcat: stdout: Broken pipeȤ顼Ǥ)
    if (-e "/etc/cron.daily/makewhatis.cron") {
        system("/bin/rm /etc/cron.daily/makewhatis.cron > /dev/null 2>&1");
    }
    # 20021028 add Ƴεưwbmcipchainsư褦ˤ롣
    # IPLB ޤϡ"WebLoadbalance" ξˤϡipchains νԤʤ
    if (!defined($IPLB{'IplbType'}) && ($WbMC{'WorkMode'} ne "WebLoadbalance")) {
        system("/etc/rc.d/init.d/wbmcipchains start > /dev/null 2>&1");
    }
    # 20030326 LBֻMWMailWebǺ߹Ǥ褦sslǥ쥯ȥΥܥå󥯤롣
    if ($WbMC{'WorkMode'} eq "WebLoadbalance") {
        system("/bin/ln -s /etc/opt/nec/wbmchttpd/conf /etc/opt/nec/wbmchttpd/conf/ssl > /dev/null 2>&1");
        system("/bin/ln -s /etc/httpd/conf /etc/httpd/conf/ssl > /dev/null 2>&1");
    }

## 20030212 Web׺ץȤ֤ǥ쥯ȥ
    if (! -e "/opt/nec/wbmc/bin/webalizer.daily") {
        system("/bin/mkdir /opt/nec/wbmc/bin/webalizer.daily > /dev/null 2>&1");
    }
    system("/bin/echo '5 5 * * * root run-parts /opt/nec/wbmc/bin/webalizer.daily\n' >> /etc/crontab");

done:
    return($err);
}

#
# եɤ߹
#
sub readConfFile
{
    my($filename) = @_;
    my($err);
    local(@line);
    my($section);
    my($name);
    my($value);
    my($ipaddr);
    my($netmask);
    my($netaddr);
    my($bcastaddr);

    if (defined($filename)) {
        # ե뤫ɤ߹
        if (!&readFile($filename, "conffile", *line)) {
            $err = "եɤ߹ޤǤ";
            goto done;
        }
    } else {
        # ɸϤɤ߹
        @line = <>;
    }
    
    for (@line) {
        if (/^;/) {
            # Ƭ";"ʤХ
            next;
        }
        
        s/^\s*//;
        s/[\r\n]*$//;
        if (/^\s*$/) {
            # Ԥ̵뤹
            next;
        }
        
        if (/^\[(.*)\]/) {
            # "[]" 
            $section = $1;
            $section =~ s/^\s*//;
            $section =~ s/\s*$//;
            $section =~ s/ /_/g;
            next;
        }

        if (/^([^=]*)=(.*)$/) {
            # "̾ = " 
            $name = $1;
            $value = $2;

            if ($section ne "") {
                $name =~ s/^\s*//;
                $name =~ s/\s*$//;
                if ($name ne "RootPassword") {
                    $value =~ s/^\s*//;
                    $value =~ s/\s*$//;
                }
                if ($value eq "") {
                    next;
                }

                $$section{$name} = $value;
            }
        }
    }

done:
    return($err);
}

#
# եɤ߹
#
sub readInitFile
{
    my($filename) = @_;
    my($err);
    local(@line);
    my($section);
    my($name);
    my($value);
    my($ipaddr);
    my($netmask);
    my($netaddr);
    my($bcastaddr);

    if (defined($filename)) {
        # ե뤫ɤ߹
        if (!&readFile($filename, "CONFINIT.INI", *line)) {
            $err = "եɤ߹ޤǤ";
            goto done;
        }
    } else {
        # ɸϤɤ߹
        @line = <>;
    }

    for (@line) {
        if (/^;/) {
            # Ƭ";"ʤХ
            next;
        }
    
        s/^\s*//;
        s/[\r\n]*$//;
        if (/^\s*$/) {
            # Ԥ̵뤹
            next;
        }
    
        if (/^\[(.*)\]/) {
            # "[]" 
            $section = $1;
            $section =~ s/^\s*//;
            $section =~ s/\s*$//;
            $section =~ s/ /_/g;
            next;
        }
    
        if (/^([^=]*)=(.*)$/) {
            # "̾ = " 
            $name = $1;
            $value = $2;
    
            if ($section ne "") {
                $name =~ s/^\s*//;
                $name =~ s/\s*$//;
                if ($name ne "RootPassword") {
                    $value =~ s/^\s*//;
                    $value =~ s/\s*$//;
                }
                if ($value eq "") {
                    next;
                }
                
                $$section{$name . ".old"} = $value;
            }
        }
    }

done:
    return($err);
}

#
# ե񤭹
#
sub writeConfFile
{
    my($filename) = @_;
    my($err);
    my(@line);
    my($ipaddr);
    my($netmask);
    my($netaddr);
    my($bcastaddr);

    # eth0
    if (($IfEth0{'IpAddr'} ne "") && ($IfEth0{'NetMask'})) {
        $ipaddr = &ipStr2Addr($IfEth0{'IpAddr'});
        $netmask = &ipStr2Addr($IfEth0{'NetMask'});
        $netaddr = $ipaddr & $netmask;
        $bcastaddr = $netaddr | (0xffffffff & ~$netmask);
        $IfEth0{'NetAddr'} = &ipAddr2Str($netaddr);
        $IfEth0{'BcastAddr'} = &ipAddr2Str($bcastaddr);
    } else {
        $IfEth0{'NetAddr'} = "";
        $IfEth0{'BcastAddr'} = "";
    }

    # eth1
    if (($IfEth1{'IpAddr'} ne "") && ($IfEth1{'NetMask'})) {
        $ipaddr = &ipStr2Addr($IfEth1{'IpAddr'});
        $netmask = &ipStr2Addr($IfEth1{'NetMask'});
        $netaddr = $ipaddr & $netmask;
        $bcastaddr = $netaddr | (0xffffffff & ~$netmask);
        $IfEth1{'NetAddr'} = &ipAddr2Str($netaddr);
        $IfEth1{'BcastAddr'} = &ipAddr2Str($bcastaddr);
    } else {
        $IfEth1{'NetAddr'} = "";
        $IfEth1{'BcastAddr'} = "";
    }

    @line = (
    "[WbMC]\n",
    "WorkMode=$WbMC{'WorkMode'}\n",

##010414 add CLUSTERPRO Lite!б
    "ParSize=$WbMC{'ParSize'}\n",
    "PartitionSize=$WbMC{'PartitionSize'}\n",
    "ControlPartitionSize=$WbMC{'ControlPartitionSize'}\n",
    "DeviceName=$WbMC{'DeviceName'}\n",
    "PartitionPrefix=$WbMC{'PartitionPrefix'}\n",
    "MountPoint=$WbMC{'MountPoint'}\n",
    "MountOption=$WbMC{'MountOption'}\n",
    "PartitionDump=$WbMC{'PartitionDump'}\n",
    "PartitionCheck=$WbMC{'PartitionCheck'}\n",

    "\n",
    "[Config]\n",
    "GroupName=$Config{'GroupName'}\n",
    "\n",
    "[Account]\n",
    "RootPassword=\n",
    "\n",
    "[IfEth0]\n",
    "HostName=$IfEth0{'HostName'}\n",
    "IpAddr=$IfEth0{'IpAddr'}\n",
    "NetMask=$IfEth0{'NetMask'}\n",
    "Gateway=$IfEth0{'Gateway'}\n",
    "PrimaryNameServer=$IfEth0{'PrimaryNameServer'}\n",
    "SecondaryNameServer=$IfEth0{'SecondaryNameServer'}\n",
#    "Device=$IfEth0{'Device'}\n",
    "Device=eth0\n",
    "ShortHostName=$IfEth0{'ShortHostName'}\n",
    "DomainName=$IfEth0{'DomainName'}\n",
    "\n",
    "[IfEth1]\n",
    "IpAddr=$IfEth1{'IpAddr'}\n",
    "NetMask=$IfEth1{'NetMask'}\n",
    "\n",
    "[Mail]\n",
    "TransMode=$Mail{'TransMode'}\n",
    "SmartHostName=$Mail{'SmartHostName'}\n",
    "DirectHostName=$Mail{'DirectHostName'}\n");

    # ե˽񤭹
    if (!&writeFile($filename, "CONFINIT.INI", @line)) {
        $err = "$filenameؤν񤭹ߤ˼Ԥޤ";
        goto done;
    }

done:
    return($err);
}

#
# InitConf.inf  INITCONF.INI ӤѤ߾򥯥ꥢ
#
sub clearConf
{
    my($err);

    # InitConf.inf  INITCONF.INI 
    if (
           ( $WbMC{'WorkMode'} ne $WbMC{'WorkMode.old'} )
        || ( $IfEth0{'HostName'} ne $IfEth0{'HostName.old'} )
        || ( $IfEth0{'IpAddr'} ne $IfEth0{'IpAddr.old'} )
        || ( $IfEth0{'NetMask'} ne $IfEth0{'NetMask.old'} )
        || ( defined($IfEth1{'IpAddr.old'}) && $IfEth1{'IpAddr'} ne $IfEth1{'IpAddr.old'} )
        || ( defined($IfEth1{'NetMask.old'}) && $IfEth1{'NetMask'} ne $IfEth1{'NetMask.old'} )
    ) {
        # WbMCѤ߾ƺ
        $clearFlag = 1;
    
        # ӥ
    
        # ɥᥤ󥯥ꥢ
        if ($err = &delAllDomainInf()) {
            goto done;
        }
    
        # Хååץե&ե
        if (-e "/var/backup" ) {
            system("/bin/rm -fr /var/backup");
        }
        if (-e "/var/log/wbmchttpd" ) {
            system("/bin/rm -fr /var/log/wbmchttpd/*");
        }
        if (-e "/var/log/httpd" ) {
            system("/bin/rm -fr /var/log/httpd/*");
        }
        if (-e "/var/log/wbmc" ) {
            system("/bin/rm -fr /var/log/wbmc");
        }
        if (-e "/var/log/wbmc_cluster" ) {
            system("/bin/rm -fr /var/log/wbmc_cluster");
        }
    
        # /etc/opt/nec/wbmc۲ե
        # mailϢ
        if (-e "/etc/opt/nec/wbmc" ) {
            system("/bin/rm -fr /etc/opt/nec/wbmc/sendmail.*");
            system("/bin/rm -fr /etc/opt/nec/wbmc/aliaseslist");
            system("/bin/rm -fr /etc/opt/nec/wbmc/aliasesdir/*");
        }
    
    }

done:
    return($err);
}

#
# ΥХååפȤ
#
#sub backupConfParam
#{
#    my($err);
#
#    $Account{'RootPassword.old'} = $Account{'RootPassword'};
#
#    $Meta{'NetType.old'} = $Meta{'NetType'};
#
#    $IfEth0{'ShortHostName.old'} = $IfEth0{'ShortHostName'};
#    $IfEth0{'DomainName.old'} = $IfEth0{'DomainName'};
#    $IfEth0{'HostName.old'} = $IfEth0{'HostName'};
#    $IfEth0{'IpAddr.old'} = $IfEth0{'IpAddr'};
#    $IfEth0{'NetMask.old'} = $IfEth0{'NetMask'};
#    $IfEth0{'NetAddr.old'} = $IfEth0{'NetAddr'};
#    $IfEth0{'BcastAddr.old'} = $IfEth0{'BcastAddr'};
#    $IfEth0{'Gateway.old'} = $IfEth0{'Gateway'};
#    $IfEth0{'DnsType.old'} = $IfEth0{'DnsType'};
#    $IfEth0{'PrimaryNameServer.old'} = $IfEth0{'PrimaryNameServer'};
#    $IfEth0{'SecondaryNameServer.old'} = $IfEth0{'SecondaryNameServer'};
#    $IfEth0{'DhcpOn.old'} = $IfEth0{'DhcpOn'};
#    $IfEth0{'DhcpRangeStart.old'} = $IfEth0{'DhcpRangeStart'};
#    $IfEth0{'DhcpRangeEnd.old'} = $IfEth0{'DhcpRangeEnd'};
#
#    $IfEth1{'ShortHostName.old'} = $IfEth1{'ShortHostName'};
#    $IfEth1{'DomainName.old'} = $IfEth1{'DomainName'};
#    $IfEth1{'HostName.old'} = $IfEth1{'HostName'};
#    $IfEth1{'IpAddr.old'} = $IfEth1{'IpAddr'};
#    $IfEth1{'NetMask.old'} = $IfEth1{'NetMask'};
#    $IfEth1{'NetAddr.old'} = $IfEth1{'NetAddr'};
#    $IfEth1{'BcastAddr.old'} = $IfEth1{'BcastAddr'};
#    $IfEth1{'Gateway.old'} = $IfEth1{'Gateway'};
#    $IfEth1{'DnsType.old'} = $IfEth1{'DnsType'};
#    $IfEth1{'PrimaryNameServer.old'} = $IfEth1{'PrimaryNameServer'};
#    $IfEth1{'SecondaryNameServer.old'} = $IfEth1{'SecondaryNameServer'};
#    $IfEth1{'DnsZoneName.old'} = $IfEth1{'DnsZoneName'};
#
#    $Service_Mail{'Mail.smtpserver.old'} = $Service_Mail{'Mail.smtpserver'};
#    $Service_Mail{'Mail.pop3server.old'} = $Service_Mail{'Mail.pop3server'};
#
#done:
#    return($err);
#}

#
# ѥ᡼å
#
sub checkConfParam
{
    my($err);
    my($ipaddr, $netmask, $netaddr, $bcastaddr, $addr1, $addr2);
##010414 add next 1 line
    local(@line);
    local($cylinders, $heads, $sectors);
    local($ctrlcylinders, $sizecylinders, $cylindersectors, $maxMB);
    local($deviceList);
    local($license_key) = "/etc/opt/nec/LICENSE_KEY";
    local($dev_file) = "/etc/opt/nec/dev_name";
    local($i, @mc_line);
    local($dev, $key, $def_key);
    local($salt) = "MC";

    # ư⡼ɤΥå
    if ($WbMC{'WorkMode'} !~ /^(Standalone|WebLoadbalance|MailCluster)$/) {
        $err = "ư⡼ɤǤ";
        goto done;
    }

##001109 add next 3 line
    if ($WbMC{'WorkMode'} eq "WebLoadbalance") {
        $WBMC_MACHINE_TYPE = "web";
    }

    # machinetype Ȥбå
    if ( ($WBMC_MACHINE_TYPE eq "web") && ($WbMC{'WorkMode'} eq "MailCluster") ) {
        $err = "ư⡼ɤǤ";
        goto done;
    } elsif ( ($WBMC_MACHINE_TYPE eq "mail") && ($WbMC{'WorkMode'} eq "WebLoadbalance") ) {
        $err = "ư⡼ɤǤ";
        goto done;
    } elsif ( ($WBMC_MACHINE_TYPE ne "mail") && ($WBMC_MACHINE_TYPE ne "web")
      && ($WbMC{'WorkMode'} eq "WebLoadbalance") ) {
        $err = "ư⡼ɤǤ";
        goto done;
    }

##010414 add CLUSTERPRO Lite!б å
    if ($WbMC{'WorkMode'} eq "MailCluster") {
        # 饤󥹾
        if (! -e $license_key) {
            $err = "饤󥹤̤ϿǤ";
            goto done;
        } else {
            system ("/usr/bin/nkf -e $license_key > $license_key.euc");
            if (open(MK, "$license_key.euc")) {
                @mc_line = <MK>;
                close(MK);
                for ($i = 0; $i < 2; $i++) {
                    $mc_line[$i] =~ s/^\s+//;
                    $mc_line[$i] =~ s/\s+$//;
                    $key = $mc_line[$i] if ($i == 0);
                    $dev = $mc_line[$i] if ($i == 1);
                }
            }

            if (open(KY, "/etc/opt/nec/wbmc/mc_key")) {
                while (<KY>) {
                    s/^\s+//;
                    s/\s+$//;
                    $def_key = $_;
                }
                close(KY);
            }

            if (crypt($key, $salt) ne $def_key) {
                $err = "饤󥹥Ǥ";
                unlink "$license_key", "$license_key.euc";
                goto done;
            }
            if ($dev !~ /^\/dev\//) {
                $err = "ߥ顼ǥǥХ̾Ǥ";
                unlink "$license_key", "$license_key.euc";
                goto done;
            }

            system ("/bin/echo $dev > $dev_file");
            unlink "$license_key", "$license_key.euc";
        }

        # ǥХ
        if (!defined($WbMC{'DeviceName'})) {
            # ǥХ
            if (-e $dev_file) {
                if (open(MT, $dev_file)) {
                    @line = <MT>;
                    close(MT);
                    if (defined($line[0])) {
                        $line[0] =~ s/^\s*([^\s]*)\s*$/$1/;
                        if ($line[0] ne "") {
                            $WbMC{'DeviceName'} = $line[0];
                        }
                    }
                }
            } else {
                $err = "ߥ顼ǥǥХ̤̾Ǥ";
                goto done;
            }
        }
        # ץեå
        if (!defined($WbMC{'PartitionPrefix'})) {
            $WbMC{'PartitionPrefix'} = "";
            if ($WbMC{'DeviceName'} =~ /^\/dev\/rd\/c\d+d\d+$/) {
                # MylexDAC
                $WbMC{'PartitionPrefix'} = "p";
            }
        }
        # CLUSTERPRO Lite!ѥѡƥ󥵥
        if (!defined($WbMC{'ControlPartitionSize'})) {
            $WbMC{'ControlPartitionSize'} = 10;
        }
        # ߥ顼ѥѡƥ󥵥
        if (!defined($WbMC{'ParSize'})) {
            if (!defined($WbMC{'PartitionSize'})) {
                $err = "ߥ顼ѥѡƥ󥵥̤Ǥ";
                goto done;
            }
        } else {
            if (!defined($WbMC{'PartitionSize'})) {
                $WbMC{'PartitionSize'} = $WbMC{'ParSize'};
            }
        }
        # ޥȥݥ
        if (!defined($WbMC{'MountPoint'})) {
            $WbMC{'MountPoint'} = "/mnt/mirror1";
        }
        # ޥȥץ
        if (!defined($WbMC{'MountOption'})) {
            $WbMC{'MountOption'} = "rw,sync,nonstop,usrquota,grpquota,noauto";
        }
        # ׻
        if (!defined($WbMC{'PartitionDump'})) {
            $WbMC{'PartitionDump'} = "0";
        }
        # bootѡƥå
        if (!defined($WbMC{'PartitionCheck'})) {
            $WbMC{'PartitionCheck'} = "0";
        }
        # ߥ顼ѡƥ̾
        if (!defined($WbMC{'MirrorPartition'})) {
            $WbMC{'MirrorPartition'} = "/dev/md0";
        }

        # ߥ顼ǥ̼() by sfdisk
        # ꥵ(-> )
        open(IN, "/sbin/sfdisk -g $WbMC{'DeviceName'} 2>&1 |");
        @line = <IN>;
        close(IN);

        if ($line[0]=~
            /$WbMC{'DeviceName'}:\s*(\d+)\s*cylinders,\s*(\d+)\s*heads,\s*(\d+)\s*sectors\/track/) {
            $cylinders = $1; $heads = $2 ; $sectors = $3 ;
            $cylindersectors = $heads * $sectors;
        } else {
            $err = "ߥ顼ѥǥξ˼Ԥޤ";
            goto done;
        }

        # ߥ顼ѥǥХ̤ѤǤ뤳Ȥǧ(/etc/fstab)
        if (open(IN, "/bin/cat /etc/fstab |")) {
            $deviceList = "";
            while(<IN>) {
                $line = $_;
                if ($line =~ /^\s*(\/dev\/\S+)\s/) {
                    $deviceList .= "$1 ";
                }
            }
            close(IN);
            if ($deviceList =~ /$WbMC{'DeviceName'}/) {
                $err = "ߥ顼ѥǥϴ˻ѤƤޤ(/etc/fstab)";
                goto done;
            }
        }

        # ߥ顼ѥǥХ̤ѤǤ뤳Ȥǧ(/etc/raidtab)
        if (-e "/etc/raidtab") {
            if (open(IN, "/bin/cat /etc/raidtab |")) {
                $deviceList = "";
                while(<IN>) {
                    $line = $_;
                    if ($line =~ /^\s*device\s(\S+)/) {
                        $deviceList .= "$1 ";
                    }
                }
                close(IN);
                if ($deviceList =~ /$WbMC{'DeviceName'}/) {
                    $err = "ߥ顼ѥǥϴ˻ѤƤޤ(/etc/raidtab)";
                    goto done;
                }
            }
        }

        # $WbMC{'PartitionSize'} eq "" ξƱOK
        $ctrlcylinders = int( ($WbMC{'ControlPartitionSize'} * 1024 * 2 + $cylindersectors - 1)
                              / $cylindersectors );
        $sizecylinders = int( ($WbMC{'PartitionSize'} * 1024 * 2 + $cylindersectors - 1)
                              / $cylindersectors );
        if ($ctrlcylinders + $sizecylinders > $cylinders) {
            $maxMB = int(($cylinders - $ctrlcylinders) * $cylindersectors / 2048);
            $err = "ߥ顼ѥǥ̤­ޤ(${maxMB}MB)";
            goto done;
        }
    }

    # ͥåȥ³ǥΥå
#    if ($Meta{'NetType'} !~ /^(internet|dialup|intranet)$/) {
#       $err = "ͥåȥ³ǥ뤬Ǥ";
#       goto done;
#    }

    # eth0󥿥եѥ᡼Υå
    if (!&checkLongHostName($IfEth0{'HostName'})) {
        $err = "ۥ̾Ǥ";
        goto done;
    }
    # ShortHostName : HostName黻
    # DomainName    : HostName黻
    if ($IfEth0{'HostName'} =~ /^([^\.]+)\.(.+)$/) {
        $IfEth0{'ShortHostName'} = $1;
        $IfEth0{'DomainName'} = $2;
    } else {
        $err = "ۥ̾Ǥ";
        goto done;
    }
    if (!&checkShortHostName($IfEth0{'ShortHostName'})) {
        $err = "ۥ̾(ۥʬ)Ǥ";
        goto done;
    }
    if (!&checkDomainName($IfEth0{'DomainName'})) {
        $err = "ۥ̾(ɥᥤʬ)Ǥ";
        goto done;
    }

    if (!&ipAddrCheck($IfEth0{'IpAddr'})) {
        $err = "1ܤΥͥåȥ󥿥եIPɥ쥹Ǥ";
        goto done;
    }
    if (!&ipAddrCheck($IfEth0{'NetMask'})) {
        $err = "1ܤΥͥåȥ󥿥եΥͥåȥޥǤ";
        goto done;
    }
    if (($IfEth0{'IpAddr'} ne "") && ($IfEth0{'NetMask'} ne "")) {
        # NetAddr       : IpAddr,NetMask黻
        # BcastAddr     : IpAddr,NetMask黻
        $ipaddr = &ipStr2Addr($IfEth0{'IpAddr'});
        $netmask = &ipStr2Addr($IfEth0{'NetMask'});
        $netaddr = $ipaddr & $netmask;
        $bcastaddr = $netaddr | (0xffffffff & ~$netmask);
        $IfEth0{'NetAddr'} = &ipAddr2Str($netaddr);
        $IfEth0{'BcastAddr'} = &ipAddr2Str($bcastaddr);
        
        if (!&ipAddrCheck($IfEth0{'NetAddr'})) {
            $err = "1ܤΥͥåȥ󥿥եΥͥåȥɥ쥹Ǥ";
            goto done;
        }
        if (!&ipAddrCheck($IfEth0{'BcastAddr'})) {
            $err = "1ܤΥͥåȥ󥿥եΥ֥ɥ㥹ȥɥ쥹Ǥ";
            goto done;
        }
    }

    if ($IfEth0{'Gateway'} ne "") {
        if (!&ipAddrCheck($IfEth0{'Gateway'})) {
            $err = "1ܤΥͥåȥ󥿥եΥǥեȥȥǤ";
            goto done;
        }
    }
    if ($IfEth0{'PraimaryNameServer'} ne "") {
        if (!&ipAddrCheck($IfEth0{'PraimaryNameServer'})) {
            $err = "1ܤΥͥåȥ󥿥եΥץ饤ޥ͡ॵФǤ";
            goto done;
        }
    }
    if ($IfEth0{'SecondaryNameServer'} ne "") {
        if (!&ipAddrCheck($IfEth0{'SecondaryNameServer'})) {
            $err = "1ܤΥͥåȥ󥿥եΥ͡ॵФǤ";
            goto done;
        }
    }

    if ($IfEth1{'IpAddr'} ne "") {
        if (!&ipAddrCheck($IfEth1{'IpAddr'})) {
            $err = "2ܤΥͥåȥ󥿥եIPɥ쥹Ǥ";
            goto done;
        }
    }
    if ($IfEth1{'NetMask'} ne "") {
        if (!&ipAddrCheck($IfEth1{'NetMask'})) {
            $err = "2ܤΥͥåȥ󥿥եΥͥåȥޥǤ";
            goto done;
        }
    }
    if (($IfEth1{'IpAddr'} ne "") && ($IfEth1{'NetMask'} ne "")) {
        # NetAddr       : IpAddr,NetMask黻
        # BcastAddr     : IpAddr,NetMask黻
        $ipaddr = &ipStr2Addr($IfEth1{'IpAddr'});
        $netmask = &ipStr2Addr($IfEth1{'NetMask'});
        $netaddr = $ipaddr & $netmask;
        $bcastaddr = $netaddr | (0xffffffff & ~$netmask);
        $IfEth1{'NetAddr'} = &ipAddr2Str($netaddr);
        $IfEth1{'BcastAddr'} = &ipAddr2Str($bcastaddr);
    
        if (!&ipAddrCheck($IfEth1{'NetAddr'})) {
            $err = "2ܤΥͥåȥ󥿥եΥͥåȥɥ쥹Ǥ";
            goto done;
        }
        if (!&ipAddrCheck($IfEth1{'BcastAddr'})) {
            $err = "2ܤΥͥåȥ󥿥եΥ֥ɥ㥹ȥɥ쥹Ǥ";
            goto done;
        }
    }

done:
    return($err);
}

#
# (/etc/passwd)
# (/etc/shadow)
#
sub writeShadow
{
    my($err);
    my($passwd);
    my($passwd_arg);
    my($home);
    local(@line);
    local(@lines);

    $passwd = $Account{'RootPassword'};
    $passwd_arg = &encodeCmdArg($passwd);

    # ǥեȤΥۡǥ쥯ȥ/home/users/*ѹ
    if (system("/usr/sbin/useradd -D -b /home/users > /dev/null") != 0) {
        $err = "ǥեȥۡǥ쥯ȥѹǤޤǤ";
        goto done;
    }

    # /home/users̵к
    if (! -d "/home/users") {
        if (!mkdir("/home/users", 0755)) {
            $err = "/home/usersǤޤǤ";
            goto done;
        }
    }

    # root롼פ̵ɲä
    if (!defined(getgrnam("root"))) {
        if (system("/usr/sbin/groupadd -g 0 root > /dev/null") != 0) {
            $err = "root롼פɲäǤޤǤ";
            goto done;
        }
    }

    # root桼̵ɲä
    if (!defined(getpwnam("root"))) {
        if (system("/usr/sbin/useradd -r -m -d /root -u 0 root > /dev/null") != 0) {
            $err = "root桼ɲäǤޤǤ";
            goto done;
        }
        if (-e "/etc/group.lock") {
            system("/bin/rm -f /etc/group.lock");
        }

    }

    # root.forwardꤹ
    $home = (getpwnam("root"))[7];
    @line = ( "admin\n" );
    if (!&writeFile("$home/.forward", ".forward", @line)) {
        $err = "root桼.forwardǤޤǤ";
        goto done;
    }

    # rootΥѥɤѹ
    if ($passwd ne "") {
        if (system("/bin/echo $passwd_arg | /usr/bin/passwd --stdin root > /dev/null") != 0) {
            $err = "rootΥѥɤѹǤޤǤ";
            goto done;
        }
    }

    # admin롼פ̵ɲä
    if (!defined(getgrnam("admin"))) {
    if (system("/usr/sbin/groupadd -r admin > /dev/null") != 0) {
        $err = "admin롼פɲäǤޤǤ";
        goto done;
    }
    }

    # admin桼̵ɲä
    # telnetǽʥ桼ѹ("-s /bin/false")
    if (!defined(getpwnam("admin"))) {
    if (system("/usr/sbin/useradd -r -m -d /home/users/admin -g admin admin > /dev/null") != 0) {
        $err = "admin桼ɲäǤޤǤ";
        goto done;
    }
    if (-e "/etc/group.lock") {
        system("/bin/rm -f /etc/group.lock");
    }

    }

    # adminΥѥɤѹ
    if ($passwd ne "") {
    if (system("/bin/echo $passwd_arg | /usr/bin/passwd --stdin admin > /dev/null") != 0) {
        $err = "adminΥѥɤѹǤޤǤ";
        goto done;
    }
    }

# admin 桼 telnet ftp ǽȤʤä web 桼
#    if ($WBMC_MACHINE_TYPE ne "mail") {
#   # web롼פ̵ɲä
#   if (!defined(getgrnam("web"))) {
#       if (system("/usr/sbin/groupadd web") != 0) {
#       $err = "web롼פɲäǤޤǤ";
#       goto done;
#       }
#   }
#
#   # web桼̵ɲä
#   if (!defined(getpwnam("web"))) {
#       if (system("/usr/sbin/useradd -r -m -d /home/users/web web") != 0) {
#       $err = "web桼ɲäǤޤǤ";
#       goto done;
#       }
#   }
#
#   # web桼Υѥɤѹ
#   if ($passwd ne "") {
#       if (system("/bin/echo web:$passwd_arg | /usr/sbin/chpasswd") != 0) {
#       $err = "web桼ΥѥɤѹǤޤǤ";
#       goto done;
#       }
#   }
#    }

    if ($WBMC_MACHINE_TYPE ne "web") {
    # fml롼פ̵ɲä
    if (!defined(getgrnam("fml"))) {
        if (system("/usr/sbin/groupadd fml > /dev/null") != 0) {
        $err = "fml롼פɲäǤޤǤ";
        goto done;
        }
    }

    # fml桼̵ɲä
    if (!defined(getpwnam("fml"))) {
        if (system("/usr/sbin/useradd -r -m -d /home/users/fml -g fml fml > /dev/null") != 0) {
        $err = "fml桼ɲäǤޤǤ";
        goto done;
        }
        if (-e "/etc/group.lock") {
        system("/bin/rm -f /etc/group.lock");
        }

    }

    # fml桼Υѥɤѹ
    if ($passwd ne "") {
        if (system("/bin/echo $passwd_arg | /usr/bin/passwd --stdin fml > /dev/null") != 0) {
        $err = "fml桼ΥѥɤѹǤޤǤ";
        goto done;
        }
    }
    }

    # unix桼Ф .forward 
    # uid500꾮桼оݤˤ롣admin,fml Ͻ
    ##011106  root 
    # /etc/passwdեɤ߹
    if ( !&readFile( "/etc/passwd", "passwd", *lines ) ){
    $err = "/etc/passwdեɤ߹ߤ˼Ԥޤ";
    goto done;
    }

    foreach (@lines) {
    @row = split( ":" );
    if ( $row[3] >= 500 ) {
        next;
    }
    # .forward  admin
    if ( $row[0] eq "admin" || $row[0] eq "fml" || $row[0] eq "root" ) {
        next;
    }
    # root.forwardꤹ
    $home = $row[5];
    if ((!-e "$home") || ($home =~ /\/dev\/null/) || (-e "$home/.forward")) {
        next;
    }
    ##011106 žѹ admin -> root 
    @line = ( "root\n" );
    if (!&writeFile("$home/.forward", ".forward", @line)) {
        $err = "$row[0]桼.forwardǤޤǤ";
        goto done;
    }
    }

    # SMB Guest桼/롼פκ
    if (!defined(getgrnam("smbguest"))) {
        if (system("/usr/sbin/groupadd -g 300 smbguest &> /dev/null") != 0) {
            $err = "smbguest롼פɲäǤޤǤ";
            goto done;
        }
    }
    if (!defined(getgrnam("smb"))) {
        if (system("/usr/sbin/groupadd -g 301 smb &> /dev/null") != 0) {
            $err = "smb롼פɲäǤޤǤ";
            goto done;
        }
    }
    if (!defined(getpwnam("smbguest"))) {
        if (system("/usr/sbin/useradd -u 300 -g 300 -c \"SMB Guest Account\" -d /dev/null -s /dev/null smbguest &> /dev/null") != 0) {
            $err = "smbguest桼ɲäǤޤǤ";
            goto done;
        }
    }

    # Sambaǥ쥯ȥκ
    if (!mkdir("/home/samba", 0755)) {
        $err = "/home/sambaǤޤǤ";
        goto done;
    }
    if (!mkdir("/home/samba/private", 1777)) {
        $err = "/home/samba/privateǤޤǤ";
        goto done;
    }
    if (!mkdir("/home/samba/public", 1777)) {
        $err = "/home/samba/publicǤޤǤ";
        goto done;
    }
    system("/bin/chmod 1777 /home/samba/* &> /dev/null");
    system("/bin/chown -R root.smb /home/samba &> /dev/null");
    

done:
    return($err);
}

#
# (/etc/shells)
#
sub writeShells
{
    local(@line);
    my($err);
    my($filename);
    my($shell);
    my(%shells);

    $filename = "/etc/shells";

    # /etc/shellsɤ߹
    if (!&readFile($filename, "shells", *line)) {
    $err = "$filenameɤ߹ޤǤ";
    goto done;
    }

    # ϥåɤ߹
    for ($i = 0; $i <= $#line; $i++) {
    $shell = $line[$i];
    $shell =~ s/^\s*//;
    $shell =~ s/\s*$//;
    $shells{$shell} = 1;
    }

    # /bin/bash̵ɲä
    if (!defined($shells{"/bin/bash"})) {
    $line[$i++] = "/bin/bash\n";
    }

    # /bin/false̵ɲä
    if (!defined($shells{"/bin/false"})) {
    $line[$i++] = "/bin/false\n";
    }

    # ե˽񤭹
    if (!&writeFile($filename, "shells", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/ftpusers)
#
sub writeFtpUsers
{
    local(@line);
    my($err);
    my($filename);
    my($found);

    $filename = "/etc/ftpusers";

    # /etc/ftpusersɤ߹
    if (!&readFile($filename, "ftpusers", *line)) {
    $err = "$filenameɤ߹ޤǤ";
    goto done;
    }

    # adminõ
    $found = 0;
    for ($i = 0; $i <= $#line; $i++) {
    if ($line[$i] =~ /^\s*admin\s*$/) {
        $found = 1;
        last;
    }
    }

    # ̵ɲä
    if ($found == 0) {
    $line[$i++] = "admin\n";
    }

    # /etc/ftpusers˽񤭹
    if (!&writeFile($filename, "ftpusers", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/lftp.conf)
#
sub writeLftpConf
{
    local(@line);
    my($err);
    my($filename);
    my($found);

    $filename = "/etc/lftp.conf";

    # /etc/lftp.confɤ߹
    if (!&readFile($filename, "lftp.conf", *line)) {
        $err = "$filenameɤ߹ޤǤ";
        goto done;
    }

    # set net:max-retries ΥȤ򳰤
    $found = 0;
    for ($i = 0; $i <= $#line; $i++) {
        if ($line[$i] =~ /^\s*(#|)\s*(set\s+net:max-retries\s.*$)/) {
            $line[$i] = $2;
            $found = 1;
            last;
        }
    }

    # ̵ɲä
    if ($found == 0) {
        $line[$i++] = "\n";
        $line[$i++] = "set net:max-retries 3\n";
    }

#    # set ftp:passive-mode on ΥȤ򳰤
#    $found = 0;
#    for ($i = 0; $i <= $#line; $i++) {
#        if ($line[$i] =~ /^\s*(#|)\s*(set\s+ftp:passive-mode\s+on\s+$)/) {
#            $line[$i] = $2;
#            $found = 1;
#            last;
#        }
#    }
#
#    # ̵ɲä
#    if ($found == 0) {
#        $line[$i++] = "\n";
#        $line[$i++] = "set ftp:passive-mode on\n";
#    }

    # /etc/lftp.conf˽񤭹
    if (!&writeFile($filename, "lftp.conf", @line)) {
        $err = "$filename˽񤭹ޤǤ";
        goto done;
    }

done:
    return($err);
}

#
# (/etc/fstab)
# ($homedir/quota.user)
# ($homedir/quota.group)
#
sub writeFstab
{
    my($err);
    my($filename);
    my(@ent);
    my($homedir);
    local(@line);
    my($i);
#    my($j, @option);
    my($mirrorExist) = 0;

    $filename = "/etc/fstab";

    # /homeΥե륷ƥĴ٤
    if (open(CMD, "/bin/df /home |")) {
        <CMD>;
        @ent = split(/\s+/, <CMD>);
        $homedir = $ent[5];
        close(CMD);
    }

    # /etc/fstabɤ߹
    if (!&readFile($filename, "fstab", *line)) {
        $err = "$filenameɤ߹ޤǤ";
        goto done;
    }

    # userquota,grpquota ɲä
    for ($i = 0; $i <= $#line; $i++) {
        @ent = split(/\s+/, $line[$i]);
        if ($ent[1] eq $homedir) {
            if ($ent[3] !~ /(^|,)usrquota(,|$)/) {
                $ent[3] .= ",usrquota";
            }
            if ($ent[3] !~ /(^|,)grpquota(,|$)/) {
                $ent[3] .= ",grpquota";
            }
            $line[$i] = "$ent[0] $ent[1] $ent[2] $ent[3] $ent[4] $ent[5]\n";

##010414 add CLUSTERPRO Lite!б
        } elsif (($WbMC{'WorkMode'} eq "MailCluster") && ($ent[0] eq $WbMC{'MirrorPartition'})) {

#            $ent[1] = $WbMC{'MountPoint'};
#            @option = spilit(/,/, $WbMC{'MountOption'});
#            for($j = 0; $j <= $#option; $j++) {
#                if ($ent[3] !~ /(^|,)$option[$j](,|$)/) {
#                    $ent[3] .= ",$option[$j]";
#                }
#            }
#            $line[$i] = "$ent[0] $ent[1] $ent[2] $ent[3] $ent[4] $ent[5]\n";
# 20030221 del CLUSTERPRO LE б
            #$line[$i] = "$ent[0] $WbMC{'MountPoint'} ext2 $WbMC{'MountOption'} "
            #          . "$WbMC{'PartitionDump'} $WbMC{'PartitionCheck'}\n";
            $mirrorExist = 1;
        }
    }

##010414 add CLUSTERPRO Lite!б
    if (($WbMC{'WorkMode'} eq "MailCluster") && ($mirrorExist == 0)) {
# 20030221 del CLUSTERPRO LE б
        #$line[$#line+1] = "$WbMC{'MirrorPartition'} "
        #                . "$WbMC{'MountPoint'} "
        #                . "ext2 "
        #                . "$WbMC{'MountOption'} "
        #                . "$WbMC{'PartitionDump'} "
        #                . "$WbMC{'PartitionCheck'}\n";
    }
#    if ($WbMC{'WorkMode'} eq "MailCluster") {
#        $line[$#line+1] = "$WbMC{'DeviceName'}$WbMC{'PartitionPrefix'}2 "
#                        . "$WbMC{'MountPoint'} "
#                        . "ext2 "
#                        . "$WbMC{'MountOption'} "
#                        . "$WbMC{'PartitionDump'} "
#                        . "$WbMC{'PartitionCheck'}\n";
#    }

    # /etc/fstab˽񤭹
    if (!&writeFile($filename, "fstab", @line)) {
        $err = "$filename˽񤭹ޤǤ";
        goto done;
    }

    # $homedir/aquota.user
    if ($homedir eq "/") {
        $homedir = "";
    }
    if (system("/bin/touch $homedir/aquota.user") != 0) {
        $err = "$homedir/aquota.user˼Ԥޤ";
        goto done;
    }
    if (chmod(0600, "$homedir/aquota.user") == 0) {
        $err = "$homedir/aquota.user˼Ԥޤ";
        goto done;
    }

    # $homedir/aquota.group
    if ($homedir eq "/") {
        $homedir = "";
    }
    if (system("/bin/touch $homedir/aquota.group") != 0) {
        $err = "$homedir/aquota.group˼Ԥޤ";
        goto done;
    }
    if (chmod(0600, "$homedir/aquota.group") == 0) {
        $err = "$homedir/aquota.group˼Ԥޤ";
        goto done;
    }
    if (system("/sbin/quotacheck -g -u $homedir >/dev/null 2>&1") != 0) {
        $err = "$homedir Υ˼Ԥޤ";
        goto done;
    }
    if (system("/sbin/quotaon -avug >/dev/null 2>&1") != 0) {
        $err = "$homedir Υ˼Ԥޤ";
        goto done;
    }

    
done:
    return($err);
}

#
# (/etc/crontab)
#
sub writeCrontab
{
    my($filename);
    local(@line);
    my($err);

    $filename = "/etc/crontab";

    # /etc/crontabwbmcdailyΥȥɲä
    if (!&readFile($filename, "crontab", *line)) {
    $err = "$filenameɤ߹ޤǤ";
    goto done;
    }
    for ($i = 0; $i <= $#line; $i++) {
    if ($line[$i] =~ /\/wbmcdaily\s*$/) {
        last;
    }
    }
    $line[$i++] = "00 0 * * * root /opt/nec/wbmc/bin/wbmcdaily\n";
    if (!&writeFile($filename, "crontab", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/sysconfig/network)
#
sub writeNetwork
{
    local(@line);
    my($err);
    my($filename);
    my($gateway);
    my($gatewaydev);

    $filename = "/etc/sysconfig/network";

    $gateway = $IfEth0{'Gateway'};
    $gatewaydev = "eth0";

    # 񤭹Ƥ
    @line = (
    "NETWORKING=yes\n",
    "HOSTNAME=$IfEth0{'HostName'}\n",
    "DOMAINNAME=$IfEth0{'DomainName'}\n",
    "GATEWAY=$gateway\n",
    "GATEWAYDEV=$gatewaydev\n",
#    "FORWARD_IPV4=yes\n");
    "FORWARD_IPV4=no\n");

    # ե˽񤭹
    if (!&writeFile($filename, "network", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/sysconfig/network-scripts/ifcfg-*)
#
sub writeInterface
{
    local(@line);
    my($err);
    my($filename);

    $filename = "/etc/sysconfig/network-scripts/ifcfg-eth0";

    @line = (
    "DEVICE=eth0\n",
    "IPADDR=$IfEth0{'IpAddr'}\n",
    "NETMASK=$IfEth0{'NetMask'}\n",
    "NETWORK=$IfEth0{'NetAddr'}\n",
    "BROADCAST=$IfEth0{'BcastAddr'}\n",
    "ONBOOT=yes\n",
    "BOOTPROTO=\n");

    if (!&writeFile($filename, $lockfile, @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }


    if (($IfEth1{'IpAddr'} ne "") && ($IfEth1{'NetMask'} ne "")) {
    $filename = "/etc/sysconfig/network-scripts/ifcfg-eth1";

    @line = (
    "DEVICE=eth1\n",
    "IPADDR=$IfEth1{'IpAddr'}\n",
    "NETMASK=$IfEth1{'NetMask'}\n",
    "NETWORK=$IfEth1{'NetAddr'}\n",
    "BROADCAST=$IfEth1{'BcastAddr'}\n",
#   "ONBOOT=" . (($Meta{'NetType'} eq "intranet") ? "no" : "yes") . "\n",
    "ONBOOT=yes\n",
    "BOOTPROTO=\n");

    if (!&writeFile($filename, $lockfile, @line)) {
        $err = "$filename˽񤭹ޤǤ";
        goto done;
    }
    }

done:
    return($err);
}

#
# (/etc/HOSTNAME)
#
sub writeHOSTNAME
{
    my(@line);
    my($err);
    my($filename);
    my($hostname);

    $filename = "/etc/HOSTNAME";

    # 񤭹Ƥ
    @line = ( "$IfEth0{'HostName'}\n" );

    # եؽ񤭹
    if (!&writeFile($filename, "HOSTNAME", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

    # hostnameޥɤ¹Ԥ
    if (system("/bin/hostname $IfEth0{'HostName'}") != 0) {
    $err = "ۥ̾˼Ԥޤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/hosts)
#
sub writeHosts
{
    local(@line);
    my(@line2);
    my($line);
    my($err);
    my($filename);
    my($i, $j);

    $filename = "/etc/hosts";

    # ե뤫ɤ߹
    if (-f $filename) {
    if (!&readFile($filename, "hosts", *line)) {
        $err = "$filenameɤ߹ޤǤ";
        goto done;
    }
    }

    # ɥ쥹⤷ϥۥ̾ޥåԤ
    for ($i = 0; $i <= $#line; $i++) {
    $line = $line[$i];
    $line =~ s/#.*//;
    @ent = split(/\s+/, $line);
    if (($ent[0] eq "127.0.0.1")
     || ($IfEth0{'IpAddr'} && ($ent[0] eq $IfEth0{'IpAddr'}))
     || ($IfEth1{'IpAddr'} && ($ent[0] eq $IfEth1{'IpAddr'}))) {
        splice(@line, $i--, 1);
        next;
    }
    for ($j = 1; $j <= $#ent; $j++) {
        if (($ent[$j] eq "localhost")
         || ($ent[$j] eq $IfEth0{'HostName'})
         || ($ent[$j] eq $IfEth1{'HostName'})
         || ($ent[$j] eq $IfEth0{'ShortHostName'})
         || ($ent[$j] eq $IfEth1{'ShortHostName'})) {
        splice(@line, $i--, 1);
        last;
        }
    }
    }

    # ɬפʥȥɲä
    $i = 0;
#    $line2[$i++] = "127.0.0.1\tlocalhost\n";
#    $line2[$i++] = "$IfEth0{'IpAddr'}\t$IfEth0{'HostName'}\n";
    $line2[$i++] = "127.0.0.1\tlocalhost.localdomain\tlocalhost\n";
    $line2[$i++] = "$IfEth0{'IpAddr'}\t$IfEth0{'HostName'}\t$IfEth0{'ShortHostName'}\n";
    # Ͽס
    if ($IfEth1{'IpAddr'} ne "") {
    $line2[$i++] = "$IfEth1{'IpAddr'}\t$IfEth0{'HostName'}\t$IfEth0{'ShortHostName'}\n";
    }

    splice(@line, 0, 0, @line2);

    # եؽ񤭹
    if (!&writeFile($filename, "hosts", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/resolv.conf)
#
sub writeResolvConf
{
    local(@line);
    my($err);
    my($filename);
    my($i);

    $filename = "/etc/resolv.conf";
    @line = ();
    $i = 0;

    # Ƥ
    $line[$i++] = "domain $IfEth0{'DomainName'}\n";
    if ($IfEth0{'PrimaryNameServer'} ne "") {
    $line[$i++] = "nameserver $IfEth0{'PrimaryNameServer'}\n";
    }
    if ($IfEth0{'SecondaryNameServer'} ne "") {
    $line[$i++] = "nameserver $IfEth0{'SecondaryNameServer'}\n";
    }

    # եؽ񤭹
    if (!&writeFile($filename, "resolv.conf", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/hosts.allow)
#
sub writeHostsAllow
{
    local(@line);
    my($err);
    my($filename);

    @line = ();
    $filename = "/etc/hosts.allow";

    # եԽ
    if ($WBMC_MACHINE_TYPE eq "web") {
    @line = (
        "ALL : 127.0.0.1\n",
	"snmpd :ALL\n",
        "sshd : ALL\n", 
        "in.ftpd : ALL\n",
        "in.telnetd : ALL\n",
	"portmap : ALL\n",
	"slapd : ALL\n"
    );
    } elsif ($WBMC_MACHINE_TYPE eq "mail") {
    @line = (
        "ALL : 127.0.0.1\n",
	"snmpd :ALL\n",
        "sshd : ALL\n", 
        "in.ftpd : ALL\n",
        "in.telnetd : ALL\n",
	"portmap : ALL\n",
	"slapd : ALL\n"
    );
    } else {
    @line = (
        "ALL : 127.0.0.1\n",
	"snmpd :ALL\n",
        "sshd : ALL\n", 
        "in.ftpd : ALL\n",
        "in.telnetd : ALL\n",
	"portmap : ALL\n",
	"slapd : ALL\n"
    );
    }

#    @line = (
#    "in.ftpd : $IfEth0{'NetAddr'}/$IfEth0{'NetMask'}\n",
#    "in.telnetd : $IfEth0{'NetAddr'}/$IfEth0{'NetMask'}\n",
#    "ipop3d : $IfEth0{'NetAddr'}/$IfEth0{'NetMask'}\n",
#    "imapd : $IfEth0{'NetAddr'}/$IfEth0{'NetMask'}\n");

    # եؽ񤭹
    if (!&writeFile($filename, "hosts.allow", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/hosts.deny)
#
sub writeHostsDeny
{
    local(@line);
    my($err);
    my($filename);

    @line = ();
    $filename = "/etc/hosts.deny";

    # եԽ
    @line = ("ALL : ALL\n");

    # եؽ񤭹
    if (!&writeFile($filename, "hosts.deny", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}


#
# (/etc/inetd.conf)
#
sub writeInetdConf
{
    my($err);
    my($filename);
    local(@line);
    my($i);
    my($name);

    $filename = "/etc/inetd.conf";

    # ե뤫ɤ߹
    if (!&readFile($filename, "inetd.conf", *line)) {
    $err = "$filenameɤ߹ޤǤ";
    goto done;
    }

    # ȥȤƤг
    for ($i = 0; $i <= $#line; $i++) {
    if ($line[$i] =~ /^\s*(#|)\s*([^\s]*)\s+(stream|dgram)/) {
        $name = $2;
    } else {
        next;
    }
    $names{$name} = 1;
    if ($name eq "ftp") {
        if ($WBMC_MACHINE_TYPE ne "mail") {
        $line[$i] =~ s/^(\s*)(#)/$1/;
        } else {
        $line[$i] =~ s/^(\s*)(#)/#$1/;
        }
    }
    elsif ($name eq "telnet") {
        $line[$i] =~ s/^(\s*)(#)/#$1/;  #wbmc03-005:->
    }
    elsif ($name eq "pop-3") {
        $line[$i] =~ s/^(\s*)(#)/#$1/;
    }
    elsif ($name eq "imap") {
        $line[$i] =~ s/^(\s*)(#)/#$1/;
    }
    }

    # ̵ɲä
    if (!defined($names{"ftp"})) {
    if ($WBMC_MACHINE_TYPE ne "mail") {
        $line[$i++] = "ftp\tstream\ttcp\tnowait\troot\t/usr/sbin/tcpd\tin.ftpd -l -a\n";
    } else {
        $line[$i++] = "#ftp\tstream\ttcp\tnowait\troot\t/usr/sbin/tcpd\tin.ftpd -l -a\n";
    }
    }
    if (!defined($names{"telnet"})) {
    $line[$i++] = "#telnet\tstream\ttcp\tnowait\troot\t/usr/sbin/tcpd\tin.telnetd -h\n";
        #wbmc03-005:->
    }

    if ($WBMC_MACHINE_TYPE ne "web") {
    # sendmail-8.11(NECʪ)б
    if (!defined($names{"pop-3"})) {
       $line[$i++] = "#pop-3\tstream\ttcp\tnowait\troot\t/usr/sbin/tcpd\tipop3d\n";
    }
    if (!defined($names{"imap"})) {
       $line[$i++] = "#imap\tstream\ttcp\tnowait\troot\t/usr/sbin/tcpd\timapd\n";
    }
    }

    # եؽ񤭹
    if (!&writeFile($filename, "inetd.conf", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/xinetd.d/wu-ftpd, /etc/xinetd.d/telnet)
#
sub writeXinetdConf
{
    my($err);
    my($filename);
    local(@line);
    my($i);
    my($name);

    $err = "";

    $wu_ftpd_filename ='/etc/xinetd.d/wu-ftpd';
    $telnet_filename ='/etc/xinetd.d/telnet';

    # ե뤫ɤ߹(wu-ftpd)
    if (-e $wu_ftpd_filename) {
        if (!&readFile($wu_ftpd_filename, "xinetd.d", *line)) {
            $err = "$wu_ftpd_filenameɤ߹ޤǤ";
            goto done;
        }
        # ѥ᡼å
        for ($i = 0; $i <= $#line; $i++) {
            if ($line[$i] =~ /socket_type\s*=\s*(.*)/) {
                if ($1 ne 'stream') {
                    splice(@line, $i, 1, "\tsocket_type\t\t= stream\n");
                }
            }
            if ($line[$i] =~ /wait\s*=\s*(.*)/) {
                if ($1 ne 'no') {
                    splice(@line, $i, 1, "\twait\t\t\t= no\n");
                }
            }
            if ($line[$i] =~ /user\s*=\s*(.*)/) {
                if ($1 ne 'root') {
                    splice(@line, $i, 1, "\tuser\t\t\t= root\n");
                }
            }
            if ($line[$i] =~ /server\s*=\s*(.*)/) {
                if ($1 ne '/usr/sbin/in.ftpd') {
                    splice(@line, $i, 1, "\tserver\t\t\t= /usr/sbin/in.ftpd\n");
                }
            }
            if ($line[$i] =~ /server_args\s*=\s*([.*\s*]*)/) {
                if ($1 ne '-l -a') {
                    splice(@line, $i, 1, "\tserver_args\t\t= -l -a\n");
                }
            }
            if ($line[$i] =~ /log_on_success\s*[-+]*=\s*([.*\s*]*)/) {
                if ($1 ne 'DURATION') {
                    splice(@line, $i, 1, "\tlog_on_success\t\t+= DURATION\n");
                }
            }
            if ($line[$i] =~ /nice\s*=\s*(.*)/) {
                if ($1 ne '10') {
                    splice(@line, $i, 1, "\tnice\t\t\t= 10\n");
                }
            }
            if ($line[$i] =~ /disable\s*=\s*(.*)/) {
                if ($WBMC_MACHINE_TYPE ne "mail") {
                    splice(@line, $i, 1, "\tdisable\t\t\t= no\n");
                }
                else {
                    splice(@line, $i, 1, "\tdisable\t\t\t= yes\n");
                }
            }
        }
    }
    # ե뤬̵Ϻ
    else {
        system("/bin/touch $wu_ftpd_filename");
        push(@line, "\tsocket_type\t\t= stream\n");
        push(@line, "\twait\t\t\t= no\n");
        push(@line, "\tuser\t\t\t= root\n");
        push(@line, "\tserver\t\t\t= /usr/sbin/in.ftpd\n");
        push(@line, "\tserver_args\t\t= -l -a\n");
        push(@line, "\tlog_on_success\t\t+= DURATION\n");
        push(@line, "\tnice\t\t\t= 10\n");
        if ($WBMC_MACHINE_TYPE ne "mail") {
            push(@line, "\tdisable\t\t\t= no\n");
        }
        else {
            push(@line, "\tdisable\t\t\t= yes\n");
        }
    }
    # ե񤭹
    if (!&writeFile($wu_ftpd_filename, "xinetd.d", @line)) {
        $err = "$wu_ftpd_filename˽񤭹ޤǤ";
        goto done;
    }

    # ե뤫ɤ߹(telnet)
    if (-e $telnet_filename) {
        if (!&readFile($telnet_filename, "xinetd.d", *line)) {
            $err = "$telnet_filenameɤ߹ޤǤ";
            goto done;
        }
        # ѥ᡼å
        for ($i = 0; $i <= $#line; $i++) {
            if ($line[$i] =~ /flags\s*=\s*(.*)/) {
                if ($1 ne 'REUSE') {
                    splice(@line, $i, 1, "\flags\t\t= REUSE\n");
                }
            }
            if ($line[$i] =~ /socket_type\s*=\s*(.*)/) {
                if ($1 ne 'stream') {
                    splice(@line, $i, 1, "\tsocket_type\t\t= stream\n");
                }
            }
            if ($line[$i] =~ /wait\s*=\s*(.*)/) {
                if ($1 ne 'no') {
                    splice(@line, $i, 1, "\twait\t\t\t= no\n");
                }
            }
            if ($line[$i] =~ /user\s*=\s*(.*)/) {
                if ($1 ne 'root') {
                    splice(@line, $i, 1, "\tuser\t\t\t= root\n");
                }
            }
            if ($line[$i] =~ /server\s*=\s*(.*)/) {
                if ($1 ne '/usr/sbin/in.telnetd') {
                    splice(@line, $i, 1, "\tserver\t\t\t= /usr/sbin/in.telnetd\n");
                }
            }
            if ($line[$i] =~ /server_args\s*=\s*([.*\s*]*)/) {
                if ($1 ne '-h') {
                    splice(@line, $i, 1, "\tserver_args\t\t= -h\n");
                }
            }
            if ($line[$i] =~ /log_on_failure\s*[-+]*=\s*([.*\s*]*)/) {
                if ($1 ne 'USERID') {
                    splice(@line, $i, 1, "\tlog_on_failure\t\t+= USERID\n");
                }
            }
            if ($line[$i] =~ /disable\s*=\s*(.*)/) {
                if ($1 ne 'yes') {
                    splice(@line, $i, 1, "\tdisable\t\t\t= yes\n");
                }
            }
        }
    }
    # ե뤬̵Ϻ
    else {
        system("/bin/touch $telnet_filename");
        push(@line, "\flags\t\t= REUSE\n");
        push(@line, "\tsocket_type\t\t= stream\n");
        push(@line, "\twait\t\t\t= no\n");
        push(@line, "\tuser\t\t\t= root\n");
        push(@line, "\tserver\t\t\t= /usr/sbin/in.telnetd\n");
        push(@line, "\tserver_args\t\t= -h\n");
        push(@line, "\tlog_on_failure\t\t+= USERID\n");
        push(@line, "\tdisable\t\t\t= yes\n");
    }
    # ե񤭹
    if (!&writeFile($telnet_filename, "xinetd.d", @line)) {
        $err = "$telnet_filename˽񤭹ޤǤ";
        goto done;
    }

done:
    return($err);
}

#
# (/etc/opt/nec/wbmc/ipchains_cur.conf)
#
sub writeIpchainsConf
{
    my($err);
    my(@line);
    my($filename);

    $filename = "/etc/opt/nec/wbmc/ipchains_cur.conf";

    @line = (
    "forward    off\n",
    "if eth0    off off -\n",
    "if eth1    off on  1\n",
    "filter 1   all ident dns\n");

    # եؽ񤭹
    if (!&writeFile($filename, "ipchains_cur.conf", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/opt/nec/wbmchttpd/conf/*)
#
sub writeWbmcHttpd
{
    my($err);
    my($filename);
    local(@line);
    my($i);
    my($changeflag) = 0;
    my($admflag) = 0;

    $filename = "/etc/opt/nec/wbmchttpd/conf/wbmchttpd.conf";

    # WbMCĥۥȤ񤭴$changeflag1ˤ
    if (($IfEth0{'NetAddr'} ne $IfEth0{'NetAddr.old'})
     || ($IfEth0{'NetMask'} ne $IfEth0{'NetMask.old'})
     || ($IfEth0{'IpAddr'} ne $IfEth0{'IpAddr.old'})) {
    $changeflag = 1;
    }

    # wbmchttpd.confɤ߹
    if (!&readFile($filename, "wbmchttpd.conf", *line)) {
    $err = "$filenameɤ߹ޤǤ";
    goto done;
    }

    # Ƥι
    for ($i = 0; $i <= $#line; $i++) {

    # ServerAdminꤹ
    if ($line[$i] =~ /^ServerAdmin\s+/i) {
        $line[$i] = "ServerAdmin admin\@$IfEth0{'HostName'}\n";
    }

    # ServerNameꤹ
#   if ($line[$i] =~ /^ServerName\s+/i) {
#       $line[$i] = "ServerName $IfEth0{'HostName'}\n";
#   }

    # IPɥ쥹ͥåȥɥ쥹ѹ줿ϡ
    # WbMCؤΥǽۥȤꥻåȤ롣
    if ($changeflag) {
#       if ($line[$i] =~ /^\s*<Directory\s+\/opt\/nec\/wbmc\/adm\s*>/) {}
        if ($line[$i] =~ /^\s*<Directory\s+\/opt\/nec\/wbmc\s*>/) {
        $admflag = 1;
        } elsif ($admflag && ($line[$i] =~ /^\s*<\/Directory>/)) {
        $admflag = 0;
        }
        if ($admflag && ($line[$i] =~ /^\s*Allow\s+from\s+/)) {
        $line[$i] = "    Allow from all\n";
        }
    }
    }
    # https б
    open(STDERR,">/dev/null");
    $| = 1;
    $err = &make_cert();
    if ($err ne ""){
      goto done;
    }
    push(@line,"<VirtualHost _default_:50453>\n"
        ."SSLEngine on\n"
        ."SSLCertificateFile /etc/opt/nec/wbmchttpd/conf/ssl.crt/server.crt\n"
        ."SSLCertificateKeyFile /etc/opt/nec/wbmchttpd/conf/ssl.key/server.key\n"
        ."</VirtualHost>\n");

    # wbmchttpd.conf񤭹
    if (!&writeFile($filename, "wbmchttpd.conf", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/named.conf)
#
sub writeNamedConf
{
    my($err);
    my($filename);
    local(@line);
    my($net);
    my($mask);
    my($zone);

    $filename = "/etc/named.conf";

    # /var/named̵к
    if (! -d "/var/named") {
if (!mkdir("/var/named", 0755)) {
    $err = "/var/namedǤޤǤ";
    goto done;
}
    }

    # named.confƤ
    $i = 0;

    if ($Meta{'NetType'} eq "intranet") {
# ץ
$line[$i++] = "options {\n";
$line[$i++] = "\tdirectory \"/var/named\";\n";
$line[$i++] = "\tversion \"unknown\";\n";
$line[$i++] = "\tforwarders {\n";
if ($IfEth0{'PrimaryNameServer'} ne "") {
    $line[$i++] = "\t\t$IfEth0{'PrimaryNameServer'};\n";
}
if ($IfEth0{'SecondaryNameServer'} ne "") {
    $line[$i++] = "\t\t$IfEth0{'SecondaryNameServer'};\n";
}
    $line[$i++] = "\t};\n";
    $line[$i++] = "\tquery-source address * port 53;\n";
    $line[$i++] = "};\n";

    # ҥȥե
    $line[$i++] = "zone \".\" {\n";
    $line[$i++] = "\ttype hint;\n";
    $line[$i++] = "\tfile \"named.ca\";\n";
    $line[$i++] = "};\n";

    # 
    $line[$i++] = "zone \"0.0.127.in-addr.arpa\" {\n";
    $line[$i++] = "\ttype master;\n";
    $line[$i++] = "\tfile \"named.local\";\n";
    $line[$i++] = "};\n";

    # ¦(eth0¦)󥿥ե
    if ($IfEth0{'DnsType'} eq "master") {
        $line[$i++] = "zone \"$IfEth0{'DomainName'}\" {\n";
        $line[$i++] = "\ttype master;\n";
        $line[$i++] = "\tfile \"g.$IfEth0{'DomainName'}\";\n";
        $line[$i++] = "};\n";
        $mask = &mask2bit($IfEth0{'NetMask'});
        $zone = &net2Zone("$IfEth0{'NetAddr'}/$mask");
        $line[$i++] = "zone \"$zone\" {\n";
        $line[$i++] = "\ttype master;\n";
        $zone =~ s/\//_/g;
        $line[$i++] = "\tfile \"g.$zone\";\n";
        $line[$i++] = "};\n";
    }
    }
    elsif ($Meta{'NetType'} eq "dialup") {
    # ץ
    $line[$i++] = "options {\n";
    $line[$i++] = "\tdirectory \"/var/named\";\n";
    $line[$i++] = "\tversion \"unknown\";\n";
    $line[$i++] = "\tforwarders {\n";
    if ($IfEth1{'PrimaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth1{'PrimaryNameServer'};\n";
    }
    if ($IfEth1{'SecondaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth1{'SecondaryNameServer'};\n";
    }
    $line[$i++] = "\t};\n";
    $line[$i++] = "\tquery-source address * port 53;\n";
    $line[$i++] = "};\n";

    # ҥȥե
    $line[$i++] = "zone \".\" {\n";
    $line[$i++] = "\ttype hint;\n";
    $line[$i++] = "\tfile \"named.ca\";\n";
    $line[$i++] = "};\n";

    # 
    $line[$i++] = "zone \"0.0.127.in-addr.arpa\" {\n";
    $line[$i++] = "\ttype master;\n";
    $line[$i++] = "\tfile \"named.local\";\n";
    $line[$i++] = "};\n";

    # ¦ϥޥξ
    if ($IfEth0{'DnsType'} eq "master") {

        $line[$i++] = "zone \"$IfEth0{'DomainName'}\" {\n";
        $line[$i++] = "\ttype master;\n";
        $line[$i++] = "\tfile \"g.$IfEth0{'DomainName'}\";\n";
        $line[$i++] = "};\n";

        $mask = &mask2bit($IfEth0{'NetMask'});
        $zone = &net2Zone("$IfEth0{'NetAddr'}/$mask");
        $line[$i++] = "zone \"$zone\" {\n";
        $line[$i++] = "\ttype master;\n";
        $zone =~ s/\//_/g;
        $line[$i++] = "\tfile \"g.$zone\";\n";
        $line[$i++] = "};\n";

        $line[$i++] = "zone \"$IfEth1{'DomainName'}\" {\n";
        $line[$i++] = "\ttype master;\n";
        $line[$i++] = "\tfile \"g.$IfEth1{'DomainName'}\";\n";
        $line[$i++] = "};\n";

        $mask = &mask2bit($IfEth1{'NetMask'});
        $zone = &net2Zone("$IfEth1{'NetAddr'}/$mask");
        $line[$i++] = "zone \"$zone\" {\n";
        $line[$i++] = "\ttype master;\n";
        $zone =~ s/\//_/g;
        $line[$i++] = "\tfile \"g.$zone\";\n";
        $line[$i++] = "};\n";
    }

    # ¦ϥեɤξ
    elsif ($IfEth0{'DnsType'} eq "forward") {

        $line[$i++] = "zone \"$IfEth0{'DomainName'}\" {\n";
        $line[$i++] = "\ttype forward;\n";
        $line[$i++] = "\tforwarders {\n";
        if ($IfEth0{'PrimaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'PrimaryNameServer'};\n";
        }
        if ($IfEth0{'SecondaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'SecondaryNameServer'};\n";
        }
        $line[$i++] = "\t};\n";
        $line[$i++] = "};\n";

        $mask = &mask2bit($IfEth0{'NetMask'});
        $zone = &net2Zone("$IfEth0{'NetAddr'}/$mask");
        $line[$i++] = "zone \"$zone\" {\n";
        $line[$i++] = "\ttype forward;\n";
        $line[$i++] = "\tforwarders {\n";
        if ($IfEth0{'PrimaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'PrimaryNameServer'};\n";
        }
        if ($IfEth0{'SecondaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'SecondaryNameServer'};\n";
        }
        $line[$i++] = "\t};\n";
        $line[$i++] = "};\n";

        $line[$i++] = "zone \"$IfEth1{'DomainName'}\" {\n";
        $line[$i++] = "\ttype forward;\n";
        $line[$i++] = "\tforwarders {\n";
        if ($IfEth0{'PrimaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'PrimaryNameServer'};\n";
        }
        if ($IfEth0{'SecondaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'SecondaryNameServer'};\n";
        }
        $line[$i++] = "\t};\n";
        $line[$i++] = "};\n";

        $mask = &mask2bit($IfEth1{'NetMask'});
        $zone = &net2Zone("$IfEth1{'NetAddr'}/$mask");
        $line[$i++] = "zone \"$zone\" {\n";
        $line[$i++] = "\ttype forward;\n";
        $line[$i++] = "\tforwarders {\n";
        if ($IfEth0{'PrimaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'PrimaryNameServer'};\n";
        }
        if ($IfEth0{'SecondaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'SecondaryNameServer'};\n";
        }
        $line[$i++] = "\t};\n";
        $line[$i++] = "};\n";
    }
    }
    elsif ($Meta{'NetType'} eq "internet") {
    # ץ
    $line[$i++] = "options {\n";
    $line[$i++] = "\tdirectory \"/var/named\";\n";
    $line[$i++] = "\tversion \"unknown\";\n";
    if ($IfEth1{'DnsType'} eq "forward") {
        $line[$i++] = "\tforwarders {\n";
        if ($IfEth1{'PrimaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth1{'PrimaryNameServer'};\n";
        }
        if ($IfEth1{'SecondaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth1{'SecondaryNameServer'};\n";
        }
        $line[$i++] = "\t};\n";
    }
    $line[$i++] = "\tquery-source address * port 53;\n";
    $line[$i++] = "};\n";

    # ҥȥե
    $line[$i++] = "zone \".\" {\n";
    $line[$i++] = "\ttype hint;\n";
    $line[$i++] = "\tfile \"named.ca\";\n";
    $line[$i++] = "};\n";

    # 
    $line[$i++] = "zone \"0.0.127.in-addr.arpa\" {\n";
    $line[$i++] = "\ttype master;\n";
    $line[$i++] = "\tfile \"named.local\";\n";
    $line[$i++] = "};\n";

    # ¦(eth0¦)󥿥ե
    $mask = &mask2bit($IfEth0{'NetMask'});
    $zone = $IfEth0{'DomainName'};
    $line[$i++] = "zone \"$zone\" {\n";
    if ($IfEth0{'DnsType'} eq "master") {
        $line[$i++] = "\ttype master;\n";
        $line[$i++] = "\tfile \"g.$zone\";\n";
    } elsif ($IfEth0{'DnsType'} eq "slave") {
        $line[$i++] = "\ttype slave;\n";
        $line[$i++] = "\tfile \"g.$zone\";\n";
        $line[$i++] = "\tmasters {\n";
        if ($IfEth0{'PrimaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'PrimaryNameServer'};\n";
        }
        $line[$i++] = "\t};\n";
        unlink("/var/named/g.$zone");
    }
    $line[$i++] = "\tallow-query {\n";
    $line[$i++] = "\t\t127.0.0.0/8;\n";
    $line[$i++] = "\t\t$IfEth0{'NetAddr'}/$mask;\n";
    $line[$i++] = "\t};\n";
    $line[$i++] = "\tallow-transfer {\n";
    $line[$i++] = "\t\t$IfEth0{'NetAddr'}/$mask;\n";
    $line[$i++] = "\t};\n";
    $line[$i++] = "};\n";

    $mask = &mask2bit($IfEth0{'NetMask'});
    $zone = &net2Zone("$IfEth0{'NetAddr'}/$mask");
    $line[$i++] = "zone \"$zone\" {\n";
    if ($IfEth0{'DnsType'} eq "master") {
        $line[$i++] = "\ttype master;\n";
        $zone =~ s/\//_/g;
        $line[$i++] = "\tfile \"g.$zone\";\n";
    } elsif ($IfEth0{'DnsType'} eq "slave") {
        $line[$i++] = "\ttype slave;\n";
        $zone =~ s/\//_/g;
        $line[$i++] = "\tfile \"g.$zone\";\n";
        $line[$i++] = "\tmasters {\n";
        if ($IfEth0{'PrimaryNameServer'} ne "") {
        $line[$i++] = "\t\t$IfEth0{'PrimaryNameServer'};\n";
        }
        $line[$i++] = "\t};\n";
        unlink("/var/named/g.$zone");
    }
    $line[$i++] = "\tallow-query {\n";
    $line[$i++] = "\t\t127.0.0.0/8;\n";
    $line[$i++] = "\t\t$IfEth0{'NetAddr'}/$mask;\n";
    $line[$i++] = "\t};\n";
    $line[$i++] = "\tallow-transfer {\n";
    $line[$i++] = "\t\t$IfEth0{'NetAddr'}/$mask;\n";
    $line[$i++] = "\t};\n";
    $line[$i++] = "};\n";

    # ¦(eth1¦)󥿥ե
    if ($IfEth1{'DnsType'} eq "master") {
        $line[$i++] = "zone \"$IfEth1{'DomainName'}\" {\n";
        $line[$i++] = "\ttype master;\n";
        $line[$i++] = "\tfile \"g.$IfEth1{'DomainName'}\";\n";
        $line[$i++] = "\tallow-transfer {\n";
        $line[$i++] = "\t\t$IfEth1{'SecondaryNameServer'};\n";
        $line[$i++] = "\t};\n";
        $line[$i++] = "};\n";

        $mask = &mask2bit($IfEth1{'NetMask'});
        $zone = $IfEth1{'DnsZoneName'};
        $line[$i++] = "zone \"$zone\" {\n";
        $line[$i++] = "\ttype master;\n";
        $zone = &net2Zone("$IfEth1{'NetAddr'}/$mask");
        $zone =~ s/\//_/g;
        $line[$i++] = "\tfile \"g.$zone\";\n";
        $line[$i++] = "\tallow-transfer {\n";
        $line[$i++] = "\t\t$IfEth1{'SecondaryNameServer'};\n";
        $line[$i++] = "\t};\n";
        $line[$i++] = "};\n";
    }
    }

    # եؽ񤭹
    if (!&writeFile($filename, "named.conf", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

    # /etc/hostsɤ߹
    if (!&readFile("/etc/hosts", "hosts", *hosts)) {
    $err = "/etc/hostsɤ߹ޤǤ";
    goto done;
    }

    # ե
    if ($err = &updateDnsData(@hosts)) {
    goto done;
    }

done:
    return($err);
}

#
# (/etc/httpd/conf/*)
#
sub writeHttpdConf
{
    local(@line);
    my($err);
    my($filename);
    my($i);
    my($found);
    my($docroot);
    my($server);
    my($changeflag);
#    local($sslkey);
#    local($sslcsr);
#    local($sslcrt);
#    local($text);
#    local($who);

    $filename = "/etc/httpd/conf/httpd.conf";

    # եɤ߹
    if (!&readFile($filename, "httpd.conf", *line)) {
    $err = "$filenameɤ߹ޤǤ";
    goto done;
    }

    # httpd.confƤ
    $found = 0;
    for ($i = 0; $i <= $#line; $i++) {
    if ($line[$i] =~ /^\s*ServerName\s+/i) {
        $line[$i] = "ServerName $IfEth0{'HostName'}\n";
    }
    if ($line[$i] =~ /^\s*ServerAdmin\s+/i) {
        $line[$i] = "ServerAdmin web\@$IfEth0{'HostName'}\n";
        }
    if ($line[$i] =~ /^\s*(Listen\s+.*)/i) {
        $line[$i] = "#$1\n";
    }
    if ($line[$i] =~ /^\s*DocumentRoot\s+/i) {
        $line[$i] = "DocumentRoot /home/httpd/html\n";
    }
    if ($line[$i] =~ /^\s*Include\s+\/etc\/httpd\/conf\/wbmc.conf\s+/i) {
        $found = 1;
    }
    }
    if ($found == 0) {
    $line[$i++] = "Include /etc/httpd/conf/wbmc.conf\n";
    }

    # ե˽񤭹
    if (!&writeFile($filename, "httpd.conf", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

    # httpd.bootoptե
    $filename = "/etc/httpd/conf/httpd.bootopt";
    @line = ( "HTTPDOPT=-DSSL\n" );
    if (!&writeFile($filename, "httpd.bootopt", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

    # ۥ̾ʤɤѹƤʤаʹߤνϹԤʤ
    # ˹Ԥ褦ѹ
    if (($firstSet == 1) || ($clearFlag == 1)) {
    # wbmc.confե
    @line = ();
#    $filename = "/opt/nec/wbmc/adm/httpd/wbmc.conf";
    $filename = "/opt/nec/wbmc/adm/service/01httpd/wbmc.conf";
    if (!&readFile($filename, "wbmc.conf", *line)) {
        $err = "$filenameɤ߹ޤǤ";
        goto done;
    }
    $filename = "/etc/httpd/conf/wbmc.conf";
    if (!&writeFile($filename, "wbmc.conf", @line)) {
        $err = "$filename˽񤭹ޤǤ";
        goto done;
    }
    }

    # ۥФɲä
#    $docroot = "/home/httpd/html";
#    if ($IfEth0{'HostName'} ne "") {
#   $server = $IfEth0{'HostName'};
#   if ($err = &addVirtualHost($server, "80", $docroot)) {
#       goto done;
#   }
#   if ($err = &addDirectory($server, "80", "/home/users")) {
#       goto done;
#   }
#   if ($err = &modDirectory($server, "80", "/home/users",
#        "index.html index.htm default.htm",
#       "off", "off", "off", "off", "off", "off")) {
#       goto done;
#   }
#   if ($err = &addVirtualHost($server, "443", $docroot)) {
#       goto done;
#   }
#   if ($err = &addDirectory($server, "443", "/home/users")) {
#       goto done;
#   }
#   if ($err = &modDirectory($server, "443", "/home/users",
#       "index.html index.htm default.htm",
#       "off", "off", "off", "off", "off", "off")) {
#       goto done;
#   }
#
    # ʽ̾
#   if (&getSecretStatus($server, "443", *sslkey)) {
#       $sslkey = 0;
#   }
#   if (&getCertificateRequest($server, "443", *text, *sslcsr)) {
#       $sslcsr = 0;
#   }
#   if (&getCertificate($server, "443", *text, *who, *sslcrt)) {
#       $sslcrt = 0;
#   }
#   if (!$sslkey || (!$sslcsr && !$sslcrt)) {
#       if ($err = &makeSelfCertificate($server, "443",
#           "jp", "unknown", "unknown", "unknown",
#           "unknown", $server)) {
#       goto done;
#       }
#   }
#   if (&getSecretStatus($server, "443", *sslkey)) {
#       $sslkey = 0;
#   }
#   if (&getCertificate($server, "443", *text, *who, *sslcrt)) {
#       $sslcrt = 0;
#   }
#   if ($sslkey && $sslcrt) {
#       if ($err = &setSslStatus($server, "443", "on")) {
#       goto done;
#       }
#   }
#    }

done:
    return($err);
}

#
# (/home/webalizer/*)
#
sub writeWebalizer
{
    my($err);

    # /home/webalizer
    if (! -d "/home/webalizer") {
    if (!mkdir("/home/webalizer", 0755)) {
        $err = "/home/webalizerǤޤǤ";
        goto done;
    }
    }

    # Ǥ˥׾
    if (! -f "/home/webalizer/index.html") {
    if ((-f "/var/log/httpd/access_log")
     && (! -z "/var/log/httpd/access_log")) {
        system("/etc/cron.daily/wbmc_webalizer");
    }
    }

done:
    return($err);
}

#
# (/etc/sendmail.cf)
#
sub writeMail
{
    my($err);
    my($changeflag);

    # ᡼륵Ф
    if(! -e "/etc/mail/local-host-names"){ # 20021004 add matumaura --->
        system("/bin/touch /etc/mail/local-host-names > /dev/null 2>&1");
    } # 20021004 add matumaura <---
    if (initMail(
    $Meta{'NetType'},
    $Service_Mail{'Mail.smtpserver'},
    $Service_Mail{'Mail.pop3server'},
    "pop3",
    0, 1, 1, 1, 1, 1, 0,    # Sun, Mon, ...
    8, 18, 30, 1)) {    # start, end, min, initflag
    $err = "᡼륵Ф˼Ԥޤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/dhcpd.conf)
# (/etc/rc.d/init.d/dhcpd)
#
sub writeDhcpdConf
{
    local(@line);
    my($err);
    my($filename);
    my($i);
    my($namesv);

    $filename = "/etc/dhcpd.conf";

    # ե˽񤭹Ƥꤹ
    $i = 0;
    $line[$i++] = "subnet $IfEth0{'NetAddr'} netmask $IfEth0{'NetMask'} {\n";
    $line[$i++] = "\toption domain-name \"$IfEth0{'DomainName'}\" ;\n";
    if ($IfEth0{'DnsType'} eq "master") {
    $namesv = $IfEth0{'IpAddr'};
    if ($IfEth0{'SecondaryNameServer'} ne "") {
        $namesv .= ", $IfEth0{'SecondaryNameServer'}";
    }
    } elsif ($IfEth0{'DnsType'} eq "slave") {
    $namesv = "$IfEth0{'PrimaryNameServer'}, $IfEth0{'IpAddr'}";
    } elsif ($IfEth0{'DnsType'} eq "forward") {
    $namesv = $IfEth0{'PrimaryNameServer'};
    if ($IfEth0{'SecondaryNameServer'} ne "") {
        $namesv .= ", $IfEth0{'SecondaryNameServer'}";
    }
    }
    $line[$i++] = "\toption domain-name-servers $namesv ;\n";
    $line[$i++] = "\toption broadcast-address $IfEth0{'BcastAddr'} ;\n";
    $line[$i++] = "\tmax-lease-time 86400 ;\n";
    $line[$i++] = "\tdefault-lease-time 43200 ;\n";
    if ($Meta{'NetType'} eq "intranet") {
    if ($IfEth0{'Gateway'} ne "") {
        $line[$i++] = "\toption routers $IfEth0{'Gateway'} ;\n";
    }
    } else {
    $line[$i++] = "\toption routers $IfEth0{'IpAddr'} ;\n";
    }
    $line[$i++] = "\trange $IfEth0{'DhcpRangeStart'} $IfEth0{'DhcpRangeEnd'} ;\n";
    $line[$i++] = "}\n";

    # ե˽񤭹
    if (!&writeFile($filename, "dhcpd.conf", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

    # /etc/opt/nec/rc.d/dhcpd.bootե򹹿
    $filename = "/etc/opt/nec/rc.d/dhcpd.boot";
    @line = (
    "DHCPD=" . (($IfEth0{'DhcpOn'} eq "yes") ? "on" : "off") . "\n",
    "DHCPD_DEV=eth0\n"
    );
    if (!&writeFile($filename, "dhcpd.boot", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/squid/squid.conf)
#
sub writeSquidConf
{
    my($err);
    my($filename);
    local(@line);
    my($line);
    my($addrchange);
    my($accessflag);
    my($accelfound);
    my($accessfound);
    my($hostfound);
    my($timefound);
    my($allowfound);

    $filename = "/etc/squid/squid.conf";

    # ¦ɥ쥹ѹƤ뤫Ĵ٤
    if (($IfEth0{'NetAddr'} ne $IfEth0{'NetAddr.old'})
     || ($IfEth0{'NetMask'} ne $IfEth0{'NetMask.old'})) {
    $addrchange = 1;
    }

    # ե뤫ɤ߹
    if (!&readFile($filename, "squid.conf", *line)) {
    $err = "$filenameɤ߹ޤǤ";
    goto done;
    }

    # wbmc_access󳰤http_access򥳥ȥȤ
    # ɥ쥹ѹСwbmc_access
    $accessflag = 0;
    $accelfound = 0;
    $accessfound = 0;
    for ($i = 0; $i <= $#line; $i++) {
    $line = $line[$i];
    if ($line =~ /^##wbmc_accel_start\s+/) {
        $accelfound = 1;
    }
    if ($line =~ /^##wbmc_access_start\s+/) {
        $accessfound = 1;
        $accessflag = 1;
    }
    if ($accessflag) {
        if ($line =~ /^##wbmc_access_end\s+/) {
        $accessflag = 0;
        }
        if ($addrchange) {
        splice(@line, $i, 1);
        $i--;
        }
    } else {
        if ($line =~ /^\s*http_access\s+/) {
        $line[$i] = "#$line";
        }
    }
    }

    # WbMCϢɲäԤ
    if (!$accelfound) {
    $line[$i++] = "##wbmc_accel_start all\n";
    $line[$i++] = "httpd_accel_host virtual\n";
    $line[$i++] = "httpd_accel_port 80\n";
    $line[$i++] = "httpd_accel_with_proxy on\n";
    $line[$i++] = "httpd_accel_uses_host_header on\n";
    $line[$i++] = "##wbmc_accel_end\n";
    $line[$i++] = "\n";
    }
    if (!$accessfound || $addrchange) {
    $line[$i++] = "##wbmc_access_start all\n";
    $line[$i++] = "http_port 8080\n";
    $line[$i++] = "cache_mem 16 MB\n";
    $line[$i++] = "cache_dir ufs /var/spool/squid 1000 16 256\n";
    $line[$i++] = "acl wbmc_all src 0.0.0.0/0.0.0.0\n";
    $line[$i++] = "acl wbmc_time time SMTWHFA 0:0-23:59\n";
    $line[$i++] = "acl wbmc_host0 src 127.0.0.0/255.0.0.0\n";
    $line[$i++] = "acl wbmc_host1 src $IfEth0{'NetAddr'}/$IfEth0{'NetMask'}\n";
    $line[$i++] = "http_access allow wbmc_time wbmc_host0 \n";
    $line[$i++] = "http_access allow wbmc_time wbmc_host1 \n";
    $line[$i++] = "http_access deny wbmc_all\n";
    $line[$i++] = "never_direct deny wbmc_all\n";
    $line[$i++] = "##wbmc_access_end\n";
    }

    # ե˽񤭹
    if (!&writeFile($filename, "squid.conf", @line)) {
    $err = "$filename˽񤭹ޤǤ";
    goto done;
    }

done:
    return($err);
}

#
# (/etc/smb.conf)
#
sub writeSmbConf
{
    my($err);
    my(@line);
    my($filename);
    my($uid);

    @line = (
        "[global]\n",
    "\tdeadtime = 5\n",
    "\tsmb passwd file = /etc/smbpasswd\n",
    "\tcoding system = euc\n",
    "\tclient code page = 932\n",
    "\tworkgroup = WORKGROUP\n",
    "\tserver string = Samba %v\n",
    "\tencrypt passwords = yes\n",
    "\tmap to guest = Bad User\n",
    "\tsocket options = TCP_NODELAY SO_RCVBUF=8192 SO_SNDBUF=8192\n",
    "\tdns proxy = No\n",
    "\tguest account = smbguest\n",
    "\tos level = 1\n",
    "\tsecurity = user\n",
    "\n",
    "[homes]\n",
    "\tcomment = %U's Home directory\n",
    "\tread only = No\n",
    "\tbrowseable = No\n",
    "\n",
    "[web]\n",
    "\tcomment = Web page\n",
    "\tpath = /home/httpd\n",
    "\tread only = No\n",
    "\tbrowseable = yes\n"
    );

    # /etc/smb.conf˽񤭹
    $filename = "/etc/smb.conf";
    if (!&writeFile($filename, "smb.conf", @line)) {
    $err = "$filenameؤν񤭹ߤ˼Ԥޤ";
    goto done;
    }

    # web桼UID
    $uid = (getpwnam("web"))[2];
    if (!defined($uid)) {
        $err = "web桼Υ桼IDǤޤǤ";
        goto done;
    }

    # web桼SambaϿ
    if ($Account{'RootPassword'} ne "") {
        ##001129 rep misa
        if ($err = &modSambaLogin("web", $uid, $Account{'RootPassword'}, "on")) {
            #$err = "web桼SambaϿǤޤǤ";
            goto done;
        }
    }

done:
    return($err);
}

sub ssh_key_copy{
        my($err);

        if (system("/bin/cp -f /etc/ssh/ssh_host_key.pub /opt/nec/wbmc/")) {
                $err = "ssh ΥΥԡ˼Ԥޤ";
                goto done;
        }

done:
        return($err);

}

sub config_root_ssh_config{

  if(!-d "/root/\.ssh"){
    system("/bin/mkdir /root/\.ssh > /dev/null 2>&1");
    system("/bin/chmod 700 /root/\.ssh > /dev/null 2>&1");
  }
  system("/bin/echo  Protocol 1 > /root/.ssh/config");

  return 0;
}

sub wbmc_slink_set{
    my($err);

    my($file)    = "/etc/rc.d/init.d/wbmcinit";
    my($symlink3) = "/etc/rc.d/rc3.d/S37wbmcinit";
    my($symlink4) = "/etc/rc.d/rc4.d/S37wbmcinit";
    my($symlink5) = "/etc/rc.d/rc5.d/S37wbmcinit";

    if(!(-e $symlink3)){
            symlink $file,$symlink3;
    }
    if(!(-e $symlink4)){
            symlink $file,$symlink4;
    }
    if(!(-e $symlink5)){
            symlink $file,$symlink5;
    }

    ## ե륳ԡ Ͽ
    $file     = "/etc/rc.d/init.d/wbmccopy";
    $symlink3 = "/etc/rc.d/rc3.d/S83wbmccopy";
    $symlink4 = "/etc/rc.d/rc4.d/S83wbmccopy";
    $symlink5 = "/etc/rc.d/rc5.d/S83wbmccopy";

    if(!(-e $symlink3)){
            symlink $file,$symlink3;
    }
    if(!(-e $symlink4)){
            symlink $file,$symlink4;
    }
    if(!(-e $symlink5)){
            symlink $file,$symlink5;
    }

    # IPLB ޤϡ"WebLoadbalance" ξˤϡipchains νԤʤ
    if (!defined($IPLB{'IplbType'}) && ($WbMC{'WorkMode'} ne "WebLoadbalance")) {
        ## wbmcipchains
        $file     = "/etc/rc.d/init.d/wbmcipchains";
        $symlink3 = "/etc/rc.d/rc3.d/S84wbmcipchains";
        $symlink4 = "/etc/rc.d/rc4.d/S84wbmcipchains";
        $symlink5 = "/etc/rc.d/rc5.d/S84wbmcipchains";

        if(!(-e $symlink3)){
                symlink $file,$symlink3;
        }
        if(!(-e $symlink4)){
                symlink $file,$symlink4;
        }
        if(!(-e $symlink5)){
                symlink $file,$symlink5;
        }
    }
done:
        return($err);

}

#
# 顼λ
#
sub errorMsg
{
    my($msg) = @_;

    $msg .= "\n";
    print STDERR $msg;
}


#
# (/etc/logrotate.d/syslog)     ##001121 add
#
sub writeSyslog
{
    # ʺˤ

    ##SMTPХ
    if ($err = &writeSyslog2("/var/log/maillog")) {
        goto done;
    }
    ##POP/IMAPХ
    if ($err = &writeSyslog2("/var/log/imaplog")) {
        goto done;
    }

done:
    return($err);

}

#
# writeSyslogΥ֥롼(ʤ̵뤹)
#
sub writeSyslog2
{
    my($sectionname) = @_;
    local(@file);
    my($err);
    my($filename);

    $filename = "/etc/logrotate.d/syslog";

    # եɤ߹
    if (!&readFile($filename, "syslog", *file)) {
        $err = "$filenameɤ߹ޤǤ";
        goto done;
    }

    #
    # "̾ {" õ
    #
#    $findflag = 0;
    for ($i = 0; $i < @file; $i++) {
        $file[$i] =~ s/^\s*//;
        if ($file[$i] =~ /^\Q$sectionname\E\s*{/) {
            $startline = $i;
            $startflag = 1;
        }
    }
    if ($startflag == 0) {
#       $err = "$sectionnameĤޤ";
        goto done;
    }

    #
    # νȤʤ '}' õ 
    #
    $endflag = 0;
    for ($i = $startline; $i < @file; $i++) {
        if ($file[$i] =~ /^}/) {
            $endline = $i;
            $endflag = 1;
            last;
        }
    }
    if ($endflag == 0) {
        $err = "$filenameǤ";
        goto done;
    }

    for ($i = $startline + 1; $i <= $endline; $i++) {
        #
        # 
        #
        if ($file[$i] =~ /^#/) {
            next;
        }
        #
        # "daily","weekly","monthly"
        #
        if ($file[$i] =~ /^daily/) {
            splice(@file, $i, 1);
            $i--;
            next;
        } elsif ($file[$i] =~ /^weekly/) {
            splice(@file, $i, 1);
            $i--;
            next;
        } elsif ($file[$i] =~ /^monthly/) {
            splice(@file, $i, 1);
            $i--;
            next;
        } elsif ($file[$i] =~ /^size/) {
            #
            # "size"
            #
            splice(@file, $i, 1);
            $i--;
            next;
        } elsif ($file[$i] =~ /^rotate/) {
            #
            # "rotate"
            #       
            splice(@file, $i, 1);
            $i--;
            next;
        }
    }

    # ե˽񤭹
    if (!&writeFile($filename, "syslog", @file)) {
        $err = "$filename˽񤭹ޤǤ";
        goto done;
    }

done:
    return($err);

}


#
# ̾
#   setMailUser - mailѥ桼ɲ(ɬפǤХǥ쥯ȥ
# 
#   setMailUser($name, $domainName, $passwd, $expire, $quota)
# 
#   $name         user-name
#   $domainName   domain-name
#   $passwd       password
#   $expire       expire
#   $quota        quota
# 
#   λ ""
#   Ԥλ ""ʳ
#
sub setMailUser
{
    local($name,$domainName,$passwd,$expire,$quota) = @_;

    local($err) = "";
    local(@lines) = ();
    local($mailDirectory,$domainDirectory,$userDirectory) = ();

    # parameter check
    # pass

    $mailDirectory = "/home/mail";
    $domainDirectory = "/home/mail/$domainName";
    $userDirectory = "/home/mail/$domainName/$name";

    # create mailDirectory
    if ($err = &createDirectory( $mailDirectory, oct "0700", "root", "mail" )) {
  goto done;
    }

    # create domain-directory
    if ($err = &createDirectory( $domainDirectory, oct "0700", "root", "mail" )) {
  goto done;
    }

    # create user-directory
    if ($err = &createDirectory( $userDirectory, oct "0700", "root", "mail" )) {
  goto done;
    }

use MIME::Base64 qw(encode_base64);

    # set #pass (base64)
    # saslpasswd бɲ 2002.9.28 kima
    if ($err = setMailPassword($name, $passwd, $userDirectory, $domainName)) {
        goto DONE;
    }

    # set #quota (binary 4bytes)
    if ($err = setMailQuota($name, $quota, $userDirectory)) {
        goto DONE;
    }

    # set #expire (binary 4bytes)
    if ($err = setMailExpire($name, $expire, $userDirectory)) {
        goto DONE;
    }

    $cmd = "/bin/chown " . "-R " . "root:mail " . "$userDirectory";
    open(IN, "$cmd 2>&1 |");
    @ans = <IN>;
    close(IN);

    # chown 顼֤
    if (@ans) {
        $err = "MailѤΥǥ쥯ȥchownǥ顼ޤϷٹȯޤ@ans";
        goto done;
    }
    
done:
    return $err;
}

#
# (ߥ顼ѥѡƥ)     ##010414 add
#
sub makeClusterPartition
{
    local($err) ="";

    # ǥѡƥ
    if (system("/bin/echo \",0\n,0\n,0\n,0\n\" "
               . "| /sbin/sfdisk -q $WbMC{'DeviceName'} > /etc/opt/nec/wbmc/confinit.log")) {
        $err = "ߥ顼ѥǥν˼Ԥޤ";
        goto done;
    }

    if (system("/bin/echo \"n\np\n1\n\n+$WbMC{'ControlPartitionSize'}M\n"
                         . "n\np\n2\n\n+$WbMC{'PartitionSize'}M\n"
                         . "w\n\" " . " | /sbin/fdisk $WbMC{'DeviceName'} "
                         . " >> /etc/opt/nec/wbmc/confinit.log 2>&1")) {
        $err = "ߥ顼ѥǥΥѡƥκ˼Ԥޤ";
        goto done;
    }
done:
    return($err);
}

sub openldapInitSetup
{
    local ($err) = "";
    my ($passwd);
    $passwd = $Account{'RootPassword'};
    $passwd_arg = &encodeCmdArg($passwd);

    my ($SLAPD_CONF) = "/etc/openldap/slapd.conf";
    my ($SLAPD_CONF_NEW) = "/etc/openldap/slapd.conf.new";

    $err = "$SLAPD_CONF ĤޤǤ";
    ( -e $SLAPD_CONF ) || return($err);
    $err = "$SLAPD_CONF ץǤޤǤ";
    open (SLAPD_CONF, $SLAPD_CONF) || return($err);
    $err = "$SLAPD_CONF_NEW ץǤޤǤ";
    open (OUT,">$SLAPD_CONF_NEW") || return($err);
    while (<SLAPD_CONF>) {
        if ($_ =~ /^suffix/) {
            print OUT "suffix    \"dc=Express5800,dc=mw\"\n";
        }
        elsif ($_ =~ /^rootdn/) {
            print OUT "rootdn    \"cn=Manager, dc=Express5800,dc=mw\"\n";
        }
        elsif ($_ =~ /^rootpw/) {
            next;
        }
        else {
            print OUT $_;
        }
    }
    close(SLAPD_CONF);
    print OUT "\nrootpw    \"$passwd_arg\"";
    close(SLAPD_CONF_NEW);
    $err = "$SLAPD_CONF ǤޤǤ";
    unlink($SLAPD_CONF) || return($err);
    $err = "$SLAPD_CONF_NEW  $SLAPD_CONF ̾ѹǤޤǤ";
    rename($SLAPD_CONF_NEW,$SLAPD_CONF) || return($err);
    $err = "$SLAPD_CONF Υ¤ѹǤޤǤ";
    chmod(0640,$SLAPD_CONF) || return($err);
    system("/bin/chown root:ldap /etc/openldap/slapd.conf");

    # 롼ȥ֥Ȥκ
    open(LDIF,">/tmp/init-ldif");
    print LDIF <<END_OF_MESSAGE;
dn: dc=Express5800,dc=mw
objectclass: top
END_OF_MESSAGE
    close(LDIF);
    $err = "openldap εư˼Ԥޤ";
    system("/etc/rc.d/init.d/ldap start >/dev/null 2>&1") && return($err);
    system("/sbin/ifconfig lo 127.0.0.1 netmask 255.0.0.0 up");
    $err = "openldap 롼ȥ֥Ȥ˼Ԥޤ";
    system("/usr/bin/ldapadd -x -D \"cn=Manager,dc=Express5800,dc=mw\" -w $passwd_arg -f /tmp/init-ldif >/dev/null 2>&1") && return($err);
    system("/sbin/ifconfig lo down");
    system("/etc/rc.d/init.d/ldap stop >/dev/null 2>&1");
    unlink("/tmp/init-ldif");

    return("");
}

1;
