# $Id: wbmc_dc_rsync.pl,v 1.1.1.1 2002/09/09 07:43:33 snavi Exp $
# $Revision: 1.1.1.1 $
# $Date: 2002/09/09 07:43:33 $

##010323 v4.0.1 rsync̃IvV -H ǉ(n[hNp)  S.Oku

use IPC::Open3;

$env_prog = '/usr/bin/env';
$rsync_env = 'RSYNC_RSH="/usr/bin/ssh"';
$rsync_prog = '/usr/bin/rsync';
$rsync_opt = '-a --delete -H ';
$config_file = '/opt/nec/wbmc/wbmc_dc/wbmc_dc_rsync.cfg';
$touch_prog = '/bin/touch';
$last_file = '/etc/opt/nec/wbmc_dc.last_rsync';

sub wbmc_dc_exec_rsync {
    my($hostname, $dir) = @_;
    my $message = '';
    my $pid = open3('WRITER', 'READER', '',
		    "$env_prog $rsync_env $rsync_prog $rsync_opt $dir $hostname:$dir\n");
    while(<READER>) {
	$message .= $_;
    }
    close(WRITER);
    close(READER);
    waitpid($pid, 0);
    my $rsync_status = $?;
    my @touch_result = &wbmc_dc_rsh_sigle_host("$touch_prog $last_file", 
					       $hostname, 'root');
    return [$hostname, $rsync_status, $message];
}

sub wbmc_dc_parse_rsync_configs {
    my($config_file) = @_;
    my %config = {};
    open(CFG_FILE, $config_file);
    while(<CFG_FILE>) {
	$line = $_;
	if ($_ =~ /^\#/) {
	    next;
	}
    }
}

1;
