#!/usr/bin/perl

# Copyright (C) 2000 NEC Corporation
# All Rights Reserved.

# RCS: $Id: ssl.cgi,v 1.1.1.1 2002/09/09 07:43:34 snavi Exp $

#-----------------------------------------------------------------------

##000802 4.1 2000/10Ǥ˹ѹ   .haramoto
##000819 4.1 $navibar            .haramoto
##000823 4.1 $serverɽ       .haramoto

#-----------------------------------------------------------------------
require "../../lib/wbmc.pl";
require join ("/", $WBMC_DOMADM_DIR, "httpd/server.pl");
require join ("/", $WBMC_DOMADM_DIR, "httpd/ssl.pl");

$server = $ARGV[0]; $server =~ s/\\(.)/$1/g;
$port = $ARGV[1]; $port =~ s/\\(.)/$1/g;

# ݡֹ椬 * λϥ顼
if ($port eq "*") {
	&showErrorPage("ݡֹ * ФSSLꤹ뤳ȤϤǤޤ");
	exit(1);
}

# ̩κ
if ($err = &getSecretStatus($server, $port, *status)) {
	&showErrorPage($err);
	exit(1);
}
if ($status) {
	$secret = "<FONT COLOR=red></FONT>";
	$secflag = 1;
} else {
	$secret = "̤";
	$secflag = 0;
}

# ̾׵κ
if ($err = &getCertificateRequest($server, $port, *text, *exist)) {
	&showErrorPage($err);
	exit(1);
}
if ($exist) {
	$csr = "<FONT COLOR=red></FONT>";
	$csrflag = 1;
} else {
	$csr = "̤";
	$csrflag = 0;
}

# κ
if ($err = &getCertificate($server, $port, *text, *who, *exist)) {
	&showErrorPage($err);
	exit(1);
}
if ($exist) {
	$certificate = "<FONT COLOR=red></FONT>";
	$certflag = 1;
} else {
	$certificate = "̤";
	$certflag = 0;
}

#ʥӥ
$navibar = &getNavigation(
	"Web",	"index.cgi",
	"SSL",		"",
	"_back",	"index.cgi",
	"_help",	"ssl_help.html");

#-----------------------------------------------------------------------
print <<END_OF_DATA
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>Web - SSL</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function func() {
	for (i = 0; i < document.f1.Action.length; i++) {
		if (document.f1.Action[i].checked) {
			act = document.f1.Action[i].value;
			break;
		}
	}
	if (i == document.f1.Action.length) {
		alert("ꤷƤ");
		return;
	}
	else if (act == "makeSelfCertificate") {
		if ($certflag == 1) {
			if (!window.confirm("Ǥ˾¸ߤޤ񤭤Ƥ⤫ޤޤ󤫡")) {
				return;
			}
		}
		if ($secflag == 1) {
			if (!window.confirm("Ť̩¸ߤΤǾ񤭤ޤǤ")) {
				return;
			}
		}
		if ($csrflag == 1) {
			if (!window.confirm("Ť̾׵᤬¸ߤΤǺޤǤ")) {
				return;
			}
		}
	}
	else if (act == "showCertificate") {
		if ($certflag == 0) {
			alert("񤬺Ƥޤ");
			return;
		}
	}
	else if (act == "deleteSelfCertificate") {
		if (($secflag == 0) && ($certflag == 0)) {
			alert("̩Ⱦ񤬺Ƥޤ");
			return;
		} else if (($secflag == 1) && ($certflag == 0)) {
			if (!window.confirm("̩ޤǤ")) {
				return;
			}
		} else if (($secflag == 0) && ($certflag == 1)) {
			if (!window.confirm("ޤǤ")) {
				return;
			}
		} else {
			if (!window.confirm("̩ȾޤǤ")) {
				return;
			}
		}
	}
	else if (act == "makeCertificateRequest") {
		if ($csrflag == 1) {
			if (!window.confirm("Ǥ˾̾׵᤬¸ߤޤ񤭤Ƥޤޤ󤫡")) {
				return;
			}
		}
		if ($certflag == 1) {
			if (!window.confirm("Ť¸ߤΤǺޤǤ")) {
				return;
			}
		}
		if ($secflag == 1) {
			if (!window.confirm("Ť̩¸ߤΤǾ񤭤ޤǤ")) {
				return;
			}
		}
	}
	else if (act == "showCertificateRequest") {
		if ($csrflag == 0) {
			alert("̾׵᤬Ƥޤ");
			return;
		}
	}
	else if (act == "deleteCertificateRequest") {
		if (($secflag == 0) && ($csrflag == 0)) {
			alert("̩Ⱦ̾׵᤬Ƥޤ");
			return;
		} else if (($secflag == 1) && ($csrflag == 0)) {
			if (!window.confirm("̩ޤǤ")) {
				return;
			}
		} else if (($secflag == 0) && ($csrflag == 1)) {
			if (!window.confirm("̾׵ޤǤ")) {
				return;
			}
		} else {
			if (!window.confirm("̩Ⱦ̾׵ޤǤ")) {
				return;
			}
		}
	}
	else if (act == "registCertificate") {
		if ($secflag == 0) {
			alert("̩Ƥޤ");
			return;
		}
		if ($csrflag == 0) {
			alert("̾׵᤬Ƥޤ");
			return;
		}
		if ($certflag == 1) {
			if (!window.confirm("Ǥ˾¸ߤޤ񤭤Ƥ⤫ޤޤ󤫡")) {
				return;
			}
		}
	}
	else if (act == "deleteCertificate") {
		if ($certflag == 0) {
			alert("񤬺Ƥޤ");
			return;
		} else {
			if (!window.confirm("ޤǤ")) {
				return;
			}
		}
	}
	document.f1.submit();
}
// -->
</SCRIPT>
</HEAD>
<BODY>
<H4 ALIGN="center">Web - SSL</H4>
<HR>
 $navibar
<HR>
		<!-- ##000823 delete --
<CENTER>
<FONT COLOR="red"><B>$server : $port</B></FONT>
</CENTER>
<P>
		  -->
<CENTER>
<TABLE>
 <TR>
  <TD>
   <FORM METHOD=POST NAME="f1" ACTION="ssl2.cgi?$server+$port">
    <TABLE BGCOLOR="#CCCCCC" BORDER=1 CELLSPACING=0 CELLPADDING=1 WIDTH="100%">
     <TR BGCOLOR="#000080">
      <TD>
       <FONT COLOR="#FFFFFF"> <B>̩Ⱦκ</B></FONT>
      </TD>
     </TR>
     <TR>
      <TD>
       <TABLE>
	<TR>
         <TD>
          <BR>ߤξ<BR>
          <TABLE>
           <TR>
            <TD WIDTH=35></TD>
            <TD>̩ξ֡</TD>
            <TD>$secret</TD>
           </TR>
           <TR>
            <TD></TD>
            <TD>̾׵ξ֡</TD>
            <TD>$csr</TD>
           </TR>
           <TR>
            <TD></TD>
            <TD>ξ֡</TD>
            <TD>$certificate</TD>
           </TR>
          </TABLE>
         </TD>
        </TR>

        <TR>
         <TD>
          <TABLE>
           <TR>
            <TD>
             ʽ̾ξ<BR>

             <TABLE>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="makeSelfCertificate">̩Ⱦ<BR>
               </TD>
              </TR>
              <TR>
               <TD></TD>
               <TD>
                <INPUT TYPE=radio  NAME="Action" VALUE="showCertificate">ξɽ<BR>
               </TD>
              </TR>
              <TR>
               <TD></TD>
               <TD>
               <INPUT TYPE=radio NAME="Action" VALUE="deleteSelfCertificate">̩Ⱦ<BR>
               </TD>
              </TR>
             </TABLE>

            </TD>
           </TR>
          </TABLE>
         </TD>
        </TR>

        <TR>
         <TD>
          <TABLE>
           <TR>
            <TD>
             ǧڶɽ̾ξ<BR>

             <TABLE>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="makeCertificateRequest">̩Ⱦ̾׵<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="showCertificateRequest">̾׵ɽ<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="deleteCertificateRequest">̩Ⱦ̾׵<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="registCertificate">̾ѤߤξϿ<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="showCertificate">ξɽ<BR>
               </TD>
              </TR>
              <TR>
               <TD WIDTH=30></TD>
               <TD>
                <INPUT TYPE=radio NAME="Action" VALUE="deleteCertificate"><BR>
               </TD>
              </TR>
             </TABLE>

	    </TD>
           </TR>
          </TABLE>
         </TD>
        </TR>

        <TR>
         <TD>

       <TABLE ALIGN=center>
        <TR>
         <TD>
          <INPUT TYPE="button" VALUE="" onClick="func()">
         </TD>
        </TR>
       </TABLE>

         </TD>
        </TR>
       </TABLE>

     </TR>
    </TABLE>
   </FORM>
  </TD>
 </TR>
</TABLE>
</CENTER>
$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#-----------------------------------------------------------------------

