#!/usr/bin/perl

# Copyright (C) 2000-2003 NEC Corporation
# All Rights Reserved.

# RCS: $Id: wbmc.pl,v 1.4 2005/09/26 11:59:36 snavi Exp $

##000912 饹бɲ require
##001102 v5.1  FQDNб(wbmc03-001) S.Oku
##001109 v5.1 WebLoadbalanceб by haramoto
##001221 v5.1 wbmc03-077бcheckAppDomainNameɲáS.Oku
##010319 v4.0.1 showRltBtnPage()ɲ	Nagashima
##010706 v4.1.1 writeFile() my б Hori

require "/opt/nec/wbmc/lib/cluster_com.pl";

#--------------------------------------------------------------------
#  DM  wbmc.pl(/opt/nec/wbmc/domain/lib/wbmc.pl) Ǥ
#--------------------------------------------------------------------

# 󥹥ȡǥ쥯ȥ
$WBMC_INSTALL_DIR = "/opt/nec/wbmc";
$WBMC_BIN_DIR = "$WBMC_INSTALL_DIR/bin";
$WBMC_LIB_DIR = "$WBMC_INSTALL_DIR/lib";        #domain⡢̤(000819)
$WBMC_ADM_DIR = "$WBMC_INSTALL_DIR/adm";
$WBMC_USR_DIR = "$WBMC_INSTALL_DIR/usr";        #domain⡢̤(000819)

# 000726 misa add start (for domain)
$WBMC_DOM_DIR    = "$WBMC_INSTALL_DIR/domain";  # /opt/nec/wbmc/domain
$WBMC_DOMBIN_DIR = "$WBMC_DOM_DIR/bin";         # /opt/nec/wbmc/domain/bin
$WBMC_DOMLIB_DIR = "$WBMC_DOM_DIR/lib";         # /opt/nec/wbmc/domain/lib
$WBMC_DOMADM_DIR = "$WBMC_DOM_DIR/adm";         # /opt/nec/wbmc/domain/adm
$WBMC_DOMUSR_DIR = "$WBMC_DOM_DIR/usr";         # /opt/nec/wbmc/domain/usr
# 000726 misa add end   (for domain)

#ɥᥤ̾롼̾μ                   #000901
$domainname = &getDomainName();                 #000901
$WBMC_DOMCNF_DIR = "/home/.wbmc/$domainname";   #000901 for backup

$WBMC_VAR_DIR = "/var/opt/nec/wbmc";
$WBMC_HTTPD_DIR = "/opt/nec/wbmchttpd";
$WBMC_HTTPD_CONF_DIR = "/etc/opt/nec/wbmchttpd/conf";

$WBMC_DOMAIN_DIR = "/etc/opt/nec/wbmc";     ##000901 (domain.conf)

# ̲ηcopyrightʸ
$WBMC_COPYRIGHT = &getCopyright();


{
    my($filename);
    local(*MT);
    my(@line);

    $WBMC_MACHINE_TYPE = "pre";

    # ޥ󥿥פ
    $filename = "/etc/opt/nec/machinetype";
    if (-e $filename) {
        if (open(MT, $filename)) {
            @line = <MT>;
            close(MT);

            if (defined($line[0])) {
                $line[0] =~ s/^\s*//;
                $line[0] =~ s/\s*$//;
                if ($line[0] ne "") {
                    $WBMC_MACHINE_TYPE = $line[0]
                }
            }
        }
    }

    # OSפ
    if (-f "/etc/turbolinux-release") {
        $WBMC_OS_TYPE = "turbo";
    } elsif (-f "/etc/redhat-release") {
        $WBMC_OS_TYPE = "redhat";
    } else {
        $WBMC_OS_TYPE = "unknown";
    }

    ##001109 -------------- ɲ --------------
    if($WBMC_MACHINE_TYPE eq "pre"){
        # webmail ξ硢WebLoadbalance ʤwebѹ
        $filename = "/etc/opt/nec/wbmc/INITCONF.INI";
        if (-e $filename) {
            if (open(MT, $filename)) {
                @line = <MT>;
                close(MT);

                for ($i = 0; $i < @line; $i++) {
                    $line[$i] =~ s/^\s*//;
                    if ($line[$i] =~ /WorkMode=WebLoadbalance\s*/) {
                        $WBMC_MACHINE_TYPE = "web";
                        last;
                    }
                }

            }
        }
    }
    ##001109 -------------- ޤɲ --------------
}


# Сեɤ߹ߡ
{
    # ͥå(appliance3.0 ʹߤϥե뤬ΤǥåȤʤ)
    # $WBMC_MGRNAME   = "Management Console for Appliance Server ";
    # $WBMC_MGRVER    = "3.10";
    
    # WbMC ̾γǼեɤ߹ߡ
    $filename   = "/etc/opt/nec/mgr_name";
    if (-e $filename) {
        if (open(MT, $filename)) {
            @line = <MT>;
            close(MT);
            if (defined($line[0])) {
                $line[0] =~ s/^\s*//;
                $line[0] =~ s/\s*$//;
                if ($line[0] ne "") {
                    $WBMC_MGRNAME = $line[0];
                }
            }
        }
    }
    # WbMC СǼեɤ߹ߡ
    $filename   = "/etc/opt/nec/mgr_version";
    if (-e $filename) {
        if (open(MT, $filename)) {
            @line = <MT>;
            close(MT);
            if (defined($line[0])) {
                $line[0] =~ s/^\s*//;
                $line[0] =~ s/\s*$//;
                if ($line[0] ne "") {
                    $WBMC_MGRVER = $line[0];
                }
            }
        }
    }
}


#
# ̾
#   getCopyright - ֲ̰  copyright ʸФ
# 
#   getCopyright()
# 
#   ʤ
# 
#   Copyright  html ᡼
#
sub getCopyright
{
    local($data) = "";
    $data   = "<HR>\n"
            . "<IMG SRC=\"/image/nec_w.gif\" WIDTH=56 HEIGHT=16>Copyright(C) NEC Corporation 2000-2005\n";
    
    return($data);
}


#
# ̾
#   readParam - եफΥѥ᡼ɤ߹
# 
#   readParam()
# 
#   ʤ
# 
#   ΤȤʸ
#   ԤΤȤ顼å
#
sub readParam
{
    local($err, $buf, $name, $value);

    if ($ENV{'REQUEST_METHOD'} eq "POST") {
        read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
    } elsif ($ENV{'REQUEST_METHOD'} eq "GET") {
        $buf = $ENV{'QUERY_STRING'};
    } else {
        $err = "Invalid request method.";
        return($err);
    }

    foreach (split(/&/, $buf)) {
        ($name, $value) = split(/=/);
        $value =~ tr/+/ /;
        $value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
        $FORM{$name} = $value;
    }

    return($err);
}

#
# ̾
#   showErrorPage - 顼åɽ
# 
#   showErrorPage($message, $page)
# 
#   $message ɽ륨顼å
#       ꤷʤ""ꤹȡ"ϼԤޤ"ɽ
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
# 
#   ʤ
#
sub showErrorPage
{
    my($message, $page) = @_;
    my($msg);

    if (!defined($message) || $message eq "") {
        $msg = "ϼԤޤ";
    } else {
        $msg = $message;
    }

    &showMessagePage("顼", $msg, $page);
}

#
# ̾
#   showResultPage - ()ɽ
# 
#   showResultPage($message, $page, $page2)
# 
#   $message ɽ̥å
#       ꤷʤ""ꤹȡ"ޤ"ɽ
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
#   $page2 ɲåܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡܥΤɽʤ
# 
#   ʤ
#
sub showResultPage
{
    my($message, $page, $page2) = @_;
    my($msg);

    if (!defined($message) || $message eq "") {
        $msg = "ޤ";
    } else {
        $msg = $message;
    }

    &showMessagePage("", $msg, $page, $page2);
}

#
# ̾
#   showMessagePage - åɽ()
#           showErrorPageshowResultPageμ
# 
#   showMessagePage($title, $message, $page, $page2)
# 
#   $title ɽ륿ȥ
#   $message ɽå
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
#   $page2 ɲåܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡܥΤɽʤ
# 
#   ʤ
#
sub showMessagePage
{
    my($title, $message, $page, $page2) = @_;
    my($newpage, $newpage2);

    if (!defined($page) || $page eq "") {
        $newpage = "history.back()";
    } else {
        $newpage = "location.href='$page'";
    }

    if (!defined($page2) || $page2 eq "") {
        $newpage2 = "";
    } else {
        $newpage2 = "<INPUT TYPE='button' VALUE='ɲ' onClick=\"location.href='$page2'\">";
    }

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY>
<H4 ALIGN="center">$title</H4>
<HR>

<CENTER>
 <FORM>
  <TABLE BGCOLOR="#CCCCCC" WIDTH=300 BORDER=1 CELLSPACING=0 CELLPADDING=1>
   <TR BGCOLOR="#000080">
    <TD>
     <FONT COLOR="#FFFFFF"> <B>$title</B></FONT>
    </TD>
   </TR>
   <TR>
    <TD>
     <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD>
        $message
       </TD>
      </TR>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD ALIGN="center">
        <INPUT TYPE="button" VALUE="" onClick=$newpage>
        $newpage2
       </TD>
      </TR>
     </TABLE>
    </TD>
   </TR>
  </TABLE>
 </FORM>
</CENTER>

$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------
}

#
# ̾
#   showPage - ꤵ줿ڡ򳫤
# 
#   showPage($page)
# 
#   $page ڡ("/"ǻϤޤʤиƤӽФڡβۥѥղä)
# 
#   ʤ
#
sub showPage
{
    local($page) = @_;
    my($path);

    if (defined($ENV{'HTTPS'}) && $ENV{'HTTPS'} eq "on") {
        $path = "https://";
    } else {
        $path = "http://";
    }

    $path .= $ENV{'HTTP_HOST'};

    if ($page =~ /^\//) {
        $path .= $page;
    } else {
        $path .= &getScriptPath() . "/$page";
    }
#------------------------------------------------------------
print <<END_OF_DATA;
Location: $path

END_OF_DATA
#------------------------------------------------------------
}

#
# ̾
#   getScriptPath - ץȤβۥѥ
# 
#   getScriptPath()
# 
#   ʤ
# 
#   ץȤβۥѥ(ʸ)
#
sub getScriptPath
{
    local($script);

    $script = $ENV{'SCRIPT_NAME'};
    $script =~ s|/[^/]+$||;
    return($script);
}

#
# ̾
#   getNetType - ͥåȥ³֤
# 
#   getNetType()
# 
#   ʤ
# 
#   ³ ( intranet | dialup | internet | unknown )
# 
#   getConfParam("Meta", "NetType")
#
sub getNetType
{
    local(@line, $i, $metaflag, $nettype);

    if (!&readFile("/etc/opt/nec/wbmc/INITCONF.INI", "INITCONF.INI", *line)) {
        return("unknown");
    }

    for ($i = 0; $i <= $#line; $i++) {
        $line[$i] =~ s/[\r\n]*$//;
        if ($line[$i] =~ /^\s*\[\s*Meta\s*\]\s*$/) {
            $metaflag = 1;
        }
        elsif ($line[$i] =~ /^\s*\[/) {
            $metaflag = 0;
        }
        elsif ($metaflag && ($line[$i] =~ /^\s*NetType=(.*)/)) {
            $nettype = $1;
            if ($nettype =~ /^(intranet|dialup|internet)$/) {
                return($nettype);
            } else {
                return("unknown");
            }
        }
    }
    return("unknown");
}

#
# ̾
#   getConfParam - եͤɤ߹
# 
#   getConfParam($section, $name)
# 
#   $section ̾
#   $name ѥ᡼̾
# 
#   (դʤ"")
#
sub getConfParam
{
    local($section, $name) = @_;
    local(@line, $i, $flag);

    if (!&readFile("/etc/opt/nec/wbmc/INITCONF.INI", "INITCONF.INI", *line)) {
        return("");
    }

    $flag = 0;
    for ($i = 0; $i <= $#line; $i++) {
        $line[$i] =~ s/[\r\n]*$//;
        if ($line[$i] =~ /^\s*\[\s*$section\s*\]\s*$/) {
            $flag = 1;
        }
        elsif ($line[$i] =~ /^\s*\[/) {
            $flag = 0;
        }
        elsif ($flag && ($line[$i] =~ /^\s*$name=(.*)/)) {
            return($1);
        }
    }
    return("");
}

#
# ̾
#   getDate - ߤλ
# 
#   getDate()
# 
#   ʤ
# 
#   ߤλ(ʸ)
#
sub getDate
{
    local($year, $mon, $mday, $hour, $min, $sec);

    ($sec, $min, $hour, $mday, $mon, $year) = localtime();
    return(sprintf("%04d/%02d/%02d %02d:%02d:%02d",
    $year + 1900, $mon + 1, $mday, $hour, $min, $sec));
}

#
# ̾
#   ipAddrCheck - IPɥ쥹Υ󥿥ååԤ
# 
#   ipAddrCheck($addr)
# 
#   $addr ɥåɽIPɥ쥹
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub ipAddrCheck
{
    local($addr) = @_;

    if ($addr !~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
        return(0);
    }

    if (($1 < 0) || (255 < $1)
     || ($2 < 0) || (255 < $2)
     || ($3 < 0) || (255 < $3)
     || ($4 < 0) || (255 < $4)) {
        return(0);
    }

    return(1);
}

#
# ̾
#   ipStr2Addr - IPɥ쥹ʸ󤫤ͤѴ
# 
#   ipStr2Addr($addr)
# 
#   $addr ɥåɽIPɥ쥹
# 
#   ͤȤƤIPɥ쥹
#
sub ipStr2Addr
{
    local($addr) = @_;
    local(@ent);

    @ent = split(/\./, $addr);

    return($ent[0] * 256 * 256 * 256
     + $ent[1] * 256 * 256
     + $ent[2] * 256
     + $ent[3]);
}

#
# ̾
#   ipAddr2Str - IPɥ쥹ͤʸѴ
# 
#   ipAddr2Str($addr)
# 
#   $addr ͤȤƤIPɥ쥹
# 
#   ɥåɽIPɥ쥹
#
sub ipAddr2Str
{
    local($addr) = @_;

    return(sprintf("%d.%d.%d.%d",
    ($addr & 0xff000000) / (256 * 256 * 256),
    ($addr & 0x00ff0000) / (256 * 256),
    ($addr & 0x0000ff00) / (256),
    ($addr & 0x000000ff)));
}

#
# ̾
#   getNetMask - IPɥ쥹ǥեȤΥͥåȥޥ
# 
#   getNetMask($netaddr)
# 
#   $netaddr ɥåɽIPɥ쥹
# 
#   ɥåɽΥͥåȥޥ
#
sub getNetMask
{
    my($netaddr) = @_;
    my($netaddrnum);
    my($netmask);

    $netaddrnum = &ipStr2Addr($netaddr);
    if (($netaddrnum & 0x80000000) == 0) {
        # 饹A
        $netmask = "255.0.0.0";
    } elsif (($netaddrnum & 0xc0000000) == 0x80000000) {
        # 饹B
        $netmask = "255.255.0.0";
    } elsif (($netaddrnum & 0xe0000000) == 0xc0000000) {
        # 饹C
        $netmask = "255.255.255.0";
    } else {
        # ¾
        $netmask = "";
    }

    return($netmask);
}

# եåΥ⡼
$WBMC_LOCK_R_B = 1; # ɤ߹ߥå(֥å⡼)
$WBMC_LOCK_W_B = 2; # 񤭹ߥå(֥å⡼)
$WBMC_LOCK_R_NB = 5;    # ɤ߹ߥå(Υ֥å⡼)
$WBMC_LOCK_W_NB = 6;    # 񤭹ߥå(Υ֥å⡼)

#
# ̾
#   lockFile - ꤵ줿ե˥å򤫤
# 
#   lockFile($lockfile, $mode, *LOCK)
# 
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   $mode åΥ⡼(β줫)
#       $WBMC_LOCK_R_B  ɤ߹ߥå(֥å⡼)
#       $WBMC_LOCK_W_B  񤭹ߥå(֥å⡼)
#       $WBMC_LOCK_R_NB ɤ߹ߥå(Υ֥å⡼)
#       $WBMC_LOCK_W_NB 񤭹ߥå(Υ֥å⡼)
#   *LOCK եϥɥ
#       åˤϤΥեϥɥclose
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub lockFile
{
    local($lockfile, $mode, *LOCK) = @_;

    my($ret);
    my($lockdir);

    $ret = 0;
    $lockdir = "$WBMC_VAR_DIR/lock";

    if ($lockfile eq "") {
        goto done;
    }

    # åեѤΥǥ쥯ȥ(̵)
    if (! -d $lockdir) {
        if (!mkdir($lockdir, 0755)) {
            goto done;
        }
    }

    # åե򥪡ץ󤹤
    if (!open(LOCK, "> $lockdir/$lockfile")) {
        goto done;
    }

    # å򤫤
    if (!flock(LOCK, $mode)) {
        close(LOCK);
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   readFile - եɤƤ֤(åդ)
# 
#   readFile($filename, $lockfile, *line)
# 
#   $filename ɤ߹ե̾
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   *line եƤ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub readFile
{
    local($filename, $lockfile, *line) = @_;

    local(*LOCK);
    local(*IN);
    my($ret);
    my($lockfileflag);

    $ret = 0;
    $lockfileflag = 0;

    if ($filename eq "") {
        goto done;
    }

    if ($lockfile ne "") {
        # ɤ߹ߥå(֥å⡼)򤫤
        if (!&lockFile($lockfile, $WBMC_LOCK_R_B, *LOCK)) {
            goto done;
        }
        $lockfileflag = 1;
    }

    # ե򥪡ץ󤷤ɤ߹
    if (!open(IN, $filename)) {
        goto done;
    }
    @line = <IN>;
    close(IN);

    $ret = 1;

done:
    if ($lockfileflag != 0) {
        close(LOCK);
    }

    return($ret);
}

#
# ̾
#   readFileCsv - CsvեɤƤ֤(åդ)
# 
#   readFileCsv($filename, $lockfile, *line)
# 
#   $filename ɤ߹ե̾
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   *line եƤ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub readFileCsv
{
    local($filename, $lockfile, *line) = @_;

    local(*LOCK);
    local(*IN);
    my($ret);
    my($lockfileflag);

    $ret = 0;
    $lockfileflag = 0;

    if ($filename eq "") {
        goto done;
    }

    if ($lockfile ne "") {
        # ɤ߹ߥå(֥å⡼)򤫤
        if (!&lockFile($lockfile, $WBMC_LOCK_R_B, *LOCK)) {
            goto done;
        }
        $lockfileflag = 1;
    }

    $readcnt   = 0;
    # ե򥪡ץ󤷤ɤ߹
    if (!open(IN, $filename)) {
        goto done;
    }
        while (<IN>) {
            s/[\r\n]*$//;
            $line[$readcnt] = "$_\n";
            $readcnt++ ;
        }
    close(IN);

    $ret = 1;

done:
    if ($lockfileflag != 0) {
        close(LOCK);
    }

    return($ret);
}


#
# ̾
#   writeFile - ꤵ줿Ƥե˽񤭹(åդ)
# 
#   writeFile($filename, $lockfile, @line)
# 
#   $filename 񤭹ե̾
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   @line ե˽񤭹Ƥ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub writeFile
{
    local($filename, $lockfile, @line) = @_;

    local(*LOCK);
    local(*OUT);
    my($ret);
    my($lockfileflag);
    my($tmpfile);
    my($filemode);

    my($tag_name) = "wbmc_cluster"                      ;#cluster add
    my($log_file) = "/var/log/wbmc_cluster"             ;#cluster add
    my($cluster_backup_dir) = "/home/.wbmc/.wbmcsys"    ;#cluster add
    my($cluster_type)   = cluster_typechk()             ;#cluster add
    my($cluster_master) = cluster_masterchk()           ;#cluster add

    $ret = 0;
    $lockfileflag = 0;
    $tmpfile = "$filename.$$";

    if ($filename eq "") {
    goto done;
    }

    if ($lockfile ne "") {
    # 񤭹ߥå(֥å⡼)򤫤
    if (!&lockFile($lockfile, $WBMC_LOCK_W_B, *LOCK)) {
        goto done;
    }
    $lockfileflag = 1;
    }

    # ȥե򥪡ץ󤷤ƽ񤭹
    if (!open(OUT, "> $tmpfile")) {
    goto done;
    }
    if (!print(OUT @line)) {
    close(OUT);
    goto done;
    }
    close(OUT);

    ##########  $tmpfile . ̾Ĥɬ
    ##########  $tmpfile . ̾Ĥɬ
    #饹ʤ顢ͭǥ˥ХååפԤ
    if($cluster_type eq "cluster"){
        if($cluster_master eq "master"){
            # ե̾ƥեȰפ뤫
            # פʤ硧⤷ʤ
&writeLog($filename ."  ------", $tag_name, $log_file);
            if (&cluster_sysfile_check($filename) ne "") {
&writeLog($filename ."  check ok", $tag_name, $log_file);

                $dir_name = get_dir("$cluster_backup_dir$filename");
                if(-e $dir_name){
                }else{
                    $dir_command = "/bin/mkdir -p " . $dir_name ;
                    if (system($dir_command)){
                        &writeLog($cluster_backup_dir ." " . $dir_name . " mkdir err", $tag_name, $log_file);
                    }
                }

                if (system("/bin/cp -af $tmpfile $cluster_backup_dir$filename")) {
                    &writeLog($cluster_backup_dir ." ". $filename . " cp err", $tag_name, $log_file);
                    goto done;
                }
            }
        }
    }

    # եΥ⡼ɤ
    if (-e $filename) {
    $filemode = (stat($filename))[2];
    } else {
    $filemode = 0644;
    }

    # Υե˥͡ह
    if (!rename($tmpfile, $filename)) {
    goto done;
    }

    # եΥ⡼ɤꤹ
    chmod($filemode & 07777, $filename);
    # ͭǥ¸եΥ⡼ɤꤹ
       if($cluster_type eq "cluster" && $cluster_master eq "master"){
        chmod($filemode & 07777, "$cluster_backup_dir$filename");
    }

    #饹ޥޤϥߥ顼ޥʤ顢Фž롣
    if($cluster_type eq "cluster" || $cluster_type eq "mirror"){
        if($cluster_master eq "master"){
            # פʤ硧⤷ʤ
            if (&cluster_sysfile_check($filename) ne "") {
                $errmsg = cluster_ftp_all($filename);
                if ($errmsg ne "") {
                    &writeLog($errmsg . " ftp err", $tag_name, $log_file);
                    goto done;
                }
            }
        }
    }

    $ret = 1;

done:
    if ($lockfileflag != 0) {
    close(LOCK);
    }

    if (-f $tmpfile) {
    unlink($tmpfile);
    }

    return($ret);
}

#
# ̾
#   get_dir - ǥ쥯ȥ
# 
#   get_dir()
# 
#   ʤ
# 
#   ǥ쥯ȥ
#
sub get_dir{
    my($filename) = @_;
    my($dirname) = "";
    @list = split(/\//, $filename);
    for(1..($#list-1)) {
            $dirname .= '/' . $list[$_] ;
    }   
    return $dirname;
}

#
# ̾
#   getNavigation - ʥӥС֤
# 
#   getNavigation($name1, $page2, $name2, $page2, ...)
# 
#   $nameN ɽ̾
#       _backб
#       _helpϥإפб
#   $pageN Ȥɽڡ
#       ꤷʤ""ꤹȡ󥯤ɽʤ
#       ΤȤ_back_helpξ̾ɽʤ
# 
#   ʥӥС(ʸ)
#
sub getNavigation
{
    my(@argv) = @_;

    my(@name);
    my(@page);
    my($backpage);
    my($helppage);
    my($i);
    my($buf);

    $backpage = "";
    $helppage = "";
    for ($i = 0; $i <= $#argv; $i++) {
        if ($argv[$i] eq "_back") {
            if (($i + 1) <= $#argv) {
                $backpage = $argv[$i + 1];
                $i++;
            }
        } elsif ($argv[$i] eq "_help") {
            if (($i + 1) <= $#argv) {
                $helppage = $argv[$i + 1];
                $i++;
            }
        } else {
            push(@name, $argv[$i]);
            if (($i + 1) <= $#argv) {
                push(@page, $argv[$i + 1]);
                $i++;
            } else {
                push(@page, "");
            }
        }
    }

    $buf = ""
    . "<TABLE WIDTH='100%'>\n"
    . " <TR>\n"
    . "  <TD ALIGN='left'>\n";

    for ($i = 0; $i <= $#name; $i++) {
        if ($page[$i] ne "") {
            $buf .= "   <A HREF='$page[$i]'>$name[$i]</A> &gt;\n";
        } else {
            $buf .= "   $name[$i]\n";
        }
    }

    $buf .= ""
    . "  </TD>\n"
    . "  <TD ALIGN='right'>\n";

    if ($backpage ne "") {
        $buf .= "   <A HREF='$backpage'>[]</A>\n";
    }
    if ($helppage ne "") {
        $buf .= "   <A HREF='$helppage' TARGET='help'>[إ]</A>\n";
    }

    $buf .= ""
    . "  </TD>\n"
    . " </TR>\n"
    . "</TABLE>\n";

    return($buf);
}

#
# ̾
#   parseUint - Ϥ줿ͤå
# 
#   parseUint($str)
# 
#   $str ʸ(ζʸ̵뤹)
# 
#   ΤȤ(0ʾ)
#   ԤΤȤ-1
#
sub parseUint
{
    my($str) = @_;
    my($num);

    $str =~ s/^\s*//;
    $str =~ s/\s*$//;

    if ($str =~ /[^0-9]/) {
        $num = -1;
    } else {
        $str =~ s/^0+//;
        if ($str eq "") {
            $num = 0;
        } else {
            $num = $str;
        }
    }

    return($num);
}

#
# ̾
#   isServiceRunning - ӥư椫ɤǧ
# 
#   isServiceRunning($dir)
# 
#   $dir Υӥ wbmc.rc Τǥ쥯ȥ
#       ꤷʤ""ꤹȡȥǥ쥯ȥȤߤʤ
# 
#   ưΤȤ1
#   ΤȤ0
#   ΤȤ-1
#
sub isServiceRunning
{
    my($dir) = @_;

    local(@inetd_conf);
    local(@wbmc_rc);
    my(@ent);
    my(%inetd_conf);
    my(%process);
    my($filename);
    my($service_type);
    my($service_name);
    my($upcheck);
    my($process_name);
    my($updown_current);

    $updown_current = "unknown";

    # inetd.confƤɤߤƤ
    if (!&readFile("/etc/inetd.conf", "inetd.conf", *inetd_conf)) {
        goto nextstep1;
    }

    for (@inetd_conf) {
        s/^\s*//;
        s/\s*$//;
        if (/^#/) {
            next;
        }
        @ent = split(/\s+/);
        if ($ent[1] !~ /^(stream|dgram)$/) {
            next;
        }
        $inetd_conf{$ent[0]} = 1;
    }

nextstep1:

    # psη̤ɤߤƤ
    if (!open(IN, "/bin/ps -efwwwww |")) {
        goto nextstep2;
    }
    while (<IN>) {
        s/\s*$//;
        @ent = split(/\s+/);
        $ent[7] =~ s/\[//;
        $ent[7] =~ s/\]//;
        $ent[7] =~ s/.*\///;
        $process{$ent[7]} = 1;
    }
    close(IN);

nextstep2:

    if (defined($dir) && $dir ne "") {
        $filename = "$dir/wbmc.rc";
    } else {
        $filename = "./wbmc.rc";
    }

    # wbmc.rc եɤ߹
    if (!&readFile($filename, "wbmc.rc", *wbmc_rc)) {
        goto nextstep3;
    }
    $service_type = "";
    $service_name = "";
    $upcheck = "";
    $process_name = "";
    for (@wbmc_rc) {
        s/\s*$//;
        if (/^#/) {
            next;
        }
        elsif (/^\s*ServiceType:\s*(.*)/i) {
            $service_type = $1;
        }
        elsif (/^\s*ServiceName:\s*(.*)/i) {
            $service_name = $1;
        }
        elsif (/^\s*UpCheck:\s*(.*)/i) {
            $upcheck = $1;
        }
        elsif (/^\s*ProcessName:\s*(.*)/i) {
            $process_name = $1;
        }
    }

    # ӥפ inetd Ǥʤ rc Ȥߤʤ
    if ($service_type !~ /^inetd$/i) {
        $service_type = "rc";
    }

    # ߤξ֤
    if ($upcheck) {
#   chdir($dir);
        if ($upcheck !~ /^\//) {
            if (defined($dir) && $dir ne "") {
                $upcheck = "$dir/$upcheck";
            } else {
                $upcheck = "./$upcheck";
            }
        }
        if (open(IN, "$upcheck |")) {
            $updown_current = <IN>;
            $updown_current =~ s/\s*$//;
            close(IN);
        }
#   chdir("..");
    } elsif ($service_type =~ /^inetd$/i) {
        if ($inetd_conf{$service_name}) {
            $updown_current = "up";
        } else {
            $updown_current = "down";
        }
    } else {
        if ($process_name) {
            if ($process{$process_name}) {
                $updown_current = "up";
            } else {
                $updown_current = "down";
            }
        }
    }

nextstep3:

    if ($updown_current eq "up") {
        return(1);
    } elsif ($updown_current eq "down") {
        return(0);
    } else {
        return(-1);
    }
}

#
# ̾
#   checkNum - ͤꤵ줿ϰϤˤ뤫ɤå
# 
#   checkNum($num, $min, $max)
# 
#   $num 
#   $min Ǿ
#   $max 
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkNum
{
    my($num, $min, $max) = @_;
    my($ret);

    $ret = 0;

    if (!defined($num) || $num eq "") {
        goto done;
    }
    if ($num =~ /\D+/) {
        goto done;
    }
    if ($num < $min || $num > $max) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkNetMask - ֥ͥåȥޥηå
# 
#   checkNetMask($netmask)
# 
#   $netmask ֥ͥåȥޥ
#       (ɥåɽ131)
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkNetMask
{
    my($netmask) = @_;
    my($ret);

    $ret = 0;

    if (!defined($netmask) || $netmask eq "") {
        goto done;
    }
    if ($netmask =~ /\./) {
        if (!&ipAddrCheck($netmask)) {
            goto done;
        }
    } else {
        if (!&checkNum($netmask, 1, 31)) {
            goto done;
        }
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkPortNum - ݡֹηå
# 
#   checkPortNum($port)
# 
#   $port ݡֹ
#       (165535)
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkPortNum
{
    my($port) = @_;

    return(&checkNum($port, 1, 65535));
}

#
# ̾
#   checkUserID - 桼IDηå
# 
#   checkUserID($uid)
# 
#   $uid 桼ID
#       (065534)
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkUserID
{
    my($uid) = @_;

    return(&checkNum($uid, 0, 65534));
}

#
# ̾
#   checkGroupID - 롼IDηå
# 
#   checkGroupID($gid)
# 
#   $gid 롼ID
#       (065534)
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkGroupID
{
    my($gid) = @_;

    return(&checkNum($gid, 0, 65534));
}

#
# ̾
#   checkName - ̾ηå
# 
#   checkName($name)
# 
#   $name ̾
#       (ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_')
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkName
{
    my($name) = @_;
    my($ret);

    $ret = 0;

    if (!defined($name) || $name eq "") {
        goto done;
    }

    if ($name =~ /^[^A-Za-z]/) {
        goto done;
    }

    if ($name =~ /[^A-Za-z0-9\-\._]/) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkUserName - unix桼(ƥ桼)̾ηå롣
#                   ̥桼 checkAppUserName() Ȥȡ
# 
#   checkUserName($user)
# 
#   $user unix桼̾
#       (ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_')
#       (Ĺ132) useradd ǧǽĹ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkUserName
{
    my($user) = @_;
    my($ret);
    my($len);
    
    $ret = 0;
    
    if(!&checkName($user)) {
        goto done;
    }
    $len = length($user);
    if(!&checkNum($len, 1, 32)) {
        goto done;
    }
    
    $ret = 1;
    
done:
    return($ret);
}

#
# ̾
#   checkGroupName - 롼̾ηå
#                   ƥѥ롼פޤࡣ
#                   appliance ǻѤ륰롼̾åѤ checkAppGroupName() Ȥ
# 
#   checkGroupName($group)
# 
#   $group 롼̾
#       (ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-')
#       (Ĺ116) groupadd ϿǽĹ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkGroupName
{
    my($group) = @_;
    my($ret);
    my($len);
    
    $ret = 0;
    
    if(!&checkName($group)) {
        goto done;
    }
    
    # 嵭åϰϤʤ롣'.', '_' ᡣ
    if ($group =~ /[^A-Za-z0-9\-]/) {
        goto done;
    }
    
    $len = length($group);
    if(!&checkNum($len, 1, 16)) {
        goto done;
    }
    
    $ret = 1;
    
done:
    return($ret);
}

#
# ̾
#   checkAppUserName - aplianceѰ̥桼̾ηå
#                       unix桼Υå checkUserName() Ȥȡ
# 
#   checkAppUserName($user)
# 
#   $user ̥桼̾
#       (Ƭa-zǡΤa-z, 0-9, '-', '.', '_')
#       (Ĺ116)
#       ᡼DNShttpdʤʸʸ̤ʤӥǻȤ褦
#       ̾Υ桼ϡʸԲĤȤ롣
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkAppUserName
{
    my($user) = @_;
    my($ret);
    my($len);
    
    $ret = 0;
    
    # ƥ桼å
    if(!&checkUserName($user)) {
        goto done;
    }
    # 嵭åϰϤʤ롣'A-Z' ϥᡣ
    if ($user =~ /[A-Z]/) {
        goto done;
    }
    $len = length($user);
    if(!&checkNum($len, 1, 16)) {
        goto done;
    }
    
    $ret = 1;
    
done:
    return($ret);
}

#
# ̾
#   checkAppGroupName - appliance ǻȤ롼̾ηå
#                        桼ͳϿ륰롼׸Υå
#                          checkGroupName() Ȥȡ
# 
#   checkAppGroupName($group)
# 
#   $group 롼̾
#       (Ƭa-zǡΤa-z, 0-9, '-')
#       (Ĺ115)
#       ᡼DNShttpdʤʸʸ̤ʤӥǻȤ褦
#       ̾Υ롼פϡʸԲĤȤ롣
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkAppGroupName
{
    my($group) = @_;
    my($ret);
    my($len);
    
    $ret = 0;
    
    # ƥ?롼ץå
    if(!&checkGroupName($group)) {
        goto done;
    }
    
    # 嵭åϰϤʤ롣ʸᡣ
    if ($group =~ /[A-Z]/) {
        goto done;
    }
    # 115ʸޤǡ(SURFNAVIǤ1ʸä)
    $len = length($group);
    if(!&checkNum($len, 1, 15)) {
        goto done;
    }
    
    $ret = 1;
    
done:
    return($ret);
}

# ̾
#   checkMailAddr - ᡼륢ɥ쥹ηå롣
#                   @ʤϡunix桼Ȥߤʤƥå롣
# 
#   checkMailAddr($addr)
# 
#   $addr  ᡼륢ɥ쥹
#     ᡼륢ɥ쥹 @ ޤޤ(user@domain ξ)
#       user
#           ʳʸ 1ʸʾ夢뤳ȡ
#             ¾ϡåʤĹ 1ʾ̵¡/֤ʤɤǽ
#       domain  checkDomainName() ǥå
#           ǤƬA-Z, a-z, 0-9ǹƤ뤳
#           ǤʸA-Z, a-z, 0-9, ϥե(-)ǹƤ뤳
#           ġǤ163ʸǤ뤳
#           Τ1255ʸǤ뤳
#           ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#     ᡼륢ɥ쥹 @ ޤޤʤ(user Τ)
#       user    checkUserName() ǥå
#           ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_'
#           Ĺ132
#     "  ǰϤġ"xxx" ξ xxx Τߤå롣
#     <> ǰϤġ<xxx> ξ xxx Τߤå롣
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkMailAddr
{
	local($mail) = @_;
    my(@buf) = ();
    my($user, $domain);
	my($ret);
	
	# ΤߡޤϲꤷƤʤｪλ
	$ret = 1;
	goto done unless length($mail);
	goto done if     $mail =~ /^\s*$/;
	
	$ret = 0;
	# "" ޤ <> ǰϤǤȤΤߥå
	if ($mail =~ /^\"/ && $mail =~ /\"$/) {
		$mail =~ s/^\"//;
		$mail =~ s/\"$//;
	}
	if ($mail =~ /^</ && $mail =~ />$/) {
		$mail =~ s/^<//;
		$mail =~ s/>$//;
	}
	
	@buf = split(/\@/, $mail);
    if ($#buf == 0) {
		goto done unless &checkUserName($mail);
    }
    elsif ($#buf == 1) {
        ($user, $domain) = @buf;
		goto done unless length($user);
		goto done if     $user =~ /^\s*$/;
		goto done unless &checkDomainName($domain);
    }
    else {
		goto done;
    }
	
	$ret = 1;
	
done:
	return($ret);
}

#
# ̾
#   checkShortHostName - ۥ̾ηå
# 
#   checkShortHostName($host)
# 
#   $host ۥ̾
#     ƬA-Z, a-z, 0-9ǹƤ뤳
#     ʸA-Z, a-z, 0-9, ϥե(-)ǹƤ뤳
#     163ʸǤ뤳
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkShortHostName
{
    my($host) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if (!defined($host) || $host eq "") {
        goto done;
    }

    $len = length($host);
    if (!&checkNum($len, 1, 63)) {
        goto done;
    }

    if ($host !~ /^[A-Za-z0-9]([A-Za-z0-9\-]*[A-Za-z0-9]|)$/) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkLongHostName - ۥ̾(FQDN)ηå
# 
#   checkLongHostName($host)
# 
#   $host ۥ̾
#     ǤƬA-Z, a-z, 0-9ǹƤ뤳
#     ǤʸA-Z, a-z, 0-9, ϥե(-)ǹƤ뤳
#     Τ163ʸǤ뤳
#     ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkLongHostName
{
    my($host) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if (!&checkDomainName($host)) {
        goto done;
    }
    $len = length($host);
    if (!&checkNum($len, 1, 63)) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkDomainName - ɥᥤ̾ηå
# 
#   checkDomainName($domain)
# 
#   $domain ɥᥤ̾
#     ǤƬA-Z, a-z, 0-9ǹƤ뤳
#     ǤʸA-Z, a-z, 0-9, ϥե(-)ǹƤ뤳
#     ġǤ163ʸǤ뤳
#     Τ1255ʸǤ뤳
#     ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkDomainName
{
    my($domain) = @_;
    my($ret);
    my($len);
    my(@ent);
    my($i);

    $ret = 0;

    if (!defined($domain) || $domain eq "") {
        goto done;
    }

    if ($domain =~ /^\./) {
        goto done;
    }

    if ($domain =~ /\.$/) {
        goto done;
    }

    $len = length($domain);
    if (!&checkNum($len, 1, 255)) {
        goto done;
    }

    if ($domain =~ /^[0-9\.]+$/) {
        goto done;
    }

    @ent = split(/\./, $domain);
    for ($i = 0; $i <= $#ent; $i++) {
        $len = length($ent[$i]);
        if (!&checkNum($len, 1, 63)) {
            goto done;
        }

        if ($ent[$i] !~ /^[A-Za-z0-9]([A-Za-z0-9\-]*[A-Za-z0-9]|)$/) {
            goto done;
        }
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   encodeHtml - HTMLΥ󥳡(&  &amp;)Ԥ
# 
#   encodeHtml($str)
# 
#   $str ʸ
# 
#   󥳡ɤ줿ʸ
#
sub encodeHtml
{
    my($str) = @_;

    $str =~ s/&/&amp;/g;
    $str =~ s/</&lt;/g;
    $str =~ s/>/&gt;/g;
    $str =~ s/"/&quot;/g;
    return($str);
}

#
# ̾
#   encodeCmdArg - ޥɥ饤Υ󥳡(&  \&)Ԥ
# 
#   encodeCmdArg($str)
# 
#   $str ʸ
# 
#   󥳡ɤ줿ʸ
#
sub encodeCmdArg
{
    my($str) = @_;

    $str =~ s/([^0-9a-zA-Z])/\\$1/g;
    return($str);
}

#
# ̾
#   encodeUrl - URLΥ󥳡(&  %26)Ԥ
# 
#   encodeUrl($str)
# 
#   $str ʸ
# 
#   󥳡ɤ줿ʸ
#
sub encodeUrl
{
    my($str) = @_;

    $str =~ s/([^\-\_\.\/0-9a-zA-Z])/sprintf("%%%02X", ord($1))/eg;
    return($str);
}

#
# ̾
#   writeLog - wbmcѥɲ
# 
#   writeLog($message, $tag, $file)
# 
#   $message ɲäå
#   $tag     ˵Ҥ륿̾(ޥ̾)
#   $file    Ҥե̾
# ϥեޥå
#   YYYY/MM/DD hh:mm:ss TAG: MESSAGE ...
# 
#   λ 1
#   Ԥλ 0
#
sub writeLog {
    my($message, $tag, $file) = @_;
    local(*OUT);
    my($time);
    my($ret);

    $ret = 0;

    if ($file eq "") {
        goto done;
    }
    $time = &getDate();
    if (!open(OUT, ">> $file")) {
        goto done;
    }
    if (!flock(OUT, $WBMC_LOCK_W_B)) {
        goto done;
    }
    if (!print OUT "$time $tag: $message\n") {
        goto done;
    }
    close(OUT);

    $ret = 1;

done:
    return(1);
}

#
# ̾
#   getDomainName - ɥᥤ̾μԤ
# 
#   getDomainName()
# 
#   ʤ
# 
#   ɥᥤ̾
#
sub getDomainName
{
    my($domain,$mode);

    $domain = $ENV{'SERVER_NAME'};
#   if ($domain =~ /^\s*[^.\s]+.(.+)/i) {
#       $domain = $1;
#   }
    return($domain);
}

#
# ̾
#   getPortNumber - ݡֹμԤ
# 
#   getPortNumber()
# 
#   ʤ
# 
#   ɥᥤ̾
#
sub getPortNumber
{
    my($port);

    $port = $ENV{'SERVER_PORT'};
    return($port);
}


#
# ̾
#   getDomainConf - domain.conf ͤõ
# 
#   getDomainConf($mydomain, $param)
# 
#   $mydomain   оݤоݥɥᥤ̾
#   $param      ѥ᡼()
# 
#   ѥ᡼()
#   ""  եɤ߽ФԤʤ
#
sub getDomainConf
{
    local($mydomain, $param) = @_;
    local($ret, $target, $i) = "";
    local(@lines) = ();
    $ret = "";
    
    # ɥᥤեɤ߽Ф
    if (!&readFile("$WBMC_DOMAIN_DIR/domain.conf", "domain.conf", *lines)) {
        goto done;
    }
    $target = 0;
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*<DOMAINNAME\s+([^\s]+)\s*>/i) {
            if ($target == 1) {
                last;
            }
            elsif ($mydomain eq $1) {
                $target = 1;
            }
        }
        if ($target == 0) {
            next;
        }
        if ($lines[$i] =~ /^\s*\Q$param\E\s+([^\s]+)\s*/i) {
            $ret = $1;
        }
    }
    
done:
    return ($ret);
}


############################################################################
# ǥ쥯ȥ
# ̾
#   getDomainDir
# 
#   getDomainDir($domainname,$type)
# 
#   $domainname     ɥᥤ̾
#   $type           web mail wbmc Τ줫
#                   3İʳλϡwebɤȤƽ
# 
#   λ ǥ쥯ȥ̾եѥ֤
############################################################################
sub getDomainDir
{
    local($domainname,$type) = @_;
    local($rtn_code) = "";
    $rtn_code = -1;
    $domainname =~ s/^\s*\s*$//;
    $type =~ s/^\s*\s*$//;

    if($type eq "web") {
        $rtn_code = "/home/web/$domainname";
        return($rtn_code);
    }
    elsif($type eq "mail") {
        $rtn_code = "/home/mail/$domainname";
        return($rtn_code);
    }
    elsif($type eq "wbmc") {
        $rtn_code = "/home/.wbmc/$domainname";
        return($rtn_code);
    }
    else {
        $rtn_code = "/home/web/$domainname";
        return($rtn_code);
    }
}

#
# ̾
#   checkAppDomainName - ɥᥤ̾ηå
# 
#   checkAppDomainName($domain)
# 
#   $domain ɥᥤ̾
#     ʸػ
#     ǤƬ a-z, 0-9ǹƤ뤳
#     Ǥʸ a-z, 0-9, ϥե(-)ǹƤ뤳
#     ġǤ163ʸǤ뤳
#     Τ1230ʸǤ뤳
#     ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkAppDomainName
{
    my($domain) = @_;
    my($ret);
    my($len);
    my(@ent);
    my($i);

    $ret = 0;

    if (!defined($domain) || $domain eq "") {
        goto done;
    }

    if ($domain =~ /^\./) {
        goto done;
    }

    if ($domain =~ /\.$/) {
        goto done;
    }

    $len = length($domain);
    if (!&checkNum($len, 1, 230)) {
        goto done;
    }

    if ($domain =~ /^[0-9\.]+$/) {
        goto done;
    }

    @ent = split(/\./, $domain);
    for ($i = 0; $i <= $#ent; $i++) {
        $len = length($ent[$i]);
        if (!&checkNum($len, 1, 63)) {
            goto done;
        }

        if ($ent[$i] !~ /^[a-z0-9]([a-z0-9\-]*[a-z0-9]|)$/) {
            goto done;
        }
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   showRltBtnPage - åɽ(ʣܥ)
#           
# 
#   showRltBtnPage($title, $message, $rtn_page, %pages)
#
# 
#   $title ɽ륿ȥ
#   $message ɽå
#   $rtn_page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
#   %pages ¾Υܥ򲡤Ȥɽڡ
#	"" ܥ̾
#	""   ư
#       ꤷʤ""ꤹȡܥΤɽʤ
# 
#   ʤ
#
sub showRltBtnPage
{
    local($title, $message, $rtn_page, %pages) = @_;
    local($rtnpage, $page_cnt, $newpages);
    local(@btns);

    if (!defined($rtn_page) || $rtn_page eq "") {
    $rtnpage = "history.back()";
    } else {
    $rtnpage = "location.href='$rtn_page'";
    }

    @btns = keys %pages;
    $newpages = "";
    for($page_cnt=0; $page_cnt<@btns; $page_cnt++) {
	    $newpages .= "<INPUT TYPE='button' VALUE='$btns[$page_cnt]' onClick=\"location.href='$pages{$btns[$page_cnt]}'\">";
    }
    $newpages .= "";

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY>
<H4 ALIGN="center">$title</H4>
<HR>

<CENTER>
 <FORM>
  <TABLE BGCOLOR="#CCCCCC" WIDTH=300 BORDER=1 CELLSPACING=0 CELLPADDING=1>
   <TR BGCOLOR="#000080">
    <TD>
     <FONT COLOR="#FFFFFF"> <B>$title</B></FONT>
    </TD>
   </TR>
   <TR>
    <TD>
     <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD>
        $message
       </TD>
      </TR>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD ALIGN="center">
        <INPUT TYPE="button" VALUE="" onClick=$rtnpage>
        $newpages
       </TD>
      </TR>
     </TABLE>
    </TD>
   </TR>
  </TABLE>
 </FORM>
</CENTER>

$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------
}

1;

