#!/usr/bin/perl

# Copyright (C) 2000-2003 NEC Corporation
# All Rights Reserved.

# RCS: $Id: wbmc.pl,v 1.5 2005/09/26 11:59:36 snavi Exp $

##001109 v5.1 WebLoadbalanceб by haramoto
##001221 v5.1 wbmc03-077бcheckAppDomainNameɲáS.Oku
##010305 v4.0.1 cluster б  Chikita
##010319 v4.0.1 getWhereFrom()ɲ  Oku
##010319 v4.0.1 showRltBtnPage()ɲ    Nagashima
##010319 v4.0.1 getTruePath()ɲ  S.Oku
##010706 v4.1.1 writeFile() my б Hori
##011025 v4.3.1 getSysAdminName() ɲ oku
##011025 v4.3.1 chkUserControl(),getDomainAdmInf(),chkDomainAdmParam() ɲ Y.Uemukai
##011101 v4.30 ƥ̾ѹǽб  Oku

require "/opt/nec/wbmc/lib/cluster_com.pl";

#--------------------------------------------------------------------
#  SM  wbmc.pl(/opt/nec/wbmc/lib/wbmc.pl) Ǥ
#--------------------------------------------------------------------

# 󥹥ȡǥ쥯ȥ
$WBMC_INSTALL_DIR = "/opt/nec/wbmc";
$WBMC_BIN_DIR = "$WBMC_INSTALL_DIR/bin";
$WBMC_LIB_DIR = "$WBMC_INSTALL_DIR/lib";
$WBMC_ADM_DIR = "$WBMC_INSTALL_DIR/adm";
$WBMC_USR_DIR = "$WBMC_INSTALL_DIR/usr";

# 000915 misa add start (for domain)
$WBMC_DOM_DIR    = "$WBMC_INSTALL_DIR/domain";  # /opt/nec/wbmc/domain
$WBMC_DOMBIN_DIR = "$WBMC_DOM_DIR/bin";         # /opt/nec/wbmc/domain/bin
$WBMC_DOMLIB_DIR = "$WBMC_DOM_DIR/lib";         # /opt/nec/wbmc/domain/lib
$WBMC_DOMADM_DIR = "$WBMC_DOM_DIR/adm";         # /opt/nec/wbmc/domain/adm
$WBMC_DOMUSR_DIR = "$WBMC_DOM_DIR/usr";         # /opt/nec/wbmc/domain/usr
# 000915 misa add end   (for domain)

$WBMC_CONF_DIR = "/etc/opt/nec/wbmc";
$WBMC_VAR_DIR = "/var/opt/nec/wbmc";
$WBMC_HTTPD_DIR = "/opt/nec/wbmchttpd";
$WBMC_HTTPD_CONF_DIR = "/etc/opt/nec/wbmchttpd/conf";

$WBMC_DOMAIN_DIR = "/etc/opt/nec/wbmc";     ##000901 (domain.conf)

# ̲ηcopyrightʸ
$WBMC_COPYRIGHT = &getCopyright();

# ޥ󥿥׼
&getMachineType();

# Сեɤ߹ߡ
{
    # ͥå(appliance3.0 ʹߤϥե뤬ΤǥåȤʤ)
    # $WBMC_MGRNAME   = "Management Console for Appliance Server ";
    # $WBMC_MGRVER    = "3.10";

    # WbMC ̾γǼեɤ߹ߡ
    $filename   = "/etc/opt/nec/mgr_name";
    if (-e $filename) {
        if (open(MT, $filename)) {
            @line = <MT>;
            close(MT);
            if (defined($line[0])) {
                $line[0] =~ s/^\s*//;
                $line[0] =~ s/\s*$//;
                if ($line[0] ne "") {
                    $WBMC_MGRNAME = $line[0];
                }
            }
        }
    }
    # WbMC СǼեɤ߹ߡ
    $filename   = "/etc/opt/nec/mgr_version";
    if (-e $filename) {
        if (open(MT, $filename)) {
            @line = <MT>;
            close(MT);
            if (defined($line[0])) {
                $line[0] =~ s/^\s*//;
                $line[0] =~ s/\s*$//;
                if ($line[0] ne "") {
                    $WBMC_MGRVER = $line[0];
                }
            }
        }
    }
}


#
# ̾
#   getCopyright - ֲ̰  copyright ʸФ
# 
#   getCopyright()
# 
#   ʤ
# 
#   Copyright  html ᡼
#
sub getCopyright
{
    local($data) = "";
    $data   = "<HR>\n"
            . "<IMG SRC=\"/image/nec_w.gif\" WIDTH=56 HEIGHT=16>Copyright(C) NEC Corporation 2000-2005\n";

    return($data);
}


#
# ̾
#   readParam - եफΥѥ᡼ɤ߹
# 
#   readParam()
# 
#   ʤ
# 
#   ΤȤʸ
#   ԤΤȤ顼å
#
sub readParam
{
    local($err, $buf, $name, $value);

    if ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
    } elsif ($ENV{'REQUEST_METHOD'} eq "GET") {
    $buf = $ENV{'QUERY_STRING'};
    } else {
    $err = "Invalid request method.";
    return($err);
    }

    foreach (split(/&/, $buf)) {
    ($name, $value) = split(/=/);
    $value =~ tr/+/ /;
    $value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
    }

    return($err);
}

#
# ̾
#   showErrorPage - 顼åɽ
# 
#   showErrorPage($message, $page)
# 
#   $message ɽ륨顼å
#       ꤷʤ""ꤹȡ"ϼԤޤ"ɽ
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
# 
#   ʤ
#
sub showErrorPage
{
    my($message, $page) = @_;
    my($msg);

    if (!defined($message) || $message eq "") {
    $msg = "ϼԤޤ";
    } else {
    $msg = $message;
    }

    &showMessagePage("顼", $msg, $page);
}

#
# ̾
#   showResultPage - ()ɽ
# 
#   showResultPage($message, $page, $page2)
# 
#   $message ɽ̥å
#       ꤷʤ""ꤹȡ"ޤ"ɽ
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
#   $page2 ɲåܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡܥΤɽʤ
# 
#   ʤ
#
sub showResultPage
{
    my($message, $page, $page2) = @_;
    my($msg);

    if (!defined($message) || $message eq "") {
    $msg = "ޤ";
    } else {
    $msg = $message;
    }

    &showMessagePage("", $msg, $page, $page2);
}

#
# ̾
#   showMessagePage - åɽ()
#           showErrorPageshowResultPageμ
# 
#   showMessagePage($title, $message, $page, $page2)
# 
#   $title ɽ륿ȥ
#   $message ɽå
#   $page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
#   $page2 ɲåܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡܥΤɽʤ
# 
#   ʤ
#
sub showMessagePage
{
    my($title, $message, $page, $page2) = @_;
    my($newpage, $newpage2);

    if (!defined($page) || $page eq "") {
    $newpage = "history.back()";
    } else {
    $newpage = "location.href='$page'";
    }

    if (!defined($page2) || $page2 eq "") {
    $newpage2 = "";
    } else {
    $newpage2 = "<INPUT TYPE='button' VALUE='ɲ' onClick=\"location.href='$page2'\">";
    }

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY>
<H4 ALIGN="center">$title</H4>
<HR>

<CENTER>
 <FORM>
  <TABLE BGCOLOR="#CCCCCC" WIDTH=300 BORDER=1 CELLSPACING=0 CELLPADDING=1>
   <TR BGCOLOR="#000080">
    <TD>
     <FONT COLOR="#FFFFFF"> <B>$title</B></FONT>
    </TD>
   </TR>
   <TR>
    <TD>
     <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD>
        $message
       </TD>
      </TR>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD ALIGN="center">
        <INPUT TYPE="button" VALUE="" onClick=$newpage>
        $newpage2
       </TD>
      </TR>
     </TABLE>
    </TD>
   </TR>
  </TABLE>
 </FORM>
</CENTER>

$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------
}

#
# ̾
#   showPage - ꤵ줿ڡ򳫤
# 
#   showPage($page)
# 
#   $page ڡ("/"ǻϤޤʤиƤӽФڡβۥѥղä)
# 
#   ʤ
#
sub showPage
{
    local($page) = @_;
    my($path);

    if (defined($ENV{'HTTPS'}) && $ENV{'HTTPS'} eq "on") {
    $path = "https://";
    } else {
    $path = "http://";
    }

    $path .= $ENV{'HTTP_HOST'};

    if ($page =~ /^\//) {
    $path .= $page;
    } else {
    $path .= &getScriptPath() . "/$page";
    }
#------------------------------------------------------------
print <<END_OF_DATA;
Location: $path

END_OF_DATA
#------------------------------------------------------------
}

#
# ̾
#   getScriptPath - ץȤβۥѥ
# 
#   getScriptPath()
# 
#   ʤ
# 
#   ץȤβۥѥ(ʸ)
#
sub getScriptPath
{
    local($script);

    $script = $ENV{'SCRIPT_NAME'};
    $script =~ s|/[^/]+$||;
    return($script);
}

#
# ̾
#   getNetType - ͥåȥ³֤
# 
#   getNetType()
# 
#   ʤ
# 
#   ³ ( intranet | dialup | internet | unknown )
# 
#   getConfParam("Meta", "NetType")
#
sub getNetType
{
    local(@line, $i, $metaflag, $nettype);

    if (!&readFile("/etc/opt/nec/wbmc/INITCONF.INI", "INITCONF.INI", *line)) {
    return("unknown");
    }
    for ($i = 0; $i <= $#line; $i++) {
    $line[$i] =~ s/[\r\n]*$//;
    if ($line[$i] =~ /^\s*\[\s*Meta\s*\]\s*$/) {
        $metaflag = 1;
    }
    elsif ($line[$i] =~ /^\s*\[/) {
        $metaflag = 0;
    }
    elsif ($metaflag && ($line[$i] =~ /^\s*NetType=(.*)/)) {
        $nettype = $1;
        if ($nettype =~ /^(intranet|dialup|internet)$/) {
        return($nettype);
        } else {
        return("unknown");
        }
    }
    }
    return("unknown");
}

#
# ̾
#   getConfParam - եͤɤ߹
# 
#   getConfParam($section, $name)
# 
#   $section ̾
#   $name ѥ᡼̾
# 
#   (դʤ"")
#
sub getConfParam
{
    local($section, $name) = @_;
    local(@line, $i, $flag);

    if (!&readFile("/etc/opt/nec/wbmc/INITCONF.INI", "INITCONF.INI", *line)) {
    return("");
    }
    $flag = 0;
    for ($i = 0; $i <= $#line; $i++) {
    $line[$i] =~ s/[\r\n]*$//;
    if ($line[$i] =~ /^\s*\[\s*$section\s*\]\s*$/) {
        $flag = 1;
    }
    elsif ($line[$i] =~ /^\s*\[/) {
        $flag = 0;
    }
    elsif ($flag && ($line[$i] =~ /^\s*$name=(.*)/)) {
        return($1);
    }
    }
    return("");
}

#
# ̾
#   getDate - ߤλ
# 
#   getDate()
# 
#   ʤ
# 
#   ߤλ(ʸ)
#
sub getDate
{
    local($year, $mon, $mday, $hour, $min, $sec);

    ($sec, $min, $hour, $mday, $mon, $year) = localtime();
    return(sprintf("%04d/%02d/%02d %02d:%02d:%02d",
    $year + 1900, $mon + 1, $mday, $hour, $min, $sec));
}

#
# ̾
#   ipAddrCheck - IPɥ쥹Υ󥿥ååԤ
# 
#   ipAddrCheck($addr)
# 
#   $addr ɥåɽIPɥ쥹
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub ipAddrCheck
{
    local($addr) = @_;

    if ($addr !~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
    return(0);
    }

    if (($1 < 0) || (255 < $1)
     || ($2 < 0) || (255 < $2)
     || ($3 < 0) || (255 < $3)
     || ($4 < 0) || (255 < $4)) {
    return(0);
    }

    return(1);
}

#
# ̾
#   ipStr2Addr - IPɥ쥹ʸ󤫤ͤѴ
# 
#   ipStr2Addr($addr)
# 
#   $addr ɥåɽIPɥ쥹
# 
#   ͤȤƤIPɥ쥹
#
sub ipStr2Addr
{
    local($addr) = @_;
    local(@ent);

    @ent = split(/\./, $addr);

    return($ent[0] * 256 * 256 * 256
     + $ent[1] * 256 * 256
     + $ent[2] * 256
     + $ent[3]);
}

#
# ̾
#   ipAddr2Str - IPɥ쥹ͤʸѴ
# 
#   ipAddr2Str($addr)
# 
#   $addr ͤȤƤIPɥ쥹
# 
#   ɥåɽIPɥ쥹
#
sub ipAddr2Str
{
    local($addr) = @_;

    return(sprintf("%d.%d.%d.%d",
    ($addr & 0xff000000) / (256 * 256 * 256),
    ($addr & 0x00ff0000) / (256 * 256),
    ($addr & 0x0000ff00) / (256),
    ($addr & 0x000000ff)));
}

#
# ̾
#   getNetMask - IPɥ쥹ǥեȤΥͥåȥޥ
# 
#   getNetMask($netaddr)
# 
#   $netaddr ɥåɽIPɥ쥹
# 
#   ɥåɽΥͥåȥޥ
#
sub getNetMask
{
    my($netaddr) = @_;
    my($netaddrnum);
    my($netmask);

    $netaddrnum = &ipStr2Addr($netaddr);
    if (($netaddrnum & 0x80000000) == 0) {
    # 饹A
    $netmask = "255.0.0.0";
    } elsif (($netaddrnum & 0xc0000000) == 0x80000000) {
    # 饹B
    $netmask = "255.255.0.0";
    } elsif (($netaddrnum & 0xe0000000) == 0xc0000000) {
    # 饹C
    $netmask = "255.255.255.0";
    } else {
    # ¾
    $netmask = "";
    }

    return($netmask);
}

# եåΥ⡼
$WBMC_LOCK_R_B = 1; # ɤ߹ߥå(֥å⡼)
$WBMC_LOCK_W_B = 2; # 񤭹ߥå(֥å⡼)
$WBMC_LOCK_R_NB = 5;    # ɤ߹ߥå(Υ֥å⡼)
$WBMC_LOCK_W_NB = 6;    # 񤭹ߥå(Υ֥å⡼)

#
# ̾
#   lockFile - ꤵ줿ե˥å򤫤
# 
#   lockFile($lockfile, $mode, *LOCK)
# 
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   $mode åΥ⡼(β줫)
#       $WBMC_LOCK_R_B  ɤ߹ߥå(֥å⡼)
#       $WBMC_LOCK_W_B  񤭹ߥå(֥å⡼)
#       $WBMC_LOCK_R_NB ɤ߹ߥå(Υ֥å⡼)
#       $WBMC_LOCK_W_NB 񤭹ߥå(Υ֥å⡼)
#   *LOCK եϥɥ
#       åˤϤΥեϥɥclose
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub lockFile
{
    local($lockfile, $mode, *LOCK) = @_;

    my($ret);
    my($lockdir);

    $ret = 0;
    $lockdir = "$WBMC_VAR_DIR/lock";

    if ($lockfile eq "") {
    goto done;
    }

    # åեѤΥǥ쥯ȥ(̵)
    if (! -d $lockdir) {
    if (!mkdir($lockdir, 0755)) {
        goto done;
    }
    }

    # åե򥪡ץ󤹤
    if (!open(LOCK, "> $lockdir/$lockfile")) {
    goto done;
    }

    # å򤫤
    if (!flock(LOCK, $mode)) {
    close(LOCK);
    goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   readFile - եɤƤ֤(åդ)
# 
#   readFile($filename, $lockfile, *line)
# 
#   $filename ɤ߹ե̾
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   *line եƤ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub readFile
{
    local($filename, $lockfile, *line) = @_;

    local(*LOCK);
    local(*IN);
    my($ret);
    my($lockfileflag);

    $ret = 0;
    $lockfileflag = 0;

    if ($filename eq "") {
    goto done;
    }

    if ($lockfile ne "") {
    # ɤ߹ߥå(֥å⡼)򤫤
    if (!&lockFile($lockfile, $WBMC_LOCK_R_B, *LOCK)) {
        goto done;
    }
    $lockfileflag = 1;
    }

    # ե򥪡ץ󤷤ɤ߹
    if (!open(IN, $filename)) {
    goto done;
    }
    @line = <IN>;
    close(IN);

    $ret = 1;

done:
    if ($lockfileflag != 0) {
    close(LOCK);
    }

    return($ret);
}

#
# ̾
#   writeFile - ꤵ줿Ƥե˽񤭹(åդ)
# 
#   writeFile($filename, $lockfile, @line)
# 
#   $filename 񤭹ե̾
#   $lockfile åե̾(/var/opt/nec/wbmc/lock/β˺)
#   @line ե˽񤭹Ƥ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub writeFile
{
    local($filename, $lockfile, @line) = @_;

    local(*LOCK);
    local(*OUT);
    my($ret);
    my($lockfileflag);
    my($tmpfile);
    my($filemode);

    my($tag_name) = "wbmc_cluster"                      ;#cluster add
    my($log_file) = "/var/log/wbmc_cluster"             ;#cluster add
    my($cluster_backup_dir) = "/home/.wbmc/.wbmcsys"    ;#cluster add
    my($cluster_type)   = cluster_typechk()             ;#cluster add
    my($cluster_master) = cluster_masterchk()           ;#cluster add

    $ret = 0;
    $lockfileflag = 0;
    $tmpfile = "$filename.$$";

    if ($filename eq "") {
    goto done;
    }

    if ($lockfile ne "") {
    # 񤭹ߥå(֥å⡼)򤫤
    if (!&lockFile($lockfile, $WBMC_LOCK_W_B, *LOCK)) {
        goto done;
    }
    $lockfileflag = 1;
    }

    # ȥե򥪡ץ󤷤ƽ񤭹
    if (!open(OUT, "> $tmpfile")) {
    goto done;
    }

    if (!print(OUT @line)) {
    close(OUT);
    goto done;
    }
    close(OUT);

    ##########  $tmpfile . ̾Ĥɬ
    ##########  $tmpfile . ̾Ĥɬ
    #饹ʤ顢ͭǥ˥ХååפԤ
    if($cluster_type eq "cluster"){
        if($cluster_master eq "master"){
            # ե̾ƥեȰפ뤫
            # פʤ硧⤷ʤ
            if (&cluster_sysfile_check($filename) ne "") {

                $dir_name = get_dir("$cluster_backup_dir$filename");
                if(-e $dir_name){
                }else{
                    $dir_command = "/bin/mkdir -p " . $dir_name ;
                    if (system($dir_command)){
                        &writeLog($cluster_backup_dir ." " . $dir_name . " mkdir err", $tag_name, $log_file);
                    }
                }

                if (system("/bin/cp -af $tmpfile $cluster_backup_dir$filename")) {
                    &writeLog($cluster_backup_dir ." ". $filename . " cp err", $tag_name, $log_file);
                    goto done;
                }
            }
        }
    }

    # եΥ⡼ɤ
    if (-e $filename) {
    $filemode = (stat($filename))[2];
    } else {
    $filemode = 0644;
    }

    # Υե˥͡ह
    if (!rename($tmpfile, $filename)) {
    goto done;
    }

    # եΥ⡼ɤꤹ
    chmod($filemode & 07777, $filename);
    # ͭǥ¸եΥ⡼ɤꤹ   200010305
    if($cluster_type eq "cluster" && $cluster_master eq "master"){
        chmod($filemode & 07777, "$cluster_backup_dir$filename");
    }

    #饹ޥޤϥߥ顼ޥʤ顢Фž롣
    if($cluster_type eq "cluster" || $cluster_type eq "mirror"){
        if($cluster_master eq "master"){
            # פʤ硧⤷ʤ
            if (&cluster_sysfile_check($filename) ne "") {
                $errmsg = cluster_ftp_all($filename);
                if ($errmsg ne "") {
                    &writeLog($errmsg . " ftp err", $tag_name, $log_file);
                    goto done;
                }
            }
        }
    }

    $ret = 1;

done:
    if ($lockfileflag != 0) {
    close(LOCK);
    }

    if (-f $tmpfile) {
    unlink($tmpfile);
    }

    return($ret);
}

#
# ̾
#   get_dir - ǥ쥯ȥ
# 
#   get_dir()
# 
#   ʤ
# 
#   ǥ쥯ȥ
#
sub get_dir{
    my($filename) = @_;
    my($dirname) = "";
    @list = split(/\//, $filename);
    for(1..($#list-1)) {
            $dirname .= '/' . $list[$_] ;
    }
    return $dirname;
}

#
# ̾
#   getNavigation - ʥӥС֤
# 
#   getNavigation($name1, $page2, $name2, $page2, ...)
# 
#   $nameN ɽ̾
#       _backб
#       _helpϥإפб
#   $pageN Ȥɽڡ
#       ꤷʤ""ꤹȡ󥯤ɽʤ
#       ΤȤ_back_helpξ̾ɽʤ
# 
#   ʥӥС(ʸ)
#
sub getNavigation
{
    my(@argv) = @_;

    my(@name);
    my(@page);
    my($backpage);
    my($helppage);
    my($i);
    my($buf);

    $backpage = "";
    $helppage = "";
    for ($i = 0; $i <= $#argv; $i++) {
    if ($argv[$i] eq "_back") {
        if (($i + 1) <= $#argv) {
        $backpage = $argv[$i + 1];
        $i++;
        }
    } elsif ($argv[$i] eq "_help") {
        if (($i + 1) <= $#argv) {
        $helppage = $argv[$i + 1];
        $i++;
        }
    } else {
        push(@name, $argv[$i]);
        if (($i + 1) <= $#argv) {
        push(@page, $argv[$i + 1]);
        $i++;
        } else {
        push(@page, "");
        }
    }
    }

    $buf = ""
    . "<TABLE WIDTH='100%'>\n"
    . " <TR>\n"
    . "  <TD ALIGN='left'>\n";

    for ($i = 0; $i <= $#name; $i++) {
    if ($page[$i] ne "") {
        $buf .= "   <A HREF='$page[$i]'>$name[$i]</A> &gt;\n";
    } else {
        $buf .= "   $name[$i]\n";
    }
    }

    $buf .= ""
    . "  </TD>\n"
    . "  <TD ALIGN='right'>\n";

    if ($backpage ne "") {
    $buf .= "   <A HREF='$backpage'>[]</A>\n";
    }
    if ($helppage ne "") {
    $buf .= "   <A HREF='$helppage' TARGET='help'>[إ]</A>\n";
    }

    $buf .= ""
    . "  </TD>\n"
    . " </TR>\n"
    . "</TABLE>\n";

    return($buf);
}

#
# ̾
#   parseUint - Ϥ줿ͤå
# 
#   parseUint($str)
# 
#   $str ʸ(ζʸ̵뤹)
# 
#   ΤȤ(0ʾ)
#   ԤΤȤ-1
#
sub parseUint
{
    my($str) = @_;
    my($num);

    $str =~ s/^\s*//;
    $str =~ s/\s*$//;

    if ($str =~ /[^0-9]/) {
    $num = -1;
    } else {
    $str =~ s/^0+//;
    if ($str eq "") {
        $num = 0;
    } else {
        $num = $str;
    }
    }

    return($num);
}

#
# ̾
#   isServiceRunning - ӥư椫ɤǧ
# 
#   isServiceRunning($dir)
# 
#   $dir Υӥ wbmc.rc Τǥ쥯ȥ
#       ꤷʤ""ꤹȡȥǥ쥯ȥȤߤʤ
# 
#   ưΤȤ1
#   ΤȤ0
#   ΤȤ-1
#
sub isServiceRunning
{
    my($dir) = @_;

    local(@inetd_conf);
    local(@wbmc_rc);
    my(@ent);
    my(%inetd_conf);
    my(%process);
    my($filename);
    my($service_type);
    my($service_name);
    my($upcheck);
    my($process_name);
    my($updown_current);

    $updown_current = "unknown";

    # inetd.confƤɤߤƤ
    if (!&readFile("/etc/inetd.conf", "inetd.conf", *inetd_conf)) {
    goto nextstep1;
    }
    for (@inetd_conf) {
    s/^\s*//;
    s/\s*$//;
    if (/^#/) {
        next;
    }
    @ent = split(/\s+/);
    if ($ent[1] !~ /^(stream|dgram)$/) {
        next;
    }
    $inetd_conf{$ent[0]} = 1;
    }

nextstep1:

    # psη̤ɤߤƤ
    if (!open(IN, "/bin/ps -efwwwww |")) {
    goto nextstep2;
    }
    while (<IN>) {
    s/\s*$//;
    @ent = split(/\s+/);
    $ent[7] =~ s/\[//;
    $ent[7] =~ s/\]//;
    $ent[7] =~ s/.*\///;
    $process{$ent[7]} = 1;
    }
    close(IN);

nextstep2:

    if (defined($dir) && $dir ne "") {
    $filename = "$dir/wbmc.rc";
    } else {
    $filename = "./wbmc.rc";
    }

    # wbmc.rc եɤ߹
    if (!&readFile($filename, "wbmc.rc", *wbmc_rc)) {
    goto nextstep3;
    }
    $service_type = "";
    $service_name = "";
    $upcheck = "";
    $process_name = "";
    for (@wbmc_rc) {
    s/\s*$//;
    if (/^#/) {
        next;
    }
    elsif (/^\s*ServiceType:\s*(.*)/i) {
        $service_type = $1;
    }
    elsif (/^\s*ServiceName:\s*(.*)/i) {
        $service_name = $1;
    }
    elsif (/^\s*UpCheck:\s*(.*)/i) {
        $upcheck = $1;
    }
    elsif (/^\s*ProcessName:\s*(.*)/i) {
        $process_name = $1;
    }
    }

    # ӥפ inetd Ǥʤ rc Ȥߤʤ
    if ($service_type !~ /^inetd$/i) {
    $service_type = "rc";
    }

    # ߤξ֤
    if ($upcheck) {
#   chdir($dir);
    if ($upcheck !~ /^\//) {
        if (defined($dir) && $dir ne "") {
        $upcheck = "$dir/$upcheck";
        } else {
        $upcheck = "./$upcheck";
        }
    }
    if (open(IN, "$upcheck |")) {
        $updown_current = <IN>;
        $updown_current =~ s/\s*$//;
        close(IN);
    }
#   chdir("..");
    } elsif ($service_type =~ /^inetd$/i) {
    if ($inetd_conf{$service_name}) {
        $updown_current = "up";
    } else {
        $updown_current = "down";
    }
    } else {
    if ($process_name) {
        if ($process{$process_name}) {
        $updown_current = "up";
        } else {
        $updown_current = "down";
        }
    }
    }

nextstep3:

    if ($updown_current eq "up") {
    return(1);
    } elsif ($updown_current eq "down") {
    return(0);
    } else {
    return(-1);
    }
}

#
# ̾
#   checkNum - ͤꤵ줿ϰϤˤ뤫ɤå
# 
#   checkNum($num, $min, $max)
# 
#   $num 
#   $min Ǿ
#   $max 
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkNum
{
    my($num, $min, $max) = @_;
    my($ret);

    $ret = 0;

    if (!defined($num) || $num eq "") {
    goto done;
    }
    if ($num =~ /\D+/) {
    goto done;
    }
    if ($num < $min || $num > $max) {
    goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkNetMask - ֥ͥåȥޥηå
# 
#   checkNetMask($netmask)
# 
#   $netmask ֥ͥåȥޥ
#       (ɥåɽ131)
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkNetMask
{
    my($netmask) = @_;
    my($ret);

    $ret = 0;

    if (!defined($netmask) || $netmask eq "") {
    goto done;
    }
    if ($netmask =~ /\./) {
    if (!&ipAddrCheck($netmask)) {
        goto done;
    }
    } else {
    if (!&checkNum($netmask, 1, 31)) {
        goto done;
    }
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkPortNum - ݡֹηå
# 
#   checkPortNum($port)
# 
#   $port ݡֹ
#       (165535)
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkPortNum
{
    my($port) = @_;

    return(&checkNum($port, 1, 65535));
}

#
# ̾
#   checkUserID - 桼IDηå
# 
#   checkUserID($uid)
# 
#   $uid 桼ID
#       (065534)
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkUserID
{
    my($uid) = @_;

    return(&checkNum($uid, 0, 65534));
}

#
# ̾
#   checkGroupID - 롼IDηå
# 
#   checkGroupID($gid)
# 
#   $gid 롼ID
#       (065534)
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkGroupID
{
    my($gid) = @_;

    return(&checkNum($gid, 0, 65534));
}

#
# ̾
#   checkName - ̾ηå
# 
#   checkName($name)
# 
#   $name ̾
#       (ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_')
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkName
{
    my($name) = @_;
    my($ret);

    $ret = 0;

    if (!defined($name) || $name eq "") {
        goto done;
    }

    if ($name =~ /^[^A-Za-z]/) {
        goto done;
    }

    if ($name =~ /[^A-Za-z0-9\-\._]/) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkUserName - unix桼(ƥ桼)̾ηå롣
#                   ̥桼 checkAppUserName() Ȥȡ
# 
#   checkUserName($user)
# 
#   $user unix桼̾
#       (ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_')
#       (Ĺ132) useradd ǧǽĹ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkUserName
{
    my($user) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if(!&checkName($user)) {
        goto done;
    }
    $len = length($user);
    if(!&checkNum($len, 1, 32)) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkGroupName - 롼̾ηå
#                   ƥѥ롼פޤࡣ
#                   appliance ǻѤ륰롼̾åѤ checkAppGroupName() Ȥ
# 
#   checkGroupName($group)
# 
#   $group 롼̾
#       (ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-')
#       (Ĺ116) groupadd ϿǽĹ
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkGroupName
{
    my($group) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if(!&checkName($group)) {
        goto done;
    }

    # 嵭åϰϤʤ롣'.', '_' ᡣ
    if ($group =~ /[^A-Za-z0-9\-]/) {
        goto done;
    }

    $len = length($group);
    if(!&checkNum($len, 1, 16)) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkAppUserName - aplianceѰ̥桼̾ηå
#                       unix桼Υå checkUserName() Ȥȡ
# 
#   checkAppUserName($user)
# 
#   $user ̥桼̾
#       (Ƭa-zǡΤa-z, 0-9, '-', '.', '_')
#       (Ĺ116)
#       ᡼DNShttpdʤʸʸ̤ʤӥǻȤ褦
#       ̾Υ桼ϡʸԲĤȤ롣
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkAppUserName
{
    my($user) = @_;
    my($ret);
    my($len);

    $ret = 0;

    # ƥ桼å
    if(!&checkUserName($user)) {
        goto done;
    }
    # 嵭åϰϤʤ롣'A-Z' ϥᡣ
    if ($user =~ /[A-Z]/) {
        goto done;
    }
    $len = length($user);
    if(!&checkNum($len, 1, 16)) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkAppGroupName - appliance ǻȤ롼̾ηå
#                        桼ͳϿ륰롼׸Υå
#                          checkGroupName() Ȥȡ
# 
#   checkAppGroupName($group)
# 
#   $group 롼̾
#       (Ƭa-zǡΤa-z, 0-9, '-')
#       (Ĺ115)
#       ᡼DNShttpdʤʸʸ̤ʤӥǻȤ褦
#       ̾Υ롼פϡʸԲĤȤ롣
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkAppGroupName
{
    my($group) = @_;
    my($ret);
    my($len);

    $ret = 0;

    # ƥ?롼ץå
    if(!&checkGroupName($group)) {
        goto done;
    }

    # 嵭åϰϤʤ롣ʸᡣ
    if ($group =~ /[A-Z]/) {
        goto done;
    }
    # 115ʸޤǡ(SURFNAVIǤ1ʸä)
    $len = length($group);
    if(!&checkNum($len, 1, 15)) {
        goto done;
    }

    $ret = 1;

done:
    return($ret);
}

# ̾
#   checkMailAddr - ᡼륢ɥ쥹ηå롣
#                   @ʤϡunix桼Ȥߤʤƥå롣
# 
#   checkMailAddr($addr)
# 
#   $addr  ᡼륢ɥ쥹
#     ᡼륢ɥ쥹 @ ޤޤ(user@domain ξ)
#       user
#           ʳʸ 1ʸʾ夢뤳ȡ
#             ¾ϡåʤĹ 1ʾ̵¡/֤ʤɤǽ
#       domain  checkDomainName() ǥå
#           ǤƬA-Z, a-z, 0-9ǹƤ뤳
#           ǤʸA-Z, a-z, 0-9, ϥե(-)ǹƤ뤳
#           ġǤ163ʸǤ뤳
#           Τ1255ʸǤ뤳
#           ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#     ᡼륢ɥ쥹 @ ޤޤʤ(user Τ)
#       user    checkUserName() ǥå
#           ƬA-Zޤa-zǡΤA-Z, a-z, 0-9, '-', '.', '_'
#           Ĺ132
#     "  ǰϤġ"xxx" ξ xxx Τߤå롣
#     <> ǰϤġ<xxx> ξ xxx Τߤå롣
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkMailAddr
{
	local($mail) = @_;
    my(@buf) = ();
    my($user, $domain);
	my($ret);

	# ΤߡޤϲꤷƤʤｪλ
	$ret = 1;
	goto done unless length($mail);
	goto done if     $mail =~ /^\s*$/;

	$ret = 0;
	# "" ޤ <> ǰϤǤȤΤߥå
	if ($mail =~ /^\"/ && $mail =~ /\"$/) {
		$mail =~ s/^\"//;
		$mail =~ s/\"$//;
	}
	if ($mail =~ /^</ && $mail =~ />$/) {
		$mail =~ s/^<//;
		$mail =~ s/>$//;
	}

	@buf = split(/\@/, $mail);
    if ($#buf == 0) {
		goto done unless &checkUserName($mail);
    }
    elsif ($#buf == 1) {
        ($user, $domain) = @buf;
		goto done unless length($user);
		goto done if     $user =~ /^\s*$/;
		goto done unless &checkDomainName($domain);
    }
    else {
		goto done;
    }

	$ret = 1;

done:
	return($ret);
}


#
# ̾
#   checkShortHostName - ۥ̾ηå
# 
#   checkShortHostName($host)
# 
#   $host ۥ̾
#     ƬA-Z, a-z, 0-9ǹƤ뤳
#     ʸA-Z, a-z, 0-9, ϥե(-)ǹƤ뤳
#     163ʸǤ뤳
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkShortHostName
{
    my($host) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if (!defined($host) || $host eq "") {
    goto done;
    }

    $len = length($host);
    if (!&checkNum($len, 1, 63)) {
    goto done;
    }

    if ($host !~ /^[A-Za-z0-9]([A-Za-z0-9\-]*[A-Za-z0-9]|)$/) {
    goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkLongHostName - ۥ̾(FQDN)ηå
# 
#   checkLongHostName($host)
# 
#   $host ۥ̾
#     ǤƬA-Z, a-z, 0-9ǹƤ뤳
#     ǤʸA-Z, a-z, 0-9, ϥե(-)ǹƤ뤳
#     Τ163ʸǤ뤳
#     ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkLongHostName
{
    my($host) = @_;
    my($ret);
    my($len);

    $ret = 0;

    if (!&checkDomainName($host)) {
    goto done;
    }
    $len = length($host);
    if (!&checkNum($len, 1, 63)) {
    goto done;
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   checkDomainName - ɥᥤ̾ηå
# 
#   checkDomainName($domain)
# 
#   $domain ɥᥤ̾
#     ǤƬA-Z, a-z, 0-9ǹƤ뤳
#     ǤʸA-Z, a-z, 0-9, ϥե(-)ǹƤ뤳
#     ġǤ163ʸǤ뤳
#     Τ1255ʸǤ뤳
#     ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkDomainName
{
    my($domain) = @_;
    my($ret);
    my($len);
    my(@ent);
    my($i);

    $ret = 0;

    if (!defined($domain) || $domain eq "") {
    goto done;
    }
    if ($domain =~ /^\./) {
    goto done;
    }
    if ($domain =~ /\.$/) {
    goto done;
    }

    $len = length($domain);
    if (!&checkNum($len, 1, 255)) {
    goto done;
    }

    if ($domain =~ /^[0-9\.]+$/) {
    goto done;
    }

    @ent = split(/\./, $domain);
    for ($i = 0; $i <= $#ent; $i++) {
    $len = length($ent[$i]);
    if (!&checkNum($len, 1, 63)) {
        goto done;
    }

    if ($ent[$i] !~ /^[A-Za-z0-9]([A-Za-z0-9\-]*[A-Za-z0-9]|)$/) {
        goto done;
    }
    }

    $ret = 1;

done:
    return($ret);
}

#
# ̾
#   encodeHtml - HTMLΥ󥳡(&  &amp;)Ԥ
# 
#   encodeHtml($str)
# 
#   $str ʸ
# 
#   󥳡ɤ줿ʸ
#
sub encodeHtml
{
    my($str) = @_;

    $str =~ s/&/&amp;/g;
    $str =~ s/</&lt;/g;
    $str =~ s/>/&gt;/g;
    $str =~ s/"/&quot;/g;
    return($str);
}

#
# ̾
#   encodeCmdArg - ޥɥ饤Υ󥳡(&  \&)Ԥ
# 
#   encodeCmdArg($str)
# 
#   $str ʸ
# 
#   󥳡ɤ줿ʸ
#
sub encodeCmdArg
{
    my($str) = @_;

    $str =~ s/([^0-9a-zA-Z])/\\$1/g;
    return($str);
}

#
# ̾
#   encodeUrl - URLΥ󥳡(&  %26)Ԥ
# 
#   encodeUrl($str)
# 
#   $str ʸ
# 
#   󥳡ɤ줿ʸ
#
sub encodeUrl
{
    my($str) = @_;

    $str =~ s/([^\-\_\.\/0-9a-zA-Z])/sprintf("%%%02X", ord($1))/eg;
    return($str);
}

#
# ̾
#   writeLog - wbmcѥɲ
# 
#   writeLog($message, $tag, $file)
# 
#   $message ɲäå
#   $tag     ˵Ҥ륿̾(ޥ̾)
#   $file    Ҥե̾
# ϥեޥå
#   YYYY/MM/DD hh:mm:ss TAG: MESSAGE ...
# 
#   λ 1
#   Ԥλ 0
#
sub writeLog {
    my($message, $tag, $file) = @_;
    local(*OUT);
    my($time);
    my($ret);

    $ret = 0;

    if ($file eq "") {
        goto done;
    }
    $time = &getDate();
    if (!open(OUT, ">> $file")) {
        goto done;
    }
    if (!flock(OUT, $WBMC_LOCK_W_B)) {
        goto done;
    }
    if (!print OUT "$time $tag: $message\n") {
        goto done;
    }
    close(OUT);

    $ret = 1;

done:
    return(1);
}

#
# ̾
#   createDirectory - make directory
# 
#   createDirectory($path, $mode, $owner, $group)
# 
#   $path         file-path
#   $mode         file-mode
#   $owner        file-owner
#   $groupe       file-group
# 
#   λ ""
#   Ԥλ ""ʳ
#
sub createDirectory
{
    local($path,$mode,$owner,$group) = @_;

    local($err) = "";

    if (! -d "$path") {
    # not exist
    if (mkdir("$path", "$mode") == 0) {
        $err = "ǥ쥯ȥ($path)κ˼Ԥޤ";
        goto done;
    }
    }
    $cmd = "/bin/chown " . "$owner:$group " . "$path";
    open(IN, "$cmd 2>&1 |");
    @ans = <IN>;
    close(IN);

    # chown 顼֤
    if (@ans) {
    $err = "ǥ쥯ȥ($path)chownǥ顼ޤϷٹȯޤ@ans";
    goto done;
    }

done:
    return($err);
}

#
# ƥ⡼ɤ
# ̾
#   getSecurityMode
# 
#   getSecurityMode()
# 
#   ʤ
# 
#   λ none , pass , ssl
#   Ԥλ -1
#

sub getSecurityMode(){
    local($security_mode , $htaccess_file , $htaccess_lock) = "";
    local(@file) = ();
    local($i , $security_mode , $wbmchttpd_conf_file , $wbmchttpd_conf_lock)="";

    $htaccess_file = "$WBMC_ADM_DIR/.htaccess";
    $htaccess_lock = ".htaccess";
    $wbmchttpd_conf_file = "$WBMC_HTTPD_CONF_DIR/wbmchttpd.conf";
    $wbmchttpd_conf_lock = "wbmchttpd.conf";

    $security_mode = "pass";
    if (!&readFile($htaccess_file ,$htaccess_lock, *file)) {
        return(-1);
    }
    for ($i = 0; $i < @file; $i++) {
        if ($file[$i] =~ /^#AuthType/) {
            $security_mode = "none";
            return($security_mode);
        }
    }
    if ($security_mode ne "none") {
        if (!&readFile($wbmchttpd_conf_file, $wbmchttpd_conf_lock, *file)) {
            return(-1);
        }
        for ($i = 0; $i < @file; $i++) {
            if ($file[$i] =~ /<IfDefine SSL>/) {
                while((!($file[$i] =~ /<\/IfDefine>/))||($i >= @file)) {
                    $i++;
                }
            }
            if ($file[$i] =~ /^\s*SSLEngine\s+on/) {
                    $security_mode = "ssl";
                return($security_mode);
            }
        }
        }
    return($security_mode);
}

#
# ǥ쥯ȥ
# ̾
#   getDomainDir
# 
#   getDomainDir($domainname,$type)
# 
#   $domainname     ɥᥤ̾
#   $type           web mail wbmc Τ줫
#                   3İʳλϡwebɤȤƽ
# 
#   λ ǥ쥯ȥ̾եѥ֤
#
sub getDomainDir
{
    local($domainname,$type) = @_;
    local($rtn_code) = "";
    $rtn_code = -1;
    $domainname =~ s/^\s*\s*$//;
    $type =~ s/^\s*\s*$//;

    if($type eq "web") {
        $rtn_code = "/home/web/$domainname";
        return($rtn_code);
    }
    elsif($type eq "mail") {
        $rtn_code = "/home/mail/$domainname";
        return($rtn_code);
    }
    elsif($type eq "wbmc") {
        $rtn_code = "/home/.wbmc/$domainname";
        return($rtn_code);
    }
    else {
        $rtn_code = "/home/web/$domainname";
        return($rtn_code);
    }
}

#
# ̾
#   checkAppDomainName - ɥᥤ̾ηå
# 
#   checkAppDomainName($domain)
# 
#   $domain ɥᥤ̾
#     ʸػ
#     ǤƬ a-z, 0-9ǹƤ뤳
#     Ǥʸ a-z, 0-9, ϥե(-)ǹƤ뤳
#     ġǤ163ʸǤ뤳
#     Τ1230ʸǤ뤳
#     ٤ƤǤϤʤ(IPɥ쥹ɥᥤ̾Ȳᤷʤ)
#
# 
#   ΤȤ1
#   ԤΤȤ0
#
sub checkAppDomainName
{
    my($domain) = @_;
    my($ret);
    my($len);
    my(@ent);
    my($i);

    $ret = 0;

    if (!defined($domain) || $domain eq "") {
    goto done;
    }
    if ($domain =~ /^\./) {
    goto done;
    }
    if ($domain =~ /\.$/) {
    goto done;
    }


    $len = length($domain);
    if (!&checkNum($len, 1, 230)) {
    goto done;
    }

    if ($domain =~ /^[0-9\.]+$/) {
    goto done;
    }

    @ent = split(/\./, $domain);
    for ($i = 0; $i <= $#ent; $i++) {
    $len = length($ent[$i]);
    if (!&checkNum($len, 1, 63)) {
        goto done;
    }

    if ($ent[$i] !~ /^[a-z0-9]([a-z0-9\-]*[a-z0-9]|)$/) {
        goto done;
    }
    }

    $ret = 1;

done:
    return($ret);
}

sub getMachineType
{
    my($filename);
    local(*MT);
    my(@line);

    $WBMC_MACHINE_TYPE = "pre";

    # ޥ󥿥פ
    $filename = "/etc/opt/nec/machinetype";
    if (-e $filename) {
    if (open(MT, $filename)) {
        @line = <MT>;
        close(MT);

        if (defined($line[0])) {
        $line[0] =~ s/^\s*//;
        $line[0] =~ s/\s*$//;
        if ($line[0] ne "") {
            $WBMC_MACHINE_TYPE = $line[0]
        }
        }
    }
    }

    # OSפ
    if (-f "/etc/turbolinux-release") {
    $WBMC_OS_TYPE = "turbo";
    } elsif (-f "/etc/redhat-release") {
    $WBMC_OS_TYPE = "redhat";
    } else {
    $WBMC_OS_TYPE = "unknown";
    }

    ##001109 -------------- ɲ --------------
    if($WBMC_MACHINE_TYPE eq "pre"){
        # webmail ξ硢WebLoadbalance ʤwebѹ
        $filename = "/etc/opt/nec/wbmc/INITCONF.INI";
        if (-e $filename) {
            if (open(MT, $filename)) {
                @line = <MT>;
                close(MT);

                for ($i = 0; $i < @line; $i++) {
                    $line[$i] =~ s/^\s*//;
                    if ($line[$i] =~ /WorkMode=WebLoadbalance\s*/) {
                        $WBMC_MACHINE_TYPE = "web";
                        last;
                    }
                }

            }
        }
    }
    ##001109 -------------- ޤɲ --------------
}

# ̾
#   getWhereFrom - ɥᥤ̾μԤ
# 
#   getWhereFrom()
# 
#   ʤ
# 
#   ΥڡURL
#
sub getWhereFrom
{
    my($domain,$mode);

    $domain = $ENV{'HTTP_REFERER'};
#   if ($domain =~ /^\s*[^.\s]+.(.+)/i) {
#       $domain = $1;
#   }
    return($domain);
}

#
# ̾
#   showRltBtnPage - åɽ(ʣܥ)
#
# 
#   showRltBtnPage($title, $message, $rtn_page, %pages)
#
# 
#   $title ɽ륿ȥ
#   $message ɽå
#   $rtn_page ܥ򲡤Ȥɽڡ
#       ꤷʤ""ꤹȡΥڡɽ
#   %pages ¾Υܥ򲡤Ȥɽڡ
#	"" ܥ̾
#	""   ư
#       ꤷʤ""ꤹȡܥΤɽʤ
# 
#   ʤ
#
sub showRltBtnPage
{
    local($title, $message, $rtn_page, %pages) = @_;
    local($rtnpage, $page_cnt, $newpages);
    local(@btns);

    if (!defined($rtn_page) || $rtn_page eq "") {
    $rtnpage = "history.back()";
    } else {
    $rtnpage = "location.href='$rtn_page'";
    }

    @btns = keys %pages;
    $newpages = "";
    for($page_cnt=0; $page_cnt<@btns; $page_cnt++) {
	    $newpages .= "<INPUT TYPE='button' VALUE='$btns[$page_cnt]' onClick=\"location.href='$pages{$btns[$page_cnt]}'\">";
    }
    $newpages .= "";

#------------------------------------------------------------
print <<END_OF_DATA;
Content-type: text/html; charset=euc-jp

<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY>
<H4 ALIGN="center">$title</H4>
<HR>

<CENTER>
 <FORM>
  <TABLE BGCOLOR="#CCCCCC" WIDTH=300 BORDER=1 CELLSPACING=0 CELLPADDING=1>
   <TR BGCOLOR="#000080">
    <TD>
     <FONT COLOR="#FFFFFF"> <B>$title</B></FONT>
    </TD>
   </TR>
   <TR>
    <TD>
     <TABLE BORDER=0 WIDTH="100%" CELLSPACING=0 CELLPADDING=1>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD>
        $message
       </TD>
      </TR>
      <TR>
       <TD><BR></TD>
      </TR>
      <TR>
       <TD ALIGN="center">
        <INPUT TYPE="button" VALUE="" onClick=$rtnpage>
        $newpages
       </TD>
      </TR>
     </TABLE>
    </TD>
   </TR>
  </TABLE>
 </FORM>
</CENTER>

$WBMC_COPYRIGHT
</BODY>
</HTML>
END_OF_DATA
#------------------------------------------------------------
}

# ̾
#   getTruePath - ɥᥤ̾μԤ
# 
#   getTruePath($dirname, *symlink_dir)
# 
#   $dirname      ܥå
#   *symlink_dir  NULL (ｪλ˥ΥѥǼ)
# 
#   NULL
#   ۾顼å
sub getTruePath
{
        local($dirname,*symlink_dir) = @_;
        local(*DIR);
        my($i,$err,@lslist,@lsinfo);

        if (! -l $dirname) {
                $err = "$dirname ϥܥå󥯤ǤϤޤ";
                return $err;
        }

        open(DIR, "/bin/ls -la $dirname |");
        @lslist = <DIR>;
        close(DIR);

        for ($i = 0; $i < @lslist; $i++) {
                @lsinfo = split(/\s+/, $lslist[$i]);
                if ($lsinfo[0] =~ /^l/) {
                        push(@symlink_dir, $lsinfo[10]);
                }
        }
        return "";
}


#
# ̾
#   checkAdminName - ̾ηå
# 
#   checkAdminName($adminname)
# 
#   $adminname ̾
#       (Ƭa-zǡΤa-z, 0-9, '-', '.', '_')
#       (Ĺ116)
#       ᡼DNShttpdʤʸʸ̤ʤӥǻȤ褦
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub checkAdminName
{
	local($adminname) = @_;
	local(@file) = ();
	my($passwd,$passwd_lock) = ("/etc/passwd","passwd");
	my($i) = "";

	if ($adminname =~ /\./) {
		return("̾Ǥ");
	}
	if (&checkAppUserName($adminname) eq "0") {
		return("̾Ǥ");
	}

	if (!&readFile("$passwd", "$passwd_lock", *file)) {
		return("$passwd ɤ߹ߤ˼Ԥޤ");
	}

	for ($i=0; $i<@file; $i++) {
		$file[$i] =~ s/^\s+//;
		if ($file[$i] =~ /^\Q$adminname\E:/) {
			return("̾˻ꤵ줿̾ϴ˻ѤƤޤ");
		}
	}
	return();
}

#
# ̾
#   getSysAdminName - /etc/opt/nec/wbmc/adminname 鸽ߤδ̾ȵ̾
#                     Υե뤬ʤк롣
# 
#   getSysAdminName(*adminname)
# 
#   *adminname NULL (ｪλ˴̾Ǽ)
#                     $adminname{'ADMIN'}      ̾
#                     $adminname{'OLD_ADMIN'}  ̾
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub getSysAdminName
{
	local(*adminname) = @_;
	local(@adminline) = ();
	my($i, $adminid) = "";
	my($adminfile, $adminfile_lock) = ("/etc/opt/nec/wbmc/adminname" , "adminname");

	$adminname{'OLD_ADMIN'} = "";
	$adminname{'ADMIN'} = "admin";

	if (-f $adminfile) {
		if (!&readFile("$adminfile", "$adminfile_lock", *adminline)) {
			return("$adminfile ɤ߹ߤ˼Ԥޤ");
		}
		for ($i=0; $i<@adminline; $i++) {
			$adminline[$i] =~ s/^\s+//;
			if ($adminline[$i] =~ /^OLD_ADMIN\s+(.+)\s+(.+)/) {
				$adminname{'OLD_ADMIN'} = $1;
			}
			elsif ($adminline[$i] =~ /^ADMIN\s+(.+)\s+(.+)/) {
				$adminname{'ADMIN'} = $1;
			}
		}
		if (!$adminname{'OLD_ADMIN'}) {
			$adminname{'OLD_ADMIN'} = "admin";
		}
		if (!$adminname{'ADMIN'}) {
			$adminname{'ADMIN'} = "admin";
		}
	}
	else { ## adminname ̵п
		system("/bin/touch $adminfile  > /dev/null 2>&1");
		system("/bin/chown root:root $adminfile  > /dev/null 2>&1");
		system("/bin/chmod 600 $adminfile  > /dev/null 2>&1");
		($adminid) = (getpwnam("admin"))[2];
		if (($adminid =~ /\D/)||($adminid !~ /\d/)) {
			$adminid = "UNKNOWN";
		}
		$adminline[0] = "OLD_ADMIN admin $adminid\n";
		$adminline[1] = "ADMIN admin $adminid\n";
		if(!&writeFile($adminfile,$adminfile_lock, @adminline)) {
			return("$adminfile ν񤭹ߤ˼Ԥޤ");
		}
		$adminname{'OLD_ADMIN'} = "admin";
		$adminname{'ADMIN'} = "admin";
	}
	return();
}

##==========================================================================
##  <̾>
##        chkUserControl (¹ԸȽؿ)
##  <>
##        桼˽¹Ը(cgiեˤ뤫Ƚ
##        оcgi/opt/nec/wbmc/domain/adm ۲Τ
##        ¹Ը硢٥Ϣֵ
##        ƥԤऱˤϢ
##  <>
##       chkUserControl($func,%adminf)
##  <>
##       ($func)  : cgiεǽ̾
##                 ºݤˤϡwbmc.plƤDefineɤ
##                   $TOP_FUNC       (ȥåײ)
##                   $ADMININF_FUNC  (Ծ)
##                   $USERINF_FUNC   (桼)
##                   $WEBSV_FUNC     (WEBо)
##                   $MAILSV_FUNC    (MAILо)
##                   $SYSTEM_FUNC    (ƥ)
##
##       (*adminf): ɥᥤԾǼΰ
##
##  <>
##        ｪλ :  ""
##        ۾ｪλ :  顼å
##
##==========================================================================
$TOP_FUNC      = 0;
$ADMININF_FUNC = 1;
$USERINF_FUNC  = 2;
$WEBSV_FUNC    = 3;
$MAILSV_FUNC   = 4;
$SYSTEM_FUNC   = 5;
$ADMFILE = "cur_domain.inf";

sub chkUserControl
{
  local($func,*adminf) = @_;
  local($domainname) = $ENV{'SERVER_NAME'};
  local($username)   = $ENV{'REMOTE_USER'};
  local($rtn_code)= "";
  local($err_flg)= 0;
  local(@adminname,@ent) = ();


  if(($rtn_code=getSysAdminName(*adminnname)) ne ""){
    return($rtn_code);
  }
  if($adminnname{'ADMIN'} eq $username){
     $adminf{'USERNAME'} = "$adminnname{'ADMIN'}";
     $adminf{'CLASS'}    = "YES";
     $adminf{'ADMINF'}   = "ALL";
     $adminf{'USERINF'}  = "ALL";
     $adminf{'WEBSV'}    = "ALL";
     $adminf{'MAILSV'}   = "ALL";
     $adminf{'SYSTEM'}   = "ALL";
   }else{

## Ծ
    if(($rtn_code=&getDomainAdmInf($domainname,$username,*adminf)) ne ""){
      return($rtn_code);
    }

    if($adminf{'USERNAME'} eq "" || $adminf{'USERNAME'} ne $username){
      $err_flg = 1;
      goto error;
    }

##ѡǤʤTOPȽ̵ϳƵǽ٥Ƚ
    if($adminf{'CLASS'} eq "NO" && $func != $TOP_FUNC){
      if($func == $ADMININF_FUNC){
        if($adminf{'ADMINF'} eq "NO"){
          $err_flg = 1;
          goto error;
        }
      }elsif($func == $USERINF_FUNC){
        if($adminf{'USERINF'} eq "NO"){
          $err_flg = 1;
          goto error;
        }
      }elsif($func == $WEBSV_FUNC){
        if($adminf{'WEBSV'} eq "NO"){
          $err_flg = 1;
          goto error;
        }
      }elsif($func == $MAILSV_FUNC){
        if($adminf{'MAILSV'} eq "NO"){
          $err_flg = 1;
          goto error;
        }
      }elsif($func == $SYSTEM_FUNC){
        if($adminf{'SYSTEM'} eq "NO"){
          $err_flg = 1;
          goto error;
        }
      }
    }
  }

error:
  if($err_flg == 1){
##롼̾򥨥顼˽Фʤ
   @ent = split(/\@/,$username);
   return("桼$ent[0]ˤˤϡ¤ޤ\n");
  }

  return($rtn_code);
}


##==========================================================================
##  <̾>
##        getDomainAdmInf (̥ɥᥤԾؿ)
##  <>
##       /home/.wbmc/ɥᥤ̾/cur_domain.inf ե뤫
##       桼μ塢ꤷֵѤ롣
##  <>
##       getDomainAdmInf($domainname,$username,*adminf)
##  <>
##       ($domainname) : ɥᥤ̾
##       ($username)   : 桼̾ (@롼̾)
##       (*adminf)     : ɥᥤԾǼΰ
##
##                       Ϣեޥå
##                        ѥ᡼̾ : ѥ᡼
##                       {'USERNAME'}  : 桼̾(@롼̾)
##                       {'CLASS'}     : YES/NO       #饹Ƚ
##                       {'ADMINF'}    : ALL/SHOW/NO  #Ծ
##                       {'USERINF'}   : ALL/SHOW/NO  #桼
##                       {'WEBSV'}     : ALL/SHOW/NO  #WEBо
##                       {'MAILSV'}    : ALL/SHOW/NO  #MAILо
##                       {'SYSTEM'}    : ALL/NO       #ƥ
##
##  <>
##        ｪλ :  ""
##        ۾ｪλ :  顼å
##           cur_domain.infե뤬¸ߤʤ()硢ｪλȤ롣
##==========================================================================
sub getDomainAdmInf
{
  local($domainname,$username,*adminf) = @_;
  local(@ent,@line) = ();
  local($filename) = join("/", "/home/.wbmc/$domainname/", $ADMFILE);

  if(-f $filename){
    if(!&readFile($filename,$ADMFILE, *line)){
      return("$filenameեɤ߹ߤ˼Ԥޤ\n");
    }

    foreach(@line){
      s/^\s*//;
      s/\s*$//;
      if(/^domain_user_count:\s*/ || /^web_user_count:\s*/){
        next;
      }
      @ent=();
      @ent = split(/\//);
      if($username eq $ent[0]){
        $adminf{'USERNAME'} = "$ent[0]";
        $adminf{'CLASS'}    = "$ent[1]";
        $adminf{'ADMINF'}   = "$ent[2]";
        $adminf{'USERINF'}  = "$ent[3]";
        $adminf{'WEBSV'}    = "$ent[4]";
        $adminf{'MAILSV'}   = "$ent[5]";
        $adminf{'SYSTEM'}   = "$ent[6]";
        last;
      }
    }
  }
  return("");
}


##==========================================================================
##  <̾>
##        chkDomainAdmParam (ɥᥤԸѥ᡼åؿ)
##  <>
##        cur_domain.inf μ褷ƥɥᥤԸѥ᡼ͤ
##        å롣â桼̾˴ؤƤϡNULLȽΤߤȤ롣
##  <>
##       chkDomainAdmParam($username,$class,$adminf,$userinf,$websv,$mailsv,$system)
##  <>
##       $username : 桼̾
##       $class    : 饹Ƚ
##       $adminf   : Ծ
##       $userinf  : 桼
##       $websv    : WEBо
##       $mailsv   : MAILо
##       $system   : ƥ
##  <>
##        ｪλ :  ""
##        ۾ｪλ :  顼å
##
##==========================================================================
sub chkDomainAdmParam
{
  local($username,$class,$adminf,$userinf,$websv,$mailsv,$system) = @_;
  local($rtn_code)= "";

##桼̾å
  if($username eq ""){
    $rtn_code = "桼̾ꤵƤޤ\n";
  }
##饹Ƚå
  if($class eq ""){
    $rtn_code = "饹ȽꤵƤޤ(桼̾:$username)\n";
  }
  elsif($class ne "YES" &&
        $class ne "NO" ){
    $rtn_code = "饹ȽꤵƤ($class)ޤ(桼̾:$username)\n";
  }
##Ծå
  if($adminf eq ""){
    $rtn_code = "ԾꤵƤޤ\n";
  }
  elsif($adminf ne "ALL"  &&
        $adminf ne "SHOW" &&
        $adminf ne "NO"   ){
    $rtn_code = "ԾꤵƤ($adminf)ޤ(桼̾:$username)\n";
  }
##桼å
  if($userinf eq ""){
    $rtn_code = "桼ꤵƤޤ\n";
  }
  elsif($userinf ne "ALL"  &&
        $userinf ne "SHOW" &&
        $userinf ne "NO"   ){
    $rtn_code = "桼ꤵƤ($userinf)ޤ(桼̾:$username)\n";
  }
##WEBоå
  if($websv eq ""){
    $rtn_code = "WEBоꤵƤޤ\n";
  }
  elsif($websv ne "ALL"  &&
        $websv ne "SHOW" &&
        $websv ne "NO"   ){
    $rtn_code = "WEBоꤵƤ($websv)ޤ(桼̾:$username)\n";
  }
##MAILоå
  if($mailsv eq ""){
    $rtn_code = "MAILоꤵƤޤ\n";
  }
  elsif($mailsv ne "ALL"  &&
        $mailsv ne "SHOW" &&
        $mailsv ne "NO"   ){
    $rtn_code = "MAILоꤵƤ($mailsv)ޤ(桼̾:$username)\n";
  }
##SYSTEMå
  if($system eq ""){
    $rtn_code = "SYSTEMꤵƤޤ(桼̾:$username)\n";
  }
  elsif($system ne "ALL"  &&
        $system ne "SHOW" &&
        $system ne "NO"   ){
    $rtn_code = "SYSTEMꤵƤ($system)ޤ\n";
  }


  return($rtn_code);
}


##
## ̾
##   getParamDomainConf - domain.conf ͤõ
## 
##   getParamDomainConf($mydomain, $param)
## 
##   $mydomain   оݤоݥɥᥤ̾
##   $param      ѥ᡼()
## 
##   ѥ᡼()
##   ""  եɤ߽ФԤʤ
##
## /opt/nec/wbmc/domain/lib/wbmc.plˤ
##    getDomainConf()ؿ̾Ѥ
##
sub getParamDomainConf
{
    local($mydomain, $param) = @_;
    local($ret, $target, $i) = "";
    local(@lines) = ();
    $ret = "";

    # ɥᥤեɤ߽Ф
    if (!&readFile("$WBMC_DOMAIN_DIR/domain.conf", "domain.conf", *lines)) {
      goto done;
    }
    $target = 0;
    for ($i = 0; $i <= $#lines; $i++) {
        if ($lines[$i] =~ /^\s*<DOMAINNAME\s+([^\s]+)\s*>/i) {
            if ($target == 1) {
                last;
            }
            elsif ($mydomain eq $1) {
                $target = 1;
            }
        }
        if ($target == 0) {
            next;
        }
        if ($lines[$i] =~ /^\s*\Q$param\E\s+([^\s]+)\s*/i) {
            $ret = $1;
        }
    }

done:
    return ($ret);
}

#
# ̾
#   chgAdminName - ƥ̾ѹ
# 
#   chgAdminName($oldadminname,$newadminname)
# 
#   $oldadminname ̾
#   $newadminname ̾
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub chgAdminName
{
	local($oldadminname,$newadminname) = @_;
	my($i, $err, $openfile, $lockfile, $adminid, $domainname) = "";
	local(@ftpline, @buff, @htline, @fwdline, @wbmcline, @adminline, @newadminline) = ();


	# Хåå׽
		if (&cluster_typechk() eq "mirror") {
			if ($err = &cluster_exec_all("backupAdminName")) {
				return($err);
			}
		}
		else {
			if ($err = &backupAdminName()) {
				return($err);
			}
		}

	# /etc/passwd ѹ
		if (system("/usr/sbin/usermod -l $newadminname -d /home/users/$newadminname $oldadminname >/dev/null 2>&1") != 0) {
			$err = &restoreAdminName();
			return("̾ѹ˼Ԥޤ<BR> $err");
		}
		# writeFile ѤƤʤ١Ū˥ߥ顼󥰤¹
		if ($err = &cluster_system_sync("/etc/passwd") ) {
			$err = $err . "<BR>" . &restoreAdminName();
			return($err);
		}
		if ($err = &cluster_system_sync("/etc/shadow") ) {
			$err = $err . "<BR>" . &restoreAdminName();
			return($err);
		}

	# /etc/ftpaccess ѹ
		$openfile = "/etc/ftpaccess";
		$lockfile = "ftpaccess";
		@buff = ();
		if (!&readFile($openfile, $lockfile, *ftpline)) {
			$err = &restoreAdminName();
			return("$openfile ɤ߹ߤ˼Ԥޤ<BR> $err");
		}
		for ($i=0; $i<@ftpline; $i++) {
			$buff[$i] = $ftpline[$i];
			$buff[$i] =~ s/^\s+//;
			$buff[$i] =~ s/\s+$//;
			if ($buff[$i] =~ /^#/) {
				next;
			}
			if ($buff[$i] =~ /^virtual\s+(.+)\s+allow\s+\Q$oldadminname\E$/) {
				$ftpline[$i] = "virtual $1 allow $newadminname\n";
			}
		}
		if(!&writeFile($openfile, $lockfile, @ftpline)) {
			$err = &restoreAdminName();
			return("$openfile ν񤭹ߤ˼Ԥޤ<BR> $err");
		}

	# /opt/nec/wbmc/adm/.htaccess ѹ
		$openfile = "/opt/nec/wbmc/adm/.htaccess";
		$lockfile = "htaccess";
		@buff = ();
		if (!&readFile($openfile, $lockfile, *htline)) {
			$err = &restoreAdminName();
			return("$openfile ɤ߹ߤ˼Ԥޤ<BR> $err");
		}
		for ($i=0; $i<@htline; $i++) {
			$buff[$i] = $htline[$i];
			$buff[$i] =~ s/^\s+//;
			if ($buff[$i] =~ /^#\s*Require\s+user\s+(.+)/) {
				$htline[$i] = "#Require user $newadminname\n";
			}
			elsif ($buff[$i] =~ /^Require\s+user\s+(.+)/) {
				$htline[$i] = "Require user $newadminname\n";
			}
		}
		if(!&writeFile($openfile, $lockfile, @htline)) {
			$err = &restoreAdminName();
			return("$openfile ν񤭹ߤ˼Ԥޤ<BR> $err");
		}

	# /root/.forward ѹ
		$openfile = "/root/.forward";
		$lockfile = "forward";
		@buff = ();
		if (!&readFile($openfile, $lockfile, *fwdline)) {
			$err = &restoreAdminName();
			return("$openfile ɤ߹ߤ˼Ԥޤ<BR> $err");
		}
		for ($i=0; $i<@fwdline; $i++) {
			$buff[$i] = $fwdline[$i];
			$buff[$i] =~ s/^\s+//;
			$buff[$i] =~ s/\s+$//;
			if ($buff[$i] eq $oldadminname) {
				$fwdline[$i] = "$newadminname\n"
			}
		}
		if(!&writeFile($openfile, $lockfile, @fwdline)) {
			$err = &restoreAdminName();
			return("$openfile ν񤭹ߤ˼Ԥޤ<BR> $err");
		}

	# /etc/opt/nec/wbmchttpd/conf/wbmchttpd.conf ѹ
		$openfile = "/etc/opt/nec/wbmchttpd/conf/wbmchttpd.conf";
		$lockfile = "wbmchttpd.conf";
		@buff = ();
		if (!&readFile($openfile, $lockfile, *wbmcline)) {
			$err = &restoreAdminName();
			return("$openfile ɤ߹ߤ˼Ԥޤ<BR> $err");
		}
		for ($i=0; $i<@wbmcline; $i++) {
			$buff[$i] = $wbmcline[$i];
			$buff[$i] =~ s/^\s+//;
			$buff[$i] =~ s/\s+$//;
			if ($buff[$i] =~ /^#/) {
				next;
			}
			if ($buff[$i] =~ /^ServerAdmin\s+([^\@]+)\@(.*)/) {
				$wbmcline[$i] = "ServerAdmin $newadminname\@$2\n";
			}
			elsif ($buff[$i] =~ /^ServerAdmin\s+([^\@]+)$/) {
				$wbmcline[$i] = "ServerAdmin $newadminname\n";
			}
		}
		if(!&writeFile($openfile, $lockfile, @wbmcline)) {
			$err = &restoreAdminName();
			return("$openfile ν񤭹ߤ˼Ԥޤ<BR> $err");
		}

	# /etc/opt/nec/wbmc/adminname ѹ
		$openfile = "/etc/opt/nec/wbmc/adminname";
		$lockfile = "adminname";
		@buff = ();
		if (!&readFile($openfile, $lockfile, *adminline)) {
			$err = &restoreAdminName();
			return("$openfile ɤ߹ߤ˼Ԥޤ<BR> $err");
		}
		for ($i=0; $i<@adminline; $i++) {
			$adminline[$i] =~ s/^\s+//;
			$adminline[$i] =~ s/\s+$//;
			if ($adminline[$i] =~ /^ADMIN\s+(.+)\s+(.+)/) {
				push(@newadminline,"OLD_ADMIN $1 $2\n");
				$adminid = "";
				($adminid) = (getpwnam("$newadminname"))[2];
				if (($adminid =~ /\D/)||($adminid !~ /\d/)) {
					$adminid = "UNKNOWN";
				}
				push(@newadminline,"ADMIN $newadminname $adminid\n");
			}
		}
		if (@newadminline != 2) {
			$err = &restoreAdminName();
			return("$openfile ѹ˼Ԥޤ<BR> $err");
		}
		if(!&writeFile($openfile, $lockfile, @newadminline)) {
			$err = &restoreAdminName();
			return("$openfile ν񤭹ߤ˼Ԥޤ<BR> $err");
		}

	# ǥ쥯ȥ̾ѹ
		if ($err = &chgAdminDir($oldadminname,$newadminname)) {
			$err = $err . "<BR>" . &restoreAdminName();
			return($err);
		}
		if (&cluster_typechk() eq "mirror") {
			if (system("/opt/nec/wbmc/bin/wbmc_dc_rsync --dir /home/users/$newadminname")) {
				if (-d "/home/users/$newadminname") {
					system("/bin/mv -f /home/users/$newadminname /home/users/$oldadminname > /dev/null 2>&1");
				}
				$err = &restoreAdminName();
				return("ԤΥۡǥ쥯ȥ̾ѹǤޤ<BR> $err");
			}
			&cluster_exec_all("chkSlaveDir", $oldadminname, $newadminname);
		}
}

#
# ̾
#   backupAdminName - ƥ̾ѹ˴ؤեΥХååפԤʤ
# 
#   backupAdminName()
# 
#   ʤ
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub backupAdminName
{
	my(@backfiles) = ();
	my($i) = "";

	# Хååоݥե
	push(@backfiles,"/etc/passwd");
	push(@backfiles,"/etc/shadow");
	push(@backfiles,"/etc/ftpaccess");
	push(@backfiles,"/opt/nec/wbmc/adm/.htaccess");
	push(@backfiles,"/root/.forward");
	push(@backfiles,"/etc/opt/nec/wbmchttpd/conf/wbmchttpd.conf");
	push(@backfiles,"/etc/opt/nec/wbmc/adminname");

	for ($i=0; $i<@backfiles; $i++) {
		if (-f $backfiles[$i]) {
			if (system("/bin/cp -prf $backfiles[$i] $backfiles[$i].old >/dev/null 2>&1") != 0) {
				return("$backfiles[$i] ΥХååפ˼Ԥޤ");
			}
		}
	}
	return();
}

#
# ̾
#   restoreAdminName - ƥ̾ѹ˴ؤХååץեΥꥹȥԤʤ
# 
#   restoreAdminName()
# 
#   ʤ
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub restoreAdminName
{
	my(@restorefiles) = ();
	my($i,$err,$rtn) = "";

	# ꥹȥоݥե
	push(@restorefiles,"/etc/passwd");
	push(@restorefiles,"/etc/shadow");
	push(@restorefiles,"/etc/ftpaccess");
	push(@restorefiles,"/opt/nec/wbmc/adm/.htaccess");
	push(@restorefiles,"/root/.forward");
	push(@restorefiles,"/etc/opt/nec/wbmchttpd/conf/wbmchttpd.conf");
	push(@restorefiles,"/etc/opt/nec/wbmc/adminname");

	for ($i=0; $i<@restorefiles; $i++) {
		if (-f "$restorefiles[$i].old") {
			if (system("/bin/cp -prf $restorefiles[$i].old $restorefiles[$i] >/dev/null 2>&1") != 0) {
				$err .= "$restorefiles[$i].old Υꥹȥ˼Ԥޤ<BR>";
			}
			if ($rtn = &cluster_system_sync("$restorefiles[$i]") ) {
				$err .= "졼֤ $restorefiles[$i].old Υꥹȥ˼Ԥޤ<BR>";
			}
		}
	}
	return($err);
}

#
# ̾
#   getFileList - ե̾ǥ쥯ȥ̾ΰ
# 
#   getFileList($pdir, *filelist, $mode)
# 
#   $pdir       ƥǥ쥯ȥ
#   *filelist   NULL  ｪλ $pdir ľΥե̾ǥ쥯ȥΰǼ
#   $mode       d ޤ f ޤ NULL(̵)
#                  d   ǥ쥯ȥ̾ΰΤ
#                  f   ե̾ΰΤ
#                  NULLǥ쥯ȥ̾ȥե̾ΰ
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub getFileList
{
	local($pdir,*filelist,$mode) = @_;
	local(@dirs,$dir,$err);
	local(*DIR);

	$err = "";
	$mode =~ s/\s//g;
	# ǥ쥯ȥ꤬¸ߤʤϲ⤷ʤ
	if (!-d $pdir) {
		goto done;
	}
	if (!opendir(DIR, "$pdir")) {
		$err = "cannot open error $pdir<BR>";
		goto done;
	}
	@dirs = readdir(DIR);
	closedir(DIR);
	@dirs = sort(@dirs);

	foreach $dir (@dirs) {
		if (($dir eq ".") || ($dir eq "..")) {
			next;
		}
		if (($mode eq "f")&&(-d "$pdir/$dir")) {
			next;
		}
		elsif (($mode eq "d")&&(!-d "$pdir/$dir")) {
			next;
		}
		push(@filelist, "$pdir\/$dir");
	}
	done:
	return $err;
}

#
# ̾
#   makeAdminHome - ƥԤΥۡǥ쥯ȥ򿷵
#                   ᡼ѥǥ쥯ȥϺʤ
# 
#   makeAdminHome($adminname)
# 
#   $adminname       ƥ̾
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub makeAdminHome
{
	local($adminname) = @_;
	local(@filelist) = ();
	my($adminid, $i, $admingroupid) = "";
	$adminname =~ s/\s//g;
	
	if ($err = &getFileList("/etc/skel", *filelist,"")) {
		return("ԤΥۡǥ쥯ȥɬפ /etc/skel ۲ΥեޤǤ");
	}
	if (-d "/home/users/$adminname") {
		return();
	}
	else {
		if (system("/bin/mkdir -m 700 /home/users/$adminname >/dev/null 2>&1") != 0) {
			return("ԤΥۡǥ쥯ȥǤޤǤ");
		}
	}
	for ($i=0 ;$i<@filelist; $i++) {
		system("/bin/cp -prf $filelist[$i] /home/users/$adminname/ >/dev/null 2>&1");
	}
	($adminid) = (getpwnam("$adminname"))[2];
	($admingroupid) = (getpwnam("$adminname"))[3];
	if (($adminid =~ /\D/)||($adminid !~ /\d/)) {
		return("ԤΥۡǥ쥯ȥΥʡѹ˼Ԥޤ");
	}
	if (($admingroupid =~ /\D/)||($admingroupid !~ /\d/)) {
		return("ԤΥۡǥ쥯ȥΥʡѹ˼Ԥޤ");
	}
	if (system("/bin/chown -R $adminid:$admingroupid /home/users/$adminname >/dev/null 2>&1") != 0) {
		return("ԤΥۡǥ쥯ȥΥʡѹ˼Ԥޤ");
	}
	return();
}

#
# ̾
#   chgAdminDir - ƥ̾ѹȼäƥǥ쥯ȥ̾ѹԤʤ
#                 ѹоݤϥƥԤΥۡǥ쥯ȥȥ᡼ѥǥ쥯ȥ
# 
#   chgAdminDir($oldadmin,$newadmin)
# 
#   $oldadmin    ̾
#   $newadmin    ̾
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub chgAdminDir
{
	local($oldadminname,$newadminname) = @_;
	local($err, $domainname) = "";

	# ƥѥۡǥ쥯ȥ̾ѹ
		if ((-d "/home/users/$oldadminname")&&(!-d "/home/users/$newadminname")) {
		# ϡԤΥۡǥ쥯ȥ꤬¸ߤġԤΥۡǥ쥯ȥ꤬¸ߤʤ
			if (system("/bin/mv -f /home/users/$oldadminname /home/users/$newadminname >/dev/null 2>&1") != 0) {
				return("ԤΥۡǥ쥯ȥ̾ѹǤޤǤ");
			}
		}
		elsif ((-d "/home/users/$oldadminname")&&(-d "/home/users/$newadminname")) {
		# ۾ϣԤΥۡǥ쥯ȥ꤬¸ߤġԤΥۡǥ쥯ȥ꤬¸ߤ
			if (system("/bin/mv -f /home/users/$newadminname /home/users/$newadminname.old >/dev/null 2>&1") != 0) {
				return("¸ /home/users/$newadminname ǤޤǤ");
			}
			if (system("/bin/mv -f /home/users/$oldadminname /home/users/$newadminname >/dev/null 2>&1") != 0) {
				system("/bin/mv -f /home/users/$newadminname.old /home/users/$newadminname >/dev/null 2>&1");
				return("ԤΥۡǥ쥯ȥ̾ѹǤޤǤ");
			}
		}
		elsif ((!-d "/home/users/$oldadminname")&&(!-d "/home/users/$newadminname")) {
		# ۾ϣԤΥۡǥ쥯ȥ꤬¸ߤʤġԤΥۡǥ쥯ȥ꤬¸ߤʤ
			if ($err = &makeAdminHome($newadminname)) {
				return($err);
			}
		}
		elsif ((!-d "/home/users/$oldadminname")&&(-d "/home/users/$newadminname")) {
		# ۾ϣԤΥۡǥ쥯ȥ꤬¸ߤʤġԤΥۡǥ쥯ȥ꤬¸ߤ
			if (system("/bin/mv -f /home/users/$newadminname /home/users/$newadminname.old >/dev/null 2>&1") != 0) {
				return("¸ /home/users/$newadminname ǤޤǤ");
			}
			if ($err = &makeAdminHome($newadminname)) {
				system("/bin/mv -f /home/users/$newadminname.old /home/users/$newadminname >/dev/null 2>&1");
				return($err);
			}
		}
		else {
			return("ԤΥۡǥ쥯ȥ̾ѹ˼Ԥޤ");
		}

	#  ƥԥ᡼륹סѥǥ쥯ȥ̾ѹ(LBְʳ)
		if (&cluster_typechk() ne "mirror") {
			$domainname = `hostname`;
			$domainname =~ s/\s//g;
			if (!$domainname) {
				system("/bin/mv -f /home/users/$newadminname /home/users/$oldadminname >/dev/null 2>&1");
				return("ƥԥ᡼륹סѥǥ쥯ȥ̾ѹǤޤǤ\(/home/mail/¥ɥᥤ̾/̾\)");
			}
			if (system("/bin/mv -f /home/mail/$domainname/$oldadminname /home/mail/$domainname/$newadminname >/dev/null 2>&1") != 0) {
				system("/bin/mv -f /home/users/$newadminname /home/users/$oldadminname >/dev/null 2>&1");
				return("ƥԥ᡼륹סѥǥ쥯ȥ̾ѹǤޤǤ\(/home/mail/¥ɥᥤ̾/̾\)");
			}
		}
	return();
}

#
# ̾
#   stopAllMail -  ߵưƤ᡼륵ӥߤ롣
#                 оݤ sendmail, popd, imapd, mail-httpd
# 
#   stopAllMail(*stopservice)
# 
#   *stopservice   NULL  (ｪλߤӥWbMCѥǥ쥯ȥ̾Ǽ)
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub stopAllMail
{
	local(*stopservice) = @_;
	local(@wbmc_rc) = ();
	my(@mail) = ();
	my($i, $service_name, $process_name, $process) = "";
	
	if (&cluster_typechk() eq "mirror") {
		return();
	}

	if (!open(IN, "/bin/ps -efwwwww |")) {
		return("᡼륵ӥεư֤ǤޤǤ");
	}
	while (<IN>) {
		s/\s*$//;
		@ent = split(/\s+/);
		$ent[7] =~ s/\[//;
		$ent[7] =~ s/\]//;
		$ent[7] =~ s/.*\///;
		$process{$ent[7]} = 1;
	}
	close(IN);

	push(@mail,"11sendmail");
	push(@mail,"12popd");
	push(@mail,"13imapd");
	push(@mail,"14mail-httpd");

	for ($i=0; $i<@mail; $i++) {
		@wbmc_rc = ();
		$service_name = "";
		$process_name = "";
		if (!&readFile("/opt/nec/wbmc/adm/service/$mail[$i]/wbmc.rc", "wbmc.rc", *wbmc_rc)) {
			next;
		}
		for (@wbmc_rc) {
			s/\s*$//;
			if (/^#/) {
				next;
			}
			elsif (/^\s*ServiceName:\s*(.*)/i) {
				$service_name = $1;
			}
			elsif (/^\s*ProcessName:\s*(.*)/i) {
				$process_name = $1;
			}
		}
		if ($process{$process_name}) {
			if ($process_name && $service_name) {
				push(@stopservice,"$mail[$i]");
				system("/etc/rc.d/init.d/$service_name stop > /dev/null 2>&1");
			}
		}
	}
	return();
}

#
# ̾
#   startAllMail -  stopAllMail()ߤ᡼륵ӥư롣
#                 оݤ sendmail, popd, imapd, mail-httpd
# 
#   startAllMail(@startservice)
# 
#   @startservice   stopAllMail() Ϥߤ᡼륵ӥWbMCѥǥ쥯ȥ̾ǼƤ
# 
#   ΤȤ NULL
#   ԤΤȤ 顼å
#
sub startAllMail
{
	local(*startservice) = @_;
	my($i, $process, $service_name, $process_name) = "";

	if (&cluster_typechk() eq "mirror") {
		return();
	}

	for ($i=0; $i<@startservice; $i++) {
		@wbmc_rc = ();
		$service_name = "";
		$process_name = "";
		if (!&readFile("/opt/nec/wbmc/adm/service/$startservice[$i]/wbmc.rc", "wbmc.rc", *wbmc_rc)) {
			next;
		}
		for (@wbmc_rc) {
			s/\s*$//;
			if (/^#/) {
				next;
			}
			elsif (/^\s*ServiceName:\s*(.*)/i) {
				$service_name = $1;
			}
		}
		if ($service_name) {
				system("/etc/rc.d/init.d/$service_name start > /dev/null 2>&1");
		}
	}
	return();
}

#
# ̾
#   chkSlaveDir - ƥ̾ѹȼäƥ졼֥оεԥۡǥ쥯ȥ
# 
#   chkSlaveDir($oldadmin,$newadmin)
# 
#   $oldadmin    ̾
#   $newadmin    ̾
# 
#   NULL
#
sub chkSlaveDir
{
	local($oldadminname,$newadminname) = @_;

	$oldadminname =~ s/\s//g;
	$newadminname =~ s/\s//g;
	if (&cluster_masterchk() ne "slave") {
		return();
	}
	if (!$oldadminname || !$newadminname) {
		return();
	}
	if ((-d "/home/users/$oldadminname")&&(-d "/home/users/$newadminname")) {
		system("/bin/rm -fr /home/users/$oldadminname >/dev/null 2>&1");
	}
	return();
}

1;

